// Koka generated module: "std/num/int32", koka version: 2.2.1
#include "std_num_int32.h"

kk_integer_t kk_std_num_int32_max_int32;
 
// Show an `:int32` in hexadecimal notation
// The `width`  parameter specifies how wide the hex value is where `'0'`  is used to align.
// The `use-capitals` parameter (= `True`) determines if captical letters should be used to display the hexadecimal digits.
// The `pre` (=`"0x"`) is an optional prefix for the number (goes between the sign and the number).

kk_string_t kk_std_num_int32_show_hex(int32_t i, kk_std_core_types__optional width, kk_std_core_types__optional use_capitals, kk_std_core_types__optional pre, kk_context_t* _ctx) { /* (i : int32, width : optional<int>, use-capitals : optional<bool>, pre : optional<string>) -> string */ 
  kk_integer_t _x1396 = kk_integer_from_int(i,kk_context()); /*int*/
  kk_std_core_types__optional _x1397;
  kk_integer_t _b_1335_1330;
  if (kk_std_core_types__is_Optional(width)) {
    kk_box_t _box_x1329 = width._cons.Optional.value;
    kk_integer_t _width_156 = kk_integer_unbox(_box_x1329);
    kk_integer_dup(_width_156);
    kk_std_core_types__optional_drop(width, _ctx);
    kk_Unit;
    _b_1335_1330 = _width_156; /*int*/
    goto _match1398;
  }
  _b_1335_1330 = kk_integer_from_small(1); /*int*/
  _match1398: ;
  _x1397 = kk_std_core_types__new_Optional(kk_integer_box(_b_1335_1330), _ctx); /*optional<106>*/
  kk_std_core_types__optional _x1400;
  bool _b_1336_1332;
  if (kk_std_core_types__is_Optional(use_capitals)) {
    kk_box_t _box_x1331 = use_capitals._cons.Optional.value;
    bool _use_capitals_160 = kk_bool_unbox(_box_x1331);
    kk_std_core_types__optional_drop(use_capitals, _ctx);
    kk_Unit;
    _b_1336_1332 = _use_capitals_160; /*bool*/
    goto _match1401;
  }
  _b_1336_1332 = true; /*bool*/
  _match1401: ;
  _x1400 = kk_std_core_types__new_Optional(kk_bool_box(_b_1336_1332), _ctx); /*optional<106>*/
  kk_std_core_types__optional _x1403;
  kk_string_t _b_1337_1334;
  if (kk_std_core_types__is_Optional(pre)) {
    kk_box_t _box_x1333 = pre._cons.Optional.value;
    kk_string_t _pre_164 = kk_string_unbox(_box_x1333);
    kk_string_dup(_pre_164);
    kk_std_core_types__optional_drop(pre, _ctx);
    kk_Unit;
    _b_1337_1334 = _pre_164; /*string*/
    goto _match1404;
  }
  kk_define_string_literal(, _s1406, 2, "0x")
  _b_1337_1334 = kk_string_dup(_s1406); /*string*/
  _match1404: ;
  _x1403 = kk_std_core_types__new_Optional(kk_string_box(_b_1337_1334), _ctx); /*optional<106>*/
  return kk_std_core_show_hex(_x1396, _x1397, _x1400, _x1403, _ctx);
}

int32_t kk_std_num_int32_one;

int32_t kk_std_num_int32_zero;
 
// Euclidean-0 modulus. See `(/):(x : int32, y : int32) -> int32` division for more information.

int32_t kk_std_num_int32__lp__perc__rp_(int32_t x, int32_t y, kk_context_t* _ctx) { /* (x : int32, y : int32) -> int32 */ 
  bool _match_1386 = (y == (((int32_t)0))); /*bool*/;
  if (_match_1386) {
    return x;
  }
  int32_t r = (x % y); /*int32*/;
  bool _match_1387 = (r >= (((int32_t)0))); /*bool*/;
  if (_match_1387) {
    return r;
  }
  bool _match_1388 = (y > (((int32_t)0))); /*bool*/;
  if (_match_1388) {
    return (r + y);
  }
  return (r - y);
}
 
/*
Euclidean-0 division.
Euclidean division is defined as: For any `D`  and `d`  where `d!=0` , we have:
1. `D == d*(D/d) + (D%d)`
2. `D%d`  is always positive where `0 <= D%d < abs(d)`
Moreover, Euclidean-0 is a total function, for the case where `d==0`  we have
that `D%0 == D`  and `D/0 == 0` . So property (1) still holds, but not property (2).
Useful laws that hold for Euclidean-0 division:
* `D/(-d) == -(D/d)`
* `D%(-d) == D%d`
* `D/(2^n) == sar(D,n)         `  (with `0 <= n <= 31`)
* `D%(2^n) == D & ((2^n) - 1)  `  (with `0 <= n <= 31`)
Note that an interesting edge case is `min-int32 / -1` which equals `min-int32` since in modulo 32-bit
arithmetic `min-int32 == -1 * min-int32 == -1 * (min-int32 / -1) + (min-int32 % -1)` satisfying property (1).
Of course `(min-int32 + 1) / -1` is again positive (namely `max-int32`).
See also _Division and modulus for computer scientists, Daan Leijen, 2001_
[pdf](http://research.microsoft.com/pubs/151917/divmodnote.pdf) .
*/

int32_t kk_std_num_int32__lp__fs__rp_(int32_t x, int32_t y, kk_context_t* _ctx) { /* (x : int32, y : int32) -> int32 */ 
  bool _match_1383 = (y == (((int32_t)0))); /*bool*/;
  if (_match_1383) {
    return ((int32_t)0);
  }
  int32_t q = (x / y); /*int32*/;
  int32_t r = (x % y); /*int32*/;
  bool _match_1384 = (r >= (((int32_t)0))); /*bool*/;
  if (_match_1384) {
    return q;
  }
  bool _match_1385 = (y > (((int32_t)0))); /*bool*/;
  if (_match_1385) {
    return (q - (((int32_t)1)));
  }
  return (q + (((int32_t)1)));
}

kk_integer_t kk_std_num_int32_min_int32;
 
// Return the absolute value of an integer.
// Raises an exception if the `:int32` is `min-int32`
// (since the negation of `min-int32` equals itself and is still negative)


// lift anonymous function
struct kk_std_num_int32_abs_fun1409__t {
  struct kk_function_s _base;
};
static bool kk_std_num_int32_abs_fun1409(kk_function_t _fself, bool b, kk_context_t* _ctx);
static kk_function_t kk_std_num_int32_new_abs_fun1409(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_int32_abs_fun1409, _ctx)
  return kk_function_dup(_fself);
}

static bool kk_std_num_int32_abs_fun1409(kk_function_t _fself, bool b, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  if (b) {
    return false;
  }
  return true;
}


// lift anonymous function
struct kk_std_num_int32_abs_fun1411__t {
  struct kk_function_s _base;
  kk_function_t _b_1343_1338;
};
static kk_box_t kk_std_num_int32_abs_fun1411(kk_function_t _fself, kk_box_t _b_1340, kk_context_t* _ctx);
static kk_function_t kk_std_num_int32_new_abs_fun1411(kk_function_t _b_1343_1338, kk_context_t* _ctx) {
  struct kk_std_num_int32_abs_fun1411__t* _self = kk_function_alloc_as(struct kk_std_num_int32_abs_fun1411__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_int32_abs_fun1411, kk_context());
  _self->_b_1343_1338 = _b_1343_1338;
  return &_self->_base;
}

static kk_box_t kk_std_num_int32_abs_fun1411(kk_function_t _fself, kk_box_t _b_1340, kk_context_t* _ctx) {
  struct kk_std_num_int32_abs_fun1411__t* _self = kk_function_as(struct kk_std_num_int32_abs_fun1411__t*, _fself);
  kk_function_t _b_1343_1338 = _self->_b_1343_1338; /* (b : bool) -> bool */
  kk_drop_match(_self, {kk_function_dup(_b_1343_1338);}, {}, _ctx)
  bool _x1412;
  bool _x1413 = kk_bool_unbox(_b_1340); /*bool*/
  _x1412 = kk_function_call(bool, (kk_function_t, bool, kk_context_t*), _b_1343_1338, (_b_1343_1338, _x1413, _ctx)); /*bool*/
  return kk_bool_box(_x1412);
}

int32_t kk_std_num_int32_abs(int32_t i, kk_context_t* _ctx) { /* (i : int32) -> exn int32 */ 
  bool _x1 = (i)<0; /*bool*/;
  bool _match_1381;
  kk_function_t _b_1343_1338 = kk_std_num_int32_new_abs_fun1409(_ctx); /*(b : bool) -> bool*/;
  bool _b_1344_1339 = _x1; /*bool*/;
  kk_box_t _x1410 = kk_std_core_hnd__open_none1(kk_std_num_int32_new_abs_fun1411(_b_1343_1338, _ctx), kk_bool_box(_b_1344_1339), _ctx); /*3289*/
  _match_1381 = kk_bool_unbox(_x1410); /*bool*/
  if (_match_1381) {
    return i;
  }
  bool _match_1382;
  int32_t _x1414;
  kk_integer_t _x1415 = kk_integer_neg((kk_integer_from_str("2147483648", _ctx)),kk_context()); /*int*/
  _x1414 = kk_std_core_int32(_x1415, _ctx); /*int32*/
  _match_1382 = (i > _x1414); /*bool*/
  if (_match_1382) {
    return ((((int32_t)0)) - i);
  }
  kk_string_t _b_1345_1341;
  kk_define_string_literal(, _s1416, 79, "std/num/int32/abs: cannot make min-int32 into a positive int32 without overflow")
  _b_1345_1341 = kk_string_dup(_s1416); /*string*/
  kk_std_core_types__optional _b_1346_1342 = kk_std_core_types__new_None(_ctx); /*optional<exception-info>*/;
  kk_box_t _x1417 = kk_std_core_throw(_b_1345_1341, _b_1346_1342, _ctx); /*11652*/
  return kk_int32_unbox(_x1417, _ctx);
}
 
// Return the absolute value of an integer.
// Returns 0 if the `:int32` is `min-int32`
// (since the negation of `min-int32` equals itself and is still negative)

int32_t kk_std_num_int32_abs0(int32_t i, kk_context_t* _ctx) { /* (i : int32) -> int32 */ 
  bool b_1316 = (i)<0; /*bool*/;
  if (b_1316) {
    bool _match_1380;
    int32_t _x1418;
    kk_integer_t _x1419 = kk_integer_neg((kk_integer_from_str("2147483648", _ctx)),kk_context()); /*int*/
    _x1418 = kk_std_core_int32(_x1419, _ctx); /*int32*/
    _match_1380 = (i > _x1418); /*bool*/
    if (_match_1380) {
      return ((((int32_t)0)) - i);
    }
    return ((int32_t)0);
  }
  return i;
}

int32_t kk_std_num_int32_bits_int32;

kk_std_core_types__tuple2_ kk_std_num_int32_divmod(int32_t x, int32_t y, kk_context_t* _ctx) { /* (x : int32, y : int32) -> (int32, int32) */ 
  bool _match_1378 = 0==(y); /*bool*/;
  if (_match_1378) {
    int32_t _b_1355_1347 = ((int32_t)0); /*int32*/;
    int32_t _b_1356_1348 = ((int32_t)0); /*int32*/;
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_int32_box(_b_1355_1347, _ctx), kk_int32_box(_b_1356_1348, _ctx), _ctx);
  }
  int32_t q = (x / y); /*int32*/;
  int32_t r = (x % y); /*int32*/;
  bool b_1318 = (r)<0; /*bool*/;
  if (b_1318) {
    bool _match_1379 = 0<=(y); /*bool*/;
    if (_match_1379) {
      int32_t _b_1357_1349 = (q - (((int32_t)1))); /*int32*/;
      int32_t _b_1358_1350 = (r + y); /*int32*/;
      return kk_std_core_types__new_dash__lp__comma__rp_(kk_int32_box(_b_1357_1349, _ctx), kk_int32_box(_b_1358_1350, _ctx), _ctx);
    }
    int32_t _b_1359_1351 = (q + (((int32_t)1))); /*int32*/;
    int32_t _b_1360_1352 = (r - y); /*int32*/;
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_int32_box(_b_1359_1351, _ctx), kk_int32_box(_b_1360_1352, _ctx), _ctx);
  }
  int32_t _b_1361_1353 = q; /*int32*/;
  int32_t _b_1362_1354 = r; /*int32*/;
  return kk_std_core_types__new_dash__lp__comma__rp_(kk_int32_box(_b_1361_1353, _ctx), kk_int32_box(_b_1362_1354, _ctx), _ctx);
}

kk_box_t kk_std_num_int32_fold_int32(int32_t start, int32_t end, kk_box_t init, kk_function_t f, kk_context_t* _ctx) { /* forall<a> (start : int32, end : int32, init : a, f : (int32, a) -> a) -> a */ 
  kk__tailcall: ;
  bool _match_1377 = (start >= end); /*bool*/;
  if (_match_1377) {
    kk_function_drop(f, _ctx);
    return init;
  }
  kk_box_t x;
  kk_function_t _x1420 = kk_function_dup(f); /*(int32, 996) -> 996*/
  x = kk_function_call(kk_box_t, (kk_function_t, int32_t, kk_box_t, kk_context_t*), _x1420, (_x1420, start, init, _ctx)); /*996*/
  { // tailcall
    int32_t _x1421 = (start + (((int32_t)1))); /*int32*/
    start = _x1421;
    init = x;
    goto kk__tailcall;
  }
}
 
// Bitwise rotate an `:int32` `n` bits to the left.
// Does not rotate when `n` is negative.

int32_t kk_std_num_int32_rotl(int32_t i, int32_t n, kk_context_t* _ctx) { /* (i : int32, n : int32) -> int32 */ 
  bool _match_1376 = (n)<0; /*bool*/;
  if (_match_1376) {
    return i;
  }
  int32_t r;
  int32_t _x1424;
  int32_t i0_1322 = ((int32_t)32); /*int32*/;
  _x1424 = (i0_1322 - (((int32_t)1))); /*int32*/
  r = (n & _x1424); /*int32*/
  int32_t _x1425 = (i << r); /*int32*/
  int32_t _x1426;
  int32_t _x1427 = ((((int32_t)32)) - r); /*int32*/
  _x1426 = ((int32_t)((uint32_t)i >> _x1427)); /*int32*/
  return (_x1425 | _x1426);
}
 
// Bitwise rotate an `:int32` `n` bits to the right.
// Does not rotate when `n` is negative.

int32_t kk_std_num_int32_rotr(int32_t i, int32_t n, kk_context_t* _ctx) { /* (i : int32, n : int32) -> int32 */ 
  bool _match_1375 = (n)<0; /*bool*/;
  if (_match_1375) {
    return i;
  }
  int32_t r;
  int32_t _x1428;
  int32_t i0_1323 = ((int32_t)32); /*int32*/;
  _x1428 = (i0_1323 - (((int32_t)1))); /*int32*/
  r = (n & _x1428); /*int32*/
  int32_t _x1429 = ((int32_t)((uint32_t)i >> r)); /*int32*/
  int32_t _x1430;
  int32_t _x1431 = ((((int32_t)32)) - r); /*int32*/
  _x1430 = (i << _x1431); /*int32*/
  return (_x1429 | _x1430);
}
 
// Show an `:int32` in hexadecimal notation interpreted as an unsigned 32-bit value.
// The `width`  parameter specifies how wide the hex value is where `'0'`  is used to align.
// The `use-capitals` parameter (= `True`) determines if captical letters should be used to display the hexadecimal digits.
// The `pre` (=`"0x"`) is an optional prefix for the number.

kk_string_t kk_std_num_int32_show_hex32(int32_t i, kk_std_core_types__optional width, kk_std_core_types__optional use_capitals, kk_std_core_types__optional pre, kk_context_t* _ctx) { /* (i : int32, width : optional<int>, use-capitals : optional<bool>, pre : optional<string>) -> string */ 
  kk_integer_t _x1433 = kk_std_num_int32_uint(i, _ctx); /*int*/
  kk_std_core_types__optional _x1434;
  kk_integer_t _b_1369_1364;
  if (kk_std_core_types__is_Optional(width)) {
    kk_box_t _box_x1363 = width._cons.Optional.value;
    kk_integer_t _width_1233 = kk_integer_unbox(_box_x1363);
    kk_integer_dup(_width_1233);
    kk_std_core_types__optional_drop(width, _ctx);
    kk_Unit;
    _b_1369_1364 = _width_1233; /*int*/
    goto _match1435;
  }
  _b_1369_1364 = kk_integer_from_small(8); /*int*/
  _match1435: ;
  _x1434 = kk_std_core_types__new_Optional(kk_integer_box(_b_1369_1364), _ctx); /*optional<106>*/
  kk_std_core_types__optional _x1437;
  bool _b_1370_1366;
  if (kk_std_core_types__is_Optional(use_capitals)) {
    kk_box_t _box_x1365 = use_capitals._cons.Optional.value;
    bool _use_capitals_1237 = kk_bool_unbox(_box_x1365);
    kk_std_core_types__optional_drop(use_capitals, _ctx);
    kk_Unit;
    _b_1370_1366 = _use_capitals_1237; /*bool*/
    goto _match1438;
  }
  _b_1370_1366 = true; /*bool*/
  _match1438: ;
  _x1437 = kk_std_core_types__new_Optional(kk_bool_box(_b_1370_1366), _ctx); /*optional<106>*/
  kk_std_core_types__optional _x1440;
  kk_string_t _b_1371_1368;
  if (kk_std_core_types__is_Optional(pre)) {
    kk_box_t _box_x1367 = pre._cons.Optional.value;
    kk_string_t _pre_1241 = kk_string_unbox(_box_x1367);
    kk_string_dup(_pre_1241);
    kk_std_core_types__optional_drop(pre, _ctx);
    kk_Unit;
    _b_1371_1368 = _pre_1241; /*string*/
    goto _match1441;
  }
  kk_define_string_literal(, _s1443, 2, "0x")
  _b_1371_1368 = kk_string_dup(_s1443); /*string*/
  _match1441: ;
  _x1440 = kk_std_core_types__new_Optional(kk_string_box(_b_1371_1368), _ctx); /*optional<106>*/
  return kk_std_core_show_hex(_x1433, _x1434, _x1437, _x1440, _ctx);
}

// initialization
void kk_std_num_int32__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
  {
    kk_std_num_int32_max_int32 = kk_integer_from_int(2147483647, _ctx); /*int*/
  }
  {
    kk_std_num_int32_one = ((int32_t)1); /*int32*/
  }
  {
    kk_std_num_int32_zero = ((int32_t)0); /*int32*/
  }
  {
    kk_std_num_int32_min_int32 = kk_integer_neg((kk_integer_from_str("2147483648", _ctx)),kk_context()); /*int*/
  }
  {
    kk_std_num_int32_bits_int32 = ((int32_t)32); /*int32*/
  }
}

// termination
void kk_std_num_int32__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_integer_drop(kk_std_num_int32_min_int32, _ctx);
  kk_integer_drop(kk_std_num_int32_max_int32, _ctx);
  kk_std_core__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
