// Koka generated module: "std/os/dir", koka version: 2.2.1
#include "std_os_dir.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/

static kk_std_core__error kk_os_ensure_dir_error( kk_string_t path, kk_integer_t mode, kk_context_t* ctx ) {
  int m  = kk_integer_clamp32_borrow(mode);
  kk_integer_drop(mode, ctx);
  const int err = kk_os_ensure_dir(path,m,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_unit_box(kk_Unit),ctx);
}

static kk_std_core__error kk_os_copy_file_error( kk_string_t from, kk_string_t to, bool preserve_mtime, kk_context_t* ctx ) {
  const int err = kk_os_copy_file(from,to,preserve_mtime,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_unit_box(kk_Unit),ctx);
}

static kk_std_core__error kk_os_list_directory_prim( kk_string_t dir, kk_context_t* ctx ) {
  kk_vector_t contents;
  const int err = kk_os_list_directory(dir,&contents,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_vector_box(contents,ctx),ctx);
}


kk_std_core__exception kk_std_os_dir_prepend(kk_std_core__exception exn, kk_string_t pre, kk_context_t* _ctx) { /* (exn : exception, pre : string) -> exception */ 
  kk_string_t _x1341;
  kk_string_t _x1342;
  kk_string_t _x1343;
  kk_define_string_literal(, _s1344, 2, ": ")
  _x1343 = kk_string_dup(_s1344); /*string*/
  kk_string_t _x1345;
  kk_string_t _x = exn.message;
  kk_string_dup(_x);
  _x1345 = _x; /*string*/
  _x1342 = kk_std_core__lp__plus__plus__1_rp_(_x1343, _x1345, _ctx); /*string*/
  _x1341 = kk_std_core__lp__plus__plus__1_rp_(pre, _x1342, _ctx); /*string*/
  kk_std_core__exception_info _x1346;
  kk_std_core__exception_info _x0 = exn.info;
  kk_std_core__exception_info_dup(_x0);
  kk_std_core__exception_drop(exn, _ctx);
  kk_Unit;
  _x1346 = _x0; /*exception-info*/
  return kk_std_core__new_Exception(_x1341, _x1346, _ctx);
}

kk_std_core__error kk_std_os_dir_prim_copy_file(kk_string_t from, kk_string_t to, bool preserve_mtime, kk_context_t* _ctx) { /* (from : string, to : string, preserve-mtime : bool) -> fsys error<()> */ 
  return kk_os_copy_file_error(from,to,preserve_mtime,kk_context());
}

kk_std_core__error kk_std_os_dir_ensure_dir_err(kk_string_t path, kk_integer_t mode, kk_context_t* _ctx) { /* (path : string, mode : int) -> fsys error<()> */ 
  return kk_os_ensure_dir_error(path,mode,kk_context());
}

bool kk_std_os_dir_prim_is_dir(kk_string_t dir, kk_context_t* _ctx) { /* (dir : string) -> fsys bool */ 
  return kk_os_is_directory(dir,kk_context());
}

kk_std_core__error kk_std_os_dir_prim_list_dir(kk_string_t dir, kk_context_t* _ctx) { /* (dir : string) -> fsys error<vector<string>> */ 
  return kk_os_list_directory_prim(dir,kk_context());
}

bool kk_std_os_dir_prim_is_file(kk_string_t path, kk_context_t* _ctx) { /* (path : string) -> fsys bool */ 
  return kk_os_is_file(path,kk_context());
}
 
// Copy a file.


// lift anonymous function
struct kk_std_os_dir_copy_file_fun1348__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_fun1348(kk_function_t _fself, kk_box_t _b_1059, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun1348(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun1348, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_dir_copy_file_fun1348(kk_function_t _fself, kk_box_t _b_1059, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x1349;
  kk_std_os_path__path _x1350 = kk_std_os_path__path_unbox(_b_1059, _ctx); /*std/os/path/path*/
  _x1349 = kk_std_os_path_string(_x1350, _ctx); /*string*/
  return kk_string_box(_x1349);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_fun1354__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_fun1354(kk_function_t _fself, kk_box_t _b_1064, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun1354(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun1354, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_dir_copy_file_fun1354(kk_function_t _fself, kk_box_t _b_1064, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x1355;
  kk_std_os_path__path _x1356 = kk_std_os_path__path_unbox(_b_1064, _ctx); /*std/os/path/path*/
  _x1355 = kk_std_os_path_string(_x1356, _ctx); /*string*/
  return kk_string_box(_x1355);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_fun1362__t {
  struct kk_function_s _base;
};
static kk_std_core__error kk_std_os_dir_copy_file_fun1362(kk_function_t _fself, kk_string_t _x11359, kk_string_t _x21360, bool _x31361, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun1362(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun1362, _ctx)
  return kk_function_dup(_fself);
}

static kk_std_core__error kk_std_os_dir_copy_file_fun1362(kk_function_t _fself, kk_string_t _x11359, kk_string_t _x21360, bool _x31361, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_os_dir_prim_copy_file(_x11359, _x21360, _x31361, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_fun1366__t {
  struct kk_function_s _base;
  kk_function_t _b_1091_1068;
};
static kk_box_t kk_std_os_dir_copy_file_fun1366(kk_function_t _fself, kk_box_t _b_1072, kk_box_t _b_1073, kk_box_t _b_1074, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun1366(kk_function_t _b_1091_1068, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_file_fun1366__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_file_fun1366__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir_copy_file_fun1366, kk_context());
  _self->_b_1091_1068 = _b_1091_1068;
  return &_self->_base;
}

static kk_box_t kk_std_os_dir_copy_file_fun1366(kk_function_t _fself, kk_box_t _b_1072, kk_box_t _b_1073, kk_box_t _b_1074, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_file_fun1366__t* _self = kk_function_as(struct kk_std_os_dir_copy_file_fun1366__t*, _fself);
  kk_function_t _b_1091_1068 = _self->_b_1091_1068; /* (from : string, to : string, preserve-mtime : bool) -> fsys error<()> */
  kk_drop_match(_self, {kk_function_dup(_b_1091_1068);}, {}, _ctx)
  kk_std_core__error _x1367;
  kk_string_t _x1368 = kk_string_unbox(_b_1072); /*string*/
  kk_string_t _x1369 = kk_string_unbox(_b_1073); /*string*/
  bool _x1370 = kk_bool_unbox(_b_1074); /*bool*/
  _x1367 = kk_function_call(kk_std_core__error, (kk_function_t, kk_string_t, kk_string_t, bool, kk_context_t*), _b_1091_1068, (_b_1091_1068, _x1368, _x1369, _x1370, _ctx)); /*error<()>*/
  return kk_std_core__error_box(_x1367, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_fun1377__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_fun1377(kk_function_t _fself, kk_box_t _b_1077, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun1377(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun1377, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_dir_copy_file_fun1377(kk_function_t _fself, kk_box_t _b_1077, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x1378;
  kk_std_os_path__path p_1096 = kk_std_os_path__path_unbox(_b_1077, _ctx); /*std/os/path/path*/;
  kk_string_t _x1379 = kk_std_os_path_string(p_1096, _ctx); /*string*/
  _x1378 = kk_std_core_show_3(_x1379, _ctx); /*string*/
  return kk_string_box(_x1378);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_fun1385__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_fun1385(kk_function_t _fself, kk_box_t _b_1080, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun1385(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun1385, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_dir_copy_file_fun1385(kk_function_t _fself, kk_box_t _b_1080, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x1386;
  kk_std_os_path__path p0_1097 = kk_std_os_path__path_unbox(_b_1080, _ctx); /*std/os/path/path*/;
  kk_string_t _x1387 = kk_std_os_path_string(p0_1097, _ctx); /*string*/
  _x1386 = kk_std_core_show_3(_x1387, _ctx); /*string*/
  return kk_string_box(_x1386);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_fun1388__t {
  struct kk_function_s _base;
};
static kk_std_core__exception kk_std_os_dir_copy_file_fun1388(kk_function_t _fself, kk_std_core__exception exn0, kk_string_t pre, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun1388(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun1388, _ctx)
  return kk_function_dup(_fself);
}

static kk_std_core__exception kk_std_os_dir_copy_file_fun1388(kk_function_t _fself, kk_std_core__exception exn0, kk_string_t pre, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x1389;
  kk_string_t _x1390;
  kk_string_t _x1391;
  kk_define_string_literal(, _s1392, 2, ": ")
  _x1391 = kk_string_dup(_s1392); /*string*/
  kk_string_t _x1393;
  kk_string_t _x = exn0.message;
  kk_string_dup(_x);
  _x1393 = _x; /*string*/
  _x1390 = kk_std_core__lp__plus__plus__1_rp_(_x1391, _x1393, _ctx); /*string*/
  _x1389 = kk_std_core__lp__plus__plus__1_rp_(pre, _x1390, _ctx); /*string*/
  kk_std_core__exception_info _x1394;
  kk_std_core__exception_info _x03 = exn0.info;
  kk_std_core__exception_info_dup(_x03);
  kk_std_core__exception_drop(exn0, _ctx);
  kk_Unit;
  _x1394 = _x03; /*exception-info*/
  return kk_std_core__new_Exception(_x1389, _x1394, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_fun1396__t {
  struct kk_function_s _base;
  kk_function_t _b_1098_1085;
};
static kk_box_t kk_std_os_dir_copy_file_fun1396(kk_function_t _fself, kk_box_t _b_1088, kk_box_t _b_1089, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun1396(kk_function_t _b_1098_1085, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_file_fun1396__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_file_fun1396__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir_copy_file_fun1396, kk_context());
  _self->_b_1098_1085 = _b_1098_1085;
  return &_self->_base;
}

static kk_box_t kk_std_os_dir_copy_file_fun1396(kk_function_t _fself, kk_box_t _b_1088, kk_box_t _b_1089, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_file_fun1396__t* _self = kk_function_as(struct kk_std_os_dir_copy_file_fun1396__t*, _fself);
  kk_function_t _b_1098_1085 = _self->_b_1098_1085; /* (exn0 : exception, pre : string) -> exception */
  kk_drop_match(_self, {kk_function_dup(_b_1098_1085);}, {}, _ctx)
  kk_std_core__exception _x1397;
  kk_std_core__exception _x1398 = kk_std_core__exception_unbox(_b_1088, _ctx); /*exception*/
  kk_string_t _x1399 = kk_string_unbox(_b_1089); /*string*/
  _x1397 = kk_function_call(kk_std_core__exception, (kk_function_t, kk_std_core__exception, kk_string_t, kk_context_t*), _b_1098_1085, (_b_1098_1085, _x1398, _x1399, _ctx)); /*exception*/
  return kk_std_core__exception_box(_x1397, _ctx);
}

kk_unit_t kk_std_os_dir_copy_file(kk_std_os_path__path from, kk_std_os_path__path to, kk_std_core_types__optional preserve_mtime, kk_context_t* _ctx) { /* (from : std/os/path/path, to : std/os/path/path, preserve-mtime : optional<bool>) -> <exn,fsys> () */ 
  kk_string_t _x1;
  kk_box_t _x1347;
  kk_box_t _x1351;
  kk_std_os_path__path _x1352 = kk_std_os_path__path_dup(from); /*std/os/path/path*/
  _x1351 = kk_std_os_path__path_box(_x1352, _ctx); /*3288*/
  _x1347 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_file_fun1348(_ctx), _x1351, _ctx); /*3289*/
  _x1 = kk_string_unbox(_x1347); /*string*/
  kk_string_t _x2;
  kk_box_t _x1353;
  kk_box_t _x1357;
  kk_std_os_path__path _x1358 = kk_std_os_path__path_dup(to); /*std/os/path/path*/
  _x1357 = kk_std_os_path__path_box(_x1358, _ctx); /*3288*/
  _x1353 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_file_fun1354(_ctx), _x1357, _ctx); /*3289*/
  _x2 = kk_string_unbox(_x1353); /*string*/
  kk_std_core__error _match_1340;
  kk_function_t _b_1091_1068 = kk_std_os_dir_new_copy_file_fun1362(_ctx); /*(from : string, to : string, preserve-mtime : bool) -> fsys error<()>*/;
  kk_string_t _b_1092_1069 = _x1; /*string*/;
  kk_string_t _b_1093_1070 = _x2; /*string*/;
  bool _b_1094_1071;
  if (kk_std_core_types__is_Optional(preserve_mtime)) {
    kk_box_t _box_x1067 = preserve_mtime._cons.Optional.value;
    bool _preserve_mtime_119 = kk_bool_unbox(_box_x1067);
    kk_std_core_types__optional_drop(preserve_mtime, _ctx);
    kk_Unit;
    _b_1094_1071 = _preserve_mtime_119; /*bool*/
    goto _match1363;
  }
  _b_1094_1071 = true; /*bool*/
  _match1363: ;
  kk_box_t _x1365 = kk_std_core_hnd__open_none3(kk_std_os_dir_new_copy_file_fun1366(_b_1091_1068, _ctx), kk_string_box(_b_1092_1069), kk_string_box(_b_1093_1070), kk_bool_box(_b_1094_1071), _ctx); /*3425*/
  _match_1340 = kk_std_core__error_unbox(_x1365, _ctx); /*error<()>*/
  if (kk_std_core__is_Error(_match_1340)) {
    kk_std_core__exception exn = _match_1340._cons.Error.exception;
    kk_std_core__exception_dup(exn);
    kk_std_core__error_drop(_match_1340, _ctx);
    kk_Unit;
    kk_std_core__error _b_1095_1090;
    kk_std_core__exception _x1371;
    kk_string_t _x20;
    kk_string_t _x1372;
    kk_define_string_literal(, _s1373, 15, "unable to copy ")
    _x1372 = kk_string_dup(_s1373); /*string*/
    kk_string_t _x1374;
    kk_string_t _x1375;
    kk_box_t _x1376 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_file_fun1377(_ctx), kk_std_os_path__path_box(from, _ctx), _ctx); /*3289*/
    _x1375 = kk_string_unbox(_x1376); /*string*/
    kk_string_t _x1380;
    kk_string_t _x1381;
    kk_define_string_literal(, _s1382, 4, " to ")
    _x1381 = kk_string_dup(_s1382); /*string*/
    kk_string_t _x1383;
    kk_box_t _x1384 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_file_fun1385(_ctx), kk_std_os_path__path_box(to, _ctx), _ctx); /*3289*/
    _x1383 = kk_string_unbox(_x1384); /*string*/
    _x1380 = kk_std_core__lp__plus__plus__1_rp_(_x1381, _x1383, _ctx); /*string*/
    _x1374 = kk_std_core__lp__plus__plus__1_rp_(_x1375, _x1380, _ctx); /*string*/
    _x20 = kk_std_core__lp__plus__plus__1_rp_(_x1372, _x1374, _ctx); /*string*/
    kk_function_t _b_1098_1085 = kk_std_os_dir_new_copy_file_fun1388(_ctx); /*(exn0 : exception, pre : string) -> exception*/;
    kk_std_core__exception _b_1099_1086 = exn; /*exception*/;
    kk_string_t _b_1100_1087 = _x20; /*string*/;
    kk_box_t _x1395 = kk_std_core_hnd__open_none2(kk_std_os_dir_new_copy_file_fun1396(_b_1098_1085, _ctx), kk_std_core__exception_box(_b_1099_1086, _ctx), kk_string_box(_b_1100_1087), _ctx); /*3381*/
    _x1371 = kk_std_core__exception_unbox(_x1395, _ctx); /*exception*/
    _b_1095_1090 = kk_std_core__new_Error(_x1371, _ctx); /*error<()>*/
    kk_box_t _x1400 = kk_std_core_throw_1(_b_1095_1090, _ctx); /*11674*/
    kk_unit_unbox(_x1400); return kk_Unit;
  }
  kk_std_core__error_drop(_match_1340, _ctx);
  kk_std_os_path__path_drop(from, _ctx);
  kk_std_os_path__path_drop(to, _ctx);
  kk_Unit; return kk_Unit;
}
 
// Ensure a directory path exists


// lift anonymous function
struct kk_std_os_dir_ensure_dir_fun1402__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_ensure_dir_fun1402(kk_function_t _fself, kk_box_t _b_1103, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_ensure_dir_fun1402(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_ensure_dir_fun1402, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_dir_ensure_dir_fun1402(kk_function_t _fself, kk_box_t _b_1103, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x1403;
  kk_std_os_path__path _x1404 = kk_std_os_path__path_unbox(_b_1103, _ctx); /*std/os/path/path*/
  _x1403 = kk_std_os_path_string(_x1404, _ctx); /*string*/
  return kk_string_box(_x1403);
}


// lift anonymous function
struct kk_std_os_dir_ensure_dir_fun1409__t {
  struct kk_function_s _base;
};
static kk_std_core__error kk_std_os_dir_ensure_dir_fun1409(kk_function_t _fself, kk_string_t _x11407, kk_integer_t _x21408, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_ensure_dir_fun1409(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_ensure_dir_fun1409, _ctx)
  return kk_function_dup(_fself);
}

static kk_std_core__error kk_std_os_dir_ensure_dir_fun1409(kk_function_t _fself, kk_string_t _x11407, kk_integer_t _x21408, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_os_dir_ensure_dir_err(_x11407, _x21408, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_ensure_dir_fun1411__t {
  struct kk_function_s _base;
  kk_function_t _b_1123_1106;
};
static kk_box_t kk_std_os_dir_ensure_dir_fun1411(kk_function_t _fself, kk_box_t _b_1109, kk_box_t _b_1110, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_ensure_dir_fun1411(kk_function_t _b_1123_1106, kk_context_t* _ctx) {
  struct kk_std_os_dir_ensure_dir_fun1411__t* _self = kk_function_alloc_as(struct kk_std_os_dir_ensure_dir_fun1411__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir_ensure_dir_fun1411, kk_context());
  _self->_b_1123_1106 = _b_1123_1106;
  return &_self->_base;
}

static kk_box_t kk_std_os_dir_ensure_dir_fun1411(kk_function_t _fself, kk_box_t _b_1109, kk_box_t _b_1110, kk_context_t* _ctx) {
  struct kk_std_os_dir_ensure_dir_fun1411__t* _self = kk_function_as(struct kk_std_os_dir_ensure_dir_fun1411__t*, _fself);
  kk_function_t _b_1123_1106 = _self->_b_1123_1106; /* (path : string, mode : int) -> fsys error<()> */
  kk_drop_match(_self, {kk_function_dup(_b_1123_1106);}, {}, _ctx)
  kk_std_core__error _x1412;
  kk_string_t _x1413 = kk_string_unbox(_b_1109); /*string*/
  kk_integer_t _x1414 = kk_integer_unbox(_b_1110); /*int*/
  _x1412 = kk_function_call(kk_std_core__error, (kk_function_t, kk_string_t, kk_integer_t, kk_context_t*), _b_1123_1106, (_b_1123_1106, _x1413, _x1414, _ctx)); /*error<()>*/
  return kk_std_core__error_box(_x1412, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_ensure_dir_fun1420__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_ensure_dir_fun1420(kk_function_t _fself, kk_box_t _b_1113, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_ensure_dir_fun1420(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_ensure_dir_fun1420, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_dir_ensure_dir_fun1420(kk_function_t _fself, kk_box_t _b_1113, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x1421;
  kk_std_os_path__path p_1127 = kk_std_os_path__path_unbox(_b_1113, _ctx); /*std/os/path/path*/;
  kk_string_t _x1422 = kk_std_os_path_string(p_1127, _ctx); /*string*/
  _x1421 = kk_std_core_show_3(_x1422, _ctx); /*string*/
  return kk_string_box(_x1421);
}


// lift anonymous function
struct kk_std_os_dir_ensure_dir_fun1423__t {
  struct kk_function_s _base;
};
static kk_std_core__exception kk_std_os_dir_ensure_dir_fun1423(kk_function_t _fself, kk_std_core__exception exn0, kk_string_t pre, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_ensure_dir_fun1423(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_ensure_dir_fun1423, _ctx)
  return kk_function_dup(_fself);
}

static kk_std_core__exception kk_std_os_dir_ensure_dir_fun1423(kk_function_t _fself, kk_std_core__exception exn0, kk_string_t pre, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x1424;
  kk_string_t _x1425;
  kk_string_t _x1426;
  kk_define_string_literal(, _s1427, 2, ": ")
  _x1426 = kk_string_dup(_s1427); /*string*/
  kk_string_t _x1428;
  kk_string_t _x = exn0.message;
  kk_string_dup(_x);
  _x1428 = _x; /*string*/
  _x1425 = kk_std_core__lp__plus__plus__1_rp_(_x1426, _x1428, _ctx); /*string*/
  _x1424 = kk_std_core__lp__plus__plus__1_rp_(pre, _x1425, _ctx); /*string*/
  kk_std_core__exception_info _x1429;
  kk_std_core__exception_info _x02 = exn0.info;
  kk_std_core__exception_info_dup(_x02);
  kk_std_core__exception_drop(exn0, _ctx);
  kk_Unit;
  _x1429 = _x02; /*exception-info*/
  return kk_std_core__new_Exception(_x1424, _x1429, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_ensure_dir_fun1431__t {
  struct kk_function_s _base;
  kk_function_t _b_1128_1116;
};
static kk_box_t kk_std_os_dir_ensure_dir_fun1431(kk_function_t _fself, kk_box_t _b_1119, kk_box_t _b_1120, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_ensure_dir_fun1431(kk_function_t _b_1128_1116, kk_context_t* _ctx) {
  struct kk_std_os_dir_ensure_dir_fun1431__t* _self = kk_function_alloc_as(struct kk_std_os_dir_ensure_dir_fun1431__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir_ensure_dir_fun1431, kk_context());
  _self->_b_1128_1116 = _b_1128_1116;
  return &_self->_base;
}

static kk_box_t kk_std_os_dir_ensure_dir_fun1431(kk_function_t _fself, kk_box_t _b_1119, kk_box_t _b_1120, kk_context_t* _ctx) {
  struct kk_std_os_dir_ensure_dir_fun1431__t* _self = kk_function_as(struct kk_std_os_dir_ensure_dir_fun1431__t*, _fself);
  kk_function_t _b_1128_1116 = _self->_b_1128_1116; /* (exn0 : exception, pre : string) -> exception */
  kk_drop_match(_self, {kk_function_dup(_b_1128_1116);}, {}, _ctx)
  kk_std_core__exception _x1432;
  kk_std_core__exception _x1433 = kk_std_core__exception_unbox(_b_1119, _ctx); /*exception*/
  kk_string_t _x1434 = kk_string_unbox(_b_1120); /*string*/
  _x1432 = kk_function_call(kk_std_core__exception, (kk_function_t, kk_std_core__exception, kk_string_t, kk_context_t*), _b_1128_1116, (_b_1128_1116, _x1433, _x1434, _ctx)); /*exception*/
  return kk_std_core__exception_box(_x1432, _ctx);
}

kk_unit_t kk_std_os_dir_ensure_dir(kk_std_os_path__path dir, kk_context_t* _ctx) { /* (dir : std/os/path/path) -> <exn,fsys> () */ 
  kk_string_t _x1;
  kk_box_t _x1401;
  kk_box_t _x1405;
  kk_std_os_path__path _x1406 = kk_std_os_path__path_dup(dir); /*std/os/path/path*/
  _x1405 = kk_std_os_path__path_box(_x1406, _ctx); /*3288*/
  _x1401 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_ensure_dir_fun1402(_ctx), _x1405, _ctx); /*3289*/
  _x1 = kk_string_unbox(_x1401); /*string*/
  kk_std_core__error _match_1339;
  kk_function_t _b_1123_1106 = kk_std_os_dir_new_ensure_dir_fun1409(_ctx); /*(path : string, mode : int) -> fsys error<()>*/;
  kk_string_t _b_1124_1107 = _x1; /*string*/;
  kk_integer_t _b_1125_1108 = kk_integer_from_small(-1); /*int*/;
  kk_box_t _x1410 = kk_std_core_hnd__open_none2(kk_std_os_dir_new_ensure_dir_fun1411(_b_1123_1106, _ctx), kk_string_box(_b_1124_1107), kk_integer_box(_b_1125_1108), _ctx); /*3381*/
  _match_1339 = kk_std_core__error_unbox(_x1410, _ctx); /*error<()>*/
  if (kk_std_core__is_Error(_match_1339)) {
    kk_std_core__exception exn = _match_1339._cons.Error.exception;
    kk_std_core__exception_dup(exn);
    kk_std_core__error_drop(_match_1339, _ctx);
    kk_Unit;
    kk_std_core__error _b_1126_1121;
    kk_std_core__exception _x1415;
    kk_string_t _x20;
    kk_string_t _x1416;
    kk_define_string_literal(, _s1417, 27, "unable to create directory ")
    _x1416 = kk_string_dup(_s1417); /*string*/
    kk_string_t _x1418;
    kk_box_t _x1419 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_ensure_dir_fun1420(_ctx), kk_std_os_path__path_box(dir, _ctx), _ctx); /*3289*/
    _x1418 = kk_string_unbox(_x1419); /*string*/
    _x20 = kk_std_core__lp__plus__plus__1_rp_(_x1416, _x1418, _ctx); /*string*/
    kk_function_t _b_1128_1116 = kk_std_os_dir_new_ensure_dir_fun1423(_ctx); /*(exn0 : exception, pre : string) -> exception*/;
    kk_std_core__exception _b_1129_1117 = exn; /*exception*/;
    kk_string_t _b_1130_1118 = _x20; /*string*/;
    kk_box_t _x1430 = kk_std_core_hnd__open_none2(kk_std_os_dir_new_ensure_dir_fun1431(_b_1128_1116, _ctx), kk_std_core__exception_box(_b_1129_1117, _ctx), kk_string_box(_b_1130_1118), _ctx); /*3381*/
    _x1415 = kk_std_core__exception_unbox(_x1430, _ctx); /*exception*/
    _b_1126_1121 = kk_std_core__new_Error(_x1415, _ctx); /*error<()>*/
    kk_box_t _x1435 = kk_std_core_throw_1(_b_1126_1121, _ctx); /*11674*/
    kk_unit_unbox(_x1435); return kk_Unit;
  }
  kk_box_t _box_x1122 = _match_1339._cons.Ok.result;
  kk_unit_t _pat30 = kk_unit_unbox(_box_x1122);
  kk_std_core__error_drop(_match_1339, _ctx);
  kk_std_os_path__path_drop(dir, _ctx);
  kk_Unit; return kk_Unit;
}
 
// List directory contents (excluding `.` and `..`).
// Returns a list of full paths (not just the names in the directory).


// lift anonymous function
struct kk_std_os_dir_list_directory_fun1441__t {
  struct kk_function_s _base;
  kk_std_os_path__path dir;
};
static kk_std_os_path__path kk_std_os_dir_list_directory_fun1441(kk_function_t _fself, kk_string_t name, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_list_directory_fun1441(kk_std_os_path__path dir, kk_context_t* _ctx) {
  struct kk_std_os_dir_list_directory_fun1441__t* _self = kk_function_alloc_as(struct kk_std_os_dir_list_directory_fun1441__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir_list_directory_fun1441, kk_context());
  _self->dir = dir;
  return &_self->_base;
}

static kk_std_os_path__path kk_std_os_dir_list_directory_fun1441(kk_function_t _fself, kk_string_t name, kk_context_t* _ctx) {
  struct kk_std_os_dir_list_directory_fun1441__t* _self = kk_function_as(struct kk_std_os_dir_list_directory_fun1441__t*, _fself);
  kk_std_os_path__path dir = _self->dir; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(dir);}, {}, _ctx)
  kk_std_os_path__path _x1442 = kk_std_os_path_path(name, _ctx); /*std/os/path/path*/
  return kk_std_os_path__lp__fs__rp_(dir, _x1442, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_list_directory_fun1443__t {
  struct kk_function_s _base;
  kk_function_t _b_1136_1133;
};
static kk_box_t kk_std_os_dir_list_directory_fun1443(kk_function_t _fself, kk_box_t _b_1134, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_list_directory_fun1443(kk_function_t _b_1136_1133, kk_context_t* _ctx) {
  struct kk_std_os_dir_list_directory_fun1443__t* _self = kk_function_alloc_as(struct kk_std_os_dir_list_directory_fun1443__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir_list_directory_fun1443, kk_context());
  _self->_b_1136_1133 = _b_1136_1133;
  return &_self->_base;
}

static kk_box_t kk_std_os_dir_list_directory_fun1443(kk_function_t _fself, kk_box_t _b_1134, kk_context_t* _ctx) {
  struct kk_std_os_dir_list_directory_fun1443__t* _self = kk_function_as(struct kk_std_os_dir_list_directory_fun1443__t*, _fself);
  kk_function_t _b_1136_1133 = _self->_b_1136_1133; /* (name : string) -> fsys std/os/path/path */
  kk_drop_match(_self, {kk_function_dup(_b_1136_1133);}, {}, _ctx)
  kk_std_os_path__path _x1444;
  kk_string_t _x1445 = kk_string_unbox(_b_1134); /*string*/
  _x1444 = kk_function_call(kk_std_os_path__path, (kk_function_t, kk_string_t, kk_context_t*), _b_1136_1133, (_b_1136_1133, _x1445, _ctx)); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x1444, _ctx);
}

kk_std_core__list kk_std_os_dir_list_directory(kk_std_os_path__path dir, kk_context_t* _ctx) { /* (dir : std/os/path/path) -> fsys list<std/os/path/path> */ 
  kk_std_core__error _match_1338;
  kk_string_t _x1438;
  kk_std_os_path__path _x1439 = kk_std_os_path__path_dup(dir); /*std/os/path/path*/
  _x1438 = kk_std_os_path_string(_x1439, _ctx); /*string*/
  _match_1338 = kk_std_os_dir_prim_list_dir(_x1438, _ctx); /*error<vector<string>>*/
  if (kk_std_core__is_Error(_match_1338)) {
    kk_std_core__exception _pat0 = _match_1338._cons.Error.exception;
    kk_std_core__error_drop(_match_1338, _ctx);
    kk_std_os_path__path_drop(dir, _ctx);
    return kk_std_core__new_Nil(_ctx);
  }
  kk_box_t _box_x1131 = _match_1338._cons.Ok.result;
  kk_vector_t contents = kk_vector_unbox(_box_x1131, NULL);
  kk_vector_dup(contents);
  kk_std_core__error_drop(_match_1338, _ctx);
  kk_Unit;
  kk_std_core__list _b_1135_1132 = kk_std_core_vlist(contents, kk_std_core_types__new_None(_ctx), _ctx); /*list<string>*/;
  kk_function_t _b_1136_1133 = kk_std_os_dir_new_list_directory_fun1441(dir, _ctx); /*(name : string) -> fsys std/os/path/path*/;
  return kk_std_core_map_5(_b_1135_1132, kk_std_os_dir_new_list_directory_fun1443(_b_1136_1133, _ctx), _ctx);
}
 
// monadic lift


// lift anonymous function
struct kk_std_os_dir__mlift1036_copy_directory_fun1446__t {
  struct kk_function_s _base;
  kk_std_os_path__path to;
};
static kk_unit_t kk_std_os_dir__mlift1036_copy_directory_fun1446(kk_function_t _fself, kk_std_os_path__path d, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift1036_copy_directory_fun1446(kk_std_os_path__path to, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1036_copy_directory_fun1446__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift1036_copy_directory_fun1446__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir__mlift1036_copy_directory_fun1446, kk_context());
  _self->to = to;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_os_dir__mlift1036_copy_directory_fun1450__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir__mlift1036_copy_directory_fun1450(kk_function_t _fself, kk_box_t _b_1142, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift1036_copy_directory_fun1450(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift1036_copy_directory_fun1450, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_dir__mlift1036_copy_directory_fun1450(kk_function_t _fself, kk_box_t _b_1142, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_std_os_path__path _x1451;
  kk_std_os_path__path p0_1155 = kk_std_os_path__path_unbox(_b_1142, _ctx); /*std/os/path/path*/;
  kk_std_core__list _b_1138_1137;
  kk_std_core__list _x1452;
  kk_std_core__list _x100 = p0_1155.parts;
  kk_std_core__list_dup(_x100);
  _x1452 = _x100; /*list<string>*/
  _b_1138_1137 = kk_std_core_take(_x1452, kk_integer_from_small(1), _ctx); /*list<string>*/
  kk_string_t _x1453 = kk_string_empty(); /*string*/
  kk_std_core__list _x1455;
  kk_std_core_types__optional _match_1337 = kk_std_core_types__new_Optional(kk_std_core__list_box(_b_1138_1137, _ctx), _ctx); /*optional<106>*/;
  if (kk_std_core_types__is_Optional(_match_1337)) {
    kk_box_t _box_x1139 = _match_1337._cons.Optional.value;
    kk_std_core__list _parts_1110 = kk_std_core__list_unbox(_box_x1139, NULL);
    kk_std_os_path__path_drop(p0_1155, _ctx);
    kk_std_core__list_dup(_parts_1110);
    kk_std_core_types__optional_drop(_match_1337, _ctx);
    kk_Unit;
    _x1455 = _parts_1110; /*list<string>*/
    goto _match1456;
  }
  kk_std_core__list _x000 = p0_1155.parts;
  kk_std_core__list_dup(_x000);
  kk_std_os_path__path_drop(p0_1155, _ctx);
  kk_Unit;
  _x1455 = _x000; /*list<string>*/
  _match1456: ;
  _x1451 = kk_std_os_path__new_Path(_x1453, _x1455, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x1451, _ctx);
}


// lift anonymous function
struct kk_std_os_dir__mlift1036_copy_directory_fun1460__t {
  struct kk_function_s _base;
};
static kk_std_os_path__path kk_std_os_dir__mlift1036_copy_directory_fun1460(kk_function_t _fself, kk_std_os_path__path _x11458, kk_std_os_path__path _x21459, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift1036_copy_directory_fun1460(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift1036_copy_directory_fun1460, _ctx)
  return kk_function_dup(_fself);
}

static kk_std_os_path__path kk_std_os_dir__mlift1036_copy_directory_fun1460(kk_function_t _fself, kk_std_os_path__path _x11458, kk_std_os_path__path _x21459, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_os_path__lp__fs__rp_(_x11458, _x21459, _ctx);
}


// lift anonymous function
struct kk_std_os_dir__mlift1036_copy_directory_fun1462__t {
  struct kk_function_s _base;
  kk_function_t _b_1156_1145;
};
static kk_box_t kk_std_os_dir__mlift1036_copy_directory_fun1462(kk_function_t _fself, kk_box_t _b_1148, kk_box_t _b_1149, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift1036_copy_directory_fun1462(kk_function_t _b_1156_1145, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1036_copy_directory_fun1462__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift1036_copy_directory_fun1462__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir__mlift1036_copy_directory_fun1462, kk_context());
  _self->_b_1156_1145 = _b_1156_1145;
  return &_self->_base;
}

static kk_box_t kk_std_os_dir__mlift1036_copy_directory_fun1462(kk_function_t _fself, kk_box_t _b_1148, kk_box_t _b_1149, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1036_copy_directory_fun1462__t* _self = kk_function_as(struct kk_std_os_dir__mlift1036_copy_directory_fun1462__t*, _fself);
  kk_function_t _b_1156_1145 = _self->_b_1156_1145; /* (p1 : std/os/path/path, p2 : std/os/path/path) -> std/os/path/path */
  kk_drop_match(_self, {kk_function_dup(_b_1156_1145);}, {}, _ctx)
  kk_std_os_path__path _x1463;
  kk_std_os_path__path _x1464 = kk_std_os_path__path_unbox(_b_1148, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x1465 = kk_std_os_path__path_unbox(_b_1149, _ctx); /*std/os/path/path*/
  _x1463 = kk_function_call(kk_std_os_path__path, (kk_function_t, kk_std_os_path__path, kk_std_os_path__path, kk_context_t*), _b_1156_1145, (_b_1156_1145, _x1464, _x1465, _ctx)); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x1463, _ctx);
}
static kk_unit_t kk_std_os_dir__mlift1036_copy_directory_fun1446(kk_function_t _fself, kk_std_os_path__path d, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1036_copy_directory_fun1446__t* _self = kk_function_as(struct kk_std_os_dir__mlift1036_copy_directory_fun1446__t*, _fself);
  kk_std_os_path__path to = _self->to; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to);}, {}, _ctx)
  kk_std_os_path__path _x1447 = kk_std_os_path__path_dup(d); /*std/os/path/path*/
  kk_std_os_path__path _x1448;
  kk_std_os_path__path _x20;
  kk_box_t _x1449 = kk_std_core_hnd__open_none1(kk_std_os_dir__new_mlift1036_copy_directory_fun1450(_ctx), kk_std_os_path__path_box(d, _ctx), _ctx); /*3289*/
  _x20 = kk_std_os_path__path_unbox(_x1449, _ctx); /*std/os/path/path*/
  kk_function_t _b_1156_1145 = kk_std_os_dir__new_mlift1036_copy_directory_fun1460(_ctx); /*(p1 : std/os/path/path, p2 : std/os/path/path) -> std/os/path/path*/;
  kk_std_os_path__path _b_1157_1146 = to; /*std/os/path/path*/;
  kk_std_os_path__path _b_1158_1147 = _x20; /*std/os/path/path*/;
  kk_box_t _x1461 = kk_std_core_hnd__open_none2(kk_std_os_dir__new_mlift1036_copy_directory_fun1462(_b_1156_1145, _ctx), kk_std_os_path__path_box(_b_1157_1146, _ctx), kk_std_os_path__path_box(_b_1158_1147, _ctx), _ctx); /*3381*/
  _x1448 = kk_std_os_path__path_unbox(_x1461, _ctx); /*std/os/path/path*/
  return kk_std_os_dir_copy_directory(_x1447, _x1448, _ctx);
}


// lift anonymous function
struct kk_std_os_dir__mlift1036_copy_directory_fun1466__t {
  struct kk_function_s _base;
  kk_function_t _b_1154_1151;
};
static kk_unit_t kk_std_os_dir__mlift1036_copy_directory_fun1466(kk_function_t _fself, kk_box_t _b_1152, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift1036_copy_directory_fun1466(kk_function_t _b_1154_1151, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1036_copy_directory_fun1466__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift1036_copy_directory_fun1466__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir__mlift1036_copy_directory_fun1466, kk_context());
  _self->_b_1154_1151 = _b_1154_1151;
  return &_self->_base;
}

static kk_unit_t kk_std_os_dir__mlift1036_copy_directory_fun1466(kk_function_t _fself, kk_box_t _b_1152, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1036_copy_directory_fun1466__t* _self = kk_function_as(struct kk_std_os_dir__mlift1036_copy_directory_fun1466__t*, _fself);
  kk_function_t _b_1154_1151 = _self->_b_1154_1151; /* (d : std/os/path/path) -> <div,exn,fsys> () */
  kk_drop_match(_self, {kk_function_dup(_b_1154_1151);}, {}, _ctx)
  kk_std_os_path__path _x1467 = kk_std_os_path__path_unbox(_b_1152, _ctx); /*std/os/path/path*/
  return kk_function_call(kk_unit_t, (kk_function_t, kk_std_os_path__path, kk_context_t*), _b_1154_1151, (_b_1154_1151, _x1467, _ctx));
}

kk_unit_t kk_std_os_dir__mlift1036_copy_directory(kk_std_core__list dirs, kk_std_os_path__path to, kk_unit_t wild__0, kk_context_t* _ctx) { /* (dirs : list<std/os/path/path>, to : std/os/path/path, wild_0 : ()) -> <exn,fsys,div> () */ 
  kk_std_core__list _b_1153_1150 = dirs; /*list<std/os/path/path>*/;
  kk_function_t _b_1154_1151 = kk_std_os_dir__new_mlift1036_copy_directory_fun1446(to, _ctx); /*(d : std/os/path/path) -> <div,exn,fsys> ()*/;
  kk_std_core_foreach(_b_1153_1150, kk_std_os_dir__new_mlift1036_copy_directory_fun1466(_b_1154_1151, _ctx), _ctx); return kk_Unit;
}
 
// monadic lift


// lift anonymous function
struct kk_std_os_dir__mlift1037_copy_directory_fun1471__t {
  struct kk_function_s _base;
  kk_std_os_path__path to0;
};
static kk_unit_t kk_std_os_dir__mlift1037_copy_directory_fun1471(kk_function_t _fself, kk_box_t _b_1176, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift1037_copy_directory_fun1471(kk_std_os_path__path to0, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1037_copy_directory_fun1471__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift1037_copy_directory_fun1471__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir__mlift1037_copy_directory_fun1471, kk_context());
  _self->to0 = to0;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_os_dir__mlift1037_copy_directory_fun1475__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir__mlift1037_copy_directory_fun1475(kk_function_t _fself, kk_box_t _b_1166, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift1037_copy_directory_fun1475(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift1037_copy_directory_fun1475, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_dir__mlift1037_copy_directory_fun1475(kk_function_t _fself, kk_box_t _b_1166, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_std_os_path__path _x1476;
  kk_std_core__list _b_1162_1161;
  kk_std_core__list _x1477;
  kk_std_os_path__path _match_1336;
  kk_box_t _x1478 = kk_box_dup(_b_1166); /*3288*/
  _match_1336 = kk_std_os_path__path_unbox(_x1478, _ctx); /*std/os/path/path*/
  kk_std_core__list _x13 = _match_1336.parts;
  kk_std_core__list_dup(_x13);
  kk_std_os_path__path_drop(_match_1336, _ctx);
  kk_Unit;
  _x1477 = _x13; /*list<string>*/
  _b_1162_1161 = kk_std_core_take(_x1477, kk_integer_from_small(1), _ctx); /*list<string>*/
  kk_string_t _x1479 = kk_string_empty(); /*string*/
  kk_std_core__list _x1481;
  kk_std_core_types__optional _match_1334 = kk_std_core_types__new_Optional(kk_std_core__list_box(_b_1162_1161, _ctx), _ctx); /*optional<106>*/;
  if (kk_std_core_types__is_Optional(_match_1334)) {
    kk_box_t _box_x1163 = _match_1334._cons.Optional.value;
    kk_std_core__list _parts_111 = kk_std_core__list_unbox(_box_x1163, NULL);
    kk_std_core__list_dup(_parts_111);
    kk_std_core_types__optional_drop(_match_1334, _ctx);
    kk_Unit;
    kk_box_drop(_b_1166, _ctx);
    kk_Unit;
    _x1481 = _parts_111; /*list<string>*/
    goto _match1482;
  }
  kk_std_os_path__path _match_1335 = kk_std_os_path__path_unbox(_b_1166, _ctx); /*std/os/path/path*/;
  kk_std_core__list _x03 = _match_1335.parts;
  kk_std_core__list_dup(_x03);
  kk_std_os_path__path_drop(_match_1335, _ctx);
  kk_Unit;
  _x1481 = _x03; /*list<string>*/
  _match1482: ;
  _x1476 = kk_std_os_path__new_Path(_x1479, _x1481, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x1476, _ctx);
}


// lift anonymous function
struct kk_std_os_dir__mlift1037_copy_directory_fun1485__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir__mlift1037_copy_directory_fun1485(kk_function_t _fself, kk_box_t _b_1172, kk_box_t _b_1173, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift1037_copy_directory_fun1485(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift1037_copy_directory_fun1485, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_dir__mlift1037_copy_directory_fun1485(kk_function_t _fself, kk_box_t _b_1172, kk_box_t _b_1173, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_std_os_path__path _x1486;
  kk_std_os_path__path _x1487 = kk_std_os_path__path_unbox(_b_1172, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x1488 = kk_std_os_path__path_unbox(_b_1173, _ctx); /*std/os/path/path*/
  _x1486 = kk_std_os_path__lp__fs__rp_(_x1487, _x1488, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x1486, _ctx);
}
static kk_unit_t kk_std_os_dir__mlift1037_copy_directory_fun1471(kk_function_t _fself, kk_box_t _b_1176, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1037_copy_directory_fun1471__t* _self = kk_function_as(struct kk_std_os_dir__mlift1037_copy_directory_fun1471__t*, _fself);
  kk_std_os_path__path to0 = _self->to0; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to0);}, {}, _ctx)
  kk_std_os_path__path f_1185 = kk_std_os_path__path_unbox(_b_1176, _ctx); /*std/os/path/path*/;
  kk_std_os_path__path _x1472 = kk_std_os_path__path_dup(f_1185); /*std/os/path/path*/
  kk_std_os_path__path _x1473;
  kk_std_os_path__path _x2;
  kk_box_t _x1474 = kk_std_core_hnd__open_none1(kk_std_os_dir__new_mlift1037_copy_directory_fun1475(_ctx), kk_std_os_path__path_box(f_1185, _ctx), _ctx); /*3289*/
  _x2 = kk_std_os_path__path_unbox(_x1474, _ctx); /*std/os/path/path*/
  kk_box_t _x1484 = kk_std_core_hnd__open_none2(kk_std_os_dir__new_mlift1037_copy_directory_fun1485(_ctx), kk_std_os_path__path_box(to0, _ctx), kk_std_os_path__path_box(_x2, _ctx), _ctx); /*3381*/
  _x1473 = kk_std_os_path__path_unbox(_x1484, _ctx); /*std/os/path/path*/
  return kk_std_os_dir_copy_file(_x1472, _x1473, kk_std_core_types__new_None(_ctx), _ctx);
}


// lift anonymous function
struct kk_std_os_dir__mlift1037_copy_directory_fun1489__t {
  struct kk_function_s _base;
  kk_std_core__list dirs0;
  kk_std_os_path__path to0;
};
static kk_unit_t kk_std_os_dir__mlift1037_copy_directory_fun1489(kk_function_t _fself, kk_unit_t wild__00, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift1037_copy_directory_fun1489(kk_std_core__list dirs0, kk_std_os_path__path to0, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1037_copy_directory_fun1489__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift1037_copy_directory_fun1489__t, 4, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir__mlift1037_copy_directory_fun1489, kk_context());
  _self->dirs0 = dirs0;
  _self->to0 = to0;
  return &_self->_base;
}

static kk_unit_t kk_std_os_dir__mlift1037_copy_directory_fun1489(kk_function_t _fself, kk_unit_t wild__00, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1037_copy_directory_fun1489__t* _self = kk_function_as(struct kk_std_os_dir__mlift1037_copy_directory_fun1489__t*, _fself);
  kk_std_core__list dirs0 = _self->dirs0; /* list<std/os/path/path> */
  kk_std_os_path__path to0 = _self->to0; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_core__list_dup(dirs0);kk_std_os_path__path_dup(to0);}, {}, _ctx)
  return kk_std_os_dir__mlift1036_copy_directory(dirs0, to0, wild__00, _ctx);
}


// lift anonymous function
struct kk_std_os_dir__mlift1037_copy_directory_fun1491__t {
  struct kk_function_s _base;
  kk_function_t _b_1186_1183;
};
static kk_box_t kk_std_os_dir__mlift1037_copy_directory_fun1491(kk_function_t _fself, kk_box_t _b_1184, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift1037_copy_directory_fun1491(kk_function_t _b_1186_1183, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1037_copy_directory_fun1491__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift1037_copy_directory_fun1491__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir__mlift1037_copy_directory_fun1491, kk_context());
  _self->_b_1186_1183 = _b_1186_1183;
  return &_self->_base;
}

static kk_box_t kk_std_os_dir__mlift1037_copy_directory_fun1491(kk_function_t _fself, kk_box_t _b_1184, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1037_copy_directory_fun1491__t* _self = kk_function_as(struct kk_std_os_dir__mlift1037_copy_directory_fun1491__t*, _fself);
  kk_function_t _b_1186_1183 = _self->_b_1186_1183; /* (wild_00 : ()) -> <exn,fsys,div> () */
  kk_drop_match(_self, {kk_function_dup(_b_1186_1183);}, {}, _ctx)
  kk_unit_t _x1492 = kk_Unit;
  kk_unit_t _x1493 = kk_Unit;
  kk_unit_unbox(_b_1184);
  kk_function_call(kk_unit_t, (kk_function_t, kk_unit_t, kk_context_t*), _b_1186_1183, (_b_1186_1183, _x1493, _ctx));
  return kk_unit_box(_x1492);
}

kk_unit_t kk_std_os_dir__mlift1037_copy_directory(kk_std_os_path__path to0, kk_std_core_types__tuple2_ _y_1011, kk_context_t* _ctx) { /* (to : std/os/path/path, (list<std/os/path/path>, list<std/os/path/path>)) -> <fsys,div,exn> () */ 
  kk_box_t _box_x1159 = _y_1011.fst;
  kk_box_t _box_x1160 = _y_1011.snd;
  kk_std_core__list dirs0 = kk_std_core__list_unbox(_box_x1159, NULL);
  kk_std_core__list files = kk_std_core__list_unbox(_box_x1160, NULL);
  kk_std_core__list_dup(dirs0);
  kk_std_core__list_dup(files);
  kk_std_core_types__tuple2__drop(_y_1011, _ctx);
  kk_Unit;
  kk_unit_t x_1039 = kk_Unit;
  kk_function_t _x1470;
  kk_std_os_path__path_dup(to0);
  _x1470 = kk_std_os_dir__new_mlift1037_copy_directory_fun1471(to0, _ctx); /*(10978) -> 10979 ()*/
  kk_std_core_foreach(files, _x1470, _ctx);
  if (kk_yielding(kk_context())) {
    kk_function_t _b_1186_1183 = kk_std_os_dir__new_mlift1037_copy_directory_fun1489(dirs0, to0, _ctx); /*(wild_00 : ()) -> <exn,fsys,div> ()*/;
    kk_box_t _x1490 = kk_std_core_hnd_yield_extend(kk_std_os_dir__new_mlift1037_copy_directory_fun1491(_b_1186_1183, _ctx), _ctx); /*3858*/
    kk_unit_unbox(_x1490); return kk_Unit;
  }
  kk_std_os_dir__mlift1036_copy_directory(dirs0, to0, x_1039, _ctx); return kk_Unit;
}
 
// monadic lift


// lift anonymous function
struct kk_std_os_dir__mlift1038_copy_directory_fun1495__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir__mlift1038_copy_directory_fun1495(kk_function_t _fself, kk_box_t _b_1189, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift1038_copy_directory_fun1495(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift1038_copy_directory_fun1495, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_dir__mlift1038_copy_directory_fun1495(kk_function_t _fself, kk_box_t _b_1189, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_std_core__list _x1496;
  kk_std_os_path__path _x1497 = kk_std_os_path__path_unbox(_b_1189, _ctx); /*std/os/path/path*/
  _x1496 = kk_std_os_dir_list_directory(_x1497, _ctx); /*list<std/os/path/path>*/
  return kk_std_core__list_box(_x1496, _ctx);
}


// lift anonymous function
struct kk_std_os_dir__mlift1038_copy_directory_fun1498__t {
  struct kk_function_s _base;
};
static bool kk_std_os_dir__mlift1038_copy_directory_fun1498(kk_function_t _fself, kk_box_t _b_1199, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift1038_copy_directory_fun1498(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift1038_copy_directory_fun1498, _ctx)
  return kk_function_dup(_fself);
}



// lift anonymous function
struct kk_std_os_dir__mlift1038_copy_directory_fun1500__t {
  struct kk_function_s _base;
};
static bool kk_std_os_dir__mlift1038_copy_directory_fun1500(kk_function_t _fself, kk_std_os_path__path _x11499, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift1038_copy_directory_fun1500(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift1038_copy_directory_fun1500, _ctx)
  return kk_function_dup(_fself);
}

static bool kk_std_os_dir__mlift1038_copy_directory_fun1500(kk_function_t _fself, kk_std_os_path__path _x11499, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_os_dir_is_directory(_x11499, _ctx);
}


// lift anonymous function
struct kk_std_os_dir__mlift1038_copy_directory_fun1502__t {
  struct kk_function_s _base;
  kk_function_t _b_1204_1192;
};
static kk_box_t kk_std_os_dir__mlift1038_copy_directory_fun1502(kk_function_t _fself, kk_box_t _b_1194, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift1038_copy_directory_fun1502(kk_function_t _b_1204_1192, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1038_copy_directory_fun1502__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift1038_copy_directory_fun1502__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir__mlift1038_copy_directory_fun1502, kk_context());
  _self->_b_1204_1192 = _b_1204_1192;
  return &_self->_base;
}

static kk_box_t kk_std_os_dir__mlift1038_copy_directory_fun1502(kk_function_t _fself, kk_box_t _b_1194, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1038_copy_directory_fun1502__t* _self = kk_function_as(struct kk_std_os_dir__mlift1038_copy_directory_fun1502__t*, _fself);
  kk_function_t _b_1204_1192 = _self->_b_1204_1192; /* (dir : std/os/path/path) -> fsys bool */
  kk_drop_match(_self, {kk_function_dup(_b_1204_1192);}, {}, _ctx)
  bool _x1503;
  kk_std_os_path__path _x1504 = kk_std_os_path__path_unbox(_b_1194, _ctx); /*std/os/path/path*/
  _x1503 = kk_function_call(bool, (kk_function_t, kk_std_os_path__path, kk_context_t*), _b_1204_1192, (_b_1204_1192, _x1504, _ctx)); /*bool*/
  return kk_bool_box(_x1503);
}
static bool kk_std_os_dir__mlift1038_copy_directory_fun1498(kk_function_t _fself, kk_box_t _b_1199, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_std_os_path__path _x10_1208 = kk_std_os_path__path_unbox(_b_1199, _ctx); /*std/os/path/path*/;
  kk_function_t _b_1204_1192 = kk_std_os_dir__new_mlift1038_copy_directory_fun1500(_ctx); /*(dir : std/os/path/path) -> fsys bool*/;
  kk_std_os_path__path _b_1205_1193 = _x10_1208; /*std/os/path/path*/;
  kk_box_t _x1501 = kk_std_core_hnd__open_none1(kk_std_os_dir__new_mlift1038_copy_directory_fun1502(_b_1204_1192, _ctx), kk_std_os_path__path_box(_b_1205_1193, _ctx), _ctx); /*3289*/
  return kk_bool_unbox(_x1501);
}


// lift anonymous function
struct kk_std_os_dir__mlift1038_copy_directory_fun1505__t {
  struct kk_function_s _base;
  kk_std_os_path__path to1;
};
static kk_unit_t kk_std_os_dir__mlift1038_copy_directory_fun1505(kk_function_t _fself, kk_std_core_types__tuple2_ _y_10110, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift1038_copy_directory_fun1505(kk_std_os_path__path to1, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1038_copy_directory_fun1505__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift1038_copy_directory_fun1505__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir__mlift1038_copy_directory_fun1505, kk_context());
  _self->to1 = to1;
  return &_self->_base;
}

static kk_unit_t kk_std_os_dir__mlift1038_copy_directory_fun1505(kk_function_t _fself, kk_std_core_types__tuple2_ _y_10110, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1038_copy_directory_fun1505__t* _self = kk_function_as(struct kk_std_os_dir__mlift1038_copy_directory_fun1505__t*, _fself);
  kk_std_os_path__path to1 = _self->to1; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to1);}, {}, _ctx)
  return kk_std_os_dir__mlift1037_copy_directory(to1, _y_10110, _ctx);
}


// lift anonymous function
struct kk_std_os_dir__mlift1038_copy_directory_fun1507__t {
  struct kk_function_s _base;
  kk_function_t _b_1209_1206;
};
static kk_box_t kk_std_os_dir__mlift1038_copy_directory_fun1507(kk_function_t _fself, kk_box_t _b_1207, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift1038_copy_directory_fun1507(kk_function_t _b_1209_1206, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1038_copy_directory_fun1507__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift1038_copy_directory_fun1507__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir__mlift1038_copy_directory_fun1507, kk_context());
  _self->_b_1209_1206 = _b_1209_1206;
  return &_self->_base;
}

static kk_box_t kk_std_os_dir__mlift1038_copy_directory_fun1507(kk_function_t _fself, kk_box_t _b_1207, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1038_copy_directory_fun1507__t* _self = kk_function_as(struct kk_std_os_dir__mlift1038_copy_directory_fun1507__t*, _fself);
  kk_function_t _b_1209_1206 = _self->_b_1209_1206; /* ((list<std/os/path/path>, list<std/os/path/path>)) -> <fsys,div,exn> () */
  kk_drop_match(_self, {kk_function_dup(_b_1209_1206);}, {}, _ctx)
  kk_unit_t _x1508 = kk_Unit;
  kk_std_core_types__tuple2_ _x1509 = kk_std_core_types__tuple2__unbox(_b_1207, _ctx); /*(list<std/os/path/path>, list<std/os/path/path>)*/
  kk_function_call(kk_unit_t, (kk_function_t, kk_std_core_types__tuple2_, kk_context_t*), _b_1209_1206, (_b_1209_1206, _x1509, _ctx));
  return kk_unit_box(_x1508);
}

kk_unit_t kk_std_os_dir__mlift1038_copy_directory(kk_std_os_path__path dir, kk_std_os_path__path to1, kk_unit_t wild__, kk_context_t* _ctx) { /* (dir : std/os/path/path, to : std/os/path/path, wild_ : ()) -> <exn,fsys> () */ 
  kk_std_core__list all;
  kk_box_t _x1494 = kk_std_core_hnd__open_none1(kk_std_os_dir__new_mlift1038_copy_directory_fun1495(_ctx), kk_std_os_path__path_box(dir, _ctx), _ctx); /*3289*/
  all = kk_std_core__list_unbox(_x1494, _ctx); /*list<std/os/path/path>*/
  kk_std_core_types__tuple2_ x0_1041 = kk_std_core_partition_acc(all, kk_std_os_dir__new_mlift1038_copy_directory_fun1498(_ctx), kk_std_core__new_Nil(_ctx), kk_std_core__new_Nil(_ctx), _ctx); /*(list<std/os/path/path>, list<std/os/path/path>)*/;
  if (kk_yielding(kk_context())) {
    kk_std_core_types__tuple2__drop(x0_1041, _ctx);
    kk_function_t _b_1209_1206 = kk_std_os_dir__new_mlift1038_copy_directory_fun1505(to1, _ctx); /*((list<std/os/path/path>, list<std/os/path/path>)) -> <fsys,div,exn> ()*/;
    kk_box_t _x1506 = kk_std_core_hnd_yield_extend(kk_std_os_dir__new_mlift1038_copy_directory_fun1507(_b_1209_1206, _ctx), _ctx); /*3858*/
    kk_unit_unbox(_x1506); return kk_Unit;
  }
  kk_std_os_dir__mlift1037_copy_directory(to1, x0_1041, _ctx); return kk_Unit;
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1511__t {
  struct kk_function_s _base;
  kk_std_os_path__path dir0;
  kk_std_os_path__path to2;
};
static kk_unit_t kk_std_os_dir_copy_directory_fun1511(kk_function_t _fself, kk_unit_t wild__1, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1511(kk_std_os_path__path dir0, kk_std_os_path__path to2, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1511__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun1511__t, 5, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir_copy_directory_fun1511, kk_context());
  _self->dir0 = dir0;
  _self->to2 = to2;
  return &_self->_base;
}

static kk_unit_t kk_std_os_dir_copy_directory_fun1511(kk_function_t _fself, kk_unit_t wild__1, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1511__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun1511__t*, _fself);
  kk_std_os_path__path dir0 = _self->dir0; /* std/os/path/path */
  kk_std_os_path__path to2 = _self->to2; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(dir0);kk_std_os_path__path_dup(to2);}, {}, _ctx)
  return kk_std_os_dir__mlift1038_copy_directory(dir0, to2, wild__1, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1513__t {
  struct kk_function_s _base;
  kk_function_t _b_1275_1210;
};
static kk_box_t kk_std_os_dir_copy_directory_fun1513(kk_function_t _fself, kk_box_t _b_1211, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1513(kk_function_t _b_1275_1210, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1513__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun1513__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir_copy_directory_fun1513, kk_context());
  _self->_b_1275_1210 = _b_1275_1210;
  return &_self->_base;
}

static kk_box_t kk_std_os_dir_copy_directory_fun1513(kk_function_t _fself, kk_box_t _b_1211, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1513__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun1513__t*, _fself);
  kk_function_t _b_1275_1210 = _self->_b_1275_1210; /* (wild_1 : ()) -> <exn,fsys> () */
  kk_drop_match(_self, {kk_function_dup(_b_1275_1210);}, {}, _ctx)
  kk_unit_t _x1514 = kk_Unit;
  kk_unit_t _x1515 = kk_Unit;
  kk_unit_unbox(_b_1211);
  kk_function_call(kk_unit_t, (kk_function_t, kk_unit_t, kk_context_t*), _b_1275_1210, (_b_1275_1210, _x1515, _ctx));
  return kk_unit_box(_x1514);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1517__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_directory_fun1517(kk_function_t _fself, kk_box_t _b_1214, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1517(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun1517, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_dir_copy_directory_fun1517(kk_function_t _fself, kk_box_t _b_1214, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_std_core__list _x1518;
  kk_std_os_path__path _x1519 = kk_std_os_path__path_unbox(_b_1214, _ctx); /*std/os/path/path*/
  _x1518 = kk_std_os_dir_list_directory(_x1519, _ctx); /*list<std/os/path/path>*/
  return kk_std_core__list_box(_x1518, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1520__t {
  struct kk_function_s _base;
};
static bool kk_std_os_dir_copy_directory_fun1520(kk_function_t _fself, kk_box_t _b_1224, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1520(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun1520, _ctx)
  return kk_function_dup(_fself);
}



// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1522__t {
  struct kk_function_s _base;
};
static bool kk_std_os_dir_copy_directory_fun1522(kk_function_t _fself, kk_std_os_path__path _x11521, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1522(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun1522, _ctx)
  return kk_function_dup(_fself);
}

static bool kk_std_os_dir_copy_directory_fun1522(kk_function_t _fself, kk_std_os_path__path _x11521, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_os_dir_is_directory(_x11521, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1524__t {
  struct kk_function_s _base;
  kk_function_t _b_1229_1217;
};
static kk_box_t kk_std_os_dir_copy_directory_fun1524(kk_function_t _fself, kk_box_t _b_1219, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1524(kk_function_t _b_1229_1217, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1524__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun1524__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir_copy_directory_fun1524, kk_context());
  _self->_b_1229_1217 = _b_1229_1217;
  return &_self->_base;
}

static kk_box_t kk_std_os_dir_copy_directory_fun1524(kk_function_t _fself, kk_box_t _b_1219, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1524__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun1524__t*, _fself);
  kk_function_t _b_1229_1217 = _self->_b_1229_1217; /* (dir : std/os/path/path) -> fsys bool */
  kk_drop_match(_self, {kk_function_dup(_b_1229_1217);}, {}, _ctx)
  bool _x1525;
  kk_std_os_path__path _x1526 = kk_std_os_path__path_unbox(_b_1219, _ctx); /*std/os/path/path*/
  _x1525 = kk_function_call(bool, (kk_function_t, kk_std_os_path__path, kk_context_t*), _b_1229_1217, (_b_1229_1217, _x1526, _ctx)); /*bool*/
  return kk_bool_box(_x1525);
}
static bool kk_std_os_dir_copy_directory_fun1520(kk_function_t _fself, kk_box_t _b_1224, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_std_os_path__path _x101_1276 = kk_std_os_path__path_unbox(_b_1224, _ctx); /*std/os/path/path*/;
  kk_function_t _b_1229_1217 = kk_std_os_dir_new_copy_directory_fun1522(_ctx); /*(dir : std/os/path/path) -> fsys bool*/;
  kk_std_os_path__path _b_1230_1218 = _x101_1276; /*std/os/path/path*/;
  kk_box_t _x1523 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_directory_fun1524(_b_1229_1217, _ctx), kk_std_os_path__path_box(_b_1230_1218, _ctx), _ctx); /*3289*/
  return kk_bool_unbox(_x1523);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1527__t {
  struct kk_function_s _base;
  kk_std_os_path__path to2;
};
static kk_unit_t kk_std_os_dir_copy_directory_fun1527(kk_function_t _fself, kk_std_core_types__tuple2_ _y_10111, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1527(kk_std_os_path__path to2, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1527__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun1527__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir_copy_directory_fun1527, kk_context());
  _self->to2 = to2;
  return &_self->_base;
}

static kk_unit_t kk_std_os_dir_copy_directory_fun1527(kk_function_t _fself, kk_std_core_types__tuple2_ _y_10111, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1527__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun1527__t*, _fself);
  kk_std_os_path__path to2 = _self->to2; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to2);}, {}, _ctx)
  return kk_std_os_dir__mlift1037_copy_directory(to2, _y_10111, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1529__t {
  struct kk_function_s _base;
  kk_function_t _b_1277_1231;
};
static kk_box_t kk_std_os_dir_copy_directory_fun1529(kk_function_t _fself, kk_box_t _b_1232, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1529(kk_function_t _b_1277_1231, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1529__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun1529__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir_copy_directory_fun1529, kk_context());
  _self->_b_1277_1231 = _b_1277_1231;
  return &_self->_base;
}

static kk_box_t kk_std_os_dir_copy_directory_fun1529(kk_function_t _fself, kk_box_t _b_1232, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1529__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun1529__t*, _fself);
  kk_function_t _b_1277_1231 = _self->_b_1277_1231; /* ((list<std/os/path/path>, list<std/os/path/path>)) -> <fsys,div,exn> () */
  kk_drop_match(_self, {kk_function_dup(_b_1277_1231);}, {}, _ctx)
  kk_unit_t _x1530 = kk_Unit;
  kk_std_core_types__tuple2_ _x1531 = kk_std_core_types__tuple2__unbox(_b_1232, _ctx); /*(list<std/os/path/path>, list<std/os/path/path>)*/
  kk_function_call(kk_unit_t, (kk_function_t, kk_std_core_types__tuple2_, kk_context_t*), _b_1277_1231, (_b_1277_1231, _x1531, _ctx));
  return kk_unit_box(_x1530);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1535__t {
  struct kk_function_s _base;
  kk_std_os_path__path to2;
};
static kk_unit_t kk_std_os_dir_copy_directory_fun1535(kk_function_t _fself, kk_box_t _b_1250, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1535(kk_std_os_path__path to2, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1535__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun1535__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir_copy_directory_fun1535, kk_context());
  _self->to2 = to2;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1539__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_directory_fun1539(kk_function_t _fself, kk_box_t _b_1240, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1539(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun1539, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_dir_copy_directory_fun1539(kk_function_t _fself, kk_box_t _b_1240, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_std_os_path__path _x1540;
  kk_std_core__list _b_1236_1235;
  kk_std_core__list _x1541;
  kk_std_os_path__path _match_1331;
  kk_box_t _x1542 = kk_box_dup(_b_1240); /*3288*/
  _match_1331 = kk_std_os_path__path_unbox(_x1542, _ctx); /*std/os/path/path*/
  kk_std_core__list _x130 = _match_1331.parts;
  kk_std_core__list_dup(_x130);
  kk_std_os_path__path_drop(_match_1331, _ctx);
  kk_Unit;
  _x1541 = _x130; /*list<string>*/
  _b_1236_1235 = kk_std_core_take(_x1541, kk_integer_from_small(1), _ctx); /*list<string>*/
  kk_string_t _x1543 = kk_string_empty(); /*string*/
  kk_std_core__list _x1545;
  kk_std_core_types__optional _match_1329 = kk_std_core_types__new_Optional(kk_std_core__list_box(_b_1236_1235, _ctx), _ctx); /*optional<106>*/;
  if (kk_std_core_types__is_Optional(_match_1329)) {
    kk_box_t _box_x1237 = _match_1329._cons.Optional.value;
    kk_std_core__list _parts_1111 = kk_std_core__list_unbox(_box_x1237, NULL);
    kk_std_core__list_dup(_parts_1111);
    kk_std_core_types__optional_drop(_match_1329, _ctx);
    kk_Unit;
    kk_box_drop(_b_1240, _ctx);
    kk_Unit;
    _x1545 = _parts_1111; /*list<string>*/
    goto _match1546;
  }
  kk_std_os_path__path _match_1330 = kk_std_os_path__path_unbox(_b_1240, _ctx); /*std/os/path/path*/;
  kk_std_core__list _x030 = _match_1330.parts;
  kk_std_core__list_dup(_x030);
  kk_std_os_path__path_drop(_match_1330, _ctx);
  kk_Unit;
  _x1545 = _x030; /*list<string>*/
  _match1546: ;
  _x1540 = kk_std_os_path__new_Path(_x1543, _x1545, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x1540, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1549__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_directory_fun1549(kk_function_t _fself, kk_box_t _b_1246, kk_box_t _b_1247, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1549(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun1549, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_dir_copy_directory_fun1549(kk_function_t _fself, kk_box_t _b_1246, kk_box_t _b_1247, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_std_os_path__path _x1550;
  kk_std_os_path__path _x1551 = kk_std_os_path__path_unbox(_b_1246, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x1552 = kk_std_os_path__path_unbox(_b_1247, _ctx); /*std/os/path/path*/
  _x1550 = kk_std_os_path__lp__fs__rp_(_x1551, _x1552, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x1550, _ctx);
}
static kk_unit_t kk_std_os_dir_copy_directory_fun1535(kk_function_t _fself, kk_box_t _b_1250, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1535__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun1535__t*, _fself);
  kk_std_os_path__path to2 = _self->to2; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to2);}, {}, _ctx)
  kk_std_os_path__path f0_1278 = kk_std_os_path__path_unbox(_b_1250, _ctx); /*std/os/path/path*/;
  kk_std_os_path__path _x1536 = kk_std_os_path__path_dup(f0_1278); /*std/os/path/path*/
  kk_std_os_path__path _x1537;
  kk_std_os_path__path _x21;
  kk_box_t _x1538 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_directory_fun1539(_ctx), kk_std_os_path__path_box(f0_1278, _ctx), _ctx); /*3289*/
  _x21 = kk_std_os_path__path_unbox(_x1538, _ctx); /*std/os/path/path*/
  kk_box_t _x1548 = kk_std_core_hnd__open_none2(kk_std_os_dir_new_copy_directory_fun1549(_ctx), kk_std_os_path__path_box(to2, _ctx), kk_std_os_path__path_box(_x21, _ctx), _ctx); /*3381*/
  _x1537 = kk_std_os_path__path_unbox(_x1548, _ctx); /*std/os/path/path*/
  return kk_std_os_dir_copy_file(_x1536, _x1537, kk_std_core_types__new_None(_ctx), _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1553__t {
  struct kk_function_s _base;
  kk_std_core__list dirs1;
  kk_std_os_path__path to2;
};
static kk_unit_t kk_std_os_dir_copy_directory_fun1553(kk_function_t _fself, kk_unit_t wild__01, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1553(kk_std_core__list dirs1, kk_std_os_path__path to2, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1553__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun1553__t, 4, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir_copy_directory_fun1553, kk_context());
  _self->dirs1 = dirs1;
  _self->to2 = to2;
  return &_self->_base;
}

static kk_unit_t kk_std_os_dir_copy_directory_fun1553(kk_function_t _fself, kk_unit_t wild__01, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1553__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun1553__t*, _fself);
  kk_std_core__list dirs1 = _self->dirs1; /* list<std/os/path/path> */
  kk_std_os_path__path to2 = _self->to2; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_core__list_dup(dirs1);kk_std_os_path__path_dup(to2);}, {}, _ctx)
  return kk_std_os_dir__mlift1036_copy_directory(dirs1, to2, wild__01, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1555__t {
  struct kk_function_s _base;
  kk_function_t _b_1279_1257;
};
static kk_box_t kk_std_os_dir_copy_directory_fun1555(kk_function_t _fself, kk_box_t _b_1258, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1555(kk_function_t _b_1279_1257, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1555__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun1555__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir_copy_directory_fun1555, kk_context());
  _self->_b_1279_1257 = _b_1279_1257;
  return &_self->_base;
}

static kk_box_t kk_std_os_dir_copy_directory_fun1555(kk_function_t _fself, kk_box_t _b_1258, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1555__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun1555__t*, _fself);
  kk_function_t _b_1279_1257 = _self->_b_1279_1257; /* (wild_01 : ()) -> <exn,fsys,div> () */
  kk_drop_match(_self, {kk_function_dup(_b_1279_1257);}, {}, _ctx)
  kk_unit_t _x1556 = kk_Unit;
  kk_unit_t _x1557 = kk_Unit;
  kk_unit_unbox(_b_1258);
  kk_function_call(kk_unit_t, (kk_function_t, kk_unit_t, kk_context_t*), _b_1279_1257, (_b_1279_1257, _x1557, _ctx));
  return kk_unit_box(_x1556);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1558__t {
  struct kk_function_s _base;
  kk_std_os_path__path to2;
};
static kk_unit_t kk_std_os_dir_copy_directory_fun1558(kk_function_t _fself, kk_std_os_path__path d0, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1558(kk_std_os_path__path to2, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1558__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun1558__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir_copy_directory_fun1558, kk_context());
  _self->to2 = to2;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1562__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_directory_fun1562(kk_function_t _fself, kk_box_t _b_1264, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1562(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun1562, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_dir_copy_directory_fun1562(kk_function_t _fself, kk_box_t _b_1264, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_std_os_path__path _x1563;
  kk_std_os_path__path p00_1282 = kk_std_os_path__path_unbox(_b_1264, _ctx); /*std/os/path/path*/;
  kk_std_core__list _b_1260_1259;
  kk_std_core__list _x1564;
  kk_std_core__list _x1000 = p00_1282.parts;
  kk_std_core__list_dup(_x1000);
  _x1564 = _x1000; /*list<string>*/
  _b_1260_1259 = kk_std_core_take(_x1564, kk_integer_from_small(1), _ctx); /*list<string>*/
  kk_string_t _x1565 = kk_string_empty(); /*string*/
  kk_std_core__list _x1567;
  kk_std_core_types__optional _match_1328 = kk_std_core_types__new_Optional(kk_std_core__list_box(_b_1260_1259, _ctx), _ctx); /*optional<106>*/;
  if (kk_std_core_types__is_Optional(_match_1328)) {
    kk_box_t _box_x1261 = _match_1328._cons.Optional.value;
    kk_std_core__list _parts_11100 = kk_std_core__list_unbox(_box_x1261, NULL);
    kk_std_os_path__path_drop(p00_1282, _ctx);
    kk_std_core__list_dup(_parts_11100);
    kk_std_core_types__optional_drop(_match_1328, _ctx);
    kk_Unit;
    _x1567 = _parts_11100; /*list<string>*/
    goto _match1568;
  }
  kk_std_core__list _x0000 = p00_1282.parts;
  kk_std_core__list_dup(_x0000);
  kk_std_os_path__path_drop(p00_1282, _ctx);
  kk_Unit;
  _x1567 = _x0000; /*list<string>*/
  _match1568: ;
  _x1563 = kk_std_os_path__new_Path(_x1565, _x1567, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x1563, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1572__t {
  struct kk_function_s _base;
};
static kk_std_os_path__path kk_std_os_dir_copy_directory_fun1572(kk_function_t _fself, kk_std_os_path__path _x11570, kk_std_os_path__path _x21571, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1572(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun1572, _ctx)
  return kk_function_dup(_fself);
}

static kk_std_os_path__path kk_std_os_dir_copy_directory_fun1572(kk_function_t _fself, kk_std_os_path__path _x11570, kk_std_os_path__path _x21571, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_os_path__lp__fs__rp_(_x11570, _x21571, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1574__t {
  struct kk_function_s _base;
  kk_function_t _b_1283_1267;
};
static kk_box_t kk_std_os_dir_copy_directory_fun1574(kk_function_t _fself, kk_box_t _b_1270, kk_box_t _b_1271, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1574(kk_function_t _b_1283_1267, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1574__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun1574__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir_copy_directory_fun1574, kk_context());
  _self->_b_1283_1267 = _b_1283_1267;
  return &_self->_base;
}

static kk_box_t kk_std_os_dir_copy_directory_fun1574(kk_function_t _fself, kk_box_t _b_1270, kk_box_t _b_1271, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1574__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun1574__t*, _fself);
  kk_function_t _b_1283_1267 = _self->_b_1283_1267; /* (p1 : std/os/path/path, p2 : std/os/path/path) -> std/os/path/path */
  kk_drop_match(_self, {kk_function_dup(_b_1283_1267);}, {}, _ctx)
  kk_std_os_path__path _x1575;
  kk_std_os_path__path _x1576 = kk_std_os_path__path_unbox(_b_1270, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x1577 = kk_std_os_path__path_unbox(_b_1271, _ctx); /*std/os/path/path*/
  _x1575 = kk_function_call(kk_std_os_path__path, (kk_function_t, kk_std_os_path__path, kk_std_os_path__path, kk_context_t*), _b_1283_1267, (_b_1283_1267, _x1576, _x1577, _ctx)); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x1575, _ctx);
}
static kk_unit_t kk_std_os_dir_copy_directory_fun1558(kk_function_t _fself, kk_std_os_path__path d0, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1558__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun1558__t*, _fself);
  kk_std_os_path__path to2 = _self->to2; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to2);}, {}, _ctx)
  kk_std_os_path__path _x1559 = kk_std_os_path__path_dup(d0); /*std/os/path/path*/
  kk_std_os_path__path _x1560;
  kk_std_os_path__path _x200;
  kk_box_t _x1561 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_directory_fun1562(_ctx), kk_std_os_path__path_box(d0, _ctx), _ctx); /*3289*/
  _x200 = kk_std_os_path__path_unbox(_x1561, _ctx); /*std/os/path/path*/
  kk_function_t _b_1283_1267 = kk_std_os_dir_new_copy_directory_fun1572(_ctx); /*(p1 : std/os/path/path, p2 : std/os/path/path) -> std/os/path/path*/;
  kk_std_os_path__path _b_1284_1268 = to2; /*std/os/path/path*/;
  kk_std_os_path__path _b_1285_1269 = _x200; /*std/os/path/path*/;
  kk_box_t _x1573 = kk_std_core_hnd__open_none2(kk_std_os_dir_new_copy_directory_fun1574(_b_1283_1267, _ctx), kk_std_os_path__path_box(_b_1284_1268, _ctx), kk_std_os_path__path_box(_b_1285_1269, _ctx), _ctx); /*3381*/
  _x1560 = kk_std_os_path__path_unbox(_x1573, _ctx); /*std/os/path/path*/
  return kk_std_os_dir_copy_directory(_x1559, _x1560, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1578__t {
  struct kk_function_s _base;
  kk_function_t _b_1281_1273;
};
static kk_unit_t kk_std_os_dir_copy_directory_fun1578(kk_function_t _fself, kk_box_t _b_1274, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1578(kk_function_t _b_1281_1273, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1578__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun1578__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir_copy_directory_fun1578, kk_context());
  _self->_b_1281_1273 = _b_1281_1273;
  return &_self->_base;
}

static kk_unit_t kk_std_os_dir_copy_directory_fun1578(kk_function_t _fself, kk_box_t _b_1274, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1578__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun1578__t*, _fself);
  kk_function_t _b_1281_1273 = _self->_b_1281_1273; /* (d0 : std/os/path/path) -> <div,exn,fsys> () */
  kk_drop_match(_self, {kk_function_dup(_b_1281_1273);}, {}, _ctx)
  kk_std_os_path__path _x1579 = kk_std_os_path__path_unbox(_b_1274, _ctx); /*std/os/path/path*/
  return kk_function_call(kk_unit_t, (kk_function_t, kk_std_os_path__path, kk_context_t*), _b_1281_1273, (_b_1281_1273, _x1579, _ctx));
}

kk_unit_t kk_std_os_dir_copy_directory(kk_std_os_path__path dir0, kk_std_os_path__path to2, kk_context_t* _ctx) { /* (dir : std/os/path/path, to : std/os/path/path) -> <pure,fsys> () */ 
  kk_unit_t x1_1043 = kk_Unit;
  kk_std_os_path__path _x1510 = kk_std_os_path__path_dup(to2); /*std/os/path/path*/
  kk_std_os_dir_ensure_dir(_x1510, _ctx);
  if (kk_yielding(kk_context())) {
    kk_function_t _b_1275_1210 = kk_std_os_dir_new_copy_directory_fun1511(dir0, to2, _ctx); /*(wild_1 : ()) -> <exn,fsys> ()*/;
    kk_box_t _x1512 = kk_std_core_hnd_yield_extend(kk_std_os_dir_new_copy_directory_fun1513(_b_1275_1210, _ctx), _ctx); /*3858*/
    kk_unit_unbox(_x1512); return kk_Unit;
  }
  kk_std_core__list all0;
  kk_box_t _x1516 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_directory_fun1517(_ctx), kk_std_os_path__path_box(dir0, _ctx), _ctx); /*3289*/
  all0 = kk_std_core__list_unbox(_x1516, _ctx); /*list<std/os/path/path>*/
  kk_std_core_types__tuple2_ x2_1046 = kk_std_core_partition_acc(all0, kk_std_os_dir_new_copy_directory_fun1520(_ctx), kk_std_core__new_Nil(_ctx), kk_std_core__new_Nil(_ctx), _ctx); /*(list<std/os/path/path>, list<std/os/path/path>)*/;
  if (kk_yielding(kk_context())) {
    kk_std_core_types__tuple2__drop(x2_1046, _ctx);
    kk_function_t _b_1277_1231 = kk_std_os_dir_new_copy_directory_fun1527(to2, _ctx); /*((list<std/os/path/path>, list<std/os/path/path>)) -> <fsys,div,exn> ()*/;
    kk_box_t _x1528 = kk_std_core_hnd_yield_extend(kk_std_os_dir_new_copy_directory_fun1529(_b_1277_1231, _ctx), _ctx); /*3858*/
    kk_unit_unbox(_x1528); return kk_Unit;
  }
  kk_box_t _box_x1233 = x2_1046.fst;
  kk_box_t _box_x1234 = x2_1046.snd;
  kk_std_core__list dirs1 = kk_std_core__list_unbox(_box_x1233, NULL);
  kk_std_core__list files0 = kk_std_core__list_unbox(_box_x1234, NULL);
  kk_std_core__list_dup(dirs1);
  kk_std_core__list_dup(files0);
  kk_std_core_types__tuple2__drop(x2_1046, _ctx);
  kk_Unit;
  kk_unit_t x3_1049 = kk_Unit;
  kk_function_t _x1534;
  kk_std_os_path__path_dup(to2);
  _x1534 = kk_std_os_dir_new_copy_directory_fun1535(to2, _ctx); /*(10978) -> 10979 ()*/
  kk_std_core_foreach(files0, _x1534, _ctx);
  if (kk_yielding(kk_context())) {
    kk_function_t _b_1279_1257 = kk_std_os_dir_new_copy_directory_fun1553(dirs1, to2, _ctx); /*(wild_01 : ()) -> <exn,fsys,div> ()*/;
    kk_box_t _x1554 = kk_std_core_hnd_yield_extend(kk_std_os_dir_new_copy_directory_fun1555(_b_1279_1257, _ctx), _ctx); /*3858*/
    kk_unit_unbox(_x1554); return kk_Unit;
  }
  kk_std_core__list _b_1280_1272 = dirs1; /*list<std/os/path/path>*/;
  kk_function_t _b_1281_1273 = kk_std_os_dir_new_copy_directory_fun1558(to2, _ctx); /*(d0 : std/os/path/path) -> <div,exn,fsys> ()*/;
  kk_std_core_foreach(_b_1280_1272, kk_std_os_dir_new_copy_directory_fun1578(_b_1281_1273, _ctx), _ctx); return kk_Unit;
}
 
// Copy a file to a directory


// lift anonymous function
struct kk_std_os_dir_copy_file_to_dir_fun1583__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_to_dir_fun1583(kk_function_t _fself, kk_box_t _b_1291, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_to_dir_fun1583(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_to_dir_fun1583, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_dir_copy_file_to_dir_fun1583(kk_function_t _fself, kk_box_t _b_1291, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_std_os_path__path _x1584;
  kk_std_os_path__path p_1299 = kk_std_os_path__path_unbox(_b_1291, _ctx); /*std/os/path/path*/;
  kk_std_core__list _b_1287_1286;
  kk_std_core__list _x1585;
  kk_std_core__list _x11 = p_1299.parts;
  kk_std_core__list_dup(_x11);
  _x1585 = _x11; /*list<string>*/
  _b_1287_1286 = kk_std_core_take(_x1585, kk_integer_from_small(1), _ctx); /*list<string>*/
  kk_string_t _x1586 = kk_string_empty(); /*string*/
  kk_std_core__list _x1588;
  kk_std_core_types__optional _match_1324 = kk_std_core_types__new_Optional(kk_std_core__list_box(_b_1287_1286, _ctx), _ctx); /*optional<106>*/;
  if (kk_std_core_types__is_Optional(_match_1324)) {
    kk_box_t _box_x1288 = _match_1324._cons.Optional.value;
    kk_std_core__list _parts_111 = kk_std_core__list_unbox(_box_x1288, NULL);
    kk_std_os_path__path_drop(p_1299, _ctx);
    kk_std_core__list_dup(_parts_111);
    kk_std_core_types__optional_drop(_match_1324, _ctx);
    kk_Unit;
    _x1588 = _parts_111; /*list<string>*/
    goto _match1589;
  }
  kk_std_core__list _x01 = p_1299.parts;
  kk_std_core__list_dup(_x01);
  kk_std_os_path__path_drop(p_1299, _ctx);
  kk_Unit;
  _x1588 = _x01; /*list<string>*/
  _match1589: ;
  _x1584 = kk_std_os_path__new_Path(_x1586, _x1588, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x1584, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_to_dir_fun1593__t {
  struct kk_function_s _base;
};
static kk_std_os_path__path kk_std_os_dir_copy_file_to_dir_fun1593(kk_function_t _fself, kk_std_os_path__path _x11591, kk_std_os_path__path _x21592, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_to_dir_fun1593(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_to_dir_fun1593, _ctx)
  return kk_function_dup(_fself);
}

static kk_std_os_path__path kk_std_os_dir_copy_file_to_dir_fun1593(kk_function_t _fself, kk_std_os_path__path _x11591, kk_std_os_path__path _x21592, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_os_path__lp__fs__rp_(_x11591, _x21592, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_to_dir_fun1595__t {
  struct kk_function_s _base;
  kk_function_t _b_1300_1294;
};
static kk_box_t kk_std_os_dir_copy_file_to_dir_fun1595(kk_function_t _fself, kk_box_t _b_1297, kk_box_t _b_1298, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_to_dir_fun1595(kk_function_t _b_1300_1294, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_file_to_dir_fun1595__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_file_to_dir_fun1595__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir_copy_file_to_dir_fun1595, kk_context());
  _self->_b_1300_1294 = _b_1300_1294;
  return &_self->_base;
}

static kk_box_t kk_std_os_dir_copy_file_to_dir_fun1595(kk_function_t _fself, kk_box_t _b_1297, kk_box_t _b_1298, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_file_to_dir_fun1595__t* _self = kk_function_as(struct kk_std_os_dir_copy_file_to_dir_fun1595__t*, _fself);
  kk_function_t _b_1300_1294 = _self->_b_1300_1294; /* (p1 : std/os/path/path, p2 : std/os/path/path) -> std/os/path/path */
  kk_drop_match(_self, {kk_function_dup(_b_1300_1294);}, {}, _ctx)
  kk_std_os_path__path _x1596;
  kk_std_os_path__path _x1597 = kk_std_os_path__path_unbox(_b_1297, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x1598 = kk_std_os_path__path_unbox(_b_1298, _ctx); /*std/os/path/path*/
  _x1596 = kk_function_call(kk_std_os_path__path, (kk_function_t, kk_std_os_path__path, kk_std_os_path__path, kk_context_t*), _b_1300_1294, (_b_1300_1294, _x1597, _x1598, _ctx)); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x1596, _ctx);
}

kk_unit_t kk_std_os_dir_copy_file_to_dir(kk_std_os_path__path from, kk_std_os_path__path dir, kk_context_t* _ctx) { /* (from : std/os/path/path, dir : std/os/path/path) -> <exn,fsys> () */ 
  kk_std_os_path__path _x1580 = kk_std_os_path__path_dup(from); /*std/os/path/path*/
  kk_std_os_path__path _x1581;
  kk_std_os_path__path _x2;
  kk_box_t _x1582 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_file_to_dir_fun1583(_ctx), kk_std_os_path__path_box(from, _ctx), _ctx); /*3289*/
  _x2 = kk_std_os_path__path_unbox(_x1582, _ctx); /*std/os/path/path*/
  kk_function_t _b_1300_1294 = kk_std_os_dir_new_copy_file_to_dir_fun1593(_ctx); /*(p1 : std/os/path/path, p2 : std/os/path/path) -> std/os/path/path*/;
  kk_std_os_path__path _b_1301_1295 = dir; /*std/os/path/path*/;
  kk_std_os_path__path _b_1302_1296 = _x2; /*std/os/path/path*/;
  kk_box_t _x1594 = kk_std_core_hnd__open_none2(kk_std_os_dir_new_copy_file_to_dir_fun1595(_b_1300_1294, _ctx), kk_std_os_path__path_box(_b_1301_1295, _ctx), kk_std_os_path__path_box(_b_1302_1296, _ctx), _ctx); /*3381*/
  _x1581 = kk_std_os_path__path_unbox(_x1594, _ctx); /*std/os/path/path*/
  kk_std_os_dir_copy_file(_x1580, _x1581, kk_std_core_types__new_None(_ctx), _ctx); return kk_Unit;
}
 
// Recursively list all the entries under a directory.


// lift anonymous function
struct kk_std_os_dir_list_directory_recursive_fun1603__t {
  struct kk_function_s _base;
};
static bool kk_std_os_dir_list_directory_recursive_fun1603(kk_function_t _fself, kk_box_t _b_1306, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_list_directory_recursive_fun1603(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_list_directory_recursive_fun1603, _ctx)
  return kk_function_dup(_fself);
}

static bool kk_std_os_dir_list_directory_recursive_fun1603(kk_function_t _fself, kk_box_t _b_1306, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_std_os_path__path _x1604 = kk_std_os_path__path_unbox(_b_1306, _ctx); /*std/os/path/path*/
  return kk_std_os_dir_is_directory(_x1604, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_list_directory_recursive_fun1605__t {
  struct kk_function_s _base;
  kk_std_core_types__optional max_depth;
};
static kk_std_core__list kk_std_os_dir_list_directory_recursive_fun1605(kk_function_t _fself, kk_box_t _b_1314, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_list_directory_recursive_fun1605(kk_std_core_types__optional max_depth, kk_context_t* _ctx) {
  struct kk_std_os_dir_list_directory_recursive_fun1605__t* _self = kk_function_alloc_as(struct kk_std_os_dir_list_directory_recursive_fun1605__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir_list_directory_recursive_fun1605, kk_context());
  _self->max_depth = max_depth;
  return &_self->_base;
}

static kk_std_core__list kk_std_os_dir_list_directory_recursive_fun1605(kk_function_t _fself, kk_box_t _b_1314, kk_context_t* _ctx) {
  struct kk_std_os_dir_list_directory_recursive_fun1605__t* _self = kk_function_as(struct kk_std_os_dir_list_directory_recursive_fun1605__t*, _fself);
  kk_std_core_types__optional max_depth = _self->max_depth; /* optional<int> */
  kk_drop_match(_self, {kk_std_core_types__optional_dup(max_depth);}, {}, _ctx)
  kk_std_os_path__path sub_1319 = kk_std_os_path__path_unbox(_b_1314, _ctx); /*std/os/path/path*/;
  kk_std_core_types__optional _x1606;
  kk_integer_t _b_1318_1310;
  kk_integer_t _x1607;
  if (kk_std_core_types__is_Optional(max_depth)) {
    kk_box_t _box_x1309 = max_depth._cons.Optional.value;
    kk_integer_t _max_depth_9080 = kk_integer_unbox(_box_x1309);
    kk_integer_dup(_max_depth_9080);
    kk_std_core_types__optional_drop(max_depth, _ctx);
    kk_Unit;
    _x1607 = _max_depth_9080; /*int*/
    goto _match1608;
  }
  _x1607 = kk_integer_from_small(1000); /*int*/
  _match1608: ;
  _b_1318_1310 = kk_integer_sub(_x1607,(kk_integer_from_small(1)),kk_context()); /*int*/
  _x1606 = kk_std_core_types__new_Optional(kk_integer_box(_b_1318_1310), _ctx); /*optional<106>*/
  return kk_std_os_dir_list_directory_recursive(sub_1319, _x1606, _ctx);
}

kk_std_core__list kk_std_os_dir_list_directory_recursive(kk_std_os_path__path dir, kk_std_core_types__optional max_depth, kk_context_t* _ctx) { /* (dir : std/os/path/path, max-depth : optional<int>) -> <div,fsys> list<std/os/path/path> */ 
  bool _match_1320;
  kk_integer_t _borrowedArg_1322;
  if (kk_std_core_types__is_Optional(max_depth)) {
    kk_box_t _box_x1303 = max_depth._cons.Optional.value;
    kk_integer_t _max_depth_908 = kk_integer_unbox(_box_x1303);
    kk_integer_dup(_max_depth_908);
    _borrowedArg_1322 = _max_depth_908; /*int*/
    goto _match1600;
  }
  _borrowedArg_1322 = kk_integer_from_small(1000); /*int*/
  _match1600: ;
  kk_integer_t _borrowedArg_1321 = kk_integer_from_small(0); /*int*/;
  bool _borrowApp_1323 = kk_integer_lt_borrow(_borrowedArg_1322,_borrowedArg_1321,kk_context()); /*bool*/;
  kk_integer_drop(_borrowedArg_1322, _ctx);
  kk_integer_drop(_borrowedArg_1321, _ctx);
  _match_1320 = _borrowApp_1323; /*bool*/
  if (_match_1320) {
    kk_std_os_path__path_drop(dir, _ctx);
    kk_std_core_types__optional_drop(max_depth, _ctx);
    return kk_std_core__new_Nil(_ctx);
  }
  kk_std_core__list all = kk_std_os_dir_list_directory(dir, _ctx); /*list<std/os/path/path>*/;
  kk_std_core__list dirs;
  kk_std_core__list _x1602 = kk_std_core__list_dup(all); /*list<std/os/path/path>*/
  dirs = kk_std_core_filter(_x1602, kk_std_os_dir_new_list_directory_recursive_fun1603(_ctx), _ctx); /*list<std/os/path/path>*/
  kk_std_core__list ys_1003 = kk_std_core__lift17067_flatmap(kk_std_os_dir_new_list_directory_recursive_fun1605(max_depth, _ctx), kk_std_core__new_Nil(_ctx), dirs, _ctx); /*list<std/os/path/path>*/;
  return kk_std_core_append(all, ys_1003, _ctx);
}

// initialization
void kk_std_os_dir__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core__init(_ctx);
  kk_std_os_path__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
}

// termination
void kk_std_os_dir__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_os_path__done(_ctx);
  kk_std_core__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
