// Koka generated module: "std/os/file", koka version: 2.2.1
#include "std_os_file.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/

static kk_std_core__error kk_os_read_text_file_error( kk_string_t path, kk_context_t* ctx ) {
  kk_string_t content;
  const int err = kk_os_read_text_file(path,&content,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_string_box(content),ctx);
}

static kk_std_core__error kk_os_write_text_file_error( kk_string_t path, kk_string_t content, kk_context_t* ctx ) {
  const int err = kk_os_write_text_file(path,content,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_unit_box(kk_Unit),ctx);
}


kk_std_core__exception kk_std_os_file_prepend(kk_std_core__exception exn, kk_string_t pre, kk_context_t* _ctx) { /* (exn : exception, pre : string) -> exception */ 
  kk_string_t _x457;
  kk_string_t _x458;
  kk_string_t _x459;
  kk_define_string_literal(, _s460, 2, ": ")
  _x459 = kk_string_dup(_s460); /*string*/
  kk_string_t _x461;
  kk_string_t _x = exn.message;
  kk_string_dup(_x);
  _x461 = _x; /*string*/
  _x458 = kk_std_core__lp__plus__plus__1_rp_(_x459, _x461, _ctx); /*string*/
  _x457 = kk_std_core__lp__plus__plus__1_rp_(pre, _x458, _ctx); /*string*/
  kk_std_core__exception_info _x462;
  kk_std_core__exception_info _x0 = exn.info;
  kk_std_core__exception_info_dup(_x0);
  kk_std_core__exception_drop(exn, _ctx);
  kk_Unit;
  _x462 = _x0; /*exception-info*/
  return kk_std_core__new_Exception(_x457, _x462, _ctx);
}

kk_std_core__error kk_std_os_file_read_text_file_err(kk_string_t path, kk_context_t* _ctx) { /* (path : string) -> fsys error<string> */ 
  return kk_os_read_text_file_error(path,kk_context());
}

kk_std_core__error kk_std_os_file_write_text_file_err(kk_string_t path, kk_string_t content, kk_context_t* _ctx) { /* (path : string, content : string) -> fsys error<()> */ 
  return kk_os_write_text_file_error(path,content,kk_context());
}
 
// Read a text file synchronously (using UTF8 encoding)


// lift anonymous function
struct kk_std_os_file_read_text_file_fun464__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file_read_text_file_fun464(kk_function_t _fself, kk_box_t _b_346, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_read_text_file_fun464(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_read_text_file_fun464, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_file_read_text_file_fun464(kk_function_t _fself, kk_box_t _b_346, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x465;
  kk_std_os_path__path _x466 = kk_std_os_path__path_unbox(_b_346, _ctx); /*std/os/path/path*/
  _x465 = kk_std_os_path_string(_x466, _ctx); /*string*/
  return kk_string_box(_x465);
}


// lift anonymous function
struct kk_std_os_file_read_text_file_fun470__t {
  struct kk_function_s _base;
};
static kk_std_core__error kk_std_os_file_read_text_file_fun470(kk_function_t _fself, kk_string_t _x1469, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_read_text_file_fun470(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_read_text_file_fun470, _ctx)
  return kk_function_dup(_fself);
}

static kk_std_core__error kk_std_os_file_read_text_file_fun470(kk_function_t _fself, kk_string_t _x1469, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_os_file_read_text_file_err(_x1469, _ctx);
}


// lift anonymous function
struct kk_std_os_file_read_text_file_fun472__t {
  struct kk_function_s _base;
  kk_function_t _b_364_349;
};
static kk_box_t kk_std_os_file_read_text_file_fun472(kk_function_t _fself, kk_box_t _b_351, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_read_text_file_fun472(kk_function_t _b_364_349, kk_context_t* _ctx) {
  struct kk_std_os_file_read_text_file_fun472__t* _self = kk_function_alloc_as(struct kk_std_os_file_read_text_file_fun472__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_file_read_text_file_fun472, kk_context());
  _self->_b_364_349 = _b_364_349;
  return &_self->_base;
}

static kk_box_t kk_std_os_file_read_text_file_fun472(kk_function_t _fself, kk_box_t _b_351, kk_context_t* _ctx) {
  struct kk_std_os_file_read_text_file_fun472__t* _self = kk_function_as(struct kk_std_os_file_read_text_file_fun472__t*, _fself);
  kk_function_t _b_364_349 = _self->_b_364_349; /* (path : string) -> fsys error<string> */
  kk_drop_match(_self, {kk_function_dup(_b_364_349);}, {}, _ctx)
  kk_std_core__error _x473;
  kk_string_t _x474 = kk_string_unbox(_b_351); /*string*/
  _x473 = kk_function_call(kk_std_core__error, (kk_function_t, kk_string_t, kk_context_t*), _b_364_349, (_b_364_349, _x474, _ctx)); /*error<string>*/
  return kk_std_core__error_box(_x473, _ctx);
}


// lift anonymous function
struct kk_std_os_file_read_text_file_fun480__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file_read_text_file_fun480(kk_function_t _fself, kk_box_t _b_354, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_read_text_file_fun480(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_read_text_file_fun480, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_file_read_text_file_fun480(kk_function_t _fself, kk_box_t _b_354, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x481;
  kk_std_os_path__path p_367 = kk_std_os_path__path_unbox(_b_354, _ctx); /*std/os/path/path*/;
  kk_string_t _x482 = kk_std_os_path_string(p_367, _ctx); /*string*/
  _x481 = kk_std_core_show_3(_x482, _ctx); /*string*/
  return kk_string_box(_x481);
}


// lift anonymous function
struct kk_std_os_file_read_text_file_fun483__t {
  struct kk_function_s _base;
};
static kk_std_core__exception kk_std_os_file_read_text_file_fun483(kk_function_t _fself, kk_std_core__exception exn0, kk_string_t pre, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_read_text_file_fun483(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_read_text_file_fun483, _ctx)
  return kk_function_dup(_fself);
}

static kk_std_core__exception kk_std_os_file_read_text_file_fun483(kk_function_t _fself, kk_std_core__exception exn0, kk_string_t pre, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x484;
  kk_string_t _x485;
  kk_string_t _x486;
  kk_define_string_literal(, _s487, 2, ": ")
  _x486 = kk_string_dup(_s487); /*string*/
  kk_string_t _x488;
  kk_string_t _x = exn0.message;
  kk_string_dup(_x);
  _x488 = _x; /*string*/
  _x485 = kk_std_core__lp__plus__plus__1_rp_(_x486, _x488, _ctx); /*string*/
  _x484 = kk_std_core__lp__plus__plus__1_rp_(pre, _x485, _ctx); /*string*/
  kk_std_core__exception_info _x489;
  kk_std_core__exception_info _x02 = exn0.info;
  kk_std_core__exception_info_dup(_x02);
  kk_std_core__exception_drop(exn0, _ctx);
  kk_Unit;
  _x489 = _x02; /*exception-info*/
  return kk_std_core__new_Exception(_x484, _x489, _ctx);
}


// lift anonymous function
struct kk_std_os_file_read_text_file_fun491__t {
  struct kk_function_s _base;
  kk_function_t _b_368_357;
};
static kk_box_t kk_std_os_file_read_text_file_fun491(kk_function_t _fself, kk_box_t _b_360, kk_box_t _b_361, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_read_text_file_fun491(kk_function_t _b_368_357, kk_context_t* _ctx) {
  struct kk_std_os_file_read_text_file_fun491__t* _self = kk_function_alloc_as(struct kk_std_os_file_read_text_file_fun491__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_file_read_text_file_fun491, kk_context());
  _self->_b_368_357 = _b_368_357;
  return &_self->_base;
}

static kk_box_t kk_std_os_file_read_text_file_fun491(kk_function_t _fself, kk_box_t _b_360, kk_box_t _b_361, kk_context_t* _ctx) {
  struct kk_std_os_file_read_text_file_fun491__t* _self = kk_function_as(struct kk_std_os_file_read_text_file_fun491__t*, _fself);
  kk_function_t _b_368_357 = _self->_b_368_357; /* (exn0 : exception, pre : string) -> exception */
  kk_drop_match(_self, {kk_function_dup(_b_368_357);}, {}, _ctx)
  kk_std_core__exception _x492;
  kk_std_core__exception _x493 = kk_std_core__exception_unbox(_b_360, _ctx); /*exception*/
  kk_string_t _x494 = kk_string_unbox(_b_361); /*string*/
  _x492 = kk_function_call(kk_std_core__exception, (kk_function_t, kk_std_core__exception, kk_string_t, kk_context_t*), _b_368_357, (_b_368_357, _x493, _x494, _ctx)); /*exception*/
  return kk_std_core__exception_box(_x492, _ctx);
}

kk_string_t kk_std_os_file_read_text_file(kk_std_os_path__path path, kk_context_t* _ctx) { /* (path : std/os/path/path) -> <exn,fsys> string */ 
  kk_string_t _x1;
  kk_box_t _x463;
  kk_box_t _x467;
  kk_std_os_path__path _x468 = kk_std_os_path__path_dup(path); /*std/os/path/path*/
  _x467 = kk_std_os_path__path_box(_x468, _ctx); /*3288*/
  _x463 = kk_std_core_hnd__open_none1(kk_std_os_file_new_read_text_file_fun464(_ctx), _x467, _ctx); /*3289*/
  _x1 = kk_string_unbox(_x463); /*string*/
  kk_std_core__error _match_454;
  kk_function_t _b_364_349 = kk_std_os_file_new_read_text_file_fun470(_ctx); /*(path : string) -> fsys error<string>*/;
  kk_string_t _b_365_350 = _x1; /*string*/;
  kk_box_t _x471 = kk_std_core_hnd__open_none1(kk_std_os_file_new_read_text_file_fun472(_b_364_349, _ctx), kk_string_box(_b_365_350), _ctx); /*3289*/
  _match_454 = kk_std_core__error_unbox(_x471, _ctx); /*error<string>*/
  if (kk_std_core__is_Error(_match_454)) {
    kk_std_core__exception exn = _match_454._cons.Error.exception;
    kk_std_core__exception_dup(exn);
    kk_std_core__error_drop(_match_454, _ctx);
    kk_Unit;
    kk_std_core__error _b_366_362;
    kk_std_core__exception _x475;
    kk_string_t _x2;
    kk_string_t _x476;
    kk_define_string_literal(, _s477, 25, "unable to read text file ")
    _x476 = kk_string_dup(_s477); /*string*/
    kk_string_t _x478;
    kk_box_t _x479 = kk_std_core_hnd__open_none1(kk_std_os_file_new_read_text_file_fun480(_ctx), kk_std_os_path__path_box(path, _ctx), _ctx); /*3289*/
    _x478 = kk_string_unbox(_x479); /*string*/
    _x2 = kk_std_core__lp__plus__plus__1_rp_(_x476, _x478, _ctx); /*string*/
    kk_function_t _b_368_357 = kk_std_os_file_new_read_text_file_fun483(_ctx); /*(exn0 : exception, pre : string) -> exception*/;
    kk_std_core__exception _b_369_358 = exn; /*exception*/;
    kk_string_t _b_370_359 = _x2; /*string*/;
    kk_box_t _x490 = kk_std_core_hnd__open_none2(kk_std_os_file_new_read_text_file_fun491(_b_368_357, _ctx), kk_std_core__exception_box(_b_369_358, _ctx), kk_string_box(_b_370_359), _ctx); /*3381*/
    _x475 = kk_std_core__exception_unbox(_x490, _ctx); /*exception*/
    _b_366_362 = kk_std_core__new_Error(_x475, _ctx); /*error<string>*/
    kk_box_t _x495 = kk_std_core_throw_1(_b_366_362, _ctx); /*11674*/
    return kk_string_unbox(_x495);
  }
  kk_box_t _box_x363 = _match_454._cons.Ok.result;
  kk_string_t content = kk_string_unbox(_box_x363);
  kk_std_os_path__path_drop(path, _ctx);
  kk_string_dup(content);
  kk_std_core__error_drop(_match_454, _ctx);
  kk_Unit;
  return content;
}
 
// monadic lift


// lift anonymous function
struct kk_std_os_file__mlift339_write_text_file_fun498__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file__mlift339_write_text_file_fun498(kk_function_t _fself, kk_box_t _b_373, kk_context_t* _ctx);
static kk_function_t kk_std_os_file__new_mlift339_write_text_file_fun498(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file__mlift339_write_text_file_fun498, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_file__mlift339_write_text_file_fun498(kk_function_t _fself, kk_box_t _b_373, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x499;
  kk_std_os_path__path _x500 = kk_std_os_path__path_unbox(_b_373, _ctx); /*std/os/path/path*/
  _x499 = kk_std_os_path_string(_x500, _ctx); /*string*/
  return kk_string_box(_x499);
}


// lift anonymous function
struct kk_std_os_file__mlift339_write_text_file_fun505__t {
  struct kk_function_s _base;
};
static kk_std_core__error kk_std_os_file__mlift339_write_text_file_fun505(kk_function_t _fself, kk_string_t _x1503, kk_string_t _x2504, kk_context_t* _ctx);
static kk_function_t kk_std_os_file__new_mlift339_write_text_file_fun505(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file__mlift339_write_text_file_fun505, _ctx)
  return kk_function_dup(_fself);
}

static kk_std_core__error kk_std_os_file__mlift339_write_text_file_fun505(kk_function_t _fself, kk_string_t _x1503, kk_string_t _x2504, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_os_file_write_text_file_err(_x1503, _x2504, _ctx);
}


// lift anonymous function
struct kk_std_os_file__mlift339_write_text_file_fun507__t {
  struct kk_function_s _base;
  kk_function_t _b_392_376;
};
static kk_box_t kk_std_os_file__mlift339_write_text_file_fun507(kk_function_t _fself, kk_box_t _b_379, kk_box_t _b_380, kk_context_t* _ctx);
static kk_function_t kk_std_os_file__new_mlift339_write_text_file_fun507(kk_function_t _b_392_376, kk_context_t* _ctx) {
  struct kk_std_os_file__mlift339_write_text_file_fun507__t* _self = kk_function_alloc_as(struct kk_std_os_file__mlift339_write_text_file_fun507__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_file__mlift339_write_text_file_fun507, kk_context());
  _self->_b_392_376 = _b_392_376;
  return &_self->_base;
}

static kk_box_t kk_std_os_file__mlift339_write_text_file_fun507(kk_function_t _fself, kk_box_t _b_379, kk_box_t _b_380, kk_context_t* _ctx) {
  struct kk_std_os_file__mlift339_write_text_file_fun507__t* _self = kk_function_as(struct kk_std_os_file__mlift339_write_text_file_fun507__t*, _fself);
  kk_function_t _b_392_376 = _self->_b_392_376; /* (path : string, content : string) -> fsys error<()> */
  kk_drop_match(_self, {kk_function_dup(_b_392_376);}, {}, _ctx)
  kk_std_core__error _x508;
  kk_string_t _x509 = kk_string_unbox(_b_379); /*string*/
  kk_string_t _x510 = kk_string_unbox(_b_380); /*string*/
  _x508 = kk_function_call(kk_std_core__error, (kk_function_t, kk_string_t, kk_string_t, kk_context_t*), _b_392_376, (_b_392_376, _x509, _x510, _ctx)); /*error<()>*/
  return kk_std_core__error_box(_x508, _ctx);
}


// lift anonymous function
struct kk_std_os_file__mlift339_write_text_file_fun516__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file__mlift339_write_text_file_fun516(kk_function_t _fself, kk_box_t _b_383, kk_context_t* _ctx);
static kk_function_t kk_std_os_file__new_mlift339_write_text_file_fun516(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file__mlift339_write_text_file_fun516, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_file__mlift339_write_text_file_fun516(kk_function_t _fself, kk_box_t _b_383, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x517;
  kk_std_os_path__path p1_396 = kk_std_os_path__path_unbox(_b_383, _ctx); /*std/os/path/path*/;
  kk_string_t _x518 = kk_std_os_path_string(p1_396, _ctx); /*string*/
  _x517 = kk_std_core_show_3(_x518, _ctx); /*string*/
  return kk_string_box(_x517);
}


// lift anonymous function
struct kk_std_os_file__mlift339_write_text_file_fun519__t {
  struct kk_function_s _base;
};
static kk_std_core__exception kk_std_os_file__mlift339_write_text_file_fun519(kk_function_t _fself, kk_std_core__exception exn0, kk_string_t pre, kk_context_t* _ctx);
static kk_function_t kk_std_os_file__new_mlift339_write_text_file_fun519(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file__mlift339_write_text_file_fun519, _ctx)
  return kk_function_dup(_fself);
}

static kk_std_core__exception kk_std_os_file__mlift339_write_text_file_fun519(kk_function_t _fself, kk_std_core__exception exn0, kk_string_t pre, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x520;
  kk_string_t _x521;
  kk_string_t _x522;
  kk_define_string_literal(, _s523, 2, ": ")
  _x522 = kk_string_dup(_s523); /*string*/
  kk_string_t _x524;
  kk_string_t _x21 = exn0.message;
  kk_string_dup(_x21);
  _x524 = _x21; /*string*/
  _x521 = kk_std_core__lp__plus__plus__1_rp_(_x522, _x524, _ctx); /*string*/
  _x520 = kk_std_core__lp__plus__plus__1_rp_(pre, _x521, _ctx); /*string*/
  kk_std_core__exception_info _x525;
  kk_std_core__exception_info _x3 = exn0.info;
  kk_std_core__exception_info_dup(_x3);
  kk_std_core__exception_drop(exn0, _ctx);
  kk_Unit;
  _x525 = _x3; /*exception-info*/
  return kk_std_core__new_Exception(_x520, _x525, _ctx);
}


// lift anonymous function
struct kk_std_os_file__mlift339_write_text_file_fun527__t {
  struct kk_function_s _base;
  kk_function_t _b_397_386;
};
static kk_box_t kk_std_os_file__mlift339_write_text_file_fun527(kk_function_t _fself, kk_box_t _b_389, kk_box_t _b_390, kk_context_t* _ctx);
static kk_function_t kk_std_os_file__new_mlift339_write_text_file_fun527(kk_function_t _b_397_386, kk_context_t* _ctx) {
  struct kk_std_os_file__mlift339_write_text_file_fun527__t* _self = kk_function_alloc_as(struct kk_std_os_file__mlift339_write_text_file_fun527__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_file__mlift339_write_text_file_fun527, kk_context());
  _self->_b_397_386 = _b_397_386;
  return &_self->_base;
}

static kk_box_t kk_std_os_file__mlift339_write_text_file_fun527(kk_function_t _fself, kk_box_t _b_389, kk_box_t _b_390, kk_context_t* _ctx) {
  struct kk_std_os_file__mlift339_write_text_file_fun527__t* _self = kk_function_as(struct kk_std_os_file__mlift339_write_text_file_fun527__t*, _fself);
  kk_function_t _b_397_386 = _self->_b_397_386; /* (exn0 : exception, pre : string) -> exception */
  kk_drop_match(_self, {kk_function_dup(_b_397_386);}, {}, _ctx)
  kk_std_core__exception _x528;
  kk_std_core__exception _x529 = kk_std_core__exception_unbox(_b_389, _ctx); /*exception*/
  kk_string_t _x530 = kk_string_unbox(_b_390); /*string*/
  _x528 = kk_function_call(kk_std_core__exception, (kk_function_t, kk_std_core__exception, kk_string_t, kk_context_t*), _b_397_386, (_b_397_386, _x529, _x530, _ctx)); /*exception*/
  return kk_std_core__exception_box(_x528, _ctx);
}

kk_unit_t kk_std_os_file__mlift339_write_text_file(kk_string_t content, kk_std_os_path__path path, kk_unit_t _c_326, kk_context_t* _ctx) { /* (content : string, path : std/os/path/path, ()) -> () */ 
  kk_string_t _x12;
  kk_box_t _x497;
  kk_box_t _x501;
  kk_std_os_path__path _x502 = kk_std_os_path__path_dup(path); /*std/os/path/path*/
  _x501 = kk_std_os_path__path_box(_x502, _ctx); /*3288*/
  _x497 = kk_std_core_hnd__open_none1(kk_std_os_file__new_mlift339_write_text_file_fun498(_ctx), _x501, _ctx); /*3289*/
  _x12 = kk_string_unbox(_x497); /*string*/
  kk_std_core__error _match_453;
  kk_function_t _b_392_376 = kk_std_os_file__new_mlift339_write_text_file_fun505(_ctx); /*(path : string, content : string) -> fsys error<()>*/;
  kk_string_t _b_393_377 = _x12; /*string*/;
  kk_string_t _b_394_378 = content; /*string*/;
  kk_box_t _x506 = kk_std_core_hnd__open_none2(kk_std_os_file__new_mlift339_write_text_file_fun507(_b_392_376, _ctx), kk_string_box(_b_393_377), kk_string_box(_b_394_378), _ctx); /*3381*/
  _match_453 = kk_std_core__error_unbox(_x506, _ctx); /*error<()>*/
  if (kk_std_core__is_Error(_match_453)) {
    kk_std_core__exception exn = _match_453._cons.Error.exception;
    kk_std_core__exception_dup(exn);
    kk_std_core__error_drop(_match_453, _ctx);
    kk_Unit;
    kk_std_core__error _b_395_391;
    kk_std_core__exception _x511;
    kk_string_t _x20;
    kk_string_t _x512;
    kk_define_string_literal(, _s513, 26, "unable to write text file ")
    _x512 = kk_string_dup(_s513); /*string*/
    kk_string_t _x514;
    kk_box_t _x515 = kk_std_core_hnd__open_none1(kk_std_os_file__new_mlift339_write_text_file_fun516(_ctx), kk_std_os_path__path_box(path, _ctx), _ctx); /*3289*/
    _x514 = kk_string_unbox(_x515); /*string*/
    _x20 = kk_std_core__lp__plus__plus__1_rp_(_x512, _x514, _ctx); /*string*/
    kk_function_t _b_397_386 = kk_std_os_file__new_mlift339_write_text_file_fun519(_ctx); /*(exn0 : exception, pre : string) -> exception*/;
    kk_std_core__exception _b_398_387 = exn; /*exception*/;
    kk_string_t _b_399_388 = _x20; /*string*/;
    kk_box_t _x526 = kk_std_core_hnd__open_none2(kk_std_os_file__new_mlift339_write_text_file_fun527(_b_397_386, _ctx), kk_std_core__exception_box(_b_398_387, _ctx), kk_string_box(_b_399_388), _ctx); /*3381*/
    _x511 = kk_std_core__exception_unbox(_x526, _ctx); /*exception*/
    _b_395_391 = kk_std_core__new_Error(_x511, _ctx); /*error<()>*/
    kk_box_t _x531 = kk_std_core_throw_1(_b_395_391, _ctx); /*11674*/
    kk_unit_unbox(_x531); return kk_Unit;
  }
  kk_std_core__error_drop(_match_453, _ctx);
  kk_std_os_path__path_drop(path, _ctx);
  kk_Unit; return kk_Unit;
}
 
// Write a text file synchronously (using UTF8 encoding)


// lift anonymous function
struct kk_std_os_file_write_text_file_fun536__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file_write_text_file_fun536(kk_function_t _fself, kk_box_t _b_405, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_write_text_file_fun536(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_write_text_file_fun536, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_file_write_text_file_fun536(kk_function_t _fself, kk_box_t _b_405, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_std_os_path__path _x537;
  kk_std_os_path__path p_438 = kk_std_os_path__path_unbox(_b_405, _ctx); /*std/os/path/path*/;
  kk_string_t _x538;
  kk_std_core_types__optional _match_452 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
  if (kk_std_core_types__is_Optional(_match_452)) {
    kk_box_t _box_x401 = _match_452._cons.Optional.value;
    kk_string_t _root_105 = kk_string_unbox(_box_x401);
    kk_string_dup(_root_105);
    kk_std_core_types__optional_drop(_match_452, _ctx);
    kk_Unit;
    _x538 = _root_105; /*string*/
    goto _match539;
  }
  kk_string_t _x00 = p_438.root;
  kk_string_dup(_x00);
  _x538 = _x00; /*string*/
  _match539: ;
  kk_std_core__list _x541;
  kk_std_core__list _x = p_438.parts;
  kk_std_core__list_dup(_x);
  kk_std_os_path__path_drop(p_438, _ctx);
  kk_Unit;
  if (kk_std_core__is_Cons(_x)) {
    struct kk_std_core_Cons* _con543 = kk_std_core__as_Cons(_x);
    kk_box_t _box_x402 = _con543->head;
    kk_std_core__list xx = _con543->tail;
    if (kk_likely(kk_std_core__list_is_unique(_x))) {
      kk_box_drop(_box_x402, _ctx);
      kk_Unit;
      kk_Unit;
      kk_std_core__list_free(_x);
    }
    else {
      kk_std_core__list_dup(xx);
      kk_Unit;
      kk_std_core__list_decref(_x, _ctx);
      kk_Unit;
    }
    _x541 = xx; /*list<string>*/
    goto _match542;
  }
  _x541 = kk_std_core__new_Nil(_ctx); /*list<string>*/
  _match542: ;
  _x537 = kk_std_os_path__new_Path(_x538, _x541, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x537, _ctx);
}


// lift anonymous function
struct kk_std_os_file_write_text_file_fun549__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file_write_text_file_fun549(kk_function_t _fself, kk_box_t _b_410, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_write_text_file_fun549(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_write_text_file_fun549, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_file_write_text_file_fun549(kk_function_t _fself, kk_box_t _b_410, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_std_os_path__path _x550;
  kk_std_os_path__path p0_439 = kk_std_os_path__path_unbox(_b_410, _ctx); /*std/os/path/path*/;
  kk_string_t _x551;
  kk_std_core_types__optional _match_451 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
  if (kk_std_core_types__is_Optional(_match_451)) {
    kk_box_t _box_x406 = _match_451._cons.Optional.value;
    kk_string_t _root_1050 = kk_string_unbox(_box_x406);
    kk_string_dup(_root_1050);
    kk_std_core_types__optional_drop(_match_451, _ctx);
    kk_Unit;
    _x551 = _root_1050; /*string*/
    goto _match552;
  }
  kk_string_t _x000 = p0_439.root;
  kk_string_dup(_x000);
  _x551 = _x000; /*string*/
  _match552: ;
  kk_std_core__list _x554;
  kk_std_core__list _x11 = p0_439.parts;
  kk_std_core__list_dup(_x11);
  kk_std_os_path__path_drop(p0_439, _ctx);
  kk_Unit;
  if (kk_std_core__is_Cons(_x11)) {
    struct kk_std_core_Cons* _con556 = kk_std_core__as_Cons(_x11);
    kk_box_t _box_x407 = _con556->head;
    kk_std_core__list xx0 = _con556->tail;
    if (kk_likely(kk_std_core__list_is_unique(_x11))) {
      kk_box_drop(_box_x407, _ctx);
      kk_Unit;
      kk_Unit;
      kk_std_core__list_free(_x11);
    }
    else {
      kk_std_core__list_dup(xx0);
      kk_Unit;
      kk_std_core__list_decref(_x11, _ctx);
      kk_Unit;
    }
    _x554 = xx0; /*list<string>*/
    goto _match555;
  }
  _x554 = kk_std_core__new_Nil(_ctx); /*list<string>*/
  _match555: ;
  _x550 = kk_std_os_path__new_Path(_x551, _x554, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x550, _ctx);
}


// lift anonymous function
struct kk_std_os_file_write_text_file_fun560__t {
  struct kk_function_s _base;
  kk_string_t content;
  kk_std_os_path__path path;
};
static kk_unit_t kk_std_os_file_write_text_file_fun560(kk_function_t _fself, kk_unit_t _c_326, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_write_text_file_fun560(kk_string_t content, kk_std_os_path__path path, kk_context_t* _ctx) {
  struct kk_std_os_file_write_text_file_fun560__t* _self = kk_function_alloc_as(struct kk_std_os_file_write_text_file_fun560__t, 4, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_file_write_text_file_fun560, kk_context());
  _self->content = content;
  _self->path = path;
  return &_self->_base;
}

static kk_unit_t kk_std_os_file_write_text_file_fun560(kk_function_t _fself, kk_unit_t _c_326, kk_context_t* _ctx) {
  struct kk_std_os_file_write_text_file_fun560__t* _self = kk_function_as(struct kk_std_os_file_write_text_file_fun560__t*, _fself);
  kk_string_t content = _self->content; /* string */
  kk_std_os_path__path path = _self->path; /* std/os/path/path */
  kk_drop_match(_self, {kk_string_dup(content);kk_std_os_path__path_dup(path);}, {}, _ctx)
  return kk_std_os_file__mlift339_write_text_file(content, path, _c_326, _ctx);
}


// lift anonymous function
struct kk_std_os_file_write_text_file_fun562__t {
  struct kk_function_s _base;
  kk_function_t _b_440_415;
};
static kk_box_t kk_std_os_file_write_text_file_fun562(kk_function_t _fself, kk_box_t _b_416, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_write_text_file_fun562(kk_function_t _b_440_415, kk_context_t* _ctx) {
  struct kk_std_os_file_write_text_file_fun562__t* _self = kk_function_alloc_as(struct kk_std_os_file_write_text_file_fun562__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_file_write_text_file_fun562, kk_context());
  _self->_b_440_415 = _b_440_415;
  return &_self->_base;
}

static kk_box_t kk_std_os_file_write_text_file_fun562(kk_function_t _fself, kk_box_t _b_416, kk_context_t* _ctx) {
  struct kk_std_os_file_write_text_file_fun562__t* _self = kk_function_as(struct kk_std_os_file_write_text_file_fun562__t*, _fself);
  kk_function_t _b_440_415 = _self->_b_440_415; /* (()) -> () */
  kk_drop_match(_self, {kk_function_dup(_b_440_415);}, {}, _ctx)
  kk_unit_t _x563 = kk_Unit;
  kk_unit_t _x564 = kk_Unit;
  kk_unit_unbox(_b_416);
  kk_function_call(kk_unit_t, (kk_function_t, kk_unit_t, kk_context_t*), _b_440_415, (_b_440_415, _x564, _ctx));
  return kk_unit_box(_x563);
}


// lift anonymous function
struct kk_std_os_file_write_text_file_fun566__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file_write_text_file_fun566(kk_function_t _fself, kk_box_t _b_419, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_write_text_file_fun566(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_write_text_file_fun566, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_file_write_text_file_fun566(kk_function_t _fself, kk_box_t _b_419, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x567;
  kk_std_os_path__path _x568 = kk_std_os_path__path_unbox(_b_419, _ctx); /*std/os/path/path*/
  _x567 = kk_std_os_path_string(_x568, _ctx); /*string*/
  return kk_string_box(_x567);
}


// lift anonymous function
struct kk_std_os_file_write_text_file_fun573__t {
  struct kk_function_s _base;
};
static kk_std_core__error kk_std_os_file_write_text_file_fun573(kk_function_t _fself, kk_string_t _x1571, kk_string_t _x2572, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_write_text_file_fun573(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_write_text_file_fun573, _ctx)
  return kk_function_dup(_fself);
}

static kk_std_core__error kk_std_os_file_write_text_file_fun573(kk_function_t _fself, kk_string_t _x1571, kk_string_t _x2572, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_os_file_write_text_file_err(_x1571, _x2572, _ctx);
}


// lift anonymous function
struct kk_std_os_file_write_text_file_fun575__t {
  struct kk_function_s _base;
  kk_function_t _b_441_422;
};
static kk_box_t kk_std_os_file_write_text_file_fun575(kk_function_t _fself, kk_box_t _b_425, kk_box_t _b_426, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_write_text_file_fun575(kk_function_t _b_441_422, kk_context_t* _ctx) {
  struct kk_std_os_file_write_text_file_fun575__t* _self = kk_function_alloc_as(struct kk_std_os_file_write_text_file_fun575__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_file_write_text_file_fun575, kk_context());
  _self->_b_441_422 = _b_441_422;
  return &_self->_base;
}

static kk_box_t kk_std_os_file_write_text_file_fun575(kk_function_t _fself, kk_box_t _b_425, kk_box_t _b_426, kk_context_t* _ctx) {
  struct kk_std_os_file_write_text_file_fun575__t* _self = kk_function_as(struct kk_std_os_file_write_text_file_fun575__t*, _fself);
  kk_function_t _b_441_422 = _self->_b_441_422; /* (path : string, content : string) -> fsys error<()> */
  kk_drop_match(_self, {kk_function_dup(_b_441_422);}, {}, _ctx)
  kk_std_core__error _x576;
  kk_string_t _x577 = kk_string_unbox(_b_425); /*string*/
  kk_string_t _x578 = kk_string_unbox(_b_426); /*string*/
  _x576 = kk_function_call(kk_std_core__error, (kk_function_t, kk_string_t, kk_string_t, kk_context_t*), _b_441_422, (_b_441_422, _x577, _x578, _ctx)); /*error<()>*/
  return kk_std_core__error_box(_x576, _ctx);
}


// lift anonymous function
struct kk_std_os_file_write_text_file_fun584__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file_write_text_file_fun584(kk_function_t _fself, kk_box_t _b_429, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_write_text_file_fun584(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_write_text_file_fun584, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_file_write_text_file_fun584(kk_function_t _fself, kk_box_t _b_429, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x585;
  kk_std_os_path__path p1_445 = kk_std_os_path__path_unbox(_b_429, _ctx); /*std/os/path/path*/;
  kk_string_t _x586 = kk_std_os_path_string(p1_445, _ctx); /*string*/
  _x585 = kk_std_core_show_3(_x586, _ctx); /*string*/
  return kk_string_box(_x585);
}


// lift anonymous function
struct kk_std_os_file_write_text_file_fun587__t {
  struct kk_function_s _base;
};
static kk_std_core__exception kk_std_os_file_write_text_file_fun587(kk_function_t _fself, kk_std_core__exception exn0, kk_string_t pre, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_write_text_file_fun587(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_write_text_file_fun587, _ctx)
  return kk_function_dup(_fself);
}

static kk_std_core__exception kk_std_os_file_write_text_file_fun587(kk_function_t _fself, kk_std_core__exception exn0, kk_string_t pre, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x588;
  kk_string_t _x589;
  kk_string_t _x590;
  kk_define_string_literal(, _s591, 2, ": ")
  _x590 = kk_string_dup(_s591); /*string*/
  kk_string_t _x592;
  kk_string_t _x21 = exn0.message;
  kk_string_dup(_x21);
  _x592 = _x21; /*string*/
  _x589 = kk_std_core__lp__plus__plus__1_rp_(_x590, _x592, _ctx); /*string*/
  _x588 = kk_std_core__lp__plus__plus__1_rp_(pre, _x589, _ctx); /*string*/
  kk_std_core__exception_info _x593;
  kk_std_core__exception_info _x3 = exn0.info;
  kk_std_core__exception_info_dup(_x3);
  kk_std_core__exception_drop(exn0, _ctx);
  kk_Unit;
  _x593 = _x3; /*exception-info*/
  return kk_std_core__new_Exception(_x588, _x593, _ctx);
}


// lift anonymous function
struct kk_std_os_file_write_text_file_fun595__t {
  struct kk_function_s _base;
  kk_function_t _b_446_432;
};
static kk_box_t kk_std_os_file_write_text_file_fun595(kk_function_t _fself, kk_box_t _b_435, kk_box_t _b_436, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_write_text_file_fun595(kk_function_t _b_446_432, kk_context_t* _ctx) {
  struct kk_std_os_file_write_text_file_fun595__t* _self = kk_function_alloc_as(struct kk_std_os_file_write_text_file_fun595__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_file_write_text_file_fun595, kk_context());
  _self->_b_446_432 = _b_446_432;
  return &_self->_base;
}

static kk_box_t kk_std_os_file_write_text_file_fun595(kk_function_t _fself, kk_box_t _b_435, kk_box_t _b_436, kk_context_t* _ctx) {
  struct kk_std_os_file_write_text_file_fun595__t* _self = kk_function_as(struct kk_std_os_file_write_text_file_fun595__t*, _fself);
  kk_function_t _b_446_432 = _self->_b_446_432; /* (exn0 : exception, pre : string) -> exception */
  kk_drop_match(_self, {kk_function_dup(_b_446_432);}, {}, _ctx)
  kk_std_core__exception _x596;
  kk_std_core__exception _x597 = kk_std_core__exception_unbox(_b_435, _ctx); /*exception*/
  kk_string_t _x598 = kk_string_unbox(_b_436); /*string*/
  _x596 = kk_function_call(kk_std_core__exception, (kk_function_t, kk_std_core__exception, kk_string_t, kk_context_t*), _b_446_432, (_b_446_432, _x597, _x598, _ctx)); /*exception*/
  return kk_std_core__exception_box(_x596, _ctx);
}

kk_unit_t kk_std_os_file_write_text_file(kk_std_os_path__path path, kk_string_t content, kk_std_core_types__optional create_dir, kk_context_t* _ctx) { /* (path : std/os/path/path, content : string, create-dir : optional<bool>) -> <exn,fsys> () */ 
  kk_unit_t x_340 = kk_Unit;
  if (kk_std_core_types__is_Optional(create_dir)) {
    kk_box_t _box_x400 = create_dir._cons.Optional.value;
    bool _create_dir_188 = kk_bool_unbox(_box_x400);
    kk_std_core_types__optional_drop(create_dir, _ctx);
    kk_Unit;
    if (_create_dir_188) {
      kk_std_os_path__path _x534;
      kk_box_t _x535;
      kk_box_t _x545;
      kk_std_os_path__path _x546 = kk_std_os_path__path_dup(path); /*std/os/path/path*/
      _x545 = kk_std_os_path__path_box(_x546, _ctx); /*3288*/
      _x535 = kk_std_core_hnd__open_none1(kk_std_os_file_new_write_text_file_fun536(_ctx), _x545, _ctx); /*3289*/
      _x534 = kk_std_os_path__path_unbox(_x535, _ctx); /*std/os/path/path*/
      kk_std_os_dir_ensure_dir(_x534, _ctx);
      goto _match532;
    }
    kk_Unit;
    goto _match532;
  }
  kk_std_os_path__path _x547;
  kk_box_t _x548;
  kk_box_t _x558;
  kk_std_os_path__path _x559 = kk_std_os_path__path_dup(path); /*std/os/path/path*/
  _x558 = kk_std_os_path__path_box(_x559, _ctx); /*3288*/
  _x548 = kk_std_core_hnd__open_none1(kk_std_os_file_new_write_text_file_fun549(_ctx), _x558, _ctx); /*3289*/
  _x547 = kk_std_os_path__path_unbox(_x548, _ctx); /*std/os/path/path*/
  kk_std_os_dir_ensure_dir(_x547, _ctx);
  _match532: ;
  if (kk_yielding(kk_context())) {
    kk_function_t _b_440_415 = kk_std_os_file_new_write_text_file_fun560(content, path, _ctx); /*(()) -> ()*/;
    kk_box_t _x561 = kk_std_core_hnd_yield_extend(kk_std_os_file_new_write_text_file_fun562(_b_440_415, _ctx), _ctx); /*3858*/
    kk_unit_unbox(_x561); return kk_Unit;
  }
  kk_string_t _x12;
  kk_box_t _x565;
  kk_box_t _x569;
  kk_std_os_path__path _x570 = kk_std_os_path__path_dup(path); /*std/os/path/path*/
  _x569 = kk_std_os_path__path_box(_x570, _ctx); /*3288*/
  _x565 = kk_std_core_hnd__open_none1(kk_std_os_file_new_write_text_file_fun566(_ctx), _x569, _ctx); /*3289*/
  _x12 = kk_string_unbox(_x565); /*string*/
  kk_std_core__error _match_450;
  kk_function_t _b_441_422 = kk_std_os_file_new_write_text_file_fun573(_ctx); /*(path : string, content : string) -> fsys error<()>*/;
  kk_string_t _b_442_423 = _x12; /*string*/;
  kk_string_t _b_443_424 = content; /*string*/;
  kk_box_t _x574 = kk_std_core_hnd__open_none2(kk_std_os_file_new_write_text_file_fun575(_b_441_422, _ctx), kk_string_box(_b_442_423), kk_string_box(_b_443_424), _ctx); /*3381*/
  _match_450 = kk_std_core__error_unbox(_x574, _ctx); /*error<()>*/
  if (kk_std_core__is_Error(_match_450)) {
    kk_std_core__exception exn = _match_450._cons.Error.exception;
    kk_std_core__exception_dup(exn);
    kk_std_core__error_drop(_match_450, _ctx);
    kk_Unit;
    kk_std_core__error _b_444_437;
    kk_std_core__exception _x579;
    kk_string_t _x20;
    kk_string_t _x580;
    kk_define_string_literal(, _s581, 26, "unable to write text file ")
    _x580 = kk_string_dup(_s581); /*string*/
    kk_string_t _x582;
    kk_box_t _x583 = kk_std_core_hnd__open_none1(kk_std_os_file_new_write_text_file_fun584(_ctx), kk_std_os_path__path_box(path, _ctx), _ctx); /*3289*/
    _x582 = kk_string_unbox(_x583); /*string*/
    _x20 = kk_std_core__lp__plus__plus__1_rp_(_x580, _x582, _ctx); /*string*/
    kk_function_t _b_446_432 = kk_std_os_file_new_write_text_file_fun587(_ctx); /*(exn0 : exception, pre : string) -> exception*/;
    kk_std_core__exception _b_447_433 = exn; /*exception*/;
    kk_string_t _b_448_434 = _x20; /*string*/;
    kk_box_t _x594 = kk_std_core_hnd__open_none2(kk_std_os_file_new_write_text_file_fun595(_b_446_432, _ctx), kk_std_core__exception_box(_b_447_433, _ctx), kk_string_box(_b_448_434), _ctx); /*3381*/
    _x579 = kk_std_core__exception_unbox(_x594, _ctx); /*exception*/
    _b_444_437 = kk_std_core__new_Error(_x579, _ctx); /*error<()>*/
    kk_box_t _x599 = kk_std_core_throw_1(_b_444_437, _ctx); /*11674*/
    kk_unit_unbox(_x599); return kk_Unit;
  }
  kk_std_core__error_drop(_match_450, _ctx);
  kk_std_os_path__path_drop(path, _ctx);
  kk_Unit; return kk_Unit;
}

// initialization
void kk_std_os_file__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core__init(_ctx);
  kk_std_os_path__init(_ctx);
  kk_std_os_dir__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
}

// termination
void kk_std_os_file__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_os_dir__done(_ctx);
  kk_std_os_path__done(_ctx);
  kk_std_core__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
