// Koka generated module: "std/time/chrono", koka version: 2.2.1
#include "std_time_chrono.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/

static kk_std_core_types__tuple2_ kk_time_unix_now_tuple(kk_context_t* ctx) {
  double frac;
  double secs = kk_time_unix_now(&frac,ctx);
  return kk_std_core_types__new_dash__lp__comma__rp_( kk_double_box(secs,ctx), kk_double_box(frac,ctx), ctx );
}

 
// Returns a unix time stamp as seconds and fraction of seconds;
// The fraction of seconds is for added precision if necessary,
// and can be larger than one to indicate leap seconds.
// This still needs to be adjusted to our epoch and taking account of leap seconds.

kk_std_core_types__tuple2_ kk_std_time_chrono_unix_now(kk_context_t* _ctx) { /* () -> ndet (double, double) */ 
  return kk_time_unix_now_tuple(kk_context());
}

double kk_std_time_chrono_xnow_resolution(kk_context_t* _ctx) { /* () -> ndet double */ 
  return kk_time_resolution(kk_context());
}
 
// The current `:instant` in time as returned by the system clock
// in an optional time scale `ts` (`= ts-ti`).
//
// This uses the best available system clock for the requested
// timescale. For example
// it uses [``CLOCK_UTC``](http://www.madore.org/~david/computers/unix-leap-seconds.html)
// when available to get proper UTC time, or ``CLOCK_TAI`` for TAI time.
//
// Otherwise, it usually uses Unix (POSIX) time (``CLOCK_REALTIME``).
// Unfortunately, most operating systems cannot not report time in leap
// seconds accurately. The `now` function is limited by the OS in this case.
//
// To guard against inaccurate clocks and increase monotonicity,
// the `now` function guarantees that if the current measurement is
// upto 1 second in the past with regard to the previous call to `now`,
// that the returned instant is monotonic by adding nano seconds to the
// previous measurement until the system clock catches up again.
//
// This is effective in particular on older OS's where the time sometimes jumps
// back one second after a leap second. By limiting the adjustment to at most
// one second it ensures the clock catches up soon and does not affect the user
// setting a new time in the past.

kk_std_time_instant__instant kk_std_time_chrono_now_in(kk_std_core_types__optional ts, kk_context_t* _ctx) { /* (ts : optional<std/time/instant/timescale>) -> ndet std/time/instant/instant */ 
  kk_std_core_types__tuple2_ _match_161 = kk_std_time_chrono_unix_now(_ctx); /*(double, double)*/;
  kk_box_t _box_x112 = _match_161.fst;
  kk_box_t _box_x113 = _match_161.snd;
  double secs = kk_double_unbox(_box_x112, NULL);
  double frac = kk_double_unbox(_box_x113, NULL);
  kk_std_core_types__tuple2__drop(_match_161, _ctx);
  kk_Unit;
  kk_std_core_types__optional _x165;
  double _b_117_114 = frac; /*double*/;
  _x165 = kk_std_core_types__new_Optional(kk_double_box(_b_117_114, _ctx), _ctx); /*optional<106>*/
  kk_std_core_types__optional _x166;
  kk_std_time_instant__timescale _b_118_116;
  if (kk_std_core_types__is_Optional(ts)) {
    kk_box_t _box_x115 = ts._cons.Optional.value;
    kk_std_time_instant__timescale _ts_37 = kk_std_time_instant__timescale_unbox(_box_x115, NULL);
    kk_std_time_instant__timescale_dup(_ts_37);
    kk_std_core_types__optional_drop(ts, _ctx);
    kk_Unit;
    _b_118_116 = _ts_37; /*std/time/instant/timescale*/
    goto _match167;
  }
  kk_string_t _x169 = kk_string_empty(); /*string*/
  kk_std_time_utc__leaps_table _x171 = kk_std_time_utc__leaps_table_dup(kk_std_time_utc_leaps_table_ti); /*std/time/utc/leaps-table*/
  _b_118_116 = kk_std_time_utc_utc_timescale(_x169, _x171, _ctx); /*std/time/instant/timescale*/
  _match167: ;
  _x166 = kk_std_core_types__new_Optional(kk_std_time_instant__timescale_box(_b_118_116, _ctx), _ctx); /*optional<106>*/
  return kk_std_time_utc_unix_instant(secs, _x165, _x166, _ctx);
}
 
// monadic lift


// lift anonymous function
struct kk_std_time_chrono__mlift105_now_fun172__t {
  struct kk_function_s _base;
};
static kk_std_time_instant__instant kk_std_time_chrono__mlift105_now_fun172(kk_function_t _fself, kk_std_core_types__optional ts, kk_context_t* _ctx);
static kk_function_t kk_std_time_chrono__new_mlift105_now_fun172(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_time_chrono__mlift105_now_fun172, _ctx)
  return kk_function_dup(_fself);
}

static kk_std_time_instant__instant kk_std_time_chrono__mlift105_now_fun172(kk_function_t _fself, kk_std_core_types__optional ts, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_std_core_types__tuple2_ _match_160 = kk_std_time_chrono_unix_now(_ctx); /*(double, double)*/;
  kk_box_t _box_x119 = _match_160.fst;
  kk_box_t _box_x120 = _match_160.snd;
  double secs = kk_double_unbox(_box_x119, NULL);
  double frac = kk_double_unbox(_box_x120, NULL);
  kk_std_core_types__tuple2__drop(_match_160, _ctx);
  kk_Unit;
  kk_std_core_types__optional _x175;
  double _b_130_121 = frac; /*double*/;
  _x175 = kk_std_core_types__new_Optional(kk_double_box(_b_130_121, _ctx), _ctx); /*optional<106>*/
  kk_std_core_types__optional _x176;
  kk_std_time_instant__timescale _b_131_123;
  if (kk_std_core_types__is_Optional(ts)) {
    kk_box_t _box_x122 = ts._cons.Optional.value;
    kk_std_time_instant__timescale _ts_37 = kk_std_time_instant__timescale_unbox(_box_x122, NULL);
    kk_std_time_instant__timescale_dup(_ts_37);
    kk_std_core_types__optional_drop(ts, _ctx);
    kk_Unit;
    _b_131_123 = _ts_37; /*std/time/instant/timescale*/
    goto _match177;
  }
  kk_string_t _x179 = kk_string_empty(); /*string*/
  kk_std_time_utc__leaps_table _x181 = kk_std_time_utc__leaps_table_dup(kk_std_time_utc_leaps_table_ti); /*std/time/utc/leaps-table*/
  _b_131_123 = kk_std_time_utc_utc_timescale(_x179, _x181, _ctx); /*std/time/instant/timescale*/
  _match177: ;
  _x176 = kk_std_core_types__new_Optional(kk_std_time_instant__timescale_box(_b_131_123, _ctx), _ctx); /*optional<106>*/
  return kk_std_time_utc_unix_instant(secs, _x175, _x176, _ctx);
}


// lift anonymous function
struct kk_std_time_chrono__mlift105_now_fun183__t {
  struct kk_function_s _base;
  kk_function_t _b_128_125;
};
static kk_box_t kk_std_time_chrono__mlift105_now_fun183(kk_function_t _fself, kk_box_t _b_127, kk_context_t* _ctx);
static kk_function_t kk_std_time_chrono__new_mlift105_now_fun183(kk_function_t _b_128_125, kk_context_t* _ctx) {
  struct kk_std_time_chrono__mlift105_now_fun183__t* _self = kk_function_alloc_as(struct kk_std_time_chrono__mlift105_now_fun183__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_time_chrono__mlift105_now_fun183, kk_context());
  _self->_b_128_125 = _b_128_125;
  return &_self->_base;
}

static kk_box_t kk_std_time_chrono__mlift105_now_fun183(kk_function_t _fself, kk_box_t _b_127, kk_context_t* _ctx) {
  struct kk_std_time_chrono__mlift105_now_fun183__t* _self = kk_function_as(struct kk_std_time_chrono__mlift105_now_fun183__t*, _fself);
  kk_function_t _b_128_125 = _self->_b_128_125; /* (ts : optional<std/time/instant/timescale>) -> ndet std/time/instant/instant */
  kk_drop_match(_self, {kk_function_dup(_b_128_125);}, {}, _ctx)
  kk_std_time_instant__instant _x184;
  kk_std_core_types__optional _x185 = kk_std_core_types__optional_unbox(_b_127, _ctx); /*optional<std/time/instant/timescale>*/
  _x184 = kk_function_call(kk_std_time_instant__instant, (kk_function_t, kk_std_core_types__optional, kk_context_t*), _b_128_125, (_b_128_125, _x185, _ctx)); /*std/time/instant/instant*/
  return kk_std_time_instant__instant_box(_x184, _ctx);
}

kk_std_time_instant__instant kk_std_time_chrono__mlift105_now(kk_std_time_instant__timescale _y_103, kk_context_t* _ctx) { /* (std/time/instant/timescale) -> std/time/utc/utc std/time/instant/instant */ 
  kk_function_t _b_128_125 = kk_std_time_chrono__new_mlift105_now_fun172(_ctx); /*(ts : optional<std/time/instant/timescale>) -> ndet std/time/instant/instant*/;
  kk_std_core_types__optional _b_129_126;
  kk_std_time_instant__timescale _b_132_124 = _y_103; /*std/time/instant/timescale*/;
  _b_129_126 = kk_std_core_types__new_Optional(kk_std_time_instant__timescale_box(_b_132_124, _ctx), _ctx); /*optional<std/time/instant/timescale>*/
  kk_box_t _x182 = kk_std_core_hnd__open_none1(kk_std_time_chrono__new_mlift105_now_fun183(_b_128_125, _ctx), kk_std_core_types__optional_box(_b_129_126, _ctx), _ctx); /*3289*/
  return kk_std_time_instant__instant_unbox(_x182, _ctx);
}
 
// The current `:instant` in time as returned by the system clock
// in the UTC timescale. Equivalent to `now-in(utc())`, see
// `now-in` for further information about the system clock.


// lift anonymous function
struct kk_std_time_chrono_now_fun191__t {
  struct kk_function_s _base;
};
static kk_std_time_instant__instant kk_std_time_chrono_now_fun191(kk_function_t _fself, kk_std_time_instant__timescale _x1190, kk_context_t* _ctx);
static kk_function_t kk_std_time_chrono_new_now_fun191(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_time_chrono_now_fun191, _ctx)
  return kk_function_dup(_fself);
}

static kk_std_time_instant__instant kk_std_time_chrono_now_fun191(kk_function_t _fself, kk_std_time_instant__timescale _x1190, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_time_chrono__mlift105_now(_x1190, _ctx);
}


// lift anonymous function
struct kk_std_time_chrono_now_fun193__t {
  struct kk_function_s _base;
  kk_function_t _b_150_139;
};
static kk_box_t kk_std_time_chrono_now_fun193(kk_function_t _fself, kk_box_t _b_140, kk_context_t* _ctx);
static kk_function_t kk_std_time_chrono_new_now_fun193(kk_function_t _b_150_139, kk_context_t* _ctx) {
  struct kk_std_time_chrono_now_fun193__t* _self = kk_function_alloc_as(struct kk_std_time_chrono_now_fun193__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_time_chrono_now_fun193, kk_context());
  _self->_b_150_139 = _b_150_139;
  return &_self->_base;
}

static kk_box_t kk_std_time_chrono_now_fun193(kk_function_t _fself, kk_box_t _b_140, kk_context_t* _ctx) {
  struct kk_std_time_chrono_now_fun193__t* _self = kk_function_as(struct kk_std_time_chrono_now_fun193__t*, _fself);
  kk_function_t _b_150_139 = _self->_b_150_139; /* (std/time/instant/timescale) -> std/time/utc/utc std/time/instant/instant */
  kk_drop_match(_self, {kk_function_dup(_b_150_139);}, {}, _ctx)
  kk_std_time_instant__instant _x194;
  kk_std_time_instant__timescale _x195 = kk_std_time_instant__timescale_unbox(_b_140, _ctx); /*std/time/instant/timescale*/
  _x194 = kk_function_call(kk_std_time_instant__instant, (kk_function_t, kk_std_time_instant__timescale, kk_context_t*), _b_150_139, (_b_150_139, _x195, _ctx)); /*std/time/instant/instant*/
  return kk_std_time_instant__instant_box(_x194, _ctx);
}


// lift anonymous function
struct kk_std_time_chrono_now_fun196__t {
  struct kk_function_s _base;
};
static kk_std_time_instant__instant kk_std_time_chrono_now_fun196(kk_function_t _fself, kk_std_core_types__optional ts, kk_context_t* _ctx);
static kk_function_t kk_std_time_chrono_new_now_fun196(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_time_chrono_now_fun196, _ctx)
  return kk_function_dup(_fself);
}

static kk_std_time_instant__instant kk_std_time_chrono_now_fun196(kk_function_t _fself, kk_std_core_types__optional ts, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_std_core_types__tuple2_ _match_157 = kk_std_time_chrono_unix_now(_ctx); /*(double, double)*/;
  kk_box_t _box_x141 = _match_157.fst;
  kk_box_t _box_x142 = _match_157.snd;
  double secs = kk_double_unbox(_box_x141, NULL);
  double frac = kk_double_unbox(_box_x142, NULL);
  kk_std_core_types__tuple2__drop(_match_157, _ctx);
  kk_Unit;
  kk_std_core_types__optional _x199;
  double _b_153_143 = frac; /*double*/;
  _x199 = kk_std_core_types__new_Optional(kk_double_box(_b_153_143, _ctx), _ctx); /*optional<106>*/
  kk_std_core_types__optional _x200;
  kk_std_time_instant__timescale _b_154_145;
  if (kk_std_core_types__is_Optional(ts)) {
    kk_box_t _box_x144 = ts._cons.Optional.value;
    kk_std_time_instant__timescale _ts_37 = kk_std_time_instant__timescale_unbox(_box_x144, NULL);
    kk_std_time_instant__timescale_dup(_ts_37);
    kk_std_core_types__optional_drop(ts, _ctx);
    kk_Unit;
    _b_154_145 = _ts_37; /*std/time/instant/timescale*/
    goto _match201;
  }
  kk_string_t _x203 = kk_string_empty(); /*string*/
  kk_std_time_utc__leaps_table _x205 = kk_std_time_utc__leaps_table_dup(kk_std_time_utc_leaps_table_ti); /*std/time/utc/leaps-table*/
  _b_154_145 = kk_std_time_utc_utc_timescale(_x203, _x205, _ctx); /*std/time/instant/timescale*/
  _match201: ;
  _x200 = kk_std_core_types__new_Optional(kk_std_time_instant__timescale_box(_b_154_145, _ctx), _ctx); /*optional<106>*/
  return kk_std_time_utc_unix_instant(secs, _x199, _x200, _ctx);
}


// lift anonymous function
struct kk_std_time_chrono_now_fun207__t {
  struct kk_function_s _base;
  kk_function_t _b_151_147;
};
static kk_box_t kk_std_time_chrono_now_fun207(kk_function_t _fself, kk_box_t _b_149, kk_context_t* _ctx);
static kk_function_t kk_std_time_chrono_new_now_fun207(kk_function_t _b_151_147, kk_context_t* _ctx) {
  struct kk_std_time_chrono_now_fun207__t* _self = kk_function_alloc_as(struct kk_std_time_chrono_now_fun207__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_time_chrono_now_fun207, kk_context());
  _self->_b_151_147 = _b_151_147;
  return &_self->_base;
}

static kk_box_t kk_std_time_chrono_now_fun207(kk_function_t _fself, kk_box_t _b_149, kk_context_t* _ctx) {
  struct kk_std_time_chrono_now_fun207__t* _self = kk_function_as(struct kk_std_time_chrono_now_fun207__t*, _fself);
  kk_function_t _b_151_147 = _self->_b_151_147; /* (ts : optional<std/time/instant/timescale>) -> ndet std/time/instant/instant */
  kk_drop_match(_self, {kk_function_dup(_b_151_147);}, {}, _ctx)
  kk_std_time_instant__instant _x208;
  kk_std_core_types__optional _x209 = kk_std_core_types__optional_unbox(_b_149, _ctx); /*optional<std/time/instant/timescale>*/
  _x208 = kk_function_call(kk_std_time_instant__instant, (kk_function_t, kk_std_core_types__optional, kk_context_t*), _b_151_147, (_b_151_147, _x209, _ctx)); /*std/time/instant/instant*/
  return kk_std_time_instant__instant_box(_x208, _ctx);
}

kk_std_time_instant__instant kk_std_time_chrono_now(kk_context_t* _ctx) { /* () -> <ndet,std/time/utc/utc> std/time/instant/instant */ 
  kk_std_core_hnd__ev ev_109;
  kk_ssize_t _x186 = ((kk_ssize_t)0); /*ssize_t*/
  ev_109 = kk_evv_at(_x186,kk_context()); /*std/core/hnd/ev<std/time/utc/.hnd-utc>*/
  kk_std_time_instant__timescale x_106;
  kk_box_t _x187;
  struct kk_std_core_hnd_Ev* _con188 = kk_std_core_hnd__as_Ev(ev_109);
  kk_std_core_hnd__marker m0 = _con188->marker;
  kk_box_t _box_x133 = _con188->hnd;
  kk_std_time_utc__hnd_utc h = kk_std_time_utc__hnd_utc_unbox(_box_x133, NULL);
  kk_std_time_utc__hnd_utc_dup(h);
  kk_std_core_hnd__clause0 _match_158;
  kk_std_core_hnd__clause0 _borrowApp_159 = kk_std_time_utc__select_utc(h, _ctx); /*std/core/hnd/clause0<std/time/instant/timescale,std/time/utc/.hnd-utc,277,278>*/;
  kk_std_time_utc__hnd_utc_drop(h, _ctx);
  _match_158 = _borrowApp_159; /*std/core/hnd/clause0<std/time/instant/timescale,std/time/utc/.hnd-utc,277,278>*/
  kk_function_t _fun_unbox_x136 = _match_158.clause;
  _x187 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_context_t*), _fun_unbox_x136, (_fun_unbox_x136, m0, ev_109, _ctx)); /*37*/
  x_106 = kk_std_time_instant__timescale_unbox(_x187, _ctx); /*std/time/instant/timescale*/
  if (kk_yielding(kk_context())) {
    kk_std_time_instant__timescale_dropn(x_106, ((int32_t)10), _ctx);
    kk_function_t _b_150_139 = kk_std_time_chrono_new_now_fun191(_ctx); /*(std/time/instant/timescale) -> std/time/utc/utc std/time/instant/instant*/;
    kk_box_t _x192 = kk_std_core_hnd_yield_extend(kk_std_time_chrono_new_now_fun193(_b_150_139, _ctx), _ctx); /*3858*/
    return kk_std_time_instant__instant_unbox(_x192, _ctx);
  }
  kk_function_t _b_151_147 = kk_std_time_chrono_new_now_fun196(_ctx); /*(ts : optional<std/time/instant/timescale>) -> ndet std/time/instant/instant*/;
  kk_std_core_types__optional _b_152_148;
  kk_std_time_instant__timescale _b_155_146 = x_106; /*std/time/instant/timescale*/;
  _b_152_148 = kk_std_core_types__new_Optional(kk_std_time_instant__timescale_box(_b_155_146, _ctx), _ctx); /*optional<std/time/instant/timescale>*/
  kk_box_t _x206 = kk_std_core_hnd__open_none1(kk_std_time_chrono_new_now_fun207(_b_151_147, _ctx), kk_std_core_types__optional_box(_b_152_148, _ctx), _ctx); /*3289*/
  return kk_std_time_instant__instant_unbox(_x206, _ctx);
}

// initialization
void kk_std_time_chrono__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core__init(_ctx);
  kk_std_num_ddouble__init(_ctx);
  kk_std_time_duration__init(_ctx);
  kk_std_time_instant__init(_ctx);
  kk_std_time_utc__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
}

// termination
void kk_std_time_chrono__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_time_utc__done(_ctx);
  kk_std_time_instant__done(_ctx);
  kk_std_time_duration__done(_ctx);
  kk_std_num_ddouble__done(_ctx);
  kk_std_core__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
