// Koka generated module: "std/time/timer", koka version: 2.2.1
#include "std_time_timer.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/

static kk_std_core_types__tuple2_ kk_timer_ticks_tuple(kk_context_t* ctx) {
  double frac;
  double secs = kk_timer_ticks(&frac,ctx);
  return kk_std_core_types__new_dash__lp__comma__rp_( kk_double_box(secs,ctx), kk_double_box(frac,ctx), ctx );
}


kk_std_core_types__tuple2_ kk_std_time_timer_xticks(kk_context_t* _ctx) { /* () -> ndet (double, double) */ 
  return kk_timer_ticks_tuple(kk_context());
}
 
// Return the smallest time difference in seconds that `ticks` can measure.

double kk_std_time_timer_xticks_resolution(kk_context_t* _ctx) { /* () -> ndet double */ 
  return kk_timer_resolution(kk_context());
}
 
// Return a high-resolution time stamp in fractional SI seconds.
// The duration is guaranteed to be monotonically increasing
// and have at least millisecond resolution.

kk_std_time_duration__duration kk_std_time_timer_ticks(kk_context_t* _ctx) { /* () -> ndet std/time/duration/duration */ 
  kk_std_core_types__tuple2_ _match_370 = kk_std_time_timer_xticks(_ctx); /*(double, double)*/;
  kk_box_t _box_x335 = _match_370.fst;
  kk_box_t _box_x336 = _match_370.snd;
  double secs = kk_double_unbox(_box_x335, NULL);
  double frac = kk_double_unbox(_box_x336, NULL);
  kk_std_core_types__tuple2__drop(_match_370, _ctx);
  kk_Unit;
  kk_integer_t secs0_316;
  double _x375;
  bool _match_372 = (secs >= (0.0)); /*bool*/;
  if (_match_372) {
    _x375 = floor(secs); /*double*/
  }
  else {
    _x375 = ceil(secs); /*double*/
  }
  secs0_316 = kk_integer_from_double(_x375,kk_context()); /*int*/
  double _b_338_337;
  double _x376 = kk_std_num_double_fraction(secs, _ctx); /*double*/
  _b_338_337 = (_x376 + frac); /*double*/
  kk_std_num_ddouble__ddouble _x377;
  kk_std_core_types__optional _x378;
  double _b_341_340;
  kk_std_core_types__optional _match_371 = kk_std_core_types__new_Optional(kk_double_box(_b_338_337, _ctx), _ctx); /*optional<106>*/;
  if (kk_std_core_types__is_Optional(_match_371)) {
    kk_box_t _box_x339 = _match_371._cons.Optional.value;
    double _frac_162 = kk_double_unbox(_box_x339, NULL);
    kk_std_core_types__optional_drop(_match_371, _ctx);
    kk_Unit;
    _b_341_340 = _frac_162; /*double*/
    goto _match379;
  }
  _b_341_340 = 0.0; /*double*/
  _match379: ;
  _x378 = kk_std_core_types__new_Optional(kk_double_box(_b_341_340, _ctx), _ctx); /*optional<106>*/
  _x377 = kk_std_time_timestamp_timespan(secs0_316, _x378, _ctx); /*std/time/timestamp/timespan*/
  return kk_std_time_duration__new_Duration(_x377, _ctx);
}
 
// Return the number of fractional seconds that it takes to evaluate `action`.


// lift anonymous function
struct kk_std_time_timer_elapsed_fun381__t {
  struct kk_function_s _base;
  kk_std_time_duration__duration t0;
};
static kk_std_core_types__tuple2_ kk_std_time_timer_elapsed_fun381(kk_function_t _fself, kk_box_t x0, kk_context_t* _ctx);
static kk_function_t kk_std_time_timer_new_elapsed_fun381(kk_std_time_duration__duration t0, kk_context_t* _ctx) {
  struct kk_std_time_timer_elapsed_fun381__t* _self = kk_function_alloc_as(struct kk_std_time_timer_elapsed_fun381__t, 1, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_time_timer_elapsed_fun381, kk_context());
  _self->t0 = t0;
  return &_self->_base;
}

static kk_std_core_types__tuple2_ kk_std_time_timer_elapsed_fun381(kk_function_t _fself, kk_box_t x0, kk_context_t* _ctx) {
  struct kk_std_time_timer_elapsed_fun381__t* _self = kk_function_as(struct kk_std_time_timer_elapsed_fun381__t*, _fself);
  kk_std_time_duration__duration t0 = _self->t0; /* std/time/duration/duration */
  kk_drop_match(_self, {kk_std_time_duration__duration_dup(t0);}, {}, _ctx)
  kk_std_time_duration__duration t1 = kk_std_time_timer_ticks(_ctx); /*std/time/duration/duration*/;
  kk_std_time_duration__duration _b_353_346 = kk_std_time_duration__lp__dash__rp_(t1, t0, _ctx); /*std/time/duration/duration*/;
  kk_box_t _b_354_347 = x0; /*163*/;
  return kk_std_core_types__new_dash__lp__comma__rp_(kk_std_time_duration__duration_box(_b_353_346, _ctx), _b_354_347, _ctx);
}


// lift anonymous function
struct kk_std_time_timer_elapsed_fun383__t {
  struct kk_function_s _base;
  kk_function_t _b_352_348;
};
static kk_box_t kk_std_time_timer_elapsed_fun383(kk_function_t _fself, kk_box_t _b_349, kk_context_t* _ctx);
static kk_function_t kk_std_time_timer_new_elapsed_fun383(kk_function_t _b_352_348, kk_context_t* _ctx) {
  struct kk_std_time_timer_elapsed_fun383__t* _self = kk_function_alloc_as(struct kk_std_time_timer_elapsed_fun383__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_time_timer_elapsed_fun383, kk_context());
  _self->_b_352_348 = _b_352_348;
  return &_self->_base;
}

static kk_box_t kk_std_time_timer_elapsed_fun383(kk_function_t _fself, kk_box_t _b_349, kk_context_t* _ctx) {
  struct kk_std_time_timer_elapsed_fun383__t* _self = kk_function_as(struct kk_std_time_timer_elapsed_fun383__t*, _fself);
  kk_function_t _b_352_348 = _self->_b_352_348; /* (x0 : 163) -> <ndet|164> (std/time/duration/duration, 163) */
  kk_drop_match(_self, {kk_function_dup(_b_352_348);}, {}, _ctx)
  kk_std_core_types__tuple2_ _x384 = kk_function_call(kk_std_core_types__tuple2_, (kk_function_t, kk_box_t, kk_context_t*), _b_352_348, (_b_352_348, _b_349, _ctx)); /*(std/time/duration/duration, 163)*/
  return kk_std_core_types__tuple2__box(_x384, _ctx);
}

kk_std_core_types__tuple2_ kk_std_time_timer_elapsed(kk_function_t action, kk_context_t* _ctx) { /* forall<a,e> (action : () -> <ndet|e> a) -> <ndet|e> (std/time/duration/duration, a) */ 
  kk_std_time_duration__duration t0 = kk_std_time_timer_ticks(_ctx); /*std/time/duration/duration*/;
  kk_box_t x_325 = kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), action, (action, _ctx)); /*163*/;
  if (kk_yielding(kk_context())) {
    kk_box_drop(x_325, _ctx);
    kk_function_t _b_352_348 = kk_std_time_timer_new_elapsed_fun381(t0, _ctx); /*(x0 : 163) -> <ndet|164> (std/time/duration/duration, 163)*/;
    kk_box_t _x382 = kk_std_core_hnd_yield_extend(kk_std_time_timer_new_elapsed_fun383(_b_352_348, _ctx), _ctx); /*3858*/
    return kk_std_core_types__tuple2__unbox(_x382, _ctx);
  }
  kk_std_time_duration__duration t10 = kk_std_time_timer_ticks(_ctx); /*std/time/duration/duration*/;
  kk_std_time_duration__duration _b_355_350 = kk_std_time_duration__lp__dash__rp_(t10, t0, _ctx); /*std/time/duration/duration*/;
  kk_box_t _b_356_351 = x_325; /*163*/;
  return kk_std_core_types__new_dash__lp__comma__rp_(kk_std_time_duration__duration_box(_b_355_350, _ctx), _b_356_351, _ctx);
}
 
// monadic lift

kk_box_t kk_std_time_timer__mlift324_print_elapsed(kk_std_core_types__optional msg, kk_std_core_types__tuple2_ _y_321, kk_context_t* _ctx) { /* forall<a,e> (msg : optional<string>, (std/time/duration/duration, a)) -> <ndet,console|e> a */ 
  kk_box_t _box_x357 = _y_321.fst;
  kk_box_t x = _y_321.snd;
  kk_std_time_duration__duration t = kk_std_time_duration__duration_unbox(_box_x357, NULL);
  kk_box_dup(x);
  kk_std_core_types__tuple2__drop(_y_321, _ctx);
  kk_Unit;
  kk_unit_t __ = kk_Unit;
  kk_string_t _x386;
  kk_string_t _x387;
  if (kk_std_core_types__is_Optional(msg)) {
    kk_box_t _box_x358 = msg._cons.Optional.value;
    kk_string_t _msg_170 = kk_string_unbox(_box_x358);
    kk_string_dup(_msg_170);
    kk_std_core_types__optional_drop(msg, _ctx);
    kk_Unit;
    _x387 = _msg_170; /*string*/
    goto _match388;
  }
  kk_define_string_literal(, _s390, 7, "elapsed")
  _x387 = kk_string_dup(_s390); /*string*/
  _match388: ;
  kk_string_t _x391;
  kk_string_t _x392;
  kk_define_string_literal(, _s393, 1, " ")
  _x392 = kk_string_dup(_s393); /*string*/
  kk_string_t _x394;
  kk_std_core_types__optional _x395 = kk_std_core_types__new_Optional(kk_integer_box(kk_integer_from_small(3)), _ctx); /*optional<106>*/
  _x394 = kk_std_time_duration_show(t, _x395, _ctx); /*string*/
  _x391 = kk_std_core__lp__plus__plus__1_rp_(_x392, _x394, _ctx); /*string*/
  _x386 = kk_std_core__lp__plus__plus__1_rp_(_x387, _x391, _ctx); /*string*/
  kk_std_core_printsln(_x386, _ctx);
  return x;
}
 
// Measure the number of fractional seconds that it takes to evaluate `action`, and print `msg` postfixed with the
// measured time in millisecond resolution.


// lift anonymous function
struct kk_std_time_timer_print_elapsed_fun396__t {
  struct kk_function_s _base;
  kk_std_core_types__optional msg;
};
static kk_box_t kk_std_time_timer_print_elapsed_fun396(kk_function_t _fself, kk_std_core_types__tuple2_ _y_321, kk_context_t* _ctx);
static kk_function_t kk_std_time_timer_new_print_elapsed_fun396(kk_std_core_types__optional msg, kk_context_t* _ctx) {
  struct kk_std_time_timer_print_elapsed_fun396__t* _self = kk_function_alloc_as(struct kk_std_time_timer_print_elapsed_fun396__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_time_timer_print_elapsed_fun396, kk_context());
  _self->msg = msg;
  return &_self->_base;
}

static kk_box_t kk_std_time_timer_print_elapsed_fun396(kk_function_t _fself, kk_std_core_types__tuple2_ _y_321, kk_context_t* _ctx) {
  struct kk_std_time_timer_print_elapsed_fun396__t* _self = kk_function_as(struct kk_std_time_timer_print_elapsed_fun396__t*, _fself);
  kk_std_core_types__optional msg = _self->msg; /* optional<string> */
  kk_drop_match(_self, {kk_std_core_types__optional_dup(msg);}, {}, _ctx)
  return kk_std_time_timer__mlift324_print_elapsed(msg, _y_321, _ctx);
}


// lift anonymous function
struct kk_std_time_timer_print_elapsed_fun397__t {
  struct kk_function_s _base;
  kk_function_t _b_367_361;
};
static kk_box_t kk_std_time_timer_print_elapsed_fun397(kk_function_t _fself, kk_box_t _b_362, kk_context_t* _ctx);
static kk_function_t kk_std_time_timer_new_print_elapsed_fun397(kk_function_t _b_367_361, kk_context_t* _ctx) {
  struct kk_std_time_timer_print_elapsed_fun397__t* _self = kk_function_alloc_as(struct kk_std_time_timer_print_elapsed_fun397__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_time_timer_print_elapsed_fun397, kk_context());
  _self->_b_367_361 = _b_367_361;
  return &_self->_base;
}

static kk_box_t kk_std_time_timer_print_elapsed_fun397(kk_function_t _fself, kk_box_t _b_362, kk_context_t* _ctx) {
  struct kk_std_time_timer_print_elapsed_fun397__t* _self = kk_function_as(struct kk_std_time_timer_print_elapsed_fun397__t*, _fself);
  kk_function_t _b_367_361 = _self->_b_367_361; /* ((std/time/duration/duration, 297)) -> <ndet,console|298> 297 */
  kk_drop_match(_self, {kk_function_dup(_b_367_361);}, {}, _ctx)
  kk_std_core_types__tuple2_ _x398 = kk_std_core_types__tuple2__unbox(_b_362, _ctx); /*(std/time/duration/duration, 297)*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_types__tuple2_, kk_context_t*), _b_367_361, (_b_367_361, _x398, _ctx));
}

kk_box_t kk_std_time_timer_print_elapsed(kk_function_t action, kk_std_core_types__optional msg, kk_context_t* _ctx) { /* forall<a,e> (action : () -> <ndet,console|e> a, msg : optional<string>) -> <ndet,console|e> a */ 
  kk_std_core_types__tuple2_ x_330 = kk_std_time_timer_elapsed(action, _ctx); /*(std/time/duration/duration, 297)*/;
  if (kk_yielding(kk_context())) {
    kk_std_core_types__tuple2__drop(x_330, _ctx);
    kk_function_t _b_367_361 = kk_std_time_timer_new_print_elapsed_fun396(msg, _ctx); /*((std/time/duration/duration, 297)) -> <ndet,console|298> 297*/;
    return kk_std_core_hnd_yield_extend(kk_std_time_timer_new_print_elapsed_fun397(_b_367_361, _ctx), _ctx);
  }
  kk_box_t _box_x363 = x_330.fst;
  kk_box_t x0 = x_330.snd;
  kk_std_time_duration__duration t = kk_std_time_duration__duration_unbox(_box_x363, NULL);
  kk_box_dup(x0);
  kk_std_core_types__tuple2__drop(x_330, _ctx);
  kk_Unit;
  kk_unit_t __ = kk_Unit;
  kk_string_t _x400;
  kk_string_t _x401;
  if (kk_std_core_types__is_Optional(msg)) {
    kk_box_t _box_x364 = msg._cons.Optional.value;
    kk_string_t _msg_170 = kk_string_unbox(_box_x364);
    kk_string_dup(_msg_170);
    kk_std_core_types__optional_drop(msg, _ctx);
    kk_Unit;
    _x401 = _msg_170; /*string*/
    goto _match402;
  }
  kk_define_string_literal(, _s404, 7, "elapsed")
  _x401 = kk_string_dup(_s404); /*string*/
  _match402: ;
  kk_string_t _x405;
  kk_string_t _x406;
  kk_define_string_literal(, _s407, 1, " ")
  _x406 = kk_string_dup(_s407); /*string*/
  kk_string_t _x408;
  kk_std_core_types__optional _x409 = kk_std_core_types__new_Optional(kk_integer_box(kk_integer_from_small(3)), _ctx); /*optional<106>*/
  _x408 = kk_std_time_duration_show(t, _x409, _ctx); /*string*/
  _x405 = kk_std_core__lp__plus__plus__1_rp_(_x406, _x408, _ctx); /*string*/
  _x400 = kk_std_core__lp__plus__plus__1_rp_(_x401, _x405, _ctx); /*string*/
  kk_std_core_printsln(_x400, _ctx);
  return x0;
}

// initialization
void kk_std_time_timer__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core__init(_ctx);
  kk_std_num_double__init(_ctx);
  kk_std_num_ddouble__init(_ctx);
  kk_std_time_timestamp__init(_ctx);
  kk_std_time_duration__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
}

// termination
void kk_std_time_timer__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_time_duration__done(_ctx);
  kk_std_time_timestamp__done(_ctx);
  kk_std_num_ddouble__done(_ctx);
  kk_std_num_double__done(_ctx);
  kk_std_core__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
