// Koka generated module: "std/os/dir", koka version: 2.2.1
#include "std_os_dir.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/

static kk_std_core__error kk_os_ensure_dir_error( kk_string_t path, kk_integer_t mode, kk_context_t* ctx ) {
  int m  = kk_integer_clamp32_borrow(mode);
  kk_integer_drop(mode, ctx);
  const int err = kk_os_ensure_dir(path,m,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_unit_box(kk_Unit),ctx);
}

static kk_std_core__error kk_os_copy_file_error( kk_string_t from, kk_string_t to, bool preserve_mtime, kk_context_t* ctx ) {
  const int err = kk_os_copy_file(from,to,preserve_mtime,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_unit_box(kk_Unit),ctx);
}

static kk_std_core__error kk_os_list_directory_prim( kk_string_t dir, kk_context_t* ctx ) {
  kk_vector_t contents;
  const int err = kk_os_list_directory(dir,&contents,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_vector_box(contents,ctx),ctx);
}


kk_std_core__exception kk_std_os_dir_prepend(kk_std_core__exception exn, kk_string_t pre, kk_context_t* _ctx) { /* (exn : exception, pre : string) -> exception */ 
  kk_string_t _x1338;
  kk_string_t _x1339;
  kk_string_t _x1340;
  kk_define_string_literal(, _s1341, 2, ": ")
  _x1340 = kk_string_dup(_s1341); /*string*/
  kk_string_t _x1342;
  kk_string_t _x = exn.message;
  kk_string_dup(_x);
  _x1342 = _x; /*string*/
  _x1339 = kk_std_core__lp__plus__plus__1_rp_(_x1340, _x1342, _ctx); /*string*/
  _x1338 = kk_std_core__lp__plus__plus__1_rp_(pre, _x1339, _ctx); /*string*/
  kk_std_core__exception_info _x1343;
  kk_std_core__exception_info _x0 = exn.info;
  kk_std_core__exception_info_dup(_x0);
  kk_std_core__exception_drop(exn, _ctx);
  kk_Unit;
  _x1343 = _x0; /*exception-info*/
  return kk_std_core__new_Exception(_x1338, _x1343, _ctx);
}

kk_std_core__error kk_std_os_dir_prim_copy_file(kk_string_t from, kk_string_t to, bool preserve_mtime, kk_context_t* _ctx) { /* (from : string, to : string, preserve-mtime : bool) -> fsys error<()> */ 
  return kk_os_copy_file_error(from,to,preserve_mtime,kk_context());
}

kk_std_core__error kk_std_os_dir_ensure_dir_err(kk_string_t path, kk_integer_t mode, kk_context_t* _ctx) { /* (path : string, mode : int) -> fsys error<()> */ 
  return kk_os_ensure_dir_error(path,mode,kk_context());
}

bool kk_std_os_dir_prim_is_dir(kk_string_t dir, kk_context_t* _ctx) { /* (dir : string) -> fsys bool */ 
  return kk_os_is_directory(dir,kk_context());
}

kk_std_core__error kk_std_os_dir_prim_list_dir(kk_string_t dir, kk_context_t* _ctx) { /* (dir : string) -> fsys error<vector<string>> */ 
  return kk_os_list_directory_prim(dir,kk_context());
}

bool kk_std_os_dir_prim_is_file(kk_string_t path, kk_context_t* _ctx) { /* (path : string) -> fsys bool */ 
  return kk_os_is_file(path,kk_context());
}
 
// Copy a file.


// lift anonymous function
struct kk_std_os_dir_copy_file_fun1345__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_fun1345(kk_function_t _fself, kk_box_t _b_1140, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun1345(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun1345, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_dir_copy_file_fun1345(kk_function_t _fself, kk_box_t _b_1140, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x1346;
  kk_std_os_path__path _x1347 = kk_std_os_path__path_unbox(_b_1140, _ctx); /*std/os/path/path*/
  _x1346 = kk_std_os_path_string(_x1347, _ctx); /*string*/
  return kk_string_box(_x1346);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_fun1351__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_fun1351(kk_function_t _fself, kk_box_t _b_1145, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun1351(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun1351, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_dir_copy_file_fun1351(kk_function_t _fself, kk_box_t _b_1145, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x1352;
  kk_std_os_path__path _x1353 = kk_std_os_path__path_unbox(_b_1145, _ctx); /*std/os/path/path*/
  _x1352 = kk_std_os_path_string(_x1353, _ctx); /*string*/
  return kk_string_box(_x1352);
}

kk_unit_t kk_std_os_dir_copy_file(kk_std_os_path__path from, kk_std_os_path__path to, kk_std_core_types__optional preserve_mtime, kk_context_t* _ctx) { /* (from : std/os/path/path, to : std/os/path/path, preserve-mtime : optional<bool>) -> <exn,fsys> () */ 
  kk_string_t _x1;
  kk_box_t _x1344;
  kk_box_t _x1348;
  kk_std_os_path__path _x1349 = kk_std_os_path__path_dup(from); /*std/os/path/path*/
  _x1348 = kk_std_os_path__path_box(_x1349, _ctx); /*3288*/
  _x1344 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_file_fun1345(_ctx), _x1348, _ctx); /*3289*/
  _x1 = kk_string_unbox(_x1344); /*string*/
  kk_string_t _x2;
  kk_box_t _x1350;
  kk_box_t _x1354;
  kk_std_os_path__path _x1355 = kk_std_os_path__path_dup(to); /*std/os/path/path*/
  _x1354 = kk_std_os_path__path_box(_x1355, _ctx); /*3288*/
  _x1350 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_file_fun1351(_ctx), _x1354, _ctx); /*3289*/
  _x2 = kk_string_unbox(_x1350); /*string*/
  kk_evv_t w = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<(<>)>*/;
  kk_std_core__error x;
  bool _x1356;
  if (kk_std_core_types__is_Optional(preserve_mtime)) {
    kk_box_t _box_x1148 = preserve_mtime._cons.Optional.value;
    bool _preserve_mtime_119 = kk_bool_unbox(_box_x1148);
    kk_std_core_types__optional_drop(preserve_mtime, _ctx);
    kk_Unit;
    _x1356 = _preserve_mtime_119; /*bool*/
    goto _match1357;
  }
  _x1356 = true; /*bool*/
  _match1357: ;
  x = kk_std_os_dir_prim_copy_file(_x1, _x2, _x1356, _ctx); /*error<()>*/
  kk_unit_t keep = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_std_core__is_Error(x)) {
    kk_std_core__exception exn = x._cons.Error.exception;
    kk_std_core__exception_dup(exn);
    kk_std_core__error_drop(x, _ctx);
    kk_Unit;
    kk_std_core__error err_995;
    kk_std_core__exception _x1359;
    kk_string_t _x20;
    kk_string_t _x1360;
    kk_define_string_literal(, _s1361, 15, "unable to copy ")
    _x1360 = kk_string_dup(_s1361); /*string*/
    kk_string_t _x1362;
    kk_string_t _x1363;
    kk_evv_t w0 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<(<>)>*/;
    kk_string_t x0;
    kk_string_t _x1364 = kk_std_os_path_string(from, _ctx); /*string*/
    x0 = kk_std_core_show_3(_x1364, _ctx); /*string*/
    kk_unit_t keep0 = kk_Unit;
    kk_evv_set(w0,kk_context());
    _x1363 = x0; /*string*/
    kk_string_t _x1365;
    kk_string_t _x1366;
    kk_define_string_literal(, _s1367, 4, " to ")
    _x1366 = kk_string_dup(_s1367); /*string*/
    kk_string_t _x1368;
    kk_evv_t w1 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<(<>)>*/;
    kk_string_t x4;
    kk_string_t _x1369 = kk_std_os_path_string(to, _ctx); /*string*/
    x4 = kk_std_core_show_3(_x1369, _ctx); /*string*/
    kk_unit_t keep1 = kk_Unit;
    kk_evv_set(w1,kk_context());
    _x1368 = x4; /*string*/
    _x1365 = kk_std_core__lp__plus__plus__1_rp_(_x1366, _x1368, _ctx); /*string*/
    _x1362 = kk_std_core__lp__plus__plus__1_rp_(_x1363, _x1365, _ctx); /*string*/
    _x20 = kk_std_core__lp__plus__plus__1_rp_(_x1360, _x1362, _ctx); /*string*/
    kk_evv_t w2 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<(<>)>*/;
    kk_std_core__exception x5;
    kk_string_t _x1370;
    kk_string_t _x1371;
    kk_string_t _x1372;
    kk_define_string_literal(, _s1373, 2, ": ")
    _x1372 = kk_string_dup(_s1373); /*string*/
    kk_string_t _x1374;
    kk_string_t _x = exn.message;
    kk_string_dup(_x);
    _x1374 = _x; /*string*/
    _x1371 = kk_std_core__lp__plus__plus__1_rp_(_x1372, _x1374, _ctx); /*string*/
    _x1370 = kk_std_core__lp__plus__plus__1_rp_(_x20, _x1371, _ctx); /*string*/
    kk_std_core__exception_info _x1375;
    kk_std_core__exception_info _x03 = exn.info;
    kk_std_core__exception_info_dup(_x03);
    kk_std_core__exception_drop(exn, _ctx);
    kk_Unit;
    _x1375 = _x03; /*exception-info*/
    x5 = kk_std_core__new_Exception(_x1370, _x1375, _ctx); /*exception*/
    kk_unit_t keep2 = kk_Unit;
    kk_evv_set(w2,kk_context());
    _x1359 = x5; /*exception*/
    err_995 = kk_std_core__new_Error(_x1359, _ctx); /*error<()>*/
    if (kk_std_core__is_Error(err_995)) {
      kk_std_core__exception exn0 = err_995._cons.Error.exception;
      kk_std_core__exception_dup(exn0);
      kk_std_core__error_drop(err_995, _ctx);
      kk_Unit;
      kk_std_core_hnd__ev ev_1077;
      kk_ssize_t _x1376 = ((kk_ssize_t)0); /*ssize_t*/
      ev_1077 = kk_evv_at(_x1376,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
      struct kk_std_core_hnd_Ev* _con1377 = kk_std_core_hnd__as_Ev(ev_1077);
      kk_std_core_hnd__marker m0 = _con1377->marker;
      kk_box_t _box_x1149 = _con1377->hnd;
      kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x1149, NULL);
      kk_std_core__hnd_exn_dup(h);
      kk_std_core_hnd__clause1 _match_1330;
      kk_std_core_hnd__clause1 _borrowApp_1331 = kk_std_core__select_throw_exn(h, _ctx); /*std/core/hnd/clause1<exception,1926,.hnd-exn,1927,1928>*/;
      kk_std_core__hnd_exn_drop(h, _ctx);
      _match_1330 = _borrowApp_1331; /*std/core/hnd/clause1<exception,1926,.hnd-exn,1927,1928>*/
      kk_function_t _fun_unbox_x1153 = _match_1330.clause;
      kk_std_core_hnd__marker _b_1154 = m0; /*std/core/hnd/marker<3573,3574>*/;
      kk_std_core_hnd__ev _b_1155 = ev_1077; /*std/core/hnd/ev<.hnd-exn>*/;
      kk_std_core__exception _b_1156 = exn0; /*exception*/;
      kk_box_t _x1379 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x1153, (_fun_unbox_x1153, _b_1154, _b_1155, kk_std_core__exception_box(_b_1156, _ctx), _ctx)); /*52*/
      kk_unit_unbox(_x1379); return kk_Unit;
    }
    kk_box_t _box_x1157 = err_995._cons.Ok.result;
    kk_unit_t x7 = kk_unit_unbox(_box_x1157);
    kk_std_core__error_drop(err_995, _ctx);
    kk_Unit;
    x7; return kk_Unit;
  }
  kk_std_os_path__path_drop(from, _ctx);
  kk_std_os_path__path_drop(to, _ctx);
  kk_std_core__error_drop(x, _ctx);
  kk_Unit; return kk_Unit;
}
 
// Ensure a directory path exists


// lift anonymous function
struct kk_std_os_dir_ensure_dir_fun1382__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_ensure_dir_fun1382(kk_function_t _fself, kk_box_t _b_1160, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_ensure_dir_fun1382(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_ensure_dir_fun1382, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_dir_ensure_dir_fun1382(kk_function_t _fself, kk_box_t _b_1160, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x1383;
  kk_std_os_path__path _x1384 = kk_std_os_path__path_unbox(_b_1160, _ctx); /*std/os/path/path*/
  _x1383 = kk_std_os_path_string(_x1384, _ctx); /*string*/
  return kk_string_box(_x1383);
}

kk_unit_t kk_std_os_dir_ensure_dir(kk_std_os_path__path dir, kk_context_t* _ctx) { /* (dir : std/os/path/path) -> <exn,fsys> () */ 
  kk_string_t _x1;
  kk_box_t _x1381;
  kk_box_t _x1385;
  kk_std_os_path__path _x1386 = kk_std_os_path__path_dup(dir); /*std/os/path/path*/
  _x1385 = kk_std_os_path__path_box(_x1386, _ctx); /*3288*/
  _x1381 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_ensure_dir_fun1382(_ctx), _x1385, _ctx); /*3289*/
  _x1 = kk_string_unbox(_x1381); /*string*/
  kk_evv_t w = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<(<>)>*/;
  kk_std_core__error x = kk_std_os_dir_ensure_dir_err(_x1, kk_integer_from_small(-1), _ctx); /*error<()>*/;
  kk_unit_t keep = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_std_core__is_Error(x)) {
    kk_std_core__exception exn = x._cons.Error.exception;
    kk_std_core__exception_dup(exn);
    kk_std_core__error_drop(x, _ctx);
    kk_Unit;
    kk_std_core__error err_998;
    kk_std_core__exception _x1387;
    kk_string_t _x20;
    kk_string_t _x1388;
    kk_define_string_literal(, _s1389, 27, "unable to create directory ")
    _x1388 = kk_string_dup(_s1389); /*string*/
    kk_string_t _x1390;
    kk_evv_t w0 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<(<>)>*/;
    kk_string_t x0;
    kk_string_t _x1391 = kk_std_os_path_string(dir, _ctx); /*string*/
    x0 = kk_std_core_show_3(_x1391, _ctx); /*string*/
    kk_unit_t keep0 = kk_Unit;
    kk_evv_set(w0,kk_context());
    _x1390 = x0; /*string*/
    _x20 = kk_std_core__lp__plus__plus__1_rp_(_x1388, _x1390, _ctx); /*string*/
    kk_evv_t w1 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<(<>)>*/;
    kk_std_core__exception x3;
    kk_string_t _x1392;
    kk_string_t _x1393;
    kk_string_t _x1394;
    kk_define_string_literal(, _s1395, 2, ": ")
    _x1394 = kk_string_dup(_s1395); /*string*/
    kk_string_t _x1396;
    kk_string_t _x = exn.message;
    kk_string_dup(_x);
    _x1396 = _x; /*string*/
    _x1393 = kk_std_core__lp__plus__plus__1_rp_(_x1394, _x1396, _ctx); /*string*/
    _x1392 = kk_std_core__lp__plus__plus__1_rp_(_x20, _x1393, _ctx); /*string*/
    kk_std_core__exception_info _x1397;
    kk_std_core__exception_info _x02 = exn.info;
    kk_std_core__exception_info_dup(_x02);
    kk_std_core__exception_drop(exn, _ctx);
    kk_Unit;
    _x1397 = _x02; /*exception-info*/
    x3 = kk_std_core__new_Exception(_x1392, _x1397, _ctx); /*exception*/
    kk_unit_t keep1 = kk_Unit;
    kk_evv_set(w1,kk_context());
    _x1387 = x3; /*exception*/
    err_998 = kk_std_core__new_Error(_x1387, _ctx); /*error<()>*/
    if (kk_std_core__is_Error(err_998)) {
      kk_std_core__exception exn0 = err_998._cons.Error.exception;
      kk_std_core__exception_dup(exn0);
      kk_std_core__error_drop(err_998, _ctx);
      kk_Unit;
      kk_std_core_hnd__ev ev_1088;
      kk_ssize_t _x1398 = ((kk_ssize_t)0); /*ssize_t*/
      ev_1088 = kk_evv_at(_x1398,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
      struct kk_std_core_hnd_Ev* _con1399 = kk_std_core_hnd__as_Ev(ev_1088);
      kk_std_core_hnd__marker m0 = _con1399->marker;
      kk_box_t _box_x1163 = _con1399->hnd;
      kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x1163, NULL);
      kk_std_core__hnd_exn_dup(h);
      kk_std_core_hnd__clause1 _match_1328;
      kk_std_core_hnd__clause1 _borrowApp_1329 = kk_std_core__select_throw_exn(h, _ctx); /*std/core/hnd/clause1<exception,1926,.hnd-exn,1927,1928>*/;
      kk_std_core__hnd_exn_drop(h, _ctx);
      _match_1328 = _borrowApp_1329; /*std/core/hnd/clause1<exception,1926,.hnd-exn,1927,1928>*/
      kk_function_t _fun_unbox_x1167 = _match_1328.clause;
      kk_std_core_hnd__marker _b_1168 = m0; /*std/core/hnd/marker<3573,3574>*/;
      kk_std_core_hnd__ev _b_1169 = ev_1088; /*std/core/hnd/ev<.hnd-exn>*/;
      kk_std_core__exception _b_1170 = exn0; /*exception*/;
      kk_box_t _x1401 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x1167, (_fun_unbox_x1167, _b_1168, _b_1169, kk_std_core__exception_box(_b_1170, _ctx), _ctx)); /*52*/
      kk_unit_unbox(_x1401); return kk_Unit;
    }
    kk_box_t _box_x1171 = err_998._cons.Ok.result;
    kk_unit_t x5 = kk_unit_unbox(_box_x1171);
    kk_std_core__error_drop(err_998, _ctx);
    kk_Unit;
    x5; return kk_Unit;
  }
  kk_box_t _box_x1172 = x._cons.Ok.result;
  kk_unit_t _pat300 = kk_unit_unbox(_box_x1172);
  kk_std_os_path__path_drop(dir, _ctx);
  kk_std_core__error_drop(x, _ctx);
  kk_Unit; return kk_Unit;
}
 
// lifted
// specialized std/core/map.5 to parameters [f]

kk_std_core__list kk_std_os_dir__ctail_lift1010_list_directory(kk_std_os_path__path dir, kk_std_core__list xs, kk_std_core_types__ctail _acc, kk_context_t* _ctx) { /* (dir : std/os/path/path, xs : list<string>, ctail<list<std/os/path/path>>) -> fsys list<std/os/path/path> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs)) {
    struct kk_std_core_Cons* _con1405 = kk_std_core__as_Cons(xs);
    kk_box_t _box_x1173 = _con1405->head;
    kk_std_core__list xx = _con1405->tail;
    kk_string_t x = kk_string_unbox(_box_x1173);
    kk_reuse_t _ru_1334 = kk_reuse_null; /*reuse*/;
    if (kk_likely(kk_std_core__list_is_unique(xs))) {
      _ru_1334 = (kk_std_core__list_reuse(xs));
    }
    else {
      kk_string_dup(x);
      kk_std_core__list_dup(xx);
      kk_Unit;
      kk_std_core__list_decref(xs, _ctx);
      kk_Unit;
    }
    kk_std_os_path__path p2_1003 = kk_std_os_path_path(x, _ctx); /*std/os/path/path*/;
    kk_std_core__list _b_1175_1174;
    kk_std_core__list _x1407;
    kk_std_core__list _x1408;
    kk_std_core__list _x0 = p2_1003.parts;
    kk_std_core__list_dup(_x0);
    kk_std_os_path__path_drop(p2_1003, _ctx);
    kk_Unit;
    _x1408 = _x0; /*list<string>*/
    _x1407 = kk_std_core__lift17186_reverse(kk_std_core__new_Nil(_ctx), _x1408, _ctx); /*list<2436>*/
    kk_std_core__list _x1409;
    kk_std_core__list _x1 = dir.parts;
    kk_std_core__list_dup(_x1);
    _x1409 = _x1; /*list<string>*/
    _b_1175_1174 = kk_std_os_path_push_parts(_x1407, _x1409, _ctx); /*list<string>*/
    kk_std_core__list _ctail_1023 = kk_std_core__list_hole(); /*list<std/os/path/path>*/;
    kk_std_core__list _ctail_1024;
    kk_box_t _x1410;
    kk_std_os_path__path _x1411;
    kk_string_t _x1412;
    kk_string_t _x = dir.root;
    kk_string_dup(_x);
    _x1412 = _x; /*string*/
    kk_std_core__list _x1413;
    kk_std_core_types__optional _match_1327 = kk_std_core_types__new_Optional(kk_std_core__list_box(_b_1175_1174, _ctx), _ctx); /*optional<106>*/;
    if (kk_std_core_types__is_Optional(_match_1327)) {
      kk_box_t _box_x1176 = _match_1327._cons.Optional.value;
      kk_std_core__list _parts_876 = kk_std_core__list_unbox(_box_x1176, NULL);
      kk_std_core__list_dup(_parts_876);
      kk_std_core_types__optional_drop(_match_1327, _ctx);
      kk_Unit;
      _x1413 = _parts_876; /*list<string>*/
      goto _match1414;
    }
    _x1413 = kk_std_core__new_Nil(_ctx); /*list<string>*/
    _match1414: ;
    _x1411 = kk_std_os_path__new_Path(_x1412, _x1413, _ctx); /*std/os/path/path*/
    _x1410 = kk_std_os_path__path_box(_x1411, _ctx); /*61*/
    _ctail_1024 = kk_std_core__new_Cons(_ru_1334, _x1410, _ctail_1023, _ctx); /*list<std/os/path/path>*/
    { // tailcall
      kk_std_core_types__ctail _x1416;
      kk_box_t* field_1093 = (kk_box_t*)((&kk_std_core__as_Cons(_ctail_1024)->tail)); /*cfield<list<std/os/path/path>>*/;
      if (kk_std_core_types__is_CTail(_acc)) {
        kk_box_t _box_x1187 = _acc._cons.CTail._field1;
        kk_box_t* last = _acc._cons.CTail._field2;
        kk_std_core__list head = kk_std_core__list_unbox(_box_x1187, NULL);
        kk_std_core__list_dup(head);
        kk_std_core_types__ctail_drop(_acc, _ctx);
        kk_Unit;
        kk_unit_t __ = kk_Unit;
        *(last) = kk_std_core__list_box(_ctail_1024, _ctx);
        kk_std_core__list _b_1201_1192 = head; /*list<std/os/path/path>*/;
        kk_box_t* _b_1202_1193 = field_1093; /*cfield<list<std/os/path/path>>*/;
        _x1416 = kk_std_core_types__new_CTail(kk_std_core__list_box(_b_1201_1192, _ctx), _b_1202_1193, _ctx); /*ctail<58>*/
        goto _match1417;
      }
      kk_std_core__list _b_1203_1194 = _ctail_1024; /*list<std/os/path/path>*/;
      kk_box_t* _b_1204_1195 = field_1093; /*cfield<list<std/os/path/path>>*/;
      _x1416 = kk_std_core_types__new_CTail(kk_std_core__list_box(_b_1203_1194, _ctx), _b_1204_1195, _ctx); /*ctail<58>*/
      _match1417: ;
      xs = xx;
      _acc = _x1416;
      goto kk__tailcall;
    }
  }
  kk_std_os_path__path_drop(dir, _ctx);
  if (kk_std_core_types__is_CTail(_acc)) {
    kk_box_t _box_x1196 = _acc._cons.CTail._field1;
    kk_box_t* last0 = _acc._cons.CTail._field2;
    kk_std_core__list head0 = kk_std_core__list_unbox(_box_x1196, NULL);
    kk_std_core__list_dup(head0);
    kk_std_core_types__ctail_drop(_acc, _ctx);
    kk_Unit;
    kk_unit_t __0 = kk_Unit;
    *(last0) = kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx);
    return head0;
  }
  return kk_std_core__new_Nil(_ctx);
}
 
// lifted
// specialized std/core/map.5 to parameters [f]

kk_std_core__list kk_std_os_dir__lift1010_list_directory(kk_std_os_path__path dir0, kk_std_core__list xs0, kk_context_t* _ctx) { /* (dir : std/os/path/path, xs : list<string>) -> fsys list<std/os/path/path> */ 
  return kk_std_os_dir__ctail_lift1010_list_directory(dir0, xs0, kk_std_core_types__new_CTailNil(_ctx), _ctx);
}
 
// List directory contents (excluding `.` and `..`).
// Returns a list of full paths (not just the names in the directory).

kk_std_core__list kk_std_os_dir_list_directory(kk_std_os_path__path dir, kk_context_t* _ctx) { /* (dir : std/os/path/path) -> fsys list<std/os/path/path> */ 
  kk_std_core__error _match_1326;
  kk_string_t _x1420;
  kk_std_os_path__path _x1421 = kk_std_os_path__path_dup(dir); /*std/os/path/path*/
  _x1420 = kk_std_os_path_string(_x1421, _ctx); /*string*/
  _match_1326 = kk_std_os_dir_prim_list_dir(_x1420, _ctx); /*error<vector<string>>*/
  if (kk_std_core__is_Error(_match_1326)) {
    kk_std_core__exception _pat0 = _match_1326._cons.Error.exception;
    kk_std_core__error_drop(_match_1326, _ctx);
    kk_std_os_path__path_drop(dir, _ctx);
    return kk_std_core__new_Nil(_ctx);
  }
  kk_box_t _box_x1205 = _match_1326._cons.Ok.result;
  kk_vector_t contents = kk_vector_unbox(_box_x1205, NULL);
  kk_vector_dup(contents);
  kk_std_core__error_drop(_match_1326, _ctx);
  kk_Unit;
  kk_std_core__list xs = kk_std_core_vlist(contents, kk_std_core_types__new_None(_ctx), _ctx); /*list<string>*/;
  return kk_std_os_dir__lift1010_list_directory(dir, xs, _ctx);
}
 
// monadic lift

kk_unit_t kk_std_os_dir__mlift1061_op(kk_std_os_path__path to, kk_std_core__list xx, kk_unit_t wild__0, kk_context_t* _ctx) { /* (to : std/os/path/path, xx : list<std/os/path/path>, wild_0 : ()) -> <exn,fsys> () */ 
  kk_std_os_dir__lift1011_copy_directory(to, xx, _ctx); return kk_Unit;
}
 
// monadic lift

kk_unit_t kk_std_os_dir__mlift1062_op(kk_std_os_path__path to0, kk_std_core__list xx0, kk_unit_t wild__1, kk_context_t* _ctx) { /* (to : std/os/path/path, xx0 : list<std/os/path/path>, wild_1 : ()) -> <fsys,pure> () */ 
  kk_std_os_dir__lift1012_copy_directory(to0, xx0, _ctx); return kk_Unit;
}
 
// monadic lift

kk_unit_t kk_std_os_dir__mlift1063_copy_directory(kk_std_core__list dirs, kk_std_os_path__path to1, kk_unit_t wild__00, kk_context_t* _ctx) { /* (dirs : list<std/os/path/path>, to : std/os/path/path, wild_00 : ()) -> <exn,fsys,div> () */ 
  kk_std_os_dir__lift1012_copy_directory(to1, dirs, _ctx); return kk_Unit;
}
 
// monadic lift


// lift anonymous function
struct kk_std_os_dir__mlift1064_copy_directory_fun1426__t {
  struct kk_function_s _base;
  kk_std_core__list dirs0;
  kk_std_os_path__path to2;
};
static kk_unit_t kk_std_os_dir__mlift1064_copy_directory_fun1426(kk_function_t _fself, kk_unit_t wild__000, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift1064_copy_directory_fun1426(kk_std_core__list dirs0, kk_std_os_path__path to2, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1064_copy_directory_fun1426__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift1064_copy_directory_fun1426__t, 4, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir__mlift1064_copy_directory_fun1426, kk_context());
  _self->dirs0 = dirs0;
  _self->to2 = to2;
  return &_self->_base;
}

static kk_unit_t kk_std_os_dir__mlift1064_copy_directory_fun1426(kk_function_t _fself, kk_unit_t wild__000, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1064_copy_directory_fun1426__t* _self = kk_function_as(struct kk_std_os_dir__mlift1064_copy_directory_fun1426__t*, _fself);
  kk_std_core__list dirs0 = _self->dirs0; /* list<std/os/path/path> */
  kk_std_os_path__path to2 = _self->to2; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_core__list_dup(dirs0);kk_std_os_path__path_dup(to2);}, {}, _ctx)
  return kk_std_os_dir__mlift1063_copy_directory(dirs0, to2, wild__000, _ctx);
}


// lift anonymous function
struct kk_std_os_dir__mlift1064_copy_directory_fun1428__t {
  struct kk_function_s _base;
  kk_function_t _b_1210_1208;
};
static kk_box_t kk_std_os_dir__mlift1064_copy_directory_fun1428(kk_function_t _fself, kk_box_t _b_1209, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift1064_copy_directory_fun1428(kk_function_t _b_1210_1208, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1064_copy_directory_fun1428__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift1064_copy_directory_fun1428__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir__mlift1064_copy_directory_fun1428, kk_context());
  _self->_b_1210_1208 = _b_1210_1208;
  return &_self->_base;
}

static kk_box_t kk_std_os_dir__mlift1064_copy_directory_fun1428(kk_function_t _fself, kk_box_t _b_1209, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1064_copy_directory_fun1428__t* _self = kk_function_as(struct kk_std_os_dir__mlift1064_copy_directory_fun1428__t*, _fself);
  kk_function_t _b_1210_1208 = _self->_b_1210_1208; /* (wild_000 : ()) -> <exn,fsys,div> () */
  kk_drop_match(_self, {kk_function_dup(_b_1210_1208);}, {}, _ctx)
  kk_unit_t _x1429 = kk_Unit;
  kk_unit_t _x1430 = kk_Unit;
  kk_unit_unbox(_b_1209);
  kk_function_call(kk_unit_t, (kk_function_t, kk_unit_t, kk_context_t*), _b_1210_1208, (_b_1210_1208, _x1430, _ctx));
  return kk_unit_box(_x1429);
}

kk_unit_t kk_std_os_dir__mlift1064_copy_directory(kk_std_os_path__path to2, kk_std_core_types__tuple2_ _y_1038, kk_context_t* _ctx) { /* (to : std/os/path/path, (list<std/os/path/path>, list<std/os/path/path>)) -> <fsys,div,exn> () */ 
  kk_box_t _box_x1206 = _y_1038.fst;
  kk_box_t _box_x1207 = _y_1038.snd;
  kk_std_core__list dirs0 = kk_std_core__list_unbox(_box_x1206, NULL);
  kk_std_core__list files = kk_std_core__list_unbox(_box_x1207, NULL);
  kk_std_core__list_dup(dirs0);
  kk_std_core__list_dup(files);
  kk_std_core_types__tuple2__drop(_y_1038, _ctx);
  kk_Unit;
  kk_unit_t x_1096 = kk_Unit;
  kk_std_os_path__path _x1425 = kk_std_os_path__path_dup(to2); /*std/os/path/path*/
  kk_std_os_dir__lift1011_copy_directory(_x1425, files, _ctx);
  if (kk_yielding(kk_context())) {
    kk_function_t _b_1210_1208 = kk_std_os_dir__new_mlift1064_copy_directory_fun1426(dirs0, to2, _ctx); /*(wild_000 : ()) -> <exn,fsys,div> ()*/;
    kk_box_t _x1427 = kk_std_core_hnd_yield_extend(kk_std_os_dir__new_mlift1064_copy_directory_fun1428(_b_1210_1208, _ctx), _ctx); /*3858*/
    kk_unit_unbox(_x1427); return kk_Unit;
  }
  kk_std_os_dir__mlift1063_copy_directory(dirs0, to2, x_1096, _ctx); return kk_Unit;
}
 
// monadic lift


// lift anonymous function
struct kk_std_os_dir__mlift1065_copy_directory_fun1432__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir__mlift1065_copy_directory_fun1432(kk_function_t _fself, kk_box_t _b_1213, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift1065_copy_directory_fun1432(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift1065_copy_directory_fun1432, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_dir__mlift1065_copy_directory_fun1432(kk_function_t _fself, kk_box_t _b_1213, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_std_core__list _x1433;
  kk_std_os_path__path _x1434 = kk_std_os_path__path_unbox(_b_1213, _ctx); /*std/os/path/path*/
  _x1433 = kk_std_os_dir_list_directory(_x1434, _ctx); /*list<std/os/path/path>*/
  return kk_std_core__list_box(_x1433, _ctx);
}


// lift anonymous function
struct kk_std_os_dir__mlift1065_copy_directory_fun1435__t {
  struct kk_function_s _base;
};
static bool kk_std_os_dir__mlift1065_copy_directory_fun1435(kk_function_t _fself, kk_box_t _b_1223, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift1065_copy_directory_fun1435(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift1065_copy_directory_fun1435, _ctx)
  return kk_function_dup(_fself);
}



// lift anonymous function
struct kk_std_os_dir__mlift1065_copy_directory_fun1437__t {
  struct kk_function_s _base;
};
static bool kk_std_os_dir__mlift1065_copy_directory_fun1437(kk_function_t _fself, kk_std_os_path__path _x11436, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift1065_copy_directory_fun1437(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift1065_copy_directory_fun1437, _ctx)
  return kk_function_dup(_fself);
}

static bool kk_std_os_dir__mlift1065_copy_directory_fun1437(kk_function_t _fself, kk_std_os_path__path _x11436, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_os_dir_is_directory(_x11436, _ctx);
}


// lift anonymous function
struct kk_std_os_dir__mlift1065_copy_directory_fun1439__t {
  struct kk_function_s _base;
  kk_function_t _b_1228_1216;
};
static kk_box_t kk_std_os_dir__mlift1065_copy_directory_fun1439(kk_function_t _fself, kk_box_t _b_1218, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift1065_copy_directory_fun1439(kk_function_t _b_1228_1216, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1065_copy_directory_fun1439__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift1065_copy_directory_fun1439__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir__mlift1065_copy_directory_fun1439, kk_context());
  _self->_b_1228_1216 = _b_1228_1216;
  return &_self->_base;
}

static kk_box_t kk_std_os_dir__mlift1065_copy_directory_fun1439(kk_function_t _fself, kk_box_t _b_1218, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1065_copy_directory_fun1439__t* _self = kk_function_as(struct kk_std_os_dir__mlift1065_copy_directory_fun1439__t*, _fself);
  kk_function_t _b_1228_1216 = _self->_b_1228_1216; /* (dir : std/os/path/path) -> fsys bool */
  kk_drop_match(_self, {kk_function_dup(_b_1228_1216);}, {}, _ctx)
  bool _x1440;
  kk_std_os_path__path _x1441 = kk_std_os_path__path_unbox(_b_1218, _ctx); /*std/os/path/path*/
  _x1440 = kk_function_call(bool, (kk_function_t, kk_std_os_path__path, kk_context_t*), _b_1228_1216, (_b_1228_1216, _x1441, _ctx)); /*bool*/
  return kk_bool_box(_x1440);
}
static bool kk_std_os_dir__mlift1065_copy_directory_fun1435(kk_function_t _fself, kk_box_t _b_1223, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_std_os_path__path _x10_1232 = kk_std_os_path__path_unbox(_b_1223, _ctx); /*std/os/path/path*/;
  kk_function_t _b_1228_1216 = kk_std_os_dir__new_mlift1065_copy_directory_fun1437(_ctx); /*(dir : std/os/path/path) -> fsys bool*/;
  kk_std_os_path__path _b_1229_1217 = _x10_1232; /*std/os/path/path*/;
  kk_box_t _x1438 = kk_std_core_hnd__open_none1(kk_std_os_dir__new_mlift1065_copy_directory_fun1439(_b_1228_1216, _ctx), kk_std_os_path__path_box(_b_1229_1217, _ctx), _ctx); /*3289*/
  return kk_bool_unbox(_x1438);
}


// lift anonymous function
struct kk_std_os_dir__mlift1065_copy_directory_fun1442__t {
  struct kk_function_s _base;
  kk_std_os_path__path to3;
};
static kk_unit_t kk_std_os_dir__mlift1065_copy_directory_fun1442(kk_function_t _fself, kk_std_core_types__tuple2_ _y_10380, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift1065_copy_directory_fun1442(kk_std_os_path__path to3, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1065_copy_directory_fun1442__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift1065_copy_directory_fun1442__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir__mlift1065_copy_directory_fun1442, kk_context());
  _self->to3 = to3;
  return &_self->_base;
}

static kk_unit_t kk_std_os_dir__mlift1065_copy_directory_fun1442(kk_function_t _fself, kk_std_core_types__tuple2_ _y_10380, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1065_copy_directory_fun1442__t* _self = kk_function_as(struct kk_std_os_dir__mlift1065_copy_directory_fun1442__t*, _fself);
  kk_std_os_path__path to3 = _self->to3; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to3);}, {}, _ctx)
  return kk_std_os_dir__mlift1064_copy_directory(to3, _y_10380, _ctx);
}


// lift anonymous function
struct kk_std_os_dir__mlift1065_copy_directory_fun1444__t {
  struct kk_function_s _base;
  kk_function_t _b_1233_1230;
};
static kk_box_t kk_std_os_dir__mlift1065_copy_directory_fun1444(kk_function_t _fself, kk_box_t _b_1231, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift1065_copy_directory_fun1444(kk_function_t _b_1233_1230, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1065_copy_directory_fun1444__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift1065_copy_directory_fun1444__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir__mlift1065_copy_directory_fun1444, kk_context());
  _self->_b_1233_1230 = _b_1233_1230;
  return &_self->_base;
}

static kk_box_t kk_std_os_dir__mlift1065_copy_directory_fun1444(kk_function_t _fself, kk_box_t _b_1231, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1065_copy_directory_fun1444__t* _self = kk_function_as(struct kk_std_os_dir__mlift1065_copy_directory_fun1444__t*, _fself);
  kk_function_t _b_1233_1230 = _self->_b_1233_1230; /* ((list<std/os/path/path>, list<std/os/path/path>)) -> <fsys,div,exn> () */
  kk_drop_match(_self, {kk_function_dup(_b_1233_1230);}, {}, _ctx)
  kk_unit_t _x1445 = kk_Unit;
  kk_std_core_types__tuple2_ _x1446 = kk_std_core_types__tuple2__unbox(_b_1231, _ctx); /*(list<std/os/path/path>, list<std/os/path/path>)*/
  kk_function_call(kk_unit_t, (kk_function_t, kk_std_core_types__tuple2_, kk_context_t*), _b_1233_1230, (_b_1233_1230, _x1446, _ctx));
  return kk_unit_box(_x1445);
}

kk_unit_t kk_std_os_dir__mlift1065_copy_directory(kk_std_os_path__path dir, kk_std_os_path__path to3, kk_unit_t wild__, kk_context_t* _ctx) { /* (dir : std/os/path/path, to : std/os/path/path, wild_ : ()) -> <exn,fsys> () */ 
  kk_std_core__list all;
  kk_box_t _x1431 = kk_std_core_hnd__open_none1(kk_std_os_dir__new_mlift1065_copy_directory_fun1432(_ctx), kk_std_os_path__path_box(dir, _ctx), _ctx); /*3289*/
  all = kk_std_core__list_unbox(_x1431, _ctx); /*list<std/os/path/path>*/
  kk_std_core_types__tuple2_ x0_1098 = kk_std_core_partition_acc(all, kk_std_os_dir__new_mlift1065_copy_directory_fun1435(_ctx), kk_std_core__new_Nil(_ctx), kk_std_core__new_Nil(_ctx), _ctx); /*(list<std/os/path/path>, list<std/os/path/path>)*/;
  if (kk_yielding(kk_context())) {
    kk_std_core_types__tuple2__drop(x0_1098, _ctx);
    kk_function_t _b_1233_1230 = kk_std_os_dir__new_mlift1065_copy_directory_fun1442(to3, _ctx); /*((list<std/os/path/path>, list<std/os/path/path>)) -> <fsys,div,exn> ()*/;
    kk_box_t _x1443 = kk_std_core_hnd_yield_extend(kk_std_os_dir__new_mlift1065_copy_directory_fun1444(_b_1233_1230, _ctx), _ctx); /*3858*/
    kk_unit_unbox(_x1443); return kk_Unit;
  }
  kk_std_os_dir__mlift1064_copy_directory(to3, x0_1098, _ctx); return kk_Unit;
}
 
// lifted
// specialized std/core/foreach to parameters [action]


// lift anonymous function
struct kk_std_os_dir__lift1011_copy_directory_fun1461__t {
  struct kk_function_s _base;
  kk_std_os_path__path to4;
  kk_std_core__list xx1;
};
static kk_unit_t kk_std_os_dir__lift1011_copy_directory_fun1461(kk_function_t _fself, kk_unit_t wild__01, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_lift1011_copy_directory_fun1461(kk_std_os_path__path to4, kk_std_core__list xx1, kk_context_t* _ctx) {
  struct kk_std_os_dir__lift1011_copy_directory_fun1461__t* _self = kk_function_alloc_as(struct kk_std_os_dir__lift1011_copy_directory_fun1461__t, 4, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir__lift1011_copy_directory_fun1461, kk_context());
  _self->to4 = to4;
  _self->xx1 = xx1;
  return &_self->_base;
}

static kk_unit_t kk_std_os_dir__lift1011_copy_directory_fun1461(kk_function_t _fself, kk_unit_t wild__01, kk_context_t* _ctx) {
  struct kk_std_os_dir__lift1011_copy_directory_fun1461__t* _self = kk_function_as(struct kk_std_os_dir__lift1011_copy_directory_fun1461__t*, _fself);
  kk_std_os_path__path to4 = _self->to4; /* std/os/path/path */
  kk_std_core__list xx1 = _self->xx1; /* list<std/os/path/path> */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to4);kk_std_core__list_dup(xx1);}, {}, _ctx)
  return kk_std_os_dir__mlift1061_op(to4, xx1, wild__01, _ctx);
}


// lift anonymous function
struct kk_std_os_dir__lift1011_copy_directory_fun1463__t {
  struct kk_function_s _base;
  kk_function_t _b_1243_1241;
};
static kk_box_t kk_std_os_dir__lift1011_copy_directory_fun1463(kk_function_t _fself, kk_box_t _b_1242, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_lift1011_copy_directory_fun1463(kk_function_t _b_1243_1241, kk_context_t* _ctx) {
  struct kk_std_os_dir__lift1011_copy_directory_fun1463__t* _self = kk_function_alloc_as(struct kk_std_os_dir__lift1011_copy_directory_fun1463__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir__lift1011_copy_directory_fun1463, kk_context());
  _self->_b_1243_1241 = _b_1243_1241;
  return &_self->_base;
}

static kk_box_t kk_std_os_dir__lift1011_copy_directory_fun1463(kk_function_t _fself, kk_box_t _b_1242, kk_context_t* _ctx) {
  struct kk_std_os_dir__lift1011_copy_directory_fun1463__t* _self = kk_function_as(struct kk_std_os_dir__lift1011_copy_directory_fun1463__t*, _fself);
  kk_function_t _b_1243_1241 = _self->_b_1243_1241; /* (wild_01 : ()) -> <exn,fsys> () */
  kk_drop_match(_self, {kk_function_dup(_b_1243_1241);}, {}, _ctx)
  kk_unit_t _x1464 = kk_Unit;
  kk_unit_t _x1465 = kk_Unit;
  kk_unit_unbox(_b_1242);
  kk_function_call(kk_unit_t, (kk_function_t, kk_unit_t, kk_context_t*), _b_1243_1241, (_b_1243_1241, _x1465, _ctx));
  return kk_unit_box(_x1464);
}

kk_unit_t kk_std_os_dir__lift1011_copy_directory(kk_std_os_path__path to4, kk_std_core__list xs, kk_context_t* _ctx) { /* (to : std/os/path/path, xs : list<std/os/path/path>) -> <exn,fsys,div> () */ 
  kk__tailcall: ;
  if (kk_std_core__is_Nil(xs)) {
    kk_std_os_path__path_drop(to4, _ctx);
    kk_Unit; return kk_Unit;
  }
  struct kk_std_core_Cons* _con1447 = kk_std_core__as_Cons(xs);
  kk_box_t _box_x1234 = _con1447->head;
  kk_std_core__list xx1 = _con1447->tail;
  kk_std_os_path__path x1 = kk_std_os_path__path_unbox(_box_x1234, NULL);
  if (kk_likely(kk_std_core__list_is_unique(xs))) {
    kk_std_os_path__path_dup(x1);
    kk_box_drop(_box_x1234, _ctx);
    kk_Unit;
    kk_Unit;
    kk_std_core__list_free(xs);
  }
  else {
    kk_std_os_path__path_dup(x1);
    kk_std_core__list_dup(xx1);
    kk_Unit;
    kk_std_core__list_decref(xs, _ctx);
    kk_Unit;
  }
  kk_unit_t x2_1100 = kk_Unit;
  kk_std_os_path__path _x1449 = kk_std_os_path__path_dup(x1); /*std/os/path/path*/
  kk_std_os_path__path _x1450;
  kk_evv_t w = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<(<>)>*/;
  kk_std_core__list _b_1236_1235;
  kk_std_core__list _x1451;
  kk_std_core__list _x100 = x1.parts;
  kk_std_core__list_dup(_x100);
  _x1451 = _x100; /*list<string>*/
  _b_1236_1235 = kk_std_core_take(_x1451, kk_integer_from_small(1), _ctx); /*list<string>*/
  kk_unit_t keep = kk_Unit;
  kk_evv_set(w,kk_context());
  kk_evv_t w0 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<(<>)>*/;
  kk_std_core__list _b_1239_1238;
  kk_std_core__list _x1452;
  kk_std_core__list _x1453;
  kk_std_core_types__optional _match_1323 = kk_std_core_types__new_Optional(kk_std_core__list_box(_b_1236_1235, _ctx), _ctx); /*optional<106>*/;
  if (kk_std_core_types__is_Optional(_match_1323)) {
    kk_box_t _box_x1237 = _match_1323._cons.Optional.value;
    kk_std_core__list _parts_111 = kk_std_core__list_unbox(_box_x1237, NULL);
    kk_std_os_path__path_drop(x1, _ctx);
    kk_std_core__list_dup(_parts_111);
    kk_std_core_types__optional_drop(_match_1323, _ctx);
    kk_Unit;
    _x1453 = _parts_111; /*list<string>*/
    goto _match1454;
  }
  kk_std_core__list _x000 = x1.parts;
  kk_std_core__list_dup(_x000);
  kk_std_os_path__path_drop(x1, _ctx);
  kk_Unit;
  _x1453 = _x000; /*list<string>*/
  _match1454: ;
  _x1452 = kk_std_core__lift17186_reverse(kk_std_core__new_Nil(_ctx), _x1453, _ctx); /*list<2436>*/
  kk_std_core__list _x1456;
  kk_std_core__list _x101 = to4.parts;
  kk_std_core__list_dup(_x101);
  _x1456 = _x101; /*list<string>*/
  _b_1239_1238 = kk_std_os_path_push_parts(_x1452, _x1456, _ctx); /*list<string>*/
  kk_unit_t keep0 = kk_Unit;
  kk_evv_set(w0,kk_context());
  kk_string_t _x1457;
  kk_string_t _x = to4.root;
  kk_string_dup(_x);
  _x1457 = _x; /*string*/
  kk_std_core__list _x1458;
  kk_std_core_types__optional _match_1322 = kk_std_core_types__new_Optional(kk_std_core__list_box(_b_1239_1238, _ctx), _ctx); /*optional<106>*/;
  if (kk_std_core_types__is_Optional(_match_1322)) {
    kk_box_t _box_x1240 = _match_1322._cons.Optional.value;
    kk_std_core__list _parts_876 = kk_std_core__list_unbox(_box_x1240, NULL);
    kk_std_core__list_dup(_parts_876);
    kk_std_core_types__optional_drop(_match_1322, _ctx);
    kk_Unit;
    _x1458 = _parts_876; /*list<string>*/
    goto _match1459;
  }
  _x1458 = kk_std_core__new_Nil(_ctx); /*list<string>*/
  _match1459: ;
  _x1450 = kk_std_os_path__new_Path(_x1457, _x1458, _ctx); /*std/os/path/path*/
  kk_std_os_dir_copy_file(_x1449, _x1450, kk_std_core_types__new_None(_ctx), _ctx);
  if (kk_yielding(kk_context())) {
    kk_function_t _b_1243_1241 = kk_std_os_dir__new_lift1011_copy_directory_fun1461(to4, xx1, _ctx); /*(wild_01 : ()) -> <exn,fsys> ()*/;
    kk_box_t _x1462 = kk_std_core_hnd_yield_extend(kk_std_os_dir__new_lift1011_copy_directory_fun1463(_b_1243_1241, _ctx), _ctx); /*3858*/
    kk_unit_unbox(_x1462); return kk_Unit;
  }
  { // tailcall
    xs = xx1;
    goto kk__tailcall;
  }
}
 
// lifted
// specialized std/core/foreach to parameters [action]


// lift anonymous function
struct kk_std_os_dir__lift1012_copy_directory_fun1480__t {
  struct kk_function_s _base;
  kk_std_os_path__path to5;
  kk_std_core__list xx00;
};
static kk_unit_t kk_std_os_dir__lift1012_copy_directory_fun1480(kk_function_t _fself, kk_unit_t wild__10, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_lift1012_copy_directory_fun1480(kk_std_os_path__path to5, kk_std_core__list xx00, kk_context_t* _ctx) {
  struct kk_std_os_dir__lift1012_copy_directory_fun1480__t* _self = kk_function_alloc_as(struct kk_std_os_dir__lift1012_copy_directory_fun1480__t, 4, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir__lift1012_copy_directory_fun1480, kk_context());
  _self->to5 = to5;
  _self->xx00 = xx00;
  return &_self->_base;
}

static kk_unit_t kk_std_os_dir__lift1012_copy_directory_fun1480(kk_function_t _fself, kk_unit_t wild__10, kk_context_t* _ctx) {
  struct kk_std_os_dir__lift1012_copy_directory_fun1480__t* _self = kk_function_as(struct kk_std_os_dir__lift1012_copy_directory_fun1480__t*, _fself);
  kk_std_os_path__path to5 = _self->to5; /* std/os/path/path */
  kk_std_core__list xx00 = _self->xx00; /* list<std/os/path/path> */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to5);kk_std_core__list_dup(xx00);}, {}, _ctx)
  return kk_std_os_dir__mlift1062_op(to5, xx00, wild__10, _ctx);
}


// lift anonymous function
struct kk_std_os_dir__lift1012_copy_directory_fun1482__t {
  struct kk_function_s _base;
  kk_function_t _b_1253_1251;
};
static kk_box_t kk_std_os_dir__lift1012_copy_directory_fun1482(kk_function_t _fself, kk_box_t _b_1252, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_lift1012_copy_directory_fun1482(kk_function_t _b_1253_1251, kk_context_t* _ctx) {
  struct kk_std_os_dir__lift1012_copy_directory_fun1482__t* _self = kk_function_alloc_as(struct kk_std_os_dir__lift1012_copy_directory_fun1482__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir__lift1012_copy_directory_fun1482, kk_context());
  _self->_b_1253_1251 = _b_1253_1251;
  return &_self->_base;
}

static kk_box_t kk_std_os_dir__lift1012_copy_directory_fun1482(kk_function_t _fself, kk_box_t _b_1252, kk_context_t* _ctx) {
  struct kk_std_os_dir__lift1012_copy_directory_fun1482__t* _self = kk_function_as(struct kk_std_os_dir__lift1012_copy_directory_fun1482__t*, _fself);
  kk_function_t _b_1253_1251 = _self->_b_1253_1251; /* (wild_10 : ()) -> <fsys,pure> () */
  kk_drop_match(_self, {kk_function_dup(_b_1253_1251);}, {}, _ctx)
  kk_unit_t _x1483 = kk_Unit;
  kk_unit_t _x1484 = kk_Unit;
  kk_unit_unbox(_b_1252);
  kk_function_call(kk_unit_t, (kk_function_t, kk_unit_t, kk_context_t*), _b_1253_1251, (_b_1253_1251, _x1484, _ctx));
  return kk_unit_box(_x1483);
}

kk_unit_t kk_std_os_dir__lift1012_copy_directory(kk_std_os_path__path to5, kk_std_core__list xs0, kk_context_t* _ctx) { /* (to : std/os/path/path, xs0 : list<std/os/path/path>) -> <div,exn,fsys> () */ 
  kk__tailcall: ;
  if (kk_std_core__is_Nil(xs0)) {
    kk_std_os_path__path_drop(to5, _ctx);
    kk_Unit; return kk_Unit;
  }
  struct kk_std_core_Cons* _con1466 = kk_std_core__as_Cons(xs0);
  kk_box_t _box_x1244 = _con1466->head;
  kk_std_core__list xx00 = _con1466->tail;
  kk_std_os_path__path x00 = kk_std_os_path__path_unbox(_box_x1244, NULL);
  if (kk_likely(kk_std_core__list_is_unique(xs0))) {
    kk_std_os_path__path_dup(x00);
    kk_box_drop(_box_x1244, _ctx);
    kk_Unit;
    kk_Unit;
    kk_std_core__list_free(xs0);
  }
  else {
    kk_std_os_path__path_dup(x00);
    kk_std_core__list_dup(xx00);
    kk_Unit;
    kk_std_core__list_decref(xs0, _ctx);
    kk_Unit;
  }
  kk_unit_t x5_1108 = kk_Unit;
  kk_std_os_path__path _x1468 = kk_std_os_path__path_dup(x00); /*std/os/path/path*/
  kk_std_os_path__path _x1469;
  kk_evv_t w1 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<(<>)>*/;
  kk_std_core__list _b_1246_1245;
  kk_std_core__list _x1470;
  kk_std_core__list _x12 = x00.parts;
  kk_std_core__list_dup(_x12);
  _x1470 = _x12; /*list<string>*/
  _b_1246_1245 = kk_std_core_take(_x1470, kk_integer_from_small(1), _ctx); /*list<string>*/
  kk_unit_t keep1 = kk_Unit;
  kk_evv_set(w1,kk_context());
  kk_evv_t w2 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<(<>)>*/;
  kk_std_core__list _b_1249_1248;
  kk_std_core__list _x1471;
  kk_std_core__list _x1472;
  kk_std_core_types__optional _match_1320 = kk_std_core_types__new_Optional(kk_std_core__list_box(_b_1246_1245, _ctx), _ctx); /*optional<106>*/;
  if (kk_std_core_types__is_Optional(_match_1320)) {
    kk_box_t _box_x1247 = _match_1320._cons.Optional.value;
    kk_std_core__list _parts_1110 = kk_std_core__list_unbox(_box_x1247, NULL);
    kk_std_os_path__path_drop(x00, _ctx);
    kk_std_core__list_dup(_parts_1110);
    kk_std_core_types__optional_drop(_match_1320, _ctx);
    kk_Unit;
    _x1472 = _parts_1110; /*list<string>*/
    goto _match1473;
  }
  kk_std_core__list _x02 = x00.parts;
  kk_std_core__list_dup(_x02);
  kk_std_os_path__path_drop(x00, _ctx);
  kk_Unit;
  _x1472 = _x02; /*list<string>*/
  _match1473: ;
  _x1471 = kk_std_core__lift17186_reverse(kk_std_core__new_Nil(_ctx), _x1472, _ctx); /*list<2436>*/
  kk_std_core__list _x1475;
  kk_std_core__list _x11 = to5.parts;
  kk_std_core__list_dup(_x11);
  _x1475 = _x11; /*list<string>*/
  _b_1249_1248 = kk_std_os_path_push_parts(_x1471, _x1475, _ctx); /*list<string>*/
  kk_unit_t keep2 = kk_Unit;
  kk_evv_set(w2,kk_context());
  kk_string_t _x1476;
  kk_string_t _x200 = to5.root;
  kk_string_dup(_x200);
  _x1476 = _x200; /*string*/
  kk_std_core__list _x1477;
  kk_std_core_types__optional _match_1319 = kk_std_core_types__new_Optional(kk_std_core__list_box(_b_1249_1248, _ctx), _ctx); /*optional<106>*/;
  if (kk_std_core_types__is_Optional(_match_1319)) {
    kk_box_t _box_x1250 = _match_1319._cons.Optional.value;
    kk_std_core__list _parts_8760 = kk_std_core__list_unbox(_box_x1250, NULL);
    kk_std_core__list_dup(_parts_8760);
    kk_std_core_types__optional_drop(_match_1319, _ctx);
    kk_Unit;
    _x1477 = _parts_8760; /*list<string>*/
    goto _match1478;
  }
  _x1477 = kk_std_core__new_Nil(_ctx); /*list<string>*/
  _match1478: ;
  _x1469 = kk_std_os_path__new_Path(_x1476, _x1477, _ctx); /*std/os/path/path*/
  kk_std_os_dir_copy_directory(_x1468, _x1469, _ctx);
  if (kk_yielding(kk_context())) {
    kk_function_t _b_1253_1251 = kk_std_os_dir__new_lift1012_copy_directory_fun1480(to5, xx00, _ctx); /*(wild_10 : ()) -> <fsys,pure> ()*/;
    kk_box_t _x1481 = kk_std_core_hnd_yield_extend(kk_std_os_dir__new_lift1012_copy_directory_fun1482(_b_1253_1251, _ctx), _ctx); /*3858*/
    kk_unit_unbox(_x1481); return kk_Unit;
  }
  { // tailcall
    xs0 = xx00;
    goto kk__tailcall;
  }
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1486__t {
  struct kk_function_s _base;
  kk_std_os_path__path dir0;
  kk_std_os_path__path to6;
};
static kk_unit_t kk_std_os_dir_copy_directory_fun1486(kk_function_t _fself, kk_unit_t wild__2, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1486(kk_std_os_path__path dir0, kk_std_os_path__path to6, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1486__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun1486__t, 5, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir_copy_directory_fun1486, kk_context());
  _self->dir0 = dir0;
  _self->to6 = to6;
  return &_self->_base;
}

static kk_unit_t kk_std_os_dir_copy_directory_fun1486(kk_function_t _fself, kk_unit_t wild__2, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1486__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun1486__t*, _fself);
  kk_std_os_path__path dir0 = _self->dir0; /* std/os/path/path */
  kk_std_os_path__path to6 = _self->to6; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(dir0);kk_std_os_path__path_dup(to6);}, {}, _ctx)
  return kk_std_os_dir__mlift1065_copy_directory(dir0, to6, wild__2, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1488__t {
  struct kk_function_s _base;
  kk_function_t _b_1281_1254;
};
static kk_box_t kk_std_os_dir_copy_directory_fun1488(kk_function_t _fself, kk_box_t _b_1255, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1488(kk_function_t _b_1281_1254, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1488__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun1488__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir_copy_directory_fun1488, kk_context());
  _self->_b_1281_1254 = _b_1281_1254;
  return &_self->_base;
}

static kk_box_t kk_std_os_dir_copy_directory_fun1488(kk_function_t _fself, kk_box_t _b_1255, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1488__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun1488__t*, _fself);
  kk_function_t _b_1281_1254 = _self->_b_1281_1254; /* (wild_2 : ()) -> <exn,fsys> () */
  kk_drop_match(_self, {kk_function_dup(_b_1281_1254);}, {}, _ctx)
  kk_unit_t _x1489 = kk_Unit;
  kk_unit_t _x1490 = kk_Unit;
  kk_unit_unbox(_b_1255);
  kk_function_call(kk_unit_t, (kk_function_t, kk_unit_t, kk_context_t*), _b_1281_1254, (_b_1281_1254, _x1490, _ctx));
  return kk_unit_box(_x1489);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1492__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_directory_fun1492(kk_function_t _fself, kk_box_t _b_1258, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1492(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun1492, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_dir_copy_directory_fun1492(kk_function_t _fself, kk_box_t _b_1258, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_std_core__list _x1493;
  kk_std_os_path__path _x1494 = kk_std_os_path__path_unbox(_b_1258, _ctx); /*std/os/path/path*/
  _x1493 = kk_std_os_dir_list_directory(_x1494, _ctx); /*list<std/os/path/path>*/
  return kk_std_core__list_box(_x1493, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1495__t {
  struct kk_function_s _base;
};
static bool kk_std_os_dir_copy_directory_fun1495(kk_function_t _fself, kk_box_t _b_1268, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1495(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun1495, _ctx)
  return kk_function_dup(_fself);
}



// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1497__t {
  struct kk_function_s _base;
};
static bool kk_std_os_dir_copy_directory_fun1497(kk_function_t _fself, kk_std_os_path__path _x11496, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1497(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun1497, _ctx)
  return kk_function_dup(_fself);
}

static bool kk_std_os_dir_copy_directory_fun1497(kk_function_t _fself, kk_std_os_path__path _x11496, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_os_dir_is_directory(_x11496, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1499__t {
  struct kk_function_s _base;
  kk_function_t _b_1273_1261;
};
static kk_box_t kk_std_os_dir_copy_directory_fun1499(kk_function_t _fself, kk_box_t _b_1263, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1499(kk_function_t _b_1273_1261, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1499__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun1499__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir_copy_directory_fun1499, kk_context());
  _self->_b_1273_1261 = _b_1273_1261;
  return &_self->_base;
}

static kk_box_t kk_std_os_dir_copy_directory_fun1499(kk_function_t _fself, kk_box_t _b_1263, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1499__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun1499__t*, _fself);
  kk_function_t _b_1273_1261 = _self->_b_1273_1261; /* (dir : std/os/path/path) -> fsys bool */
  kk_drop_match(_self, {kk_function_dup(_b_1273_1261);}, {}, _ctx)
  bool _x1500;
  kk_std_os_path__path _x1501 = kk_std_os_path__path_unbox(_b_1263, _ctx); /*std/os/path/path*/
  _x1500 = kk_function_call(bool, (kk_function_t, kk_std_os_path__path, kk_context_t*), _b_1273_1261, (_b_1273_1261, _x1501, _ctx)); /*bool*/
  return kk_bool_box(_x1500);
}
static bool kk_std_os_dir_copy_directory_fun1495(kk_function_t _fself, kk_box_t _b_1268, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_std_os_path__path _x102_1282 = kk_std_os_path__path_unbox(_b_1268, _ctx); /*std/os/path/path*/;
  kk_function_t _b_1273_1261 = kk_std_os_dir_new_copy_directory_fun1497(_ctx); /*(dir : std/os/path/path) -> fsys bool*/;
  kk_std_os_path__path _b_1274_1262 = _x102_1282; /*std/os/path/path*/;
  kk_box_t _x1498 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_directory_fun1499(_b_1273_1261, _ctx), kk_std_os_path__path_box(_b_1274_1262, _ctx), _ctx); /*3289*/
  return kk_bool_unbox(_x1498);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1502__t {
  struct kk_function_s _base;
  kk_std_os_path__path to6;
};
static kk_unit_t kk_std_os_dir_copy_directory_fun1502(kk_function_t _fself, kk_std_core_types__tuple2_ _y_10381, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1502(kk_std_os_path__path to6, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1502__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun1502__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir_copy_directory_fun1502, kk_context());
  _self->to6 = to6;
  return &_self->_base;
}

static kk_unit_t kk_std_os_dir_copy_directory_fun1502(kk_function_t _fself, kk_std_core_types__tuple2_ _y_10381, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1502__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun1502__t*, _fself);
  kk_std_os_path__path to6 = _self->to6; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to6);}, {}, _ctx)
  return kk_std_os_dir__mlift1064_copy_directory(to6, _y_10381, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1504__t {
  struct kk_function_s _base;
  kk_function_t _b_1283_1275;
};
static kk_box_t kk_std_os_dir_copy_directory_fun1504(kk_function_t _fself, kk_box_t _b_1276, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1504(kk_function_t _b_1283_1275, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1504__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun1504__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir_copy_directory_fun1504, kk_context());
  _self->_b_1283_1275 = _b_1283_1275;
  return &_self->_base;
}

static kk_box_t kk_std_os_dir_copy_directory_fun1504(kk_function_t _fself, kk_box_t _b_1276, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1504__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun1504__t*, _fself);
  kk_function_t _b_1283_1275 = _self->_b_1283_1275; /* ((list<std/os/path/path>, list<std/os/path/path>)) -> <fsys,div,exn> () */
  kk_drop_match(_self, {kk_function_dup(_b_1283_1275);}, {}, _ctx)
  kk_unit_t _x1505 = kk_Unit;
  kk_std_core_types__tuple2_ _x1506 = kk_std_core_types__tuple2__unbox(_b_1276, _ctx); /*(list<std/os/path/path>, list<std/os/path/path>)*/
  kk_function_call(kk_unit_t, (kk_function_t, kk_std_core_types__tuple2_, kk_context_t*), _b_1283_1275, (_b_1283_1275, _x1506, _ctx));
  return kk_unit_box(_x1505);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1510__t {
  struct kk_function_s _base;
  kk_std_core__list dirs1;
  kk_std_os_path__path to6;
};
static kk_unit_t kk_std_os_dir_copy_directory_fun1510(kk_function_t _fself, kk_unit_t wild__001, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1510(kk_std_core__list dirs1, kk_std_os_path__path to6, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1510__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun1510__t, 4, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir_copy_directory_fun1510, kk_context());
  _self->dirs1 = dirs1;
  _self->to6 = to6;
  return &_self->_base;
}

static kk_unit_t kk_std_os_dir_copy_directory_fun1510(kk_function_t _fself, kk_unit_t wild__001, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1510__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun1510__t*, _fself);
  kk_std_core__list dirs1 = _self->dirs1; /* list<std/os/path/path> */
  kk_std_os_path__path to6 = _self->to6; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_core__list_dup(dirs1);kk_std_os_path__path_dup(to6);}, {}, _ctx)
  return kk_std_os_dir__mlift1063_copy_directory(dirs1, to6, wild__001, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1512__t {
  struct kk_function_s _base;
  kk_function_t _b_1284_1279;
};
static kk_box_t kk_std_os_dir_copy_directory_fun1512(kk_function_t _fself, kk_box_t _b_1280, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1512(kk_function_t _b_1284_1279, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1512__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun1512__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir_copy_directory_fun1512, kk_context());
  _self->_b_1284_1279 = _b_1284_1279;
  return &_self->_base;
}

static kk_box_t kk_std_os_dir_copy_directory_fun1512(kk_function_t _fself, kk_box_t _b_1280, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1512__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun1512__t*, _fself);
  kk_function_t _b_1284_1279 = _self->_b_1284_1279; /* (wild_001 : ()) -> <exn,fsys,div> () */
  kk_drop_match(_self, {kk_function_dup(_b_1284_1279);}, {}, _ctx)
  kk_unit_t _x1513 = kk_Unit;
  kk_unit_t _x1514 = kk_Unit;
  kk_unit_unbox(_b_1280);
  kk_function_call(kk_unit_t, (kk_function_t, kk_unit_t, kk_context_t*), _b_1284_1279, (_b_1284_1279, _x1514, _ctx));
  return kk_unit_box(_x1513);
}

kk_unit_t kk_std_os_dir_copy_directory(kk_std_os_path__path dir0, kk_std_os_path__path to6, kk_context_t* _ctx) { /* (dir : std/os/path/path, to : std/os/path/path) -> <pure,fsys> () */ 
  kk_unit_t x8_1116 = kk_Unit;
  kk_std_os_path__path _x1485 = kk_std_os_path__path_dup(to6); /*std/os/path/path*/
  kk_std_os_dir_ensure_dir(_x1485, _ctx);
  if (kk_yielding(kk_context())) {
    kk_function_t _b_1281_1254 = kk_std_os_dir_new_copy_directory_fun1486(dir0, to6, _ctx); /*(wild_2 : ()) -> <exn,fsys> ()*/;
    kk_box_t _x1487 = kk_std_core_hnd_yield_extend(kk_std_os_dir_new_copy_directory_fun1488(_b_1281_1254, _ctx), _ctx); /*3858*/
    kk_unit_unbox(_x1487); return kk_Unit;
  }
  kk_std_core__list all0;
  kk_box_t _x1491 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_directory_fun1492(_ctx), kk_std_os_path__path_box(dir0, _ctx), _ctx); /*3289*/
  all0 = kk_std_core__list_unbox(_x1491, _ctx); /*list<std/os/path/path>*/
  kk_std_core_types__tuple2_ x9_1119 = kk_std_core_partition_acc(all0, kk_std_os_dir_new_copy_directory_fun1495(_ctx), kk_std_core__new_Nil(_ctx), kk_std_core__new_Nil(_ctx), _ctx); /*(list<std/os/path/path>, list<std/os/path/path>)*/;
  if (kk_yielding(kk_context())) {
    kk_std_core_types__tuple2__drop(x9_1119, _ctx);
    kk_function_t _b_1283_1275 = kk_std_os_dir_new_copy_directory_fun1502(to6, _ctx); /*((list<std/os/path/path>, list<std/os/path/path>)) -> <fsys,div,exn> ()*/;
    kk_box_t _x1503 = kk_std_core_hnd_yield_extend(kk_std_os_dir_new_copy_directory_fun1504(_b_1283_1275, _ctx), _ctx); /*3858*/
    kk_unit_unbox(_x1503); return kk_Unit;
  }
  kk_box_t _box_x1277 = x9_1119.fst;
  kk_box_t _box_x1278 = x9_1119.snd;
  kk_std_core__list dirs1 = kk_std_core__list_unbox(_box_x1277, NULL);
  kk_std_core__list files0 = kk_std_core__list_unbox(_box_x1278, NULL);
  kk_std_core__list_dup(dirs1);
  kk_std_core__list_dup(files0);
  kk_std_core_types__tuple2__drop(x9_1119, _ctx);
  kk_Unit;
  kk_unit_t x14_1122 = kk_Unit;
  kk_std_os_path__path _x1509 = kk_std_os_path__path_dup(to6); /*std/os/path/path*/
  kk_std_os_dir__lift1011_copy_directory(_x1509, files0, _ctx);
  if (kk_yielding(kk_context())) {
    kk_function_t _b_1284_1279 = kk_std_os_dir_new_copy_directory_fun1510(dirs1, to6, _ctx); /*(wild_001 : ()) -> <exn,fsys,div> ()*/;
    kk_box_t _x1511 = kk_std_core_hnd_yield_extend(kk_std_os_dir_new_copy_directory_fun1512(_b_1284_1279, _ctx), _ctx); /*3858*/
    kk_unit_unbox(_x1511); return kk_Unit;
  }
  kk_std_os_dir__lift1012_copy_directory(to6, dirs1, _ctx); return kk_Unit;
}
 
// Copy a file to a directory

kk_unit_t kk_std_os_dir_copy_file_to_dir(kk_std_os_path__path from, kk_std_os_path__path dir, kk_context_t* _ctx) { /* (from : std/os/path/path, dir : std/os/path/path) -> <exn,fsys> () */ 
  kk_std_os_path__path _x1515 = kk_std_os_path__path_dup(from); /*std/os/path/path*/
  kk_std_os_path__path _x1516;
  kk_evv_t w = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<(<>)>*/;
  kk_std_core__list _b_1286_1285;
  kk_std_core__list _x1517;
  kk_std_core__list _x100 = from.parts;
  kk_std_core__list_dup(_x100);
  _x1517 = _x100; /*list<string>*/
  _b_1286_1285 = kk_std_core_take(_x1517, kk_integer_from_small(1), _ctx); /*list<string>*/
  kk_unit_t keep = kk_Unit;
  kk_evv_set(w,kk_context());
  kk_evv_t w0 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<(<>)>*/;
  kk_std_core__list _b_1289_1288;
  kk_std_core__list _x1518;
  kk_std_core__list _x1519;
  kk_std_core_types__optional _match_1314 = kk_std_core_types__new_Optional(kk_std_core__list_box(_b_1286_1285, _ctx), _ctx); /*optional<106>*/;
  if (kk_std_core_types__is_Optional(_match_1314)) {
    kk_box_t _box_x1287 = _match_1314._cons.Optional.value;
    kk_std_core__list _parts_111 = kk_std_core__list_unbox(_box_x1287, NULL);
    kk_std_os_path__path_drop(from, _ctx);
    kk_std_core__list_dup(_parts_111);
    kk_std_core_types__optional_drop(_match_1314, _ctx);
    kk_Unit;
    _x1519 = _parts_111; /*list<string>*/
    goto _match1520;
  }
  kk_std_core__list _x000 = from.parts;
  kk_std_core__list_dup(_x000);
  kk_std_os_path__path_drop(from, _ctx);
  kk_Unit;
  _x1519 = _x000; /*list<string>*/
  _match1520: ;
  _x1518 = kk_std_core__lift17186_reverse(kk_std_core__new_Nil(_ctx), _x1519, _ctx); /*list<2436>*/
  kk_std_core__list _x1522;
  kk_std_core__list _x10 = dir.parts;
  kk_std_core__list_dup(_x10);
  _x1522 = _x10; /*list<string>*/
  _b_1289_1288 = kk_std_os_path_push_parts(_x1518, _x1522, _ctx); /*list<string>*/
  kk_unit_t keep0 = kk_Unit;
  kk_evv_set(w0,kk_context());
  kk_string_t _x1523;
  kk_string_t _x = dir.root;
  kk_string_dup(_x);
  kk_std_os_path__path_drop(dir, _ctx);
  kk_Unit;
  _x1523 = _x; /*string*/
  kk_std_core__list _x1524;
  kk_std_core_types__optional _match_1313 = kk_std_core_types__new_Optional(kk_std_core__list_box(_b_1289_1288, _ctx), _ctx); /*optional<106>*/;
  if (kk_std_core_types__is_Optional(_match_1313)) {
    kk_box_t _box_x1290 = _match_1313._cons.Optional.value;
    kk_std_core__list _parts_876 = kk_std_core__list_unbox(_box_x1290, NULL);
    kk_std_core__list_dup(_parts_876);
    kk_std_core_types__optional_drop(_match_1313, _ctx);
    kk_Unit;
    _x1524 = _parts_876; /*list<string>*/
    goto _match1525;
  }
  _x1524 = kk_std_core__new_Nil(_ctx); /*list<string>*/
  _match1525: ;
  _x1516 = kk_std_os_path__new_Path(_x1523, _x1524, _ctx); /*std/os/path/path*/
  kk_std_os_dir_copy_file(_x1515, _x1516, kk_std_core_types__new_None(_ctx), _ctx); return kk_Unit;
}
 
// lifted
// specialized std/core/filter to parameters [pred]

kk_std_core__list kk_std_os_dir__lift1013_list_directory_recursive(kk_std_core__list xs, kk_context_t* _ctx) { /* (xs : list<std/os/path/path>) -> <fsys,div> list<std/os/path/path> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs)) {
    struct kk_std_core_Cons* _con1528 = kk_std_core__as_Cons(xs);
    kk_box_t _box_x1291 = _con1528->head;
    kk_std_core__list xx = _con1528->tail;
    kk_std_os_path__path x = kk_std_os_path__path_unbox(_box_x1291, NULL);
    kk_reuse_t _ru_1337 = kk_reuse_null; /*reuse*/;
    if (kk_likely(kk_std_core__list_is_unique(xs))) {
      kk_std_os_path__path_dup(x);
      kk_box_drop(_box_x1291, _ctx);
      kk_Unit;
      kk_Unit;
      _ru_1337 = (kk_std_core__list_reuse(xs));
    }
    else {
      kk_std_os_path__path_dup(x);
      kk_std_core__list_dup(xx);
      kk_Unit;
      kk_std_core__list_decref(xs, _ctx);
      kk_Unit;
    }
    bool _match_1312;
    kk_string_t _x1530;
    kk_std_os_path__path _x1531 = kk_std_os_path__path_dup(x); /*std/os/path/path*/
    _x1530 = kk_std_os_path_string(_x1531, _ctx); /*string*/
    _match_1312 = kk_std_os_dir_prim_is_dir(_x1530, _ctx); /*bool*/
    if (_match_1312) {
      kk_std_os_path__path _b_1294_1292 = x; /*std/os/path/path*/;
      kk_std_core__list _b_1295_1293 = kk_std_os_dir__lift1013_list_directory_recursive(xx, _ctx); /*list<std/os/path/path>*/;
      return kk_std_core__new_Cons(_ru_1337, kk_std_os_path__path_box(_b_1294_1292, _ctx), _b_1295_1293, _ctx);
    }
    kk_reuse_drop(_ru_1337);
    kk_std_os_path__path_drop(x, _ctx);
    { // tailcall
      xs = xx;
      goto kk__tailcall;
    }
  }
  return kk_std_core__new_Nil(_ctx);
}
 
// Recursively list all the entries under a directory.


// lift anonymous function
struct kk_std_os_dir_list_directory_recursive_fun1535__t {
  struct kk_function_s _base;
  kk_std_core_types__optional max_depth;
};
static kk_std_core__list kk_std_os_dir_list_directory_recursive_fun1535(kk_function_t _fself, kk_box_t _b_1302, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_list_directory_recursive_fun1535(kk_std_core_types__optional max_depth, kk_context_t* _ctx) {
  struct kk_std_os_dir_list_directory_recursive_fun1535__t* _self = kk_function_alloc_as(struct kk_std_os_dir_list_directory_recursive_fun1535__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_dir_list_directory_recursive_fun1535, kk_context());
  _self->max_depth = max_depth;
  return &_self->_base;
}

static kk_std_core__list kk_std_os_dir_list_directory_recursive_fun1535(kk_function_t _fself, kk_box_t _b_1302, kk_context_t* _ctx) {
  struct kk_std_os_dir_list_directory_recursive_fun1535__t* _self = kk_function_as(struct kk_std_os_dir_list_directory_recursive_fun1535__t*, _fself);
  kk_std_core_types__optional max_depth = _self->max_depth; /* optional<int> */
  kk_drop_match(_self, {kk_std_core_types__optional_dup(max_depth);}, {}, _ctx)
  kk_std_os_path__path sub_1307 = kk_std_os_path__path_unbox(_b_1302, _ctx); /*std/os/path/path*/;
  kk_std_core_types__optional _x1536;
  kk_integer_t _b_1306_1298;
  kk_integer_t _x1537;
  if (kk_std_core_types__is_Optional(max_depth)) {
    kk_box_t _box_x1297 = max_depth._cons.Optional.value;
    kk_integer_t _max_depth_9080 = kk_integer_unbox(_box_x1297);
    kk_integer_dup(_max_depth_9080);
    kk_std_core_types__optional_drop(max_depth, _ctx);
    kk_Unit;
    _x1537 = _max_depth_9080; /*int*/
    goto _match1538;
  }
  _x1537 = kk_integer_from_small(1000); /*int*/
  _match1538: ;
  _b_1306_1298 = kk_integer_sub(_x1537,(kk_integer_from_small(1)),kk_context()); /*int*/
  _x1536 = kk_std_core_types__new_Optional(kk_integer_box(_b_1306_1298), _ctx); /*optional<106>*/
  return kk_std_os_dir_list_directory_recursive(sub_1307, _x1536, _ctx);
}

kk_std_core__list kk_std_os_dir_list_directory_recursive(kk_std_os_path__path dir0, kk_std_core_types__optional max_depth, kk_context_t* _ctx) { /* (dir : std/os/path/path, max-depth : optional<int>) -> <div,fsys> list<std/os/path/path> */ 
  bool _match_1308;
  kk_integer_t _borrowedArg_1310;
  if (kk_std_core_types__is_Optional(max_depth)) {
    kk_box_t _box_x1296 = max_depth._cons.Optional.value;
    kk_integer_t _max_depth_908 = kk_integer_unbox(_box_x1296);
    kk_integer_dup(_max_depth_908);
    _borrowedArg_1310 = _max_depth_908; /*int*/
    goto _match1532;
  }
  _borrowedArg_1310 = kk_integer_from_small(1000); /*int*/
  _match1532: ;
  kk_integer_t _borrowedArg_1309 = kk_integer_from_small(0); /*int*/;
  bool _borrowApp_1311 = kk_integer_lt_borrow(_borrowedArg_1310,_borrowedArg_1309,kk_context()); /*bool*/;
  kk_integer_drop(_borrowedArg_1310, _ctx);
  kk_integer_drop(_borrowedArg_1309, _ctx);
  _match_1308 = _borrowApp_1311; /*bool*/
  if (_match_1308) {
    kk_std_os_path__path_drop(dir0, _ctx);
    kk_std_core_types__optional_drop(max_depth, _ctx);
    return kk_std_core__new_Nil(_ctx);
  }
  kk_std_core__list all = kk_std_os_dir_list_directory(dir0, _ctx); /*list<std/os/path/path>*/;
  kk_std_core__list dirs;
  kk_std_core__list _x1534 = kk_std_core__list_dup(all); /*list<std/os/path/path>*/
  dirs = kk_std_os_dir__lift1013_list_directory_recursive(_x1534, _ctx); /*list<std/os/path/path>*/
  kk_std_core__list ys_1007 = kk_std_core__lift17165_flatmap(kk_std_os_dir_new_list_directory_recursive_fun1535(max_depth, _ctx), kk_std_core__new_Nil(_ctx), dirs, _ctx); /*list<std/os/path/path>*/;
  return kk_std_core_append(all, ys_1007, _ctx);
}

// initialization
void kk_std_os_dir__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core__init(_ctx);
  kk_std_os_path__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
}

// termination
void kk_std_os_dir__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_os_path__done(_ctx);
  kk_std_core__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
