#pragma once
#ifndef kk_std_time_calendar_H
#define kk_std_time_calendar_H
// Koka generated module: "std/time/calendar", koka version: 2.2.1
#include <kklib.h>
#include "std_core_types.h"
#include "std_core_hnd.h"
#include "std_core.h"
#include "std_num_ddouble.h"
#include "std_time_date.h"
#include "std_time_timestamp.h"
#include "std_time_duration.h"
#include "std_time_instant.h"
#include "std_time_utc.h"

// type declarations

// value type std/time/calendar/timezone
struct kk_std_time_calendar_Timezone {
  kk_string_t name;
  kk_function_t utc_delta;
  kk_function_t utc_inverse;
};
typedef struct kk_std_time_calendar_Timezone kk_std_time_calendar__timezone;
static inline kk_std_time_calendar__timezone kk_std_time_calendar__new_Timezone(kk_string_t name, kk_function_t utc_delta, kk_function_t utc_inverse, kk_context_t* _ctx){
  kk_std_time_calendar__timezone _con;
  _con.name = name;
  _con.utc_delta = utc_delta;
  _con.utc_inverse = utc_inverse;
  return _con;
}
static inline bool kk_std_time_calendar__is_Timezone(kk_std_time_calendar__timezone x) {
  return (true);
}
static inline kk_std_time_calendar__timezone kk_std_time_calendar__timezone_dup(kk_std_time_calendar__timezone _x) {
  kk_string_dup(_x.name);
  kk_function_dup(_x.utc_delta);
  kk_function_dup(_x.utc_inverse);
  return _x;
}
static inline void kk_std_time_calendar__timezone_drop(kk_std_time_calendar__timezone _x, kk_context_t* _ctx) {
  kk_string_drop(_x.name, _ctx);
  kk_function_drop(_x.utc_delta, _ctx);
  kk_function_drop(_x.utc_inverse, _ctx);
}
static inline kk_box_t kk_std_time_calendar__timezone_box(kk_std_time_calendar__timezone _x, kk_context_t* _ctx) {
  kk_box_t _box;
  kk_valuetype_box(kk_std_time_calendar__timezone, _box, _x, 3 /* scan count */, _ctx);
  return _box;
}
static inline kk_std_time_calendar__timezone kk_std_time_calendar__timezone_unbox(kk_box_t _x, kk_context_t* _ctx) {
  kk_boxed_value_t _p;
  kk_std_time_calendar__timezone _unbox;
  kk_valuetype_unbox_(kk_std_time_calendar__timezone, _p, _unbox, _x, _ctx);
  if (_ctx!=NULL && _p!=NULL) {
    if (kk_basetype_is_unique(_p)) { kk_basetype_free(_p); } else {
      kk_std_time_calendar__timezone_dup(_unbox);
      kk_basetype_decref(_p, _ctx);
    }
  }
  return _unbox;
}

// type std/time/calendar/calendar
struct kk_std_time_calendar__calendar_s {
  kk_block_t _block;
};
typedef struct kk_std_time_calendar__calendar_s* kk_std_time_calendar__calendar;
struct kk_std_time_calendar_Calendar {
  struct kk_std_time_calendar__calendar_s _base;
  kk_string_t name;
  kk_string_t long_name;
  kk_string_t month_prefix;
  kk_function_t show_era;
  kk_function_t instant_to_dc;
  kk_function_t dc_to_instant;
  kk_function_t days_to_date;
  kk_function_t date_to_days;
};
static inline kk_std_time_calendar__calendar kk_std_time_calendar__base_Calendar(struct kk_std_time_calendar_Calendar* _x){
  return &_x->_base;
}
static inline kk_std_time_calendar__calendar kk_std_time_calendar__new_Calendar(kk_reuse_t _at, kk_string_t name, kk_string_t long_name, kk_string_t month_prefix, kk_function_t show_era, kk_function_t instant_to_dc, kk_function_t dc_to_instant, kk_function_t days_to_date, kk_function_t date_to_days, kk_context_t* _ctx){
  struct kk_std_time_calendar_Calendar* _con = kk_block_alloc_at_as(struct kk_std_time_calendar_Calendar, _at, 8 /* scan count */, (kk_tag_t)(1), _ctx);
  _con->name = name;
  _con->long_name = long_name;
  _con->month_prefix = month_prefix;
  _con->show_era = show_era;
  _con->instant_to_dc = instant_to_dc;
  _con->dc_to_instant = dc_to_instant;
  _con->days_to_date = days_to_date;
  _con->date_to_days = date_to_days;
  return kk_std_time_calendar__base_Calendar(_con);
}
static inline struct kk_std_time_calendar_Calendar* kk_std_time_calendar__as_Calendar(kk_std_time_calendar__calendar x) {
  return kk_basetype_as_assert(struct kk_std_time_calendar_Calendar*, x, (kk_tag_t)(1) /* _tag */);
}
static inline bool kk_std_time_calendar__is_Calendar(kk_std_time_calendar__calendar x) {
  return (true);
}
static inline kk_std_time_calendar__calendar kk_std_time_calendar__calendar_dup(kk_std_time_calendar__calendar _x) {
  return kk_basetype_dup_as(kk_std_time_calendar__calendar, _x);
}
static inline void kk_std_time_calendar__calendar_drop(kk_std_time_calendar__calendar _x, kk_context_t* _ctx) {
  kk_basetype_drop(_x, _ctx);
}
static inline bool kk_std_time_calendar__calendar_is_unique(kk_std_time_calendar__calendar _x) {
  return kk_basetype_is_unique(_x);
}
static inline void kk_std_time_calendar__calendar_free(kk_std_time_calendar__calendar _x) {
  kk_basetype_free(_x);
}
static inline void kk_std_time_calendar__calendar_decref(kk_std_time_calendar__calendar _x, kk_context_t* _ctx) {
  kk_basetype_decref(_x, _ctx);
}
static inline kk_reuse_t kk_std_time_calendar__calendar_dropn_reuse(kk_std_time_calendar__calendar _x, kk_ssize_t _scan_fsize, kk_context_t* _ctx) {
  return kk_basetype_dropn_reuse(_x, _scan_fsize, _ctx);
}
static inline void kk_std_time_calendar__calendar_dropn(kk_std_time_calendar__calendar _x, kk_ssize_t _scan_fsize, kk_context_t* _ctx) {
  kk_basetype_dropn(_x, _scan_fsize, _ctx);
}
static inline kk_reuse_t kk_std_time_calendar__calendar_reuse(kk_std_time_calendar__calendar _x) {
  return kk_basetype_reuse(_x);
}
static inline kk_std_time_calendar__calendar kk_std_time_calendar__calendar_hole() {
  return (kk_std_time_calendar__calendar)(1);
}
static inline kk_box_t kk_std_time_calendar__calendar_box(kk_std_time_calendar__calendar _x, kk_context_t* _ctx) {
  return kk_basetype_box(_x);
}
static inline kk_std_time_calendar__calendar kk_std_time_calendar__calendar_unbox(kk_box_t _x, kk_context_t* _ctx) {
  return kk_basetype_unbox_as(kk_std_time_calendar__calendar, _x);
}

// type std/time/calendar/local-timezone
struct kk_std_time_calendar__local_timezone_s {
  kk_block_t _block;
};
typedef kk_datatype_t kk_std_time_calendar__local_timezone;
static inline kk_std_time_calendar__local_timezone kk_std_time_calendar__local_timezone_dup(kk_std_time_calendar__local_timezone _x) {
  return kk_datatype_dup(_x);
}
static inline void kk_std_time_calendar__local_timezone_drop(kk_std_time_calendar__local_timezone _x, kk_context_t* _ctx) {
  kk_datatype_drop(_x, _ctx);
}
static inline bool kk_std_time_calendar__local_timezone_is_unique(kk_std_time_calendar__local_timezone _x) {
  return kk_datatype_is_unique(_x);
}
static inline void kk_std_time_calendar__local_timezone_free(kk_std_time_calendar__local_timezone _x) {
  kk_datatype_free(_x);
}
static inline void kk_std_time_calendar__local_timezone_decref(kk_std_time_calendar__local_timezone _x, kk_context_t* _ctx) {
  kk_datatype_decref(_x, _ctx);
}
static inline kk_reuse_t kk_std_time_calendar__local_timezone_dropn_reuse(kk_std_time_calendar__local_timezone _x, kk_ssize_t _scan_fsize, kk_context_t* _ctx) {
  return kk_datatype_dropn_reuse(_x, _scan_fsize, _ctx);
}
static inline void kk_std_time_calendar__local_timezone_dropn(kk_std_time_calendar__local_timezone _x, kk_ssize_t _scan_fsize, kk_context_t* _ctx) {
  kk_datatype_dropn(_x, _scan_fsize, _ctx);
}
static inline kk_reuse_t kk_std_time_calendar__local_timezone_reuse(kk_std_time_calendar__local_timezone _x) {
  return kk_datatype_reuse(_x);
}
static inline kk_std_time_calendar__local_timezone kk_std_time_calendar__local_timezone_hole() {
  return kk_datatype_from_tag((kk_tag_t)0);
}
static inline kk_box_t kk_std_time_calendar__local_timezone_box(kk_std_time_calendar__local_timezone _x, kk_context_t* _ctx) {
  return kk_datatype_box(_x);
}
static inline kk_std_time_calendar__local_timezone kk_std_time_calendar__local_timezone_unbox(kk_box_t _x, kk_context_t* _ctx) {
  return kk_datatype_unbox(_x);
}

// value declarations
 
// Automatically generated. Retrieves the `name` constructor field of the `:timezone` type.

static inline kk_string_t kk_std_time_calendar_name(kk_std_time_calendar__timezone timezone, kk_context_t* _ctx) { /* (timezone : timezone) -> string */ 
  kk_string_t _x = timezone.name;
  return kk_string_dup(_x);
}
 
// Automatically generated. Retrieves the `utc-delta` constructor field of the `:timezone` type.

static inline kk_function_t kk_std_time_calendar_utc_delta(kk_std_time_calendar__timezone timezone, kk_context_t* _ctx) { /* (timezone : timezone) -> ((std/time/instant/instant) -> (std/time/duration/duration, string)) */ 
  kk_function_t _x = timezone.utc_delta;
  return kk_function_dup(_x);
}
 
// Automatically generated. Retrieves the `utc-inverse` constructor field of the `:timezone` type.

static inline kk_function_t kk_std_time_calendar_utc_inverse(kk_std_time_calendar__timezone timezone, kk_context_t* _ctx) { /* (timezone : timezone) -> ((std/time/instant/instant) -> maybe<std/time/instant/instant>) */ 
  kk_function_t _x = timezone.utc_inverse;
  return kk_function_dup(_x);
}

kk_std_time_calendar__timezone kk_std_time_calendar__copy(kk_std_time_calendar__timezone _this, kk_std_core_types__optional name0, kk_std_core_types__optional utc_delta0, kk_std_core_types__optional utc_inverse0, kk_context_t* _ctx); /* (timezone, name : optional<string>, utc-delta : optional<(std/time/instant/instant) -> (std/time/duration/duration, string)>, utc-inverse : optional<(std/time/instant/instant) -> maybe<std/time/instant/instant>>) -> timezone */ 
 
// Automatically generated. Retrieves the `name` constructor field of the `:calendar` type.

static inline kk_string_t kk_std_time_calendar_name_1(kk_std_time_calendar__calendar calendar, kk_context_t* _ctx) { /* (calendar : calendar) -> string */ 
  struct kk_std_time_calendar_Calendar* _con5840 = kk_std_time_calendar__as_Calendar(calendar);
  kk_string_t _x = _con5840->name;
  return kk_string_dup(_x);
}
 
// Automatically generated. Retrieves the `long-name` constructor field of the `:calendar` type.

static inline kk_string_t kk_std_time_calendar_long_name(kk_std_time_calendar__calendar calendar, kk_context_t* _ctx) { /* (calendar : calendar) -> string */ 
  struct kk_std_time_calendar_Calendar* _con5841 = kk_std_time_calendar__as_Calendar(calendar);
  kk_string_t _x = _con5841->long_name;
  return kk_string_dup(_x);
}
 
// Automatically generated. Retrieves the `month-prefix` constructor field of the `:calendar` type.

static inline kk_string_t kk_std_time_calendar_month_prefix(kk_std_time_calendar__calendar calendar, kk_context_t* _ctx) { /* (calendar : calendar) -> string */ 
  struct kk_std_time_calendar_Calendar* _con5842 = kk_std_time_calendar__as_Calendar(calendar);
  kk_string_t _x = _con5842->month_prefix;
  return kk_string_dup(_x);
}
 
// Automatically generated. Retrieves the `show-era` constructor field of the `:calendar` type.

static inline kk_function_t kk_std_time_calendar_show_era(kk_std_time_calendar__calendar calendar, kk_context_t* _ctx) { /* (calendar : calendar) -> ((std/time/date/date) -> string) */ 
  struct kk_std_time_calendar_Calendar* _con5843 = kk_std_time_calendar__as_Calendar(calendar);
  kk_function_t _x = _con5843->show_era;
  return kk_function_dup(_x);
}
 
// Automatically generated. Retrieves the `instant-to-dc` constructor field of the `:calendar` type.

static inline kk_function_t kk_std_time_calendar_instant_to_dc(kk_std_time_calendar__calendar calendar, kk_context_t* _ctx) { /* (calendar : calendar) -> ((i : std/time/instant/instant, tzdelta : std/time/duration/duration) -> (std/time/date/date, std/time/date/clock)) */ 
  struct kk_std_time_calendar_Calendar* _con5844 = kk_std_time_calendar__as_Calendar(calendar);
  kk_function_t _x = _con5844->instant_to_dc;
  return kk_function_dup(_x);
}
 
// Automatically generated. Retrieves the `dc-to-instant` constructor field of the `:calendar` type.

static inline kk_function_t kk_std_time_calendar_dc_to_instant(kk_std_time_calendar__calendar calendar, kk_context_t* _ctx) { /* (calendar : calendar) -> ((std/time/date/date, std/time/date/clock, timezone, std/time/instant/timescale) -> std/time/instant/instant) */ 
  struct kk_std_time_calendar_Calendar* _con5845 = kk_std_time_calendar__as_Calendar(calendar);
  kk_function_t _x = _con5845->dc_to_instant;
  return kk_function_dup(_x);
}
 
// Automatically generated. Retrieves the `days-to-date` constructor field of the `:calendar` type.

static inline kk_function_t kk_std_time_calendar_days_to_date(kk_std_time_calendar__calendar calendar, kk_context_t* _ctx) { /* (calendar : calendar) -> ((days : int) -> std/time/date/date) */ 
  struct kk_std_time_calendar_Calendar* _con5846 = kk_std_time_calendar__as_Calendar(calendar);
  kk_function_t _x = _con5846->days_to_date;
  return kk_function_dup(_x);
}
 
// Automatically generated. Retrieves the `date-to-days` constructor field of the `:calendar` type.

static inline kk_function_t kk_std_time_calendar_date_to_days(kk_std_time_calendar__calendar calendar, kk_context_t* _ctx) { /* (calendar : calendar) -> ((date : std/time/date/date) -> int) */ 
  struct kk_std_time_calendar_Calendar* _con5847 = kk_std_time_calendar__as_Calendar(calendar);
  kk_function_t _x = _con5847->date_to_days;
  return kk_function_dup(_x);
}

kk_std_time_calendar__calendar kk_std_time_calendar__copy_1(kk_std_time_calendar__calendar _this, kk_std_core_types__optional name0, kk_std_core_types__optional long_name0, kk_std_core_types__optional month_prefix0, kk_std_core_types__optional show_era0, kk_std_core_types__optional instant_to_dc0, kk_std_core_types__optional dc_to_instant0, kk_std_core_types__optional days_to_date0, kk_std_core_types__optional date_to_days0, kk_context_t* _ctx); /* (calendar, name : optional<string>, long-name : optional<string>, month-prefix : optional<string>, show-era : optional<(std/time/date/date) -> string>, instant-to-dc : optional<(i : std/time/instant/instant, tzdelta : std/time/duration/duration) -> (std/time/date/date, std/time/date/clock)>, dc-to-instant : optional<(std/time/date/date, std/time/date/clock, timezone, std/time/instant/timescale) -> std/time/instant/instant>, days-to-date : optional<(days : int) -> std/time/date/date>, date-to-days : optional<(date : std/time/date/date) -> int>) -> calendar */ 

kk_integer_t kk_std_time_calendar_iso_days_before_year(kk_integer_t year, kk_context_t* _ctx); /* (year : int) -> int */ 

kk_std_core_types__tuple2_ kk_std_time_calendar_iso_estimate_year(kk_integer_t days, kk_context_t* _ctx); /* (days : int) -> (int, maybe<int>) */ 

kk_std_time_timestamp__timestamp kk_std_time_calendar_dc_timestamp(kk_std_time_date__date d, kk_std_time_date__clock c, kk_function_t date_to_days0, kk_std_core_types__optional has_leap_seconds, kk_context_t* _ctx); /* (d : std/time/date/date, c : std/time/date/clock, date-to-days : (std/time/date/date) -> int, has-leap-seconds : optional<bool>) -> std/time/timestamp/timestamp */ 

kk_std_core_types__tuple2_ kk_std_time_calendar_earth_timestamp_to_dc(kk_std_time_timestamp__timestamp t, kk_std_num_ddouble__ddouble tzdelta, kk_function_t days_to_date0, kk_context_t* _ctx); /* (t : std/time/timestamp/timestamp, tzdelta : std/time/timestamp/timespan, days-to-date : (int) -> std/time/date/date) -> (std/time/date/date, std/time/date/clock) */ 

kk_integer_t kk_std_time_calendar_days_until(kk_std_time_calendar__calendar cal, kk_std_time_date__date d1, kk_std_time_date__date d2, kk_context_t* _ctx); /* (cal : calendar, d1 : std/time/date/date, d2 : std/time/date/date) -> int */ 

kk_std_time_calendar__local_timezone kk_std_time_calendar_local_get_timezone(kk_context_t* _ctx); /* () -> ndet local-timezone */ 

kk_std_core_types__tuple2_ kk_std_time_calendar_local_utc_delta(kk_std_time_calendar__local_timezone tz, double i, kk_context_t* _ctx); /* (tz : local-timezone, i : double) -> (double, string) */ 
 
// A `:timezone` determines a time offset with respect to the UTC / GMT timezone. For
// using general time zones, see the [`std/time/timezone`](std_time_timezone.html) module.
// The `tz-utc` and `tz-local` time zones are used for UTC/GMT time and the local system time.
// The `name` field contains the time zone name as IANA timezone identifier.
// The `utc-delta` field returns the time zone offset
// relative to UTC (for GMT-08:00 it returns a duration of `-8*3600` seconds) and the abbreviated
// time zone name (``PDT`` for example).
// The optional `utc-inverse` field returns for an instant in the time zone, the associated UTC time.
// By default it returns `Nothing` in which case a generic algorithm is used to determine the
// inverse.


// lift anonymous function
struct kk_std_time_calendar__create_Timezone_fun5945__t {
  struct kk_function_s _base;
  kk_box_t _fun_unbox_x5038;
};
extern kk_std_core_types__maybe kk_std_time_calendar__create_Timezone_fun5945(kk_function_t _fself, kk_std_time_instant__instant _b_5041, kk_context_t* _ctx);
static inline kk_function_t kk_std_time_calendar__new_create_Timezone_fun5945(kk_box_t _fun_unbox_x5038, kk_context_t* _ctx) {
  struct kk_std_time_calendar__create_Timezone_fun5945__t* _self = kk_function_alloc_as(struct kk_std_time_calendar__create_Timezone_fun5945__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_time_calendar__create_Timezone_fun5945, kk_context());
  _self->_fun_unbox_x5038 = _fun_unbox_x5038;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_time_calendar__create_Timezone_fun5948__t {
  struct kk_function_s _base;
};
extern kk_std_core_types__maybe kk_std_time_calendar__create_Timezone_fun5948(kk_function_t _fself, kk_std_time_instant__instant i, kk_context_t* _ctx);
static inline kk_function_t kk_std_time_calendar__new_create_Timezone_fun5948(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_time_calendar__create_Timezone_fun5948, _ctx)
  return kk_function_dup(_fself);
}


static inline kk_std_time_calendar__timezone kk_std_time_calendar__create_Timezone(kk_string_t name0, kk_function_t utc_delta0, kk_std_core_types__optional utc_inverse0, kk_context_t* _ctx) { /* (name : string, utc-delta : (std/time/instant/instant) -> (std/time/duration/duration, string), utc-inverse : optional<(std/time/instant/instant) -> maybe<std/time/instant/instant>>) -> timezone */ 
  kk_function_t _x5944;
  if (kk_std_core_types__is_Optional(utc_inverse0)) {
    kk_box_t _fun_unbox_x5038 = utc_inverse0._cons.Optional.value;
    _x5944 = kk_std_time_calendar__new_create_Timezone_fun5945(_fun_unbox_x5038, _ctx); /*(std/time/instant/instant) -> maybe<std/time/instant/instant>*/
  }
  else {
    _x5944 = kk_std_time_calendar__new_create_Timezone_fun5948(_ctx); /*(std/time/instant/instant) -> maybe<std/time/instant/instant>*/
  }
  return kk_std_time_calendar__new_Timezone(name0, utc_delta0, _x5944, _ctx);
}

bool kk_std_time_calendar__lp__eq__eq__rp_(kk_std_time_calendar__calendar c1, kk_std_time_calendar__calendar c2, kk_context_t* _ctx); /* (c1 : calendar, c2 : calendar) -> bool */ 
 
// Same timezone?

static inline bool kk_std_time_calendar__lp__eq__eq__1_rp_(kk_std_time_calendar__timezone tz1, kk_std_time_calendar__timezone tz2, kk_context_t* _ctx) { /* (tz1 : timezone, tz2 : timezone) -> bool */ 
  kk_string_t _x5953;
  kk_string_t _x = tz1.name;
  kk_string_dup(_x);
  kk_std_time_calendar__timezone_drop(tz1, _ctx);
  kk_Unit;
  _x5953 = _x; /*string*/
  kk_string_t _x5954;
  kk_string_t _x0 = tz2.name;
  kk_string_dup(_x0);
  kk_std_time_calendar__timezone_drop(tz2, _ctx);
  kk_Unit;
  _x5954 = _x0; /*string*/
  return kk_string_is_eq(_x5953,_x5954,kk_context());
}

bool kk_std_time_calendar_iso_is_leap(kk_integer_t year, kk_context_t* _ctx); /* (year : int) -> bool */ 

static inline kk_integer_t kk_std_time_calendar_iso_adjust(bool is_before_march, kk_integer_t year, kk_context_t* _ctx) { /* (is-before-march : bool, year : int) -> int */ 
  if (is_before_march) {
    kk_integer_drop(year, _ctx);
    return kk_integer_from_small(0);
  }
  bool _match_5731 = kk_std_time_calendar_iso_is_leap(year, _ctx); /*bool*/;
  if (_match_5731) {
    return kk_integer_from_small(1);
  }
  return kk_integer_from_small(2);
}

kk_integer_t kk_std_time_calendar_iso_days_before_month(kk_integer_t year, kk_integer_t month, kk_context_t* _ctx); /* (year : int, month : int) -> int */ 

kk_integer_t kk_std_time_calendar_iso_doy_to_month(kk_integer_t year, kk_integer_t doy, kk_context_t* _ctx); /* (year : int, doy : int) -> int */ 

kk_std_time_calendar__timezone kk_std_time_calendar_tz_fixed_1(kk_string_t name0, kk_std_time_duration__duration delta, kk_std_core_types__optional abbrv, kk_context_t* _ctx); /* (name : string, delta : std/time/duration/duration, abbrv : optional<string>) -> timezone */ 

extern kk_std_time_calendar__timezone kk_std_time_calendar_tz_utc;

kk_std_time_calendar__timezone kk_std_time_calendar_tz_fixed(kk_integer_t hours, kk_std_core_types__optional mins, kk_std_core_types__optional name0, kk_std_core_types__optional abbrv, kk_std_core_types__optional hourwidth, kk_context_t* _ctx); /* (hours : int, mins : optional<int>, name : optional<string>, abbrv : optional<string>, hourwidth : optional<int>) -> timezone */ 
 
// Is this the UTC timezone?

static inline bool kk_std_time_calendar_is_tz_utc(kk_std_time_calendar__timezone tz, kk_context_t* _ctx) { /* (tz : timezone) -> bool */ 
  kk_string_t _x6104;
  kk_string_t _x = tz.name;
  kk_string_dup(_x);
  kk_std_time_calendar__timezone_drop(tz, _ctx);
  kk_Unit;
  _x6104 = _x; /*string*/
  kk_string_t _x6105;
  kk_std_time_calendar__timezone _x6106 = kk_std_time_calendar_tz_utc; /*std/time/calendar/timezone*/
  kk_string_t _x0 = _x6106.name;
  _x6105 = kk_string_dup(_x0); /*string*/
  return kk_string_is_eq(_x6104,_x6105,kk_context());
}

kk_std_time_instant__instant kk_std_time_calendar_earth_timestamp_to_instant(kk_std_time_timestamp__timestamp t, kk_std_time_calendar__timezone tz, kk_std_time_instant__timescale ts, kk_context_t* _ctx); /* (t : std/time/timestamp/timestamp, tz : timezone, ts : std/time/instant/timescale) -> std/time/instant/instant */ 

kk_std_time_calendar__calendar kk_std_time_calendar_earth_calendar(kk_string_t name0, kk_string_t long_name0, kk_function_t days_to_date0, kk_function_t date_to_days0, kk_std_core_types__optional month_prefix0, kk_std_core_types__optional show_era0, kk_context_t* _ctx); /* (name : string, long-name : string, days-to-date : (days : int) -> std/time/date/date, date-to-days : (std/time/date/date) -> int, month-prefix : optional<string>, show-era : optional<(std/time/date/date) -> string>) -> calendar */ 

kk_std_time_calendar__calendar kk_std_time_calendar_solar_calendar(kk_string_t name0, kk_string_t long_name0, kk_function_t days_before_year, kk_function_t days_to_yeardoy, kk_function_t days_before_month, kk_function_t days_to_month, kk_std_core_types__optional epoch_shift, kk_std_core_types__optional has_year_zero, kk_std_core_types__optional month_prefix0, kk_std_core_types__optional show_era0, kk_context_t* _ctx); /* (name : string, long-name : string, days-before-year : (year : int) -> int, days-to-yeardoy : (days : int) -> (int, int), days-before-month : (year : int, month : int) -> int, days-to-month : (year : int, doy : int) -> int, epoch-shift : optional<int>, has-year-zero : optional<bool>, month-prefix : optional<string>, show-era : optional<(std/time/date/date) -> string>) -> calendar */ 

kk_std_time_calendar__calendar kk_std_time_calendar_solar_ecalendar(kk_string_t name0, kk_string_t long_name0, kk_function_t days_before_year, kk_function_t estimate_year, kk_function_t days_before_month, kk_function_t days_to_month, kk_std_core_types__optional epoch_shift, kk_std_core_types__optional has_year_zero, kk_std_core_types__optional month_prefix0, kk_std_core_types__optional show_era0, kk_context_t* _ctx); /* (name : string, long-name : string, days-before-year : (year : int) -> int, estimate-year : (days : int) -> (int, maybe<int>), days-before-month : (year : int, month : int) -> int, days-to-month : (year : int, doy : int) -> int, epoch-shift : optional<int>, has-year-zero : optional<bool>, month-prefix : optional<string>, show-era : optional<(std/time/date/date) -> string>) -> calendar */ 

kk_std_time_calendar__calendar kk_std_time_calendar_iso_calendar(kk_std_time_instant__timescale ___wildcard__455__26, kk_string_t name0, kk_std_core_types__optional long_name0, kk_context_t* _ctx); /* (std/time/instant/timescale, name : string, long-name : optional<string>) -> calendar */ 

extern kk_std_time_calendar__calendar kk_std_time_calendar_cal_iso;

kk_std_time_instant__instant kk_std_time_calendar_instant(kk_std_time_instant__timescale ts, kk_std_time_date__date d, kk_std_core_types__optional c, kk_std_core_types__optional tz, kk_std_core_types__optional cal, kk_context_t* _ctx); /* (ts : std/time/instant/timescale, d : std/time/date/date, c : optional<std/time/date/clock>, tz : optional<timezone>, cal : optional<calendar>) -> std/time/instant/instant */ 

kk_std_time_instant__instant kk_std_time_calendar__mlift4905_instant_1(kk_std_core_types__optional c, kk_std_core_types__optional cal, kk_std_time_date__date d, kk_std_core_types__optional tz, kk_std_time_instant__timescale _c_4885, kk_context_t* _ctx); /* (c : optional<std/time/date/clock>, cal : optional<calendar>, d : std/time/date/date, tz : optional<timezone>, std/time/instant/timescale) -> std/time/instant/instant */ 

kk_std_time_instant__instant kk_std_time_calendar_instant_1(kk_std_time_date__date d, kk_std_core_types__optional c, kk_std_core_types__optional tz, kk_std_core_types__optional cal, kk_std_core_types__optional ts, kk_context_t* _ctx); /* (d : std/time/date/date, c : optional<std/time/date/clock>, tz : optional<timezone>, cal : optional<calendar>, ts : optional<std/time/instant/timescale>) -> std/time/utc/utc std/time/instant/instant */ 

kk_std_time_instant__instant kk_std_time_calendar_instant_2(kk_std_time_instant__timescale ts, kk_integer_t year, kk_std_core_types__optional month, kk_std_core_types__optional day, kk_std_core_types__optional hours, kk_std_core_types__optional minutes, kk_std_core_types__optional seconds, kk_std_core_types__optional frac, kk_std_core_types__optional tz, kk_std_core_types__optional cal, kk_context_t* _ctx); /* (ts : std/time/instant/timescale, year : int, month : optional<int>, day : optional<int>, hours : optional<int>, minutes : optional<int>, seconds : optional<int>, frac : optional<double>, tz : optional<timezone>, cal : optional<calendar>) -> std/time/instant/instant */ 

kk_std_time_instant__instant kk_std_time_calendar__mlift4906_instant_3(kk_std_core_types__optional cal, kk_std_core_types__optional day, kk_std_core_types__optional frac, kk_std_core_types__optional hours, kk_std_core_types__optional minutes, kk_std_core_types__optional month, kk_std_core_types__optional seconds, kk_std_core_types__optional tz, kk_integer_t year, kk_std_time_instant__timescale _c_4887, kk_context_t* _ctx); /* (cal : optional<calendar>, day : optional<int>, frac : optional<double>, hours : optional<int>, minutes : optional<int>, month : optional<int>, seconds : optional<int>, tz : optional<timezone>, year : int, std/time/instant/timescale) -> std/time/instant/instant */ 

kk_std_time_instant__instant kk_std_time_calendar_instant_3(kk_integer_t year, kk_std_core_types__optional month, kk_std_core_types__optional day, kk_std_core_types__optional hours, kk_std_core_types__optional minutes, kk_std_core_types__optional seconds, kk_std_core_types__optional frac, kk_std_core_types__optional tz, kk_std_core_types__optional cal, kk_std_core_types__optional ts, kk_context_t* _ctx); /* (year : int, month : optional<int>, day : optional<int>, hours : optional<int>, minutes : optional<int>, seconds : optional<int>, frac : optional<double>, tz : optional<timezone>, cal : optional<calendar>, ts : optional<std/time/instant/timescale>) -> std/time/utc/utc std/time/instant/instant */ 

extern kk_std_time_calendar__calendar kk_std_time_calendar_cal_gregorian;

extern kk_std_time_calendar__calendar kk_std_time_calendar_cal_iso_sls;

kk_std_time_timestamp__timestamp kk_std_time_calendar_cal_timestamp(kk_std_time_calendar__calendar cal, kk_std_time_instant__timescale ts, kk_std_time_date__date d, kk_std_time_date__clock c, kk_context_t* _ctx); /* (cal : calendar, ts : std/time/instant/timescale, d : std/time/date/date, c : std/time/date/clock) -> std/time/timestamp/timestamp */ 

kk_std_time_calendar__calendar kk_std_time_calendar_cal_utc_create(kk_std_time_utc__leaps_table leaps, kk_context_t* _ctx); /* (leaps : std/time/utc/leaps-table) -> calendar */ 

kk_std_time_calendar__calendar kk_std_time_calendar_cal_utc_sls_create(kk_std_time_utc__leaps_table leaps, kk_context_t* _ctx); /* (leaps : std/time/utc/leaps-table) -> calendar */ 

kk_std_time_calendar__calendar kk_std_time_calendar_combine_earth_calendars(kk_string_t name0, kk_string_t long_name0, kk_std_time_date__date switch_date, kk_std_time_calendar__calendar cal1, kk_std_time_calendar__calendar cal2, kk_std_core_types__optional mb_show_era, kk_context_t* _ctx); /* (name : string, long-name : string, switch-date : std/time/date/date, cal1 : calendar, cal2 : calendar, mb-show-era : optional<maybe<(std/time/date/date) -> string>>) -> calendar */ 

kk_std_core_types__tuple4_ kk_std_time_calendar_instant_dc(kk_std_time_instant__instant i, kk_std_core_types__optional tz, kk_std_core_types__optional cal, kk_context_t* _ctx); /* (i : std/time/instant/instant, tz : optional<timezone>, cal : optional<calendar>) -> (std/time/date/date, std/time/date/clock, std/time/duration/duration, string) */ 

kk_std_time_calendar__timezone kk_std_time_calendar_tz_local(kk_context_t* _ctx); /* () -> ndet timezone */ 

kk_std_time_date__weekday kk_std_time_calendar_weekday(kk_std_time_date__date d, kk_std_time_calendar__calendar cal, kk_context_t* _ctx); /* (d : std/time/date/date, cal : calendar) -> std/time/date/weekday */ 

kk_std_time_calendar__calendar kk_std_time_calendar_year_shift_earth_calendar(kk_string_t name0, kk_string_t long_name0, kk_integer_t year_shift, kk_std_time_calendar__calendar cal, kk_std_core_types__optional month_prefix0, kk_std_core_types__optional show_era0, kk_context_t* _ctx); /* (name : string, long-name : string, year-shift : int, cal : calendar, month-prefix : optional<string>, show-era : optional<(std/time/date/date) -> string>) -> calendar */ 

void kk_std_time_calendar__init(kk_context_t* _ctx);


void kk_std_time_calendar__done(kk_context_t* _ctx);

#endif // header
