// Koka generated module: "std/time/chrono", koka version: 2.2.1
#include "std_time_chrono.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/

static kk_std_core_types__tuple2_ kk_time_unix_now_tuple(kk_context_t* ctx) {
  double frac;
  double secs = kk_time_unix_now(&frac,ctx);
  return kk_std_core_types__new_dash__lp__comma__rp_( kk_double_box(secs,ctx), kk_double_box(frac,ctx), ctx );
}

 
// Returns a unix time stamp as seconds and fraction of seconds;
// The fraction of seconds is for added precision if necessary,
// and can be larger than one to indicate leap seconds.
// This still needs to be adjusted to our epoch and taking account of leap seconds.

kk_std_core_types__tuple2_ kk_std_time_chrono_unix_now(kk_context_t* _ctx) { /* () -> ndet (double, double) */ 
  return kk_time_unix_now_tuple(kk_context());
}

double kk_std_time_chrono_xnow_resolution(kk_context_t* _ctx) { /* () -> ndet double */ 
  return kk_time_resolution(kk_context());
}
 
// The current `:instant` in time as returned by the system clock
// in an optional time scale `ts` (`= ts-ti`).
//
// This uses the best available system clock for the requested
// timescale. For example
// it uses [``CLOCK_UTC``](http://www.madore.org/~david/computers/unix-leap-seconds.html)
// when available to get proper UTC time, or ``CLOCK_TAI`` for TAI time.
//
// Otherwise, it usually uses Unix (POSIX) time (``CLOCK_REALTIME``).
// Unfortunately, most operating systems cannot not report time in leap
// seconds accurately. The `now` function is limited by the OS in this case.
//
// To guard against inaccurate clocks and increase monotonicity,
// the `now` function guarantees that if the current measurement is
// upto 1 second in the past with regard to the previous call to `now`,
// that the returned instant is monotonic by adding nano seconds to the
// previous measurement until the system clock catches up again.
//
// This is effective in particular on older OS's where the time sometimes jumps
// back one second after a leap second. By limiting the adjustment to at most
// one second it ensures the clock catches up soon and does not affect the user
// setting a new time in the past.

kk_std_time_instant__instant kk_std_time_chrono_now_in(kk_std_core_types__optional ts, kk_context_t* _ctx) { /* (ts : optional<std/time/instant/timescale>) -> ndet std/time/instant/instant */ 
  kk_std_core_types__tuple2_ _match_149 = kk_std_time_chrono_unix_now(_ctx); /*(double, double)*/;
  kk_box_t _box_x116 = _match_149.fst;
  kk_box_t _box_x117 = _match_149.snd;
  double secs = kk_double_unbox(_box_x116, NULL);
  double frac = kk_double_unbox(_box_x117, NULL);
  kk_std_core_types__tuple2__drop(_match_149, _ctx);
  kk_Unit;
  kk_std_core_types__optional _x153;
  double _b_121_118 = frac; /*double*/;
  _x153 = kk_std_core_types__new_Optional(kk_double_box(_b_121_118, _ctx), _ctx); /*optional<106>*/
  kk_std_core_types__optional _x154;
  kk_std_time_instant__timescale _b_122_120;
  if (kk_std_core_types__is_Optional(ts)) {
    kk_box_t _box_x119 = ts._cons.Optional.value;
    kk_std_time_instant__timescale _ts_37 = kk_std_time_instant__timescale_unbox(_box_x119, NULL);
    kk_std_time_instant__timescale_dup(_ts_37);
    kk_std_core_types__optional_drop(ts, _ctx);
    kk_Unit;
    _b_122_120 = _ts_37; /*std/time/instant/timescale*/
    goto _match155;
  }
  _b_122_120 = kk_std_time_instant__timescale_dup(kk_std_time_utc_ts_ti); /*std/time/instant/timescale*/
  _match155: ;
  _x154 = kk_std_core_types__new_Optional(kk_std_time_instant__timescale_box(_b_122_120, _ctx), _ctx); /*optional<106>*/
  return kk_std_time_utc_unix_instant(secs, _x153, _x154, _ctx);
}
 
// monadic lift

kk_std_time_instant__instant kk_std_time_chrono__mlift105_now(kk_std_time_instant__timescale _y_103, kk_context_t* _ctx) { /* (std/time/instant/timescale) -> std/time/utc/utc std/time/instant/instant */ 
  kk_evv_t w = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<(<>)>*/;
  kk_std_time_instant__instant x;
  kk_std_core_types__tuple2_ _match_148 = kk_std_time_chrono_unix_now(_ctx); /*(double, double)*/;
  kk_box_t _box_x123 = _match_148.fst;
  kk_box_t _box_x124 = _match_148.snd;
  double secs = kk_double_unbox(_box_x123, NULL);
  double frac = kk_double_unbox(_box_x124, NULL);
  kk_std_core_types__tuple2__drop(_match_148, _ctx);
  kk_Unit;
  kk_std_core_types__optional _x159 = kk_std_core_types__new_Optional(kk_double_box(frac, _ctx), _ctx); /*optional<106>*/
  kk_std_core_types__optional _x160 = kk_std_core_types__new_Optional(kk_std_time_instant__timescale_box(_y_103, _ctx), _ctx); /*optional<106>*/
  x = kk_std_time_utc_unix_instant(secs, _x159, _x160, _ctx); /*std/time/instant/instant*/
  kk_unit_t keep = kk_Unit;
  kk_evv_set(w,kk_context());
  return x;
}
 
// The current `:instant` in time as returned by the system clock
// in the UTC timescale. Equivalent to `now-in(utc())`, see
// `now-in` for further information about the system clock.


// lift anonymous function
struct kk_std_time_chrono_now_fun166__t {
  struct kk_function_s _base;
};
static kk_std_time_instant__instant kk_std_time_chrono_now_fun166(kk_function_t _fself, kk_std_time_instant__timescale _x1165, kk_context_t* _ctx);
static kk_function_t kk_std_time_chrono_new_now_fun166(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_time_chrono_now_fun166, _ctx)
  return kk_function_dup(_fself);
}

static kk_std_time_instant__instant kk_std_time_chrono_now_fun166(kk_function_t _fself, kk_std_time_instant__timescale _x1165, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_time_chrono__mlift105_now(_x1165, _ctx);
}


// lift anonymous function
struct kk_std_time_chrono_now_fun168__t {
  struct kk_function_s _base;
  kk_function_t _b_143_135;
};
static kk_box_t kk_std_time_chrono_now_fun168(kk_function_t _fself, kk_box_t _b_136, kk_context_t* _ctx);
static kk_function_t kk_std_time_chrono_new_now_fun168(kk_function_t _b_143_135, kk_context_t* _ctx) {
  struct kk_std_time_chrono_now_fun168__t* _self = kk_function_alloc_as(struct kk_std_time_chrono_now_fun168__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_time_chrono_now_fun168, kk_context());
  _self->_b_143_135 = _b_143_135;
  return &_self->_base;
}

static kk_box_t kk_std_time_chrono_now_fun168(kk_function_t _fself, kk_box_t _b_136, kk_context_t* _ctx) {
  struct kk_std_time_chrono_now_fun168__t* _self = kk_function_as(struct kk_std_time_chrono_now_fun168__t*, _fself);
  kk_function_t _b_143_135 = _self->_b_143_135; /* (std/time/instant/timescale) -> std/time/utc/utc std/time/instant/instant */
  kk_drop_match(_self, {kk_function_dup(_b_143_135);}, {}, _ctx)
  kk_std_time_instant__instant _x169;
  kk_std_time_instant__timescale _x170 = kk_std_time_instant__timescale_unbox(_b_136, _ctx); /*std/time/instant/timescale*/
  _x169 = kk_function_call(kk_std_time_instant__instant, (kk_function_t, kk_std_time_instant__timescale, kk_context_t*), _b_143_135, (_b_143_135, _x170, _ctx)); /*std/time/instant/instant*/
  return kk_std_time_instant__instant_box(_x169, _ctx);
}

kk_std_time_instant__instant kk_std_time_chrono_now(kk_context_t* _ctx) { /* () -> <ndet,std/time/utc/utc> std/time/instant/instant */ 
  kk_std_core_hnd__ev ev_111;
  kk_ssize_t _x161 = ((kk_ssize_t)0); /*ssize_t*/
  ev_111 = kk_evv_at(_x161,kk_context()); /*std/core/hnd/ev<std/time/utc/.hnd-utc>*/
  kk_std_time_instant__timescale x_108;
  kk_box_t _x162;
  struct kk_std_core_hnd_Ev* _con163 = kk_std_core_hnd__as_Ev(ev_111);
  kk_std_core_hnd__marker m0 = _con163->marker;
  kk_box_t _box_x129 = _con163->hnd;
  kk_std_time_utc__hnd_utc h = kk_std_time_utc__hnd_utc_unbox(_box_x129, NULL);
  kk_std_time_utc__hnd_utc_dup(h);
  kk_std_core_hnd__clause0 _match_146;
  kk_std_core_hnd__clause0 _borrowApp_147 = kk_std_time_utc__select_utc(h, _ctx); /*std/core/hnd/clause0<std/time/instant/timescale,std/time/utc/.hnd-utc,277,278>*/;
  kk_std_time_utc__hnd_utc_drop(h, _ctx);
  _match_146 = _borrowApp_147; /*std/core/hnd/clause0<std/time/instant/timescale,std/time/utc/.hnd-utc,277,278>*/
  kk_function_t _fun_unbox_x132 = _match_146.clause;
  _x162 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_context_t*), _fun_unbox_x132, (_fun_unbox_x132, m0, ev_111, _ctx)); /*37*/
  x_108 = kk_std_time_instant__timescale_unbox(_x162, _ctx); /*std/time/instant/timescale*/
  if (kk_yielding(kk_context())) {
    kk_std_time_instant__timescale_dropn(x_108, ((int32_t)10), _ctx);
    kk_function_t _b_143_135 = kk_std_time_chrono_new_now_fun166(_ctx); /*(std/time/instant/timescale) -> std/time/utc/utc std/time/instant/instant*/;
    kk_box_t _x167 = kk_std_core_hnd_yield_extend(kk_std_time_chrono_new_now_fun168(_b_143_135, _ctx), _ctx); /*3858*/
    return kk_std_time_instant__instant_unbox(_x167, _ctx);
  }
  kk_evv_t w = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<(<>)>*/;
  kk_std_time_instant__instant x0;
  kk_std_core_types__tuple2_ _match_145 = kk_std_time_chrono_unix_now(_ctx); /*(double, double)*/;
  kk_box_t _box_x137 = _match_145.fst;
  kk_box_t _box_x138 = _match_145.snd;
  double secs = kk_double_unbox(_box_x137, NULL);
  double frac = kk_double_unbox(_box_x138, NULL);
  kk_std_core_types__tuple2__drop(_match_145, _ctx);
  kk_Unit;
  kk_std_core_types__optional _x173 = kk_std_core_types__new_Optional(kk_double_box(frac, _ctx), _ctx); /*optional<106>*/
  kk_std_core_types__optional _x174 = kk_std_core_types__new_Optional(kk_std_time_instant__timescale_box(x_108, _ctx), _ctx); /*optional<106>*/
  x0 = kk_std_time_utc_unix_instant(secs, _x173, _x174, _ctx); /*std/time/instant/instant*/
  kk_unit_t keep = kk_Unit;
  kk_evv_set(w,kk_context());
  return x0;
}

// initialization
void kk_std_time_chrono__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core__init(_ctx);
  kk_std_num_ddouble__init(_ctx);
  kk_std_time_duration__init(_ctx);
  kk_std_time_instant__init(_ctx);
  kk_std_time_utc__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
}

// termination
void kk_std_time_chrono__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_time_utc__done(_ctx);
  kk_std_time_instant__done(_ctx);
  kk_std_time_duration__done(_ctx);
  kk_std_num_ddouble__done(_ctx);
  kk_std_core__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
