// Koka generated module: "std/time/timer", koka version: 2.2.1
#include "std_time_timer.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/

static kk_std_core_types__tuple2_ kk_timer_ticks_tuple(kk_context_t* ctx) {
  double frac;
  double secs = kk_timer_ticks(&frac,ctx);
  return kk_std_core_types__new_dash__lp__comma__rp_( kk_double_box(secs,ctx), kk_double_box(frac,ctx), ctx );
}


kk_std_core_types__tuple2_ kk_std_time_timer_xticks(kk_context_t* _ctx) { /* () -> ndet (double, double) */ 
  return kk_timer_ticks_tuple(kk_context());
}
 
// Return the smallest time difference in seconds that `ticks` can measure.

double kk_std_time_timer_xticks_resolution(kk_context_t* _ctx) { /* () -> ndet double */ 
  return kk_timer_resolution(kk_context());
}
 
// Return a high-resolution time stamp in fractional SI seconds.
// The duration is guaranteed to be monotonically increasing
// and have at least millisecond resolution.

kk_std_time_duration__duration kk_std_time_timer_ticks(kk_context_t* _ctx) { /* () -> ndet std/time/duration/duration */ 
  kk_std_core_types__tuple2_ _match_413 = kk_std_time_timer_xticks(_ctx); /*(double, double)*/;
  kk_box_t _box_x341 = _match_413.fst;
  kk_box_t _box_x342 = _match_413.snd;
  double secs = kk_double_unbox(_box_x341, NULL);
  double frac = kk_double_unbox(_box_x342, NULL);
  kk_std_core_types__tuple2__drop(_match_413, _ctx);
  kk_Unit;
  kk_integer_t secs0_316;
  double _x419;
  bool _match_416 = (secs >= (0.0)); /*bool*/;
  if (_match_416) {
    _x419 = floor(secs); /*double*/
  }
  else {
    _x419 = ceil(secs); /*double*/
  }
  secs0_316 = kk_integer_from_double(_x419,kk_context()); /*int*/
  double _b_344_343;
  double _x420 = kk_std_num_double_fraction(secs, _ctx); /*double*/
  _b_344_343 = (_x420 + frac); /*double*/
  kk_std_num_ddouble__ddouble _x421;
  kk_std_core_types__optional frac0_1361;
  kk_box_t _x422;
  double _x423;
  kk_std_core_types__optional _match_415 = kk_std_core_types__new_Optional(kk_double_box(_b_344_343, _ctx), _ctx); /*optional<106>*/;
  if (kk_std_core_types__is_Optional(_match_415)) {
    kk_box_t _box_x345 = _match_415._cons.Optional.value;
    double _frac_162 = kk_double_unbox(_box_x345, NULL);
    kk_std_core_types__optional_drop(_match_415, _ctx);
    kk_Unit;
    _x423 = _frac_162; /*double*/
    goto _match424;
  }
  _x423 = 0.0; /*double*/
  _match424: ;
  _x422 = kk_double_box(_x423, _ctx); /*106*/
  frac0_1361 = kk_std_core_types__new_Optional(_x422, _ctx); /*optional<double>*/
  bool _match_414;
  double _x426;
  if (kk_std_core_types__is_Optional(frac0_1361)) {
    kk_box_t _box_x348 = frac0_1361._cons.Optional.value;
    double _frac_788 = kk_double_unbox(_box_x348, NULL);
    _x426 = _frac_788; /*double*/
    goto _match427;
  }
  _x426 = 0.0; /*double*/
  _match427: ;
  _match_414 = (_x426 == (0.0)); /*bool*/
  if (_match_414) {
    kk_std_core_types__optional_drop(frac0_1361, _ctx);
    _x421 = kk_std_num_ddouble_ddouble_int_exp(secs0_316, kk_integer_from_small(0), _ctx); /*std/num/ddouble/ddouble*/
  }
  else {
    kk_std_num_ddouble__ddouble _x429 = kk_std_num_ddouble_ddouble_int_exp(secs0_316, kk_integer_from_small(0), _ctx); /*std/num/ddouble/ddouble*/
    kk_std_num_ddouble__ddouble _x430;
    double _x431;
    if (kk_std_core_types__is_Optional(frac0_1361)) {
      kk_box_t _box_x349 = frac0_1361._cons.Optional.value;
      double _frac_7880 = kk_double_unbox(_box_x349, NULL);
      kk_std_core_types__optional_drop(frac0_1361, _ctx);
      kk_Unit;
      _x431 = _frac_7880; /*double*/
      goto _match432;
    }
    _x431 = 0.0; /*double*/
    _match432: ;
    _x430 = kk_std_num_ddouble__new_Ddouble(_x431, 0.0, _ctx); /*std/num/ddouble/ddouble*/
    _x421 = kk_std_num_ddouble__lp__plus__rp_(_x429, _x430, _ctx); /*std/num/ddouble/ddouble*/
  }
  return kk_std_time_duration__new_Duration(_x421, _ctx);
}
 
// monadic lift

kk_std_core_types__tuple2_ kk_std_time_timer__mlift331_elapsed(kk_std_time_duration__duration t0, kk_box_t x, kk_context_t* _ctx) { /* forall<a,e> (t0 : std/time/duration/duration, x : a) -> <ndet|e> (std/time/duration/duration, a) */ 
  kk_std_time_duration__duration t1;
  kk_std_core_types__tuple2_ _match_409 = kk_std_time_timer_xticks(_ctx); /*(double, double)*/;
  kk_box_t _box_x350 = _match_409.fst;
  kk_box_t _box_x351 = _match_409.snd;
  double secs1 = kk_double_unbox(_box_x350, NULL);
  double frac1 = kk_double_unbox(_box_x351, NULL);
  kk_std_core_types__tuple2__drop(_match_409, _ctx);
  kk_Unit;
  kk_integer_t secs00_322;
  double _x436;
  bool _match_412 = (secs1 >= (0.0)); /*bool*/;
  if (_match_412) {
    _x436 = floor(secs1); /*double*/
  }
  else {
    _x436 = ceil(secs1); /*double*/
  }
  secs00_322 = kk_integer_from_double(_x436,kk_context()); /*int*/
  double _b_353_352;
  double _x437 = kk_std_num_double_fraction(secs1, _ctx); /*double*/
  _b_353_352 = (_x437 + frac1); /*double*/
  kk_std_num_ddouble__ddouble _x438;
  kk_std_core_types__optional frac0_13610;
  kk_box_t _x439;
  double _x440;
  kk_std_core_types__optional _match_411 = kk_std_core_types__new_Optional(kk_double_box(_b_353_352, _ctx), _ctx); /*optional<106>*/;
  if (kk_std_core_types__is_Optional(_match_411)) {
    kk_box_t _box_x354 = _match_411._cons.Optional.value;
    double _frac_1620 = kk_double_unbox(_box_x354, NULL);
    kk_std_core_types__optional_drop(_match_411, _ctx);
    kk_Unit;
    _x440 = _frac_1620; /*double*/
    goto _match441;
  }
  _x440 = 0.0; /*double*/
  _match441: ;
  _x439 = kk_double_box(_x440, _ctx); /*106*/
  frac0_13610 = kk_std_core_types__new_Optional(_x439, _ctx); /*optional<double>*/
  bool _match_410;
  double _x443;
  if (kk_std_core_types__is_Optional(frac0_13610)) {
    kk_box_t _box_x357 = frac0_13610._cons.Optional.value;
    double _frac_7881 = kk_double_unbox(_box_x357, NULL);
    _x443 = _frac_7881; /*double*/
    goto _match444;
  }
  _x443 = 0.0; /*double*/
  _match444: ;
  _match_410 = (_x443 == (0.0)); /*bool*/
  if (_match_410) {
    kk_std_core_types__optional_drop(frac0_13610, _ctx);
    _x438 = kk_std_num_ddouble_ddouble_int_exp(secs00_322, kk_integer_from_small(0), _ctx); /*std/num/ddouble/ddouble*/
  }
  else {
    kk_std_num_ddouble__ddouble _x446 = kk_std_num_ddouble_ddouble_int_exp(secs00_322, kk_integer_from_small(0), _ctx); /*std/num/ddouble/ddouble*/
    kk_std_num_ddouble__ddouble _x447;
    double _x448;
    if (kk_std_core_types__is_Optional(frac0_13610)) {
      kk_box_t _box_x358 = frac0_13610._cons.Optional.value;
      double _frac_78800 = kk_double_unbox(_box_x358, NULL);
      kk_std_core_types__optional_drop(frac0_13610, _ctx);
      kk_Unit;
      _x448 = _frac_78800; /*double*/
      goto _match449;
    }
    _x448 = 0.0; /*double*/
    _match449: ;
    _x447 = kk_std_num_ddouble__new_Ddouble(_x448, 0.0, _ctx); /*std/num/ddouble/ddouble*/
    _x438 = kk_std_num_ddouble__lp__plus__rp_(_x446, _x447, _ctx); /*std/num/ddouble/ddouble*/
  }
  t1 = kk_std_time_duration__new_Duration(_x438, _ctx); /*std/time/duration/duration*/
  kk_std_time_duration__duration _b_361_359 = kk_std_time_duration__lp__dash__rp_(t1, t0, _ctx); /*std/time/duration/duration*/;
  kk_box_t _b_362_360 = x; /*163*/;
  return kk_std_core_types__new_dash__lp__comma__rp_(kk_std_time_duration__duration_box(_b_361_359, _ctx), _b_362_360, _ctx);
}
 
// Return the number of fractional seconds that it takes to evaluate `action`.


// lift anonymous function
struct kk_std_time_timer_elapsed_fun468__t {
  struct kk_function_s _base;
  kk_std_time_duration__duration t0;
};
static kk_std_core_types__tuple2_ kk_std_time_timer_elapsed_fun468(kk_function_t _fself, kk_box_t x0, kk_context_t* _ctx);
static kk_function_t kk_std_time_timer_new_elapsed_fun468(kk_std_time_duration__duration t0, kk_context_t* _ctx) {
  struct kk_std_time_timer_elapsed_fun468__t* _self = kk_function_alloc_as(struct kk_std_time_timer_elapsed_fun468__t, 1, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_time_timer_elapsed_fun468, kk_context());
  _self->t0 = t0;
  return &_self->_base;
}

static kk_std_core_types__tuple2_ kk_std_time_timer_elapsed_fun468(kk_function_t _fself, kk_box_t x0, kk_context_t* _ctx) {
  struct kk_std_time_timer_elapsed_fun468__t* _self = kk_function_as(struct kk_std_time_timer_elapsed_fun468__t*, _fself);
  kk_std_time_duration__duration t0 = _self->t0; /* std/time/duration/duration */
  kk_drop_match(_self, {kk_std_time_duration__duration_dup(t0);}, {}, _ctx)
  return kk_std_time_timer__mlift331_elapsed(t0, x0, _ctx);
}


// lift anonymous function
struct kk_std_time_timer_elapsed_fun470__t {
  struct kk_function_s _base;
  kk_function_t _b_385_372;
};
static kk_box_t kk_std_time_timer_elapsed_fun470(kk_function_t _fself, kk_box_t _b_373, kk_context_t* _ctx);
static kk_function_t kk_std_time_timer_new_elapsed_fun470(kk_function_t _b_385_372, kk_context_t* _ctx) {
  struct kk_std_time_timer_elapsed_fun470__t* _self = kk_function_alloc_as(struct kk_std_time_timer_elapsed_fun470__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_time_timer_elapsed_fun470, kk_context());
  _self->_b_385_372 = _b_385_372;
  return &_self->_base;
}

static kk_box_t kk_std_time_timer_elapsed_fun470(kk_function_t _fself, kk_box_t _b_373, kk_context_t* _ctx) {
  struct kk_std_time_timer_elapsed_fun470__t* _self = kk_function_as(struct kk_std_time_timer_elapsed_fun470__t*, _fself);
  kk_function_t _b_385_372 = _self->_b_385_372; /* (x0 : 163) -> <ndet|164> (std/time/duration/duration, 163) */
  kk_drop_match(_self, {kk_function_dup(_b_385_372);}, {}, _ctx)
  kk_std_core_types__tuple2_ _x471 = kk_function_call(kk_std_core_types__tuple2_, (kk_function_t, kk_box_t, kk_context_t*), _b_385_372, (_b_385_372, _b_373, _ctx)); /*(std/time/duration/duration, 163)*/
  return kk_std_core_types__tuple2__box(_x471, _ctx);
}

kk_std_core_types__tuple2_ kk_std_time_timer_elapsed(kk_function_t action, kk_context_t* _ctx) { /* forall<a,e> (action : () -> <ndet|e> a) -> <ndet|e> (std/time/duration/duration, a) */ 
  kk_std_time_duration__duration t0;
  kk_std_core_types__tuple2_ _match_405 = kk_std_time_timer_xticks(_ctx); /*(double, double)*/;
  kk_box_t _box_x363 = _match_405.fst;
  kk_box_t _box_x364 = _match_405.snd;
  double secs = kk_double_unbox(_box_x363, NULL);
  double frac = kk_double_unbox(_box_x364, NULL);
  kk_std_core_types__tuple2__drop(_match_405, _ctx);
  kk_Unit;
  kk_integer_t secs0_319;
  double _x453;
  bool _match_408 = (secs >= (0.0)); /*bool*/;
  if (_match_408) {
    _x453 = floor(secs); /*double*/
  }
  else {
    _x453 = ceil(secs); /*double*/
  }
  secs0_319 = kk_integer_from_double(_x453,kk_context()); /*int*/
  double _b_366_365;
  double _x454 = kk_std_num_double_fraction(secs, _ctx); /*double*/
  _b_366_365 = (_x454 + frac); /*double*/
  kk_std_num_ddouble__ddouble _x455;
  kk_std_core_types__optional frac0_1361;
  kk_box_t _x456;
  double _x457;
  kk_std_core_types__optional _match_407 = kk_std_core_types__new_Optional(kk_double_box(_b_366_365, _ctx), _ctx); /*optional<106>*/;
  if (kk_std_core_types__is_Optional(_match_407)) {
    kk_box_t _box_x367 = _match_407._cons.Optional.value;
    double _frac_162 = kk_double_unbox(_box_x367, NULL);
    kk_std_core_types__optional_drop(_match_407, _ctx);
    kk_Unit;
    _x457 = _frac_162; /*double*/
    goto _match458;
  }
  _x457 = 0.0; /*double*/
  _match458: ;
  _x456 = kk_double_box(_x457, _ctx); /*106*/
  frac0_1361 = kk_std_core_types__new_Optional(_x456, _ctx); /*optional<double>*/
  bool _match_406;
  double _x460;
  if (kk_std_core_types__is_Optional(frac0_1361)) {
    kk_box_t _box_x370 = frac0_1361._cons.Optional.value;
    double _frac_788 = kk_double_unbox(_box_x370, NULL);
    _x460 = _frac_788; /*double*/
    goto _match461;
  }
  _x460 = 0.0; /*double*/
  _match461: ;
  _match_406 = (_x460 == (0.0)); /*bool*/
  if (_match_406) {
    kk_std_core_types__optional_drop(frac0_1361, _ctx);
    _x455 = kk_std_num_ddouble_ddouble_int_exp(secs0_319, kk_integer_from_small(0), _ctx); /*std/num/ddouble/ddouble*/
  }
  else {
    kk_std_num_ddouble__ddouble _x463 = kk_std_num_ddouble_ddouble_int_exp(secs0_319, kk_integer_from_small(0), _ctx); /*std/num/ddouble/ddouble*/
    kk_std_num_ddouble__ddouble _x464;
    double _x465;
    if (kk_std_core_types__is_Optional(frac0_1361)) {
      kk_box_t _box_x371 = frac0_1361._cons.Optional.value;
      double _frac_7880 = kk_double_unbox(_box_x371, NULL);
      kk_std_core_types__optional_drop(frac0_1361, _ctx);
      kk_Unit;
      _x465 = _frac_7880; /*double*/
      goto _match466;
    }
    _x465 = 0.0; /*double*/
    _match466: ;
    _x464 = kk_std_num_ddouble__new_Ddouble(_x465, 0.0, _ctx); /*std/num/ddouble/ddouble*/
    _x455 = kk_std_num_ddouble__lp__plus__rp_(_x463, _x464, _ctx); /*std/num/ddouble/ddouble*/
  }
  t0 = kk_std_time_duration__new_Duration(_x455, _ctx); /*std/time/duration/duration*/
  kk_box_t x_333 = kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), action, (action, _ctx)); /*163*/;
  if (kk_yielding(kk_context())) {
    kk_box_drop(x_333, _ctx);
    kk_function_t _b_385_372 = kk_std_time_timer_new_elapsed_fun468(t0, _ctx); /*(x0 : 163) -> <ndet|164> (std/time/duration/duration, 163)*/;
    kk_box_t _x469 = kk_std_core_hnd_yield_extend(kk_std_time_timer_new_elapsed_fun470(_b_385_372, _ctx), _ctx); /*3858*/
    return kk_std_core_types__tuple2__unbox(_x469, _ctx);
  }
  kk_std_time_duration__duration t1;
  kk_std_core_types__tuple2_ _match_401 = kk_std_time_timer_xticks(_ctx); /*(double, double)*/;
  kk_box_t _box_x374 = _match_401.fst;
  kk_box_t _box_x375 = _match_401.snd;
  double secs1 = kk_double_unbox(_box_x374, NULL);
  double frac1 = kk_double_unbox(_box_x375, NULL);
  kk_std_core_types__tuple2__drop(_match_401, _ctx);
  kk_Unit;
  kk_integer_t secs00_322;
  double _x474;
  bool _match_404 = (secs1 >= (0.0)); /*bool*/;
  if (_match_404) {
    _x474 = floor(secs1); /*double*/
  }
  else {
    _x474 = ceil(secs1); /*double*/
  }
  secs00_322 = kk_integer_from_double(_x474,kk_context()); /*int*/
  double _b_377_376;
  double _x475 = kk_std_num_double_fraction(secs1, _ctx); /*double*/
  _b_377_376 = (_x475 + frac1); /*double*/
  kk_std_num_ddouble__ddouble _x476;
  kk_std_core_types__optional frac0_13610;
  kk_box_t _x477;
  double _x478;
  kk_std_core_types__optional _match_403 = kk_std_core_types__new_Optional(kk_double_box(_b_377_376, _ctx), _ctx); /*optional<106>*/;
  if (kk_std_core_types__is_Optional(_match_403)) {
    kk_box_t _box_x378 = _match_403._cons.Optional.value;
    double _frac_1620 = kk_double_unbox(_box_x378, NULL);
    kk_std_core_types__optional_drop(_match_403, _ctx);
    kk_Unit;
    _x478 = _frac_1620; /*double*/
    goto _match479;
  }
  _x478 = 0.0; /*double*/
  _match479: ;
  _x477 = kk_double_box(_x478, _ctx); /*106*/
  frac0_13610 = kk_std_core_types__new_Optional(_x477, _ctx); /*optional<double>*/
  bool _match_402;
  double _x481;
  if (kk_std_core_types__is_Optional(frac0_13610)) {
    kk_box_t _box_x381 = frac0_13610._cons.Optional.value;
    double _frac_7881 = kk_double_unbox(_box_x381, NULL);
    _x481 = _frac_7881; /*double*/
    goto _match482;
  }
  _x481 = 0.0; /*double*/
  _match482: ;
  _match_402 = (_x481 == (0.0)); /*bool*/
  if (_match_402) {
    kk_std_core_types__optional_drop(frac0_13610, _ctx);
    _x476 = kk_std_num_ddouble_ddouble_int_exp(secs00_322, kk_integer_from_small(0), _ctx); /*std/num/ddouble/ddouble*/
  }
  else {
    kk_std_num_ddouble__ddouble _x484 = kk_std_num_ddouble_ddouble_int_exp(secs00_322, kk_integer_from_small(0), _ctx); /*std/num/ddouble/ddouble*/
    kk_std_num_ddouble__ddouble _x485;
    double _x486;
    if (kk_std_core_types__is_Optional(frac0_13610)) {
      kk_box_t _box_x382 = frac0_13610._cons.Optional.value;
      double _frac_78800 = kk_double_unbox(_box_x382, NULL);
      kk_std_core_types__optional_drop(frac0_13610, _ctx);
      kk_Unit;
      _x486 = _frac_78800; /*double*/
      goto _match487;
    }
    _x486 = 0.0; /*double*/
    _match487: ;
    _x485 = kk_std_num_ddouble__new_Ddouble(_x486, 0.0, _ctx); /*std/num/ddouble/ddouble*/
    _x476 = kk_std_num_ddouble__lp__plus__rp_(_x484, _x485, _ctx); /*std/num/ddouble/ddouble*/
  }
  t1 = kk_std_time_duration__new_Duration(_x476, _ctx); /*std/time/duration/duration*/
  kk_std_time_duration__duration _b_386_383 = kk_std_time_duration__lp__dash__rp_(t1, t0, _ctx); /*std/time/duration/duration*/;
  kk_box_t _b_387_384 = x_333; /*163*/;
  return kk_std_core_types__new_dash__lp__comma__rp_(kk_std_time_duration__duration_box(_b_386_383, _ctx), _b_387_384, _ctx);
}
 
// monadic lift

kk_box_t kk_std_time_timer__mlift332_print_elapsed(kk_std_core_types__optional msg, kk_std_core_types__tuple2_ _y_327, kk_context_t* _ctx) { /* forall<a,e> (msg : optional<string>, (std/time/duration/duration, a)) -> <ndet,console|e> a */ 
  kk_box_t _box_x388 = _y_327.fst;
  kk_box_t x = _y_327.snd;
  kk_std_time_duration__duration t = kk_std_time_duration__duration_unbox(_box_x388, NULL);
  kk_box_dup(x);
  kk_std_core_types__tuple2__drop(_y_327, _ctx);
  kk_Unit;
  kk_unit_t __ = kk_Unit;
  kk_string_t _x490;
  kk_string_t _x491;
  if (kk_std_core_types__is_Optional(msg)) {
    kk_box_t _box_x389 = msg._cons.Optional.value;
    kk_string_t _msg_170 = kk_string_unbox(_box_x389);
    kk_string_dup(_msg_170);
    kk_std_core_types__optional_drop(msg, _ctx);
    kk_Unit;
    _x491 = _msg_170; /*string*/
    goto _match492;
  }
  kk_define_string_literal(, _s494, 7, "elapsed")
  _x491 = kk_string_dup(_s494); /*string*/
  _match492: ;
  kk_string_t _x495;
  kk_string_t _x496;
  kk_define_string_literal(, _s497, 1, " ")
  _x496 = kk_string_dup(_s497); /*string*/
  kk_string_t _x498;
  kk_string_t _x499;
  kk_std_num_ddouble__ddouble _x500;
  kk_std_num_ddouble__ddouble _x = t.secs;
  _x500 = _x; /*std/time/timestamp/timespan*/
  kk_std_core_types__optional _x501;
  kk_integer_t _b_391_390;
  kk_integer_t _x502 = kk_integer_abs((kk_integer_from_small(3)),kk_context()); /*int*/
  _b_391_390 = kk_integer_neg(_x502,kk_context()); /*int*/
  _x501 = kk_std_core_types__new_Optional(kk_integer_box(_b_391_390), _ctx); /*optional<106>*/
  _x499 = kk_std_num_ddouble_show_fixed(_x500, _x501, _ctx); /*string*/
  kk_string_t _x503;
  kk_define_string_literal(, _s504, 1, "s")
  _x503 = kk_string_dup(_s504); /*string*/
  _x498 = kk_std_core__lp__plus__plus__1_rp_(_x499, _x503, _ctx); /*string*/
  _x495 = kk_std_core__lp__plus__plus__1_rp_(_x496, _x498, _ctx); /*string*/
  _x490 = kk_std_core__lp__plus__plus__1_rp_(_x491, _x495, _ctx); /*string*/
  kk_std_core_printsln(_x490, _ctx);
  return x;
}
 
// Measure the number of fractional seconds that it takes to evaluate `action`, and print `msg` postfixed with the
// measured time in millisecond resolution.


// lift anonymous function
struct kk_std_time_timer_print_elapsed_fun505__t {
  struct kk_function_s _base;
  kk_std_core_types__optional msg;
};
static kk_box_t kk_std_time_timer_print_elapsed_fun505(kk_function_t _fself, kk_std_core_types__tuple2_ _y_327, kk_context_t* _ctx);
static kk_function_t kk_std_time_timer_new_print_elapsed_fun505(kk_std_core_types__optional msg, kk_context_t* _ctx) {
  struct kk_std_time_timer_print_elapsed_fun505__t* _self = kk_function_alloc_as(struct kk_std_time_timer_print_elapsed_fun505__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_time_timer_print_elapsed_fun505, kk_context());
  _self->msg = msg;
  return &_self->_base;
}

static kk_box_t kk_std_time_timer_print_elapsed_fun505(kk_function_t _fself, kk_std_core_types__tuple2_ _y_327, kk_context_t* _ctx) {
  struct kk_std_time_timer_print_elapsed_fun505__t* _self = kk_function_as(struct kk_std_time_timer_print_elapsed_fun505__t*, _fself);
  kk_std_core_types__optional msg = _self->msg; /* optional<string> */
  kk_drop_match(_self, {kk_std_core_types__optional_dup(msg);}, {}, _ctx)
  return kk_std_time_timer__mlift332_print_elapsed(msg, _y_327, _ctx);
}


// lift anonymous function
struct kk_std_time_timer_print_elapsed_fun506__t {
  struct kk_function_s _base;
  kk_function_t _b_398_392;
};
static kk_box_t kk_std_time_timer_print_elapsed_fun506(kk_function_t _fself, kk_box_t _b_393, kk_context_t* _ctx);
static kk_function_t kk_std_time_timer_new_print_elapsed_fun506(kk_function_t _b_398_392, kk_context_t* _ctx) {
  struct kk_std_time_timer_print_elapsed_fun506__t* _self = kk_function_alloc_as(struct kk_std_time_timer_print_elapsed_fun506__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_time_timer_print_elapsed_fun506, kk_context());
  _self->_b_398_392 = _b_398_392;
  return &_self->_base;
}

static kk_box_t kk_std_time_timer_print_elapsed_fun506(kk_function_t _fself, kk_box_t _b_393, kk_context_t* _ctx) {
  struct kk_std_time_timer_print_elapsed_fun506__t* _self = kk_function_as(struct kk_std_time_timer_print_elapsed_fun506__t*, _fself);
  kk_function_t _b_398_392 = _self->_b_398_392; /* ((std/time/duration/duration, 297)) -> <ndet,console|298> 297 */
  kk_drop_match(_self, {kk_function_dup(_b_398_392);}, {}, _ctx)
  kk_std_core_types__tuple2_ _x507 = kk_std_core_types__tuple2__unbox(_b_393, _ctx); /*(std/time/duration/duration, 297)*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_types__tuple2_, kk_context_t*), _b_398_392, (_b_398_392, _x507, _ctx));
}

kk_box_t kk_std_time_timer_print_elapsed(kk_function_t action, kk_std_core_types__optional msg, kk_context_t* _ctx) { /* forall<a,e> (action : () -> <ndet,console|e> a, msg : optional<string>) -> <ndet,console|e> a */ 
  kk_std_core_types__tuple2_ x_336 = kk_std_time_timer_elapsed(action, _ctx); /*(std/time/duration/duration, 297)*/;
  if (kk_yielding(kk_context())) {
    kk_std_core_types__tuple2__drop(x_336, _ctx);
    kk_function_t _b_398_392 = kk_std_time_timer_new_print_elapsed_fun505(msg, _ctx); /*((std/time/duration/duration, 297)) -> <ndet,console|298> 297*/;
    return kk_std_core_hnd_yield_extend(kk_std_time_timer_new_print_elapsed_fun506(_b_398_392, _ctx), _ctx);
  }
  kk_box_t _box_x394 = x_336.fst;
  kk_box_t x0 = x_336.snd;
  kk_std_time_duration__duration t = kk_std_time_duration__duration_unbox(_box_x394, NULL);
  kk_box_dup(x0);
  kk_std_core_types__tuple2__drop(x_336, _ctx);
  kk_Unit;
  kk_unit_t __ = kk_Unit;
  kk_string_t _x509;
  kk_string_t _x510;
  if (kk_std_core_types__is_Optional(msg)) {
    kk_box_t _box_x395 = msg._cons.Optional.value;
    kk_string_t _msg_170 = kk_string_unbox(_box_x395);
    kk_string_dup(_msg_170);
    kk_std_core_types__optional_drop(msg, _ctx);
    kk_Unit;
    _x510 = _msg_170; /*string*/
    goto _match511;
  }
  kk_define_string_literal(, _s513, 7, "elapsed")
  _x510 = kk_string_dup(_s513); /*string*/
  _match511: ;
  kk_string_t _x514;
  kk_string_t _x515;
  kk_define_string_literal(, _s516, 1, " ")
  _x515 = kk_string_dup(_s516); /*string*/
  kk_string_t _x517;
  kk_string_t _x518;
  kk_std_num_ddouble__ddouble _x519;
  kk_std_num_ddouble__ddouble _x = t.secs;
  _x519 = _x; /*std/time/timestamp/timespan*/
  kk_std_core_types__optional _x520;
  kk_integer_t _b_397_396;
  kk_integer_t _x521 = kk_integer_abs((kk_integer_from_small(3)),kk_context()); /*int*/
  _b_397_396 = kk_integer_neg(_x521,kk_context()); /*int*/
  _x520 = kk_std_core_types__new_Optional(kk_integer_box(_b_397_396), _ctx); /*optional<106>*/
  _x518 = kk_std_num_ddouble_show_fixed(_x519, _x520, _ctx); /*string*/
  kk_string_t _x522;
  kk_define_string_literal(, _s523, 1, "s")
  _x522 = kk_string_dup(_s523); /*string*/
  _x517 = kk_std_core__lp__plus__plus__1_rp_(_x518, _x522, _ctx); /*string*/
  _x514 = kk_std_core__lp__plus__plus__1_rp_(_x515, _x517, _ctx); /*string*/
  _x509 = kk_std_core__lp__plus__plus__1_rp_(_x510, _x514, _ctx); /*string*/
  kk_std_core_printsln(_x509, _ctx);
  return x0;
}

// initialization
void kk_std_time_timer__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core__init(_ctx);
  kk_std_num_double__init(_ctx);
  kk_std_num_ddouble__init(_ctx);
  kk_std_time_duration__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
}

// termination
void kk_std_time_timer__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_time_duration__done(_ctx);
  kk_std_num_ddouble__done(_ctx);
  kk_std_num_double__done(_ctx);
  kk_std_core__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
