// Koka generated module: "std/num/int32", koka version: 2.2.1
#include "std_num_int32.h"

kk_integer_t kk_std_num_int32_max_int32;
 
// Show an `:int32` in hexadecimal notation
// The `width`  parameter specifies how wide the hex value is where `'0'`  is used to align.
// The `use-capitals` parameter (= `True`) determines if captical letters should be used to display the hexadecimal digits.
// The `pre` (=`"0x"`) is an optional prefix for the number (goes between the sign and the number).

kk_string_t kk_std_num_int32_show_hex(int32_t i, kk_std_core_types__optional width, kk_std_core_types__optional use_capitals, kk_std_core_types__optional pre, kk_context_t* _ctx) { /* (i : int32, width : optional<int>, use-capitals : optional<bool>, pre : optional<string>) -> string */ 
  kk_integer_t _x1406 = kk_integer_from_int(i,kk_context()); /*int*/
  kk_std_core_types__optional _x1407;
  kk_integer_t _b_1342_1337;
  if (kk_std_core_types__is_Optional(width)) {
    kk_box_t _box_x1336 = width._cons.Optional.value;
    kk_integer_t _width_156 = kk_integer_unbox(_box_x1336);
    kk_integer_dup(_width_156);
    kk_std_core_types__optional_drop(width, _ctx);
    kk_Unit;
    _b_1342_1337 = _width_156; /*int*/
    goto _match1408;
  }
  _b_1342_1337 = kk_integer_from_small(1); /*int*/
  _match1408: ;
  _x1407 = kk_std_core_types__new_Optional(kk_integer_box(_b_1342_1337), _ctx); /*optional<106>*/
  kk_std_core_types__optional _x1410;
  bool _b_1343_1339;
  if (kk_std_core_types__is_Optional(use_capitals)) {
    kk_box_t _box_x1338 = use_capitals._cons.Optional.value;
    bool _use_capitals_160 = kk_bool_unbox(_box_x1338);
    kk_std_core_types__optional_drop(use_capitals, _ctx);
    kk_Unit;
    _b_1343_1339 = _use_capitals_160; /*bool*/
    goto _match1411;
  }
  _b_1343_1339 = true; /*bool*/
  _match1411: ;
  _x1410 = kk_std_core_types__new_Optional(kk_bool_box(_b_1343_1339), _ctx); /*optional<106>*/
  kk_std_core_types__optional _x1413;
  kk_string_t _b_1344_1341;
  if (kk_std_core_types__is_Optional(pre)) {
    kk_box_t _box_x1340 = pre._cons.Optional.value;
    kk_string_t _pre_164 = kk_string_unbox(_box_x1340);
    kk_string_dup(_pre_164);
    kk_std_core_types__optional_drop(pre, _ctx);
    kk_Unit;
    _b_1344_1341 = _pre_164; /*string*/
    goto _match1414;
  }
  kk_define_string_literal(, _s1416, 2, "0x")
  _b_1344_1341 = kk_string_dup(_s1416); /*string*/
  _match1414: ;
  _x1413 = kk_std_core_types__new_Optional(kk_string_box(_b_1344_1341), _ctx); /*optional<106>*/
  return kk_std_core_show_hex(_x1406, _x1407, _x1410, _x1413, _ctx);
}

int32_t kk_std_num_int32_one;

int32_t kk_std_num_int32_zero;
 
// Euclidean-0 modulus. See `(/):(x : int32, y : int32) -> int32` division for more information.

int32_t kk_std_num_int32__lp__perc__rp_(int32_t x, int32_t y, kk_context_t* _ctx) { /* (x : int32, y : int32) -> int32 */ 
  bool _match_1395 = (y == (((int32_t)0))); /*bool*/;
  if (_match_1395) {
    return x;
  }
  int32_t r = (x % y); /*int32*/;
  bool _match_1396 = (r >= (((int32_t)0))); /*bool*/;
  if (_match_1396) {
    return r;
  }
  bool _match_1397 = (y > (((int32_t)0))); /*bool*/;
  if (_match_1397) {
    return (r + y);
  }
  return (r - y);
}
 
/*
Euclidean-0 division.
Euclidean division is defined as: For any `D`  and `d`  where `d!=0` , we have:
1. `D == d*(D/d) + (D%d)`
2. `D%d`  is always positive where `0 <= D%d < abs(d)`
Moreover, Euclidean-0 is a total function, for the case where `d==0`  we have
that `D%0 == D`  and `D/0 == 0` . So property (1) still holds, but not property (2).
Useful laws that hold for Euclidean-0 division:
* `D/(-d) == -(D/d)`
* `D%(-d) == D%d`
* `D/(2^n) == sar(D,n)         `  (with `0 <= n <= 31`)
* `D%(2^n) == D & ((2^n) - 1)  `  (with `0 <= n <= 31`)
Note that an interesting edge case is `min-int32 / -1` which equals `min-int32` since in modulo 32-bit
arithmetic `min-int32 == -1 * min-int32 == -1 * (min-int32 / -1) + (min-int32 % -1)` satisfying property (1).
Of course `(min-int32 + 1) / -1` is again positive (namely `max-int32`).
See also _Division and modulus for computer scientists, Daan Leijen, 2001_
[pdf](http://research.microsoft.com/pubs/151917/divmodnote.pdf) .
*/

int32_t kk_std_num_int32__lp__fs__rp_(int32_t x, int32_t y, kk_context_t* _ctx) { /* (x : int32, y : int32) -> int32 */ 
  bool _match_1392 = (y == (((int32_t)0))); /*bool*/;
  if (_match_1392) {
    return ((int32_t)0);
  }
  int32_t q = (x / y); /*int32*/;
  int32_t r = (x % y); /*int32*/;
  bool _match_1393 = (r >= (((int32_t)0))); /*bool*/;
  if (_match_1393) {
    return q;
  }
  bool _match_1394 = (y > (((int32_t)0))); /*bool*/;
  if (_match_1394) {
    return (q - (((int32_t)1)));
  }
  return (q + (((int32_t)1)));
}

kk_integer_t kk_std_num_int32_min_int32;
 
// Return the absolute value of an integer.
// Raises an exception if the `:int32` is `min-int32`
// (since the negation of `min-int32` equals itself and is still negative)

int32_t kk_std_num_int32_abs(int32_t i, kk_context_t* _ctx) { /* (i : int32) -> exn int32 */ 
  bool _x1 = (i)<0; /*bool*/;
  kk_evv_t w = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<(<>)>*/;
  kk_unit_t keep = kk_Unit;
  kk_evv_set(w,kk_context());
  if (_x1) {
    bool _match_1388;
    int32_t _x1419;
    kk_integer_t _x1420 = kk_integer_neg((kk_integer_from_str("2147483648", _ctx)),kk_context()); /*int*/
    _x1419 = kk_std_core_int32(_x1420, _ctx); /*int32*/
    _match_1388 = (i > _x1419); /*bool*/
    if (_match_1388) {
      return ((((int32_t)0)) - i);
    }
    kk_std_core_hnd__ev ev_1333;
    kk_ssize_t _x1421 = ((kk_ssize_t)0); /*ssize_t*/
    ev_1333 = kk_evv_at(_x1421,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
    struct kk_std_core_hnd_Ev* _con1422 = kk_std_core_hnd__as_Ev(ev_1333);
    kk_std_core_hnd__marker m0 = _con1422->marker;
    kk_box_t _box_x1345 = _con1422->hnd;
    kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x1345, NULL);
    kk_std_core__hnd_exn_dup(h);
    kk_std_core_hnd__clause1 _match_1389;
    kk_std_core_hnd__clause1 _borrowApp_1391 = kk_std_core__select_throw_exn(h, _ctx); /*std/core/hnd/clause1<exception,1926,.hnd-exn,1927,1928>*/;
    kk_std_core__hnd_exn_drop(h, _ctx);
    _match_1389 = _borrowApp_1391; /*std/core/hnd/clause1<exception,1926,.hnd-exn,1927,1928>*/
    kk_function_t _fun_unbox_x1349 = _match_1389.clause;
    kk_std_core_hnd__marker _b_1350 = m0; /*std/core/hnd/marker<3573,3574>*/;
    kk_std_core_hnd__ev _b_1351 = ev_1333; /*std/core/hnd/ev<.hnd-exn>*/;
    kk_std_core__exception _b_1352;
    kk_string_t _x1424;
    kk_define_string_literal(, _s1425, 79, "std/num/int32/abs: cannot make min-int32 into a positive int32 without overflow")
    _x1424 = kk_string_dup(_s1425); /*string*/
    kk_std_core__exception_info _x1426;
    kk_std_core_types__optional _match_1390 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
    if (kk_std_core_types__is_Optional(_match_1390)) {
      kk_box_t _box_x1353 = _match_1390._cons.Optional.value;
      kk_std_core__exception_info _info_11639 = kk_std_core__exception_info_unbox(_box_x1353, NULL);
      kk_std_core__exception_info_dup(_info_11639);
      kk_std_core_types__optional_drop(_match_1390, _ctx);
      kk_Unit;
      _x1426 = _info_11639; /*exception-info*/
      goto _match1427;
    }
    _x1426 = kk_std_core__new_ExnError(_ctx); /*exception-info*/
    _match1427: ;
    _b_1352 = kk_std_core__new_Exception(_x1424, _x1426, _ctx); /*exception*/
    kk_box_t _x1429 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x1349, (_fun_unbox_x1349, _b_1350, _b_1351, kk_std_core__exception_box(_b_1352, _ctx), _ctx)); /*52*/
    return kk_int32_unbox(_x1429, _ctx);
  }
  return i;
}
 
// Return the absolute value of an integer.
// Returns 0 if the `:int32` is `min-int32`
// (since the negation of `min-int32` equals itself and is still negative)

int32_t kk_std_num_int32_abs0(int32_t i, kk_context_t* _ctx) { /* (i : int32) -> int32 */ 
  bool b_1318 = (i)<0; /*bool*/;
  if (b_1318) {
    bool _match_1387;
    int32_t _x1430;
    kk_integer_t _x1431 = kk_integer_neg((kk_integer_from_str("2147483648", _ctx)),kk_context()); /*int*/
    _x1430 = kk_std_core_int32(_x1431, _ctx); /*int32*/
    _match_1387 = (i > _x1430); /*bool*/
    if (_match_1387) {
      return ((((int32_t)0)) - i);
    }
    return ((int32_t)0);
  }
  return i;
}

int32_t kk_std_num_int32_bits_int32;

kk_std_core_types__tuple2_ kk_std_num_int32_divmod(int32_t x, int32_t y, kk_context_t* _ctx) { /* (x : int32, y : int32) -> (int32, int32) */ 
  bool _match_1385 = 0==(y); /*bool*/;
  if (_match_1385) {
    int32_t _b_1362_1354 = ((int32_t)0); /*int32*/;
    int32_t _b_1363_1355 = ((int32_t)0); /*int32*/;
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_int32_box(_b_1362_1354, _ctx), kk_int32_box(_b_1363_1355, _ctx), _ctx);
  }
  int32_t q = (x / y); /*int32*/;
  int32_t r = (x % y); /*int32*/;
  bool b_1320 = (r)<0; /*bool*/;
  if (b_1320) {
    bool _match_1386 = 0<=(y); /*bool*/;
    if (_match_1386) {
      int32_t _b_1364_1356 = (q - (((int32_t)1))); /*int32*/;
      int32_t _b_1365_1357 = (r + y); /*int32*/;
      return kk_std_core_types__new_dash__lp__comma__rp_(kk_int32_box(_b_1364_1356, _ctx), kk_int32_box(_b_1365_1357, _ctx), _ctx);
    }
    int32_t _b_1366_1358 = (q + (((int32_t)1))); /*int32*/;
    int32_t _b_1367_1359 = (r - y); /*int32*/;
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_int32_box(_b_1366_1358, _ctx), kk_int32_box(_b_1367_1359, _ctx), _ctx);
  }
  int32_t _b_1368_1360 = q; /*int32*/;
  int32_t _b_1369_1361 = r; /*int32*/;
  return kk_std_core_types__new_dash__lp__comma__rp_(kk_int32_box(_b_1368_1360, _ctx), kk_int32_box(_b_1369_1361, _ctx), _ctx);
}

kk_box_t kk_std_num_int32_fold_int32(int32_t start, int32_t end, kk_box_t init, kk_function_t f, kk_context_t* _ctx) { /* forall<a> (start : int32, end : int32, init : a, f : (int32, a) -> a) -> a */ 
  kk__tailcall: ;
  bool _match_1384 = (start >= end); /*bool*/;
  if (_match_1384) {
    kk_function_drop(f, _ctx);
    return init;
  }
  kk_box_t x;
  kk_function_t _x1432 = kk_function_dup(f); /*(int32, 996) -> 996*/
  x = kk_function_call(kk_box_t, (kk_function_t, int32_t, kk_box_t, kk_context_t*), _x1432, (_x1432, start, init, _ctx)); /*996*/
  { // tailcall
    int32_t _x1433 = (start + (((int32_t)1))); /*int32*/
    start = _x1433;
    init = x;
    goto kk__tailcall;
  }
}
 
// Bitwise rotate an `:int32` `n` bits to the left.
// Does not rotate when `n` is negative.

int32_t kk_std_num_int32_rotl(int32_t i, int32_t n, kk_context_t* _ctx) { /* (i : int32, n : int32) -> int32 */ 
  bool _match_1383 = (n)<0; /*bool*/;
  if (_match_1383) {
    return i;
  }
  int32_t r;
  int32_t _x1436;
  int32_t i0_1324 = ((int32_t)32); /*int32*/;
  _x1436 = (i0_1324 - (((int32_t)1))); /*int32*/
  r = (n & _x1436); /*int32*/
  int32_t _x1437 = (i << r); /*int32*/
  int32_t _x1438;
  int32_t _x1439 = ((((int32_t)32)) - r); /*int32*/
  _x1438 = ((int32_t)((uint32_t)i >> _x1439)); /*int32*/
  return (_x1437 | _x1438);
}
 
// Bitwise rotate an `:int32` `n` bits to the right.
// Does not rotate when `n` is negative.

int32_t kk_std_num_int32_rotr(int32_t i, int32_t n, kk_context_t* _ctx) { /* (i : int32, n : int32) -> int32 */ 
  bool _match_1382 = (n)<0; /*bool*/;
  if (_match_1382) {
    return i;
  }
  int32_t r;
  int32_t _x1440;
  int32_t i0_1325 = ((int32_t)32); /*int32*/;
  _x1440 = (i0_1325 - (((int32_t)1))); /*int32*/
  r = (n & _x1440); /*int32*/
  int32_t _x1441 = ((int32_t)((uint32_t)i >> r)); /*int32*/
  int32_t _x1442;
  int32_t _x1443 = ((((int32_t)32)) - r); /*int32*/
  _x1442 = (i << _x1443); /*int32*/
  return (_x1441 | _x1442);
}
 
// Show an `:int32` in hexadecimal notation interpreted as an unsigned 32-bit value.
// The `width`  parameter specifies how wide the hex value is where `'0'`  is used to align.
// The `use-capitals` parameter (= `True`) determines if captical letters should be used to display the hexadecimal digits.
// The `pre` (=`"0x"`) is an optional prefix for the number.

kk_string_t kk_std_num_int32_show_hex32(int32_t i, kk_std_core_types__optional width, kk_std_core_types__optional use_capitals, kk_std_core_types__optional pre, kk_context_t* _ctx) { /* (i : int32, width : optional<int>, use-capitals : optional<bool>, pre : optional<string>) -> string */ 
  kk_integer_t _x1445 = kk_std_num_int32_uint(i, _ctx); /*int*/
  kk_std_core_types__optional _x1446;
  kk_integer_t _b_1376_1371;
  if (kk_std_core_types__is_Optional(width)) {
    kk_box_t _box_x1370 = width._cons.Optional.value;
    kk_integer_t _width_1233 = kk_integer_unbox(_box_x1370);
    kk_integer_dup(_width_1233);
    kk_std_core_types__optional_drop(width, _ctx);
    kk_Unit;
    _b_1376_1371 = _width_1233; /*int*/
    goto _match1447;
  }
  _b_1376_1371 = kk_integer_from_small(8); /*int*/
  _match1447: ;
  _x1446 = kk_std_core_types__new_Optional(kk_integer_box(_b_1376_1371), _ctx); /*optional<106>*/
  kk_std_core_types__optional _x1449;
  bool _b_1377_1373;
  if (kk_std_core_types__is_Optional(use_capitals)) {
    kk_box_t _box_x1372 = use_capitals._cons.Optional.value;
    bool _use_capitals_1237 = kk_bool_unbox(_box_x1372);
    kk_std_core_types__optional_drop(use_capitals, _ctx);
    kk_Unit;
    _b_1377_1373 = _use_capitals_1237; /*bool*/
    goto _match1450;
  }
  _b_1377_1373 = true; /*bool*/
  _match1450: ;
  _x1449 = kk_std_core_types__new_Optional(kk_bool_box(_b_1377_1373), _ctx); /*optional<106>*/
  kk_std_core_types__optional _x1452;
  kk_string_t _b_1378_1375;
  if (kk_std_core_types__is_Optional(pre)) {
    kk_box_t _box_x1374 = pre._cons.Optional.value;
    kk_string_t _pre_1241 = kk_string_unbox(_box_x1374);
    kk_string_dup(_pre_1241);
    kk_std_core_types__optional_drop(pre, _ctx);
    kk_Unit;
    _b_1378_1375 = _pre_1241; /*string*/
    goto _match1453;
  }
  kk_define_string_literal(, _s1455, 2, "0x")
  _b_1378_1375 = kk_string_dup(_s1455); /*string*/
  _match1453: ;
  _x1452 = kk_std_core_types__new_Optional(kk_string_box(_b_1378_1375), _ctx); /*optional<106>*/
  return kk_std_core_show_hex(_x1445, _x1446, _x1449, _x1452, _ctx);
}

// initialization
void kk_std_num_int32__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
  {
    kk_std_num_int32_max_int32 = kk_integer_from_int(2147483647, _ctx); /*int*/
  }
  {
    kk_std_num_int32_one = ((int32_t)1); /*int32*/
  }
  {
    kk_std_num_int32_zero = ((int32_t)0); /*int32*/
  }
  {
    kk_std_num_int32_min_int32 = kk_integer_neg((kk_integer_from_str("2147483648", _ctx)),kk_context()); /*int*/
  }
  {
    kk_std_num_int32_bits_int32 = ((int32_t)32); /*int32*/
  }
}

// termination
void kk_std_num_int32__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_integer_drop(kk_std_num_int32_min_int32, _ctx);
  kk_integer_drop(kk_std_num_int32_max_int32, _ctx);
  kk_std_core__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
