// Koka generated module: "std/os/file", koka version: 2.2.1
#include "std_os_file.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/

static kk_std_core__error kk_os_read_text_file_error( kk_string_t path, kk_context_t* ctx ) {
  kk_string_t content;
  const int err = kk_os_read_text_file(path,&content,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_string_box(content),ctx);
}

static kk_std_core__error kk_os_write_text_file_error( kk_string_t path, kk_string_t content, kk_context_t* ctx ) {
  const int err = kk_os_write_text_file(path,content,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_unit_box(kk_Unit),ctx);
}


kk_std_core__exception kk_std_os_file_prepend(kk_std_core__exception exn, kk_string_t pre, kk_context_t* _ctx) { /* (exn : exception, pre : string) -> exception */ 
  kk_string_t _x465;
  kk_string_t _x466;
  kk_string_t _x467;
  kk_define_string_literal(, _s468, 2, ": ")
  _x467 = kk_string_dup(_s468); /*string*/
  kk_string_t _x469;
  kk_string_t _x = exn.message;
  kk_string_dup(_x);
  _x469 = _x; /*string*/
  _x466 = kk_std_core__lp__plus__plus__1_rp_(_x467, _x469, _ctx); /*string*/
  _x465 = kk_std_core__lp__plus__plus__1_rp_(pre, _x466, _ctx); /*string*/
  kk_std_core__exception_info _x470;
  kk_std_core__exception_info _x0 = exn.info;
  kk_std_core__exception_info_dup(_x0);
  kk_std_core__exception_drop(exn, _ctx);
  kk_Unit;
  _x470 = _x0; /*exception-info*/
  return kk_std_core__new_Exception(_x465, _x470, _ctx);
}

kk_std_core__error kk_std_os_file_read_text_file_err(kk_string_t path, kk_context_t* _ctx) { /* (path : string) -> fsys error<string> */ 
  return kk_os_read_text_file_error(path,kk_context());
}

kk_std_core__error kk_std_os_file_write_text_file_err(kk_string_t path, kk_string_t content, kk_context_t* _ctx) { /* (path : string, content : string) -> fsys error<()> */ 
  return kk_os_write_text_file_error(path,content,kk_context());
}
 
// Read a text file synchronously (using UTF8 encoding)


// lift anonymous function
struct kk_std_os_file_read_text_file_fun472__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file_read_text_file_fun472(kk_function_t _fself, kk_box_t _b_378, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_read_text_file_fun472(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_read_text_file_fun472, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_file_read_text_file_fun472(kk_function_t _fself, kk_box_t _b_378, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x473;
  kk_std_os_path__path _x474 = kk_std_os_path__path_unbox(_b_378, _ctx); /*std/os/path/path*/
  _x473 = kk_std_os_path_string(_x474, _ctx); /*string*/
  return kk_string_box(_x473);
}


// lift anonymous function
struct kk_std_os_file_read_text_file_fun478__t {
  struct kk_function_s _base;
};
static kk_std_core__error kk_std_os_file_read_text_file_fun478(kk_function_t _fself, kk_string_t _x1477, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_read_text_file_fun478(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_read_text_file_fun478, _ctx)
  return kk_function_dup(_fself);
}

static kk_std_core__error kk_std_os_file_read_text_file_fun478(kk_function_t _fself, kk_string_t _x1477, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_os_file_read_text_file_err(_x1477, _ctx);
}


// lift anonymous function
struct kk_std_os_file_read_text_file_fun480__t {
  struct kk_function_s _base;
  kk_function_t _b_394_381;
};
static kk_box_t kk_std_os_file_read_text_file_fun480(kk_function_t _fself, kk_box_t _b_383, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_read_text_file_fun480(kk_function_t _b_394_381, kk_context_t* _ctx) {
  struct kk_std_os_file_read_text_file_fun480__t* _self = kk_function_alloc_as(struct kk_std_os_file_read_text_file_fun480__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_file_read_text_file_fun480, kk_context());
  _self->_b_394_381 = _b_394_381;
  return &_self->_base;
}

static kk_box_t kk_std_os_file_read_text_file_fun480(kk_function_t _fself, kk_box_t _b_383, kk_context_t* _ctx) {
  struct kk_std_os_file_read_text_file_fun480__t* _self = kk_function_as(struct kk_std_os_file_read_text_file_fun480__t*, _fself);
  kk_function_t _b_394_381 = _self->_b_394_381; /* (path : string) -> fsys error<string> */
  kk_drop_match(_self, {kk_function_dup(_b_394_381);}, {}, _ctx)
  kk_std_core__error _x481;
  kk_string_t _x482 = kk_string_unbox(_b_383); /*string*/
  _x481 = kk_function_call(kk_std_core__error, (kk_function_t, kk_string_t, kk_context_t*), _b_394_381, (_b_394_381, _x482, _ctx)); /*error<string>*/
  return kk_std_core__error_box(_x481, _ctx);
}

kk_string_t kk_std_os_file_read_text_file(kk_std_os_path__path path, kk_context_t* _ctx) { /* (path : std/os/path/path) -> <exn,fsys> string */ 
  kk_string_t _x1;
  kk_box_t _x471;
  kk_box_t _x475;
  kk_std_os_path__path _x476 = kk_std_os_path__path_dup(path); /*std/os/path/path*/
  _x475 = kk_std_os_path__path_box(_x476, _ctx); /*3288*/
  _x471 = kk_std_core_hnd__open_none1(kk_std_os_file_new_read_text_file_fun472(_ctx), _x475, _ctx); /*3289*/
  _x1 = kk_string_unbox(_x471); /*string*/
  kk_std_core__error _match_457;
  kk_function_t _b_394_381 = kk_std_os_file_new_read_text_file_fun478(_ctx); /*(path : string) -> fsys error<string>*/;
  kk_string_t _b_395_382 = _x1; /*string*/;
  kk_box_t _x479 = kk_std_core_hnd__open_none1(kk_std_os_file_new_read_text_file_fun480(_b_394_381, _ctx), kk_string_box(_b_395_382), _ctx); /*3289*/
  _match_457 = kk_std_core__error_unbox(_x479, _ctx); /*error<string>*/
  if (kk_std_core__is_Error(_match_457)) {
    kk_std_core__exception exn = _match_457._cons.Error.exception;
    kk_std_core__exception_dup(exn);
    kk_std_core__error_drop(_match_457, _ctx);
    kk_Unit;
    kk_std_core__error err_317;
    kk_std_core__exception _x483;
    kk_string_t _x2;
    kk_string_t _x484;
    kk_define_string_literal(, _s485, 25, "unable to read text file ")
    _x484 = kk_string_dup(_s485); /*string*/
    kk_string_t _x486;
    kk_evv_t w = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<(<>)>*/;
    kk_string_t x;
    kk_string_t _x487 = kk_std_os_path_string(path, _ctx); /*string*/
    x = kk_std_core_show_3(_x487, _ctx); /*string*/
    kk_unit_t keep = kk_Unit;
    kk_evv_set(w,kk_context());
    _x486 = x; /*string*/
    _x2 = kk_std_core__lp__plus__plus__1_rp_(_x484, _x486, _ctx); /*string*/
    kk_evv_t w0 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<(<>)>*/;
    kk_std_core__exception x0;
    kk_string_t _x488;
    kk_string_t _x489;
    kk_string_t _x490;
    kk_define_string_literal(, _s491, 2, ": ")
    _x490 = kk_string_dup(_s491); /*string*/
    kk_string_t _x492;
    kk_string_t _x = exn.message;
    kk_string_dup(_x);
    _x492 = _x; /*string*/
    _x489 = kk_std_core__lp__plus__plus__1_rp_(_x490, _x492, _ctx); /*string*/
    _x488 = kk_std_core__lp__plus__plus__1_rp_(_x2, _x489, _ctx); /*string*/
    kk_std_core__exception_info _x493;
    kk_std_core__exception_info _x02 = exn.info;
    kk_std_core__exception_info_dup(_x02);
    kk_std_core__exception_drop(exn, _ctx);
    kk_Unit;
    _x493 = _x02; /*exception-info*/
    x0 = kk_std_core__new_Exception(_x488, _x493, _ctx); /*exception*/
    kk_unit_t keep0 = kk_Unit;
    kk_evv_set(w0,kk_context());
    _x483 = x0; /*exception*/
    err_317 = kk_std_core__new_Error(_x483, _ctx); /*error<string>*/
    if (kk_std_core__is_Error(err_317)) {
      kk_std_core__exception exn0 = err_317._cons.Error.exception;
      kk_std_core__exception_dup(exn0);
      kk_std_core__error_drop(err_317, _ctx);
      kk_Unit;
      kk_std_core_hnd__ev ev_349;
      kk_ssize_t _x494 = ((kk_ssize_t)0); /*ssize_t*/
      ev_349 = kk_evv_at(_x494,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
      struct kk_std_core_hnd_Ev* _con495 = kk_std_core_hnd__as_Ev(ev_349);
      kk_std_core_hnd__marker m0 = _con495->marker;
      kk_box_t _box_x384 = _con495->hnd;
      kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x384, NULL);
      kk_std_core__hnd_exn_dup(h);
      kk_std_core_hnd__clause1 _match_458;
      kk_std_core_hnd__clause1 _borrowApp_459 = kk_std_core__select_throw_exn(h, _ctx); /*std/core/hnd/clause1<exception,1926,.hnd-exn,1927,1928>*/;
      kk_std_core__hnd_exn_drop(h, _ctx);
      _match_458 = _borrowApp_459; /*std/core/hnd/clause1<exception,1926,.hnd-exn,1927,1928>*/
      kk_function_t _fun_unbox_x388 = _match_458.clause;
      kk_std_core_hnd__marker _b_389 = m0; /*std/core/hnd/marker<3573,3574>*/;
      kk_std_core_hnd__ev _b_390 = ev_349; /*std/core/hnd/ev<.hnd-exn>*/;
      kk_std_core__exception _b_391 = exn0; /*exception*/;
      kk_box_t _x497 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x388, (_fun_unbox_x388, _b_389, _b_390, kk_std_core__exception_box(_b_391, _ctx), _ctx)); /*52*/
      return kk_string_unbox(_x497);
    }
    kk_box_t _box_x392 = err_317._cons.Ok.result;
    kk_string_t x4 = kk_string_unbox(_box_x392);
    kk_string_dup(x4);
    kk_std_core__error_drop(err_317, _ctx);
    kk_Unit;
    return x4;
  }
  kk_box_t _box_x393 = _match_457._cons.Ok.result;
  kk_string_t content = kk_string_unbox(_box_x393);
  kk_std_os_path__path_drop(path, _ctx);
  kk_string_dup(content);
  kk_std_core__error_drop(_match_457, _ctx);
  kk_Unit;
  return content;
}
 
// monadic lift


// lift anonymous function
struct kk_std_os_file__mlift343_write_text_file_fun501__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file__mlift343_write_text_file_fun501(kk_function_t _fself, kk_box_t _b_398, kk_context_t* _ctx);
static kk_function_t kk_std_os_file__new_mlift343_write_text_file_fun501(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file__mlift343_write_text_file_fun501, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_file__mlift343_write_text_file_fun501(kk_function_t _fself, kk_box_t _b_398, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x502;
  kk_std_os_path__path _x503 = kk_std_os_path__path_unbox(_b_398, _ctx); /*std/os/path/path*/
  _x502 = kk_std_os_path_string(_x503, _ctx); /*string*/
  return kk_string_box(_x502);
}


// lift anonymous function
struct kk_std_os_file__mlift343_write_text_file_fun508__t {
  struct kk_function_s _base;
};
static kk_std_core__error kk_std_os_file__mlift343_write_text_file_fun508(kk_function_t _fself, kk_string_t _x1506, kk_string_t _x2507, kk_context_t* _ctx);
static kk_function_t kk_std_os_file__new_mlift343_write_text_file_fun508(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file__mlift343_write_text_file_fun508, _ctx)
  return kk_function_dup(_fself);
}

static kk_std_core__error kk_std_os_file__mlift343_write_text_file_fun508(kk_function_t _fself, kk_string_t _x1506, kk_string_t _x2507, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_os_file_write_text_file_err(_x1506, _x2507, _ctx);
}


// lift anonymous function
struct kk_std_os_file__mlift343_write_text_file_fun510__t {
  struct kk_function_s _base;
  kk_function_t _b_415_401;
};
static kk_box_t kk_std_os_file__mlift343_write_text_file_fun510(kk_function_t _fself, kk_box_t _b_404, kk_box_t _b_405, kk_context_t* _ctx);
static kk_function_t kk_std_os_file__new_mlift343_write_text_file_fun510(kk_function_t _b_415_401, kk_context_t* _ctx) {
  struct kk_std_os_file__mlift343_write_text_file_fun510__t* _self = kk_function_alloc_as(struct kk_std_os_file__mlift343_write_text_file_fun510__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_file__mlift343_write_text_file_fun510, kk_context());
  _self->_b_415_401 = _b_415_401;
  return &_self->_base;
}

static kk_box_t kk_std_os_file__mlift343_write_text_file_fun510(kk_function_t _fself, kk_box_t _b_404, kk_box_t _b_405, kk_context_t* _ctx) {
  struct kk_std_os_file__mlift343_write_text_file_fun510__t* _self = kk_function_as(struct kk_std_os_file__mlift343_write_text_file_fun510__t*, _fself);
  kk_function_t _b_415_401 = _self->_b_415_401; /* (path : string, content : string) -> fsys error<()> */
  kk_drop_match(_self, {kk_function_dup(_b_415_401);}, {}, _ctx)
  kk_std_core__error _x511;
  kk_string_t _x512 = kk_string_unbox(_b_404); /*string*/
  kk_string_t _x513 = kk_string_unbox(_b_405); /*string*/
  _x511 = kk_function_call(kk_std_core__error, (kk_function_t, kk_string_t, kk_string_t, kk_context_t*), _b_415_401, (_b_415_401, _x512, _x513, _ctx)); /*error<()>*/
  return kk_std_core__error_box(_x511, _ctx);
}

kk_unit_t kk_std_os_file__mlift343_write_text_file(kk_string_t content, kk_std_os_path__path path, kk_unit_t _c_329, kk_context_t* _ctx) { /* (content : string, path : std/os/path/path, ()) -> () */ 
  kk_string_t _x12;
  kk_box_t _x500;
  kk_box_t _x504;
  kk_std_os_path__path _x505 = kk_std_os_path__path_dup(path); /*std/os/path/path*/
  _x504 = kk_std_os_path__path_box(_x505, _ctx); /*3288*/
  _x500 = kk_std_core_hnd__open_none1(kk_std_os_file__new_mlift343_write_text_file_fun501(_ctx), _x504, _ctx); /*3289*/
  _x12 = kk_string_unbox(_x500); /*string*/
  kk_std_core__error _match_454;
  kk_function_t _b_415_401 = kk_std_os_file__new_mlift343_write_text_file_fun508(_ctx); /*(path : string, content : string) -> fsys error<()>*/;
  kk_string_t _b_416_402 = _x12; /*string*/;
  kk_string_t _b_417_403 = content; /*string*/;
  kk_box_t _x509 = kk_std_core_hnd__open_none2(kk_std_os_file__new_mlift343_write_text_file_fun510(_b_415_401, _ctx), kk_string_box(_b_416_402), kk_string_box(_b_417_403), _ctx); /*3381*/
  _match_454 = kk_std_core__error_unbox(_x509, _ctx); /*error<()>*/
  if (kk_std_core__is_Error(_match_454)) {
    kk_std_core__exception exn = _match_454._cons.Error.exception;
    kk_std_core__exception_dup(exn);
    kk_std_core__error_drop(_match_454, _ctx);
    kk_Unit;
    kk_std_core__error err_320;
    kk_std_core__exception _x514;
    kk_string_t _x20;
    kk_string_t _x515;
    kk_define_string_literal(, _s516, 26, "unable to write text file ")
    _x515 = kk_string_dup(_s516); /*string*/
    kk_string_t _x517;
    kk_evv_t w = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<(<>)>*/;
    kk_string_t x;
    kk_string_t _x518 = kk_std_os_path_string(path, _ctx); /*string*/
    x = kk_std_core_show_3(_x518, _ctx); /*string*/
    kk_unit_t keep = kk_Unit;
    kk_evv_set(w,kk_context());
    _x517 = x; /*string*/
    _x20 = kk_std_core__lp__plus__plus__1_rp_(_x515, _x517, _ctx); /*string*/
    kk_evv_t w0 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<(<>)>*/;
    kk_std_core__exception x0;
    kk_string_t _x519;
    kk_string_t _x520;
    kk_string_t _x521;
    kk_define_string_literal(, _s522, 2, ": ")
    _x521 = kk_string_dup(_s522); /*string*/
    kk_string_t _x523;
    kk_string_t _x21 = exn.message;
    kk_string_dup(_x21);
    _x523 = _x21; /*string*/
    _x520 = kk_std_core__lp__plus__plus__1_rp_(_x521, _x523, _ctx); /*string*/
    _x519 = kk_std_core__lp__plus__plus__1_rp_(_x20, _x520, _ctx); /*string*/
    kk_std_core__exception_info _x524;
    kk_std_core__exception_info _x3 = exn.info;
    kk_std_core__exception_info_dup(_x3);
    kk_std_core__exception_drop(exn, _ctx);
    kk_Unit;
    _x524 = _x3; /*exception-info*/
    x0 = kk_std_core__new_Exception(_x519, _x524, _ctx); /*exception*/
    kk_unit_t keep0 = kk_Unit;
    kk_evv_set(w0,kk_context());
    _x514 = x0; /*exception*/
    err_320 = kk_std_core__new_Error(_x514, _ctx); /*error<()>*/
    if (kk_std_core__is_Error(err_320)) {
      kk_std_core__exception exn0 = err_320._cons.Error.exception;
      kk_std_core__exception_dup(exn0);
      kk_std_core__error_drop(err_320, _ctx);
      kk_Unit;
      kk_std_core_hnd__ev ev_357;
      kk_ssize_t _x525 = ((kk_ssize_t)0); /*ssize_t*/
      ev_357 = kk_evv_at(_x525,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
      struct kk_std_core_hnd_Ev* _con526 = kk_std_core_hnd__as_Ev(ev_357);
      kk_std_core_hnd__marker m0 = _con526->marker;
      kk_box_t _box_x406 = _con526->hnd;
      kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x406, NULL);
      kk_std_core__hnd_exn_dup(h);
      kk_std_core_hnd__clause1 _match_455;
      kk_std_core_hnd__clause1 _borrowApp_456 = kk_std_core__select_throw_exn(h, _ctx); /*std/core/hnd/clause1<exception,1926,.hnd-exn,1927,1928>*/;
      kk_std_core__hnd_exn_drop(h, _ctx);
      _match_455 = _borrowApp_456; /*std/core/hnd/clause1<exception,1926,.hnd-exn,1927,1928>*/
      kk_function_t _fun_unbox_x410 = _match_455.clause;
      kk_std_core_hnd__marker _b_411 = m0; /*std/core/hnd/marker<3573,3574>*/;
      kk_std_core_hnd__ev _b_412 = ev_357; /*std/core/hnd/ev<.hnd-exn>*/;
      kk_std_core__exception _b_413 = exn0; /*exception*/;
      kk_box_t _x528 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x410, (_fun_unbox_x410, _b_411, _b_412, kk_std_core__exception_box(_b_413, _ctx), _ctx)); /*52*/
      kk_unit_unbox(_x528); return kk_Unit;
    }
    kk_box_t _box_x414 = err_320._cons.Ok.result;
    kk_unit_t x4 = kk_unit_unbox(_box_x414);
    kk_std_core__error_drop(err_320, _ctx);
    kk_Unit;
    x4; return kk_Unit;
  }
  kk_std_core__error_drop(_match_454, _ctx);
  kk_std_os_path__path_drop(path, _ctx);
  kk_Unit; return kk_Unit;
}
 
// Write a text file synchronously (using UTF8 encoding)


// lift anonymous function
struct kk_std_os_file_write_text_file_fun548__t {
  struct kk_function_s _base;
  kk_string_t content;
  kk_std_os_path__path path;
};
static kk_unit_t kk_std_os_file_write_text_file_fun548(kk_function_t _fself, kk_unit_t _c_329, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_write_text_file_fun548(kk_string_t content, kk_std_os_path__path path, kk_context_t* _ctx) {
  struct kk_std_os_file_write_text_file_fun548__t* _self = kk_function_alloc_as(struct kk_std_os_file_write_text_file_fun548__t, 4, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_file_write_text_file_fun548, kk_context());
  _self->content = content;
  _self->path = path;
  return &_self->_base;
}

static kk_unit_t kk_std_os_file_write_text_file_fun548(kk_function_t _fself, kk_unit_t _c_329, kk_context_t* _ctx) {
  struct kk_std_os_file_write_text_file_fun548__t* _self = kk_function_as(struct kk_std_os_file_write_text_file_fun548__t*, _fself);
  kk_string_t content = _self->content; /* string */
  kk_std_os_path__path path = _self->path; /* std/os/path/path */
  kk_drop_match(_self, {kk_string_dup(content);kk_std_os_path__path_dup(path);}, {}, _ctx)
  return kk_std_os_file__mlift343_write_text_file(content, path, _c_329, _ctx);
}


// lift anonymous function
struct kk_std_os_file_write_text_file_fun550__t {
  struct kk_function_s _base;
  kk_function_t _b_444_423;
};
static kk_box_t kk_std_os_file_write_text_file_fun550(kk_function_t _fself, kk_box_t _b_424, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_write_text_file_fun550(kk_function_t _b_444_423, kk_context_t* _ctx) {
  struct kk_std_os_file_write_text_file_fun550__t* _self = kk_function_alloc_as(struct kk_std_os_file_write_text_file_fun550__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_file_write_text_file_fun550, kk_context());
  _self->_b_444_423 = _b_444_423;
  return &_self->_base;
}

static kk_box_t kk_std_os_file_write_text_file_fun550(kk_function_t _fself, kk_box_t _b_424, kk_context_t* _ctx) {
  struct kk_std_os_file_write_text_file_fun550__t* _self = kk_function_as(struct kk_std_os_file_write_text_file_fun550__t*, _fself);
  kk_function_t _b_444_423 = _self->_b_444_423; /* (()) -> () */
  kk_drop_match(_self, {kk_function_dup(_b_444_423);}, {}, _ctx)
  kk_unit_t _x551 = kk_Unit;
  kk_unit_t _x552 = kk_Unit;
  kk_unit_unbox(_b_424);
  kk_function_call(kk_unit_t, (kk_function_t, kk_unit_t, kk_context_t*), _b_444_423, (_b_444_423, _x552, _ctx));
  return kk_unit_box(_x551);
}


// lift anonymous function
struct kk_std_os_file_write_text_file_fun554__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file_write_text_file_fun554(kk_function_t _fself, kk_box_t _b_427, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_write_text_file_fun554(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_write_text_file_fun554, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_os_file_write_text_file_fun554(kk_function_t _fself, kk_box_t _b_427, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x555;
  kk_std_os_path__path _x556 = kk_std_os_path__path_unbox(_b_427, _ctx); /*std/os/path/path*/
  _x555 = kk_std_os_path_string(_x556, _ctx); /*string*/
  return kk_string_box(_x555);
}


// lift anonymous function
struct kk_std_os_file_write_text_file_fun561__t {
  struct kk_function_s _base;
};
static kk_std_core__error kk_std_os_file_write_text_file_fun561(kk_function_t _fself, kk_string_t _x1559, kk_string_t _x2560, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_write_text_file_fun561(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_write_text_file_fun561, _ctx)
  return kk_function_dup(_fself);
}

static kk_std_core__error kk_std_os_file_write_text_file_fun561(kk_function_t _fself, kk_string_t _x1559, kk_string_t _x2560, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_os_file_write_text_file_err(_x1559, _x2560, _ctx);
}


// lift anonymous function
struct kk_std_os_file_write_text_file_fun563__t {
  struct kk_function_s _base;
  kk_function_t _b_445_430;
};
static kk_box_t kk_std_os_file_write_text_file_fun563(kk_function_t _fself, kk_box_t _b_433, kk_box_t _b_434, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_write_text_file_fun563(kk_function_t _b_445_430, kk_context_t* _ctx) {
  struct kk_std_os_file_write_text_file_fun563__t* _self = kk_function_alloc_as(struct kk_std_os_file_write_text_file_fun563__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_os_file_write_text_file_fun563, kk_context());
  _self->_b_445_430 = _b_445_430;
  return &_self->_base;
}

static kk_box_t kk_std_os_file_write_text_file_fun563(kk_function_t _fself, kk_box_t _b_433, kk_box_t _b_434, kk_context_t* _ctx) {
  struct kk_std_os_file_write_text_file_fun563__t* _self = kk_function_as(struct kk_std_os_file_write_text_file_fun563__t*, _fself);
  kk_function_t _b_445_430 = _self->_b_445_430; /* (path : string, content : string) -> fsys error<()> */
  kk_drop_match(_self, {kk_function_dup(_b_445_430);}, {}, _ctx)
  kk_std_core__error _x564;
  kk_string_t _x565 = kk_string_unbox(_b_433); /*string*/
  kk_string_t _x566 = kk_string_unbox(_b_434); /*string*/
  _x564 = kk_function_call(kk_std_core__error, (kk_function_t, kk_string_t, kk_string_t, kk_context_t*), _b_445_430, (_b_445_430, _x565, _x566, _ctx)); /*error<()>*/
  return kk_std_core__error_box(_x564, _ctx);
}

kk_unit_t kk_std_os_file_write_text_file(kk_std_os_path__path path, kk_string_t content, kk_std_core_types__optional create_dir, kk_context_t* _ctx) { /* (path : std/os/path/path, content : string, create-dir : optional<bool>) -> <exn,fsys> () */ 
  kk_unit_t x_360 = kk_Unit;
  if (kk_std_core_types__is_Optional(create_dir)) {
    kk_box_t _box_x418 = create_dir._cons.Optional.value;
    bool _create_dir_188 = kk_bool_unbox(_box_x418);
    kk_std_core_types__optional_drop(create_dir, _ctx);
    kk_Unit;
    if (_create_dir_188) {
      kk_std_os_path__path _x532;
      kk_evv_t w = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<(<>)>*/;
      kk_unit_t keep = kk_Unit;
      kk_evv_set(w,kk_context());
      kk_string_t _x533;
      kk_std_core_types__optional _match_453 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
      if (kk_std_core_types__is_Optional(_match_453)) {
        kk_box_t _box_x419 = _match_453._cons.Optional.value;
        kk_string_t _root_105 = kk_string_unbox(_box_x419);
        kk_string_dup(_root_105);
        kk_std_core_types__optional_drop(_match_453, _ctx);
        kk_Unit;
        _x533 = _root_105; /*string*/
        goto _match534;
      }
      kk_string_t _x00 = path.root;
      kk_string_dup(_x00);
      _x533 = _x00; /*string*/
      _match534: ;
      kk_std_core__list _x536;
      kk_std_core__list _x = path.parts;
      kk_std_core__list_dup(_x);
      if (kk_std_core__is_Cons(_x)) {
        struct kk_std_core_Cons* _con538 = kk_std_core__as_Cons(_x);
        kk_box_t _box_x420 = _con538->head;
        kk_std_core__list xx = _con538->tail;
        if (kk_likely(kk_std_core__list_is_unique(_x))) {
          kk_box_drop(_box_x420, _ctx);
          kk_Unit;
          kk_Unit;
          kk_std_core__list_free(_x);
        }
        else {
          kk_std_core__list_dup(xx);
          kk_Unit;
          kk_std_core__list_decref(_x, _ctx);
          kk_Unit;
        }
        _x536 = xx; /*list<string>*/
        goto _match537;
      }
      _x536 = kk_std_core__new_Nil(_ctx); /*list<string>*/
      _match537: ;
      _x532 = kk_std_os_path__new_Path(_x533, _x536, _ctx); /*std/os/path/path*/
      kk_std_os_dir_ensure_dir(_x532, _ctx);
      goto _match530;
    }
    kk_Unit;
    goto _match530;
  }
  kk_std_os_path__path _x540;
  kk_evv_t w0 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<(<>)>*/;
  kk_unit_t keep0 = kk_Unit;
  kk_evv_set(w0,kk_context());
  kk_string_t _x541;
  kk_std_core_types__optional _match_452 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
  if (kk_std_core_types__is_Optional(_match_452)) {
    kk_box_t _box_x421 = _match_452._cons.Optional.value;
    kk_string_t _root_1050 = kk_string_unbox(_box_x421);
    kk_string_dup(_root_1050);
    kk_std_core_types__optional_drop(_match_452, _ctx);
    kk_Unit;
    _x541 = _root_1050; /*string*/
    goto _match542;
  }
  kk_string_t _x000 = path.root;
  kk_string_dup(_x000);
  _x541 = _x000; /*string*/
  _match542: ;
  kk_std_core__list _x544;
  kk_std_core__list _x11 = path.parts;
  kk_std_core__list_dup(_x11);
  if (kk_std_core__is_Cons(_x11)) {
    struct kk_std_core_Cons* _con546 = kk_std_core__as_Cons(_x11);
    kk_box_t _box_x422 = _con546->head;
    kk_std_core__list xx0 = _con546->tail;
    if (kk_likely(kk_std_core__list_is_unique(_x11))) {
      kk_box_drop(_box_x422, _ctx);
      kk_Unit;
      kk_Unit;
      kk_std_core__list_free(_x11);
    }
    else {
      kk_std_core__list_dup(xx0);
      kk_Unit;
      kk_std_core__list_decref(_x11, _ctx);
      kk_Unit;
    }
    _x544 = xx0; /*list<string>*/
    goto _match545;
  }
  _x544 = kk_std_core__new_Nil(_ctx); /*list<string>*/
  _match545: ;
  _x540 = kk_std_os_path__new_Path(_x541, _x544, _ctx); /*std/os/path/path*/
  kk_std_os_dir_ensure_dir(_x540, _ctx);
  _match530: ;
  if (kk_yielding(kk_context())) {
    kk_function_t _b_444_423 = kk_std_os_file_new_write_text_file_fun548(content, path, _ctx); /*(()) -> ()*/;
    kk_box_t _x549 = kk_std_core_hnd_yield_extend(kk_std_os_file_new_write_text_file_fun550(_b_444_423, _ctx), _ctx); /*3858*/
    kk_unit_unbox(_x549); return kk_Unit;
  }
  kk_string_t _x12;
  kk_box_t _x553;
  kk_box_t _x557;
  kk_std_os_path__path _x558 = kk_std_os_path__path_dup(path); /*std/os/path/path*/
  _x557 = kk_std_os_path__path_box(_x558, _ctx); /*3288*/
  _x553 = kk_std_core_hnd__open_none1(kk_std_os_file_new_write_text_file_fun554(_ctx), _x557, _ctx); /*3289*/
  _x12 = kk_string_unbox(_x553); /*string*/
  kk_std_core__error _match_449;
  kk_function_t _b_445_430 = kk_std_os_file_new_write_text_file_fun561(_ctx); /*(path : string, content : string) -> fsys error<()>*/;
  kk_string_t _b_446_431 = _x12; /*string*/;
  kk_string_t _b_447_432 = content; /*string*/;
  kk_box_t _x562 = kk_std_core_hnd__open_none2(kk_std_os_file_new_write_text_file_fun563(_b_445_430, _ctx), kk_string_box(_b_446_431), kk_string_box(_b_447_432), _ctx); /*3381*/
  _match_449 = kk_std_core__error_unbox(_x562, _ctx); /*error<()>*/
  if (kk_std_core__is_Error(_match_449)) {
    kk_std_core__exception exn = _match_449._cons.Error.exception;
    kk_std_core__exception_dup(exn);
    kk_std_core__error_drop(_match_449, _ctx);
    kk_Unit;
    kk_std_core__error err_320;
    kk_std_core__exception _x567;
    kk_string_t _x20;
    kk_string_t _x568;
    kk_define_string_literal(, _s569, 26, "unable to write text file ")
    _x568 = kk_string_dup(_s569); /*string*/
    kk_string_t _x570;
    kk_evv_t w1 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<(<>)>*/;
    kk_string_t x3;
    kk_string_t _x571 = kk_std_os_path_string(path, _ctx); /*string*/
    x3 = kk_std_core_show_3(_x571, _ctx); /*string*/
    kk_unit_t keep1 = kk_Unit;
    kk_evv_set(w1,kk_context());
    _x570 = x3; /*string*/
    _x20 = kk_std_core__lp__plus__plus__1_rp_(_x568, _x570, _ctx); /*string*/
    kk_evv_t w2 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<(<>)>*/;
    kk_std_core__exception x4;
    kk_string_t _x572;
    kk_string_t _x573;
    kk_string_t _x574;
    kk_define_string_literal(, _s575, 2, ": ")
    _x574 = kk_string_dup(_s575); /*string*/
    kk_string_t _x576;
    kk_string_t _x21 = exn.message;
    kk_string_dup(_x21);
    _x576 = _x21; /*string*/
    _x573 = kk_std_core__lp__plus__plus__1_rp_(_x574, _x576, _ctx); /*string*/
    _x572 = kk_std_core__lp__plus__plus__1_rp_(_x20, _x573, _ctx); /*string*/
    kk_std_core__exception_info _x577;
    kk_std_core__exception_info _x3 = exn.info;
    kk_std_core__exception_info_dup(_x3);
    kk_std_core__exception_drop(exn, _ctx);
    kk_Unit;
    _x577 = _x3; /*exception-info*/
    x4 = kk_std_core__new_Exception(_x572, _x577, _ctx); /*exception*/
    kk_unit_t keep2 = kk_Unit;
    kk_evv_set(w2,kk_context());
    _x567 = x4; /*exception*/
    err_320 = kk_std_core__new_Error(_x567, _ctx); /*error<()>*/
    if (kk_std_core__is_Error(err_320)) {
      kk_std_core__exception exn0 = err_320._cons.Error.exception;
      kk_std_core__exception_dup(exn0);
      kk_std_core__error_drop(err_320, _ctx);
      kk_Unit;
      kk_std_core_hnd__ev ev_372;
      kk_ssize_t _x578 = ((kk_ssize_t)0); /*ssize_t*/
      ev_372 = kk_evv_at(_x578,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
      struct kk_std_core_hnd_Ev* _con579 = kk_std_core_hnd__as_Ev(ev_372);
      kk_std_core_hnd__marker m0 = _con579->marker;
      kk_box_t _box_x435 = _con579->hnd;
      kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x435, NULL);
      kk_std_core__hnd_exn_dup(h);
      kk_std_core_hnd__clause1 _match_450;
      kk_std_core_hnd__clause1 _borrowApp_451 = kk_std_core__select_throw_exn(h, _ctx); /*std/core/hnd/clause1<exception,1926,.hnd-exn,1927,1928>*/;
      kk_std_core__hnd_exn_drop(h, _ctx);
      _match_450 = _borrowApp_451; /*std/core/hnd/clause1<exception,1926,.hnd-exn,1927,1928>*/
      kk_function_t _fun_unbox_x439 = _match_450.clause;
      kk_std_core_hnd__marker _b_440 = m0; /*std/core/hnd/marker<3573,3574>*/;
      kk_std_core_hnd__ev _b_441 = ev_372; /*std/core/hnd/ev<.hnd-exn>*/;
      kk_std_core__exception _b_442 = exn0; /*exception*/;
      kk_box_t _x581 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x439, (_fun_unbox_x439, _b_440, _b_441, kk_std_core__exception_box(_b_442, _ctx), _ctx)); /*52*/
      kk_unit_unbox(_x581); return kk_Unit;
    }
    kk_box_t _box_x443 = err_320._cons.Ok.result;
    kk_unit_t x6 = kk_unit_unbox(_box_x443);
    kk_std_core__error_drop(err_320, _ctx);
    kk_Unit;
    x6; return kk_Unit;
  }
  kk_std_core__error_drop(_match_449, _ctx);
  kk_std_os_path__path_drop(path, _ctx);
  kk_Unit; return kk_Unit;
}

// initialization
void kk_std_os_file__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core__init(_ctx);
  kk_std_os_path__init(_ctx);
  kk_std_os_dir__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
}

// termination
void kk_std_os_file__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_os_dir__done(_ctx);
  kk_std_os_path__done(_ctx);
  kk_std_core__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
