#pragma once
#ifndef kk_std_time_duration_H
#define kk_std_time_duration_H
// Koka generated module: "std/time/duration", koka version: 2.2.1
#include <kklib.h>
#include "std_core_types.h"
#include "std_core.h"
#include "std_num_ddouble.h"
#include "std_time_timestamp.h"

// type declarations

// value type std/time/duration/duration
struct kk_std_time_duration_Duration {
  kk_std_num_ddouble__ddouble secs;
};
typedef struct kk_std_time_duration_Duration kk_std_time_duration__duration;
static inline kk_std_time_duration__duration kk_std_time_duration__new_Duration(kk_std_num_ddouble__ddouble secs, kk_context_t* _ctx){
  kk_std_time_duration__duration _con = { secs };
  return _con;
}
static inline bool kk_std_time_duration__is_Duration(kk_std_time_duration__duration x) {
  return (true);
}
static inline kk_std_time_duration__duration kk_std_time_duration__duration_dup(kk_std_time_duration__duration _x) {
  kk_std_num_ddouble__ddouble_dup(_x.secs);
  return _x;
}
static inline void kk_std_time_duration__duration_drop(kk_std_time_duration__duration _x, kk_context_t* _ctx) {
  kk_std_num_ddouble__ddouble_drop(_x.secs, _ctx);
}
static inline kk_box_t kk_std_time_duration__duration_box(kk_std_time_duration__duration _x, kk_context_t* _ctx) {
  return kk_std_num_ddouble__ddouble_box(_x.secs, _ctx);
}
static inline kk_std_time_duration__duration kk_std_time_duration__duration_unbox(kk_box_t _x, kk_context_t* _ctx) {
  return kk_std_time_duration__new_Duration(kk_std_num_ddouble__ddouble_unbox(_x, _ctx), _ctx);
}

// value declarations
 
// Automatically generated. Retrieves the `secs` constructor field of the `:duration` type.

static inline kk_std_num_ddouble__ddouble kk_std_time_duration_secs(kk_std_time_duration__duration duration1, kk_context_t* _ctx) { /* (duration : duration) -> std/time/timestamp/timespan */ 
  kk_std_num_ddouble__ddouble _x = duration1.secs;
  return _x;
}

static inline kk_std_time_duration__duration kk_std_time_duration__copy(kk_std_time_duration__duration _this, kk_std_core_types__optional secs0, kk_context_t* _ctx) { /* (duration, secs : optional<std/time/timestamp/timespan>) -> duration */ 
  kk_std_num_ddouble__ddouble _x1535;
  if (kk_std_core_types__is_Optional(secs0)) {
    kk_box_t _box_x1435 = secs0._cons.Optional.value;
    kk_std_num_ddouble__ddouble _secs_60 = kk_std_num_ddouble__ddouble_unbox(_box_x1435, NULL);
    kk_std_core_types__optional_drop(secs0, _ctx);
    kk_Unit;
    _x1535 = _secs_60; /*std/time/timestamp/timespan*/
    goto _match1536;
  }
  kk_std_num_ddouble__ddouble _x = _this.secs;
  _x1535 = _x; /*std/time/timestamp/timespan*/
  _match1536: ;
  return kk_std_time_duration__new_Duration(_x1535, _ctx);
}

kk_std_core_types__order kk_std_time_duration_compare(kk_std_time_duration__duration i, kk_std_time_duration__duration j, kk_context_t* _ctx); /* (i : duration, j : duration) -> order */ 

bool kk_std_time_duration__lp__excl__eq__rp_(kk_std_time_duration__duration i, kk_std_time_duration__duration j, kk_context_t* _ctx); /* (i : duration, j : duration) -> bool */ 
 
// Convert a `:timespan` to a `:duration`. Be careful to only use
// use this on timespan's that are in TAI SI seconds!

static inline kk_std_time_duration__duration kk_std_time_duration_duration(kk_std_num_ddouble__ddouble t, kk_context_t* _ctx) { /* (t : std/time/timestamp/timespan) -> duration */ 
  return kk_std_time_duration__new_Duration(t, _ctx);
}

kk_std_time_duration__duration kk_std_time_duration_duration_1(kk_integer_t secs0, kk_std_core_types__optional frac, kk_context_t* _ctx); /* (secs : int, frac : optional<double>) -> duration */ 
 
// Create a duration from seconds as a `:double`.

static inline kk_std_time_duration__duration kk_std_time_duration_duration_2(double secs0, kk_context_t* _ctx) { /* (secs : double) -> duration */ 
  kk_std_num_ddouble__ddouble _x1560 = kk_std_num_ddouble__new_Ddouble(secs0, 0.0, _ctx); /*std/num/ddouble/ddouble*/
  return kk_std_time_duration__new_Duration(_x1560, _ctx);
}
 
// Return the duration in SI seconds.

static inline kk_std_num_ddouble__ddouble kk_std_time_duration_seconds(kk_std_time_duration__duration d, kk_context_t* _ctx) { /* (d : duration) -> std/time/timestamp/timespan */ 
  kk_std_num_ddouble__ddouble _x = d.secs;
  return _x;
}

kk_std_time_duration__duration kk_std_time_duration_seconds_1(kk_integer_t n, kk_context_t* _ctx); /* (n : int) -> duration */ 
 
// Convert a duration to a `:timespan`.

static inline kk_std_num_ddouble__ddouble kk_std_time_duration_timespan(kk_std_time_duration__duration d, kk_context_t* _ctx) { /* (d : duration) -> std/time/timestamp/timespan */ 
  kk_std_num_ddouble__ddouble _x = d.secs;
  return _x;
}
 
// Add two durations.

static inline kk_std_time_duration__duration kk_std_time_duration__lp__plus__rp_(kk_std_time_duration__duration d, kk_std_time_duration__duration e, kk_context_t* _ctx) { /* (d : duration, e : duration) -> duration */ 
  kk_std_num_ddouble__ddouble _x1574;
  kk_std_num_ddouble__ddouble _x1575;
  kk_std_num_ddouble__ddouble _x = d.secs;
  _x1575 = _x; /*std/time/timestamp/timespan*/
  kk_std_num_ddouble__ddouble _x1576;
  kk_std_num_ddouble__ddouble _x0 = e.secs;
  _x1576 = _x0; /*std/time/timestamp/timespan*/
  _x1574 = kk_std_num_ddouble__lp__plus__rp_(_x1575, _x1576, _ctx); /*std/num/ddouble/ddouble*/
  return kk_std_time_duration__new_Duration(_x1574, _ctx);
}
 
// Negate a duration.

static inline kk_std_time_duration__duration kk_std_time_duration__lp__tilde__rp_(kk_std_time_duration__duration d, kk_context_t* _ctx) { /* (d : duration) -> duration */ 
  kk_std_num_ddouble__ddouble _x1577;
  double _x1578;
  double _x1579;
  kk_std_num_ddouble__ddouble _x1 = d.secs;
  double _x = _x1.hi;
  _x1579 = _x; /*double*/
  _x1578 = (-_x1579); /*double*/
  double _x1580;
  double _x1581;
  kk_std_num_ddouble__ddouble _x10 = d.secs;
  double _x0 = _x10.lo;
  _x1581 = _x0; /*double*/
  _x1580 = (-_x1581); /*double*/
  _x1577 = kk_std_num_ddouble__new_Ddouble(_x1578, _x1580, _ctx); /*std/num/ddouble/ddouble*/
  return kk_std_time_duration__new_Duration(_x1577, _ctx);
}

kk_std_time_duration__duration kk_std_time_duration__lp__dash__rp_(kk_std_time_duration__duration d, kk_std_time_duration__duration e, kk_context_t* _ctx); /* (d : duration, e : duration) -> duration */ 

bool kk_std_time_duration__lp__eq__eq__rp_(kk_std_time_duration__duration i, kk_std_time_duration__duration j, kk_context_t* _ctx); /* (i : duration, j : duration) -> bool */ 

bool kk_std_time_duration__lp__lt__rp_(kk_std_time_duration__duration i, kk_std_time_duration__duration j, kk_context_t* _ctx); /* (i : duration, j : duration) -> bool */ 

bool kk_std_time_duration__lp__lt__eq__rp_(kk_std_time_duration__duration i, kk_std_time_duration__duration j, kk_context_t* _ctx); /* (i : duration, j : duration) -> bool */ 

bool kk_std_time_duration__lp__gt__rp_(kk_std_time_duration__duration i, kk_std_time_duration__duration j, kk_context_t* _ctx); /* (i : duration, j : duration) -> bool */ 

bool kk_std_time_duration__lp__gt__eq__rp_(kk_std_time_duration__duration i, kk_std_time_duration__duration j, kk_context_t* _ctx); /* (i : duration, j : duration) -> bool */ 

kk_std_time_duration__duration kk_std_time_duration_days(kk_integer_t n, kk_context_t* _ctx); /* (n : int) -> duration */ 

extern kk_std_time_duration__duration kk_std_time_duration_duration0;

double kk_std_time_duration_fraction(kk_std_time_duration__duration d, kk_context_t* _ctx); /* (d : duration) -> double */ 

kk_std_time_duration__duration kk_std_time_duration_hours(kk_integer_t n, kk_context_t* _ctx); /* (n : int) -> duration */ 
 
// Is this a negative duration?

static inline bool kk_std_time_duration_is_neg(kk_std_time_duration__duration d, kk_context_t* _ctx) { /* (d : duration) -> bool */ 
  double _x1631;
  kk_std_num_ddouble__ddouble _x0 = d.secs;
  double _x = _x0.hi;
  _x1631 = _x; /*double*/
  return (_x1631 < (0.0));
}
 
// Is this a positive duration?

static inline bool kk_std_time_duration_is_pos(kk_std_time_duration__duration d, kk_context_t* _ctx) { /* (d : duration) -> bool */ 
  double _x1632;
  kk_std_num_ddouble__ddouble _x0 = d.secs;
  double _x = _x0.hi;
  _x1632 = _x; /*double*/
  return (_x1632 > (0.0));
}
 
// Is this a zero duration?

static inline bool kk_std_time_duration_is_zero(kk_std_time_duration__duration d, kk_context_t* _ctx) { /* (d : duration) -> bool */ 
  double _x1633;
  kk_std_num_ddouble__ddouble _x0 = d.secs;
  double _x = _x0.hi;
  _x1633 = _x; /*double*/
  return (_x1633 == (0.0));
}
 
// The maximum of two durations.

static inline kk_std_time_duration__duration kk_std_time_duration_max(kk_std_time_duration__duration i, kk_std_time_duration__duration j, kk_context_t* _ctx) { /* (i : duration, j : duration) -> duration */ 
  bool _match_1504 = kk_std_time_duration__lp__gt__eq__rp_(i, j, _ctx); /*bool*/;
  if (_match_1504) {
    return i;
  }
  return j;
}

kk_integer_t kk_std_time_duration_milli_seconds(kk_std_time_duration__duration d, kk_context_t* _ctx); /* (d : duration) -> int */ 

kk_std_time_duration__duration kk_std_time_duration_milli_seconds_1(kk_integer_t n, kk_context_t* _ctx); /* (n : int) -> duration */ 
 
// The minimum of two durations.

static inline kk_std_time_duration__duration kk_std_time_duration_min(kk_std_time_duration__duration i, kk_std_time_duration__duration j, kk_context_t* _ctx) { /* (i : duration, j : duration) -> duration */ 
  bool _match_1494 = kk_std_time_duration__lp__lt__eq__rp_(i, j, _ctx); /*bool*/;
  if (_match_1494) {
    return i;
  }
  return j;
}

kk_std_time_duration__duration kk_std_time_duration_minutes(kk_integer_t n, kk_context_t* _ctx); /* (n : int) -> duration */ 

kk_integer_t kk_std_time_duration_nano_seconds(kk_std_time_duration__duration d, kk_context_t* _ctx); /* (d : duration) -> int */ 

kk_string_t kk_std_time_duration_show(kk_std_time_duration__duration d, kk_std_core_types__optional max_prec, kk_context_t* _ctx); /* (d : duration, max-prec : optional<int>) -> string */ 
 
// Convert a duration to a `:timespan`.

static inline kk_std_time_timestamp__timestamp kk_std_time_duration_timestamp(kk_std_time_duration__duration d, kk_context_t* _ctx) { /* (d : duration) -> std/time/timestamp/timestamp */ 
  kk_std_num_ddouble__ddouble _x1697;
  kk_std_num_ddouble__ddouble _x = d.secs;
  _x1697 = _x; /*std/time/timestamp/timespan*/
  int32_t _x1698;
  kk_integer_t _x1699;
  kk_std_core_types__optional _match_1488 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
  if (kk_std_core_types__is_Optional(_match_1488)) {
    kk_box_t _box_x1472 = _match_1488._cons.Optional.value;
    kk_integer_t _leap_319 = kk_integer_unbox(_box_x1472);
    kk_integer_dup(_leap_319);
    kk_std_core_types__optional_drop(_match_1488, _ctx);
    kk_Unit;
    _x1699 = _leap_319; /*int*/
    goto _match1700;
  }
  _x1699 = kk_integer_from_small(0); /*int*/
  _match1700: ;
  _x1698 = kk_std_core_int32(_x1699, _ctx); /*int32*/
  return kk_std_time_timestamp__new_Timestamp(_x1697, _x1698, _ctx);
}
 
// The whole seconds (in some time unit) of the duration as `:int``. Rounds towards zero.

static inline kk_integer_t kk_std_time_duration_truncate(kk_std_time_duration__duration d, kk_context_t* _ctx) { /* (d : duration) -> int */ 
  kk_std_num_ddouble__ddouble _x1702;
  bool _match_1487;
  double _x1703;
  kk_std_num_ddouble__ddouble _x0 = d.secs;
  double _x = _x0.hi;
  _x1703 = _x; /*double*/
  _match_1487 = (_x1703 < (0.0)); /*bool*/
  if (_match_1487) {
    kk_std_num_ddouble__ddouble _x1704;
    kk_std_num_ddouble__ddouble _x00 = d.secs;
    _x1704 = _x00; /*std/time/timestamp/timespan*/
    _x1702 = kk_std_num_ddouble_ceiling(_x1704, _ctx); /*std/num/ddouble/ddouble*/
  }
  else {
    kk_std_num_ddouble__ddouble _x1705;
    kk_std_num_ddouble__ddouble _x01 = d.secs;
    _x1705 = _x01; /*std/time/timestamp/timespan*/
    _x1702 = kk_std_num_ddouble_floor(_x1705, _ctx); /*std/num/ddouble/ddouble*/
  }
  return kk_std_num_ddouble_int(_x1702, kk_std_core_types__new_None(_ctx), _ctx);
}
 
// Convert a `:timestamp` to a `:duration`. Be careful to only use
// use this on timestamp's that are in TAI SI seconds and do not
// contain leap seconds!

static inline kk_std_time_duration__duration kk_std_time_duration_unsafe_duration(kk_std_time_timestamp__timestamp t, kk_context_t* _ctx) { /* (t : std/time/timestamp/timestamp) -> duration */ 
  kk_std_num_ddouble__ddouble _x1706 = kk_std_time_timestamp_unsafe_timespan_withleap(t, _ctx); /*std/time/timestamp/timespan*/
  return kk_std_time_duration__new_Duration(_x1706, _ctx);
}

kk_std_time_duration__duration kk_std_time_duration_weeks(kk_integer_t n, kk_context_t* _ctx); /* (n : int) -> duration */ 

kk_std_time_duration__duration kk_std_time_duration_years(kk_integer_t n, kk_context_t* _ctx); /* (n : int) -> duration */ 

extern kk_std_time_duration__duration kk_std_time_duration_zero;

void kk_std_time_duration__init(kk_context_t* _ctx);


void kk_std_time_duration__done(kk_context_t* _ctx);

#endif // header
