#pragma once
#ifndef kk_std_time_timestamp_H
#define kk_std_time_timestamp_H
// Koka generated module: "std/time/timestamp", koka version: 2.2.1
#include <kklib.h>
#include "std_core_types.h"
#include "std_core.h"
#include "std_num_int32.h"
#include "std_num_ddouble.h"
#include "std_time_date.h"

// type declarations

// value type std/time/timestamp/timestamp
struct kk_std_time_timestamp_Timestamp {
  kk_std_num_ddouble__ddouble since;
  int32_t leap32;
};
typedef struct kk_std_time_timestamp_Timestamp kk_std_time_timestamp__timestamp;
static inline kk_std_time_timestamp__timestamp kk_std_time_timestamp__new_Timestamp(kk_std_num_ddouble__ddouble since, int32_t leap32, kk_context_t* _ctx){
  kk_std_time_timestamp__timestamp _con;
  _con.since = since;
  _con.leap32 = leap32;
  return _con;
}
static inline bool kk_std_time_timestamp__is_Timestamp(kk_std_time_timestamp__timestamp x) {
  return (true);
}
static inline kk_std_time_timestamp__timestamp kk_std_time_timestamp__timestamp_dup(kk_std_time_timestamp__timestamp _x) {
  kk_std_num_ddouble__ddouble_dup(_x.since);
  return _x;
}
static inline void kk_std_time_timestamp__timestamp_drop(kk_std_time_timestamp__timestamp _x, kk_context_t* _ctx) {
  kk_std_num_ddouble__ddouble_drop(_x.since, _ctx);
}
static inline kk_box_t kk_std_time_timestamp__timestamp_box(kk_std_time_timestamp__timestamp _x, kk_context_t* _ctx) {
  kk_box_t _box;
  kk_valuetype_box(kk_std_time_timestamp__timestamp, _box, _x, 0 /* scan count */, _ctx);
  return _box;
}
static inline kk_std_time_timestamp__timestamp kk_std_time_timestamp__timestamp_unbox(kk_box_t _x, kk_context_t* _ctx) {
  kk_boxed_value_t _p;
  kk_std_time_timestamp__timestamp _unbox;
  kk_valuetype_unbox_(kk_std_time_timestamp__timestamp, _p, _unbox, _x, _ctx);
  if (_ctx!=NULL && _p!=NULL) {
    if (kk_basetype_is_unique(_p)) { kk_basetype_free(_p); } else {
      kk_std_time_timestamp__timestamp_dup(_unbox);
      kk_basetype_decref(_p, _ctx);
    }
  }
  return _unbox;
}

// value declarations
 
// Automatically generated. Retrieves the `since` constructor field of the `:timestamp` type.

static inline kk_std_num_ddouble__ddouble kk_std_time_timestamp_since(kk_std_time_timestamp__timestamp timestamp1, kk_context_t* _ctx) { /* (timestamp : timestamp) -> timespan */ 
  kk_std_num_ddouble__ddouble _x = timestamp1.since;
  return _x;
}
 
// Automatically generated. Retrieves the `leap32` constructor field of the `:timestamp` type.

static inline int32_t kk_std_time_timestamp_leap32(kk_std_time_timestamp__timestamp timestamp1, kk_context_t* _ctx) { /* (timestamp : timestamp) -> int32 */ 
  kk_std_num_ddouble__ddouble _pat0 = timestamp1.since;
  int32_t _x = timestamp1.leap32;
  return _x;
}

static inline kk_std_time_timestamp__timestamp kk_std_time_timestamp__copy(kk_std_time_timestamp__timestamp _this, kk_std_core_types__optional since0, kk_std_core_types__optional leap320, kk_context_t* _ctx) { /* (timestamp, since : optional<timespan>, leap32 : optional<int32>) -> timestamp */ 
  kk_std_num_ddouble__ddouble _x2467;
  if (kk_std_core_types__is_Optional(since0)) {
    kk_box_t _box_x2336 = since0._cons.Optional.value;
    kk_std_num_ddouble__ddouble _since_78 = kk_std_num_ddouble__ddouble_unbox(_box_x2336, NULL);
    kk_std_core_types__optional_drop(since0, _ctx);
    kk_Unit;
    _x2467 = _since_78; /*std/time/timestamp/timespan*/
    goto _match2468;
  }
  kk_std_num_ddouble__ddouble _x = _this.since;
  _x2467 = _x; /*std/time/timestamp/timespan*/
  _match2468: ;
  int32_t _x2470;
  if (kk_std_core_types__is_Optional(leap320)) {
    kk_box_t _box_x2337 = leap320._cons.Optional.value;
    int32_t _leap32_84 = kk_int32_unbox(_box_x2337, NULL);
    kk_std_core_types__optional_drop(leap320, _ctx);
    kk_Unit;
    _x2470 = _leap32_84; /*int32*/
    goto _match2471;
  }
  kk_std_num_ddouble__ddouble _pat01 = _this.since;
  int32_t _x0 = _this.leap32;
  _x2470 = _x0; /*int32*/
  _match2471: ;
  return kk_std_time_timestamp__new_Timestamp(_x2467, _x2470, _ctx);
}

static inline kk_integer_t kk_std_time_timestamp_leap(kk_std_time_timestamp__timestamp t, kk_context_t* _ctx) { /* (t : timestamp) -> int */ 
  int32_t _x2473;
  kk_std_num_ddouble__ddouble _pat0 = t.since;
  int32_t _x = t.leap32;
  _x2473 = _x; /*int32*/
  return kk_integer_from_int(_x2473,kk_context());
}
 
// Seconds in a solar day, 86400.

extern kk_integer_t kk_std_time_timestamp_isolar_secs_per_day;
 
// Divide using `div` to allow for different timespan representations

static inline kk_std_num_ddouble__ddouble kk_std_time_timestamp_div(kk_std_num_ddouble__ddouble x, kk_std_num_ddouble__ddouble y, kk_std_core_types__optional prec, kk_context_t* _ctx) { /* (x : timespan, y : timespan, prec : optional<int>) -> timespan */ 
  kk_std_core_types__optional_drop(prec, _ctx);
  return kk_std_num_ddouble__lp__fs__rp_(x, y, _ctx);
}
 
// The time span since 2000-01-01 for time scales that do not have
// leap seconds and where every day is 86400s. For time scales
// with leap seconds, this effectively ignores any leap seconds.

static inline kk_std_num_ddouble__ddouble kk_std_time_timestamp_timespan_noleap(kk_std_time_timestamp__timestamp ts, kk_context_t* _ctx) { /* (ts : timestamp) -> timespan */ 
  kk_std_num_ddouble__ddouble _x = ts.since;
  return _x;
}
 
// A zero-valued timespan.

extern kk_std_num_ddouble__ddouble kk_std_time_timestamp_timespan0;

kk_std_core_types__order kk_std_time_timestamp_compare(kk_std_time_timestamp__timestamp i, kk_std_time_timestamp__timestamp j, kk_context_t* _ctx); /* (i : timestamp, j : timestamp) -> order */ 

bool kk_std_time_timestamp__lp__excl__eq__rp_(kk_std_time_timestamp__timestamp i, kk_std_time_timestamp__timestamp j, kk_context_t* _ctx); /* (i : timestamp, j : timestamp) -> bool */ 
 
// Add a time span to a time stamp.

static inline kk_std_time_timestamp__timestamp kk_std_time_timestamp__lp__plus__rp_(kk_std_time_timestamp__timestamp ts, kk_std_num_ddouble__ddouble t, kk_context_t* _ctx) { /* (ts : timestamp, t : timespan) -> timestamp */ 
  kk_std_num_ddouble__ddouble _x2485;
  kk_std_num_ddouble__ddouble _x2486;
  kk_std_num_ddouble__ddouble _x = ts.since;
  _x2486 = _x; /*std/time/timestamp/timespan*/
  _x2485 = kk_std_num_ddouble__lp__plus__rp_(_x2486, t, _ctx); /*std/num/ddouble/ddouble*/
  int32_t _x2487;
  kk_std_num_ddouble__ddouble _pat00 = ts.since;
  int32_t _x0 = ts.leap32;
  _x2487 = _x0; /*int32*/
  return kk_std_time_timestamp__new_Timestamp(_x2485, _x2487, _ctx);
}
 
// Create a time stamp from a `:timespan` since 2000-01-01 and possible leap seconds.

static inline kk_std_time_timestamp__timestamp kk_std_time_timestamp_timestamp(kk_std_num_ddouble__ddouble t, kk_std_core_types__optional leap0, kk_context_t* _ctx) { /* (t : timespan, leap : optional<int>) -> timestamp */ 
  int32_t _x2488;
  kk_integer_t _x2489;
  if (kk_std_core_types__is_Optional(leap0)) {
    kk_box_t _box_x2338 = leap0._cons.Optional.value;
    kk_integer_t _leap_319 = kk_integer_unbox(_box_x2338);
    kk_integer_dup(_leap_319);
    kk_std_core_types__optional_drop(leap0, _ctx);
    kk_Unit;
    _x2489 = _leap_319; /*int*/
    goto _match2490;
  }
  _x2489 = kk_integer_from_small(0); /*int*/
  _match2490: ;
  _x2488 = kk_std_core_int32(_x2489, _ctx); /*int32*/
  return kk_std_time_timestamp__new_Timestamp(t, _x2488, _ctx);
}

kk_std_time_timestamp__timestamp kk_std_time_timestamp_timestamp_1(kk_integer_t t, kk_std_core_types__optional frac, kk_std_core_types__optional leap0, kk_context_t* _ctx); /* (t : int, frac : optional<double>, leap : optional<int>) -> timestamp */ 
 
// Subtract a time span from a time stamp.

static inline kk_std_time_timestamp__timestamp kk_std_time_timestamp__lp__dash__rp_(kk_std_time_timestamp__timestamp ts, kk_std_num_ddouble__ddouble t, kk_context_t* _ctx) { /* (ts : timestamp, t : timespan) -> timestamp */ 
  kk_std_num_ddouble__ddouble _x2501;
  kk_std_num_ddouble__ddouble _x2502;
  kk_std_num_ddouble__ddouble _x1 = ts.since;
  _x2502 = _x1; /*std/time/timestamp/timespan*/
  kk_std_num_ddouble__ddouble _x2503;
  double _x2504;
  double _x2505;
  double _x = t.hi;
  _x2505 = _x; /*double*/
  _x2504 = (-_x2505); /*double*/
  double _x2506;
  double _x2507;
  double _x0 = t.lo;
  _x2507 = _x0; /*double*/
  _x2506 = (-_x2507); /*double*/
  _x2503 = kk_std_num_ddouble__new_Ddouble(_x2504, _x2506, _ctx); /*std/num/ddouble/ddouble*/
  _x2501 = kk_std_num_ddouble__lp__plus__rp_(_x2502, _x2503, _ctx); /*std/num/ddouble/ddouble*/
  int32_t _x2508;
  kk_std_num_ddouble__ddouble _pat02 = ts.since;
  int32_t _x2 = ts.leap32;
  _x2508 = _x2; /*int32*/
  return kk_std_time_timestamp__new_Timestamp(_x2501, _x2508, _ctx);
}

bool kk_std_time_timestamp__lp__eq__eq__rp_(kk_std_time_timestamp__timestamp i, kk_std_time_timestamp__timestamp j, kk_context_t* _ctx); /* (i : timestamp, j : timestamp) -> bool */ 

bool kk_std_time_timestamp__lp__lt__rp_(kk_std_time_timestamp__timestamp i, kk_std_time_timestamp__timestamp j, kk_context_t* _ctx); /* (i : timestamp, j : timestamp) -> bool */ 

bool kk_std_time_timestamp__lp__lt__eq__rp_(kk_std_time_timestamp__timestamp i, kk_std_time_timestamp__timestamp j, kk_context_t* _ctx); /* (i : timestamp, j : timestamp) -> bool */ 

bool kk_std_time_timestamp__lp__gt__rp_(kk_std_time_timestamp__timestamp i, kk_std_time_timestamp__timestamp j, kk_context_t* _ctx); /* (i : timestamp, j : timestamp) -> bool */ 

bool kk_std_time_timestamp__lp__gt__eq__rp_(kk_std_time_timestamp__timestamp i, kk_std_time_timestamp__timestamp j, kk_context_t* _ctx); /* (i : timestamp, j : timestamp) -> bool */ 

kk_std_num_ddouble__ddouble kk_std_time_timestamp_timespan(kk_integer_t seconds, kk_std_core_types__optional frac, kk_context_t* _ctx); /* (seconds : int, frac : optional<double>) -> timespan */ 

static inline kk_std_num_ddouble__ddouble kk_std_time_timestamp_timespan_1(double secs, kk_context_t* _ctx) { /* (secs : double) -> timespan */ 
  return kk_std_num_ddouble__new_Ddouble(secs, 0.0, _ctx);
}
 
// Timespan from a `:ddouble`. Just for convenience as `:timespan` is an alias

static inline kk_std_num_ddouble__ddouble kk_std_time_timestamp_timespan_2(kk_std_num_ddouble__ddouble secs, kk_context_t* _ctx) { /* (secs : std/num/ddouble/ddouble) -> timespan */ 
  return secs;
}

kk_std_time_timestamp__timestamp kk_std_time_timestamp_add_days(kk_std_time_timestamp__timestamp ts, kk_integer_t days0, kk_context_t* _ctx); /* (ts : timestamp, days : int) -> timestamp */ 

kk_std_time_timestamp__timestamp kk_std_time_timestamp_add_leap_seconds(kk_std_time_timestamp__timestamp ts, kk_std_num_ddouble__ddouble leaps, kk_context_t* _ctx); /* (ts : timestamp, leaps : timespan) -> timestamp */ 

kk_std_core_types__tuple2_ kk_std_time_timestamp_days_seconds(kk_std_time_timestamp__timestamp ts, kk_context_t* _ctx); /* (ts : timestamp) -> (int, std/num/ddouble/ddouble) */ 

static inline kk_integer_t kk_std_time_timestamp_days(kk_std_time_timestamp__timestamp ts, kk_context_t* _ctx) { /* (ts : timestamp) -> int */ 
  kk_std_core_types__tuple2_ _this_2284 = kk_std_time_timestamp_days_seconds(ts, _ctx); /*(int, std/num/ddouble/ddouble)*/;
  kk_box_t _box_x2355 = _this_2284.fst;
  kk_box_t _box_x2356 = _this_2284.snd;
  kk_integer_t _x = kk_integer_unbox(_box_x2355);
  kk_integer_dup(_x);
  kk_std_core_types__tuple2__drop(_this_2284, _ctx);
  kk_Unit;
  return _x;
}

kk_std_core_types__tuple2_ kk_std_time_timestamp_days_clock(kk_std_time_timestamp__timestamp ts, kk_context_t* _ctx); /* (ts : timestamp) -> (int, std/time/date/clock) */ 
 
// The maximum of two timestamps.

static inline kk_std_time_timestamp__timestamp kk_std_time_timestamp_max(kk_std_time_timestamp__timestamp i, kk_std_time_timestamp__timestamp j, kk_context_t* _ctx) { /* (i : timestamp, j : timestamp) -> timestamp */ 
  bool _match_2420 = kk_std_time_timestamp__lp__gt__eq__rp_(i, j, _ctx); /*bool*/;
  if (_match_2420) {
    return i;
  }
  return j;
}
 
// The minimum of two timestamps.

static inline kk_std_time_timestamp__timestamp kk_std_time_timestamp_min(kk_std_time_timestamp__timestamp i, kk_std_time_timestamp__timestamp j, kk_context_t* _ctx) { /* (i : timestamp, j : timestamp) -> timestamp */ 
  bool _match_2419 = kk_std_time_timestamp__lp__lt__eq__rp_(i, j, _ctx); /*bool*/;
  if (_match_2419) {
    return i;
  }
  return j;
}

kk_std_time_timestamp__timestamp kk_std_time_timestamp_round_to_prec(kk_std_time_timestamp__timestamp t, kk_integer_t prec, kk_context_t* _ctx); /* (t : timestamp, prec : int) -> timestamp */ 

static inline kk_std_num_ddouble__ddouble kk_std_time_timestamp_seconds_into_day(kk_std_time_timestamp__timestamp ts, kk_context_t* _ctx) { /* (ts : timestamp) -> std/num/ddouble/ddouble */ 
  kk_std_num_ddouble__ddouble _x2602;
  kk_std_core_types__tuple2_ _this_2291 = kk_std_time_timestamp_days_seconds(ts, _ctx); /*(int, std/num/ddouble/ddouble)*/;
  kk_box_t _box_x2363 = _this_2291.fst;
  kk_box_t _box_x2364 = _this_2291.snd;
  kk_std_num_ddouble__ddouble _x = kk_std_num_ddouble__ddouble_unbox(_box_x2364, NULL);
  kk_std_core_types__tuple2__drop(_this_2291, _ctx);
  kk_Unit;
  _x2602 = _x; /*std/num/ddouble/ddouble*/
  kk_std_num_ddouble__ddouble _x2605;
  kk_integer_t i_2292;
  int32_t _x2606;
  kk_std_num_ddouble__ddouble _pat00 = ts.since;
  int32_t _x0 = ts.leap32;
  _x2606 = _x0; /*int32*/
  i_2292 = kk_integer_from_int(_x2606,kk_context()); /*int*/
  _x2605 = kk_std_num_ddouble_ddouble_int_exp(i_2292, kk_integer_from_small(0), _ctx); /*std/num/ddouble/ddouble*/
  return kk_std_num_ddouble__lp__plus__rp_(_x2602, _x2605, _ctx);
}

extern kk_std_num_ddouble__ddouble kk_std_time_timestamp_solar_secs_per_day;

kk_std_time_timestamp__timestamp kk_std_time_timestamp_timestamp_days(kk_integer_t days0, kk_std_core_types__optional secs, kk_std_core_types__optional leap0, kk_context_t* _ctx); /* (days : int, secs : optional<timespan>, leap : optional<int>) -> timestamp */ 

extern kk_std_time_timestamp__timestamp kk_std_time_timestamp_timestamp0;

kk_string_t kk_std_time_timestamp_ts_show(kk_std_time_timestamp__timestamp ts, kk_std_core_types__optional max_prec, kk_std_core_types__optional secs_width, kk_std_core_types__optional unit, kk_context_t* _ctx); /* (ts : timestamp, max-prec : optional<int>, secs-width : optional<int>, unit : optional<string>) -> string */ 

kk_string_t kk_std_time_timestamp_ts_show_days(kk_std_time_timestamp__timestamp ts, kk_std_core_types__optional prec, kk_context_t* _ctx); /* (ts : timestamp, prec : optional<int>) -> string */ 

kk_std_num_ddouble__ddouble kk_std_time_timestamp_unsafe_timespan_withleap(kk_std_time_timestamp__timestamp ts, kk_context_t* _ctx); /* (ts : timestamp) -> timespan */ 

void kk_std_time_timestamp__init(kk_context_t* _ctx);


void kk_std_time_timestamp__done(kk_context_t* _ctx);

#endif // header
