// Koka generated module: "std/num/double", koka version: 2.2.1
#include "std_num_double.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/

static inline kk_std_core_types__tuple2_ kk_double_to_bits( double d, kk_context_t* ctx ) {
  uint64_t u;
  memcpy(&u,&d,sizeof(u));  // safe for C aliasing: see <https://gist.github.com/shafik/848ae25ee209f698763cffee272a58f8#how-do-we-type-pun-correctly>
  return kk_std_core_types__new_dash__lp__comma__rp_( kk_int32_box((int32_t)u, ctx), kk_int32_box((int32_t)(u >> 32), ctx), ctx );
}

static inline double kk_double_from_bits( int32_t lo, int32_t hi, kk_context_t* ctx ) {
  KK_UNUSED(ctx);
  double d;
  uint64_t u = (((uint64_t)((uint32_t)hi)) << 32) | (uint32_t)lo;  // note: careful about sign extension
  memcpy(&d,&u,sizeof(d));
  return d;
}

static inline double kk_prim_parse_double( kk_string_t str, kk_context_t* ctx) {
  const char* s = kk_string_cbuf_borrow(str,NULL);
  char* end;
  double d = strtod(s,&end);
  kk_string_drop(str,ctx);  
  return d;
}

 
// The maximum of a list of absolute values.


// lift anonymous function
struct kk_std_num_double_abs_max_fun4546__t_1 {
  struct kk_function_s _base;
};
static double kk_std_num_double_abs_max_fun4546_1(kk_function_t _fself, double m, double x, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_abs_max_fun4546_1(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_abs_max_fun4546_1, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double_abs_max_fun4546_1(kk_function_t _fself, double m, double x, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double x0_3818 = kk_double_abs(x); /*double*/;
  bool _match_4541 = (x0_3818 >= m); /*bool*/;
  if (_match_4541) {
    return x0_3818;
  }
  return m;
}


// lift anonymous function
struct kk_std_num_double_abs_max_fun4548__t_1 {
  struct kk_function_s _base;
  kk_function_t _b_4038_4033;
};
static kk_box_t kk_std_num_double_abs_max_fun4548_1(kk_function_t _fself, kk_box_t _b_4034, kk_box_t _b_4035, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_abs_max_fun4548_1(kk_function_t _b_4038_4033, kk_context_t* _ctx) {
  struct kk_std_num_double_abs_max_fun4548__t_1* _self = kk_function_alloc_as(struct kk_std_num_double_abs_max_fun4548__t_1, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_abs_max_fun4548_1, kk_context());
  _self->_b_4038_4033 = _b_4038_4033;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_abs_max_fun4548_1(kk_function_t _fself, kk_box_t _b_4034, kk_box_t _b_4035, kk_context_t* _ctx) {
  struct kk_std_num_double_abs_max_fun4548__t_1* _self = kk_function_as(struct kk_std_num_double_abs_max_fun4548__t_1*, _fself);
  kk_function_t _b_4038_4033 = _self->_b_4038_4033; /* (m : double, x : double) -> double */
  kk_drop_match(_self, {kk_function_dup(_b_4038_4033);}, {}, _ctx)
  double _x4549;
  double _x4550 = kk_double_unbox(_b_4034, _ctx); /*double*/
  double _x4551 = kk_double_unbox(_b_4035, _ctx); /*double*/
  _x4549 = kk_function_call(double, (kk_function_t, double, double, kk_context_t*), _b_4038_4033, (_b_4038_4033, _x4550, _x4551, _ctx)); /*double*/
  return kk_double_box(_x4549, _ctx);
}

double kk_std_num_double_abs_max_1(kk_std_core__list xs, kk_context_t* _ctx) { /* (xs : list<double>) -> double */ 
  kk_std_core__list _b_4036_4031 = xs; /*list<double>*/;
  double _b_4037_4032 = 0.0; /*double*/;
  kk_function_t _b_4038_4033 = kk_std_num_double_new_abs_max_fun4546_1(_ctx); /*(m : double, x : double) -> double*/;
  kk_box_t _x4547 = kk_std_core_foldl(_b_4036_4031, kk_double_box(_b_4037_4032, _ctx), kk_std_num_double_new_abs_max_fun4548_1(_b_4038_4033, _ctx), _ctx); /*12247*/
  return kk_double_unbox(_x4547, _ctx);
}
 
// The area hyperbolic cosine of `d`

double kk_std_num_double_acosh(double d, kk_context_t* _ctx) { /* (d : double) -> double */ 
  return acosh(d);
}
 
// The area hyperbolic sine of `d`

double kk_std_num_double_asinh(double d, kk_context_t* _ctx) { /* (d : double) -> double */ 
  return asinh(d);
}
 
// The area hyperbolic tangent of `d`

double kk_std_num_double_atanh(double d, kk_context_t* _ctx) { /* (d : double) -> double */ 
  return atanh(d);
}

kk_integer_t kk_std_num_double_dbl_max_prec;
 
// Low-level: return the `(lo,hi)` bits of a 64-bit double.

kk_std_core_types__tuple2_ kk_std_num_double_double_to_bits(double d, kk_context_t* _ctx) { /* (d : double) -> (int32, int32) */ 
  return kk_double_to_bits(d,kk_context());
}
 
// Low-level: create a `:double` from the given `lo` and `hi` 32-bits.

double kk_std_num_double_double_from_bits(int32_t lo, int32_t hi, kk_context_t* _ctx) { /* (lo : int32, hi : int32) -> double */ 
  return kk_double_from_bits(lo,hi,kk_context());
}

double kk_std_num_double_make_neginf(kk_context_t* _ctx) { /* () -> double */ 
  return -HUGE_VAL;
}

double kk_std_num_double_make_posinf(kk_context_t* _ctx) { /* () -> double */ 
  return HUGE_VAL;
}
 
// fused multiply-add. Computes `(x*y)+z` as if to infinite precision
// with only the final result rounded back to a `:double`.

double kk_std_num_double_fmadd(double x, double y, double z, kk_context_t* _ctx) { /* (x : double, y : double, z : double) -> double */ 
  return fma(x,y,z);
}
 
// Return the sum of a list of doubles.
// Uses [Kahan-Babu&scaron;kan-Neumaier summation](https://en.wikipedia.org/wiki/Kahan_summation_algorithm#Further_enhancements)
// to minimize rounding errors. This
// is more precise as Kahan summation and about as fast.
// `[1.0e3,1.0e97,1.0e3,-1.0e97].sum == 2000.0`
// A. Neumaier, _Rundungsfehleranalyse einiger Verfahren zur Summation endlicher Summen_.
// Math. Mechanik, 54:39--51, 1974.


// lift anonymous function
struct kk_std_num_double_sum_fun4555__t {
  struct kk_function_s _base;
  kk_ref_t loc;
  kk_ref_t loc0;
};
static kk_unit_t kk_std_num_double_sum_fun4555(kk_function_t _fself, kk_box_t _b_4061, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_sum_fun4555(kk_ref_t loc, kk_ref_t loc0, kk_context_t* _ctx) {
  struct kk_std_num_double_sum_fun4555__t* _self = kk_function_alloc_as(struct kk_std_num_double_sum_fun4555__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_sum_fun4555, kk_context());
  _self->loc = loc;
  _self->loc0 = loc0;
  return &_self->_base;
}

static kk_unit_t kk_std_num_double_sum_fun4555(kk_function_t _fself, kk_box_t _b_4061, kk_context_t* _ctx) {
  struct kk_std_num_double_sum_fun4555__t* _self = kk_function_as(struct kk_std_num_double_sum_fun4555__t*, _fself);
  kk_ref_t loc = _self->loc; /* local-var<global,double> */
  kk_ref_t loc0 = _self->loc0; /* local-var<global,double> */
  kk_drop_match(_self, {kk_ref_dup(loc);kk_ref_dup(loc0);}, {}, _ctx)
  double x_4076 = kk_double_unbox(_b_4061, _ctx); /*double*/;
  double t;
  double _x4556;
  kk_box_t _x4557;
  kk_ref_t _x4558 = kk_ref_dup(loc); /*local-var<global,double>*/
  _x4557 = (kk_ref_get(_x4558,kk_context())); /*256*/
  _x4556 = kk_double_unbox(_x4557, _ctx); /*double*/
  t = (_x4556 + x_4076); /*double*/
  double c;
  bool _match_4538;
  double _x4559;
  double _x4560;
  kk_box_t _x4561;
  kk_ref_t _x4562 = kk_ref_dup(loc); /*local-var<global,double>*/
  _x4561 = (kk_ref_get(_x4562,kk_context())); /*256*/
  _x4560 = kk_double_unbox(_x4561, _ctx); /*double*/
  _x4559 = kk_double_abs(_x4560); /*double*/
  double _x4563 = kk_double_abs(x_4076); /*double*/
  _match_4538 = (_x4559 >= _x4563); /*bool*/
  if (_match_4538) {
    double _x4564;
    double _x4565;
    kk_box_t _x4566;
    kk_ref_t _x4567 = kk_ref_dup(loc); /*local-var<global,double>*/
    _x4566 = (kk_ref_get(_x4567,kk_context())); /*256*/
    _x4565 = kk_double_unbox(_x4566, _ctx); /*double*/
    _x4564 = (_x4565 - t); /*double*/
    c = (_x4564 + x_4076); /*double*/
  }
  else {
    double _x4568 = (x_4076 - t); /*double*/
    double _x4569;
    kk_box_t _x4570;
    kk_ref_t _x4571 = kk_ref_dup(loc); /*local-var<global,double>*/
    _x4570 = (kk_ref_get(_x4571,kk_context())); /*256*/
    _x4569 = kk_double_unbox(_x4570, _ctx); /*double*/
    c = (_x4568 + _x4569); /*double*/
  }
  double _b_4055_4053;
  double _x4572;
  kk_box_t _x4573;
  kk_ref_t _x4574 = kk_ref_dup(loc0); /*local-var<global,double>*/
  _x4573 = (kk_ref_get(_x4574,kk_context())); /*256*/
  _x4572 = kk_double_unbox(_x4573, _ctx); /*double*/
  _b_4055_4053 = (_x4572 + c); /*double*/
  kk_unit_t __ = kk_Unit;
  kk_unit_t _borrowApp_4537 = kk_Unit;
  (kk_ref_set_borrow(loc0,(kk_double_box(_b_4055_4053, _ctx)),kk_context()));
  kk_ref_drop(loc0, _ctx);
  _borrowApp_4537;
  kk_unit_t _borrowApp_4536 = kk_Unit;
  (kk_ref_set_borrow(loc,(kk_double_box(t, _ctx)),kk_context()));
  kk_ref_drop(loc, _ctx);
  return _borrowApp_4536;
}

double kk_std_num_double_sum(kk_std_core__list xs, kk_context_t* _ctx) { /* (xs : list<double>) -> double */ 
  kk_ref_t loc = kk_ref_alloc((kk_double_box(0.0, _ctx)),kk_context()); /*local-var<global,double>*/;
  kk_ref_t loc0 = kk_ref_alloc((kk_double_box(0.0, _ctx)),kk_context()); /*local-var<global,double>*/;
  kk_unit_t __0 = kk_Unit;
  kk_function_t _x4554;
  kk_ref_dup(loc);
  kk_ref_dup(loc0);
  _x4554 = kk_std_num_double_new_sum_fun4555(loc, loc0, _ctx); /*(10978) -> 10979 ()*/
  kk_std_core_foreach(xs, _x4554, _ctx);
  double res0;
  double _x4575;
  kk_box_t _x4576;
  kk_ref_t _x4577 = kk_ref_dup(loc); /*local-var<global,double>*/
  _x4576 = (kk_ref_get(_x4577,kk_context())); /*256*/
  _x4575 = kk_double_unbox(_x4576, _ctx); /*double*/
  double _x4578;
  kk_box_t _x4579;
  kk_ref_t _x4580 = kk_ref_dup(loc0); /*local-var<global,double>*/
  _x4579 = (kk_ref_get(_x4580,kk_context())); /*256*/
  _x4578 = kk_double_unbox(_x4579, _ctx); /*double*/
  res0 = (_x4575 + _x4578); /*double*/
  double res;
  kk_box_t _x4581 = kk_std_core_hnd_prompt_local_var(loc0, kk_double_box(res0, _ctx), _ctx); /*9895*/
  res = kk_double_unbox(_x4581, _ctx); /*double*/
  kk_ref_t _b_4077_4074 = loc; /*local-var<global,double>*/;
  double _b_4078_4075 = res; /*double*/;
  kk_box_t _x4582 = kk_std_core_hnd_prompt_local_var(_b_4077_4074, kk_double_box(_b_4078_4075, _ctx), _ctx); /*9895*/
  return kk_double_unbox(_x4582, _ctx);
}
 
// Is this value equal to negative or positive infinity ?

bool kk_std_num_double_is_inf(double d, kk_context_t* _ctx) { /* (d : double) -> bool */ 
  return isinf(d);
}

double kk_std_num_double_make_nan(kk_context_t* _ctx) { /* () -> double */ 
  return (double)NAN;
}
 
// Return `nan` on failure

double kk_std_num_double_prim_parse_double(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> double */ 
  return kk_prim_parse_double(s,kk_context());
}
 
// decode a normalized double (i.e. not subnormal)

kk_std_core_types__tuple2_ kk_std_num_double_decode_normalized(double d, kk_std_core_types__optional e_adjust, kk_context_t* _ctx) { /* (d : double, e-adjust : optional<int>) -> (int, int) */ 
  kk_std_core_types__tuple2_ _match_4533 = kk_std_num_double_double_to_bits(d, _ctx); /*(int32, int32)*/;
  kk_box_t _box_x4079 = _match_4533.fst;
  kk_box_t _box_x4080 = _match_4533.snd;
  int32_t lo = kk_int32_unbox(_box_x4079, NULL);
  int32_t hi = kk_int32_unbox(_box_x4080, NULL);
  kk_std_core_types__tuple2__drop(_match_4533, _ctx);
  kk_Unit;
  kk_integer_t sign;
  bool _match_4534 = (hi)<0; /*bool*/;
  if (_match_4534) {
    sign = kk_integer_from_small(-1); /*int*/
  }
  else {
    sign = kk_integer_from_small(1); /*int*/
  }
  kk_integer_t exp;
  kk_integer_t _x4586;
  int32_t _x4587;
  int32_t _x4588 = ((int32_t)((uint32_t)hi >> (((int32_t)20)))); /*int32*/
  _x4587 = (_x4588 & (((int32_t)2047))); /*int32*/
  _x4586 = kk_integer_from_int(_x4587,kk_context()); /*int*/
  exp = kk_integer_sub(_x4586,(kk_integer_from_small(1043)),kk_context()); /*int*/
  kk_integer_t man;
  kk_integer_t _x4589;
  int32_t _x4590 = (hi & (((int32_t)1048575))); /*int32*/
  _x4589 = kk_integer_from_int(_x4590,kk_context()); /*int*/
  man = kk_integer_add(_x4589,(kk_integer_from_int(1048576, _ctx)),kk_context()); /*int*/
  kk_integer_t _b_4084_4082;
  kk_integer_t _x4591;
  kk_integer_t _x4592 = kk_integer_mul(man,(kk_integer_from_str("4294967296", _ctx)),kk_context()); /*int*/
  kk_integer_t _x4593 = kk_std_num_int32_uint(lo, _ctx); /*int*/
  _x4591 = kk_integer_add(_x4592,_x4593,kk_context()); /*int*/
  _b_4084_4082 = kk_integer_mul(sign,_x4591,kk_context()); /*int*/
  kk_integer_t _b_4085_4083;
  kk_integer_t _x4594 = kk_integer_sub(exp,(kk_integer_from_small(32)),kk_context()); /*int*/
  kk_integer_t _x4595;
  if (kk_std_core_types__is_Optional(e_adjust)) {
    kk_box_t _box_x4081 = e_adjust._cons.Optional.value;
    kk_integer_t _e_adjust_736 = kk_integer_unbox(_box_x4081);
    kk_integer_dup(_e_adjust_736);
    kk_std_core_types__optional_drop(e_adjust, _ctx);
    kk_Unit;
    _x4595 = _e_adjust_736; /*int*/
    goto _match4596;
  }
  _x4595 = kk_integer_from_small(0); /*int*/
  _match4596: ;
  _b_4085_4083 = kk_integer_add(_x4594,_x4595,kk_context()); /*int*/
  return kk_std_core_types__new_dash__lp__comma__rp_(kk_integer_box(_b_4084_4082), kk_integer_box(_b_4085_4083), _ctx);
}
 
// Decode a double `d` into a tuple `(m,e)` of a mantissa `m` and exponent `e`
// such that `m`&middot;2^`e`^ =  `d` exactly. The mantissa `m` is
// always either 0 or in the range [2^52^, 2^53^). See also `frexp`.

kk_std_core_types__tuple2_ kk_std_num_double_decode(double d, kk_context_t* _ctx) { /* (d : double) -> (int, int) */ 
  bool _match_4529 = (d == (0.0)); /*bool*/;
  if (_match_4529) {
    kk_integer_t _b_4091_4086 = kk_integer_from_small(0); /*int*/;
    kk_integer_t _b_4092_4087 = kk_integer_from_small(0); /*int*/;
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_integer_box(_b_4091_4086), kk_integer_box(_b_4092_4087), _ctx);
  }
  bool _match_4530 = (d != (0.0)); /*bool*/;
  if (_match_4530) {
    bool _match_4531;
    double _x4599 = kk_double_abs(d); /*double*/
    _match_4531 = (_x4599 < (2.2250738585072014e-308)); /*bool*/
    if (_match_4531) {
      double _x4600 = (d * (1.8014398509481984e16)); /*double*/
      kk_std_core_types__optional _x4601;
      kk_integer_t _b_4093_4088 = kk_integer_from_small(-54); /*int*/;
      _x4601 = kk_std_core_types__new_Optional(kk_integer_box(_b_4093_4088), _ctx); /*optional<106>*/
      return kk_std_num_double_decode_normalized(_x4600, _x4601, _ctx);
    }
    kk_std_core_types__optional _x4602;
    kk_integer_t _b_4094_4089 = kk_integer_from_small(0); /*int*/;
    _x4602 = kk_std_core_types__new_Optional(kk_integer_box(_b_4094_4089), _ctx); /*optional<106>*/
    return kk_std_num_double_decode_normalized(d, _x4602, _ctx);
  }
  kk_std_core_types__optional _x4603;
  kk_integer_t _b_4095_4090 = kk_integer_from_small(0); /*int*/;
  _x4603 = kk_std_core_types__new_Optional(kk_integer_box(_b_4095_4090), _ctx); /*optional<106>*/
  return kk_std_num_double_decode_normalized(d, _x4603, _ctx);
}

double kk_std_num_double_rad2deg;

double kk_std_num_double_deg2rad;
 
// Calculate 2&middot;^`e`^ for an integer `e`.
// Uses efficient bit conversion for exponents between  -1022 and 1023 and
// otherwise falls back to the regular `exp2` function converting `e` to a double.

double kk_std_num_double_exp2_1(kk_integer_t e, kk_context_t* _ctx) { /* (e : int) -> double */ 
  bool _match_4521;
  kk_integer_t _borrowedArg_4527 = kk_integer_from_small(-1022); /*int*/;
  bool _borrowApp_4528 = kk_integer_gte_borrow(e,_borrowedArg_4527,kk_context()); /*bool*/;
  kk_integer_drop(_borrowedArg_4527, _ctx);
  _match_4521 = _borrowApp_4528; /*bool*/
  if (_match_4521) {
    bool _match_4523;
    kk_integer_t _borrowedArg_4525 = kk_integer_from_small(1023); /*int*/;
    bool _borrowApp_4526 = kk_integer_lte_borrow(e,_borrowedArg_4525,kk_context()); /*bool*/;
    kk_integer_drop(_borrowedArg_4525, _ctx);
    _match_4523 = _borrowApp_4526; /*bool*/
    if (_match_4523) {
      int32_t _x4605;
      int32_t _x4606;
      kk_integer_t _x4607 = kk_integer_add((kk_integer_from_small(1023)),e,kk_context()); /*int*/
      _x4606 = kk_std_core_int32(_x4607, _ctx); /*int32*/
      _x4605 = (_x4606 << (((int32_t)20))); /*int32*/
      return kk_std_num_double_double_from_bits(((int32_t)0), _x4605, _ctx);
    }
    double p_3822;
    double _borrowApp_4524 = kk_integer_as_double_borrow(e); /*double*/;
    kk_integer_drop(e, _ctx);
    p_3822 = _borrowApp_4524; /*double*/
    return pow((2.0),p_3822);
  }
  double p0_3823;
  double _borrowApp_4522 = kk_integer_as_double_borrow(e); /*double*/;
  kk_integer_drop(e, _ctx);
  p0_3823 = _borrowApp_4522; /*double*/
  return pow((2.0),p0_3823);
}

double kk_std_num_double_neginf;

double kk_std_num_double_posinf;
 
// 'Load exponent': returns `x`&middot;2^`e`^ for a `is-finite` `x` and
// otherwise `x` itself. See also `encode` which loads an integer mantissa.

double kk_std_num_double_ldexp(double x, kk_integer_t e, kk_context_t* _ctx) { /* (x : double, e : int) -> double */ 
  bool b_3824 = isfinite(x); /*bool*/;
  if (b_3824) {
    bool _match_4501;
    kk_integer_t _borrowedArg_4519 = kk_integer_from_small(-1022); /*int*/;
    bool _borrowApp_4520 = kk_integer_gte_borrow(e,_borrowedArg_4519,kk_context()); /*bool*/;
    kk_integer_drop(_borrowedArg_4519, _ctx);
    _match_4501 = _borrowApp_4520; /*bool*/
    if (_match_4501) {
      bool _match_4509;
      kk_integer_t _borrowedArg_4517 = kk_integer_from_small(1023); /*int*/;
      bool _borrowApp_4518 = kk_integer_lte_borrow(e,_borrowedArg_4517,kk_context()); /*bool*/;
      kk_integer_drop(_borrowedArg_4517, _ctx);
      _match_4509 = _borrowApp_4518; /*bool*/
      if (_match_4509) {
        double _x4609 = kk_std_num_double_exp2_1(e, _ctx); /*double*/
        return (x * _x4609);
      }
      bool _match_4510;
      kk_integer_t _borrowedArg_4515 = kk_integer_from_small(2046); /*int*/;
      bool _borrowApp_4516 = kk_integer_lte_borrow(e,_borrowedArg_4515,kk_context()); /*bool*/;
      kk_integer_drop(_borrowedArg_4515, _ctx);
      _match_4510 = _borrowApp_4516; /*bool*/
      if (_match_4510) {
        double x1_3827 = (x * (8.98846567431158e307)); /*double*/;
        kk_integer_t e1_3828 = kk_integer_sub(e,(kk_integer_from_small(1023)),kk_context()); /*int*/;
        double _x4610 = kk_std_num_double_exp2_1(e1_3828, _ctx); /*double*/
        return (x1_3827 * _x4610);
      }
      bool _match_4511;
      kk_integer_t _borrowedArg_4513 = kk_integer_from_int(3069, _ctx); /*int*/;
      bool _borrowApp_4514 = kk_integer_lte_borrow(e,_borrowedArg_4513,kk_context()); /*bool*/;
      kk_integer_drop(_borrowedArg_4513, _ctx);
      _match_4511 = _borrowApp_4514; /*bool*/
      if (_match_4511) {
        double x2_3829;
        double _x4611 = (x * (8.98846567431158e307)); /*double*/
        x2_3829 = (_x4611 * (8.98846567431158e307)); /*double*/
        kk_integer_t e2_3830 = kk_integer_sub(e,(kk_integer_from_small(2046)),kk_context()); /*int*/;
        double _x4612 = kk_std_num_double_exp2_1(e2_3830, _ctx); /*double*/
        return (x2_3829 * _x4612);
      }
      kk_integer_drop(e, _ctx);
      bool _match_4512 = (x < (0.0)); /*bool*/;
      if (_match_4512) {
        return kk_std_num_double_make_neginf(_ctx);
      }
      return kk_std_num_double_make_posinf(_ctx);
    }
    bool _match_4502;
    kk_integer_t _borrowedArg_4507 = kk_integer_from_small(-2044); /*int*/;
    bool _borrowApp_4508 = kk_integer_gte_borrow(e,_borrowedArg_4507,kk_context()); /*bool*/;
    kk_integer_drop(_borrowedArg_4507, _ctx);
    _match_4502 = _borrowApp_4508; /*bool*/
    if (_match_4502) {
      double x3_3831 = (x * (2.2250738585072014e-308)); /*double*/;
      kk_integer_t e3_3832 = kk_integer_add(e,(kk_integer_from_small(1022)),kk_context()); /*int*/;
      double _x4613 = kk_std_num_double_exp2_1(e3_3832, _ctx); /*double*/
      return (x3_3831 * _x4613);
    }
    bool _match_4503;
    kk_integer_t _borrowedArg_4505 = kk_integer_from_int(-3066, _ctx); /*int*/;
    bool _borrowApp_4506 = kk_integer_gte_borrow(e,_borrowedArg_4505,kk_context()); /*bool*/;
    kk_integer_drop(_borrowedArg_4505, _ctx);
    _match_4503 = _borrowApp_4506; /*bool*/
    if (_match_4503) {
      double x4_3833;
      double _x4614 = (x * (2.2250738585072014e-308)); /*double*/
      x4_3833 = (_x4614 * (2.2250738585072014e-308)); /*double*/
      kk_integer_t e4_3834 = kk_integer_add(e,(kk_integer_from_small(2044)),kk_context()); /*int*/;
      double _x4615 = kk_std_num_double_exp2_1(e4_3834, _ctx); /*double*/
      return (x4_3833 * _x4615);
    }
    kk_integer_drop(e, _ctx);
    bool _match_4504 = (x < (0.0)); /*bool*/;
    if (_match_4504) {
      return -0.0;
    }
    return 0.0;
  }
  kk_integer_drop(e, _ctx);
  return x;
}
 
// 'Fraction/exponent': return the normalized fraction `f` and exponent `exp`
// for a number `x` such that `x == f`&middot;2^`exp`^.
// The absolute value of the fraction `f` is always in the range [0.5, 1.0), or
// one of `0.0`, `-0.0`, `neginf`, `posinf`, or `nan`.
// See also `decode` which  decodes to an integer mantissa.

kk_std_core_types__tuple2_ kk_std_num_double_frexp(double x, kk_context_t* _ctx) { /* (x : double) -> (double, int) */ 
  bool b_3836 = isfinite(x); /*bool*/;
  if (b_3836) {
    bool _match_4493 = (x == (0.0)); /*bool*/;
    if (_match_4493) {
      bool _match_4496;
      double _x4619 = ((1.0) / x); /*double*/
      _match_4496 = (isinf(_x4619) && signbit(_x4619)); /*bool*/
      if (_match_4496) {
        double _b_4108_4096 = x; /*double*/;
        kk_integer_t _b_4109_4097 = kk_integer_from_small(0); /*int*/;
        return kk_std_core_types__new_dash__lp__comma__rp_(kk_double_box(_b_4108_4096, _ctx), kk_integer_box(_b_4109_4097), _ctx);
      }
      kk_std_core_types__tuple2_ _match_4497 = kk_std_num_double_decode(x, _ctx); /*(int, int)*/;
      kk_box_t _box_x4098 = _match_4497.fst;
      kk_box_t _box_x4099 = _match_4497.snd;
      kk_integer_t m = kk_integer_unbox(_box_x4098);
      kk_integer_t e = kk_integer_unbox(_box_x4099);
      kk_integer_dup(e);
      kk_integer_dup(m);
      kk_std_core_types__tuple2__drop(_match_4497, _ctx);
      kk_Unit;
      double _b_4110_4100;
      double _x4622;
      double _borrowApp_4498 = kk_integer_as_double_borrow(m); /*double*/;
      kk_integer_drop(m, _ctx);
      _x4622 = _borrowApp_4498; /*double*/
      _b_4110_4100 = (_x4622 * (1.1102230246251565e-16)); /*double*/
      kk_integer_t _b_4111_4101 = kk_integer_add(e,(kk_integer_from_small(53)),kk_context()); /*int*/;
      return kk_std_core_types__new_dash__lp__comma__rp_(kk_double_box(_b_4110_4100, _ctx), kk_integer_box(_b_4111_4101), _ctx);
    }
    kk_std_core_types__tuple2_ _match_4494 = kk_std_num_double_decode(x, _ctx); /*(int, int)*/;
    kk_box_t _box_x4102 = _match_4494.fst;
    kk_box_t _box_x4103 = _match_4494.snd;
    kk_integer_t m0 = kk_integer_unbox(_box_x4102);
    kk_integer_t e0 = kk_integer_unbox(_box_x4103);
    kk_integer_dup(e0);
    kk_integer_dup(m0);
    kk_std_core_types__tuple2__drop(_match_4494, _ctx);
    kk_Unit;
    double _b_4112_4104;
    double _x4625;
    double _borrowApp_4495 = kk_integer_as_double_borrow(m0); /*double*/;
    kk_integer_drop(m0, _ctx);
    _x4625 = _borrowApp_4495; /*double*/
    _b_4112_4104 = (_x4625 * (1.1102230246251565e-16)); /*double*/
    kk_integer_t _b_4113_4105 = kk_integer_add(e0,(kk_integer_from_small(53)),kk_context()); /*int*/;
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_double_box(_b_4112_4104, _ctx), kk_integer_box(_b_4113_4105), _ctx);
  }
  double _b_4114_4106 = x; /*double*/;
  kk_integer_t _b_4115_4107 = kk_integer_from_small(0); /*int*/;
  return kk_std_core_types__new_dash__lp__comma__rp_(kk_double_box(_b_4114_4106, _ctx), kk_integer_box(_b_4115_4107), _ctx);
}
 
// The hypotenuse of `x` and `y`: `sqrt(x*x + y*y)`.
// Prevents overflow for large numbers.

double kk_std_num_double_hypot(double x, double y, kk_context_t* _ctx) { /* (x : double, y : double) -> double */ 
  double xx = kk_double_abs(x); /*double*/;
  double yy = kk_double_abs(y); /*double*/;
  double lo;
  bool _match_4492 = (xx <= yy); /*bool*/;
  if (_match_4492) {
    lo = xx; /*double*/
  }
  else {
    lo = yy; /*double*/
  }
  double hi;
  bool _match_4491 = (xx >= yy); /*bool*/;
  if (_match_4491) {
    hi = xx; /*double*/
  }
  else {
    hi = yy; /*double*/
  }
  bool _match_4490 = (hi == (0.0)); /*bool*/;
  if (_match_4490) {
    return 0.0;
  }
  double z = (lo / hi); /*double*/;
  double _x4626;
  double _x4627;
  double _x4628 = (z * z); /*double*/
  _x4627 = ((1.0) + _x4628); /*double*/
  _x4626 = sqrt(_x4627); /*double*/
  return (hi * _x4626);
}
 
// The square root of the sum of the squares of three doubles.
// Prevents overflow for large numbers.

double kk_std_num_double_hypot_1(double x, double y, double z, kk_context_t* _ctx) { /* (x : double, y : double, z : double) -> double */ 
  double xx = kk_double_abs(x); /*double*/;
  double yy = kk_double_abs(y); /*double*/;
  double zz = kk_double_abs(z); /*double*/;
  double x0_3842;
  bool _match_4489 = (xx >= yy); /*bool*/;
  if (_match_4489) {
    x0_3842 = xx; /*double*/
  }
  else {
    x0_3842 = yy; /*double*/
  }
  double hi;
  bool _match_4488 = (x0_3842 >= zz); /*bool*/;
  if (_match_4488) {
    hi = x0_3842; /*double*/
  }
  else {
    hi = zz; /*double*/
  }
  bool _match_4487 = (hi == (0.0)); /*bool*/;
  if (_match_4487) {
    return 0.0;
  }
  double _x4629;
  double _x4630;
  double _x4631;
  double _x4632;
  double x2_3846 = (xx / hi); /*double*/;
  _x4632 = (x2_3846 * x2_3846); /*double*/
  double _x4633;
  double x3_3847 = (yy / hi); /*double*/;
  _x4633 = (x3_3847 * x3_3847); /*double*/
  _x4631 = (_x4632 + _x4633); /*double*/
  double _x4634;
  double x4_3848 = (zz / hi); /*double*/;
  _x4634 = (x4_3848 * x4_3848); /*double*/
  _x4630 = (_x4631 + _x4634); /*double*/
  _x4629 = sqrt(_x4630); /*double*/
  return (hi * _x4629);
}
 
// The square root of the sum of squares of a list of doubles.
// Prevents overflow for large numbers and uses Kahan-Babu&scaron;kan-Neumaier summation
// for precision.


// lift anonymous function
struct kk_std_num_double_hypot_fun4637__t_2 {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_hypot_fun4637_2(kk_function_t _fself, kk_box_t _b_4119, kk_box_t _b_4120, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_hypot_fun4637_2(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_hypot_fun4637_2, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double_hypot_fun4637_2(kk_function_t _fself, kk_box_t _b_4119, kk_box_t _b_4120, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x4638;
  double m_4127 = kk_double_unbox(_b_4119, _ctx); /*double*/;
  double x_4128 = kk_double_unbox(_b_4120, _ctx); /*double*/;
  double x0_3818 = kk_double_abs(x_4128); /*double*/;
  bool _match_4486 = (x0_3818 >= m_4127); /*bool*/;
  if (_match_4486) {
    _x4638 = x0_3818; /*double*/
  }
  else {
    _x4638 = m_4127; /*double*/
  }
  return kk_double_box(_x4638, _ctx);
}


// lift anonymous function
struct kk_std_num_double_hypot_fun4642__t_2 {
  struct kk_function_s _base;
  double hi;
};
static double kk_std_num_double_hypot_fun4642_2(kk_function_t _fself, double x0, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_hypot_fun4642_2(double hi, kk_context_t* _ctx) {
  struct kk_std_num_double_hypot_fun4642__t_2* _self = kk_function_alloc_as(struct kk_std_num_double_hypot_fun4642__t_2, 1, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_hypot_fun4642_2, kk_context());
  _self->hi = hi;
  return &_self->_base;
}

static double kk_std_num_double_hypot_fun4642_2(kk_function_t _fself, double x0, kk_context_t* _ctx) {
  struct kk_std_num_double_hypot_fun4642__t_2* _self = kk_function_as(struct kk_std_num_double_hypot_fun4642__t_2*, _fself);
  double hi = _self->hi; /* double */
  kk_drop_match(_self, {;}, {}, _ctx)
  double x0_3849 = (x0 / hi); /*double*/;
  return (x0_3849 * x0_3849);
}


// lift anonymous function
struct kk_std_num_double_hypot_fun4643__t_2 {
  struct kk_function_s _base;
  kk_function_t _b_4130_4125;
};
static kk_box_t kk_std_num_double_hypot_fun4643_2(kk_function_t _fself, kk_box_t _b_4126, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_hypot_fun4643_2(kk_function_t _b_4130_4125, kk_context_t* _ctx) {
  struct kk_std_num_double_hypot_fun4643__t_2* _self = kk_function_alloc_as(struct kk_std_num_double_hypot_fun4643__t_2, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_hypot_fun4643_2, kk_context());
  _self->_b_4130_4125 = _b_4130_4125;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_hypot_fun4643_2(kk_function_t _fself, kk_box_t _b_4126, kk_context_t* _ctx) {
  struct kk_std_num_double_hypot_fun4643__t_2* _self = kk_function_as(struct kk_std_num_double_hypot_fun4643__t_2*, _fself);
  kk_function_t _b_4130_4125 = _self->_b_4130_4125; /* (x0 : double) -> double */
  kk_drop_match(_self, {kk_function_dup(_b_4130_4125);}, {}, _ctx)
  double _x4644;
  double _x4645 = kk_double_unbox(_b_4126, _ctx); /*double*/
  _x4644 = kk_function_call(double, (kk_function_t, double, kk_context_t*), _b_4130_4125, (_b_4130_4125, _x4645, _ctx)); /*double*/
  return kk_double_box(_x4644, _ctx);
}

double kk_std_num_double_hypot_2(kk_std_core__list xs, kk_context_t* _ctx) { /* (xs : list<double>) -> double */ 
  double hi;
  kk_box_t _x4635;
  kk_std_core__list _x4636 = kk_std_core__list_dup(xs); /*list<double>*/
  _x4635 = kk_std_core_foldl(_x4636, kk_double_box(0.0, _ctx), kk_std_num_double_new_hypot_fun4637_2(_ctx), _ctx); /*12247*/
  hi = kk_double_unbox(_x4635, _ctx); /*double*/
  bool _match_4485 = (hi == (0.0)); /*bool*/;
  if (_match_4485) {
    kk_std_core__list_drop(xs, _ctx);
    return 0.0;
  }
  double _x4639;
  double _x4640;
  kk_std_core__list _x4641;
  kk_std_core__list _b_4129_4124 = xs; /*list<double>*/;
  kk_function_t _b_4130_4125 = kk_std_num_double_new_hypot_fun4642_2(hi, _ctx); /*(x0 : double) -> double*/;
  _x4641 = kk_std_core_map_5(_b_4129_4124, kk_std_num_double_new_hypot_fun4643_2(_b_4130_4125, _ctx), _ctx); /*list<6139>*/
  _x4640 = kk_std_num_double_sum(_x4641, _ctx); /*double*/
  _x4639 = sqrt(_x4640); /*double*/
  return (hi * _x4639);
}
 
// Returns `log(exp(x) + exp(y))`.
// Avoids overlow/underflow errors.

double kk_std_num_double_logaddexp(double x, double y, kk_context_t* _ctx) { /* (x : double, y : double) -> double */ 
  bool _match_4483 = (x == y); /*bool*/;
  if (_match_4483) {
    return (x + (0.6931471805599453));
  }
  double z = (x - y); /*double*/;
  bool _match_4484 = (z > (0.0)); /*bool*/;
  if (_match_4484) {
    double _x4649;
    double _x4650;
    double _x4651 = (-z); /*double*/
    _x4650 = exp(_x4651); /*double*/
    _x4649 = log1p(_x4650); /*double*/
    return (x + _x4649);
  }
  double _x4652;
  double _x4653 = exp(z); /*double*/
  _x4652 = log1p(_x4653); /*double*/
  return (y + _x4652);
}
 
// Returns `log2( exp2(x) + exp2(y) )`.
// Avoids overlow/underflow errors.

double kk_std_num_double_logaddexp2(double x, double y, kk_context_t* _ctx) { /* (x : double, y : double) -> double */ 
  bool _match_4481 = (x == y); /*bool*/;
  if (_match_4481) {
    return (x + (1.0));
  }
  double z = (x - y); /*double*/;
  bool _match_4482 = (z > (0.0)); /*bool*/;
  if (_match_4482) {
    double _x4654;
    double p_3851 = (-z); /*double*/;
    double x0_3850 = pow((2.0),p_3851); /*double*/;
    double _x4655 = log1p(x0_3850); /*double*/
    _x4654 = ((1.4426950408889634) * _x4655); /*double*/
    return (x + _x4654);
  }
  double _x4656;
  double x1_3852 = pow((2.0),z); /*double*/;
  double _x4657 = log1p(x1_3852); /*double*/
  _x4656 = ((1.4426950408889634) * _x4657); /*double*/
  return (y + _x4656);
}

double kk_std_num_double_nan;
 
// Return if two doubles are nearly equal with respect to some `epsilon` (=`8*dbl-epsilon`).
// The epsilon is the nearest difference for numbers around 1.0. The routine automatically
// scales the epsilon for larger and smaller numbers, and for subnormal numbers.

bool kk_std_num_double_nearly_eq(double x, double y, kk_std_core_types__optional epsilon, kk_context_t* _ctx) { /* (x : double, y : double, epsilon : optional<double>) -> bool */ 
  double _epsilon_2587;
  if (kk_std_core_types__is_Optional(epsilon)) {
    kk_box_t _box_x4131 = epsilon._cons.Optional.value;
    double _epsilon_2588 = kk_double_unbox(_box_x4131, NULL);
    kk_std_core_types__optional_drop(epsilon, _ctx);
    kk_Unit;
    _epsilon_2587 = _epsilon_2588; /*double*/
    goto _match4658;
  }
  _epsilon_2587 = ((8.0) * (2.220446049250313e-16)); /*double*/
  _match4658: ;
  bool _match_4476 = (x == y); /*bool*/;
  if (_match_4476) {
    return true;
  }
  double diff;
  double _x4660 = (x - y); /*double*/
  diff = kk_double_abs(_x4660); /*double*/
  bool _match_4477 = (x == (0.0)); /*bool*/;
  if (_match_4477) {
    double _x4661 = ((2.0) * diff); /*double*/
    double _x4662 = (_epsilon_2587 * (2.2250738585072014e-308)); /*double*/
    return (_x4661 < _x4662);
  }
  bool _match_4478 = (y == (0.0)); /*bool*/;
  if (_match_4478) {
    double _x4663 = ((2.0) * diff); /*double*/
    double _x4664 = (_epsilon_2587 * (2.2250738585072014e-308)); /*double*/
    return (_x4663 < _x4664);
  }
  bool _match_4479 = (diff < (2.2250738585072014e-308)); /*bool*/;
  if (_match_4479) {
    double _x4665 = ((2.0) * diff); /*double*/
    double _x4666 = (_epsilon_2587 * (2.2250738585072014e-308)); /*double*/
    return (_x4665 < _x4666);
  }
  double sum0;
  double _x4667 = kk_double_abs(x); /*double*/
  double _x4668 = kk_double_abs(y); /*double*/
  sum0 = (_x4667 + _x4668); /*double*/
  double _x4669;
  double _x4670 = ((2.0) * diff); /*double*/
  double _x4671;
  bool _match_4480 = (sum0 > (1.7976931348623157e308)); /*bool*/;
  if (_match_4480) {
    _x4671 = 1.7976931348623157e308; /*double*/
  }
  else {
    _x4671 = sum0; /*double*/
  }
  _x4669 = (_x4670 / _x4671); /*double*/
  return (_x4669 < _epsilon_2587);
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_double__mlift3905_pdecdouble_fun4673__t {
  struct kk_function_s _base;
};
static double kk_std_num_double__mlift3905_pdecdouble_fun4673(kk_function_t _fself, kk_string_t _x14672, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3905_pdecdouble_fun4673(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3905_pdecdouble_fun4673, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double__mlift3905_pdecdouble_fun4673(kk_function_t _fself, kk_string_t _x14672, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_num_double_prim_parse_double(_x14672, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3905_pdecdouble_fun4675__t {
  struct kk_function_s _base;
  kk_function_t _b_4135_4132;
};
static kk_box_t kk_std_num_double__mlift3905_pdecdouble_fun4675(kk_function_t _fself, kk_box_t _b_4134, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3905_pdecdouble_fun4675(kk_function_t _b_4135_4132, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3905_pdecdouble_fun4675__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3905_pdecdouble_fun4675__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3905_pdecdouble_fun4675, kk_context());
  _self->_b_4135_4132 = _b_4135_4132;
  return &_self->_base;
}

static kk_box_t kk_std_num_double__mlift3905_pdecdouble_fun4675(kk_function_t _fself, kk_box_t _b_4134, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3905_pdecdouble_fun4675__t* _self = kk_function_as(struct kk_std_num_double__mlift3905_pdecdouble_fun4675__t*, _fself);
  kk_function_t _b_4135_4132 = _self->_b_4135_4132; /* (s : string) -> double */
  kk_drop_match(_self, {kk_function_dup(_b_4135_4132);}, {}, _ctx)
  double _x4676;
  kk_string_t _x4677 = kk_string_unbox(_b_4134); /*string*/
  _x4676 = kk_function_call(double, (kk_function_t, kk_string_t, kk_context_t*), _b_4135_4132, (_b_4135_4132, _x4677, _ctx)); /*double*/
  return kk_double_box(_x4676, _ctx);
}

double kk_std_num_double__mlift3905_pdecdouble(kk_std_core__sslice cur, kk_integer_t exp, kk_context_t* _ctx) { /* (cur : sslice, exp : int) -> std/text/parse/parse double */ 
  kk_integer_drop(exp, _ctx);
  kk_string_t _x1 = kk_std_core_string_3(cur, _ctx); /*string*/;
  kk_function_t _b_4135_4132 = kk_std_num_double__new_mlift3905_pdecdouble_fun4673(_ctx); /*(s : string) -> double*/;
  kk_string_t _b_4136_4133 = _x1; /*string*/;
  kk_box_t _x4674 = kk_std_core_hnd__open_none1(kk_std_num_double__new_mlift3905_pdecdouble_fun4675(_b_4135_4132, _ctx), kk_string_box(_b_4136_4133), _ctx); /*3289*/
  return kk_double_unbox(_x4674, _ctx);
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_double__mlift3907_pdecdouble_fun4681__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3907_pdecdouble_fun4681(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3907_pdecdouble_fun4681(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3907_pdecdouble_fun4681, _ctx)
  return kk_function_dup(_fself);
}



// lift anonymous function
struct kk_std_num_double__mlift3907_pdecdouble_fun4686__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3907_pdecdouble_fun4686(kk_function_t _fself, kk_box_t _b_4138, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3907_pdecdouble_fun4686(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3907_pdecdouble_fun4686, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double__mlift3907_pdecdouble_fun4686(kk_function_t _fself, kk_box_t _b_4138, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_integer_t _x4687;
  kk_char_t _x4688 = kk_char_unbox(_b_4138, _ctx); /*char*/
  _x4687 = kk_std_num_double__mlift3904_pdecdouble(_x4688, _ctx); /*int*/
  return kk_integer_box(_x4687);
}
static kk_box_t kk_std_num_double__mlift3907_pdecdouble_fun4681(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_integer_t _x4682;
  kk_char_t x0_3930;
  kk_string_t _x4683;
  kk_define_string_literal(, _s4684, 2, "eE")
  _x4683 = kk_string_dup(_s4684); /*string*/
  x0_3930 = kk_std_text_parse_one_of(_x4683, _ctx); /*char*/
  if (kk_yielding(kk_context())) {
    kk_box_t _x4685 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3907_pdecdouble_fun4686(_ctx), _ctx); /*3858*/
    _x4682 = kk_integer_unbox(_x4685); /*int*/
  }
  else {
    _x4682 = kk_std_num_double__mlift3904_pdecdouble(x0_3930, _ctx); /*int*/
  }
  return kk_integer_box(_x4682);
}


// lift anonymous function
struct kk_std_num_double__mlift3907_pdecdouble_fun4689__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3907_pdecdouble_fun4689(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3907_pdecdouble_fun4689(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3907_pdecdouble_fun4689, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double__mlift3907_pdecdouble_fun4689(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_integer_box(kk_integer_from_small(0));
}


// lift anonymous function
struct kk_std_num_double__mlift3907_pdecdouble_fun4690__t {
  struct kk_function_s _base;
  kk_std_core__sslice cur;
};
static double kk_std_num_double__mlift3907_pdecdouble_fun4690(kk_function_t _fself, kk_integer_t exp, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3907_pdecdouble_fun4690(kk_std_core__sslice cur, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3907_pdecdouble_fun4690__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3907_pdecdouble_fun4690__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3907_pdecdouble_fun4690, kk_context());
  _self->cur = cur;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_num_double__mlift3907_pdecdouble_fun4692__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3907_pdecdouble_fun4692(kk_function_t _fself, kk_box_t _b_4146, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3907_pdecdouble_fun4692(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3907_pdecdouble_fun4692, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double__mlift3907_pdecdouble_fun4692(kk_function_t _fself, kk_box_t _b_4146, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x4693;
  kk_string_t _x4694 = kk_string_unbox(_b_4146); /*string*/
  _x4693 = kk_std_num_double_prim_parse_double(_x4694, _ctx); /*double*/
  return kk_double_box(_x4693, _ctx);
}
static double kk_std_num_double__mlift3907_pdecdouble_fun4690(kk_function_t _fself, kk_integer_t exp, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3907_pdecdouble_fun4690__t* _self = kk_function_as(struct kk_std_num_double__mlift3907_pdecdouble_fun4690__t*, _fself);
  kk_std_core__sslice cur = _self->cur; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(cur);}, {}, _ctx)
  kk_integer_drop(exp, _ctx);
  kk_string_t _x1 = kk_std_core_string_3(cur, _ctx); /*string*/;
  kk_box_t _x4691 = kk_std_core_hnd__open_none1(kk_std_num_double__new_mlift3907_pdecdouble_fun4692(_ctx), kk_string_box(_x1), _ctx); /*3289*/
  return kk_double_unbox(_x4691, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3907_pdecdouble_fun4696__t {
  struct kk_function_s _base;
  kk_function_t _b_4151_4149;
};
static kk_box_t kk_std_num_double__mlift3907_pdecdouble_fun4696(kk_function_t _fself, kk_box_t _b_4150, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3907_pdecdouble_fun4696(kk_function_t _b_4151_4149, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3907_pdecdouble_fun4696__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3907_pdecdouble_fun4696__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3907_pdecdouble_fun4696, kk_context());
  _self->_b_4151_4149 = _b_4151_4149;
  return &_self->_base;
}

static kk_box_t kk_std_num_double__mlift3907_pdecdouble_fun4696(kk_function_t _fself, kk_box_t _b_4150, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3907_pdecdouble_fun4696__t* _self = kk_function_as(struct kk_std_num_double__mlift3907_pdecdouble_fun4696__t*, _fself);
  kk_function_t _b_4151_4149 = _self->_b_4151_4149; /* (int) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4151_4149);}, {}, _ctx)
  double _x4697;
  kk_integer_t _x4698 = kk_integer_unbox(_b_4150); /*int*/
  _x4697 = kk_function_call(double, (kk_function_t, kk_integer_t, kk_context_t*), _b_4151_4149, (_b_4151_4149, _x4698, _ctx)); /*double*/
  return kk_double_box(_x4697, _ctx);
}

double kk_std_num_double__mlift3907_pdecdouble(kk_std_core__sslice cur, kk_string_t _y_3878, kk_context_t* _ctx) { /* (cur : sslice, string) -> std/text/parse/parse double */ 
  kk_string_t frac;
  kk_string_t _x4678;
  kk_define_string_literal(, _s4679, 1, "0")
  _x4678 = kk_string_dup(_s4679); /*string*/
  frac = kk_std_core_trim_right_1(_y_3878, _x4678, _ctx); /*string*/
  kk_string_drop(frac, _ctx);
  kk_integer_t x_3928;
  kk_box_t _x4680 = kk_std_text_parse__lp__bar__bar__rp_(kk_std_num_double__new_mlift3907_pdecdouble_fun4681(_ctx), kk_std_num_double__new_mlift3907_pdecdouble_fun4689(_ctx), _ctx); /*946*/
  x_3928 = kk_integer_unbox(_x4680); /*int*/
  kk_function_t next_3929 = kk_std_num_double__new_mlift3907_pdecdouble_fun4690(cur, _ctx); /*(int) -> std/text/parse/parse double*/;
  if (kk_yielding(kk_context())) {
    kk_integer_drop(x_3928, _ctx);
    kk_function_t _b_4151_4149 = next_3929; /*(int) -> std/text/parse/parse double*/;
    kk_box_t _x4695 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3907_pdecdouble_fun4696(_b_4151_4149, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x4695, _ctx);
  }
  return kk_function_call(double, (kk_function_t, kk_integer_t, kk_context_t*), next_3929, (next_3929, x_3928, _ctx));
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_double__mlift3908_pdecdouble_fun4700__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3908_pdecdouble_fun4700(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3908_pdecdouble_fun4700(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3908_pdecdouble_fun4700, _ctx)
  return kk_function_dup(_fself);
}



// lift anonymous function
struct kk_std_num_double__mlift3908_pdecdouble_fun4703__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3908_pdecdouble_fun4703(kk_function_t _fself, kk_box_t _b_4153, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3908_pdecdouble_fun4703(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3908_pdecdouble_fun4703, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double__mlift3908_pdecdouble_fun4703(kk_function_t _fself, kk_box_t _b_4153, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x4704;
  kk_char_t _x4705 = kk_char_unbox(_b_4153, _ctx); /*char*/
  _x4704 = kk_std_num_double__mlift3906_pdecdouble(_x4705, _ctx); /*string*/
  return kk_string_box(_x4704);
}
static kk_box_t kk_std_num_double__mlift3908_pdecdouble_fun4700(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x4701;
  kk_char_t x0_3936 = kk_std_text_parse_char('.', _ctx); /*char*/;
  if (kk_yielding(kk_context())) {
    kk_box_t _x4702 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3908_pdecdouble_fun4703(_ctx), _ctx); /*3858*/
    _x4701 = kk_string_unbox(_x4702); /*string*/
  }
  else {
    _x4701 = kk_std_num_double__mlift3906_pdecdouble(x0_3936, _ctx); /*string*/
  }
  return kk_string_box(_x4701);
}


// lift anonymous function
struct kk_std_num_double__mlift3908_pdecdouble_fun4706__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3908_pdecdouble_fun4706(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3908_pdecdouble_fun4706(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3908_pdecdouble_fun4706, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double__mlift3908_pdecdouble_fun4706(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x4707 = kk_string_empty(); /*string*/
  return kk_string_box(_x4707);
}


// lift anonymous function
struct kk_std_num_double__mlift3908_pdecdouble_fun4709__t {
  struct kk_function_s _base;
  kk_std_core__sslice cur;
};
static double kk_std_num_double__mlift3908_pdecdouble_fun4709(kk_function_t _fself, kk_string_t _y_3878, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3908_pdecdouble_fun4709(kk_std_core__sslice cur, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3908_pdecdouble_fun4709__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3908_pdecdouble_fun4709__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3908_pdecdouble_fun4709, kk_context());
  _self->cur = cur;
  return &_self->_base;
}

static double kk_std_num_double__mlift3908_pdecdouble_fun4709(kk_function_t _fself, kk_string_t _y_3878, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3908_pdecdouble_fun4709__t* _self = kk_function_as(struct kk_std_num_double__mlift3908_pdecdouble_fun4709__t*, _fself);
  kk_std_core__sslice cur = _self->cur; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(cur);}, {}, _ctx)
  return kk_std_num_double__mlift3907_pdecdouble(cur, _y_3878, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3908_pdecdouble_fun4711__t {
  struct kk_function_s _base;
  kk_function_t _b_4161_4159;
};
static kk_box_t kk_std_num_double__mlift3908_pdecdouble_fun4711(kk_function_t _fself, kk_box_t _b_4160, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3908_pdecdouble_fun4711(kk_function_t _b_4161_4159, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3908_pdecdouble_fun4711__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3908_pdecdouble_fun4711__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3908_pdecdouble_fun4711, kk_context());
  _self->_b_4161_4159 = _b_4161_4159;
  return &_self->_base;
}

static kk_box_t kk_std_num_double__mlift3908_pdecdouble_fun4711(kk_function_t _fself, kk_box_t _b_4160, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3908_pdecdouble_fun4711__t* _self = kk_function_as(struct kk_std_num_double__mlift3908_pdecdouble_fun4711__t*, _fself);
  kk_function_t _b_4161_4159 = _self->_b_4161_4159; /* (string) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4161_4159);}, {}, _ctx)
  double _x4712;
  kk_string_t _x4713 = kk_string_unbox(_b_4160); /*string*/
  _x4712 = kk_function_call(double, (kk_function_t, kk_string_t, kk_context_t*), _b_4161_4159, (_b_4161_4159, _x4713, _ctx)); /*double*/
  return kk_double_box(_x4712, _ctx);
}

double kk_std_num_double__mlift3908_pdecdouble(kk_std_core__sslice cur, kk_string_t man, kk_context_t* _ctx) { /* (cur : sslice, man : string) -> std/text/parse/parse double */ 
  kk_string_drop(man, _ctx);
  kk_string_t x_3934;
  kk_box_t _x4699 = kk_std_text_parse__lp__bar__bar__rp_(kk_std_num_double__new_mlift3908_pdecdouble_fun4700(_ctx), kk_std_num_double__new_mlift3908_pdecdouble_fun4706(_ctx), _ctx); /*946*/
  x_3934 = kk_string_unbox(_x4699); /*string*/
  if (kk_yielding(kk_context())) {
    kk_string_drop(x_3934, _ctx);
    kk_function_t _b_4161_4159 = kk_std_num_double__new_mlift3908_pdecdouble_fun4709(cur, _ctx); /*(string) -> std/text/parse/parse double*/;
    kk_box_t _x4710 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3908_pdecdouble_fun4711(_b_4161_4159, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x4710, _ctx);
  }
  return kk_std_num_double__mlift3907_pdecdouble(cur, x_3934, _ctx);
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_double__mlift3909_pdecdouble_fun4714__t {
  struct kk_function_s _base;
  kk_std_core__sslice cur;
};
static double kk_std_num_double__mlift3909_pdecdouble_fun4714(kk_function_t _fself, kk_string_t man, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3909_pdecdouble_fun4714(kk_std_core__sslice cur, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3909_pdecdouble_fun4714__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3909_pdecdouble_fun4714__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3909_pdecdouble_fun4714, kk_context());
  _self->cur = cur;
  return &_self->_base;
}

static double kk_std_num_double__mlift3909_pdecdouble_fun4714(kk_function_t _fself, kk_string_t man, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3909_pdecdouble_fun4714__t* _self = kk_function_as(struct kk_std_num_double__mlift3909_pdecdouble_fun4714__t*, _fself);
  kk_std_core__sslice cur = _self->cur; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(cur);}, {}, _ctx)
  return kk_std_num_double__mlift3908_pdecdouble(cur, man, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3909_pdecdouble_fun4716__t {
  struct kk_function_s _base;
  kk_function_t _b_4164_4162;
};
static kk_box_t kk_std_num_double__mlift3909_pdecdouble_fun4716(kk_function_t _fself, kk_box_t _b_4163, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3909_pdecdouble_fun4716(kk_function_t _b_4164_4162, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3909_pdecdouble_fun4716__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3909_pdecdouble_fun4716__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3909_pdecdouble_fun4716, kk_context());
  _self->_b_4164_4162 = _b_4164_4162;
  return &_self->_base;
}

static kk_box_t kk_std_num_double__mlift3909_pdecdouble_fun4716(kk_function_t _fself, kk_box_t _b_4163, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3909_pdecdouble_fun4716__t* _self = kk_function_as(struct kk_std_num_double__mlift3909_pdecdouble_fun4716__t*, _fself);
  kk_function_t _b_4164_4162 = _self->_b_4164_4162; /* (man : string) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4164_4162);}, {}, _ctx)
  double _x4717;
  kk_string_t _x4718 = kk_string_unbox(_b_4163); /*string*/
  _x4717 = kk_function_call(double, (kk_function_t, kk_string_t, kk_context_t*), _b_4164_4162, (_b_4164_4162, _x4718, _ctx)); /*double*/
  return kk_double_box(_x4717, _ctx);
}

double kk_std_num_double__mlift3909_pdecdouble(kk_std_core__sslice cur, kk_context_t* _ctx) { /* (cur : sslice) -> std/text/parse/parse double */ 
  kk_string_t x_3938 = kk_std_text_parse_digits(_ctx); /*string*/;
  if (kk_yielding(kk_context())) {
    kk_string_drop(x_3938, _ctx);
    kk_function_t _b_4164_4162 = kk_std_num_double__new_mlift3909_pdecdouble_fun4714(cur, _ctx); /*(man : string) -> std/text/parse/parse double*/;
    kk_box_t _x4715 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3909_pdecdouble_fun4716(_b_4164_4162, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x4715, _ctx);
  }
  return kk_std_num_double__mlift3908_pdecdouble(cur, x_3938, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun4724__t {
  struct kk_function_s _base;
};
static double kk_std_num_double_pdecdouble_fun4724(kk_function_t _fself, kk_std_core__sslice _x14723, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun4724(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdecdouble_fun4724, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double_pdecdouble_fun4724(kk_function_t _fself, kk_std_core__sslice _x14723, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_num_double__mlift3909_pdecdouble(_x14723, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun4726__t {
  struct kk_function_s _base;
  kk_function_t _b_4199_4171;
};
static kk_box_t kk_std_num_double_pdecdouble_fun4726(kk_function_t _fself, kk_box_t _b_4172, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun4726(kk_function_t _b_4199_4171, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun4726__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdecdouble_fun4726__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdecdouble_fun4726, kk_context());
  _self->_b_4199_4171 = _b_4199_4171;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pdecdouble_fun4726(kk_function_t _fself, kk_box_t _b_4172, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun4726__t* _self = kk_function_as(struct kk_std_num_double_pdecdouble_fun4726__t*, _fself);
  kk_function_t _b_4199_4171 = _self->_b_4199_4171; /* (cur : sslice) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4199_4171);}, {}, _ctx)
  double _x4727;
  kk_std_core__sslice _x4728 = kk_std_core__sslice_unbox(_b_4172, _ctx); /*sslice*/
  _x4727 = kk_function_call(double, (kk_function_t, kk_std_core__sslice, kk_context_t*), _b_4199_4171, (_b_4199_4171, _x4728, _ctx)); /*double*/
  return kk_double_box(_x4727, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun4729__t {
  struct kk_function_s _base;
  kk_std_core__sslice x_3940;
};
static double kk_std_num_double_pdecdouble_fun4729(kk_function_t _fself, kk_string_t man, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun4729(kk_std_core__sslice x_3940, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun4729__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdecdouble_fun4729__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdecdouble_fun4729, kk_context());
  _self->x_3940 = x_3940;
  return &_self->_base;
}

static double kk_std_num_double_pdecdouble_fun4729(kk_function_t _fself, kk_string_t man, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun4729__t* _self = kk_function_as(struct kk_std_num_double_pdecdouble_fun4729__t*, _fself);
  kk_std_core__sslice x_3940 = _self->x_3940; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(x_3940);}, {}, _ctx)
  return kk_std_num_double__mlift3908_pdecdouble(x_3940, man, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun4731__t {
  struct kk_function_s _base;
  kk_function_t _b_4200_4173;
};
static kk_box_t kk_std_num_double_pdecdouble_fun4731(kk_function_t _fself, kk_box_t _b_4174, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun4731(kk_function_t _b_4200_4173, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun4731__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdecdouble_fun4731__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdecdouble_fun4731, kk_context());
  _self->_b_4200_4173 = _b_4200_4173;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pdecdouble_fun4731(kk_function_t _fself, kk_box_t _b_4174, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun4731__t* _self = kk_function_as(struct kk_std_num_double_pdecdouble_fun4731__t*, _fself);
  kk_function_t _b_4200_4173 = _self->_b_4200_4173; /* (man : string) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4200_4173);}, {}, _ctx)
  double _x4732;
  kk_string_t _x4733 = kk_string_unbox(_b_4174); /*string*/
  _x4732 = kk_function_call(double, (kk_function_t, kk_string_t, kk_context_t*), _b_4200_4173, (_b_4200_4173, _x4733, _ctx)); /*double*/
  return kk_double_box(_x4732, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun4735__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_pdecdouble_fun4735(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun4735(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdecdouble_fun4735, _ctx)
  return kk_function_dup(_fself);
}



// lift anonymous function
struct kk_std_num_double_pdecdouble_fun4738__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_pdecdouble_fun4738(kk_function_t _fself, kk_box_t _b_4176, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun4738(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdecdouble_fun4738, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double_pdecdouble_fun4738(kk_function_t _fself, kk_box_t _b_4176, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x4739;
  kk_char_t _x4740 = kk_char_unbox(_b_4176, _ctx); /*char*/
  _x4739 = kk_std_num_double__mlift3906_pdecdouble(_x4740, _ctx); /*string*/
  return kk_string_box(_x4739);
}
static kk_box_t kk_std_num_double_pdecdouble_fun4735(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x4736;
  kk_char_t x2_3951 = kk_std_text_parse_char('.', _ctx); /*char*/;
  if (kk_yielding(kk_context())) {
    kk_box_t _x4737 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_pdecdouble_fun4738(_ctx), _ctx); /*3858*/
    _x4736 = kk_string_unbox(_x4737); /*string*/
  }
  else {
    _x4736 = kk_std_num_double__mlift3906_pdecdouble(x2_3951, _ctx); /*string*/
  }
  return kk_string_box(_x4736);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun4741__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_pdecdouble_fun4741(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun4741(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdecdouble_fun4741, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double_pdecdouble_fun4741(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x4742 = kk_string_empty(); /*string*/
  return kk_string_box(_x4742);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun4744__t {
  struct kk_function_s _base;
  kk_std_core__sslice x_3940;
};
static double kk_std_num_double_pdecdouble_fun4744(kk_function_t _fself, kk_string_t _y_3878, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun4744(kk_std_core__sslice x_3940, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun4744__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdecdouble_fun4744__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdecdouble_fun4744, kk_context());
  _self->x_3940 = x_3940;
  return &_self->_base;
}

static double kk_std_num_double_pdecdouble_fun4744(kk_function_t _fself, kk_string_t _y_3878, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun4744__t* _self = kk_function_as(struct kk_std_num_double_pdecdouble_fun4744__t*, _fself);
  kk_std_core__sslice x_3940 = _self->x_3940; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(x_3940);}, {}, _ctx)
  return kk_std_num_double__mlift3907_pdecdouble(x_3940, _y_3878, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun4746__t {
  struct kk_function_s _base;
  kk_function_t _b_4201_4182;
};
static kk_box_t kk_std_num_double_pdecdouble_fun4746(kk_function_t _fself, kk_box_t _b_4183, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun4746(kk_function_t _b_4201_4182, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun4746__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdecdouble_fun4746__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdecdouble_fun4746, kk_context());
  _self->_b_4201_4182 = _b_4201_4182;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pdecdouble_fun4746(kk_function_t _fself, kk_box_t _b_4183, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun4746__t* _self = kk_function_as(struct kk_std_num_double_pdecdouble_fun4746__t*, _fself);
  kk_function_t _b_4201_4182 = _self->_b_4201_4182; /* (string) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4201_4182);}, {}, _ctx)
  double _x4747;
  kk_string_t _x4748 = kk_string_unbox(_b_4183); /*string*/
  _x4747 = kk_function_call(double, (kk_function_t, kk_string_t, kk_context_t*), _b_4201_4182, (_b_4201_4182, _x4748, _ctx)); /*double*/
  return kk_double_box(_x4747, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun4752__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_pdecdouble_fun4752(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun4752(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdecdouble_fun4752, _ctx)
  return kk_function_dup(_fself);
}



// lift anonymous function
struct kk_std_num_double_pdecdouble_fun4757__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_pdecdouble_fun4757(kk_function_t _fself, kk_box_t _b_4185, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun4757(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdecdouble_fun4757, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double_pdecdouble_fun4757(kk_function_t _fself, kk_box_t _b_4185, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_integer_t _x4758;
  kk_char_t _x4759 = kk_char_unbox(_b_4185, _ctx); /*char*/
  _x4758 = kk_std_num_double__mlift3904_pdecdouble(_x4759, _ctx); /*int*/
  return kk_integer_box(_x4758);
}
static kk_box_t kk_std_num_double_pdecdouble_fun4752(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_integer_t _x4753;
  kk_char_t x4_3956;
  kk_string_t _x4754;
  kk_define_string_literal(, _s4755, 2, "eE")
  _x4754 = kk_string_dup(_s4755); /*string*/
  x4_3956 = kk_std_text_parse_one_of(_x4754, _ctx); /*char*/
  if (kk_yielding(kk_context())) {
    kk_box_t _x4756 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_pdecdouble_fun4757(_ctx), _ctx); /*3858*/
    _x4753 = kk_integer_unbox(_x4756); /*int*/
  }
  else {
    _x4753 = kk_std_num_double__mlift3904_pdecdouble(x4_3956, _ctx); /*int*/
  }
  return kk_integer_box(_x4753);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun4760__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_pdecdouble_fun4760(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun4760(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdecdouble_fun4760, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double_pdecdouble_fun4760(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_integer_box(kk_integer_from_small(0));
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun4761__t {
  struct kk_function_s _base;
  kk_std_core__sslice x_3940;
};
static double kk_std_num_double_pdecdouble_fun4761(kk_function_t _fself, kk_integer_t exp, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun4761(kk_std_core__sslice x_3940, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun4761__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdecdouble_fun4761__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdecdouble_fun4761, kk_context());
  _self->x_3940 = x_3940;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_num_double_pdecdouble_fun4763__t {
  struct kk_function_s _base;
};
static double kk_std_num_double_pdecdouble_fun4763(kk_function_t _fself, kk_string_t _x14762, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun4763(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdecdouble_fun4763, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double_pdecdouble_fun4763(kk_function_t _fself, kk_string_t _x14762, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_num_double_prim_parse_double(_x14762, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun4765__t {
  struct kk_function_s _base;
  kk_function_t _b_4203_4191;
};
static kk_box_t kk_std_num_double_pdecdouble_fun4765(kk_function_t _fself, kk_box_t _b_4193, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun4765(kk_function_t _b_4203_4191, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun4765__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdecdouble_fun4765__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdecdouble_fun4765, kk_context());
  _self->_b_4203_4191 = _b_4203_4191;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pdecdouble_fun4765(kk_function_t _fself, kk_box_t _b_4193, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun4765__t* _self = kk_function_as(struct kk_std_num_double_pdecdouble_fun4765__t*, _fself);
  kk_function_t _b_4203_4191 = _self->_b_4203_4191; /* (s : string) -> double */
  kk_drop_match(_self, {kk_function_dup(_b_4203_4191);}, {}, _ctx)
  double _x4766;
  kk_string_t _x4767 = kk_string_unbox(_b_4193); /*string*/
  _x4766 = kk_function_call(double, (kk_function_t, kk_string_t, kk_context_t*), _b_4203_4191, (_b_4203_4191, _x4767, _ctx)); /*double*/
  return kk_double_box(_x4766, _ctx);
}
static double kk_std_num_double_pdecdouble_fun4761(kk_function_t _fself, kk_integer_t exp, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun4761__t* _self = kk_function_as(struct kk_std_num_double_pdecdouble_fun4761__t*, _fself);
  kk_std_core__sslice x_3940 = _self->x_3940; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(x_3940);}, {}, _ctx)
  kk_integer_drop(exp, _ctx);
  kk_string_t _x1 = kk_std_core_string_3(x_3940, _ctx); /*string*/;
  kk_function_t _b_4203_4191 = kk_std_num_double_new_pdecdouble_fun4763(_ctx); /*(s : string) -> double*/;
  kk_string_t _b_4204_4192 = _x1; /*string*/;
  kk_box_t _x4764 = kk_std_core_hnd__open_none1(kk_std_num_double_new_pdecdouble_fun4765(_b_4203_4191, _ctx), kk_string_box(_b_4204_4192), _ctx); /*3289*/
  return kk_double_unbox(_x4764, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun4769__t {
  struct kk_function_s _base;
  kk_function_t _b_4202_4194;
};
static kk_box_t kk_std_num_double_pdecdouble_fun4769(kk_function_t _fself, kk_box_t _b_4195, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun4769(kk_function_t _b_4202_4194, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun4769__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdecdouble_fun4769__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdecdouble_fun4769, kk_context());
  _self->_b_4202_4194 = _b_4202_4194;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pdecdouble_fun4769(kk_function_t _fself, kk_box_t _b_4195, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun4769__t* _self = kk_function_as(struct kk_std_num_double_pdecdouble_fun4769__t*, _fself);
  kk_function_t _b_4202_4194 = _self->_b_4202_4194; /* (exp : int) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4202_4194);}, {}, _ctx)
  double _x4770;
  kk_integer_t _x4771 = kk_integer_unbox(_b_4195); /*int*/
  _x4770 = kk_function_call(double, (kk_function_t, kk_integer_t, kk_context_t*), _b_4202_4194, (_b_4202_4194, _x4771, _ctx)); /*double*/
  return kk_double_box(_x4770, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun4773__t {
  struct kk_function_s _base;
};
static double kk_std_num_double_pdecdouble_fun4773(kk_function_t _fself, kk_string_t _x14772, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun4773(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdecdouble_fun4773, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double_pdecdouble_fun4773(kk_function_t _fself, kk_string_t _x14772, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_num_double_prim_parse_double(_x14772, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun4775__t {
  struct kk_function_s _base;
  kk_function_t _b_4205_4196;
};
static kk_box_t kk_std_num_double_pdecdouble_fun4775(kk_function_t _fself, kk_box_t _b_4198, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun4775(kk_function_t _b_4205_4196, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun4775__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdecdouble_fun4775__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdecdouble_fun4775, kk_context());
  _self->_b_4205_4196 = _b_4205_4196;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pdecdouble_fun4775(kk_function_t _fself, kk_box_t _b_4198, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun4775__t* _self = kk_function_as(struct kk_std_num_double_pdecdouble_fun4775__t*, _fself);
  kk_function_t _b_4205_4196 = _self->_b_4205_4196; /* (s : string) -> double */
  kk_drop_match(_self, {kk_function_dup(_b_4205_4196);}, {}, _ctx)
  double _x4776;
  kk_string_t _x4777 = kk_string_unbox(_b_4198); /*string*/
  _x4776 = kk_function_call(double, (kk_function_t, kk_string_t, kk_context_t*), _b_4205_4196, (_b_4205_4196, _x4777, _ctx)); /*double*/
  return kk_double_box(_x4776, _ctx);
}

double kk_std_num_double_pdecdouble(kk_context_t* _ctx) { /* () -> std/text/parse/parse double */ 
  kk_std_core_hnd__ev ev_3943;
  kk_ssize_t _x4719 = ((kk_ssize_t)0); /*ssize_t*/
  ev_3943 = kk_evv_at(_x4719,kk_context()); /*std/core/hnd/ev<std/text/parse/.hnd-parse>*/
  kk_std_core__sslice x_3940;
  kk_box_t _x4720;
  struct kk_std_core_hnd_Ev* _con4721 = kk_std_core_hnd__as_Ev(ev_3943);
  kk_std_core_hnd__marker m0 = _con4721->marker;
  kk_box_t _box_x4165 = _con4721->hnd;
  kk_std_text_parse__hnd_parse h = kk_std_text_parse__hnd_parse_unbox(_box_x4165, NULL);
  kk_std_text_parse__hnd_parse_dup(h);
  kk_std_core_hnd__clause0 _match_4469;
  kk_std_core_hnd__clause0 _borrowApp_4470 = kk_std_text_parse__select_current_input(h, _ctx); /*std/core/hnd/clause0<sslice,std/text/parse/.hnd-parse,378,379>*/;
  kk_std_text_parse__hnd_parse_drop(h, _ctx);
  _match_4469 = _borrowApp_4470; /*std/core/hnd/clause0<sslice,std/text/parse/.hnd-parse,378,379>*/
  kk_function_t _fun_unbox_x4168 = _match_4469.clause;
  _x4720 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_context_t*), _fun_unbox_x4168, (_fun_unbox_x4168, m0, ev_3943, _ctx)); /*37*/
  x_3940 = kk_std_core__sslice_unbox(_x4720, _ctx); /*sslice*/
  if (kk_yielding(kk_context())) {
    kk_std_core__sslice_drop(x_3940, _ctx);
    kk_function_t _b_4199_4171 = kk_std_num_double_new_pdecdouble_fun4724(_ctx); /*(cur : sslice) -> std/text/parse/parse double*/;
    kk_box_t _x4725 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_pdecdouble_fun4726(_b_4199_4171, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x4725, _ctx);
  }
  kk_string_t x0_3945 = kk_std_text_parse_digits(_ctx); /*string*/;
  kk_string_drop(x0_3945, _ctx);
  if (kk_yielding(kk_context())) {
    kk_function_t _b_4200_4173 = kk_std_num_double_new_pdecdouble_fun4729(x_3940, _ctx); /*(man : string) -> std/text/parse/parse double*/;
    kk_box_t _x4730 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_pdecdouble_fun4731(_b_4200_4173, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x4730, _ctx);
  }
  kk_string_t x1_3948;
  kk_box_t _x4734 = kk_std_text_parse__lp__bar__bar__rp_(kk_std_num_double_new_pdecdouble_fun4735(_ctx), kk_std_num_double_new_pdecdouble_fun4741(_ctx), _ctx); /*946*/
  x1_3948 = kk_string_unbox(_x4734); /*string*/
  if (kk_yielding(kk_context())) {
    kk_string_drop(x1_3948, _ctx);
    kk_function_t _b_4201_4182 = kk_std_num_double_new_pdecdouble_fun4744(x_3940, _ctx); /*(string) -> std/text/parse/parse double*/;
    kk_box_t _x4745 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_pdecdouble_fun4746(_b_4201_4182, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x4745, _ctx);
  }
  kk_string_t frac;
  kk_string_t _x4749;
  kk_define_string_literal(, _s4750, 1, "0")
  _x4749 = kk_string_dup(_s4750); /*string*/
  frac = kk_std_core_trim_right_1(x1_3948, _x4749, _ctx); /*string*/
  kk_string_drop(frac, _ctx);
  kk_integer_t x3_3953;
  kk_box_t _x4751 = kk_std_text_parse__lp__bar__bar__rp_(kk_std_num_double_new_pdecdouble_fun4752(_ctx), kk_std_num_double_new_pdecdouble_fun4760(_ctx), _ctx); /*946*/
  x3_3953 = kk_integer_unbox(_x4751); /*int*/
  kk_integer_drop(x3_3953, _ctx);
  if (kk_yielding(kk_context())) {
    kk_function_t _b_4202_4194 = kk_std_num_double_new_pdecdouble_fun4761(x_3940, _ctx); /*(exp : int) -> std/text/parse/parse double*/;
    kk_box_t _x4768 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_pdecdouble_fun4769(_b_4202_4194, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x4768, _ctx);
  }
  kk_string_t _x10 = kk_std_core_string_3(x_3940, _ctx); /*string*/;
  kk_function_t _b_4205_4196 = kk_std_num_double_new_pdecdouble_fun4773(_ctx); /*(s : string) -> double*/;
  kk_string_t _b_4206_4197 = _x10; /*string*/;
  kk_box_t _x4774 = kk_std_core_hnd__open_none1(kk_std_num_double_new_pdecdouble_fun4775(_b_4205_4196, _ctx), kk_string_box(_b_4206_4197), _ctx); /*3289*/
  return kk_double_unbox(_x4774, _ctx);
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_double__mlift3911_phexdouble_fun4780__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3911_phexdouble_fun4780(kk_function_t _fself, kk_box_t _b_4212, kk_box_t _b_4213, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3911_phexdouble_fun4780(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3911_phexdouble_fun4780, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double__mlift3911_phexdouble_fun4780(kk_function_t _fself, kk_box_t _b_4212, kk_box_t _b_4213, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_std_core_types__maybe _x4781;
  kk_string_t s_4227 = kk_string_unbox(_b_4212); /*string*/;
  kk_std_core_types__optional hex_4228 = kk_std_core_types__optional_unbox(_b_4213, _ctx); /*optional<bool>*/;
  kk_string_t _x4782;
  kk_string_t _x4783 = kk_string_trim_left(s_4227,kk_context()); /*string*/
  _x4782 = kk_string_trim_right(_x4783,kk_context()); /*string*/
  bool _x4784;
  if (kk_std_core_types__is_Optional(hex_4228)) {
    kk_box_t _box_x4207 = hex_4228._cons.Optional.value;
    bool _hex_15437 = kk_bool_unbox(_box_x4207);
    kk_std_core_types__optional_drop(hex_4228, _ctx);
    kk_Unit;
    _x4784 = _hex_15437; /*bool*/
    goto _match4785;
  }
  _x4784 = false; /*bool*/
  _match4785: ;
  _x4781 = kk_std_core_xparse_int(_x4782, _x4784, _ctx); /*maybe<int>*/
  return kk_std_core_types__maybe_box(_x4781, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3911_phexdouble_fun4792__t {
  struct kk_function_s _base;
};
static double kk_std_num_double__mlift3911_phexdouble_fun4792(kk_function_t _fself, kk_integer_t man0, kk_integer_t exp0, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3911_phexdouble_fun4792(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3911_phexdouble_fun4792, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double__mlift3911_phexdouble_fun4792(kk_function_t _fself, kk_integer_t man0, kk_integer_t exp0, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x4793;
  double _borrowApp_4462 = kk_integer_as_double_borrow(man0); /*double*/;
  kk_integer_drop(man0, _ctx);
  _x4793 = _borrowApp_4462; /*double*/
  return kk_std_num_double_ldexp(_x4793, exp0, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3911_phexdouble_fun4795__t {
  struct kk_function_s _base;
  kk_function_t _b_4229_4222;
};
static kk_box_t kk_std_num_double__mlift3911_phexdouble_fun4795(kk_function_t _fself, kk_box_t _b_4225, kk_box_t _b_4226, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3911_phexdouble_fun4795(kk_function_t _b_4229_4222, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3911_phexdouble_fun4795__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3911_phexdouble_fun4795__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3911_phexdouble_fun4795, kk_context());
  _self->_b_4229_4222 = _b_4229_4222;
  return &_self->_base;
}

static kk_box_t kk_std_num_double__mlift3911_phexdouble_fun4795(kk_function_t _fself, kk_box_t _b_4225, kk_box_t _b_4226, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3911_phexdouble_fun4795__t* _self = kk_function_as(struct kk_std_num_double__mlift3911_phexdouble_fun4795__t*, _fself);
  kk_function_t _b_4229_4222 = _self->_b_4229_4222; /* (man0 : int, exp0 : int) -> double */
  kk_drop_match(_self, {kk_function_dup(_b_4229_4222);}, {}, _ctx)
  double _x4796;
  kk_integer_t _x4797 = kk_integer_unbox(_b_4225); /*int*/
  kk_integer_t _x4798 = kk_integer_unbox(_b_4226); /*int*/
  _x4796 = kk_function_call(double, (kk_function_t, kk_integer_t, kk_integer_t, kk_context_t*), _b_4229_4222, (_b_4229_4222, _x4797, _x4798, _ctx)); /*double*/
  return kk_double_box(_x4796, _ctx);
}

double kk_std_num_double__mlift3911_phexdouble(kk_string_t frac, kk_string_t man, kk_integer_t exp, kk_context_t* _ctx) { /* (frac : string, man : string, exp : int) -> std/text/parse/parse double */ 
  kk_string_t _x1;
  kk_string_t _x4778 = kk_string_dup(frac); /*string*/
  _x1 = kk_std_core__lp__plus__plus__1_rp_(man, _x4778, _ctx); /*string*/
  kk_std_core_types__maybe _b_4216_4214;
  kk_box_t _x4779;
  kk_box_t _x4787;
  kk_std_core_types__optional _x4788 = kk_std_core_types__new_Optional(kk_bool_box(true), _ctx); /*optional<106>*/
  _x4787 = kk_std_core_types__optional_box(_x4788, _ctx); /*3380*/
  _x4779 = kk_std_core_hnd__open_none2(kk_std_num_double__new_mlift3911_phexdouble_fun4780(_ctx), kk_string_box(_x1), _x4787, _ctx); /*3381*/
  _b_4216_4214 = kk_std_core_types__maybe_unbox(_x4779, _ctx); /*maybe<int>*/
  kk_integer_t m;
  kk_box_t _x4789 = kk_std_core_default(_b_4216_4214, kk_integer_box(kk_integer_from_small(0)), _ctx); /*2300*/
  m = kk_integer_unbox(_x4789); /*int*/
  kk_integer_t e;
  kk_integer_t _x4790;
  kk_integer_t _x4791 = kk_std_core_count_1(frac, _ctx); /*int*/
  _x4790 = kk_integer_mul((kk_integer_from_small(4)),_x4791,kk_context()); /*int*/
  e = kk_integer_sub(exp,_x4790,kk_context()); /*int*/
  kk_function_t _b_4229_4222 = kk_std_num_double__new_mlift3911_phexdouble_fun4792(_ctx); /*(man0 : int, exp0 : int) -> double*/;
  kk_integer_t _b_4230_4223 = m; /*int*/;
  kk_integer_t _b_4231_4224 = e; /*int*/;
  kk_box_t _x4794 = kk_std_core_hnd__open_none2(kk_std_num_double__new_mlift3911_phexdouble_fun4795(_b_4229_4222, _ctx), kk_integer_box(_b_4230_4223), kk_integer_box(_b_4231_4224), _ctx); /*3381*/
  return kk_double_unbox(_x4794, _ctx);
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_double__mlift3913_phexdouble_fun4802__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3913_phexdouble_fun4802(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3913_phexdouble_fun4802(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3913_phexdouble_fun4802, _ctx)
  return kk_function_dup(_fself);
}



// lift anonymous function
struct kk_std_num_double__mlift3913_phexdouble_fun4807__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3913_phexdouble_fun4807(kk_function_t _fself, kk_box_t _b_4233, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3913_phexdouble_fun4807(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3913_phexdouble_fun4807, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double__mlift3913_phexdouble_fun4807(kk_function_t _fself, kk_box_t _b_4233, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_integer_t _x4808;
  kk_char_t _x4809 = kk_char_unbox(_b_4233, _ctx); /*char*/
  _x4808 = kk_std_num_double__mlift3910_phexdouble(_x4809, _ctx); /*int*/
  return kk_integer_box(_x4808);
}
static kk_box_t kk_std_num_double__mlift3913_phexdouble_fun4802(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_integer_t _x4803;
  kk_char_t x0_3962;
  kk_string_t _x4804;
  kk_define_string_literal(, _s4805, 2, "pP")
  _x4804 = kk_string_dup(_s4805); /*string*/
  x0_3962 = kk_std_text_parse_one_of(_x4804, _ctx); /*char*/
  if (kk_yielding(kk_context())) {
    kk_box_t _x4806 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3913_phexdouble_fun4807(_ctx), _ctx); /*3858*/
    _x4803 = kk_integer_unbox(_x4806); /*int*/
  }
  else {
    _x4803 = kk_std_num_double__mlift3910_phexdouble(x0_3962, _ctx); /*int*/
  }
  return kk_integer_box(_x4803);
}


// lift anonymous function
struct kk_std_num_double__mlift3913_phexdouble_fun4810__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3913_phexdouble_fun4810(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3913_phexdouble_fun4810(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3913_phexdouble_fun4810, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double__mlift3913_phexdouble_fun4810(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_integer_box(kk_integer_from_small(0));
}


// lift anonymous function
struct kk_std_num_double__mlift3913_phexdouble_fun4811__t {
  struct kk_function_s _base;
  kk_string_t frac;
  kk_string_t man;
};
static double kk_std_num_double__mlift3913_phexdouble_fun4811(kk_function_t _fself, kk_integer_t exp, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3913_phexdouble_fun4811(kk_string_t frac, kk_string_t man, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3913_phexdouble_fun4811__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3913_phexdouble_fun4811__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3913_phexdouble_fun4811, kk_context());
  _self->frac = frac;
  _self->man = man;
  return &_self->_base;
}

static double kk_std_num_double__mlift3913_phexdouble_fun4811(kk_function_t _fself, kk_integer_t exp, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3913_phexdouble_fun4811__t* _self = kk_function_as(struct kk_std_num_double__mlift3913_phexdouble_fun4811__t*, _fself);
  kk_string_t frac = _self->frac; /* string */
  kk_string_t man = _self->man; /* string */
  kk_drop_match(_self, {kk_string_dup(frac);kk_string_dup(man);}, {}, _ctx)
  return kk_std_num_double__mlift3911_phexdouble(frac, man, exp, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3913_phexdouble_fun4813__t {
  struct kk_function_s _base;
  kk_function_t _b_4241_4239;
};
static kk_box_t kk_std_num_double__mlift3913_phexdouble_fun4813(kk_function_t _fself, kk_box_t _b_4240, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3913_phexdouble_fun4813(kk_function_t _b_4241_4239, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3913_phexdouble_fun4813__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3913_phexdouble_fun4813__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3913_phexdouble_fun4813, kk_context());
  _self->_b_4241_4239 = _b_4241_4239;
  return &_self->_base;
}

static kk_box_t kk_std_num_double__mlift3913_phexdouble_fun4813(kk_function_t _fself, kk_box_t _b_4240, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3913_phexdouble_fun4813__t* _self = kk_function_as(struct kk_std_num_double__mlift3913_phexdouble_fun4813__t*, _fself);
  kk_function_t _b_4241_4239 = _self->_b_4241_4239; /* (exp : int) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4241_4239);}, {}, _ctx)
  double _x4814;
  kk_integer_t _x4815 = kk_integer_unbox(_b_4240); /*int*/
  _x4814 = kk_function_call(double, (kk_function_t, kk_integer_t, kk_context_t*), _b_4241_4239, (_b_4241_4239, _x4815, _ctx)); /*double*/
  return kk_double_box(_x4814, _ctx);
}

double kk_std_num_double__mlift3913_phexdouble(kk_string_t man, kk_string_t _y_3887, kk_context_t* _ctx) { /* (man : string, string) -> std/text/parse/parse double */ 
  kk_string_t frac;
  kk_string_t _x4799;
  kk_define_string_literal(, _s4800, 1, "0")
  _x4799 = kk_string_dup(_s4800); /*string*/
  frac = kk_std_core_trim_right_1(_y_3887, _x4799, _ctx); /*string*/
  kk_integer_t x_3960;
  kk_box_t _x4801 = kk_std_text_parse__lp__bar__bar__rp_(kk_std_num_double__new_mlift3913_phexdouble_fun4802(_ctx), kk_std_num_double__new_mlift3913_phexdouble_fun4810(_ctx), _ctx); /*946*/
  x_3960 = kk_integer_unbox(_x4801); /*int*/
  if (kk_yielding(kk_context())) {
    kk_integer_drop(x_3960, _ctx);
    kk_function_t _b_4241_4239 = kk_std_num_double__new_mlift3913_phexdouble_fun4811(frac, man, _ctx); /*(exp : int) -> std/text/parse/parse double*/;
    kk_box_t _x4812 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3913_phexdouble_fun4813(_b_4241_4239, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x4812, _ctx);
  }
  return kk_std_num_double__mlift3911_phexdouble(frac, man, x_3960, _ctx);
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_double__mlift3914_phexdouble_fun4817__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3914_phexdouble_fun4817(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3914_phexdouble_fun4817(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3914_phexdouble_fun4817, _ctx)
  return kk_function_dup(_fself);
}



// lift anonymous function
struct kk_std_num_double__mlift3914_phexdouble_fun4820__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3914_phexdouble_fun4820(kk_function_t _fself, kk_box_t _b_4243, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3914_phexdouble_fun4820(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3914_phexdouble_fun4820, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double__mlift3914_phexdouble_fun4820(kk_function_t _fself, kk_box_t _b_4243, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x4821;
  kk_char_t _x4822 = kk_char_unbox(_b_4243, _ctx); /*char*/
  _x4821 = kk_std_num_double__mlift3912_phexdouble(_x4822, _ctx); /*string*/
  return kk_string_box(_x4821);
}
static kk_box_t kk_std_num_double__mlift3914_phexdouble_fun4817(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x4818;
  kk_char_t x0_3966 = kk_std_text_parse_char('.', _ctx); /*char*/;
  if (kk_yielding(kk_context())) {
    kk_box_t _x4819 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3914_phexdouble_fun4820(_ctx), _ctx); /*3858*/
    _x4818 = kk_string_unbox(_x4819); /*string*/
  }
  else {
    _x4818 = kk_std_num_double__mlift3912_phexdouble(x0_3966, _ctx); /*string*/
  }
  return kk_string_box(_x4818);
}


// lift anonymous function
struct kk_std_num_double__mlift3914_phexdouble_fun4823__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3914_phexdouble_fun4823(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3914_phexdouble_fun4823(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3914_phexdouble_fun4823, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double__mlift3914_phexdouble_fun4823(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x4824 = kk_string_empty(); /*string*/
  return kk_string_box(_x4824);
}


// lift anonymous function
struct kk_std_num_double__mlift3914_phexdouble_fun4826__t {
  struct kk_function_s _base;
  kk_string_t man;
};
static double kk_std_num_double__mlift3914_phexdouble_fun4826(kk_function_t _fself, kk_string_t _y_3887, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3914_phexdouble_fun4826(kk_string_t man, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3914_phexdouble_fun4826__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3914_phexdouble_fun4826__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3914_phexdouble_fun4826, kk_context());
  _self->man = man;
  return &_self->_base;
}

static double kk_std_num_double__mlift3914_phexdouble_fun4826(kk_function_t _fself, kk_string_t _y_3887, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3914_phexdouble_fun4826__t* _self = kk_function_as(struct kk_std_num_double__mlift3914_phexdouble_fun4826__t*, _fself);
  kk_string_t man = _self->man; /* string */
  kk_drop_match(_self, {kk_string_dup(man);}, {}, _ctx)
  return kk_std_num_double__mlift3913_phexdouble(man, _y_3887, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3914_phexdouble_fun4828__t {
  struct kk_function_s _base;
  kk_function_t _b_4251_4249;
};
static kk_box_t kk_std_num_double__mlift3914_phexdouble_fun4828(kk_function_t _fself, kk_box_t _b_4250, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3914_phexdouble_fun4828(kk_function_t _b_4251_4249, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3914_phexdouble_fun4828__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3914_phexdouble_fun4828__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3914_phexdouble_fun4828, kk_context());
  _self->_b_4251_4249 = _b_4251_4249;
  return &_self->_base;
}

static kk_box_t kk_std_num_double__mlift3914_phexdouble_fun4828(kk_function_t _fself, kk_box_t _b_4250, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3914_phexdouble_fun4828__t* _self = kk_function_as(struct kk_std_num_double__mlift3914_phexdouble_fun4828__t*, _fself);
  kk_function_t _b_4251_4249 = _self->_b_4251_4249; /* (string) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4251_4249);}, {}, _ctx)
  double _x4829;
  kk_string_t _x4830 = kk_string_unbox(_b_4250); /*string*/
  _x4829 = kk_function_call(double, (kk_function_t, kk_string_t, kk_context_t*), _b_4251_4249, (_b_4251_4249, _x4830, _ctx)); /*double*/
  return kk_double_box(_x4829, _ctx);
}

double kk_std_num_double__mlift3914_phexdouble(kk_string_t man, kk_context_t* _ctx) { /* (man : string) -> std/text/parse/parse double */ 
  kk_string_t x_3964;
  kk_box_t _x4816 = kk_std_text_parse__lp__bar__bar__rp_(kk_std_num_double__new_mlift3914_phexdouble_fun4817(_ctx), kk_std_num_double__new_mlift3914_phexdouble_fun4823(_ctx), _ctx); /*946*/
  x_3964 = kk_string_unbox(_x4816); /*string*/
  if (kk_yielding(kk_context())) {
    kk_string_drop(x_3964, _ctx);
    kk_function_t _b_4251_4249 = kk_std_num_double__new_mlift3914_phexdouble_fun4826(man, _ctx); /*(string) -> std/text/parse/parse double*/;
    kk_box_t _x4827 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3914_phexdouble_fun4828(_b_4251_4249, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x4827, _ctx);
  }
  return kk_std_num_double__mlift3913_phexdouble(man, x_3964, _ctx);
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_double__mlift3915_phexdouble_fun4832__t {
  struct kk_function_s _base;
};
static double kk_std_num_double__mlift3915_phexdouble_fun4832(kk_function_t _fself, kk_string_t _x14831, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3915_phexdouble_fun4832(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3915_phexdouble_fun4832, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double__mlift3915_phexdouble_fun4832(kk_function_t _fself, kk_string_t _x14831, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_num_double__mlift3914_phexdouble(_x14831, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3915_phexdouble_fun4834__t {
  struct kk_function_s _base;
  kk_function_t _b_4254_4252;
};
static kk_box_t kk_std_num_double__mlift3915_phexdouble_fun4834(kk_function_t _fself, kk_box_t _b_4253, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3915_phexdouble_fun4834(kk_function_t _b_4254_4252, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3915_phexdouble_fun4834__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3915_phexdouble_fun4834__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3915_phexdouble_fun4834, kk_context());
  _self->_b_4254_4252 = _b_4254_4252;
  return &_self->_base;
}

static kk_box_t kk_std_num_double__mlift3915_phexdouble_fun4834(kk_function_t _fself, kk_box_t _b_4253, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3915_phexdouble_fun4834__t* _self = kk_function_as(struct kk_std_num_double__mlift3915_phexdouble_fun4834__t*, _fself);
  kk_function_t _b_4254_4252 = _self->_b_4254_4252; /* (man : string) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4254_4252);}, {}, _ctx)
  double _x4835;
  kk_string_t _x4836 = kk_string_unbox(_b_4253); /*string*/
  _x4835 = kk_function_call(double, (kk_function_t, kk_string_t, kk_context_t*), _b_4254_4252, (_b_4254_4252, _x4836, _ctx)); /*double*/
  return kk_double_box(_x4835, _ctx);
}

double kk_std_num_double__mlift3915_phexdouble(kk_char_t wild__0, kk_context_t* _ctx) { /* (wild_0 : char) -> std/text/parse/parse double */ 
  kk_string_t x_3968 = kk_std_text_parse_hex_digits(_ctx); /*string*/;
  if (kk_yielding(kk_context())) {
    kk_string_drop(x_3968, _ctx);
    kk_function_t _b_4254_4252 = kk_std_num_double__new_mlift3915_phexdouble_fun4832(_ctx); /*(man : string) -> std/text/parse/parse double*/;
    kk_box_t _x4833 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3915_phexdouble_fun4834(_b_4254_4252, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x4833, _ctx);
  }
  return kk_std_num_double__mlift3914_phexdouble(x_3968, _ctx);
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_double__mlift3916_phexdouble_fun4840__t {
  struct kk_function_s _base;
};
static double kk_std_num_double__mlift3916_phexdouble_fun4840(kk_function_t _fself, kk_char_t _x14839, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3916_phexdouble_fun4840(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3916_phexdouble_fun4840, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double__mlift3916_phexdouble_fun4840(kk_function_t _fself, kk_char_t _x14839, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_num_double__mlift3915_phexdouble(_x14839, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3916_phexdouble_fun4842__t {
  struct kk_function_s _base;
  kk_function_t _b_4257_4255;
};
static kk_box_t kk_std_num_double__mlift3916_phexdouble_fun4842(kk_function_t _fself, kk_box_t _b_4256, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3916_phexdouble_fun4842(kk_function_t _b_4257_4255, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3916_phexdouble_fun4842__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3916_phexdouble_fun4842__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3916_phexdouble_fun4842, kk_context());
  _self->_b_4257_4255 = _b_4257_4255;
  return &_self->_base;
}

static kk_box_t kk_std_num_double__mlift3916_phexdouble_fun4842(kk_function_t _fself, kk_box_t _b_4256, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3916_phexdouble_fun4842__t* _self = kk_function_as(struct kk_std_num_double__mlift3916_phexdouble_fun4842__t*, _fself);
  kk_function_t _b_4257_4255 = _self->_b_4257_4255; /* (wild_0 : char) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4257_4255);}, {}, _ctx)
  double _x4843;
  kk_char_t _x4844 = kk_char_unbox(_b_4256, _ctx); /*char*/
  _x4843 = kk_function_call(double, (kk_function_t, kk_char_t, kk_context_t*), _b_4257_4255, (_b_4257_4255, _x4844, _ctx)); /*double*/
  return kk_double_box(_x4843, _ctx);
}

double kk_std_num_double__mlift3916_phexdouble(kk_char_t wild__, kk_context_t* _ctx) { /* (wild_ : char) -> std/text/parse/parse double */ 
  kk_char_t x_3970;
  kk_string_t _x4837;
  kk_define_string_literal(, _s4838, 2, "xX")
  _x4837 = kk_string_dup(_s4838); /*string*/
  x_3970 = kk_std_text_parse_one_of(_x4837, _ctx); /*char*/
  if (kk_yielding(kk_context())) {
    kk_function_t _b_4257_4255 = kk_std_num_double__new_mlift3916_phexdouble_fun4840(_ctx); /*(wild_0 : char) -> std/text/parse/parse double*/;
    kk_box_t _x4841 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3916_phexdouble_fun4842(_b_4257_4255, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x4841, _ctx);
  }
  return kk_std_num_double__mlift3915_phexdouble(x_3970, _ctx);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun4846__t {
  struct kk_function_s _base;
};
static double kk_std_num_double_phexdouble_fun4846(kk_function_t _fself, kk_char_t _x14845, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun4846(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_phexdouble_fun4846, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double_phexdouble_fun4846(kk_function_t _fself, kk_char_t _x14845, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_num_double__mlift3916_phexdouble(_x14845, _ctx);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun4848__t {
  struct kk_function_s _base;
  kk_function_t _b_4302_4258;
};
static kk_box_t kk_std_num_double_phexdouble_fun4848(kk_function_t _fself, kk_box_t _b_4259, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun4848(kk_function_t _b_4302_4258, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun4848__t* _self = kk_function_alloc_as(struct kk_std_num_double_phexdouble_fun4848__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_phexdouble_fun4848, kk_context());
  _self->_b_4302_4258 = _b_4302_4258;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_phexdouble_fun4848(kk_function_t _fself, kk_box_t _b_4259, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun4848__t* _self = kk_function_as(struct kk_std_num_double_phexdouble_fun4848__t*, _fself);
  kk_function_t _b_4302_4258 = _self->_b_4302_4258; /* (wild_ : char) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4302_4258);}, {}, _ctx)
  double _x4849;
  kk_char_t _x4850 = kk_char_unbox(_b_4259, _ctx); /*char*/
  _x4849 = kk_function_call(double, (kk_function_t, kk_char_t, kk_context_t*), _b_4302_4258, (_b_4302_4258, _x4850, _ctx)); /*double*/
  return kk_double_box(_x4849, _ctx);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun4854__t {
  struct kk_function_s _base;
};
static double kk_std_num_double_phexdouble_fun4854(kk_function_t _fself, kk_char_t _x14853, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun4854(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_phexdouble_fun4854, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double_phexdouble_fun4854(kk_function_t _fself, kk_char_t _x14853, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_num_double__mlift3915_phexdouble(_x14853, _ctx);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun4856__t {
  struct kk_function_s _base;
  kk_function_t _b_4303_4260;
};
static kk_box_t kk_std_num_double_phexdouble_fun4856(kk_function_t _fself, kk_box_t _b_4261, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun4856(kk_function_t _b_4303_4260, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun4856__t* _self = kk_function_alloc_as(struct kk_std_num_double_phexdouble_fun4856__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_phexdouble_fun4856, kk_context());
  _self->_b_4303_4260 = _b_4303_4260;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_phexdouble_fun4856(kk_function_t _fself, kk_box_t _b_4261, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun4856__t* _self = kk_function_as(struct kk_std_num_double_phexdouble_fun4856__t*, _fself);
  kk_function_t _b_4303_4260 = _self->_b_4303_4260; /* (wild_0 : char) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4303_4260);}, {}, _ctx)
  double _x4857;
  kk_char_t _x4858 = kk_char_unbox(_b_4261, _ctx); /*char*/
  _x4857 = kk_function_call(double, (kk_function_t, kk_char_t, kk_context_t*), _b_4303_4260, (_b_4303_4260, _x4858, _ctx)); /*double*/
  return kk_double_box(_x4857, _ctx);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun4860__t {
  struct kk_function_s _base;
};
static double kk_std_num_double_phexdouble_fun4860(kk_function_t _fself, kk_string_t _x14859, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun4860(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_phexdouble_fun4860, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double_phexdouble_fun4860(kk_function_t _fself, kk_string_t _x14859, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_num_double__mlift3914_phexdouble(_x14859, _ctx);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun4862__t {
  struct kk_function_s _base;
  kk_function_t _b_4304_4262;
};
static kk_box_t kk_std_num_double_phexdouble_fun4862(kk_function_t _fself, kk_box_t _b_4263, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun4862(kk_function_t _b_4304_4262, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun4862__t* _self = kk_function_alloc_as(struct kk_std_num_double_phexdouble_fun4862__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_phexdouble_fun4862, kk_context());
  _self->_b_4304_4262 = _b_4304_4262;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_phexdouble_fun4862(kk_function_t _fself, kk_box_t _b_4263, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun4862__t* _self = kk_function_as(struct kk_std_num_double_phexdouble_fun4862__t*, _fself);
  kk_function_t _b_4304_4262 = _self->_b_4304_4262; /* (man : string) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4304_4262);}, {}, _ctx)
  double _x4863;
  kk_string_t _x4864 = kk_string_unbox(_b_4263); /*string*/
  _x4863 = kk_function_call(double, (kk_function_t, kk_string_t, kk_context_t*), _b_4304_4262, (_b_4304_4262, _x4864, _ctx)); /*double*/
  return kk_double_box(_x4863, _ctx);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun4866__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_phexdouble_fun4866(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun4866(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_phexdouble_fun4866, _ctx)
  return kk_function_dup(_fself);
}



// lift anonymous function
struct kk_std_num_double_phexdouble_fun4869__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_phexdouble_fun4869(kk_function_t _fself, kk_box_t _b_4265, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun4869(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_phexdouble_fun4869, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double_phexdouble_fun4869(kk_function_t _fself, kk_box_t _b_4265, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x4870;
  kk_char_t _x4871 = kk_char_unbox(_b_4265, _ctx); /*char*/
  _x4870 = kk_std_num_double__mlift3912_phexdouble(_x4871, _ctx); /*string*/
  return kk_string_box(_x4870);
}
static kk_box_t kk_std_num_double_phexdouble_fun4866(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x4867;
  kk_char_t x3_3984 = kk_std_text_parse_char('.', _ctx); /*char*/;
  if (kk_yielding(kk_context())) {
    kk_box_t _x4868 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_phexdouble_fun4869(_ctx), _ctx); /*3858*/
    _x4867 = kk_string_unbox(_x4868); /*string*/
  }
  else {
    _x4867 = kk_std_num_double__mlift3912_phexdouble(x3_3984, _ctx); /*string*/
  }
  return kk_string_box(_x4867);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun4872__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_phexdouble_fun4872(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun4872(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_phexdouble_fun4872, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double_phexdouble_fun4872(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x4873 = kk_string_empty(); /*string*/
  return kk_string_box(_x4873);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun4875__t {
  struct kk_function_s _base;
  kk_string_t x1_3978;
};
static double kk_std_num_double_phexdouble_fun4875(kk_function_t _fself, kk_string_t _y_3887, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun4875(kk_string_t x1_3978, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun4875__t* _self = kk_function_alloc_as(struct kk_std_num_double_phexdouble_fun4875__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_phexdouble_fun4875, kk_context());
  _self->x1_3978 = x1_3978;
  return &_self->_base;
}

static double kk_std_num_double_phexdouble_fun4875(kk_function_t _fself, kk_string_t _y_3887, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun4875__t* _self = kk_function_as(struct kk_std_num_double_phexdouble_fun4875__t*, _fself);
  kk_string_t x1_3978 = _self->x1_3978; /* string */
  kk_drop_match(_self, {kk_string_dup(x1_3978);}, {}, _ctx)
  return kk_std_num_double__mlift3913_phexdouble(x1_3978, _y_3887, _ctx);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun4877__t {
  struct kk_function_s _base;
  kk_function_t _b_4305_4271;
};
static kk_box_t kk_std_num_double_phexdouble_fun4877(kk_function_t _fself, kk_box_t _b_4272, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun4877(kk_function_t _b_4305_4271, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun4877__t* _self = kk_function_alloc_as(struct kk_std_num_double_phexdouble_fun4877__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_phexdouble_fun4877, kk_context());
  _self->_b_4305_4271 = _b_4305_4271;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_phexdouble_fun4877(kk_function_t _fself, kk_box_t _b_4272, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun4877__t* _self = kk_function_as(struct kk_std_num_double_phexdouble_fun4877__t*, _fself);
  kk_function_t _b_4305_4271 = _self->_b_4305_4271; /* (string) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4305_4271);}, {}, _ctx)
  double _x4878;
  kk_string_t _x4879 = kk_string_unbox(_b_4272); /*string*/
  _x4878 = kk_function_call(double, (kk_function_t, kk_string_t, kk_context_t*), _b_4305_4271, (_b_4305_4271, _x4879, _ctx)); /*double*/
  return kk_double_box(_x4878, _ctx);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun4883__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_phexdouble_fun4883(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun4883(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_phexdouble_fun4883, _ctx)
  return kk_function_dup(_fself);
}



// lift anonymous function
struct kk_std_num_double_phexdouble_fun4888__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_phexdouble_fun4888(kk_function_t _fself, kk_box_t _b_4274, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun4888(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_phexdouble_fun4888, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double_phexdouble_fun4888(kk_function_t _fself, kk_box_t _b_4274, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_integer_t _x4889;
  kk_char_t _x4890 = kk_char_unbox(_b_4274, _ctx); /*char*/
  _x4889 = kk_std_num_double__mlift3910_phexdouble(_x4890, _ctx); /*int*/
  return kk_integer_box(_x4889);
}
static kk_box_t kk_std_num_double_phexdouble_fun4883(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_integer_t _x4884;
  kk_char_t x5_3989;
  kk_string_t _x4885;
  kk_define_string_literal(, _s4886, 2, "pP")
  _x4885 = kk_string_dup(_s4886); /*string*/
  x5_3989 = kk_std_text_parse_one_of(_x4885, _ctx); /*char*/
  if (kk_yielding(kk_context())) {
    kk_box_t _x4887 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_phexdouble_fun4888(_ctx), _ctx); /*3858*/
    _x4884 = kk_integer_unbox(_x4887); /*int*/
  }
  else {
    _x4884 = kk_std_num_double__mlift3910_phexdouble(x5_3989, _ctx); /*int*/
  }
  return kk_integer_box(_x4884);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun4891__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_phexdouble_fun4891(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun4891(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_phexdouble_fun4891, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double_phexdouble_fun4891(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_integer_box(kk_integer_from_small(0));
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun4892__t {
  struct kk_function_s _base;
  kk_string_t frac;
  kk_string_t x1_3978;
};
static double kk_std_num_double_phexdouble_fun4892(kk_function_t _fself, kk_integer_t exp, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun4892(kk_string_t frac, kk_string_t x1_3978, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun4892__t* _self = kk_function_alloc_as(struct kk_std_num_double_phexdouble_fun4892__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_phexdouble_fun4892, kk_context());
  _self->frac = frac;
  _self->x1_3978 = x1_3978;
  return &_self->_base;
}

static double kk_std_num_double_phexdouble_fun4892(kk_function_t _fself, kk_integer_t exp, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun4892__t* _self = kk_function_as(struct kk_std_num_double_phexdouble_fun4892__t*, _fself);
  kk_string_t frac = _self->frac; /* string */
  kk_string_t x1_3978 = _self->x1_3978; /* string */
  kk_drop_match(_self, {kk_string_dup(frac);kk_string_dup(x1_3978);}, {}, _ctx)
  return kk_std_num_double__mlift3911_phexdouble(frac, x1_3978, exp, _ctx);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun4894__t {
  struct kk_function_s _base;
  kk_function_t _b_4306_4280;
};
static kk_box_t kk_std_num_double_phexdouble_fun4894(kk_function_t _fself, kk_box_t _b_4281, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun4894(kk_function_t _b_4306_4280, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun4894__t* _self = kk_function_alloc_as(struct kk_std_num_double_phexdouble_fun4894__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_phexdouble_fun4894, kk_context());
  _self->_b_4306_4280 = _b_4306_4280;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_phexdouble_fun4894(kk_function_t _fself, kk_box_t _b_4281, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun4894__t* _self = kk_function_as(struct kk_std_num_double_phexdouble_fun4894__t*, _fself);
  kk_function_t _b_4306_4280 = _self->_b_4306_4280; /* (exp : int) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4306_4280);}, {}, _ctx)
  double _x4895;
  kk_integer_t _x4896 = kk_integer_unbox(_b_4281); /*int*/
  _x4895 = kk_function_call(double, (kk_function_t, kk_integer_t, kk_context_t*), _b_4306_4280, (_b_4306_4280, _x4896, _ctx)); /*double*/
  return kk_double_box(_x4895, _ctx);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun4899__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_phexdouble_fun4899(kk_function_t _fself, kk_box_t _b_4287, kk_box_t _b_4288, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun4899(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_phexdouble_fun4899, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double_phexdouble_fun4899(kk_function_t _fself, kk_box_t _b_4287, kk_box_t _b_4288, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_std_core_types__maybe _x4900;
  kk_string_t s_4307 = kk_string_unbox(_b_4287); /*string*/;
  kk_std_core_types__optional hex_4308 = kk_std_core_types__optional_unbox(_b_4288, _ctx); /*optional<bool>*/;
  kk_string_t _x4901;
  kk_string_t _x4902 = kk_string_trim_left(s_4307,kk_context()); /*string*/
  _x4901 = kk_string_trim_right(_x4902,kk_context()); /*string*/
  bool _x4903;
  if (kk_std_core_types__is_Optional(hex_4308)) {
    kk_box_t _box_x4282 = hex_4308._cons.Optional.value;
    bool _hex_15437 = kk_bool_unbox(_box_x4282);
    kk_std_core_types__optional_drop(hex_4308, _ctx);
    kk_Unit;
    _x4903 = _hex_15437; /*bool*/
    goto _match4904;
  }
  _x4903 = false; /*bool*/
  _match4904: ;
  _x4900 = kk_std_core_xparse_int(_x4901, _x4903, _ctx); /*maybe<int>*/
  return kk_std_core_types__maybe_box(_x4900, _ctx);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun4911__t {
  struct kk_function_s _base;
};
static double kk_std_num_double_phexdouble_fun4911(kk_function_t _fself, kk_integer_t man0, kk_integer_t exp00, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun4911(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_phexdouble_fun4911, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double_phexdouble_fun4911(kk_function_t _fself, kk_integer_t man0, kk_integer_t exp00, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x4912;
  double _borrowApp_4453 = kk_integer_as_double_borrow(man0); /*double*/;
  kk_integer_drop(man0, _ctx);
  _x4912 = _borrowApp_4453; /*double*/
  return kk_std_num_double_ldexp(_x4912, exp00, _ctx);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun4914__t {
  struct kk_function_s _base;
  kk_function_t _b_4309_4297;
};
static kk_box_t kk_std_num_double_phexdouble_fun4914(kk_function_t _fself, kk_box_t _b_4300, kk_box_t _b_4301, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun4914(kk_function_t _b_4309_4297, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun4914__t* _self = kk_function_alloc_as(struct kk_std_num_double_phexdouble_fun4914__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_phexdouble_fun4914, kk_context());
  _self->_b_4309_4297 = _b_4309_4297;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_phexdouble_fun4914(kk_function_t _fself, kk_box_t _b_4300, kk_box_t _b_4301, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun4914__t* _self = kk_function_as(struct kk_std_num_double_phexdouble_fun4914__t*, _fself);
  kk_function_t _b_4309_4297 = _self->_b_4309_4297; /* (man0 : int, exp00 : int) -> double */
  kk_drop_match(_self, {kk_function_dup(_b_4309_4297);}, {}, _ctx)
  double _x4915;
  kk_integer_t _x4916 = kk_integer_unbox(_b_4300); /*int*/
  kk_integer_t _x4917 = kk_integer_unbox(_b_4301); /*int*/
  _x4915 = kk_function_call(double, (kk_function_t, kk_integer_t, kk_integer_t, kk_context_t*), _b_4309_4297, (_b_4309_4297, _x4916, _x4917, _ctx)); /*double*/
  return kk_double_box(_x4915, _ctx);
}

double kk_std_num_double_phexdouble(kk_context_t* _ctx) { /* () -> std/text/parse/parse double */ 
  kk_char_t x_3972 = kk_std_text_parse_char('0', _ctx); /*char*/;
  if (kk_yielding(kk_context())) {
    kk_function_t _b_4302_4258 = kk_std_num_double_new_phexdouble_fun4846(_ctx); /*(wild_ : char) -> std/text/parse/parse double*/;
    kk_box_t _x4847 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_phexdouble_fun4848(_b_4302_4258, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x4847, _ctx);
  }
  kk_char_t x0_3975;
  kk_string_t _x4851;
  kk_define_string_literal(, _s4852, 2, "xX")
  _x4851 = kk_string_dup(_s4852); /*string*/
  x0_3975 = kk_std_text_parse_one_of(_x4851, _ctx); /*char*/
  if (kk_yielding(kk_context())) {
    kk_function_t _b_4303_4260 = kk_std_num_double_new_phexdouble_fun4854(_ctx); /*(wild_0 : char) -> std/text/parse/parse double*/;
    kk_box_t _x4855 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_phexdouble_fun4856(_b_4303_4260, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x4855, _ctx);
  }
  kk_string_t x1_3978 = kk_std_text_parse_hex_digits(_ctx); /*string*/;
  if (kk_yielding(kk_context())) {
    kk_string_drop(x1_3978, _ctx);
    kk_function_t _b_4304_4262 = kk_std_num_double_new_phexdouble_fun4860(_ctx); /*(man : string) -> std/text/parse/parse double*/;
    kk_box_t _x4861 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_phexdouble_fun4862(_b_4304_4262, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x4861, _ctx);
  }
  kk_string_t x2_3981;
  kk_box_t _x4865 = kk_std_text_parse__lp__bar__bar__rp_(kk_std_num_double_new_phexdouble_fun4866(_ctx), kk_std_num_double_new_phexdouble_fun4872(_ctx), _ctx); /*946*/
  x2_3981 = kk_string_unbox(_x4865); /*string*/
  if (kk_yielding(kk_context())) {
    kk_string_drop(x2_3981, _ctx);
    kk_function_t _b_4305_4271 = kk_std_num_double_new_phexdouble_fun4875(x1_3978, _ctx); /*(string) -> std/text/parse/parse double*/;
    kk_box_t _x4876 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_phexdouble_fun4877(_b_4305_4271, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x4876, _ctx);
  }
  kk_string_t frac;
  kk_string_t _x4880;
  kk_define_string_literal(, _s4881, 1, "0")
  _x4880 = kk_string_dup(_s4881); /*string*/
  frac = kk_std_core_trim_right_1(x2_3981, _x4880, _ctx); /*string*/
  kk_integer_t x4_3986;
  kk_box_t _x4882 = kk_std_text_parse__lp__bar__bar__rp_(kk_std_num_double_new_phexdouble_fun4883(_ctx), kk_std_num_double_new_phexdouble_fun4891(_ctx), _ctx); /*946*/
  x4_3986 = kk_integer_unbox(_x4882); /*int*/
  if (kk_yielding(kk_context())) {
    kk_integer_drop(x4_3986, _ctx);
    kk_function_t _b_4306_4280 = kk_std_num_double_new_phexdouble_fun4892(frac, x1_3978, _ctx); /*(exp : int) -> std/text/parse/parse double*/;
    kk_box_t _x4893 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_phexdouble_fun4894(_b_4306_4280, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x4893, _ctx);
  }
  kk_string_t _x1;
  kk_string_t _x4897 = kk_string_dup(frac); /*string*/
  _x1 = kk_std_core__lp__plus__plus__1_rp_(x1_3978, _x4897, _ctx); /*string*/
  kk_std_core_types__maybe _b_4291_4289;
  kk_box_t _x4898;
  kk_box_t _x4906;
  kk_std_core_types__optional _x4907 = kk_std_core_types__new_Optional(kk_bool_box(true), _ctx); /*optional<106>*/
  _x4906 = kk_std_core_types__optional_box(_x4907, _ctx); /*3380*/
  _x4898 = kk_std_core_hnd__open_none2(kk_std_num_double_new_phexdouble_fun4899(_ctx), kk_string_box(_x1), _x4906, _ctx); /*3381*/
  _b_4291_4289 = kk_std_core_types__maybe_unbox(_x4898, _ctx); /*maybe<int>*/
  kk_integer_t m;
  kk_box_t _x4908 = kk_std_core_default(_b_4291_4289, kk_integer_box(kk_integer_from_small(0)), _ctx); /*2300*/
  m = kk_integer_unbox(_x4908); /*int*/
  kk_integer_t e;
  kk_integer_t _x4909;
  kk_integer_t _x4910 = kk_std_core_count_1(frac, _ctx); /*int*/
  _x4909 = kk_integer_mul((kk_integer_from_small(4)),_x4910,kk_context()); /*int*/
  e = kk_integer_sub(x4_3986,_x4909,kk_context()); /*int*/
  kk_function_t _b_4309_4297 = kk_std_num_double_new_phexdouble_fun4911(_ctx); /*(man0 : int, exp00 : int) -> double*/;
  kk_integer_t _b_4310_4298 = m; /*int*/;
  kk_integer_t _b_4311_4299 = e; /*int*/;
  kk_box_t _x4913 = kk_std_core_hnd__open_none2(kk_std_num_double_new_phexdouble_fun4914(_b_4309_4297, _ctx), kk_integer_box(_b_4310_4298), kk_integer_box(_b_4311_4299), _ctx); /*3381*/
  return kk_double_unbox(_x4913, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pspecial_fun4918__t {
  struct kk_function_s _base;
};
static double kk_std_num_double_pspecial_fun4918(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pspecial_fun4918(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pspecial_fun4918, _ctx)
  return kk_function_dup(_fself);
}



// lift anonymous function
struct kk_std_num_double_pspecial_fun4922__t {
  struct kk_function_s _base;
};
static double kk_std_num_double_pspecial_fun4922(kk_function_t _fself, kk_string_t _x14921, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pspecial_fun4922(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pspecial_fun4922, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double_pspecial_fun4922(kk_function_t _fself, kk_string_t _x14921, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_num_double__mlift3917_pspecial(_x14921, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pspecial_fun4924__t {
  struct kk_function_s _base;
  kk_function_t _b_4331_4312;
};
static kk_box_t kk_std_num_double_pspecial_fun4924(kk_function_t _fself, kk_box_t _b_4313, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pspecial_fun4924(kk_function_t _b_4331_4312, kk_context_t* _ctx) {
  struct kk_std_num_double_pspecial_fun4924__t* _self = kk_function_alloc_as(struct kk_std_num_double_pspecial_fun4924__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pspecial_fun4924, kk_context());
  _self->_b_4331_4312 = _b_4331_4312;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pspecial_fun4924(kk_function_t _fself, kk_box_t _b_4313, kk_context_t* _ctx) {
  struct kk_std_num_double_pspecial_fun4924__t* _self = kk_function_as(struct kk_std_num_double_pspecial_fun4924__t*, _fself);
  kk_function_t _b_4331_4312 = _self->_b_4331_4312; /* (wild_ : string) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4331_4312);}, {}, _ctx)
  double _x4925;
  kk_string_t _x4926 = kk_string_unbox(_b_4313); /*string*/
  _x4925 = kk_function_call(double, (kk_function_t, kk_string_t, kk_context_t*), _b_4331_4312, (_b_4331_4312, _x4926, _ctx)); /*double*/
  return kk_double_box(_x4925, _ctx);
}
static double kk_std_num_double_pspecial_fun4918(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t x_3991;
  kk_string_t _x4919;
  kk_define_string_literal(, _s4920, 3, "nan")
  _x4919 = kk_string_dup(_s4920); /*string*/
  x_3991 = kk_std_text_parse_pstring(_x4919, _ctx); /*string*/
  if (kk_yielding(kk_context())) {
    kk_string_drop(x_3991, _ctx);
    kk_function_t _b_4331_4312 = kk_std_num_double_new_pspecial_fun4922(_ctx); /*(wild_ : string) -> std/text/parse/parse double*/;
    kk_box_t _x4923 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_pspecial_fun4924(_b_4331_4312, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x4923, _ctx);
  }
  return kk_std_num_double__mlift3917_pspecial(x_3991, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pspecial_fun4927__t {
  struct kk_function_s _base;
};
static double kk_std_num_double_pspecial_fun4927(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pspecial_fun4927(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pspecial_fun4927, _ctx)
  return kk_function_dup(_fself);
}



// lift anonymous function
struct kk_std_num_double_pspecial_fun4931__t {
  struct kk_function_s _base;
};
static double kk_std_num_double_pspecial_fun4931(kk_function_t _fself, kk_string_t _x14930, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pspecial_fun4931(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pspecial_fun4931, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double_pspecial_fun4931(kk_function_t _fself, kk_string_t _x14930, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_num_double__mlift3918_pspecial(_x14930, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pspecial_fun4933__t {
  struct kk_function_s _base;
  kk_function_t _b_4334_4314;
};
static kk_box_t kk_std_num_double_pspecial_fun4933(kk_function_t _fself, kk_box_t _b_4315, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pspecial_fun4933(kk_function_t _b_4334_4314, kk_context_t* _ctx) {
  struct kk_std_num_double_pspecial_fun4933__t* _self = kk_function_alloc_as(struct kk_std_num_double_pspecial_fun4933__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pspecial_fun4933, kk_context());
  _self->_b_4334_4314 = _b_4334_4314;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pspecial_fun4933(kk_function_t _fself, kk_box_t _b_4315, kk_context_t* _ctx) {
  struct kk_std_num_double_pspecial_fun4933__t* _self = kk_function_as(struct kk_std_num_double_pspecial_fun4933__t*, _fself);
  kk_function_t _b_4334_4314 = _self->_b_4334_4314; /* (wild_0 : string) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4334_4314);}, {}, _ctx)
  double _x4934;
  kk_string_t _x4935 = kk_string_unbox(_b_4315); /*string*/
  _x4934 = kk_function_call(double, (kk_function_t, kk_string_t, kk_context_t*), _b_4334_4314, (_b_4334_4314, _x4935, _ctx)); /*double*/
  return kk_double_box(_x4934, _ctx);
}
static double kk_std_num_double_pspecial_fun4927(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t x0_3993;
  kk_string_t _x4928;
  kk_define_string_literal(, _s4929, 8, "infinity")
  _x4928 = kk_string_dup(_s4929); /*string*/
  x0_3993 = kk_std_text_parse_pstring(_x4928, _ctx); /*string*/
  if (kk_yielding(kk_context())) {
    kk_string_drop(x0_3993, _ctx);
    kk_function_t _b_4334_4314 = kk_std_num_double_new_pspecial_fun4931(_ctx); /*(wild_0 : string) -> std/text/parse/parse double*/;
    kk_box_t _x4932 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_pspecial_fun4933(_b_4334_4314, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x4932, _ctx);
  }
  return kk_std_num_double__mlift3918_pspecial(x0_3993, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pspecial_fun4936__t {
  struct kk_function_s _base;
};
static double kk_std_num_double_pspecial_fun4936(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pspecial_fun4936(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pspecial_fun4936, _ctx)
  return kk_function_dup(_fself);
}



// lift anonymous function
struct kk_std_num_double_pspecial_fun4940__t {
  struct kk_function_s _base;
};
static double kk_std_num_double_pspecial_fun4940(kk_function_t _fself, kk_string_t _x14939, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pspecial_fun4940(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pspecial_fun4940, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double_pspecial_fun4940(kk_function_t _fself, kk_string_t _x14939, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_num_double__mlift3919_pspecial(_x14939, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pspecial_fun4942__t {
  struct kk_function_s _base;
  kk_function_t _b_4337_4316;
};
static kk_box_t kk_std_num_double_pspecial_fun4942(kk_function_t _fself, kk_box_t _b_4317, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pspecial_fun4942(kk_function_t _b_4337_4316, kk_context_t* _ctx) {
  struct kk_std_num_double_pspecial_fun4942__t* _self = kk_function_alloc_as(struct kk_std_num_double_pspecial_fun4942__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pspecial_fun4942, kk_context());
  _self->_b_4337_4316 = _b_4337_4316;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pspecial_fun4942(kk_function_t _fself, kk_box_t _b_4317, kk_context_t* _ctx) {
  struct kk_std_num_double_pspecial_fun4942__t* _self = kk_function_as(struct kk_std_num_double_pspecial_fun4942__t*, _fself);
  kk_function_t _b_4337_4316 = _self->_b_4337_4316; /* (wild_1 : string) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4337_4316);}, {}, _ctx)
  double _x4943;
  kk_string_t _x4944 = kk_string_unbox(_b_4317); /*string*/
  _x4943 = kk_function_call(double, (kk_function_t, kk_string_t, kk_context_t*), _b_4337_4316, (_b_4337_4316, _x4944, _ctx)); /*double*/
  return kk_double_box(_x4943, _ctx);
}
static double kk_std_num_double_pspecial_fun4936(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t x1_3995;
  kk_string_t _x4937;
  kk_define_string_literal(, _s4938, 3, "inf")
  _x4937 = kk_string_dup(_s4938); /*string*/
  x1_3995 = kk_std_text_parse_pstring(_x4937, _ctx); /*string*/
  if (kk_yielding(kk_context())) {
    kk_string_drop(x1_3995, _ctx);
    kk_function_t _b_4337_4316 = kk_std_num_double_new_pspecial_fun4940(_ctx); /*(wild_1 : string) -> std/text/parse/parse double*/;
    kk_box_t _x4941 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_pspecial_fun4942(_b_4337_4316, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x4941, _ctx);
  }
  return kk_std_num_double__mlift3919_pspecial(x1_3995, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pspecial_fun4945__t {
  struct kk_function_s _base;
  kk_function_t _b_4335_4318;
};
static kk_box_t kk_std_num_double_pspecial_fun4945(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pspecial_fun4945(kk_function_t _b_4335_4318, kk_context_t* _ctx) {
  struct kk_std_num_double_pspecial_fun4945__t* _self = kk_function_alloc_as(struct kk_std_num_double_pspecial_fun4945__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pspecial_fun4945, kk_context());
  _self->_b_4335_4318 = _b_4335_4318;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pspecial_fun4945(kk_function_t _fself, kk_context_t* _ctx) {
  struct kk_std_num_double_pspecial_fun4945__t* _self = kk_function_as(struct kk_std_num_double_pspecial_fun4945__t*, _fself);
  kk_function_t _b_4335_4318 = _self->_b_4335_4318; /* () -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4335_4318);}, {}, _ctx)
  double _x4946 = kk_function_call(double, (kk_function_t, kk_context_t*), _b_4335_4318, (_b_4335_4318, _ctx)); /*double*/
  return kk_double_box(_x4946, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pspecial_fun4947__t {
  struct kk_function_s _base;
  kk_function_t _b_4332_4321;
};
static kk_box_t kk_std_num_double_pspecial_fun4947(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pspecial_fun4947(kk_function_t _b_4332_4321, kk_context_t* _ctx) {
  struct kk_std_num_double_pspecial_fun4947__t* _self = kk_function_alloc_as(struct kk_std_num_double_pspecial_fun4947__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pspecial_fun4947, kk_context());
  _self->_b_4332_4321 = _b_4332_4321;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pspecial_fun4947(kk_function_t _fself, kk_context_t* _ctx) {
  struct kk_std_num_double_pspecial_fun4947__t* _self = kk_function_as(struct kk_std_num_double_pspecial_fun4947__t*, _fself);
  kk_function_t _b_4332_4321 = _self->_b_4332_4321; /* () -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4332_4321);}, {}, _ctx)
  double _x4948 = kk_function_call(double, (kk_function_t, kk_context_t*), _b_4332_4321, (_b_4332_4321, _ctx)); /*double*/
  return kk_double_box(_x4948, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pspecial_fun4949__t {
  struct kk_function_s _base;
  kk_function_t _b_4329_4324;
};
static kk_box_t kk_std_num_double_pspecial_fun4949(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pspecial_fun4949(kk_function_t _b_4329_4324, kk_context_t* _ctx) {
  struct kk_std_num_double_pspecial_fun4949__t* _self = kk_function_alloc_as(struct kk_std_num_double_pspecial_fun4949__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pspecial_fun4949, kk_context());
  _self->_b_4329_4324 = _b_4329_4324;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pspecial_fun4949(kk_function_t _fself, kk_context_t* _ctx) {
  struct kk_std_num_double_pspecial_fun4949__t* _self = kk_function_as(struct kk_std_num_double_pspecial_fun4949__t*, _fself);
  kk_function_t _b_4329_4324 = _self->_b_4329_4324; /* () -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4329_4324);}, {}, _ctx)
  double _x4950 = kk_function_call(double, (kk_function_t, kk_context_t*), _b_4329_4324, (_b_4329_4324, _ctx)); /*double*/
  return kk_double_box(_x4950, _ctx);
}

double kk_std_num_double_pspecial(kk_context_t* _ctx) { /* () -> std/text/parse/parse double */ 
  kk_std_core__list _b_4328_4327;
  kk_function_t _b_4329_4324 = kk_std_num_double_new_pspecial_fun4918(_ctx); /*() -> std/text/parse/parse double*/;
  kk_std_core__list _b_4330_4325;
  kk_function_t _b_4332_4321 = kk_std_num_double_new_pspecial_fun4927(_ctx); /*() -> std/text/parse/parse double*/;
  kk_std_core__list _b_4333_4322;
  kk_function_t _b_4335_4318 = kk_std_num_double_new_pspecial_fun4936(_ctx); /*() -> std/text/parse/parse double*/;
  kk_std_core__list _b_4336_4319 = kk_std_core__new_Nil(_ctx); /*list<() -> std/text/parse/parse double>*/;
  _b_4333_4322 = kk_std_core__new_Cons(kk_reuse_null, kk_function_box(kk_std_num_double_new_pspecial_fun4945(_b_4335_4318, _ctx)), _b_4336_4319, _ctx); /*list<() -> std/text/parse/parse double>*/
  _b_4330_4325 = kk_std_core__new_Cons(kk_reuse_null, kk_function_box(kk_std_num_double_new_pspecial_fun4947(_b_4332_4321, _ctx)), _b_4333_4322, _ctx); /*list<() -> std/text/parse/parse double>*/
  _b_4328_4327 = kk_std_core__new_Cons(kk_reuse_null, kk_function_box(kk_std_num_double_new_pspecial_fun4949(_b_4329_4324, _ctx)), _b_4330_4325, _ctx); /*list<() -> std/text/parse/parse double>*/
  kk_box_t _x4951 = kk_std_text_parse_choose(_b_4328_4327, _ctx); /*770*/
  return kk_double_unbox(_x4951, _ctx);
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_double__mlift3921_pdouble_fun4954__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3921_pdouble_fun4954(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3921_pdouble_fun4954(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3921_pdouble_fun4954, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double__mlift3921_pdouble_fun4954(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x4955 = kk_std_num_double_phexdouble(_ctx); /*double*/
  return kk_double_box(_x4955, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3921_pdouble_fun4957__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3921_pdouble_fun4957(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3921_pdouble_fun4957(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3921_pdouble_fun4957, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double__mlift3921_pdouble_fun4957(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x4958 = kk_std_num_double_pdecdouble(_ctx); /*double*/
  return kk_double_box(_x4958, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3921_pdouble_fun4960__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3921_pdouble_fun4960(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3921_pdouble_fun4960(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3921_pdouble_fun4960, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double__mlift3921_pdouble_fun4960(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x4961 = kk_std_num_double_pspecial(_ctx); /*double*/
  return kk_double_box(_x4961, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3921_pdouble_fun4963__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3921_pdouble_fun4963(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3921_pdouble_fun4963(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3921_pdouble_fun4963, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double__mlift3921_pdouble_fun4963(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_double_box(0.0, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3921_pdouble_fun4964__t {
  struct kk_function_s _base;
  bool neg;
};
static double kk_std_num_double__mlift3921_pdouble_fun4964(kk_function_t _fself, double d, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3921_pdouble_fun4964(bool neg, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3921_pdouble_fun4964__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3921_pdouble_fun4964__t, 1, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3921_pdouble_fun4964, kk_context());
  _self->neg = neg;
  return &_self->_base;
}

static double kk_std_num_double__mlift3921_pdouble_fun4964(kk_function_t _fself, double d, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3921_pdouble_fun4964__t* _self = kk_function_as(struct kk_std_num_double__mlift3921_pdouble_fun4964__t*, _fself);
  bool neg = _self->neg; /* bool */
  kk_drop_match(_self, {;}, {}, _ctx)
  if (neg) {
    return (-d);
  }
  return d;
}


// lift anonymous function
struct kk_std_num_double__mlift3921_pdouble_fun4966__t {
  struct kk_function_s _base;
  kk_function_t _b_4362_4360;
};
static kk_box_t kk_std_num_double__mlift3921_pdouble_fun4966(kk_function_t _fself, kk_box_t _b_4361, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3921_pdouble_fun4966(kk_function_t _b_4362_4360, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3921_pdouble_fun4966__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3921_pdouble_fun4966__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3921_pdouble_fun4966, kk_context());
  _self->_b_4362_4360 = _b_4362_4360;
  return &_self->_base;
}

static kk_box_t kk_std_num_double__mlift3921_pdouble_fun4966(kk_function_t _fself, kk_box_t _b_4361, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3921_pdouble_fun4966__t* _self = kk_function_as(struct kk_std_num_double__mlift3921_pdouble_fun4966__t*, _fself);
  kk_function_t _b_4362_4360 = _self->_b_4362_4360; /* (double) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4362_4360);}, {}, _ctx)
  double _x4967;
  double _x4968 = kk_double_unbox(_b_4361, _ctx); /*double*/
  _x4967 = kk_function_call(double, (kk_function_t, double, kk_context_t*), _b_4362_4360, (_b_4362_4360, _x4968, _ctx)); /*double*/
  return kk_double_box(_x4967, _ctx);
}

double kk_std_num_double__mlift3921_pdouble(kk_char_t c, kk_context_t* _ctx) { /* (c : char) -> std/text/parse/parse double */ 
  bool neg = (c == ('-')); /*bool*/;
  double x_3997;
  kk_box_t _x4952;
  kk_std_core__list _x4953;
  kk_std_core__list _x4956;
  kk_std_core__list _x4959;
  kk_std_core__list _x4962 = kk_std_core__new_Cons(kk_reuse_null, kk_function_box(kk_std_num_double__new_mlift3921_pdouble_fun4963(_ctx)), kk_std_core__new_Nil(_ctx), _ctx); /*list<61>*/
  _x4959 = kk_std_core__new_Cons(kk_reuse_null, kk_function_box(kk_std_num_double__new_mlift3921_pdouble_fun4960(_ctx)), _x4962, _ctx); /*list<61>*/
  _x4956 = kk_std_core__new_Cons(kk_reuse_null, kk_function_box(kk_std_num_double__new_mlift3921_pdouble_fun4957(_ctx)), _x4959, _ctx); /*list<61>*/
  _x4953 = kk_std_core__new_Cons(kk_reuse_null, kk_function_box(kk_std_num_double__new_mlift3921_pdouble_fun4954(_ctx)), _x4956, _ctx); /*list<61>*/
  _x4952 = kk_std_text_parse_choose(_x4953, _ctx); /*770*/
  x_3997 = kk_double_unbox(_x4952, _ctx); /*double*/
  kk_function_t next_3998 = kk_std_num_double__new_mlift3921_pdouble_fun4964(neg, _ctx); /*(double) -> std/text/parse/parse double*/;
  if (kk_yielding(kk_context())) {
    kk_function_t _b_4362_4360 = next_3998; /*(double) -> std/text/parse/parse double*/;
    kk_box_t _x4965 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3921_pdouble_fun4966(_b_4362_4360, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x4965, _ctx);
  }
  return kk_function_call(double, (kk_function_t, double, kk_context_t*), next_3998, (next_3998, x_3997, _ctx));
}


// lift anonymous function
struct kk_std_num_double_pdouble_fun4970__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_pdouble_fun4970(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdouble_fun4970(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdouble_fun4970, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double_pdouble_fun4970(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_char_t _x4971;
  kk_string_t _x4972;
  kk_define_string_literal(, _s4973, 2, "+-")
  _x4972 = kk_string_dup(_s4973); /*string*/
  _x4971 = kk_std_text_parse_one_of(_x4972, _ctx); /*char*/
  return kk_char_box(_x4971, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdouble_fun4974__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_pdouble_fun4974(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdouble_fun4974(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdouble_fun4974, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double_pdouble_fun4974(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_char_box('+', _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdouble_fun4976__t {
  struct kk_function_s _base;
};
static double kk_std_num_double_pdouble_fun4976(kk_function_t _fself, kk_char_t _x14975, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdouble_fun4976(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdouble_fun4976, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double_pdouble_fun4976(kk_function_t _fself, kk_char_t _x14975, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_num_double__mlift3921_pdouble(_x14975, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdouble_fun4978__t {
  struct kk_function_s _base;
  kk_function_t _b_4393_4367;
};
static kk_box_t kk_std_num_double_pdouble_fun4978(kk_function_t _fself, kk_box_t _b_4368, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdouble_fun4978(kk_function_t _b_4393_4367, kk_context_t* _ctx) {
  struct kk_std_num_double_pdouble_fun4978__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdouble_fun4978__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdouble_fun4978, kk_context());
  _self->_b_4393_4367 = _b_4393_4367;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pdouble_fun4978(kk_function_t _fself, kk_box_t _b_4368, kk_context_t* _ctx) {
  struct kk_std_num_double_pdouble_fun4978__t* _self = kk_function_as(struct kk_std_num_double_pdouble_fun4978__t*, _fself);
  kk_function_t _b_4393_4367 = _self->_b_4393_4367; /* (c : char) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4393_4367);}, {}, _ctx)
  double _x4979;
  kk_char_t _x4980 = kk_char_unbox(_b_4368, _ctx); /*char*/
  _x4979 = kk_function_call(double, (kk_function_t, kk_char_t, kk_context_t*), _b_4393_4367, (_b_4393_4367, _x4980, _ctx)); /*double*/
  return kk_double_box(_x4979, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdouble_fun4983__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_pdouble_fun4983(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdouble_fun4983(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdouble_fun4983, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double_pdouble_fun4983(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x4984 = kk_std_num_double_phexdouble(_ctx); /*double*/
  return kk_double_box(_x4984, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdouble_fun4986__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_pdouble_fun4986(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdouble_fun4986(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdouble_fun4986, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double_pdouble_fun4986(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x4987 = kk_std_num_double_pdecdouble(_ctx); /*double*/
  return kk_double_box(_x4987, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdouble_fun4989__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_pdouble_fun4989(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdouble_fun4989(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdouble_fun4989, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double_pdouble_fun4989(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x4990 = kk_std_num_double_pspecial(_ctx); /*double*/
  return kk_double_box(_x4990, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdouble_fun4992__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_pdouble_fun4992(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdouble_fun4992(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdouble_fun4992, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double_pdouble_fun4992(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_double_box(0.0, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdouble_fun4993__t {
  struct kk_function_s _base;
  bool neg;
};
static double kk_std_num_double_pdouble_fun4993(kk_function_t _fself, double d, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdouble_fun4993(bool neg, kk_context_t* _ctx) {
  struct kk_std_num_double_pdouble_fun4993__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdouble_fun4993__t, 1, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdouble_fun4993, kk_context());
  _self->neg = neg;
  return &_self->_base;
}

static double kk_std_num_double_pdouble_fun4993(kk_function_t _fself, double d, kk_context_t* _ctx) {
  struct kk_std_num_double_pdouble_fun4993__t* _self = kk_function_as(struct kk_std_num_double_pdouble_fun4993__t*, _fself);
  bool neg = _self->neg; /* bool */
  kk_drop_match(_self, {;}, {}, _ctx)
  if (neg) {
    return (-d);
  }
  return d;
}


// lift anonymous function
struct kk_std_num_double_pdouble_fun4995__t {
  struct kk_function_s _base;
  kk_function_t _b_4394_4391;
};
static kk_box_t kk_std_num_double_pdouble_fun4995(kk_function_t _fself, kk_box_t _b_4392, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdouble_fun4995(kk_function_t _b_4394_4391, kk_context_t* _ctx) {
  struct kk_std_num_double_pdouble_fun4995__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdouble_fun4995__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdouble_fun4995, kk_context());
  _self->_b_4394_4391 = _b_4394_4391;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pdouble_fun4995(kk_function_t _fself, kk_box_t _b_4392, kk_context_t* _ctx) {
  struct kk_std_num_double_pdouble_fun4995__t* _self = kk_function_as(struct kk_std_num_double_pdouble_fun4995__t*, _fself);
  kk_function_t _b_4394_4391 = _self->_b_4394_4391; /* (d : double) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4394_4391);}, {}, _ctx)
  double _x4996;
  double _x4997 = kk_double_unbox(_b_4392, _ctx); /*double*/
  _x4996 = kk_function_call(double, (kk_function_t, double, kk_context_t*), _b_4394_4391, (_b_4394_4391, _x4997, _ctx)); /*double*/
  return kk_double_box(_x4996, _ctx);
}

double kk_std_num_double_pdouble(kk_context_t* _ctx) { /* () -> std/text/parse/parse double */ 
  kk_char_t x_4001;
  kk_box_t _x4969 = kk_std_text_parse__lp__bar__bar__rp_(kk_std_num_double_new_pdouble_fun4970(_ctx), kk_std_num_double_new_pdouble_fun4974(_ctx), _ctx); /*946*/
  x_4001 = kk_char_unbox(_x4969, _ctx); /*char*/
  if (kk_yielding(kk_context())) {
    kk_function_t _b_4393_4367 = kk_std_num_double_new_pdouble_fun4976(_ctx); /*(c : char) -> std/text/parse/parse double*/;
    kk_box_t _x4977 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_pdouble_fun4978(_b_4393_4367, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x4977, _ctx);
  }
  bool neg = (x_4001 == ('-')); /*bool*/;
  double x0_4004;
  kk_box_t _x4981;
  kk_std_core__list _x4982;
  kk_std_core__list _x4985;
  kk_std_core__list _x4988;
  kk_std_core__list _x4991 = kk_std_core__new_Cons(kk_reuse_null, kk_function_box(kk_std_num_double_new_pdouble_fun4992(_ctx)), kk_std_core__new_Nil(_ctx), _ctx); /*list<61>*/
  _x4988 = kk_std_core__new_Cons(kk_reuse_null, kk_function_box(kk_std_num_double_new_pdouble_fun4989(_ctx)), _x4991, _ctx); /*list<61>*/
  _x4985 = kk_std_core__new_Cons(kk_reuse_null, kk_function_box(kk_std_num_double_new_pdouble_fun4986(_ctx)), _x4988, _ctx); /*list<61>*/
  _x4982 = kk_std_core__new_Cons(kk_reuse_null, kk_function_box(kk_std_num_double_new_pdouble_fun4983(_ctx)), _x4985, _ctx); /*list<61>*/
  _x4981 = kk_std_text_parse_choose(_x4982, _ctx); /*770*/
  x0_4004 = kk_double_unbox(_x4981, _ctx); /*double*/
  if (kk_yielding(kk_context())) {
    kk_function_t _b_4394_4391 = kk_std_num_double_new_pdouble_fun4993(neg, _ctx); /*(d : double) -> std/text/parse/parse double*/;
    kk_box_t _x4994 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_pdouble_fun4995(_b_4394_4391, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x4994, _ctx);
  }
  if (neg) {
    return (-x0_4004);
  }
  return x0_4004;
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_double__mlift3923_parse_double_fun4998__t {
  struct kk_function_s _base;
  double x;
};
static double kk_std_num_double__mlift3923_parse_double_fun4998(kk_function_t _fself, kk_unit_t wild__, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3923_parse_double_fun4998(double x, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3923_parse_double_fun4998__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3923_parse_double_fun4998__t, 1, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3923_parse_double_fun4998, kk_context());
  _self->x = x;
  return &_self->_base;
}

static double kk_std_num_double__mlift3923_parse_double_fun4998(kk_function_t _fself, kk_unit_t wild__, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3923_parse_double_fun4998__t* _self = kk_function_as(struct kk_std_num_double__mlift3923_parse_double_fun4998__t*, _fself);
  double x = _self->x; /* double */
  kk_drop_match(_self, {;}, {}, _ctx)
  return x;
}


// lift anonymous function
struct kk_std_num_double__mlift3923_parse_double_fun5000__t {
  struct kk_function_s _base;
  kk_function_t _b_4397_4395;
};
static kk_box_t kk_std_num_double__mlift3923_parse_double_fun5000(kk_function_t _fself, kk_box_t _b_4396, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3923_parse_double_fun5000(kk_function_t _b_4397_4395, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3923_parse_double_fun5000__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3923_parse_double_fun5000__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3923_parse_double_fun5000, kk_context());
  _self->_b_4397_4395 = _b_4397_4395;
  return &_self->_base;
}

static kk_box_t kk_std_num_double__mlift3923_parse_double_fun5000(kk_function_t _fself, kk_box_t _b_4396, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3923_parse_double_fun5000__t* _self = kk_function_as(struct kk_std_num_double__mlift3923_parse_double_fun5000__t*, _fself);
  kk_function_t _b_4397_4395 = _self->_b_4397_4395; /* (wild_ : ()) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4397_4395);}, {}, _ctx)
  double _x5001;
  kk_unit_t _x5002 = kk_Unit;
  kk_unit_unbox(_b_4396);
  _x5001 = kk_function_call(double, (kk_function_t, kk_unit_t, kk_context_t*), _b_4397_4395, (_b_4397_4395, _x5002, _ctx)); /*double*/
  return kk_double_box(_x5001, _ctx);
}

double kk_std_num_double__mlift3923_parse_double(double x, kk_context_t* _ctx) { /* (x : double) -> std/text/parse/parse double */ 
  kk_unit_t x0_4009 = kk_Unit;
  kk_std_text_parse_eof(_ctx);
  if (kk_yielding(kk_context())) {
    kk_function_t _b_4397_4395 = kk_std_num_double__new_mlift3923_parse_double_fun4998(x, _ctx); /*(wild_ : ()) -> std/text/parse/parse double*/;
    kk_box_t _x4999 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3923_parse_double_fun5000(_b_4397_4395, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x4999, _ctx);
  }
  return x;
}
 
// Parse a double number. Can be "NaN", "Inf(inity)" (case-insensitive),
// a fix-point number (`1.2`) or in scientific notation (`-2.3e-5`).
// Also allows floats in [hexadecimal notation](https://books.google.com/books?id=FgMsCwAAQBAJ&pg=PA41) (`0xA.Fp-10`) that can
// be represented precisely (and are the preferred _round trip_ format).


// lift anonymous function
struct kk_std_num_double_parse_double_fun5008__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_parse_double_fun5008(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_parse_double_fun5008(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_parse_double_fun5008, _ctx)
  return kk_function_dup(_fself);
}



// lift anonymous function
struct kk_std_num_double_parse_double_fun5011__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_parse_double_fun5011(kk_function_t _fself, kk_box_t _b_4399, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_parse_double_fun5011(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_parse_double_fun5011, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double_parse_double_fun5011(kk_function_t _fself, kk_box_t _b_4399, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x5012;
  double _x5013 = kk_double_unbox(_b_4399, _ctx); /*double*/
  _x5012 = kk_std_num_double__mlift3923_parse_double(_x5013, _ctx); /*double*/
  return kk_double_box(_x5012, _ctx);
}
static kk_box_t kk_std_num_double_parse_double_fun5008(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x5009;
  double x_4013 = kk_std_num_double_pdouble(_ctx); /*double*/;
  if (kk_yielding(kk_context())) {
    kk_box_t _x5010 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_parse_double_fun5011(_ctx), _ctx); /*3858*/
    _x5009 = kk_double_unbox(_x5010, _ctx); /*double*/
  }
  else {
    _x5009 = kk_std_num_double__mlift3923_parse_double(x_4013, _ctx); /*double*/
  }
  return kk_double_box(_x5009, _ctx);
}

kk_std_core_types__maybe kk_std_num_double_parse_double(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> maybe<double> */ 
  kk_string_t s0_3865;
  kk_string_t _x5003;
  kk_string_t _x5004 = kk_string_trim_left(s,kk_context()); /*string*/
  _x5003 = kk_string_trim_right(_x5004,kk_context()); /*string*/
  s0_3865 = kk_std_core_to_lower(_x5003, _ctx); /*string*/
  kk_std_core__sslice input_3863;
  kk_string_t _x5005 = kk_string_dup(s0_3865); /*string*/
  kk_ssize_t _x5006 = ((kk_ssize_t)0); /*ssize_t*/
  kk_ssize_t _x5007 = kk_string_len(s0_3865,kk_context()); /*ssize_t*/
  input_3863 = kk_std_core__new_Sslice(_x5005, _x5006, _x5007, _ctx); /*sslice*/
  kk_std_text_parse__parse_error perr_3862 = kk_std_text_parse_parse(input_3863, kk_std_num_double_new_parse_double_fun5008(_ctx), _ctx); /*std/text/parse/parse-error<double>*/;
  if (kk_std_text_parse__is_ParseOk(perr_3862)) {
    struct kk_std_text_parse_ParseOk* _con5014 = kk_std_text_parse__as_ParseOk(perr_3862);
    kk_box_t _box_x4405 = _con5014->result;
    kk_std_core__sslice _pat00 = _con5014->rest;
    double x0 = kk_double_unbox(_box_x4405, NULL);
    if (kk_likely(kk_std_text_parse__parse_error_is_unique(perr_3862))) {
      kk_std_core__sslice_drop(_pat00, _ctx);
      kk_box_drop(_box_x4405, _ctx);
      kk_Unit;
      kk_Unit;
      kk_std_text_parse__parse_error_free(perr_3862);
    }
    else {
      kk_std_text_parse__parse_error_decref(perr_3862, _ctx);
      kk_Unit;
    }
    double _b_4407_4406 = x0; /*double*/;
    return kk_std_core_types__new_Just(kk_double_box(_b_4407_4406, _ctx), _ctx);
  }
  struct kk_std_text_parse_ParseError* _con5016 = kk_std_text_parse__as_ParseError(perr_3862);
  kk_std_core__sslice _pat5 = _con5016->rest;
  kk_std_text_parse__parse_error_dropn(perr_3862, ((int32_t)2), _ctx);
  return kk_std_core_types__new_Nothing(_ctx);
}
 
// Round a double to a specified precision. Rounds to the  even number in case of a tie.
// `123.456.round-to-prec(2) == 123.46`
// `123.456.round-to-prec(-1) == 120.0`

double kk_std_num_double_round_to_prec(double d, kk_integer_t prec, kk_context_t* _ctx) { /* (d : double, prec : int) -> double */ 
  bool _match_4436;
  kk_integer_t _borrowedArg_4438 = kk_integer_from_small(0); /*int*/;
  bool _borrowApp_4439 = kk_integer_lte_borrow(prec,_borrowedArg_4438,kk_context()); /*bool*/;
  kk_integer_drop(_borrowedArg_4438, _ctx);
  _match_4436 = _borrowApp_4439; /*bool*/
  if (_match_4436) {
    kk_integer_drop(prec, _ctx);
    return round(d);
  }
  double p_3867;
  double _borrowApp_4437 = kk_integer_as_double_borrow(prec); /*double*/;
  kk_integer_drop(prec, _ctx);
  p_3867 = _borrowApp_4437; /*double*/
  double p0 = pow((10.0),p_3867); /*double*/;
  double _x5018;
  double _x5019 = (d * p0); /*double*/
  _x5018 = round(_x5019); /*double*/
  return (_x5018 / p0);
}
 
/* Show a double in [hexadecimal notation](https://books.google.com/books?id=FgMsCwAAQBAJ&pg=PA41).
An advantage of this format is that it precisely represents the `:double` and can
reliably (and efficiently) be parsed back, i.e. `d.show-hex.parse-double == Just(d)`.
The significant is the _hexadecimal_ fraction while the
exponent after the `p` is the _decimal_ power of 2.
 For example, ``0xA.Fp-10`` = (10 + 15/16)&middot;2^-10^  (not 2^-16^!) = 0.01068115234375.
 Equivalently, ``0xA.Fp-10 == 0x5.78p-9 == 0x2.BCp-8 == 0x1.5Ep-7``.
```
> dbl-min.show-hex
"0x1.0p-1022"
> 0.1.show-hex
"0x1.999999999999Ap-4"
> dbl-max.show-hex
"0x1.FFFFFFFFFFFFFp+1023"
> -0.0.show-hex
"-0x0.0p+0"
> nan.show-hex
"NaN"
> 0.01068115234375.show-hex
"0x1.5Ep-7"
```
.
*/

kk_string_t kk_std_num_double_show_hex(double d, kk_std_core_types__optional width, kk_std_core_types__optional use_capitals, kk_std_core_types__optional pre, kk_context_t* _ctx) { /* (d : double, width : optional<int>, use-capitals : optional<bool>, pre : optional<string>) -> string */ 
  bool b_3868 = isfinite(d); /*bool*/;
  if (b_3868) {
    kk_std_core_types__tuple2_ _match_4422 = kk_std_num_double_decode(d, _ctx); /*(int, int)*/;
    kk_box_t _box_x4408 = _match_4422.fst;
    kk_box_t _box_x4409 = _match_4422.snd;
    kk_integer_t m = kk_integer_unbox(_box_x4408);
    kk_integer_t e = kk_integer_unbox(_box_x4409);
    kk_integer_dup(e);
    kk_integer_dup(m);
    kk_std_core_types__tuple2__drop(_match_4422, _ctx);
    kk_Unit;
    kk_string_t man;
    kk_integer_t _x5022 = kk_integer_abs(m,kk_context()); /*int*/
    kk_std_core_types__optional _x5023 = kk_std_core_types__new_Optional(kk_integer_box(kk_integer_from_small(1)), _ctx); /*optional<106>*/
    kk_std_core_types__optional _x5024;
    kk_box_t _x5025;
    bool _x5026;
    if (kk_std_core_types__is_Optional(use_capitals)) {
      kk_box_t _box_x4411 = use_capitals._cons.Optional.value;
      bool _use_capitals_3410 = kk_bool_unbox(_box_x4411);
      kk_std_core_types__optional_drop(use_capitals, _ctx);
      kk_Unit;
      _x5026 = _use_capitals_3410; /*bool*/
      goto _match5027;
    }
    _x5026 = true; /*bool*/
    _match5027: ;
    _x5025 = kk_bool_box(_x5026); /*106*/
    _x5024 = kk_std_core_types__new_Optional(_x5025, _ctx); /*optional<106>*/
    kk_std_core_types__optional _x5029;
    kk_box_t _x5030;
    kk_string_t _x5031 = kk_string_empty(); /*string*/
    _x5030 = kk_string_box(_x5031); /*106*/
    _x5029 = kk_std_core_types__new_Optional(_x5030, _ctx); /*optional<106>*/
    man = kk_std_core_show_hex(_x5022, _x5023, _x5024, _x5029, _ctx); /*string*/
    kk_integer_t exp0;
    kk_integer_t _x5033;
    kk_integer_t _x5034;
    kk_integer_t _x5035;
    kk_string_t _x5036 = kk_string_dup(man); /*string*/
    _x5035 = kk_std_core_count_1(_x5036, _ctx); /*int*/
    _x5034 = kk_integer_sub(_x5035,(kk_integer_from_small(1)),kk_context()); /*int*/
    _x5033 = kk_integer_mul((kk_integer_from_small(4)),_x5034,kk_context()); /*int*/
    exp0 = kk_integer_add(e,_x5033,kk_context()); /*int*/
    kk_string_t exp;
    kk_string_t _x5037;
    bool _match_4433;
    kk_integer_t _borrowedArg_4434 = kk_integer_from_small(0); /*int*/;
    bool _borrowApp_4435 = kk_integer_gte_borrow(exp0,_borrowedArg_4434,kk_context()); /*bool*/;
    kk_integer_drop(_borrowedArg_4434, _ctx);
    _match_4433 = _borrowApp_4435; /*bool*/
    if (_match_4433) {
      kk_define_string_literal(, _s5038, 1, "+")
      _x5037 = kk_string_dup(_s5038); /*string*/
    }
    else {
      _x5037 = kk_string_empty(); /*string*/
    }
    kk_string_t _x5040 = kk_std_core_show(exp0, _ctx); /*string*/
    exp = kk_std_core__lp__plus__plus__1_rp_(_x5037, _x5040, _ctx); /*string*/
    kk_string_t frac;
    kk_string_t _ownedArg_4431;
    kk_string_t _x5041;
    kk_string_t _x5042 = kk_string_dup(man); /*string*/
    _x5041 = kk_std_core_tail_2(_x5042, _ctx); /*string*/
    kk_string_t _x5043;
    kk_define_string_literal(, _s5044, 1, "0")
    _x5043 = kk_string_dup(_s5044); /*string*/
    _ownedArg_4431 = kk_std_core_trim_right_1(_x5041, _x5043, _ctx); /*string*/
    kk_integer_t _borrowedArg_4426;
    bool _match_4427;
    kk_integer_t _borrowedArg_4429 = kk_integer_from_small(1); /*int*/;
    kk_integer_t _borrowedArg_4428;
    if (kk_std_core_types__is_Optional(width)) {
      kk_box_t _box_x4417 = width._cons.Optional.value;
      kk_integer_t _width_3406 = kk_integer_unbox(_box_x4417);
      kk_integer_dup(_width_3406);
      _borrowedArg_4428 = _width_3406; /*int*/
      goto _match5045;
    }
    _borrowedArg_4428 = kk_integer_from_small(1); /*int*/
    _match5045: ;
    bool _borrowApp_4430 = kk_integer_gte_borrow(_borrowedArg_4429,_borrowedArg_4428,kk_context()); /*bool*/;
    kk_integer_drop(_borrowedArg_4429, _ctx);
    kk_integer_drop(_borrowedArg_4428, _ctx);
    _match_4427 = _borrowApp_4430; /*bool*/
    if (_match_4427) {
      kk_std_core_types__optional_drop(width, _ctx);
      _borrowedArg_4426 = kk_integer_from_small(1); /*int*/
    }
    else {
      if (kk_std_core_types__is_Optional(width)) {
        kk_box_t _box_x4418 = width._cons.Optional.value;
        kk_integer_t _width_34060 = kk_integer_unbox(_box_x4418);
        kk_integer_dup(_width_34060);
        kk_std_core_types__optional_drop(width, _ctx);
        kk_Unit;
        _borrowedArg_4426 = _width_34060; /*int*/
        goto _match5047;
      }
      _borrowedArg_4426 = kk_integer_from_small(1); /*int*/
      _match5047: ;
    }
    kk_string_t _borrowApp_4432;
    kk_std_core_types__optional _x5049 = kk_std_core_types__new_Optional(kk_char_box('0', _ctx), _ctx); /*optional<106>*/
    _borrowApp_4432 = kk_std_core_pad_right(_ownedArg_4431, _borrowedArg_4426, _x5049, _ctx); /*string*/
    kk_integer_drop(_borrowedArg_4426, _ctx);
    frac = _borrowApp_4432; /*string*/
    kk_string_t sign;
    bool _match_4423 = (d < (0.0)); /*bool*/;
    if (_match_4423) {
      kk_define_string_literal(, _s5050, 1, "-")
      sign = kk_string_dup(_s5050); /*string*/
    }
    else {
      bool _match_4424 = (d == (0.0)); /*bool*/;
      if (_match_4424) {
        bool _match_4425;
        double _x5051 = ((1.0) / d); /*double*/
        _match_4425 = (isinf(_x5051) && signbit(_x5051)); /*bool*/
        if (_match_4425) {
          kk_define_string_literal(, _s5052, 1, "-")
          sign = kk_string_dup(_s5052); /*string*/
        }
        else {
          sign = kk_string_empty(); /*string*/
        }
      }
      else {
        sign = kk_string_empty(); /*string*/
      }
    }
    kk_string_t _x5055;
    kk_string_t _x5056;
    if (kk_std_core_types__is_Optional(pre)) {
      kk_box_t _box_x4421 = pre._cons.Optional.value;
      kk_string_t _pre_3414 = kk_string_unbox(_box_x4421);
      kk_string_dup(_pre_3414);
      kk_std_core_types__optional_drop(pre, _ctx);
      kk_Unit;
      _x5056 = _pre_3414; /*string*/
      goto _match5057;
    }
    kk_define_string_literal(, _s5059, 2, "0x")
    _x5056 = kk_string_dup(_s5059); /*string*/
    _match5057: ;
    kk_string_t _x5060;
    kk_string_t _x5061 = kk_std_core_head_3(man, _ctx); /*string*/
    kk_string_t _x5062;
    kk_string_t _x5063;
    kk_define_string_literal(, _s5064, 1, ".")
    _x5063 = kk_string_dup(_s5064); /*string*/
    kk_string_t _x5065;
    kk_string_t _x5066;
    kk_string_t _x5067;
    kk_define_string_literal(, _s5068, 1, "p")
    _x5067 = kk_string_dup(_s5068); /*string*/
    _x5066 = kk_std_core__lp__plus__plus__1_rp_(_x5067, exp, _ctx); /*string*/
    _x5065 = kk_std_core__lp__plus__plus__1_rp_(frac, _x5066, _ctx); /*string*/
    _x5062 = kk_std_core__lp__plus__plus__1_rp_(_x5063, _x5065, _ctx); /*string*/
    _x5060 = kk_std_core__lp__plus__plus__1_rp_(_x5061, _x5062, _ctx); /*string*/
    _x5055 = kk_std_core__lp__plus__plus__1_rp_(_x5056, _x5060, _ctx); /*string*/
    return kk_std_core__lp__plus__plus__1_rp_(sign, _x5055, _ctx);
  }
  kk_std_core_types__optional_drop(pre, _ctx);
  kk_std_core_types__optional_drop(use_capitals, _ctx);
  kk_std_core_types__optional_drop(width, _ctx);
  return kk_std_core_show_1(d, kk_std_core_types__new_None(_ctx), _ctx);
}

// initialization
void kk_std_num_double__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core__init(_ctx);
  kk_std_text_parse__init(_ctx);
  kk_std_num_int32__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
  {
    kk_std_num_double_dbl_max_prec = kk_integer_from_small(15); /*int*/
  }
  {
    kk_std_num_double_rad2deg = ((180.0) / (3.141592653589793)); /*double*/
  }
  {
    kk_std_num_double_deg2rad = ((3.141592653589793) / (180.0)); /*double*/
  }
  {
    kk_std_num_double_neginf = kk_std_num_double_make_neginf(_ctx); /*double*/
  }
  {
    kk_std_num_double_posinf = kk_std_num_double_make_posinf(_ctx); /*double*/
  }
  {
    kk_std_num_double_nan = kk_std_num_double_make_nan(_ctx); /*double*/
  }
}

// termination
void kk_std_num_double__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_integer_drop(kk_std_num_double_dbl_max_prec, _ctx);
  kk_std_num_int32__done(_ctx);
  kk_std_text_parse__done(_ctx);
  kk_std_core__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
