// Koka generated module: "std/core/hnd", koka version: 2.2.1
#include "std_core_hnd.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/
/*
typedef datatype_t kk_std_core_hnd__ev;
struct kk_std_core_hnd_Ev {
  kk_std_core_hnd__htag htag;
  kk_box_t hnd;
  int32_t cfc;  // control flow context
  kk_std_core_hnd__evv hevv;
  kk_std_core_hnd__marker marker;
};
*/

static kk_evv_vector_t kk_evv_vector_alloc(kk_ssize_t length, int32_t cfc, kk_context_t* ctx) {
  kk_assert_internal(length>=0);
  kk_evv_vector_t v = (kk_evv_vector_t)kk_block_alloc(kk_ssizeof(struct kk_evv_vector_s) + (length-1)*kk_ssizeof(void*), length + 1 /* cfc */, KK_TAG_EVV_VECTOR, ctx);
  v->cfc = kk_integer_from_int32(cfc,ctx);
  return v;
}

static kk_std_core_hnd__ev* kk_evv_vector_buf(kk_evv_vector_t vec, kk_ssize_t* len) {
  if (len != NULL) { *len = kk_block_scan_fsize(&vec->_block) - 1; }
  return &vec->vec[0];
}

static kk_std_core_hnd__ev* kk_evv_as_vec(kk_evv_t evv, kk_ssize_t* len, kk_std_core_hnd__ev* single) {
  if (kk_evv_is_vector(evv)) {
    kk_evv_vector_t vec = kk_evv_as_vector(evv);
    *len = kk_block_scan_fsize(&vec->_block) - 1;
    return &vec->vec[0];
  }
  else {
    // single evidence
    *single = kk_evv_as_ev(evv);
    *len = 1;
    return single;
  }
}

kk_std_core_hnd__ev kk_ev_none(kk_context_t* ctx) {
  static kk_std_core_hnd__ev ev_none_singleton;
  if (ev_none_singleton==NULL) {
    ev_none_singleton = kk_std_core_hnd__new_Ev(
      kk_reuse_null,
      kk_std_core_hnd__new_Htag(kk_string_empty(),ctx), // tag ""
      kk_std_core_hnd__new_Marker(0,ctx),               // marker 0
      kk_box_null,                                      // no handler
      -1,                                               // bot
      kk_evv_empty(ctx),
      ctx
    );
  }
  return kk_std_core_hnd__ev_dup(ev_none_singleton);
}


kk_ssize_t kk_evv_index( struct kk_std_core_hnd_Htag htag, kk_context_t* ctx ) {
  // todo: drop htag?
  kk_ssize_t len;
  kk_std_core_hnd__ev single;
  kk_std_core_hnd__ev* vec = kk_evv_as_vec(ctx->evv,&len,&single);
  for(kk_ssize_t i = 0; i < len; i++) {
    struct kk_std_core_hnd_Ev* ev = kk_std_core_hnd__as_Ev(vec[i]);
    if (kk_string_cmp_borrow(htag.tagname,ev->htag.tagname) <= 0) return i; // break on insertion point
  }
  //string_t evvs = kk_evv_show(dup_datatype_as(kk_evv_t,ctx->evv),ctx);
  //fatal_error(EFAULT,"cannot find tag '%s' in: %s", string_cbuf_borrow(htag.htag), string_cbuf_borrow(evvs));
  //drop_string_t(evvs,ctx);
  return len;
}

kk_std_core_hnd__ev kk_evv_lookup( struct kk_std_core_hnd_Htag htag, kk_context_t* ctx ) {
  // todo: drop htag
  kk_ssize_t idx = kk_evv_index(htag,ctx);
  return kk_evv_at(idx,ctx);
}

static inline int32_t kk_cfc_lub(int32_t cfc1, int32_t cfc2) {
  if (cfc1 < 0) return cfc2;
  else if (cfc1+cfc2 == 1) return 2;
  else if (cfc1>cfc2) return cfc1;
  else return cfc2;
}

static inline struct kk_std_core_hnd_Ev* kk_evv_as_Ev( kk_evv_t evv ) {
  return kk_std_core_hnd__as_Ev(kk_evv_as_ev(evv));
}


static int32_t kk_evv_cfc_of_borrow(kk_evv_t evv, kk_context_t* ctx) {
  if (kk_evv_is_vector(evv)) {
    kk_evv_vector_t vec = kk_evv_as_vector(evv);
    return kk_integer_clamp32_borrow(vec->cfc);
  }
  else {
    struct kk_std_core_hnd_Ev* ev = kk_evv_as_Ev(evv);
    return ev->cfc;
  }
}

int32_t kk_evv_cfc(kk_context_t* ctx) {
  return kk_evv_cfc_of_borrow(ctx->evv,ctx);
}

static void kk_evv_update_cfc_borrow(kk_evv_t evv, int32_t cfc, kk_context_t* ctx) {
  kk_assert_internal(!kk_evv_is_empty(evv)); // should never happen (as named handlers are always in some context)
  if (kk_evv_is_vector(evv)) {
    kk_evv_vector_t vec = kk_evv_as_vector(evv);
    vec->cfc = kk_integer_from_int32(kk_cfc_lub(kk_integer_clamp32_borrow(vec->cfc),cfc), ctx);
  }
  else {
    struct kk_std_core_hnd_Ev* ev = kk_evv_as_Ev(evv);
    ev->cfc = kk_cfc_lub(ev->cfc,cfc);
  }
}

kk_evv_t kk_evv_insert(kk_evv_t evvd, kk_std_core_hnd__ev evd, kk_context_t* ctx) {
  struct kk_std_core_hnd_Ev* ev = kk_std_core_hnd__as_Ev(evd);
  // update ev with parent evidence vector (either at init, or due to non-scoped resumptions)
  int32_t marker = ev->marker.m;
  if (marker==0) { kk_std_core_hnd__ev_drop(evd,ctx); return evvd; } // ev-none
  kk_evv_drop(ev->hevv,ctx);
  ev->hevv = kk_evv_dup(evvd);
  if (marker<0) { // negative marker is used for named evidence; this means this evidence should not be inserted into the evidence vector
    kk_evv_update_cfc_borrow(evvd,ev->cfc,ctx); // update cfc in-place for named evidence
    kk_std_core_hnd__ev_drop(evd,ctx);
    return evvd;
  }
  // for regular handler evidence, insert ev
  kk_ssize_t n;
  kk_std_core_hnd__ev single;
  kk_std_core_hnd__ev* const evv1 = kk_evv_as_vec(evvd, &n, &single);
  if (n == 0) {
    // use ev directly as the evidence vector
    kk_evv_drop(evvd, ctx);
    return &evd->_block;
  }
  else {
    // create evidence vector
    const int32_t cfc = kk_cfc_lub(kk_evv_cfc_of_borrow(evvd, ctx), ev->cfc);
    ev->cfc = cfc; // update in place
    kk_evv_vector_t vec2 = kk_evv_vector_alloc(n+1, cfc, ctx);
    kk_std_core_hnd__ev* const evv2 = kk_evv_vector_buf(vec2, NULL);
    kk_ssize_t i;
    for (i = 0; i < n; i++) {
      struct kk_std_core_hnd_Ev* ev1 = kk_std_core_hnd__as_Ev(evv1[i]);
      if (kk_string_cmp_borrow(ev->htag.tagname, ev1->htag.tagname) <= 0) break;
      evv2[i] = kk_std_core_hnd__ev_dup(&ev1->_base);
    }
    evv2[i] = evd;
    for (; i < n; i++) {
      evv2[i+1] = kk_std_core_hnd__ev_dup(evv1[i]);
    }
    kk_evv_drop(evvd, ctx);  // assigned to evidence already
    return &vec2->_block;
  }
}

kk_evv_t kk_evv_delete(kk_evv_t evvd, kk_ssize_t index, bool behind, kk_context_t* ctx) {
  kk_ssize_t n;
  kk_std_core_hnd__ev single;
  const kk_std_core_hnd__ev* evv1 = kk_evv_as_vec(evvd, &n, &single);
  if (n <= 1) {
    kk_evv_drop(evvd,ctx);
    return kk_evv_total(ctx);
  }
  if (behind) index++;
  kk_assert_internal(index < n);
  // todo: copy without dupping (and later dropping) when possible
  const int32_t cfc1 = kk_evv_cfc_of_borrow(evvd,ctx);
  kk_evv_vector_t const vec2 = kk_evv_vector_alloc(n-1,cfc1,ctx);
  kk_std_core_hnd__ev* const evv2 = kk_evv_vector_buf(vec2,NULL);
  kk_ssize_t i;
  for(i = 0; i < index; i++) {
    evv2[i] = kk_std_core_hnd__ev_dup(evv1[i]);
  }
  for(; i < n-1; i++) {
    evv2[i] = kk_std_core_hnd__ev_dup(evv1[i+1]);
  }
  struct kk_std_core_hnd_Ev* ev = kk_std_core_hnd__as_Ev(evv1[index]);
  if (ev->cfc >= cfc1) {
    int32_t cfc = kk_std_core_hnd__as_Ev(evv2[0])->cfc;
    for(i = 1; i < n-1; i++) {
      cfc = kk_cfc_lub(cfc,kk_std_core_hnd__as_Ev(evv2[i])->cfc);
    }
    vec2->cfc = kk_integer_from_int32(cfc,ctx);
  }
  kk_evv_drop(evvd,ctx);
  return &vec2->_block;
}

kk_evv_t kk_evv_create(kk_evv_t evv1, kk_vector_t indices, kk_context_t* ctx) {
  kk_ssize_t len;
  kk_box_t* elems = kk_vector_buf_borrow(indices,&len); // borrows
  kk_evv_vector_t evv2 = kk_evv_vector_alloc(len,kk_evv_cfc_of_borrow(evv1,ctx),ctx);
  kk_std_core_hnd__ev* buf2 = kk_evv_vector_buf(evv2,NULL);
  kk_assert_internal(kk_evv_is_vector(evv1));
  kk_ssize_t len1;
  kk_std_core_hnd__ev single;
  kk_std_core_hnd__ev* buf1 = kk_evv_as_vec(evv1,&len1,&single);
  for(kk_ssize_t i = 0; i < len; i++) {
    kk_ssize_t idx = kk_ssize_unbox(elems[i],ctx);
    kk_assert_internal(idx < len1);
    buf2[i] = kk_std_core_hnd__ev_dup( buf1[idx] );
  }
  kk_vector_drop(indices,ctx);
  kk_evv_drop(evv1,ctx);
  return &evv2->_block;
}

kk_evv_t kk_evv_swap_create( kk_vector_t indices, kk_context_t* ctx ) {
  kk_ssize_t len;
  kk_box_t* vec = kk_vector_buf_borrow(indices,&len);
  if (len==0) {
    kk_vector_drop(indices,ctx);
    return kk_evv_swap_create0(ctx);
  }
  if (len==1) {
    kk_ssize_t i = kk_ssize_unbox(vec[0],ctx);
    kk_vector_drop(indices,ctx);
    return kk_evv_swap_create1(i,ctx);
  }
  return kk_evv_swap( kk_evv_create(kk_evv_dup(ctx->evv),indices,ctx), ctx );
}


kk_string_t kk_evv_show(kk_evv_t evv, kk_context_t* ctx) {
  return kk_string_alloc_dup_valid_utf8("(not yet implemented: kk_evv_show)",ctx);
}


/*-----------------------------------------------------------------------
  Compose continuations
-----------------------------------------------------------------------*/

struct kcompose_fun_s {
  struct kk_function_s _base;
  kk_box_t      count;
  kk_function_t conts[1];
};

// kleisli composition of continuations
static kk_box_t kcompose( kk_function_t fself, kk_box_t x, kk_context_t* ctx) {
  struct kcompose_fun_s* self = kk_function_as(struct kcompose_fun_s*,fself);
  kk_intx_t count = kk_int_unbox(self->count);
  kk_function_t* conts = &self->conts[0];
  // call each continuation in order
  for(kk_intx_t i = 0; i < count; i++) {
    // todo: take uniqueness of fself into account to avoid dup_function
    kk_function_t f = kk_function_dup(conts[i]);
    x = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, x, ctx));
    if (kk_yielding(ctx)) {
      // if yielding, `yield_next` all continuations that still need to be done
      while(++i < count) {
        // todo: if fself is unique, we could copy without dup?
        kk_yield_extend(kk_function_dup(conts[i]),ctx);
      }
      kk_function_drop(fself,ctx);
      kk_box_drop(x,ctx);     // still drop even though we yield as it may release a boxed value type?
      return kk_box_any(ctx); // return yielding
    }
  }
  kk_function_drop(fself,ctx);
  return x;
}

static kk_function_t new_kcompose( kk_function_t* conts, kk_ssize_t count, kk_context_t* ctx ) {
  if (count==0) return kk_function_id(ctx);
  if (count==1) return conts[0];
  struct kcompose_fun_s* f = kk_block_as(struct kcompose_fun_s*,
                               kk_block_alloc(kk_ssizeof(struct kcompose_fun_s) - kk_ssizeof(kk_function_t) + (count*kk_ssizeof(kk_function_t)),
                                 2 + count /* scan size */, KK_TAG_FUNCTION, ctx));
  f->_base.fun = kk_cfun_ptr_box(&kcompose,ctx);
  f->count = kk_int_box(count);
  kk_memcpy(f->conts, conts, count * kk_ssizeof(kk_function_t));
  return (&f->_base);
}

/*-----------------------------------------------------------------------
  Yield extension
-----------------------------------------------------------------------*/

kk_box_t kk_yield_extend( kk_function_t next, kk_context_t* ctx ) {
  kk_yield_t* yield = &ctx->yield;
  kk_assert_internal(kk_yielding(ctx));  // cannot extend if not yielding
  if (kk_unlikely(kk_yielding_final(ctx))) {
    // todo: can we optimize this so `next` is never allocated in the first place?
    kk_function_drop(next,ctx); // ignore extension if never resuming
  }
  else {
    if (kk_unlikely(yield->conts_count >= KK_YIELD_CONT_MAX)) {
      // alloc a function to compose all continuations in the array
      kk_function_t comp = new_kcompose( yield->conts, yield->conts_count, ctx );
      yield->conts[0] = comp;
      yield->conts_count = 1;
    }
    yield->conts[yield->conts_count++] = next;
  }
  return kk_box_any(ctx);
}

// cont_apply: \x -> f(cont,x)
struct cont_apply_fun_s {
  struct kk_function_s _base;
  kk_function_t f;
  kk_function_t cont;
};

static kk_box_t cont_apply( kk_function_t fself, kk_box_t x, kk_context_t* ctx ) {
  struct cont_apply_fun_s* self = kk_function_as(struct cont_apply_fun_s*, fself);
  kk_function_t f = self->f;
  kk_function_t cont = self->cont;
  kk_drop_match(self,{kk_function_dup(f);kk_function_dup(cont);},{},ctx);
  return kk_function_call( kk_box_t, (kk_function_t, kk_function_t, kk_box_t, kk_context_t* ctx), f, (f, cont, x, ctx));
}

static kk_function_t kk_new_cont_apply( kk_function_t f, kk_function_t cont, kk_context_t* ctx ) {
  struct cont_apply_fun_s* self = kk_function_alloc_as(struct cont_apply_fun_s, 3, ctx);
  self->_base.fun = kk_cfun_ptr_box(&cont_apply,ctx);
  self->f = f;
  self->cont = cont;
  return (&self->_base);
}

// Unlike `yield_extend`, `yield_cont` gets access to the current continuation. This is used in `yield_prompt`.
kk_box_t kk_yield_cont( kk_function_t f, kk_context_t* ctx ) {
  kk_yield_t* yield = &ctx->yield;
  kk_assert_internal(kk_yielding(ctx)); // cannot extend if not yielding
  if (kk_unlikely(kk_yielding_final(ctx))) {
    kk_function_drop(f,ctx); // ignore extension if never resuming
  }
  else {
    kk_function_t cont = new_kcompose(yield->conts, yield->conts_count, ctx);
    yield->conts_count = 1;
    yield->conts[0] = kk_new_cont_apply(f, cont, ctx);
  }
  return kk_box_any(ctx);
}

kk_function_t kk_yield_to( struct kk_std_core_hnd_Marker m, kk_function_t clause, kk_context_t* ctx ) {
  kk_yield_t* yield = &ctx->yield;
  kk_assert_internal(!kk_yielding(ctx)); // already yielding
  ctx->yielding = KK_YIELD_NORMAL;
  yield->marker = m.m;
  yield->clause = clause;
  yield->conts_count = 0;
  return kk_basetype_unbox_as(kk_function_t,kk_box_any(ctx));
}

kk_box_t kk_yield_final( struct kk_std_core_hnd_Marker m, kk_function_t clause, kk_context_t* ctx ) {
  kk_yield_to(m,clause,ctx);
  ctx->yielding = KK_YIELD_FINAL;
  return kk_box_any(ctx);
}

kk_box_t kk_fatal_resume_final(kk_context_t* ctx) {
  kk_fatal_error(EFAULT,"trying to resume a finalized resumption");
  return kk_box_any(ctx);
}

static kk_box_t _fatal_resume_final(kk_function_t self, kk_context_t* ctx) {
  kk_function_drop(self,ctx);
  return kk_fatal_resume_final(ctx);
}
static kk_function_t fun_fatal_resume_final(kk_context_t* ctx) {
  kk_define_static_function(f,_fatal_resume_final,ctx);
  return kk_function_dup(f);
}


struct kk_std_core_hnd_yld_s kk_yield_prompt( struct kk_std_core_hnd_Marker m, kk_context_t* ctx ) {
  kk_yield_t* yield = &ctx->yield;
  if (ctx->yielding == KK_YIELD_NONE) {
    return kk_std_core_hnd__new_Pure(ctx);
  }
  else if (yield->marker != m.m) {
    return (ctx->yielding == KK_YIELD_FINAL ? kk_std_core_hnd__new_YieldingFinal(ctx) : kk_std_core_hnd__new_Yielding(ctx));
  }
  else {
    kk_function_t cont = (ctx->yielding == KK_YIELD_FINAL ? fun_fatal_resume_final(ctx) : new_kcompose(yield->conts, yield->conts_count, ctx));
    kk_function_t clause = yield->clause;
    ctx->yielding = KK_YIELD_NONE;
    #ifndef NDEBUG
    kk_memset(yield,0,kk_ssizeof(kk_yield_t));
    #endif
    return kk_std_core_hnd__new_Yield(clause, cont, ctx);
  }
}

kk_unit_t  kk_evv_guard(kk_evv_t evv, kk_context_t* ctx) {
  bool eq = (ctx->evv == evv);
  kk_evv_drop(evv,ctx);
  if (!eq) {
    // todo: improve error message with diagnostics
    kk_fatal_error(EFAULT,"trying to resume outside the (handler) scope of the original handler");
  }
  return kk_Unit;
}

typedef struct yield_info_s {
  struct kk_std_core_hnd__yield_info_s _base;
  kk_function_t clause;
  kk_function_t conts[KK_YIELD_CONT_MAX];
  kk_ssize_t    conts_count;
  int32_t       marker;
  int8_t        yielding;
}* yield_info_t;

kk_std_core_hnd__yield_info kk_yield_capture(kk_context_t* ctx) {
  kk_assert_internal(kk_yielding(ctx));
  yield_info_t yld = kk_block_alloc_as(struct yield_info_s, 1 + KK_YIELD_CONT_MAX, (kk_tag_t)1, ctx);
  yld->clause = ctx->yield.clause;
  kk_ssize_t i = 0;
  for( ; i < ctx->yield.conts_count; i++) {
    yld->conts[i] = ctx->yield.conts[i];
  }
  for( ; i < KK_YIELD_CONT_MAX; i++) {
    yld->conts[i] = kk_function_null(ctx);
  }
  yld->conts_count = ctx->yield.conts_count;
  yld->marker = ctx->yield.marker;
  yld->yielding = ctx->yielding;
  ctx->yielding = 0;
  ctx->yield.conts_count = 0;
  return kk_datatype_from_base(&yld->_base);
}

kk_box_t kk_yield_reyield( kk_std_core_hnd__yield_info yldinfo, kk_context_t* ctx) {
  kk_assert_internal(!kk_yielding(ctx));
  yield_info_t yld = kk_datatype_as_assert(yield_info_t, yldinfo, (kk_tag_t)1);
  ctx->yield.clause = kk_function_dup(yld->clause);
  ctx->yield.marker = yld->marker;
  ctx->yield.conts_count = yld->conts_count;
  ctx->yielding = yld->yielding;
  for(kk_ssize_t i = 0; i < yld->conts_count; i++) {
    ctx->yield.conts[i] = kk_function_dup(yld->conts[i]);
  }
  kk_constructor_drop(yld,ctx);
  return kk_box_any(ctx);
}


kk_std_core_hnd__ev kk_std_core_hnd__copy_2(kk_std_core_hnd__ev _this, kk_std_core_types__optional htag0, kk_std_core_hnd__marker marker, kk_box_t hnd, kk_std_core_types__optional cfc0, kk_evv_t hevv, kk_context_t* _ctx) { /* forall<a,e,b> (ev<a>, htag : optional<htag<a>>, marker : marker<e,b>, hnd : a<e,b>, cfc : optional<cfc>, hevv : evv<e>) -> ev<a> */ 
  kk_std_core_hnd__htag _x10560;
  if (kk_std_core_types__is_Optional(htag0)) {
    kk_box_t _box_x10336 = htag0._cons.Optional.value;
    kk_std_core_hnd__htag _htag_2051 = kk_std_core_hnd__htag_unbox(_box_x10336, NULL);
    kk_std_core_hnd__htag_dup(_htag_2051);
    kk_std_core_types__optional_drop(htag0, _ctx);
    kk_Unit;
    _x10560 = _htag_2051; /*std/core/hnd/htag<2077>*/
    goto _match10561;
  }
  struct kk_std_core_hnd_Ev* _con10563 = kk_std_core_hnd__as_Ev(_this);
  kk_std_core_hnd__htag _x = _con10563->htag;
  kk_std_core_hnd__htag_dup(_x);
  _x10560 = _x; /*std/core/hnd/htag<2077>*/
  _match10561: ;
  int32_t _x10564;
  if (kk_std_core_types__is_Optional(cfc0)) {
    kk_box_t _box_x10337 = cfc0._cons.Optional.value;
    int32_t _cfc_2058 = kk_int32_unbox(_box_x10337, NULL);
    kk_std_core_types__optional_drop(cfc0, _ctx);
    kk_Unit;
    kk_std_core_hnd__ev_dropn(_this, ((int32_t)3), _ctx);
    kk_Unit;
    _x10564 = _cfc_2058; /*std/core/hnd/cfc*/
    goto _match10565;
  }
  struct kk_std_core_hnd_Ev* _con10567 = kk_std_core_hnd__as_Ev(_this);
  kk_std_core_hnd__htag _pat01 = _con10567->htag;
  kk_box_t _pat21 = _con10567->hnd;
  int32_t _x0 = _con10567->cfc;
  kk_evv_t _pat30 = _con10567->hevv;
  if (kk_likely(kk_std_core_hnd__ev_is_unique(_this))) {
    kk_evv_drop(_pat30, _ctx);
    kk_Unit;
    kk_box_drop(_pat21, _ctx);
    kk_Unit;
    kk_std_core_hnd__htag_drop(_pat01, _ctx);
    kk_Unit;
    kk_Unit;
    kk_std_core_hnd__ev_free(_this);
  }
  else {
    kk_std_core_hnd__ev_decref(_this, _ctx);
    kk_Unit;
  }
  _x10564 = _x0; /*std/core/hnd/cfc*/
  _match10565: ;
  return kk_std_core_hnd__new_Ev(kk_reuse_null, _x10560, marker, hnd, _x10564, hevv, _ctx);
}


// lift anonymous function
struct kk_std_core_hnd__copy_fun10569__t_3 {
  struct kk_function_s _base;
  kk_box_t _fun_unbox_x10343;
};
static kk_box_t kk_std_core_hnd__copy_fun10569_3(kk_function_t _fself, kk_std_core_hnd__marker _b_10347, kk_std_core_hnd__ev _b_10348, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_copy_fun10569_3(kk_box_t _fun_unbox_x10343, kk_context_t* _ctx) {
  struct kk_std_core_hnd__copy_fun10569__t_3* _self = kk_function_alloc_as(struct kk_std_core_hnd__copy_fun10569__t_3, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd__copy_fun10569_3, kk_context());
  _self->_fun_unbox_x10343 = _fun_unbox_x10343;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd__copy_fun10569_3(kk_function_t _fself, kk_std_core_hnd__marker _b_10347, kk_std_core_hnd__ev _b_10348, kk_context_t* _ctx) {
  struct kk_std_core_hnd__copy_fun10569__t_3* _self = kk_function_as(struct kk_std_core_hnd__copy_fun10569__t_3*, _fself);
  kk_box_t _fun_unbox_x10343 = _self->_fun_unbox_x10343; /* 106 */
  kk_drop_match(_self, {kk_box_dup(_fun_unbox_x10343);}, {}, _ctx)
  kk_function_t _x10570 = kk_function_unbox(_fun_unbox_x10343); /*(10344, 10345) -> 2170 10346*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_context_t*), _x10570, (_x10570, kk_std_core_hnd__marker_box(_b_10347, _ctx), kk_std_core_hnd__ev_box(_b_10348, _ctx), _ctx));
}

kk_std_core_hnd__clause0 kk_std_core_hnd__copy_3(kk_std_core_hnd__clause0 _this, kk_std_core_types__optional clause0, kk_context_t* _ctx) { /* forall<a,b,e,c> (clause0<a,b,e,c>, clause : optional<(marker<e,c>, ev<b>) -> e a>) -> clause0<a,b,e,c> */ 
  kk_function_t _x10568;
  if (kk_std_core_types__is_Optional(clause0)) {
    kk_box_t _fun_unbox_x10343 = clause0._cons.Optional.value;
    kk_std_core_hnd__clause0_drop(_this, _ctx);
    kk_Unit;
    _x10568 = kk_std_core_hnd__new_copy_fun10569_3(_fun_unbox_x10343, _ctx); /*(std/core/hnd/marker<2170,2171>, std/core/hnd/ev<2169>) -> 2170 10346*/
  }
  else {
    kk_function_t _x = _this.clause;
    _x10568 = _x; /*(std/core/hnd/marker<2170,2171>, std/core/hnd/ev<2169>) -> 2170 10346*/
  }
  return kk_std_core_hnd__new_Clause0(_x10568, _ctx);
}


// lift anonymous function
struct kk_std_core_hnd__copy_fun10572__t_4 {
  struct kk_function_s _base;
  kk_box_t _fun_unbox_x10356;
};
static kk_box_t kk_std_core_hnd__copy_fun10572_4(kk_function_t _fself, kk_std_core_hnd__marker _b_10361, kk_std_core_hnd__ev _b_10362, kk_box_t _b_10363, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_copy_fun10572_4(kk_box_t _fun_unbox_x10356, kk_context_t* _ctx) {
  struct kk_std_core_hnd__copy_fun10572__t_4* _self = kk_function_alloc_as(struct kk_std_core_hnd__copy_fun10572__t_4, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd__copy_fun10572_4, kk_context());
  _self->_fun_unbox_x10356 = _fun_unbox_x10356;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd__copy_fun10572_4(kk_function_t _fself, kk_std_core_hnd__marker _b_10361, kk_std_core_hnd__ev _b_10362, kk_box_t _b_10363, kk_context_t* _ctx) {
  struct kk_std_core_hnd__copy_fun10572__t_4* _self = kk_function_as(struct kk_std_core_hnd__copy_fun10572__t_4*, _fself);
  kk_box_t _fun_unbox_x10356 = _self->_fun_unbox_x10356; /* 106 */
  kk_drop_match(_self, {kk_box_dup(_fun_unbox_x10356);}, {}, _ctx)
  kk_function_t _x10573 = kk_function_unbox(_fun_unbox_x10356); /*(10357, 10358, 10359) -> 2376 10360*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_context_t*), _x10573, (_x10573, kk_std_core_hnd__marker_box(_b_10361, _ctx), kk_std_core_hnd__ev_box(_b_10362, _ctx), _b_10363, _ctx));
}

kk_std_core_hnd__clause1 kk_std_core_hnd__copy_4(kk_std_core_hnd__clause1 _this, kk_std_core_types__optional clause0, kk_context_t* _ctx) { /* forall<a,b,c,e,d> (clause1<a,b,c,e,d>, clause : optional<(marker<e,d>, ev<c>, a) -> e b>) -> clause1<a,b,c,e,d> */ 
  kk_function_t _x10571;
  if (kk_std_core_types__is_Optional(clause0)) {
    kk_box_t _fun_unbox_x10356 = clause0._cons.Optional.value;
    kk_std_core_hnd__clause1_drop(_this, _ctx);
    kk_Unit;
    _x10571 = kk_std_core_hnd__new_copy_fun10572_4(_fun_unbox_x10356, _ctx); /*(std/core/hnd/marker<2376,2377>, std/core/hnd/ev<2375>, 2373) -> 2376 10360*/
  }
  else {
    kk_function_t _x = _this.clause;
    _x10571 = _x; /*(std/core/hnd/marker<2376,2377>, std/core/hnd/ev<2375>, 2373) -> 2376 10360*/
  }
  return kk_std_core_hnd__new_Clause1(_x10571, _ctx);
}


// lift anonymous function
struct kk_std_core_hnd__copy_fun10575__t_5 {
  struct kk_function_s _base;
  kk_box_t _fun_unbox_x10373;
};
static kk_box_t kk_std_core_hnd__copy_fun10575_5(kk_function_t _fself, kk_std_core_hnd__marker _b_10379, kk_std_core_hnd__ev _b_10380, kk_box_t _b_10381, kk_box_t _b_10382, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_copy_fun10575_5(kk_box_t _fun_unbox_x10373, kk_context_t* _ctx) {
  struct kk_std_core_hnd__copy_fun10575__t_5* _self = kk_function_alloc_as(struct kk_std_core_hnd__copy_fun10575__t_5, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd__copy_fun10575_5, kk_context());
  _self->_fun_unbox_x10373 = _fun_unbox_x10373;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd__copy_fun10575_5(kk_function_t _fself, kk_std_core_hnd__marker _b_10379, kk_std_core_hnd__ev _b_10380, kk_box_t _b_10381, kk_box_t _b_10382, kk_context_t* _ctx) {
  struct kk_std_core_hnd__copy_fun10575__t_5* _self = kk_function_as(struct kk_std_core_hnd__copy_fun10575__t_5*, _fself);
  kk_box_t _fun_unbox_x10373 = _self->_fun_unbox_x10373; /* 106 */
  kk_drop_match(_self, {kk_box_dup(_fun_unbox_x10373);}, {}, _ctx)
  kk_function_t _x10576 = kk_function_unbox(_fun_unbox_x10373); /*(10374, 10375, 10376, 10377) -> 2677 10378*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_box_t, kk_context_t*), _x10576, (_x10576, kk_std_core_hnd__marker_box(_b_10379, _ctx), kk_std_core_hnd__ev_box(_b_10380, _ctx), _b_10381, _b_10382, _ctx));
}

kk_std_core_hnd__clause2 kk_std_core_hnd__copy_5(kk_std_core_hnd__clause2 _this, kk_std_core_types__optional clause0, kk_context_t* _ctx) { /* forall<a,b,c,d,e,a1> (clause2<a,b,c,d,e,a1>, clause : optional<(marker<e,a1>, ev<d>, a, b) -> e c>) -> clause2<a,b,c,d,e,a1> */ 
  kk_function_t _x10574;
  if (kk_std_core_types__is_Optional(clause0)) {
    kk_box_t _fun_unbox_x10373 = clause0._cons.Optional.value;
    kk_std_core_hnd__clause2_drop(_this, _ctx);
    kk_Unit;
    _x10574 = kk_std_core_hnd__new_copy_fun10575_5(_fun_unbox_x10373, _ctx); /*(std/core/hnd/marker<2677,2678>, std/core/hnd/ev<2676>, 2673, 2674) -> 2677 10378*/
  }
  else {
    kk_function_t _x = _this.clause;
    _x10574 = _x; /*(std/core/hnd/marker<2677,2678>, std/core/hnd/ev<2676>, 2673, 2674) -> 2677 10378*/
  }
  return kk_std_core_hnd__new_Clause2(_x10574, _ctx);
}


// lift anonymous function
struct kk_std_core_hnd__copy_fun10578__t_6 {
  struct kk_function_s _base;
  kk_box_t _fun_unbox_x10386;
};
static kk_box_t kk_std_core_hnd__copy_fun10578_6(kk_function_t _fself, kk_std_core_hnd__resume_result _b_10389, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_copy_fun10578_6(kk_box_t _fun_unbox_x10386, kk_context_t* _ctx) {
  struct kk_std_core_hnd__copy_fun10578__t_6* _self = kk_function_alloc_as(struct kk_std_core_hnd__copy_fun10578__t_6, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd__copy_fun10578_6, kk_context());
  _self->_fun_unbox_x10386 = _fun_unbox_x10386;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd__copy_fun10578_6(kk_function_t _fself, kk_std_core_hnd__resume_result _b_10389, kk_context_t* _ctx) {
  struct kk_std_core_hnd__copy_fun10578__t_6* _self = kk_function_as(struct kk_std_core_hnd__copy_fun10578__t_6*, _fself);
  kk_box_t _fun_unbox_x10386 = _self->_fun_unbox_x10386; /* 106 */
  kk_drop_match(_self, {kk_box_dup(_fun_unbox_x10386);}, {}, _ctx)
  kk_function_t _x10579 = kk_function_unbox(_fun_unbox_x10386); /*(10387) -> 2891 10388*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x10579, (_x10579, kk_std_core_hnd__resume_result_box(_b_10389, _ctx), _ctx));
}

kk_std_core_hnd__resume_context kk_std_core_hnd__copy_6(kk_std_core_hnd__resume_context _this, kk_std_core_types__optional k0, kk_context_t* _ctx) { /* forall<a,e,e1,b> (resume-context<a,e,e1,b>, k : optional<(resume-result<a,b>) -> e b>) -> resume-context<a,e,e1,b> */ 
  kk_function_t _x10577;
  if (kk_std_core_types__is_Optional(k0)) {
    kk_box_t _fun_unbox_x10386 = k0._cons.Optional.value;
    kk_std_core_hnd__resume_context_drop(_this, _ctx);
    kk_Unit;
    _x10577 = kk_std_core_hnd__new_copy_fun10578_6(_fun_unbox_x10386, _ctx); /*(std/core/hnd/resume-result<2890,2893>) -> 2891 10388*/
  }
  else {
    kk_function_t _x = _this.k;
    _x10577 = _x; /*(std/core/hnd/resume-result<2890,2893>) -> 2891 10388*/
  }
  return kk_std_core_hnd__new_Resume_context(_x10577, _ctx);
}
 
// (dynamically) find evidence insertion/deletion index in the evidence vector

kk_ssize_t kk_std_core_hnd__evv_index(kk_std_core_hnd__htag htag0, kk_context_t* _ctx) { /* forall<e,a> (htag : htag<a>) -> e ev-index */ 
  return kk_evv_index(htag0,kk_context());
}

bool kk_std_core_hnd__evv_is_affine(kk_context_t* _ctx) { /* () -> bool */ 
  return kk_evv_cfc(kk_context())<=2;
}

kk_std_core_hnd__ev kk_std_core_hnd__evv_lookup(kk_std_core_hnd__htag htag0, kk_context_t* _ctx) { /* forall<a> (htag : htag<a>) -> ev<a> */ 
  return kk_evv_lookup(htag0,kk_context());
}

kk_evv_t kk_std_core_hnd_evv_get(kk_context_t* _ctx) { /* forall<e> () -> e evv<e> */ 
  return kk_evv_get(kk_context());
}

kk_evv_t kk_std_core_hnd_evv_insert(kk_evv_t evv, kk_std_core_hnd__ev ev, kk_context_t* _ctx) { /* forall<e,e1,a> (evv : evv<e>, ev : ev<a>) -> e evv<e1> */ 
  return kk_evv_insert(evv,ev,kk_context());
}

int32_t kk_std_core_hnd_fresh_marker_int(kk_context_t* _ctx) { /* () -> int32 */ 
  return kk_marker_unique(kk_context());
}

bool kk_std_core_hnd_evv_eq(kk_evv_t evv0, kk_evv_t evv1, kk_context_t* _ctx) { /* forall<e> (evv0 : evv<e>, evv1 : evv<e>) -> bool */ 
  return kk_evv_eq(evv0,evv1,kk_context());
}

kk_unit_t kk_std_core_hnd_guard(kk_evv_t w, kk_context_t* _ctx) { /* forall<e> (w : evv<e>) -> e () */ 
  kk_evv_guard(w,kk_context()); return kk_Unit;
}

kk_box_t kk_std_core_hnd_yield_extend(kk_function_t next, kk_context_t* _ctx) { /* forall<a,b,e> (next : (a) -> e b) -> e b */ 
  return kk_yield_extend(next,kk_context());
}

kk_box_t kk_std_core_hnd_yield_cont(kk_function_t f, kk_context_t* _ctx) { /* forall<a,e,b> (f : forall<c> ((c) -> e a, c) -> e b) -> e b */ 
  return kk_yield_cont(f,kk_context());
}

kk_std_core_hnd__yld kk_std_core_hnd_yield_prompt(kk_std_core_hnd__marker m0, kk_context_t* _ctx) { /* forall<a,e,b> (m : marker<e,b>) -> yld<e,a,b> */ 
  return kk_yield_prompt(m0,kk_context());
}

kk_box_t kk_std_core_hnd_yield_to_final(kk_std_core_hnd__marker m0, kk_function_t clause0, kk_context_t* _ctx) { /* forall<a,e,e1,b> (m : marker<e1,b>, clause : ((resume-result<a,b>) -> e1 b) -> e1 b) -> e a */ 
  return kk_yield_final(m0,clause0,kk_context());
}

kk_evv_t kk_std_core_hnd_evv_swap_delete(kk_ssize_t i, bool behind, kk_context_t* _ctx) { /* forall<e,e1> (i : ev-index, behind : bool) -> e1 evv<e> */ 
  return kk_evv_swap_delete(i,behind,kk_context());
}

int32_t kk_std_core_hnd_fresh_marker_named_int(kk_context_t* _ctx) { /* () -> int32 */ 
  return -kk_marker_unique(kk_context());
}

kk_evv_t kk_std_core_hnd_evv_swap_create(kk_vector_t indices, kk_context_t* _ctx) { /* forall<e> (indices : vector<ev-index>) -> e evv<e> */ 
  return kk_evv_swap_create(indices,kk_context());
}

kk_function_t kk_std_core_hnd_yield_to_prim(kk_std_core_hnd__marker m0, kk_function_t clause0, kk_context_t* _ctx) { /* forall<a,e,e1,b> (m : marker<e1,b>, clause : ((resume-result<a,b>) -> e1 b) -> e1 b) -> e (() -> a) */ 
  return kk_yield_to(m0,clause0,kk_context());
}


// lift anonymous function
struct kk_std_core_hnd_clause_tail_noyield0_fun10584__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_tail_noyield0_fun10584(kk_function_t _fself, kk_std_core_hnd__marker ___wildcard__633__14, kk_std_core_hnd__ev ___wildcard__633__17, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_tail_noyield0_fun10584(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail_noyield0_fun10584__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_tail_noyield0_fun10584__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_tail_noyield0_fun10584, kk_context());
  _self->op = op;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_tail_noyield0_fun10584(kk_function_t _fself, kk_std_core_hnd__marker ___wildcard__633__14, kk_std_core_hnd__ev ___wildcard__633__17, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail_noyield0_fun10584__t* _self = kk_function_as(struct kk_std_core_hnd_clause_tail_noyield0_fun10584__t*, _fself);
  kk_function_t op = _self->op; /* () -> 4104 4106 */
  kk_drop_match(_self, {kk_function_dup(op);}, {}, _ctx)
  kk_std_core_hnd__ev_dropn(___wildcard__633__17, ((int32_t)3), _ctx);
  return kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), op, (op, _ctx));
}

kk_std_core_hnd__clause0 kk_std_core_hnd_clause_tail_noyield0(kk_function_t op, kk_context_t* _ctx) { /* forall<e,a,b,c> (op : () -> e b) -> clause0<b,c,e,a> */ 
  return kk_std_core_hnd__new_Clause0(kk_std_core_hnd_new_clause_tail_noyield0_fun10584(op, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_tail_noyield1_fun10585__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_tail_noyield1_fun10585(kk_function_t _fself, kk_std_core_hnd__marker ___wildcard__581__14, kk_std_core_hnd__ev ___wildcard__581__17, kk_box_t x, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_tail_noyield1_fun10585(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail_noyield1_fun10585__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_tail_noyield1_fun10585__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_tail_noyield1_fun10585, kk_context());
  _self->op = op;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_tail_noyield1_fun10585(kk_function_t _fself, kk_std_core_hnd__marker ___wildcard__581__14, kk_std_core_hnd__ev ___wildcard__581__17, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail_noyield1_fun10585__t* _self = kk_function_as(struct kk_std_core_hnd_clause_tail_noyield1_fun10585__t*, _fself);
  kk_function_t op = _self->op; /* (4137) -> 4135 4138 */
  kk_drop_match(_self, {kk_function_dup(op);}, {}, _ctx)
  kk_std_core_hnd__ev_dropn(___wildcard__581__17, ((int32_t)3), _ctx);
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), op, (op, x, _ctx));
}

kk_std_core_hnd__clause1 kk_std_core_hnd_clause_tail_noyield1(kk_function_t op, kk_context_t* _ctx) { /* forall<e,a,b,c,d> (op : (b) -> e c) -> clause1<b,c,d,e,a> */ 
  return kk_std_core_hnd__new_Clause1(kk_std_core_hnd_new_clause_tail_noyield1_fun10585(op, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_tail_noyield2_fun10586__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_tail_noyield2_fun10586(kk_function_t _fself, kk_std_core_hnd__marker ___wildcard__685__14, kk_std_core_hnd__ev ___wildcard__685__17, kk_box_t x1, kk_box_t x2, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_tail_noyield2_fun10586(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail_noyield2_fun10586__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_tail_noyield2_fun10586__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_tail_noyield2_fun10586, kk_context());
  _self->op = op;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_tail_noyield2_fun10586(kk_function_t _fself, kk_std_core_hnd__marker ___wildcard__685__14, kk_std_core_hnd__ev ___wildcard__685__17, kk_box_t x1, kk_box_t x2, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail_noyield2_fun10586__t* _self = kk_function_as(struct kk_std_core_hnd_clause_tail_noyield2_fun10586__t*, _fself);
  kk_function_t op = _self->op; /* (4174, 4175) -> 4172 4176 */
  kk_drop_match(_self, {kk_function_dup(op);}, {}, _ctx)
  kk_std_core_hnd__ev_dropn(___wildcard__685__17, ((int32_t)3), _ctx);
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_context_t*), op, (op, x1, x2, _ctx));
}

kk_std_core_hnd__clause2 kk_std_core_hnd_clause_tail_noyield2(kk_function_t op, kk_context_t* _ctx) { /* forall<e,a,b,c,d,a1> (op : (b, c) -> e d) -> clause2<b,c,d,a1,e,a> */ 
  return kk_std_core_hnd__new_Clause2(kk_std_core_hnd_new_clause_tail_noyield2_fun10586(op, _ctx), _ctx);
}

kk_evv_t kk_std_core_hnd_evv_swap_with(kk_std_core_hnd__ev ev, kk_context_t* _ctx) { /* forall<a,e> (ev : ev<a>) -> evv<e> */ 
  kk_evv_t _x10587;
  struct kk_std_core_hnd_Ev* _con10588 = kk_std_core_hnd__as_Ev(ev);
  kk_std_core_hnd__htag _pat0 = _con10588->htag;
  kk_box_t _pat2 = _con10588->hnd;
  kk_evv_t w = _con10588->hevv;
  if (kk_likely(kk_std_core_hnd__ev_is_unique(ev))) {
    kk_box_drop(_pat2, _ctx);
    kk_Unit;
    kk_std_core_hnd__htag_drop(_pat0, _ctx);
    kk_Unit;
    kk_Unit;
    kk_std_core_hnd__ev_free(ev);
  }
  else {
    kk_evv_dup(w);
    kk_Unit;
    kk_std_core_hnd__ev_decref(ev, _ctx);
    kk_Unit;
  }
  _x10587 = w; /*std/core/hnd/evv<4181>*/
  return kk_evv_swap(_x10587,kk_context());
}


// lift anonymous function
struct kk_std_core_hnd_clause_value_fun10589__t {
  struct kk_function_s _base;
  kk_box_t v;
};
static kk_box_t kk_std_core_hnd_clause_value_fun10589(kk_function_t _fself, kk_std_core_hnd__marker ___wildcard__637__14, kk_std_core_hnd__ev ___wildcard__637__17, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_value_fun10589(kk_box_t v, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_value_fun10589__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_value_fun10589__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_value_fun10589, kk_context());
  _self->v = v;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_value_fun10589(kk_function_t _fself, kk_std_core_hnd__marker ___wildcard__637__14, kk_std_core_hnd__ev ___wildcard__637__17, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_value_fun10589__t* _self = kk_function_as(struct kk_std_core_hnd_clause_value_fun10589__t*, _fself);
  kk_box_t v = _self->v; /* 4224 */
  kk_drop_match(_self, {kk_box_dup(v);}, {}, _ctx)
  kk_std_core_hnd__ev_dropn(___wildcard__637__17, ((int32_t)3), _ctx);
  return v;
}

kk_std_core_hnd__clause0 kk_std_core_hnd_clause_value(kk_box_t v, kk_context_t* _ctx) { /* forall<a,e,b,c> (v : a) -> clause0<a,b,e,c> */ 
  return kk_std_core_hnd__new_Clause0(kk_std_core_hnd_new_clause_value_fun10589(v, _ctx), _ctx);
}

kk_string_t kk_std_core_hnd_evv_show(kk_evv_t evv, kk_context_t* _ctx) { /* forall<e> (evv : evv<e>) -> string */ 
  return kk_evv_show(evv,kk_context());
}

kk_box_t kk_std_core_hnd_unsafe_reyield(kk_std_core_hnd__yield_info yld, kk_context_t* _ctx) { /* forall<a,e> (yld : yield-info) -> e a */ 
  return kk_yield_reyield(yld,kk_context());
}

kk_std_core_hnd__yield_info kk_std_core_hnd_yield_capture(kk_context_t* _ctx) { /* forall<e> () -> e yield-info */ 
  return kk_yield_capture(kk_context());
}

kk_box_t kk_std_core_hnd_resume(kk_std_core_hnd__resume_context r, kk_box_t x, kk_context_t* _ctx) { /* forall<a,e,e1,b> (r : resume-context<a,e,e1,b>, x : a) -> e b */ 
  kk_function_t _x10591;
  kk_function_t _borrowApp_10536 = kk_std_core_hnd_k(r, _ctx); /*(std/core/hnd/resume-result<2855,2858>) -> 2856 2858*/;
  kk_std_core_hnd__resume_context_drop(r, _ctx);
  _x10591 = _borrowApp_10536; /*(std/core/hnd/resume-result<2855,2858>) -> 2856 2858*/
  kk_std_core_hnd__resume_result _x10590 = kk_std_core_hnd__new_Deep(x, _ctx); /*std/core/hnd/resume-result<80,81>*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__resume_result, kk_context_t*), _x10591, (_x10591, _x10590, _ctx));
}

kk_box_t kk_std_core_hnd_resume_final(kk_context_t* _ctx) { /* forall<a> () -> a */ 
  return kk_fatal_resume_final(kk_context());
}

kk_box_t kk_std_core_hnd_resume_shallow(kk_std_core_hnd__resume_context r, kk_box_t x, kk_context_t* _ctx) { /* forall<a,e,e1,b> (r : resume-context<a,e,e1,b>, x : a) -> e1 b */ 
  kk_function_t _x10593;
  kk_function_t _borrowApp_10535 = kk_std_core_hnd_k(r, _ctx); /*(std/core/hnd/resume-result<2855,2858>) -> 2856 2858*/;
  kk_std_core_hnd__resume_context_drop(r, _ctx);
  _x10593 = _borrowApp_10535; /*(std/core/hnd/resume-result<2855,2858>) -> 2856 2858*/
  kk_std_core_hnd__resume_result _x10592 = kk_std_core_hnd__new_Shallow(x, _ctx); /*std/core/hnd/resume-result<80,81>*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__resume_result, kk_context_t*), _x10593, (_x10593, _x10592, _ctx));
}


// lift anonymous function
struct kk_std_core_hnd_prompt_fun10597__t {
  struct kk_function_s _base;
  kk_std_core_hnd__ev ev;
  kk_function_t ret;
  kk_evv_t w0;
  kk_evv_t w1;
  kk_std_core_hnd__marker m0;
};
static kk_box_t kk_std_core_hnd_prompt_fun10597(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_prompt_fun10597(kk_std_core_hnd__ev ev, kk_function_t ret, kk_evv_t w0, kk_evv_t w1, kk_std_core_hnd__marker m0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_prompt_fun10597__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_prompt_fun10597__t, 5, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_prompt_fun10597, kk_context());
  _self->ev = ev;
  _self->ret = ret;
  _self->w0 = w0;
  _self->w1 = w1;
  _self->m0 = m0;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_prompt_fun10597(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd_prompt_fun10597__t* _self = kk_function_as(struct kk_std_core_hnd_prompt_fun10597__t*, _fself);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<4696> */
  kk_function_t ret = _self->ret; /* (4694) -> 4695 4697 */
  kk_evv_t w0 = _self->w0; /* std/core/hnd/evv<4695> */
  kk_evv_t w1 = _self->w1; /* std/core/hnd/evv<4695> */
  kk_std_core_hnd__marker m0 = _self->m0; /* std/core/hnd/marker<4695,4697> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev);kk_function_dup(ret);kk_evv_dup(w0);kk_evv_dup(w1);kk_std_core_hnd__marker_dup(m0);}, {}, _ctx)
  kk_evv_t w0_sq_ = kk_std_core_hnd_evv_get(_ctx); /*std/core/hnd/evv<4695>*/;
  kk_evv_t w1_sq_;
  bool _match_10533;
  kk_evv_t _x10598 = kk_evv_dup(w0_sq_); /*std/core/hnd/evv<4695>*/
  _match_10533 = kk_std_core_hnd_evv_eq(w0, _x10598, _ctx); /*bool*/
  if (_match_10533) {
    w1_sq_ = w1; /*std/core/hnd/evv<4695>*/
  }
  else {
    kk_evv_drop(w1, _ctx);
    kk_evv_t _x10599 = kk_evv_dup(w0_sq_); /*std/core/hnd/evv<4695>*/
    kk_std_core_hnd__ev _x10600 = kk_std_core_hnd__ev_dup(ev); /*std/core/hnd/ev<4696>*/
    w1_sq_ = kk_std_core_hnd_evv_insert(_x10599, _x10600, _ctx); /*std/core/hnd/evv<4695>*/
  }
  kk_unit_t __1 = kk_Unit;
  kk_evv_t _x10601 = kk_evv_dup(w1_sq_); /*std/core/hnd/evv<4695>*/
  kk_evv_set(_x10601,kk_context());
  kk_box_t _x10602 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), cont, (cont, res, _ctx)); /*4694*/
  return kk_std_core_hnd_prompt(w0_sq_, w1_sq_, ev, m0, ret, _x10602, _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_prompt_fun10603__t {
  struct kk_function_s _base;
  kk_function_t cont0;
  kk_std_core_hnd__ev ev;
  kk_function_t ret;
  kk_evv_t w0;
  kk_evv_t w1;
  kk_std_core_hnd__marker m0;
};
static kk_box_t kk_std_core_hnd_prompt_fun10603(kk_function_t _fself, kk_std_core_hnd__resume_result r, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_prompt_fun10603(kk_function_t cont0, kk_std_core_hnd__ev ev, kk_function_t ret, kk_evv_t w0, kk_evv_t w1, kk_std_core_hnd__marker m0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_prompt_fun10603__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_prompt_fun10603__t, 6, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_prompt_fun10603, kk_context());
  _self->cont0 = cont0;
  _self->ev = ev;
  _self->ret = ret;
  _self->w0 = w0;
  _self->w1 = w1;
  _self->m0 = m0;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_core_hnd_prompt_fun10609__t {
  struct kk_function_s _base;
  kk_box_t x;
};
static kk_box_t kk_std_core_hnd_prompt_fun10609(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_prompt_fun10609(kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_prompt_fun10609__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_prompt_fun10609__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_prompt_fun10609, kk_context());
  _self->x = x;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_prompt_fun10609(kk_function_t _fself, kk_context_t* _ctx) {
  struct kk_std_core_hnd_prompt_fun10609__t* _self = kk_function_as(struct kk_std_core_hnd_prompt_fun10609__t*, _fself);
  kk_box_t x = _self->x; /* 4560 */
  kk_drop_match(_self, {kk_box_dup(x);}, {}, _ctx)
  return x;
}


// lift anonymous function
struct kk_std_core_hnd_prompt_fun10610__t {
  struct kk_function_s _base;
  kk_box_t x0;
};
static kk_box_t kk_std_core_hnd_prompt_fun10610(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_prompt_fun10610(kk_box_t x0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_prompt_fun10610__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_prompt_fun10610__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_prompt_fun10610, kk_context());
  _self->x0 = x0;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_prompt_fun10610(kk_function_t _fself, kk_context_t* _ctx) {
  struct kk_std_core_hnd_prompt_fun10610__t* _self = kk_function_as(struct kk_std_core_hnd_prompt_fun10610__t*, _fself);
  kk_box_t x0 = _self->x0; /* 4560 */
  kk_drop_match(_self, {kk_box_dup(x0);}, {}, _ctx)
  return x0;
}


// lift anonymous function
struct kk_std_core_hnd_prompt_fun10616__t {
  struct kk_function_s _base;
  kk_box_t x10;
  kk_std_core_hnd__marker m0;
};
static kk_box_t kk_std_core_hnd_prompt_fun10616(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_prompt_fun10616(kk_box_t x10, kk_std_core_hnd__marker m0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_prompt_fun10616__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_prompt_fun10616__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_prompt_fun10616, kk_context());
  _self->x10 = x10;
  _self->m0 = m0;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_core_hnd_prompt_fun10617__t {
  struct kk_function_s _base;
  kk_box_t x10;
};
static kk_box_t kk_std_core_hnd_prompt_fun10617(kk_function_t _fself, kk_function_t ___wildcard__327__83, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_prompt_fun10617(kk_box_t x10, kk_context_t* _ctx) {
  struct kk_std_core_hnd_prompt_fun10617__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_prompt_fun10617__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_prompt_fun10617, kk_context());
  _self->x10 = x10;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_prompt_fun10617(kk_function_t _fself, kk_function_t ___wildcard__327__83, kk_context_t* _ctx) {
  struct kk_std_core_hnd_prompt_fun10617__t* _self = kk_function_as(struct kk_std_core_hnd_prompt_fun10617__t*, _fself);
  kk_box_t x10 = _self->x10; /* 4697 */
  kk_drop_match(_self, {kk_box_dup(x10);}, {}, _ctx)
  kk_function_drop(___wildcard__327__83, _ctx);
  return x10;
}
static kk_box_t kk_std_core_hnd_prompt_fun10616(kk_function_t _fself, kk_context_t* _ctx) {
  struct kk_std_core_hnd_prompt_fun10616__t* _self = kk_function_as(struct kk_std_core_hnd_prompt_fun10616__t*, _fself);
  kk_box_t x10 = _self->x10; /* 4697 */
  kk_std_core_hnd__marker m0 = _self->m0; /* std/core/hnd/marker<4695,4697> */
  kk_drop_match(_self, {kk_box_dup(x10);kk_std_core_hnd__marker_dup(m0);}, {}, _ctx)
  return kk_std_core_hnd_yield_to_final(m0, kk_std_core_hnd_new_prompt_fun10617(x10, _ctx), _ctx);
}
static kk_box_t kk_std_core_hnd_prompt_fun10603(kk_function_t _fself, kk_std_core_hnd__resume_result r, kk_context_t* _ctx) {
  struct kk_std_core_hnd_prompt_fun10603__t* _self = kk_function_as(struct kk_std_core_hnd_prompt_fun10603__t*, _fself);
  kk_function_t cont0 = _self->cont0; /* (() -> 4560) -> 4695 4694 */
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<4696> */
  kk_function_t ret = _self->ret; /* (4694) -> 4695 4697 */
  kk_evv_t w0 = _self->w0; /* std/core/hnd/evv<4695> */
  kk_evv_t w1 = _self->w1; /* std/core/hnd/evv<4695> */
  kk_std_core_hnd__marker m0 = _self->m0; /* std/core/hnd/marker<4695,4697> */
  kk_drop_match(_self, {kk_function_dup(cont0);kk_std_core_hnd__ev_dup(ev);kk_function_dup(ret);kk_evv_dup(w0);kk_evv_dup(w1);kk_std_core_hnd__marker_dup(m0);}, {}, _ctx)
  if (kk_std_core_hnd__is_Deep(r)) {
    kk_box_t x = r._cons.Deep.result;
    kk_evv_t w00_sq_ = kk_std_core_hnd_evv_get(_ctx); /*std/core/hnd/evv<4695>*/;
    kk_evv_t w10_sq_;
    bool _match_10532;
    kk_evv_t _x10604 = kk_evv_dup(w00_sq_); /*std/core/hnd/evv<4695>*/
    _match_10532 = kk_std_core_hnd_evv_eq(w0, _x10604, _ctx); /*bool*/
    if (_match_10532) {
      w10_sq_ = w1; /*std/core/hnd/evv<4695>*/
    }
    else {
      kk_evv_drop(w1, _ctx);
      kk_evv_t _x10605 = kk_evv_dup(w00_sq_); /*std/core/hnd/evv<4695>*/
      kk_std_core_hnd__ev _x10606 = kk_std_core_hnd__ev_dup(ev); /*std/core/hnd/ev<4696>*/
      w10_sq_ = kk_std_core_hnd_evv_insert(_x10605, _x10606, _ctx); /*std/core/hnd/evv<4695>*/
    }
    kk_unit_t __2 = kk_Unit;
    kk_evv_t _x10607 = kk_evv_dup(w10_sq_); /*std/core/hnd/evv<4695>*/
    kk_evv_set(_x10607,kk_context());
    kk_box_t _x10608 = kk_function_call(kk_box_t, (kk_function_t, kk_function_t, kk_context_t*), cont0, (cont0, kk_std_core_hnd_new_prompt_fun10609(x, _ctx), _ctx)); /*4694*/
    return kk_std_core_hnd_prompt(w00_sq_, w10_sq_, ev, m0, ret, _x10608, _ctx);
  }
  if (kk_std_core_hnd__is_Shallow(r)) {
    kk_box_t x0 = r._cons.Shallow.result;
    kk_evv_drop(w0, _ctx);
    kk_evv_drop(w1, _ctx);
    kk_std_core_hnd__ev_dropn(ev, ((int32_t)3), _ctx);
    kk_Unit;
    kk_box_t x1_10268 = kk_function_call(kk_box_t, (kk_function_t, kk_function_t, kk_context_t*), cont0, (cont0, kk_std_core_hnd_new_prompt_fun10610(x0, _ctx), _ctx)); /*4694*/;
    if (kk_yielding(kk_context())) {
      kk_box_drop(x1_10268, _ctx);
      return kk_std_core_hnd_yield_extend(ret, _ctx);
    }
    return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), ret, (ret, x1_10268, _ctx));
  }
  kk_box_t x10 = r._cons.Finalize.result;
  kk_evv_t w01_sq_ = kk_std_core_hnd_evv_get(_ctx); /*std/core/hnd/evv<4695>*/;
  kk_evv_t w11_sq_;
  bool _match_10530;
  kk_evv_t _x10611 = kk_evv_dup(w01_sq_); /*std/core/hnd/evv<4695>*/
  _match_10530 = kk_std_core_hnd_evv_eq(w0, _x10611, _ctx); /*bool*/
  if (_match_10530) {
    w11_sq_ = w1; /*std/core/hnd/evv<4695>*/
  }
  else {
    kk_evv_drop(w1, _ctx);
    kk_evv_t _x10612 = kk_evv_dup(w01_sq_); /*std/core/hnd/evv<4695>*/
    kk_std_core_hnd__ev _x10613 = kk_std_core_hnd__ev_dup(ev); /*std/core/hnd/ev<4696>*/
    w11_sq_ = kk_std_core_hnd_evv_insert(_x10612, _x10613, _ctx); /*std/core/hnd/evv<4695>*/
  }
  kk_unit_t __3 = kk_Unit;
  kk_evv_t _x10614 = kk_evv_dup(w11_sq_); /*std/core/hnd/evv<4695>*/
  kk_evv_set(_x10614,kk_context());
  kk_box_t _x10615 = kk_function_call(kk_box_t, (kk_function_t, kk_function_t, kk_context_t*), cont0, (cont0, kk_std_core_hnd_new_prompt_fun10616(x10, m0, _ctx), _ctx)); /*4694*/
  return kk_std_core_hnd_prompt(w01_sq_, w11_sq_, ev, m0, ret, _x10615, _ctx);
}

kk_box_t kk_std_core_hnd_prompt(kk_evv_t w0, kk_evv_t w1, kk_std_core_hnd__ev ev, kk_std_core_hnd__marker m0, kk_function_t ret, kk_box_t result, kk_context_t* _ctx) { /* forall<a,e,b,c> (w0 : evv<e>, w1 : evv<e>, ev : ev<b>, m : marker<e,c>, ret : (a) -> e c, result : a) -> e c */ 
  kk_unit_t __ = kk_Unit;
  kk_evv_t _x10595 = kk_evv_dup(w1); /*std/core/hnd/evv<4695>*/
  kk_std_core_hnd_guard(_x10595, _ctx);
  kk_unit_t __0 = kk_Unit;
  kk_evv_t _x10596 = kk_evv_dup(w0); /*std/core/hnd/evv<4695>*/
  kk_evv_set(_x10596,kk_context());
  kk_std_core_hnd__yld _match_10529 = kk_std_core_hnd_yield_prompt(m0, _ctx); /*std/core/hnd/yld<3900,3899,3901>*/;
  if (kk_std_core_hnd__is_Pure(_match_10529)) {
    kk_std_core_hnd__ev_dropn(ev, ((int32_t)3), _ctx);
    kk_evv_drop(w0, _ctx);
    kk_evv_drop(w1, _ctx);
    return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), ret, (ret, result, _ctx));
  }
  if (kk_std_core_hnd__is_YieldingFinal(_match_10529)) {
    kk_std_core_hnd__ev_dropn(ev, ((int32_t)3), _ctx);
    kk_box_drop(result, _ctx);
    kk_function_drop(ret, _ctx);
    kk_evv_drop(w0, _ctx);
    kk_evv_drop(w1, _ctx);
    return kk_box_any(kk_context());
  }
  if (kk_std_core_hnd__is_Yielding(_match_10529)) {
    kk_box_drop(result, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_prompt_fun10597(ev, ret, w0, w1, m0, _ctx), _ctx);
  }
  kk_function_t clause0 = _match_10529._cons.Yield.clause;
  kk_function_t cont0 = _match_10529._cons.Yield.cont;
  kk_box_drop(result, _ctx);
  kk_function_dup(clause0);
  kk_function_dup(cont0);
  kk_std_core_hnd__yld_drop(_match_10529, _ctx);
  kk_Unit;
  return kk_function_call(kk_box_t, (kk_function_t, kk_function_t, kk_context_t*), clause0, (clause0, kk_std_core_hnd_new_prompt_fun10603(cont0, ev, ret, w0, w1, m0, _ctx), _ctx));
}

kk_box_t kk_std_core_hnd__hhandle(kk_std_core_hnd__htag tag, int32_t cfc0, kk_box_t h, kk_function_t ret, kk_function_t action, kk_context_t* _ctx) { /* forall<a,e,e1,b,c> (tag : htag<b>, cfc : cfc, h : b<e,c>, ret : (a) -> e c, action : () -> e1 a) -> e c */ 
  kk_evv_t w0 = kk_std_core_hnd_evv_get(_ctx); /*std/core/hnd/evv<4793>*/;
  kk_std_core_hnd__marker m0;
  int32_t _x10618 = kk_std_core_hnd_fresh_marker_int(_ctx); /*int32*/
  m0 = kk_std_core_hnd__new_Marker(_x10618, _ctx); /*std/core/hnd/marker<4793,4796>*/
  kk_std_core_hnd__ev ev;
  kk_evv_t _x10619 = kk_evv_dup(w0); /*std/core/hnd/evv<4793>*/
  ev = kk_std_core_hnd__new_Ev(kk_reuse_null, tag, m0, h, cfc0, _x10619, _ctx); /*std/core/hnd/ev<4795>*/
  kk_evv_t w1;
  kk_evv_t _x10620 = kk_evv_dup(w0); /*std/core/hnd/evv<4793>*/
  kk_std_core_hnd__ev _x10621 = kk_std_core_hnd__ev_dup(ev); /*std/core/hnd/ev<4795>*/
  w1 = kk_std_core_hnd_evv_insert(_x10620, _x10621, _ctx); /*std/core/hnd/evv<4793>*/
  kk_unit_t __ = kk_Unit;
  kk_evv_t _x10622 = kk_evv_dup(w1); /*std/core/hnd/evv<4793>*/
  kk_evv_set(_x10622,kk_context());
  kk_box_t _x10623 = kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), action, (action, _ctx)); /*4792*/
  return kk_std_core_hnd_prompt(w0, w1, ev, m0, ret, _x10623, _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_mask_at1_fun10624__t {
  struct kk_function_s _base;
  bool behind;
  kk_ssize_t i;
};
static kk_box_t kk_std_core_hnd_mask_at1_fun10624(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_mask_at1_fun10624(bool behind, kk_ssize_t i, kk_context_t* _ctx) {
  struct kk_std_core_hnd_mask_at1_fun10624__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_mask_at1_fun10624__t, 1, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_mask_at1_fun10624, kk_context());
  _self->behind = behind;
  _self->i = i;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_mask_at1_fun10624(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd_mask_at1_fun10624__t* _self = kk_function_as(struct kk_std_core_hnd_mask_at1_fun10624__t*, _fself);
  bool behind = _self->behind; /* bool */
  kk_ssize_t i = _self->i; /* std/core/hnd/ev-index */
  kk_drop_match(_self, {;;}, {}, _ctx)
  return kk_std_core_hnd_mask_at1(i, behind, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd_mask_at1(kk_ssize_t i, bool behind, kk_function_t action, kk_box_t x, kk_context_t* _ctx) { /* forall<a,b,e,e1> (i : ev-index, behind : bool, action : (a) -> e b, x : a) -> e1 b */ 
  kk_evv_t w0 = kk_std_core_hnd_evv_swap_delete(i, behind, _ctx); /*std/core/hnd/evv<_4801>*/;
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), action, (action, x, _ctx)); /*4907*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w0,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_mask_at1_fun10624(behind, i, _ctx), _ctx);
  }
  return y;
}


// lift anonymous function
struct kk_std_core_hnd__mask_at_fun10625__t {
  struct kk_function_s _base;
  bool behind;
  kk_ssize_t i;
};
static kk_box_t kk_std_core_hnd__mask_at_fun10625(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_mask_at_fun10625(bool behind, kk_ssize_t i, kk_context_t* _ctx) {
  struct kk_std_core_hnd__mask_at_fun10625__t* _self = kk_function_alloc_as(struct kk_std_core_hnd__mask_at_fun10625__t, 1, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd__mask_at_fun10625, kk_context());
  _self->behind = behind;
  _self->i = i;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd__mask_at_fun10625(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd__mask_at_fun10625__t* _self = kk_function_as(struct kk_std_core_hnd__mask_at_fun10625__t*, _fself);
  bool behind = _self->behind; /* bool */
  kk_ssize_t i = _self->i; /* std/core/hnd/ev-index */
  kk_drop_match(_self, {;;}, {}, _ctx)
  return kk_std_core_hnd_mask_at1(i, behind, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd__mask_at(kk_ssize_t i, bool behind, kk_function_t action, kk_context_t* _ctx) { /* forall<a,e,e1> (i : ev-index, behind : bool, action : () -> e a) -> e1 a */ 
  kk_evv_t w0 = kk_std_core_hnd_evv_swap_delete(i, behind, _ctx); /*std/core/hnd/evv<_4913>*/;
  kk_box_t x = kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), action, (action, _ctx)); /*5002*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w0,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(x, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd__new_mask_at_fun10625(behind, i, _ctx), _ctx);
  }
  return x;
}

kk_box_t kk_std_core_hnd__named_handle(kk_std_core_hnd__htag tag, int32_t cfc0, kk_box_t h, kk_function_t ret, kk_function_t action, kk_context_t* _ctx) { /* forall<a,e,e1,b,c> (tag : htag<b>, cfc : cfc, h : b<e,c>, ret : (a) -> e c, action : (ev<b>) -> e1 a) -> e c */ 
  kk_std_core_hnd__marker m0;
  int32_t _x10627 = kk_std_core_hnd_fresh_marker_named_int(_ctx); /*int32*/
  m0 = kk_std_core_hnd__new_Marker(_x10627, _ctx); /*std/core/hnd/marker<5117,5120>*/
  kk_evv_t w0 = kk_std_core_hnd_evv_get(_ctx); /*std/core/hnd/evv<5117>*/;
  kk_std_core_hnd__ev ev;
  kk_evv_t _x10628 = kk_evv_dup(w0); /*std/core/hnd/evv<5117>*/
  ev = kk_std_core_hnd__new_Ev(kk_reuse_null, tag, m0, h, cfc0, _x10628, _ctx); /*std/core/hnd/ev<5119>*/
  kk_evv_t _x10629 = kk_evv_dup(w0); /*std/core/hnd/evv<5117>*/
  kk_std_core_hnd__ev _x10630 = kk_std_core_hnd__ev_dup(ev); /*std/core/hnd/ev<5119>*/
  kk_box_t _x10631 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__ev, kk_context_t*), action, (action, ev, _ctx)); /*5116*/
  return kk_std_core_hnd_prompt(_x10629, w0, _x10630, m0, ret, _x10631, _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_open_at1_fun10632__t {
  struct kk_function_s _base;
  kk_ssize_t i;
};
static kk_box_t kk_std_core_hnd_open_at1_fun10632(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_open_at1_fun10632(kk_ssize_t i, kk_context_t* _ctx) {
  struct kk_std_core_hnd_open_at1_fun10632__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_open_at1_fun10632__t, 1, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_open_at1_fun10632, kk_context());
  _self->i = i;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_open_at1_fun10632(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd_open_at1_fun10632__t* _self = kk_function_as(struct kk_std_core_hnd_open_at1_fun10632__t*, _fself);
  kk_ssize_t i = _self->i; /* std/core/hnd/ev-index */
  kk_drop_match(_self, {;}, {}, _ctx)
  return kk_std_core_hnd_open_at1(i, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd_open_at1(kk_ssize_t i, kk_function_t f, kk_box_t x, kk_context_t* _ctx) { /* forall<a,b,e,e1> (i : ev-index, f : (a) -> e b, x : a) -> e1 b */ 
  kk_evv_t w = kk_evv_swap_create1(i,kk_context()); /*std/core/hnd/evv<5230>*/;
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, x, _ctx)); /*5228*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_open_at1_fun10632(i, _ctx), _ctx);
  }
  return y;
}


// lift anonymous function
struct kk_std_core_hnd__open_at0_fun10633__t {
  struct kk_function_s _base;
  kk_ssize_t i;
};
static kk_box_t kk_std_core_hnd__open_at0_fun10633(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_open_at0_fun10633(kk_ssize_t i, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open_at0_fun10633__t* _self = kk_function_alloc_as(struct kk_std_core_hnd__open_at0_fun10633__t, 1, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd__open_at0_fun10633, kk_context());
  _self->i = i;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd__open_at0_fun10633(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open_at0_fun10633__t* _self = kk_function_as(struct kk_std_core_hnd__open_at0_fun10633__t*, _fself);
  kk_ssize_t i = _self->i; /* std/core/hnd/ev-index */
  kk_drop_match(_self, {;}, {}, _ctx)
  return kk_std_core_hnd_open_at1(i, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd__open_at0(kk_ssize_t i, kk_function_t f, kk_context_t* _ctx) { /* forall<a,e,e1> (i : ev-index, f : () -> e a) -> e1 a */ 
  kk_evv_t w = kk_evv_swap_create1(i,kk_context()); /*std/core/hnd/evv<5322>*/;
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), f, (f, _ctx)); /*5320*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd__new_open_at0_fun10633(i, _ctx), _ctx);
  }
  return y;
}


// lift anonymous function
struct kk_std_core_hnd__open_at1_fun10634__t {
  struct kk_function_s _base;
  kk_ssize_t i;
};
static kk_box_t kk_std_core_hnd__open_at1_fun10634(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_open_at1_fun10634(kk_ssize_t i, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open_at1_fun10634__t* _self = kk_function_alloc_as(struct kk_std_core_hnd__open_at1_fun10634__t, 1, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd__open_at1_fun10634, kk_context());
  _self->i = i;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd__open_at1_fun10634(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open_at1_fun10634__t* _self = kk_function_as(struct kk_std_core_hnd__open_at1_fun10634__t*, _fself);
  kk_ssize_t i = _self->i; /* std/core/hnd/ev-index */
  kk_drop_match(_self, {;}, {}, _ctx)
  return kk_std_core_hnd_open_at1(i, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd__open_at1(kk_ssize_t i, kk_function_t f, kk_box_t x, kk_context_t* _ctx) { /* forall<a,b,e,e1> (i : ev-index, f : (a) -> e b, x : a) -> e1 b */ 
  kk_evv_t w = kk_evv_swap_create1(i,kk_context()); /*std/core/hnd/evv<5429>*/;
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, x, _ctx)); /*5427*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd__new_open_at1_fun10634(i, _ctx), _ctx);
  }
  return y;
}


// lift anonymous function
struct kk_std_core_hnd__open_at2_fun10635__t {
  struct kk_function_s _base;
  kk_ssize_t i;
};
static kk_box_t kk_std_core_hnd__open_at2_fun10635(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_open_at2_fun10635(kk_ssize_t i, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open_at2_fun10635__t* _self = kk_function_alloc_as(struct kk_std_core_hnd__open_at2_fun10635__t, 1, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd__open_at2_fun10635, kk_context());
  _self->i = i;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd__open_at2_fun10635(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open_at2_fun10635__t* _self = kk_function_as(struct kk_std_core_hnd__open_at2_fun10635__t*, _fself);
  kk_ssize_t i = _self->i; /* std/core/hnd/ev-index */
  kk_drop_match(_self, {;}, {}, _ctx)
  return kk_std_core_hnd_open_at1(i, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd__open_at2(kk_ssize_t i, kk_function_t f, kk_box_t x1, kk_box_t x2, kk_context_t* _ctx) { /* forall<a,b,c,e,e1> (i : ev-index, f : (a, b) -> e c, x1 : a, x2 : b) -> e1 c */ 
  kk_evv_t w = kk_evv_swap_create1(i,kk_context()); /*std/core/hnd/evv<5551>*/;
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_context_t*), f, (f, x1, x2, _ctx)); /*5549*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd__new_open_at2_fun10635(i, _ctx), _ctx);
  }
  return y;
}


// lift anonymous function
struct kk_std_core_hnd__open_at3_fun10636__t {
  struct kk_function_s _base;
  kk_ssize_t i;
};
static kk_box_t kk_std_core_hnd__open_at3_fun10636(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_open_at3_fun10636(kk_ssize_t i, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open_at3_fun10636__t* _self = kk_function_alloc_as(struct kk_std_core_hnd__open_at3_fun10636__t, 1, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd__open_at3_fun10636, kk_context());
  _self->i = i;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd__open_at3_fun10636(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open_at3_fun10636__t* _self = kk_function_as(struct kk_std_core_hnd__open_at3_fun10636__t*, _fself);
  kk_ssize_t i = _self->i; /* std/core/hnd/ev-index */
  kk_drop_match(_self, {;}, {}, _ctx)
  return kk_std_core_hnd_open_at1(i, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd__open_at3(kk_ssize_t i, kk_function_t f, kk_box_t x1, kk_box_t x2, kk_box_t x3, kk_context_t* _ctx) { /* forall<a,b,c,d,e,e1> (i : ev-index, f : (a, b, c) -> e d, x1 : a, x2 : b, x3 : c) -> e1 d */ 
  kk_evv_t w = kk_evv_swap_create1(i,kk_context()); /*std/core/hnd/evv<5625>*/;
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_context_t*), f, (f, x1, x2, x3, _ctx)); /*5623*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd__new_open_at3_fun10636(i, _ctx), _ctx);
  }
  return y;
}


// lift anonymous function
struct kk_std_core_hnd__open_at4_fun10637__t {
  struct kk_function_s _base;
  kk_ssize_t i;
};
static kk_box_t kk_std_core_hnd__open_at4_fun10637(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_open_at4_fun10637(kk_ssize_t i, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open_at4_fun10637__t* _self = kk_function_alloc_as(struct kk_std_core_hnd__open_at4_fun10637__t, 1, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd__open_at4_fun10637, kk_context());
  _self->i = i;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd__open_at4_fun10637(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open_at4_fun10637__t* _self = kk_function_as(struct kk_std_core_hnd__open_at4_fun10637__t*, _fself);
  kk_ssize_t i = _self->i; /* std/core/hnd/ev-index */
  kk_drop_match(_self, {;}, {}, _ctx)
  return kk_std_core_hnd_open_at1(i, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd__open_at4(kk_ssize_t i, kk_function_t f, kk_box_t x1, kk_box_t x2, kk_box_t x3, kk_box_t x4, kk_context_t* _ctx) { /* forall<a,b,c,d,a1,e,e1> (i : ev-index, f : (a, b, c, d) -> e a1, x1 : a, x2 : b, x3 : c, x4 : d) -> e1 a1 */ 
  kk_evv_t w = kk_evv_swap_create1(i,kk_context()); /*std/core/hnd/evv<5705>*/;
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_box_t, kk_context_t*), f, (f, x1, x2, x3, x4, _ctx)); /*5703*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd__new_open_at4_fun10637(i, _ctx), _ctx);
  }
  return y;
}


// lift anonymous function
struct kk_std_core_hnd_open1_fun10639__t {
  struct kk_function_s _base;
  kk_vector_t indices;
};
static kk_box_t kk_std_core_hnd_open1_fun10639(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_open1_fun10639(kk_vector_t indices, kk_context_t* _ctx) {
  struct kk_std_core_hnd_open1_fun10639__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_open1_fun10639__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_open1_fun10639, kk_context());
  _self->indices = indices;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_open1_fun10639(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd_open1_fun10639__t* _self = kk_function_as(struct kk_std_core_hnd_open1_fun10639__t*, _fself);
  kk_vector_t indices = _self->indices; /* vector<std/core/hnd/ev-index> */
  kk_drop_match(_self, {kk_vector_dup(indices);}, {}, _ctx)
  return kk_std_core_hnd_open1(indices, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd_open1(kk_vector_t indices, kk_function_t f, kk_box_t x, kk_context_t* _ctx) { /* forall<a,b,e,e1> (indices : vector<ev-index>, f : (a) -> e b, x : a) -> e1 b */ 
  kk_evv_t w;
  kk_vector_t _x10638 = kk_vector_dup(indices); /*vector<std/core/hnd/ev-index>*/
  w = kk_std_core_hnd_evv_swap_create(_x10638, _ctx); /*std/core/hnd/evv<5815>*/
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, x, _ctx)); /*5813*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_open1_fun10639(indices, _ctx), _ctx);
  }
  kk_vector_drop(indices, _ctx);
  return y;
}


// lift anonymous function
struct kk_std_core_hnd__open0_fun10641__t {
  struct kk_function_s _base;
  kk_vector_t indices;
};
static kk_box_t kk_std_core_hnd__open0_fun10641(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_open0_fun10641(kk_vector_t indices, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open0_fun10641__t* _self = kk_function_alloc_as(struct kk_std_core_hnd__open0_fun10641__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd__open0_fun10641, kk_context());
  _self->indices = indices;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd__open0_fun10641(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open0_fun10641__t* _self = kk_function_as(struct kk_std_core_hnd__open0_fun10641__t*, _fself);
  kk_vector_t indices = _self->indices; /* vector<std/core/hnd/ev-index> */
  kk_drop_match(_self, {kk_vector_dup(indices);}, {}, _ctx)
  return kk_std_core_hnd_open1(indices, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd__open0(kk_vector_t indices, kk_function_t f, kk_context_t* _ctx) { /* forall<a,e,e1> (indices : vector<ev-index>, f : () -> e a) -> e1 a */ 
  kk_evv_t w;
  kk_vector_t _x10640 = kk_vector_dup(indices); /*vector<std/core/hnd/ev-index>*/
  w = kk_std_core_hnd_evv_swap_create(_x10640, _ctx); /*std/core/hnd/evv<5907>*/
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), f, (f, _ctx)); /*5905*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd__new_open0_fun10641(indices, _ctx), _ctx);
  }
  kk_vector_drop(indices, _ctx);
  return y;
}


// lift anonymous function
struct kk_std_core_hnd__open1_fun10643__t {
  struct kk_function_s _base;
  kk_vector_t indices;
};
static kk_box_t kk_std_core_hnd__open1_fun10643(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_open1_fun10643(kk_vector_t indices, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open1_fun10643__t* _self = kk_function_alloc_as(struct kk_std_core_hnd__open1_fun10643__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd__open1_fun10643, kk_context());
  _self->indices = indices;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd__open1_fun10643(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open1_fun10643__t* _self = kk_function_as(struct kk_std_core_hnd__open1_fun10643__t*, _fself);
  kk_vector_t indices = _self->indices; /* vector<std/core/hnd/ev-index> */
  kk_drop_match(_self, {kk_vector_dup(indices);}, {}, _ctx)
  return kk_std_core_hnd_open1(indices, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd__open1(kk_vector_t indices, kk_function_t f, kk_box_t x, kk_context_t* _ctx) { /* forall<a,b,e,e1> (indices : vector<ev-index>, f : (a) -> e b, x : a) -> e1 b */ 
  kk_evv_t w;
  kk_vector_t _x10642 = kk_vector_dup(indices); /*vector<std/core/hnd/ev-index>*/
  w = kk_std_core_hnd_evv_swap_create(_x10642, _ctx); /*std/core/hnd/evv<6014>*/
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, x, _ctx)); /*6012*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd__new_open1_fun10643(indices, _ctx), _ctx);
  }
  kk_vector_drop(indices, _ctx);
  return y;
}


// lift anonymous function
struct kk_std_core_hnd__open2_fun10645__t {
  struct kk_function_s _base;
  kk_vector_t indices;
};
static kk_box_t kk_std_core_hnd__open2_fun10645(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_open2_fun10645(kk_vector_t indices, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open2_fun10645__t* _self = kk_function_alloc_as(struct kk_std_core_hnd__open2_fun10645__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd__open2_fun10645, kk_context());
  _self->indices = indices;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd__open2_fun10645(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open2_fun10645__t* _self = kk_function_as(struct kk_std_core_hnd__open2_fun10645__t*, _fself);
  kk_vector_t indices = _self->indices; /* vector<std/core/hnd/ev-index> */
  kk_drop_match(_self, {kk_vector_dup(indices);}, {}, _ctx)
  return kk_std_core_hnd_open1(indices, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd__open2(kk_vector_t indices, kk_function_t f, kk_box_t x1, kk_box_t x2, kk_context_t* _ctx) { /* forall<a,b,c,e,e1> (indices : vector<ev-index>, f : (a, b) -> e c, x1 : a, x2 : b) -> e1 c */ 
  kk_evv_t w;
  kk_vector_t _x10644 = kk_vector_dup(indices); /*vector<std/core/hnd/ev-index>*/
  w = kk_std_core_hnd_evv_swap_create(_x10644, _ctx); /*std/core/hnd/evv<6136>*/
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_context_t*), f, (f, x1, x2, _ctx)); /*6134*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd__new_open2_fun10645(indices, _ctx), _ctx);
  }
  kk_vector_drop(indices, _ctx);
  return y;
}


// lift anonymous function
struct kk_std_core_hnd__open3_fun10647__t {
  struct kk_function_s _base;
  kk_vector_t indices;
};
static kk_box_t kk_std_core_hnd__open3_fun10647(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_open3_fun10647(kk_vector_t indices, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open3_fun10647__t* _self = kk_function_alloc_as(struct kk_std_core_hnd__open3_fun10647__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd__open3_fun10647, kk_context());
  _self->indices = indices;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd__open3_fun10647(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open3_fun10647__t* _self = kk_function_as(struct kk_std_core_hnd__open3_fun10647__t*, _fself);
  kk_vector_t indices = _self->indices; /* vector<std/core/hnd/ev-index> */
  kk_drop_match(_self, {kk_vector_dup(indices);}, {}, _ctx)
  return kk_std_core_hnd_open1(indices, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd__open3(kk_vector_t indices, kk_function_t f, kk_box_t x1, kk_box_t x2, kk_box_t x3, kk_context_t* _ctx) { /* forall<a,b,c,d,e,e1> (indices : vector<ev-index>, f : (a, b, c) -> e d, x1 : a, x2 : b, x3 : c) -> e1 d */ 
  kk_evv_t w;
  kk_vector_t _x10646 = kk_vector_dup(indices); /*vector<std/core/hnd/ev-index>*/
  w = kk_std_core_hnd_evv_swap_create(_x10646, _ctx); /*std/core/hnd/evv<6210>*/
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_context_t*), f, (f, x1, x2, x3, _ctx)); /*6208*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd__new_open3_fun10647(indices, _ctx), _ctx);
  }
  kk_vector_drop(indices, _ctx);
  return y;
}


// lift anonymous function
struct kk_std_core_hnd__open4_fun10649__t {
  struct kk_function_s _base;
  kk_vector_t indices;
};
static kk_box_t kk_std_core_hnd__open4_fun10649(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_open4_fun10649(kk_vector_t indices, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open4_fun10649__t* _self = kk_function_alloc_as(struct kk_std_core_hnd__open4_fun10649__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd__open4_fun10649, kk_context());
  _self->indices = indices;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd__open4_fun10649(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open4_fun10649__t* _self = kk_function_as(struct kk_std_core_hnd__open4_fun10649__t*, _fself);
  kk_vector_t indices = _self->indices; /* vector<std/core/hnd/ev-index> */
  kk_drop_match(_self, {kk_vector_dup(indices);}, {}, _ctx)
  return kk_std_core_hnd_open1(indices, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd__open4(kk_vector_t indices, kk_function_t f, kk_box_t x1, kk_box_t x2, kk_box_t x3, kk_box_t x4, kk_context_t* _ctx) { /* forall<a,b,c,d,a1,e,e1> (indices : vector<ev-index>, f : (a, b, c, d) -> e a1, x1 : a, x2 : b, x3 : c, x4 : d) -> e1 a1 */ 
  kk_evv_t w;
  kk_vector_t _x10648 = kk_vector_dup(indices); /*vector<std/core/hnd/ev-index>*/
  w = kk_std_core_hnd_evv_swap_create(_x10648, _ctx); /*std/core/hnd/evv<6290>*/
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_box_t, kk_context_t*), f, (f, x1, x2, x3, x4, _ctx)); /*6288*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd__new_open4_fun10649(indices, _ctx), _ctx);
  }
  kk_vector_drop(indices, _ctx);
  return y;
}


// lift anonymous function
struct kk_std_core_hnd_yield_to_fun10652__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_hnd_yield_to_fun10652(kk_function_t _fself, kk_function_t f, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_yield_to_fun10652(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_hnd_yield_to_fun10652, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_core_hnd_yield_to_fun10652(kk_function_t _fself, kk_function_t f, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), f, (f, _ctx));
}


// lift anonymous function
struct kk_std_core_hnd_yield_to_fun10653__t {
  struct kk_function_s _base;
  kk_function_t _b_10407_10404;
};
static kk_box_t kk_std_core_hnd_yield_to_fun10653(kk_function_t _fself, kk_box_t _b_10405, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_yield_to_fun10653(kk_function_t _b_10407_10404, kk_context_t* _ctx) {
  struct kk_std_core_hnd_yield_to_fun10653__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_yield_to_fun10653__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_yield_to_fun10653, kk_context());
  _self->_b_10407_10404 = _b_10407_10404;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_yield_to_fun10653(kk_function_t _fself, kk_box_t _b_10405, kk_context_t* _ctx) {
  struct kk_std_core_hnd_yield_to_fun10653__t* _self = kk_function_as(struct kk_std_core_hnd_yield_to_fun10653__t*, _fself);
  kk_function_t _b_10407_10404 = _self->_b_10407_10404; /* (f : () -> 6422 6421) -> 6422 6421 */
  kk_drop_match(_self, {kk_function_dup(_b_10407_10404);}, {}, _ctx)
  kk_function_t _x10654 = kk_function_unbox(_b_10405); /*() -> 6422 10406*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_function_t, kk_context_t*), _b_10407_10404, (_b_10407_10404, _x10654, _ctx));
}

kk_box_t kk_std_core_hnd_yield_to(kk_std_core_hnd__marker m0, kk_function_t clause0, kk_context_t* _ctx) { /* forall<a,e,b> (m : marker<e,b>, clause : ((resume-result<a,b>) -> e b) -> e b) -> e a */ 
  kk_function_t g = kk_std_core_hnd_yield_to_prim(m0, clause0, _ctx); /*() -> 6421*/;
  kk_function_drop(g, _ctx);
  kk_function_t _b_10407_10404 = kk_std_core_hnd_new_yield_to_fun10652(_ctx); /*(f : () -> 6422 6421) -> 6422 6421*/;
  return kk_std_core_hnd_yield_extend(kk_std_core_hnd_new_yield_to_fun10653(_b_10407_10404, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_control_raw0_fun10655__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_control_raw0_fun10655(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__614__16, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control_raw0_fun10655(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw0_fun10655__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control_raw0_fun10655__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_control_raw0_fun10655, kk_context());
  _self->op = op;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_core_hnd_clause_control_raw0_fun10656__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_control_raw0_fun10656(kk_function_t _fself, kk_function_t k0, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control_raw0_fun10656(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw0_fun10656__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control_raw0_fun10656__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_control_raw0_fun10656, kk_context());
  _self->op = op;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_control_raw0_fun10656(kk_function_t _fself, kk_function_t k0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw0_fun10656__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control_raw0_fun10656__t*, _fself);
  kk_function_t op = _self->op; /* (std/core/hnd/resume-context<6462,6463,6464,6466>) -> 6463 6466 */
  kk_drop_match(_self, {kk_function_dup(op);}, {}, _ctx)
  kk_std_core_hnd__resume_context _x10657 = kk_std_core_hnd__new_Resume_context(k0, _ctx); /*std/core/hnd/resume-context<89,90,91,92>*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__resume_context, kk_context_t*), op, (op, _x10657, _ctx));
}
static kk_box_t kk_std_core_hnd_clause_control_raw0_fun10655(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__614__16, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw0_fun10655__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control_raw0_fun10655__t*, _fself);
  kk_function_t op = _self->op; /* (std/core/hnd/resume-context<6462,6463,6464,6466>) -> 6463 6466 */
  kk_drop_match(_self, {kk_function_dup(op);}, {}, _ctx)
  kk_std_core_hnd__ev_dropn(___wildcard__614__16, ((int32_t)3), _ctx);
  return kk_std_core_hnd_yield_to(m0, kk_std_core_hnd_new_clause_control_raw0_fun10656(op, _ctx), _ctx);
}

kk_std_core_hnd__clause0 kk_std_core_hnd_clause_control_raw0(kk_function_t op, kk_context_t* _ctx) { /* forall<a,e,e1,b,c> (op : (resume-context<a,e,e1,c>) -> e c) -> clause0<a,b,e,c> */ 
  return kk_std_core_hnd__new_Clause0(kk_std_core_hnd_new_clause_control_raw0_fun10655(op, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_control_raw1_fun10658__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_control_raw1_fun10658(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__539__16, kk_box_t x, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control_raw1_fun10658(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw1_fun10658__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control_raw1_fun10658__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_control_raw1_fun10658, kk_context());
  _self->op = op;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_core_hnd_clause_control_raw1_fun10659__t {
  struct kk_function_s _base;
  kk_function_t op;
  kk_box_t x;
};
static kk_box_t kk_std_core_hnd_clause_control_raw1_fun10659(kk_function_t _fself, kk_function_t k0, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control_raw1_fun10659(kk_function_t op, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw1_fun10659__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control_raw1_fun10659__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_control_raw1_fun10659, kk_context());
  _self->op = op;
  _self->x = x;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_control_raw1_fun10659(kk_function_t _fself, kk_function_t k0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw1_fun10659__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control_raw1_fun10659__t*, _fself);
  kk_function_t op = _self->op; /* (x : 6510, r : std/core/hnd/resume-context<6511,6512,6513,6515>) -> 6512 6515 */
  kk_box_t x = _self->x; /* 6510 */
  kk_drop_match(_self, {kk_function_dup(op);kk_box_dup(x);}, {}, _ctx)
  kk_std_core_hnd__resume_context _x10660 = kk_std_core_hnd__new_Resume_context(k0, _ctx); /*std/core/hnd/resume-context<89,90,91,92>*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_std_core_hnd__resume_context, kk_context_t*), op, (op, x, _x10660, _ctx));
}
static kk_box_t kk_std_core_hnd_clause_control_raw1_fun10658(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__539__16, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw1_fun10658__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control_raw1_fun10658__t*, _fself);
  kk_function_t op = _self->op; /* (x : 6510, r : std/core/hnd/resume-context<6511,6512,6513,6515>) -> 6512 6515 */
  kk_drop_match(_self, {kk_function_dup(op);}, {}, _ctx)
  kk_std_core_hnd__ev_dropn(___wildcard__539__16, ((int32_t)3), _ctx);
  return kk_std_core_hnd_yield_to(m0, kk_std_core_hnd_new_clause_control_raw1_fun10659(op, x, _ctx), _ctx);
}

kk_std_core_hnd__clause1 kk_std_core_hnd_clause_control_raw1(kk_function_t op, kk_context_t* _ctx) { /* forall<a,b,e,e1,c,d> (op : (x : a, r : resume-context<b,e,e1,d>) -> e d) -> clause1<a,b,c,e,d> */ 
  return kk_std_core_hnd__new_Clause1(kk_std_core_hnd_new_clause_control_raw1_fun10658(op, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_control_raw2_fun10661__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_control_raw2_fun10661(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__677__16, kk_box_t x1, kk_box_t x2, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control_raw2_fun10661(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw2_fun10661__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control_raw2_fun10661__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_control_raw2_fun10661, kk_context());
  _self->op = op;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_core_hnd_clause_control_raw2_fun10662__t {
  struct kk_function_s _base;
  kk_function_t op;
  kk_box_t x1;
  kk_box_t x2;
};
static kk_box_t kk_std_core_hnd_clause_control_raw2_fun10662(kk_function_t _fself, kk_function_t k0, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control_raw2_fun10662(kk_function_t op, kk_box_t x1, kk_box_t x2, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw2_fun10662__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control_raw2_fun10662__t, 4, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_control_raw2_fun10662, kk_context());
  _self->op = op;
  _self->x1 = x1;
  _self->x2 = x2;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_control_raw2_fun10662(kk_function_t _fself, kk_function_t k0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw2_fun10662__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control_raw2_fun10662__t*, _fself);
  kk_function_t op = _self->op; /* (x1 : 6564, x2 : 6565, r : std/core/hnd/resume-context<6566,6567,6568,6570>) -> 6567 6570 */
  kk_box_t x1 = _self->x1; /* 6564 */
  kk_box_t x2 = _self->x2; /* 6565 */
  kk_drop_match(_self, {kk_function_dup(op);kk_box_dup(x1);kk_box_dup(x2);}, {}, _ctx)
  kk_std_core_hnd__resume_context _x10663 = kk_std_core_hnd__new_Resume_context(k0, _ctx); /*std/core/hnd/resume-context<89,90,91,92>*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_std_core_hnd__resume_context, kk_context_t*), op, (op, x1, x2, _x10663, _ctx));
}
static kk_box_t kk_std_core_hnd_clause_control_raw2_fun10661(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__677__16, kk_box_t x1, kk_box_t x2, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw2_fun10661__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control_raw2_fun10661__t*, _fself);
  kk_function_t op = _self->op; /* (x1 : 6564, x2 : 6565, r : std/core/hnd/resume-context<6566,6567,6568,6570>) -> 6567 6570 */
  kk_drop_match(_self, {kk_function_dup(op);}, {}, _ctx)
  kk_std_core_hnd__ev_dropn(___wildcard__677__16, ((int32_t)3), _ctx);
  return kk_std_core_hnd_yield_to(m0, kk_std_core_hnd_new_clause_control_raw2_fun10662(op, x1, x2, _ctx), _ctx);
}

kk_std_core_hnd__clause2 kk_std_core_hnd_clause_control_raw2(kk_function_t op, kk_context_t* _ctx) { /* forall<a,b,c,e,e1,d,a1> (op : (x1 : a, x2 : b, r : resume-context<c,e,e1,a1>) -> e a1) -> clause2<a,b,c,d,e,a1> */ 
  return kk_std_core_hnd__new_Clause2(kk_std_core_hnd_new_clause_control_raw2_fun10661(op, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_control_raw3_fun10664__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_control_raw3_fun10664(kk_function_t _fself, kk_std_core_types__tuple3_ x, kk_std_core_hnd__resume_context r, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control_raw3_fun10664(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw3_fun10664__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control_raw3_fun10664__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_control_raw3_fun10664, kk_context());
  _self->op = op;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_control_raw3_fun10664(kk_function_t _fself, kk_std_core_types__tuple3_ x, kk_std_core_hnd__resume_context r, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw3_fun10664__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control_raw3_fun10664__t*, _fself);
  kk_function_t op = _self->op; /* (x1 : 6805, x2 : 6806, x3 : 6807, r : std/core/hnd/resume-context<6808,6809,6810,6812>) -> 6809 6812 */
  kk_drop_match(_self, {kk_function_dup(op);}, {}, _ctx)
  kk_box_t _x10665 = kk_std_core_types_fst_1(x, _ctx); /*486*/
  kk_box_t _x10666 = kk_std_core_types_snd_1(x, _ctx); /*530*/
  kk_box_t _x10667;
  kk_box_t _borrowApp_10512 = kk_std_core_types_thd(x, _ctx); /*574*/;
  kk_std_core_types__tuple3__drop(x, _ctx);
  _x10667 = _borrowApp_10512; /*574*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_std_core_hnd__resume_context, kk_context_t*), op, (op, _x10665, _x10666, _x10667, r, _ctx));
}


// lift anonymous function
struct kk_std_core_hnd_clause_control_raw3_fun10668__t {
  struct kk_function_s _base;
  kk_function_t _b_10411_10408;
};
static kk_box_t kk_std_core_hnd_clause_control_raw3_fun10668(kk_function_t _fself, kk_box_t _b_10409, kk_std_core_hnd__resume_context _b_10410, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control_raw3_fun10668(kk_function_t _b_10411_10408, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw3_fun10668__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control_raw3_fun10668__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_control_raw3_fun10668, kk_context());
  _self->_b_10411_10408 = _b_10411_10408;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_control_raw3_fun10668(kk_function_t _fself, kk_box_t _b_10409, kk_std_core_hnd__resume_context _b_10410, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw3_fun10668__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control_raw3_fun10668__t*, _fself);
  kk_function_t _b_10411_10408 = _self->_b_10411_10408; /* (x : (6805, 6806, 6807), r : std/core/hnd/resume-context<6808,6809,6810,6812>) -> 6809 6812 */
  kk_drop_match(_self, {kk_function_dup(_b_10411_10408);}, {}, _ctx)
  kk_std_core_types__tuple3_ _x10669 = kk_std_core_types__tuple3__unbox(_b_10409, _ctx); /*(6805, 6806, 6807)*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_types__tuple3_, kk_std_core_hnd__resume_context, kk_context_t*), _b_10411_10408, (_b_10411_10408, _x10669, _b_10410, _ctx));
}

kk_std_core_hnd__clause1 kk_std_core_hnd_clause_control_raw3(kk_function_t op, kk_context_t* _ctx) { /* forall<a,b,c,d,e,e1,a1,b1> (op : (x1 : a, x2 : b, x3 : c, r : resume-context<d,e,e1,b1>) -> e b1) -> clause1<(a, b, c),d,a1,e,b1> */ 
  kk_function_t _b_10411_10408 = kk_std_core_hnd_new_clause_control_raw3_fun10664(op, _ctx); /*(x : (6805, 6806, 6807), r : std/core/hnd/resume-context<6808,6809,6810,6812>) -> 6809 6812*/;
  return kk_std_core_hnd_clause_control_raw1(kk_std_core_hnd_new_clause_control_raw3_fun10668(_b_10411_10408, _ctx), _ctx);
}
 
// lifted
// specialized std/core/hnd/prompt to parameters [ret]


// lift anonymous function
struct kk_std_core_hnd__lift10303_finalize_fun10672__t {
  struct kk_function_s _base;
  kk_std_core_hnd__ev ev;
  kk_evv_t w0;
  kk_evv_t w1;
  kk_std_core_hnd__marker m00;
};
static kk_box_t kk_std_core_hnd__lift10303_finalize_fun10672(kk_function_t _fself, kk_function_t cont0, kk_box_t res0, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_lift10303_finalize_fun10672(kk_std_core_hnd__ev ev, kk_evv_t w0, kk_evv_t w1, kk_std_core_hnd__marker m00, kk_context_t* _ctx) {
  struct kk_std_core_hnd__lift10303_finalize_fun10672__t* _self = kk_function_alloc_as(struct kk_std_core_hnd__lift10303_finalize_fun10672__t, 4, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd__lift10303_finalize_fun10672, kk_context());
  _self->ev = ev;
  _self->w0 = w0;
  _self->w1 = w1;
  _self->m00 = m00;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd__lift10303_finalize_fun10672(kk_function_t _fself, kk_function_t cont0, kk_box_t res0, kk_context_t* _ctx) {
  struct kk_std_core_hnd__lift10303_finalize_fun10672__t* _self = kk_function_as(struct kk_std_core_hnd__lift10303_finalize_fun10672__t*, _fself);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<_6833> */
  kk_evv_t w0 = _self->w0; /* std/core/hnd/evv<6873> */
  kk_evv_t w1 = _self->w1; /* std/core/hnd/evv<6873> */
  kk_std_core_hnd__marker m00 = _self->m00; /* std/core/hnd/marker<6873,6871> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev);kk_evv_dup(w0);kk_evv_dup(w1);kk_std_core_hnd__marker_dup(m00);}, {}, _ctx)
  kk_evv_t w0_sq_ = kk_std_core_hnd_evv_get(_ctx); /*std/core/hnd/evv<6873>*/;
  kk_evv_t w1_sq_;
  bool _match_10511;
  kk_evv_t _x10673 = kk_evv_dup(w0_sq_); /*std/core/hnd/evv<6873>*/
  _match_10511 = kk_std_core_hnd_evv_eq(w0, _x10673, _ctx); /*bool*/
  if (_match_10511) {
    w1_sq_ = w1; /*std/core/hnd/evv<6873>*/
  }
  else {
    kk_evv_drop(w1, _ctx);
    kk_evv_t _x10674 = kk_evv_dup(w0_sq_); /*std/core/hnd/evv<6873>*/
    kk_std_core_hnd__ev _x10675 = kk_std_core_hnd__ev_dup(ev); /*std/core/hnd/ev<_6833>*/
    w1_sq_ = kk_std_core_hnd_evv_insert(_x10674, _x10675, _ctx); /*std/core/hnd/evv<6873>*/
  }
  kk_unit_t __1 = kk_Unit;
  kk_evv_t _x10676 = kk_evv_dup(w1_sq_); /*std/core/hnd/evv<6873>*/
  kk_evv_set(_x10676,kk_context());
  kk_box_t result0_10308 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), cont0, (cont0, res0, _ctx)); /*6871*/;
  return kk_std_core_hnd__lift10303_finalize(w0_sq_, w1_sq_, ev, m00, result0_10308, _ctx);
}


// lift anonymous function
struct kk_std_core_hnd__lift10303_finalize_fun10677__t {
  struct kk_function_s _base;
  kk_function_t cont00;
  kk_std_core_hnd__ev ev;
  kk_evv_t w0;
  kk_evv_t w1;
  kk_std_core_hnd__marker m00;
};
static kk_box_t kk_std_core_hnd__lift10303_finalize_fun10677(kk_function_t _fself, kk_std_core_hnd__resume_result r, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_lift10303_finalize_fun10677(kk_function_t cont00, kk_std_core_hnd__ev ev, kk_evv_t w0, kk_evv_t w1, kk_std_core_hnd__marker m00, kk_context_t* _ctx) {
  struct kk_std_core_hnd__lift10303_finalize_fun10677__t* _self = kk_function_alloc_as(struct kk_std_core_hnd__lift10303_finalize_fun10677__t, 5, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd__lift10303_finalize_fun10677, kk_context());
  _self->cont00 = cont00;
  _self->ev = ev;
  _self->w0 = w0;
  _self->w1 = w1;
  _self->m00 = m00;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_core_hnd__lift10303_finalize_fun10682__t {
  struct kk_function_s _base;
  kk_box_t x;
};
static kk_box_t kk_std_core_hnd__lift10303_finalize_fun10682(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_lift10303_finalize_fun10682(kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_hnd__lift10303_finalize_fun10682__t* _self = kk_function_alloc_as(struct kk_std_core_hnd__lift10303_finalize_fun10682__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd__lift10303_finalize_fun10682, kk_context());
  _self->x = x;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd__lift10303_finalize_fun10682(kk_function_t _fself, kk_context_t* _ctx) {
  struct kk_std_core_hnd__lift10303_finalize_fun10682__t* _self = kk_function_as(struct kk_std_core_hnd__lift10303_finalize_fun10682__t*, _fself);
  kk_box_t x = _self->x; /* 4560 */
  kk_drop_match(_self, {kk_box_dup(x);}, {}, _ctx)
  return x;
}


// lift anonymous function
struct kk_std_core_hnd__lift10303_finalize_fun10683__t {
  struct kk_function_s _base;
  kk_box_t x0;
};
static kk_box_t kk_std_core_hnd__lift10303_finalize_fun10683(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_lift10303_finalize_fun10683(kk_box_t x0, kk_context_t* _ctx) {
  struct kk_std_core_hnd__lift10303_finalize_fun10683__t* _self = kk_function_alloc_as(struct kk_std_core_hnd__lift10303_finalize_fun10683__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd__lift10303_finalize_fun10683, kk_context());
  _self->x0 = x0;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd__lift10303_finalize_fun10683(kk_function_t _fself, kk_context_t* _ctx) {
  struct kk_std_core_hnd__lift10303_finalize_fun10683__t* _self = kk_function_as(struct kk_std_core_hnd__lift10303_finalize_fun10683__t*, _fself);
  kk_box_t x0 = _self->x0; /* 4560 */
  kk_drop_match(_self, {kk_box_dup(x0);}, {}, _ctx)
  return x0;
}


// lift anonymous function
struct kk_std_core_hnd__lift10303_finalize_fun10685__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_hnd__lift10303_finalize_fun10685(kk_function_t _fself, kk_box_t _x110684, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_lift10303_finalize_fun10685(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_hnd__lift10303_finalize_fun10685, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_core_hnd__lift10303_finalize_fun10685(kk_function_t _fself, kk_box_t _x110684, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_core_types_id(_x110684, _ctx);
}


// lift anonymous function
struct kk_std_core_hnd__lift10303_finalize_fun10690__t {
  struct kk_function_s _base;
  kk_box_t x10;
  kk_std_core_hnd__marker m00;
};
static kk_box_t kk_std_core_hnd__lift10303_finalize_fun10690(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_lift10303_finalize_fun10690(kk_box_t x10, kk_std_core_hnd__marker m00, kk_context_t* _ctx) {
  struct kk_std_core_hnd__lift10303_finalize_fun10690__t* _self = kk_function_alloc_as(struct kk_std_core_hnd__lift10303_finalize_fun10690__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd__lift10303_finalize_fun10690, kk_context());
  _self->x10 = x10;
  _self->m00 = m00;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_core_hnd__lift10303_finalize_fun10691__t {
  struct kk_function_s _base;
  kk_box_t x10;
};
static kk_box_t kk_std_core_hnd__lift10303_finalize_fun10691(kk_function_t _fself, kk_function_t ___wildcard__327__83, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_lift10303_finalize_fun10691(kk_box_t x10, kk_context_t* _ctx) {
  struct kk_std_core_hnd__lift10303_finalize_fun10691__t* _self = kk_function_alloc_as(struct kk_std_core_hnd__lift10303_finalize_fun10691__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd__lift10303_finalize_fun10691, kk_context());
  _self->x10 = x10;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd__lift10303_finalize_fun10691(kk_function_t _fself, kk_function_t ___wildcard__327__83, kk_context_t* _ctx) {
  struct kk_std_core_hnd__lift10303_finalize_fun10691__t* _self = kk_function_as(struct kk_std_core_hnd__lift10303_finalize_fun10691__t*, _fself);
  kk_box_t x10 = _self->x10; /* 6871 */
  kk_drop_match(_self, {kk_box_dup(x10);}, {}, _ctx)
  kk_function_drop(___wildcard__327__83, _ctx);
  return x10;
}
static kk_box_t kk_std_core_hnd__lift10303_finalize_fun10690(kk_function_t _fself, kk_context_t* _ctx) {
  struct kk_std_core_hnd__lift10303_finalize_fun10690__t* _self = kk_function_as(struct kk_std_core_hnd__lift10303_finalize_fun10690__t*, _fself);
  kk_box_t x10 = _self->x10; /* 6871 */
  kk_std_core_hnd__marker m00 = _self->m00; /* std/core/hnd/marker<6873,6871> */
  kk_drop_match(_self, {kk_box_dup(x10);kk_std_core_hnd__marker_dup(m00);}, {}, _ctx)
  return kk_std_core_hnd_yield_to_final(m00, kk_std_core_hnd__new_lift10303_finalize_fun10691(x10, _ctx), _ctx);
}
static kk_box_t kk_std_core_hnd__lift10303_finalize_fun10677(kk_function_t _fself, kk_std_core_hnd__resume_result r, kk_context_t* _ctx) {
  struct kk_std_core_hnd__lift10303_finalize_fun10677__t* _self = kk_function_as(struct kk_std_core_hnd__lift10303_finalize_fun10677__t*, _fself);
  kk_function_t cont00 = _self->cont00; /* (() -> 4560) -> 6873 6871 */
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<_6833> */
  kk_evv_t w0 = _self->w0; /* std/core/hnd/evv<6873> */
  kk_evv_t w1 = _self->w1; /* std/core/hnd/evv<6873> */
  kk_std_core_hnd__marker m00 = _self->m00; /* std/core/hnd/marker<6873,6871> */
  kk_drop_match(_self, {kk_function_dup(cont00);kk_std_core_hnd__ev_dup(ev);kk_evv_dup(w0);kk_evv_dup(w1);kk_std_core_hnd__marker_dup(m00);}, {}, _ctx)
  if (kk_std_core_hnd__is_Deep(r)) {
    kk_box_t x = r._cons.Deep.result;
    kk_evv_t w00_sq_ = kk_std_core_hnd_evv_get(_ctx); /*std/core/hnd/evv<6873>*/;
    kk_evv_t w10_sq_;
    bool _match_10510;
    kk_evv_t _x10678 = kk_evv_dup(w00_sq_); /*std/core/hnd/evv<6873>*/
    _match_10510 = kk_std_core_hnd_evv_eq(w0, _x10678, _ctx); /*bool*/
    if (_match_10510) {
      w10_sq_ = w1; /*std/core/hnd/evv<6873>*/
    }
    else {
      kk_evv_drop(w1, _ctx);
      kk_evv_t _x10679 = kk_evv_dup(w00_sq_); /*std/core/hnd/evv<6873>*/
      kk_std_core_hnd__ev _x10680 = kk_std_core_hnd__ev_dup(ev); /*std/core/hnd/ev<_6833>*/
      w10_sq_ = kk_std_core_hnd_evv_insert(_x10679, _x10680, _ctx); /*std/core/hnd/evv<6873>*/
    }
    kk_unit_t __2 = kk_Unit;
    kk_evv_t _x10681 = kk_evv_dup(w10_sq_); /*std/core/hnd/evv<6873>*/
    kk_evv_set(_x10681,kk_context());
    kk_box_t result1_10313 = kk_function_call(kk_box_t, (kk_function_t, kk_function_t, kk_context_t*), cont00, (cont00, kk_std_core_hnd__new_lift10303_finalize_fun10682(x, _ctx), _ctx)); /*6871*/;
    return kk_std_core_hnd__lift10303_finalize(w00_sq_, w10_sq_, ev, m00, result1_10313, _ctx);
  }
  if (kk_std_core_hnd__is_Shallow(r)) {
    kk_box_t x0 = r._cons.Shallow.result;
    kk_evv_drop(w0, _ctx);
    kk_evv_drop(w1, _ctx);
    kk_std_core_hnd__ev_dropn(ev, ((int32_t)3), _ctx);
    kk_Unit;
    kk_box_t x1_10268 = kk_function_call(kk_box_t, (kk_function_t, kk_function_t, kk_context_t*), cont00, (cont00, kk_std_core_hnd__new_lift10303_finalize_fun10683(x0, _ctx), _ctx)); /*6871*/;
    if (kk_yielding(kk_context())) {
      kk_box_drop(x1_10268, _ctx);
      return kk_std_core_hnd_yield_extend(kk_std_core_hnd__new_lift10303_finalize_fun10685(_ctx), _ctx);
    }
    return kk_std_core_types_id(x1_10268, _ctx);
  }
  kk_box_t x10 = r._cons.Finalize.result;
  kk_evv_t w01_sq_ = kk_std_core_hnd_evv_get(_ctx); /*std/core/hnd/evv<6873>*/;
  kk_evv_t w11_sq_;
  bool _match_10508;
  kk_evv_t _x10686 = kk_evv_dup(w01_sq_); /*std/core/hnd/evv<6873>*/
  _match_10508 = kk_std_core_hnd_evv_eq(w0, _x10686, _ctx); /*bool*/
  if (_match_10508) {
    w11_sq_ = w1; /*std/core/hnd/evv<6873>*/
  }
  else {
    kk_evv_drop(w1, _ctx);
    kk_evv_t _x10687 = kk_evv_dup(w01_sq_); /*std/core/hnd/evv<6873>*/
    kk_std_core_hnd__ev _x10688 = kk_std_core_hnd__ev_dup(ev); /*std/core/hnd/ev<_6833>*/
    w11_sq_ = kk_std_core_hnd_evv_insert(_x10687, _x10688, _ctx); /*std/core/hnd/evv<6873>*/
  }
  kk_unit_t __3 = kk_Unit;
  kk_evv_t _x10689 = kk_evv_dup(w11_sq_); /*std/core/hnd/evv<6873>*/
  kk_evv_set(_x10689,kk_context());
  kk_box_t result2_10318 = kk_function_call(kk_box_t, (kk_function_t, kk_function_t, kk_context_t*), cont00, (cont00, kk_std_core_hnd__new_lift10303_finalize_fun10690(x10, m00, _ctx), _ctx)); /*6871*/;
  return kk_std_core_hnd__lift10303_finalize(w01_sq_, w11_sq_, ev, m00, result2_10318, _ctx);
}

kk_box_t kk_std_core_hnd__lift10303_finalize(kk_evv_t w0, kk_evv_t w1, kk_std_core_hnd__ev ev, kk_std_core_hnd__marker m00, kk_box_t result, kk_context_t* _ctx) { /* forall<_a,b,e> (w0 : evv<e>, w1 : evv<e>, ev : ev<_a>, m00 : marker<e,b>, result : b) -> e b */ 
  kk_unit_t __ = kk_Unit;
  kk_evv_t _x10670 = kk_evv_dup(w1); /*std/core/hnd/evv<6873>*/
  kk_std_core_hnd_guard(_x10670, _ctx);
  kk_unit_t __0 = kk_Unit;
  kk_evv_t _x10671 = kk_evv_dup(w0); /*std/core/hnd/evv<6873>*/
  kk_evv_set(_x10671,kk_context());
  kk_std_core_hnd__yld _match_10507 = kk_std_core_hnd_yield_prompt(m00, _ctx); /*std/core/hnd/yld<3900,3899,3901>*/;
  if (kk_std_core_hnd__is_Pure(_match_10507)) {
    kk_std_core_hnd__ev_dropn(ev, ((int32_t)3), _ctx);
    kk_evv_drop(w0, _ctx);
    kk_evv_drop(w1, _ctx);
    return kk_std_core_types_id(result, _ctx);
  }
  if (kk_std_core_hnd__is_YieldingFinal(_match_10507)) {
    kk_std_core_hnd__ev_dropn(ev, ((int32_t)3), _ctx);
    kk_box_drop(result, _ctx);
    kk_evv_drop(w0, _ctx);
    kk_evv_drop(w1, _ctx);
    return kk_box_any(kk_context());
  }
  if (kk_std_core_hnd__is_Yielding(_match_10507)) {
    kk_box_drop(result, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd__new_lift10303_finalize_fun10672(ev, w0, w1, m00, _ctx), _ctx);
  }
  kk_function_t clause0 = _match_10507._cons.Yield.clause;
  kk_function_t cont00 = _match_10507._cons.Yield.cont;
  kk_box_drop(result, _ctx);
  kk_function_dup(clause0);
  kk_function_dup(cont00);
  kk_std_core_hnd__yld_drop(_match_10507, _ctx);
  kk_Unit;
  return kk_function_call(kk_box_t, (kk_function_t, kk_function_t, kk_context_t*), clause0, (clause0, kk_std_core_hnd__new_lift10303_finalize_fun10677(cont00, ev, w0, w1, m00, _ctx), _ctx));
}


// lift anonymous function
struct kk_std_core_hnd_finalize_fun10694__t {
  struct kk_function_s _base;
  kk_box_t res;
  kk_std_core_hnd__marker m0;
};
static kk_box_t kk_std_core_hnd_finalize_fun10694(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_finalize_fun10694(kk_box_t res, kk_std_core_hnd__marker m0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_finalize_fun10694__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_finalize_fun10694__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_finalize_fun10694, kk_context());
  _self->res = res;
  _self->m0 = m0;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_core_hnd_finalize_fun10695__t {
  struct kk_function_s _base;
  kk_box_t res;
};
static kk_box_t kk_std_core_hnd_finalize_fun10695(kk_function_t _fself, kk_function_t ___wildcard__426__70, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_finalize_fun10695(kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd_finalize_fun10695__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_finalize_fun10695__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_finalize_fun10695, kk_context());
  _self->res = res;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_finalize_fun10695(kk_function_t _fself, kk_function_t ___wildcard__426__70, kk_context_t* _ctx) {
  struct kk_std_core_hnd_finalize_fun10695__t* _self = kk_function_as(struct kk_std_core_hnd_finalize_fun10695__t*, _fself);
  kk_box_t res = _self->res; /* 6871 */
  kk_drop_match(_self, {kk_box_dup(res);}, {}, _ctx)
  kk_function_drop(___wildcard__426__70, _ctx);
  return res;
}
static kk_box_t kk_std_core_hnd_finalize_fun10694(kk_function_t _fself, kk_context_t* _ctx) {
  struct kk_std_core_hnd_finalize_fun10694__t* _self = kk_function_as(struct kk_std_core_hnd_finalize_fun10694__t*, _fself);
  kk_box_t res = _self->res; /* 6871 */
  kk_std_core_hnd__marker m0 = _self->m0; /* std/core/hnd/marker<6873,6871> */
  kk_drop_match(_self, {kk_box_dup(res);kk_std_core_hnd__marker_dup(m0);}, {}, _ctx)
  return kk_std_core_hnd_yield_to_final(m0, kk_std_core_hnd_new_finalize_fun10695(res, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_finalize_fun10696__t {
  struct kk_function_s _base;
  kk_box_t res;
};
static kk_box_t kk_std_core_hnd_finalize_fun10696(kk_function_t _fself, kk_box_t ___wildcard__426__89, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_finalize_fun10696(kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd_finalize_fun10696__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_finalize_fun10696__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_finalize_fun10696, kk_context());
  _self->res = res;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_finalize_fun10696(kk_function_t _fself, kk_box_t ___wildcard__426__89, kk_context_t* _ctx) {
  struct kk_std_core_hnd_finalize_fun10696__t* _self = kk_function_as(struct kk_std_core_hnd_finalize_fun10696__t*, _fself);
  kk_box_t res = _self->res; /* 6871 */
  kk_drop_match(_self, {kk_box_dup(res);}, {}, _ctx)
  kk_box_drop(___wildcard__426__89, _ctx);
  return res;
}

kk_box_t kk_std_core_hnd_finalize(kk_function_t cont, kk_box_t res, kk_context_t* _ctx) { /* forall<a,b,e,c> (cont : (() -> b) -> e c, res : a) -> e a */ 
  kk_std_core_hnd__marker m0;
  int32_t _x10692 = kk_std_core_hnd_fresh_marker_int(_ctx); /*int32*/
  m0 = kk_std_core_hnd__new_Marker(_x10692, _ctx); /*std/core/hnd/marker<6873,6871>*/
  kk_evv_t w = kk_std_core_hnd_evv_get(_ctx); /*std/core/hnd/evv<6873>*/;
  kk_std_core_hnd__ev ev_10321 = kk_ev_none(kk_context()); /*std/core/hnd/ev<_6833>*/;
  kk_box_t x_10276;
  kk_function_t _x10693;
  kk_box_dup(res);
  _x10693 = kk_std_core_hnd_new_finalize_fun10694(res, m0, _ctx); /*() -> 3922*/
  x_10276 = kk_function_call(kk_box_t, (kk_function_t, kk_function_t, kk_context_t*), cont, (cont, _x10693, _ctx)); /*6874*/
  kk_box_drop(x_10276, _ctx);
  kk_box_t result_10323;
  if (kk_yielding(kk_context())) {
    result_10323 = kk_std_core_hnd_yield_extend(kk_std_core_hnd_new_finalize_fun10696(res, _ctx), _ctx); /*6871*/
  }
  else {
    result_10323 = res; /*6871*/
  }
  kk_evv_t _x10697 = kk_evv_dup(w); /*std/core/hnd/evv<6873>*/
  return kk_std_core_hnd__lift10303_finalize(_x10697, w, ev_10321, m0, result_10323, _ctx);
}

kk_box_t kk_std_core_hnd_protect_check(kk_ref_t resumed, kk_function_t k0, kk_box_t res, kk_context_t* _ctx) { /* forall<a,e,b> (resumed : ref<global,bool>, k : (resume-result<a,b>) -> e b, res : b) -> e b */ 
  bool did_resume;
  kk_box_t _x10700 = kk_ref_get(resumed,kk_context()); /*182*/
  did_resume = kk_bool_unbox(_x10700); /*bool*/
  if (did_resume) {
    kk_function_drop(k0, _ctx);
    return res;
  }
  kk_std_core_hnd__resume_result _x10701 = kk_std_core_hnd__new_Finalize(res, _ctx); /*std/core/hnd/resume-result<80,81>*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__resume_result, kk_context_t*), k0, (k0, _x10701, _ctx));
}


// lift anonymous function
struct kk_std_core_hnd_protect_fun10703__t {
  struct kk_function_s _base;
  kk_function_t k0;
  kk_ref_t resumed;
};
static kk_box_t kk_std_core_hnd_protect_fun10703(kk_function_t _fself, kk_box_t ret, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_protect_fun10703(kk_function_t k0, kk_ref_t resumed, kk_context_t* _ctx) {
  struct kk_std_core_hnd_protect_fun10703__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_protect_fun10703__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_protect_fun10703, kk_context());
  _self->k0 = k0;
  _self->resumed = resumed;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_protect_fun10703(kk_function_t _fself, kk_box_t ret, kk_context_t* _ctx) {
  struct kk_std_core_hnd_protect_fun10703__t* _self = kk_function_as(struct kk_std_core_hnd_protect_fun10703__t*, _fself);
  kk_function_t k0 = _self->k0; /* (std/core/hnd/resume-result<7138,7140>) -> 7139 7140 */
  kk_ref_t resumed = _self->resumed; /* ref<global,bool> */
  kk_drop_match(_self, {kk_function_dup(k0);kk_ref_dup(resumed);}, {}, _ctx)
  kk_unit_t __ = kk_Unit;
  kk_unit_t _borrowApp_10504 = kk_Unit;
  kk_ref_set_borrow(resumed,(kk_bool_box(true)),kk_context());
  kk_ref_drop(resumed, _ctx);
  _borrowApp_10504;
  kk_std_core_hnd__resume_result _x10704 = kk_std_core_hnd__new_Deep(ret, _ctx); /*std/core/hnd/resume-result<80,81>*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__resume_result, kk_context_t*), k0, (k0, _x10704, _ctx));
}


// lift anonymous function
struct kk_std_core_hnd_protect_fun10705__t {
  struct kk_function_s _base;
  kk_function_t k0;
  kk_ref_t resumed;
};
static kk_box_t kk_std_core_hnd_protect_fun10705(kk_function_t _fself, kk_box_t xres, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_protect_fun10705(kk_function_t k0, kk_ref_t resumed, kk_context_t* _ctx) {
  struct kk_std_core_hnd_protect_fun10705__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_protect_fun10705__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_protect_fun10705, kk_context());
  _self->k0 = k0;
  _self->resumed = resumed;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_protect_fun10705(kk_function_t _fself, kk_box_t xres, kk_context_t* _ctx) {
  struct kk_std_core_hnd_protect_fun10705__t* _self = kk_function_as(struct kk_std_core_hnd_protect_fun10705__t*, _fself);
  kk_function_t k0 = _self->k0; /* (std/core/hnd/resume-result<7138,7140>) -> 7139 7140 */
  kk_ref_t resumed = _self->resumed; /* ref<global,bool> */
  kk_drop_match(_self, {kk_function_dup(k0);kk_ref_dup(resumed);}, {}, _ctx)
  return kk_std_core_hnd_protect_check(resumed, k0, xres, _ctx);
}

kk_box_t kk_std_core_hnd_protect(kk_box_t x, kk_function_t clause0, kk_function_t k0, kk_context_t* _ctx) { /* forall<a,b,e,c> (x : a, clause : (x : a, k : (b) -> e c) -> e c, k : (resume-result<b,c>) -> e c) -> e c */ 
  kk_ref_t resumed = kk_ref_alloc((kk_bool_box(false)),kk_context()); /*ref<global,bool>*/;
  kk_box_t res;
  kk_function_t _x10702;
  kk_function_dup(k0);
  kk_ref_dup(resumed);
  _x10702 = kk_std_core_hnd_new_protect_fun10703(k0, resumed, _ctx); /*(ret : 7138) -> 7139 7140*/
  res = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_function_t, kk_context_t*), clause0, (clause0, x, _x10702, _ctx)); /*7140*/
  if (kk_yielding(kk_context())) {
    kk_box_drop(res, _ctx);
    return kk_std_core_hnd_yield_extend(kk_std_core_hnd_new_protect_fun10705(k0, resumed, _ctx), _ctx);
  }
  return kk_std_core_hnd_protect_check(resumed, k0, res, _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_protect_fun10707__t_1 {
  struct kk_function_s _base;
  kk_function_t k0;
  kk_ref_t resumed;
};
static kk_box_t kk_std_core_hnd_protect_fun10707_1(kk_function_t _fself, kk_box_t ret, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_protect_fun10707_1(kk_function_t k0, kk_ref_t resumed, kk_context_t* _ctx) {
  struct kk_std_core_hnd_protect_fun10707__t_1* _self = kk_function_alloc_as(struct kk_std_core_hnd_protect_fun10707__t_1, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_protect_fun10707_1, kk_context());
  _self->k0 = k0;
  _self->resumed = resumed;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_protect_fun10707_1(kk_function_t _fself, kk_box_t ret, kk_context_t* _ctx) {
  struct kk_std_core_hnd_protect_fun10707__t_1* _self = kk_function_as(struct kk_std_core_hnd_protect_fun10707__t_1*, _fself);
  kk_function_t k0 = _self->k0; /* (std/core/hnd/resume-result<7231,7233>) -> 7232 7233 */
  kk_ref_t resumed = _self->resumed; /* ref<global,bool> */
  kk_drop_match(_self, {kk_function_dup(k0);kk_ref_dup(resumed);}, {}, _ctx)
  kk_unit_t __ = kk_Unit;
  kk_unit_t _borrowApp_10502 = kk_Unit;
  kk_ref_set_borrow(resumed,(kk_bool_box(true)),kk_context());
  kk_ref_drop(resumed, _ctx);
  _borrowApp_10502;
  kk_std_core_hnd__resume_result _x10708 = kk_std_core_hnd__new_Deep(ret, _ctx); /*std/core/hnd/resume-result<80,81>*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__resume_result, kk_context_t*), k0, (k0, _x10708, _ctx));
}


// lift anonymous function
struct kk_std_core_hnd_protect_fun10709__t_1 {
  struct kk_function_s _base;
  kk_function_t k0;
  kk_ref_t resumed;
};
static kk_box_t kk_std_core_hnd_protect_fun10709_1(kk_function_t _fself, kk_box_t xres, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_protect_fun10709_1(kk_function_t k0, kk_ref_t resumed, kk_context_t* _ctx) {
  struct kk_std_core_hnd_protect_fun10709__t_1* _self = kk_function_alloc_as(struct kk_std_core_hnd_protect_fun10709__t_1, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_protect_fun10709_1, kk_context());
  _self->k0 = k0;
  _self->resumed = resumed;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_protect_fun10709_1(kk_function_t _fself, kk_box_t xres, kk_context_t* _ctx) {
  struct kk_std_core_hnd_protect_fun10709__t_1* _self = kk_function_as(struct kk_std_core_hnd_protect_fun10709__t_1*, _fself);
  kk_function_t k0 = _self->k0; /* (std/core/hnd/resume-result<7231,7233>) -> 7232 7233 */
  kk_ref_t resumed = _self->resumed; /* ref<global,bool> */
  kk_drop_match(_self, {kk_function_dup(k0);kk_ref_dup(resumed);}, {}, _ctx)
  return kk_std_core_hnd_protect_check(resumed, k0, xres, _ctx);
}

kk_box_t kk_std_core_hnd_protect_1(kk_box_t x1, kk_box_t x2, kk_function_t clause0, kk_function_t k0, kk_context_t* _ctx) { /* forall<a,b,c,e,d> (x1 : a, x2 : b, clause : (x : a, x : b, k : (c) -> e d) -> e d, k : (resume-result<c,d>) -> e d) -> e d */ 
  kk_ref_t resumed = kk_ref_alloc((kk_bool_box(false)),kk_context()); /*ref<global,bool>*/;
  kk_box_t res;
  kk_function_t _x10706;
  kk_function_dup(k0);
  kk_ref_dup(resumed);
  _x10706 = kk_std_core_hnd_new_protect_fun10707_1(k0, resumed, _ctx); /*(ret : 7231) -> 7232 7233*/
  res = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_function_t, kk_context_t*), clause0, (clause0, x1, x2, _x10706, _ctx)); /*7233*/
  if (kk_yielding(kk_context())) {
    kk_box_drop(res, _ctx);
    return kk_std_core_hnd_yield_extend(kk_std_core_hnd_new_protect_fun10709_1(k0, resumed, _ctx), _ctx);
  }
  return kk_std_core_hnd_protect_check(resumed, k0, res, _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_control0_fun10710__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_control0_fun10710(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__624__16, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control0_fun10710(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control0_fun10710__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control0_fun10710__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_control0_fun10710, kk_context());
  _self->op = op;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_core_hnd_clause_control0_fun10711__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_control0_fun10711(kk_function_t _fself, kk_function_t k0, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control0_fun10711(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control0_fun10711__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control0_fun10711__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_control0_fun10711, kk_context());
  _self->op = op;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_core_hnd_clause_control0_fun10713__t {
  struct kk_function_s _base;
  kk_function_t k0;
  kk_ref_t resumed;
};
static kk_box_t kk_std_core_hnd_clause_control0_fun10713(kk_function_t _fself, kk_box_t ret, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control0_fun10713(kk_function_t k0, kk_ref_t resumed, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control0_fun10713__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control0_fun10713__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_control0_fun10713, kk_context());
  _self->k0 = k0;
  _self->resumed = resumed;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_control0_fun10713(kk_function_t _fself, kk_box_t ret, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control0_fun10713__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control0_fun10713__t*, _fself);
  kk_function_t k0 = _self->k0; /* (std/core/hnd/resume-result<7334,7337>) -> 7335 7337 */
  kk_ref_t resumed = _self->resumed; /* ref<global,bool> */
  kk_drop_match(_self, {kk_function_dup(k0);kk_ref_dup(resumed);}, {}, _ctx)
  kk_unit_t __ = kk_Unit;
  kk_unit_t _borrowApp_10500 = kk_Unit;
  kk_ref_set_borrow(resumed,(kk_bool_box(true)),kk_context());
  kk_ref_drop(resumed, _ctx);
  _borrowApp_10500;
  kk_std_core_hnd__resume_result _x10714 = kk_std_core_hnd__new_Deep(ret, _ctx); /*std/core/hnd/resume-result<80,81>*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__resume_result, kk_context_t*), k0, (k0, _x10714, _ctx));
}


// lift anonymous function
struct kk_std_core_hnd_clause_control0_fun10715__t {
  struct kk_function_s _base;
  kk_function_t k0;
  kk_ref_t resumed;
};
static kk_box_t kk_std_core_hnd_clause_control0_fun10715(kk_function_t _fself, kk_box_t xres, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control0_fun10715(kk_function_t k0, kk_ref_t resumed, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control0_fun10715__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control0_fun10715__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_control0_fun10715, kk_context());
  _self->k0 = k0;
  _self->resumed = resumed;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_control0_fun10715(kk_function_t _fself, kk_box_t xres, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control0_fun10715__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control0_fun10715__t*, _fself);
  kk_function_t k0 = _self->k0; /* (std/core/hnd/resume-result<7334,7337>) -> 7335 7337 */
  kk_ref_t resumed = _self->resumed; /* ref<global,bool> */
  kk_drop_match(_self, {kk_function_dup(k0);kk_ref_dup(resumed);}, {}, _ctx)
  return kk_std_core_hnd_protect_check(resumed, k0, xres, _ctx);
}
static kk_box_t kk_std_core_hnd_clause_control0_fun10711(kk_function_t _fself, kk_function_t k0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control0_fun10711__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control0_fun10711__t*, _fself);
  kk_function_t op = _self->op; /* ((7334) -> 7335 7337) -> 7335 7337 */
  kk_drop_match(_self, {kk_function_dup(op);}, {}, _ctx)
  kk_ref_t resumed = kk_ref_alloc((kk_bool_box(false)),kk_context()); /*ref<global,bool>*/;
  kk_box_t res;
  kk_function_t _x10712;
  kk_function_dup(k0);
  kk_ref_dup(resumed);
  _x10712 = kk_std_core_hnd_new_clause_control0_fun10713(k0, resumed, _ctx); /*(ret : 7334) -> 7335 7337*/
  res = kk_function_call(kk_box_t, (kk_function_t, kk_function_t, kk_context_t*), op, (op, _x10712, _ctx)); /*7337*/
  if (kk_yielding(kk_context())) {
    kk_box_drop(res, _ctx);
    return kk_std_core_hnd_yield_extend(kk_std_core_hnd_new_clause_control0_fun10715(k0, resumed, _ctx), _ctx);
  }
  return kk_std_core_hnd_protect_check(resumed, k0, res, _ctx);
}
static kk_box_t kk_std_core_hnd_clause_control0_fun10710(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__624__16, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control0_fun10710__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control0_fun10710__t*, _fself);
  kk_function_t op = _self->op; /* ((7334) -> 7335 7337) -> 7335 7337 */
  kk_drop_match(_self, {kk_function_dup(op);}, {}, _ctx)
  kk_std_core_hnd__ev_dropn(___wildcard__624__16, ((int32_t)3), _ctx);
  return kk_std_core_hnd_yield_to(m0, kk_std_core_hnd_new_clause_control0_fun10711(op, _ctx), _ctx);
}

kk_std_core_hnd__clause0 kk_std_core_hnd_clause_control0(kk_function_t op, kk_context_t* _ctx) { /* forall<a,e,b,c> (op : ((a) -> e c) -> e c) -> clause0<a,b,e,c> */ 
  return kk_std_core_hnd__new_Clause0(kk_std_core_hnd_new_clause_control0_fun10710(op, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_control1_fun10716__t {
  struct kk_function_s _base;
  kk_function_t clause0;
};
static kk_box_t kk_std_core_hnd_clause_control1_fun10716(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__573__16, kk_box_t x, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control1_fun10716(kk_function_t clause0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control1_fun10716__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control1_fun10716__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_control1_fun10716, kk_context());
  _self->clause0 = clause0;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_core_hnd_clause_control1_fun10717__t {
  struct kk_function_s _base;
  kk_function_t clause0;
  kk_box_t x;
};
static kk_box_t kk_std_core_hnd_clause_control1_fun10717(kk_function_t _fself, kk_function_t k0, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control1_fun10717(kk_function_t clause0, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control1_fun10717__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control1_fun10717__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_control1_fun10717, kk_context());
  _self->clause0 = clause0;
  _self->x = x;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_control1_fun10717(kk_function_t _fself, kk_function_t k0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control1_fun10717__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control1_fun10717__t*, _fself);
  kk_function_t clause0 = _self->clause0; /* (x : 7407, k : (7408) -> 7409 7411) -> 7409 7411 */
  kk_box_t x = _self->x; /* 7407 */
  kk_drop_match(_self, {kk_function_dup(clause0);kk_box_dup(x);}, {}, _ctx)
  return kk_std_core_hnd_protect(x, clause0, k0, _ctx);
}
static kk_box_t kk_std_core_hnd_clause_control1_fun10716(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__573__16, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control1_fun10716__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control1_fun10716__t*, _fself);
  kk_function_t clause0 = _self->clause0; /* (x : 7407, k : (7408) -> 7409 7411) -> 7409 7411 */
  kk_drop_match(_self, {kk_function_dup(clause0);}, {}, _ctx)
  kk_std_core_hnd__ev_dropn(___wildcard__573__16, ((int32_t)3), _ctx);
  return kk_std_core_hnd_yield_to(m0, kk_std_core_hnd_new_clause_control1_fun10717(clause0, x, _ctx), _ctx);
}

kk_std_core_hnd__clause1 kk_std_core_hnd_clause_control1(kk_function_t clause0, kk_context_t* _ctx) { /* forall<a,b,e,c,d> (clause : (x : a, k : (b) -> e d) -> e d) -> clause1<a,b,c,e,d> */ 
  return kk_std_core_hnd__new_Clause1(kk_std_core_hnd_new_clause_control1_fun10716(clause0, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_control2_fun10718__t {
  struct kk_function_s _base;
  kk_function_t clause0;
};
static kk_box_t kk_std_core_hnd_clause_control2_fun10718(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__672__16, kk_box_t x1, kk_box_t x2, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control2_fun10718(kk_function_t clause0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control2_fun10718__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control2_fun10718__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_control2_fun10718, kk_context());
  _self->clause0 = clause0;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_core_hnd_clause_control2_fun10719__t {
  struct kk_function_s _base;
  kk_function_t clause0;
  kk_box_t x1;
  kk_box_t x2;
};
static kk_box_t kk_std_core_hnd_clause_control2_fun10719(kk_function_t _fself, kk_function_t k0, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control2_fun10719(kk_function_t clause0, kk_box_t x1, kk_box_t x2, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control2_fun10719__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control2_fun10719__t, 4, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_control2_fun10719, kk_context());
  _self->clause0 = clause0;
  _self->x1 = x1;
  _self->x2 = x2;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_control2_fun10719(kk_function_t _fself, kk_function_t k0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control2_fun10719__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control2_fun10719__t*, _fself);
  kk_function_t clause0 = _self->clause0; /* (x1 : 7490, x2 : 7491, k : (7492) -> 7493 7495) -> 7493 7495 */
  kk_box_t x1 = _self->x1; /* 7490 */
  kk_box_t x2 = _self->x2; /* 7491 */
  kk_drop_match(_self, {kk_function_dup(clause0);kk_box_dup(x1);kk_box_dup(x2);}, {}, _ctx)
  return kk_std_core_hnd_protect_1(x1, x2, clause0, k0, _ctx);
}
static kk_box_t kk_std_core_hnd_clause_control2_fun10718(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__672__16, kk_box_t x1, kk_box_t x2, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control2_fun10718__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control2_fun10718__t*, _fself);
  kk_function_t clause0 = _self->clause0; /* (x1 : 7490, x2 : 7491, k : (7492) -> 7493 7495) -> 7493 7495 */
  kk_drop_match(_self, {kk_function_dup(clause0);}, {}, _ctx)
  kk_std_core_hnd__ev_dropn(___wildcard__672__16, ((int32_t)3), _ctx);
  return kk_std_core_hnd_yield_to(m0, kk_std_core_hnd_new_clause_control2_fun10719(clause0, x1, x2, _ctx), _ctx);
}

kk_std_core_hnd__clause2 kk_std_core_hnd_clause_control2(kk_function_t clause0, kk_context_t* _ctx) { /* forall<a,b,c,e,d,a1> (clause : (x1 : a, x2 : b, k : (c) -> e a1) -> e a1) -> clause2<a,b,c,d,e,a1> */ 
  return kk_std_core_hnd__new_Clause2(kk_std_core_hnd_new_clause_control2_fun10718(clause0, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_control3_fun10720__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_control3_fun10720(kk_function_t _fself, kk_std_core_types__tuple3_ x, kk_function_t k0, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control3_fun10720(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control3_fun10720__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control3_fun10720__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_control3_fun10720, kk_context());
  _self->op = op;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_control3_fun10720(kk_function_t _fself, kk_std_core_types__tuple3_ x, kk_function_t k0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control3_fun10720__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control3_fun10720__t*, _fself);
  kk_function_t op = _self->op; /* (x1 : 7726, x2 : 7727, x3 : 7728, k : (7729) -> 7730 7732) -> 7730 7732 */
  kk_drop_match(_self, {kk_function_dup(op);}, {}, _ctx)
  kk_box_t _x10721 = kk_std_core_types_fst_1(x, _ctx); /*486*/
  kk_box_t _x10722 = kk_std_core_types_snd_1(x, _ctx); /*530*/
  kk_box_t _x10723;
  kk_box_t _borrowApp_10498 = kk_std_core_types_thd(x, _ctx); /*574*/;
  kk_std_core_types__tuple3__drop(x, _ctx);
  _x10723 = _borrowApp_10498; /*574*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_function_t, kk_context_t*), op, (op, _x10721, _x10722, _x10723, k0, _ctx));
}


// lift anonymous function
struct kk_std_core_hnd_clause_control3_fun10724__t {
  struct kk_function_s _base;
  kk_function_t _b_10435_10432;
};
static kk_box_t kk_std_core_hnd_clause_control3_fun10724(kk_function_t _fself, kk_box_t _b_10433, kk_function_t _b_10434, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control3_fun10724(kk_function_t _b_10435_10432, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control3_fun10724__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control3_fun10724__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_control3_fun10724, kk_context());
  _self->_b_10435_10432 = _b_10435_10432;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_control3_fun10724(kk_function_t _fself, kk_box_t _b_10433, kk_function_t _b_10434, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control3_fun10724__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control3_fun10724__t*, _fself);
  kk_function_t _b_10435_10432 = _self->_b_10435_10432; /* (x : (7726, 7727, 7728), k0 : (7729) -> 7730 7732) -> 7730 7732 */
  kk_drop_match(_self, {kk_function_dup(_b_10435_10432);}, {}, _ctx)
  kk_std_core_types__tuple3_ _x10725 = kk_std_core_types__tuple3__unbox(_b_10433, _ctx); /*(7726, 7727, 7728)*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_types__tuple3_, kk_function_t, kk_context_t*), _b_10435_10432, (_b_10435_10432, _x10725, _b_10434, _ctx));
}

kk_std_core_hnd__clause1 kk_std_core_hnd_clause_control3(kk_function_t op, kk_context_t* _ctx) { /* forall<a,b,c,d,e,a1,b1> (op : (x1 : a, x2 : b, x3 : c, k : (d) -> e b1) -> e b1) -> clause1<(a, b, c),d,a1,e,b1> */ 
  kk_function_t _b_10435_10432 = kk_std_core_hnd_new_clause_control3_fun10720(op, _ctx); /*(x : (7726, 7727, 7728), k0 : (7729) -> 7730 7732) -> 7730 7732*/;
  return kk_std_core_hnd_clause_control1(kk_std_core_hnd_new_clause_control3_fun10724(_b_10435_10432, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_control4_fun10726__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_control4_fun10726(kk_function_t _fself, kk_std_core_types__tuple4_ x, kk_function_t k0, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control4_fun10726(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control4_fun10726__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control4_fun10726__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_control4_fun10726, kk_context());
  _self->op = op;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_control4_fun10726(kk_function_t _fself, kk_std_core_types__tuple4_ x, kk_function_t k0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control4_fun10726__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control4_fun10726__t*, _fself);
  kk_function_t op = _self->op; /* (x1 : 8033, x2 : 8034, x3 : 8035, x4 : 8036, k : (8037) -> 8038 8040) -> 8038 8040 */
  kk_drop_match(_self, {kk_function_dup(op);}, {}, _ctx)
  kk_box_t _x10727 = kk_std_core_types_fst_2(x, _ctx); /*731*/
  kk_box_t _x10728 = kk_std_core_types_snd_2(x, _ctx); /*800*/
  kk_box_t _x10729 = kk_std_core_types_thd_1(x, _ctx); /*869*/
  kk_box_t _x10730;
  kk_box_t _borrowApp_10497 = kk_std_core_types_field4(x, _ctx); /*925*/;
  kk_std_core_types__tuple4__dropn(x, ((int32_t)4), _ctx);
  _x10730 = _borrowApp_10497; /*925*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_box_t, kk_function_t, kk_context_t*), op, (op, _x10727, _x10728, _x10729, _x10730, k0, _ctx));
}


// lift anonymous function
struct kk_std_core_hnd_clause_control4_fun10731__t {
  struct kk_function_s _base;
  kk_function_t _b_10439_10436;
};
static kk_box_t kk_std_core_hnd_clause_control4_fun10731(kk_function_t _fself, kk_box_t _b_10437, kk_function_t _b_10438, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control4_fun10731(kk_function_t _b_10439_10436, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control4_fun10731__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control4_fun10731__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_control4_fun10731, kk_context());
  _self->_b_10439_10436 = _b_10439_10436;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_control4_fun10731(kk_function_t _fself, kk_box_t _b_10437, kk_function_t _b_10438, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control4_fun10731__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control4_fun10731__t*, _fself);
  kk_function_t _b_10439_10436 = _self->_b_10439_10436; /* (x : (8033, 8034, 8035, 8036), k0 : (8037) -> 8038 8040) -> 8038 8040 */
  kk_drop_match(_self, {kk_function_dup(_b_10439_10436);}, {}, _ctx)
  kk_std_core_types__tuple4_ _x10732 = kk_std_core_types__tuple4__unbox(_b_10437, _ctx); /*(8033, 8034, 8035, 8036)*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_types__tuple4_, kk_function_t, kk_context_t*), _b_10439_10436, (_b_10439_10436, _x10732, _b_10438, _ctx));
}

kk_std_core_hnd__clause1 kk_std_core_hnd_clause_control4(kk_function_t op, kk_context_t* _ctx) { /* forall<a,b,c,d,a1,e,b1,c1> (op : (x1 : a, x2 : b, x3 : c, x4 : d, k : (a1) -> e c1) -> e c1) -> clause1<(a, b, c, d),a1,b1,e,c1> */ 
  kk_function_t _b_10439_10436 = kk_std_core_hnd_new_clause_control4_fun10726(op, _ctx); /*(x : (8033, 8034, 8035, 8036), k0 : (8037) -> 8038 8040) -> 8038 8040*/;
  return kk_std_core_hnd_clause_control1(kk_std_core_hnd_new_clause_control4_fun10731(_b_10439_10436, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_never0_fun10733__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_never0_fun10733(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__641__16, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_never0_fun10733(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never0_fun10733__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_never0_fun10733__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_never0_fun10733, kk_context());
  _self->op = op;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_core_hnd_clause_never0_fun10734__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_never0_fun10734(kk_function_t _fself, kk_function_t ___wildcard__641__43, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_never0_fun10734(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never0_fun10734__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_never0_fun10734__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_never0_fun10734, kk_context());
  _self->op = op;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_never0_fun10734(kk_function_t _fself, kk_function_t ___wildcard__641__43, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never0_fun10734__t* _self = kk_function_as(struct kk_std_core_hnd_clause_never0_fun10734__t*, _fself);
  kk_function_t op = _self->op; /* () -> 8071 8073 */
  kk_drop_match(_self, {kk_function_dup(op);}, {}, _ctx)
  kk_function_drop(___wildcard__641__43, _ctx);
  return kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), op, (op, _ctx));
}
static kk_box_t kk_std_core_hnd_clause_never0_fun10733(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__641__16, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never0_fun10733__t* _self = kk_function_as(struct kk_std_core_hnd_clause_never0_fun10733__t*, _fself);
  kk_function_t op = _self->op; /* () -> 8071 8073 */
  kk_drop_match(_self, {kk_function_dup(op);}, {}, _ctx)
  kk_std_core_hnd__ev_dropn(___wildcard__641__16, ((int32_t)3), _ctx);
  return kk_std_core_hnd_yield_to_final(m0, kk_std_core_hnd_new_clause_never0_fun10734(op, _ctx), _ctx);
}

kk_std_core_hnd__clause0 kk_std_core_hnd_clause_never0(kk_function_t op, kk_context_t* _ctx) { /* forall<a,e,b,c> (op : () -> e c) -> clause0<a,b,e,c> */ 
  return kk_std_core_hnd__new_Clause0(kk_std_core_hnd_new_clause_never0_fun10733(op, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_never1_fun10735__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_never1_fun10735(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__585__16, kk_box_t x, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_never1_fun10735(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never1_fun10735__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_never1_fun10735__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_never1_fun10735, kk_context());
  _self->op = op;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_core_hnd_clause_never1_fun10736__t {
  struct kk_function_s _base;
  kk_function_t op;
  kk_box_t x;
};
static kk_box_t kk_std_core_hnd_clause_never1_fun10736(kk_function_t _fself, kk_function_t ___wildcard__585__45, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_never1_fun10736(kk_function_t op, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never1_fun10736__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_never1_fun10736__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_never1_fun10736, kk_context());
  _self->op = op;
  _self->x = x;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_never1_fun10736(kk_function_t _fself, kk_function_t ___wildcard__585__45, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never1_fun10736__t* _self = kk_function_as(struct kk_std_core_hnd_clause_never1_fun10736__t*, _fself);
  kk_function_t op = _self->op; /* (8108) -> 8110 8112 */
  kk_box_t x = _self->x; /* 8108 */
  kk_drop_match(_self, {kk_function_dup(op);kk_box_dup(x);}, {}, _ctx)
  kk_function_drop(___wildcard__585__45, _ctx);
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), op, (op, x, _ctx));
}
static kk_box_t kk_std_core_hnd_clause_never1_fun10735(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__585__16, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never1_fun10735__t* _self = kk_function_as(struct kk_std_core_hnd_clause_never1_fun10735__t*, _fself);
  kk_function_t op = _self->op; /* (8108) -> 8110 8112 */
  kk_drop_match(_self, {kk_function_dup(op);}, {}, _ctx)
  kk_std_core_hnd__ev_dropn(___wildcard__585__16, ((int32_t)3), _ctx);
  return kk_std_core_hnd_yield_to_final(m0, kk_std_core_hnd_new_clause_never1_fun10736(op, x, _ctx), _ctx);
}

kk_std_core_hnd__clause1 kk_std_core_hnd_clause_never1(kk_function_t op, kk_context_t* _ctx) { /* forall<a,b,e,c,d> (op : (a) -> e d) -> clause1<a,b,c,e,d> */ 
  return kk_std_core_hnd__new_Clause1(kk_std_core_hnd_new_clause_never1_fun10735(op, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_never2_fun10737__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_never2_fun10737(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__697__16, kk_box_t x1, kk_box_t x2, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_never2_fun10737(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never2_fun10737__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_never2_fun10737__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_never2_fun10737, kk_context());
  _self->op = op;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_core_hnd_clause_never2_fun10738__t {
  struct kk_function_s _base;
  kk_function_t op;
  kk_box_t x1;
  kk_box_t x2;
};
static kk_box_t kk_std_core_hnd_clause_never2_fun10738(kk_function_t _fself, kk_function_t ___wildcard__697__49, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_never2_fun10738(kk_function_t op, kk_box_t x1, kk_box_t x2, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never2_fun10738__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_never2_fun10738__t, 4, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_never2_fun10738, kk_context());
  _self->op = op;
  _self->x1 = x1;
  _self->x2 = x2;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_never2_fun10738(kk_function_t _fself, kk_function_t ___wildcard__697__49, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never2_fun10738__t* _self = kk_function_as(struct kk_std_core_hnd_clause_never2_fun10738__t*, _fself);
  kk_function_t op = _self->op; /* (8152, 8153) -> 8155 8157 */
  kk_box_t x1 = _self->x1; /* 8152 */
  kk_box_t x2 = _self->x2; /* 8153 */
  kk_drop_match(_self, {kk_function_dup(op);kk_box_dup(x1);kk_box_dup(x2);}, {}, _ctx)
  kk_function_drop(___wildcard__697__49, _ctx);
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_context_t*), op, (op, x1, x2, _ctx));
}
static kk_box_t kk_std_core_hnd_clause_never2_fun10737(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__697__16, kk_box_t x1, kk_box_t x2, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never2_fun10737__t* _self = kk_function_as(struct kk_std_core_hnd_clause_never2_fun10737__t*, _fself);
  kk_function_t op = _self->op; /* (8152, 8153) -> 8155 8157 */
  kk_drop_match(_self, {kk_function_dup(op);}, {}, _ctx)
  kk_std_core_hnd__ev_dropn(___wildcard__697__16, ((int32_t)3), _ctx);
  return kk_std_core_hnd_yield_to_final(m0, kk_std_core_hnd_new_clause_never2_fun10738(op, x1, x2, _ctx), _ctx);
}

kk_std_core_hnd__clause2 kk_std_core_hnd_clause_never2(kk_function_t op, kk_context_t* _ctx) { /* forall<a,b,c,e,d,a1> (op : (a, b) -> e a1) -> clause2<a,b,c,d,e,a1> */ 
  return kk_std_core_hnd__new_Clause2(kk_std_core_hnd_new_clause_never2_fun10737(op, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_never3_fun10739__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_never3_fun10739(kk_function_t _fself, kk_std_core_types__tuple3_ x, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_never3_fun10739(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never3_fun10739__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_never3_fun10739__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_never3_fun10739, kk_context());
  _self->op = op;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_never3_fun10739(kk_function_t _fself, kk_std_core_types__tuple3_ x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never3_fun10739__t* _self = kk_function_as(struct kk_std_core_hnd_clause_never3_fun10739__t*, _fself);
  kk_function_t op = _self->op; /* (8387, 8388, 8389) -> 8391 8393 */
  kk_drop_match(_self, {kk_function_dup(op);}, {}, _ctx)
  kk_box_t _x10740 = kk_std_core_types_fst_1(x, _ctx); /*486*/
  kk_box_t _x10741 = kk_std_core_types_snd_1(x, _ctx); /*530*/
  kk_box_t _x10742;
  kk_box_t _borrowApp_10496 = kk_std_core_types_thd(x, _ctx); /*574*/;
  kk_std_core_types__tuple3__drop(x, _ctx);
  _x10742 = _borrowApp_10496; /*574*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_context_t*), op, (op, _x10740, _x10741, _x10742, _ctx));
}


// lift anonymous function
struct kk_std_core_hnd_clause_never3_fun10743__t {
  struct kk_function_s _base;
  kk_function_t _b_10442_10440;
};
static kk_box_t kk_std_core_hnd_clause_never3_fun10743(kk_function_t _fself, kk_box_t _b_10441, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_never3_fun10743(kk_function_t _b_10442_10440, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never3_fun10743__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_never3_fun10743__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_never3_fun10743, kk_context());
  _self->_b_10442_10440 = _b_10442_10440;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_never3_fun10743(kk_function_t _fself, kk_box_t _b_10441, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never3_fun10743__t* _self = kk_function_as(struct kk_std_core_hnd_clause_never3_fun10743__t*, _fself);
  kk_function_t _b_10442_10440 = _self->_b_10442_10440; /* (x : (8387, 8388, 8389)) -> 8391 8393 */
  kk_drop_match(_self, {kk_function_dup(_b_10442_10440);}, {}, _ctx)
  kk_std_core_types__tuple3_ _x10744 = kk_std_core_types__tuple3__unbox(_b_10441, _ctx); /*(8387, 8388, 8389)*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_types__tuple3_, kk_context_t*), _b_10442_10440, (_b_10442_10440, _x10744, _ctx));
}

kk_std_core_hnd__clause1 kk_std_core_hnd_clause_never3(kk_function_t op, kk_context_t* _ctx) { /* forall<a,b,c,d,e,a1,b1> (op : (a, b, c) -> e b1) -> clause1<(a, b, c),d,a1,e,b1> */ 
  kk_function_t _b_10442_10440 = kk_std_core_hnd_new_clause_never3_fun10739(op, _ctx); /*(x : (8387, 8388, 8389)) -> 8391 8393*/;
  return kk_std_core_hnd_clause_never1(kk_std_core_hnd_new_clause_never3_fun10743(_b_10442_10440, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_tail_noyield3_fun10745__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_tail_noyield3_fun10745(kk_function_t _fself, kk_std_core_types__tuple3_ x, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_tail_noyield3_fun10745(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail_noyield3_fun10745__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_tail_noyield3_fun10745__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_tail_noyield3_fun10745, kk_context());
  _self->op = op;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_tail_noyield3_fun10745(kk_function_t _fself, kk_std_core_types__tuple3_ x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail_noyield3_fun10745__t* _self = kk_function_as(struct kk_std_core_hnd_clause_tail_noyield3_fun10745__t*, _fself);
  kk_function_t op = _self->op; /* (8623, 8624, 8625) -> 8627 8626 */
  kk_drop_match(_self, {kk_function_dup(op);}, {}, _ctx)
  kk_box_t _x10746 = kk_std_core_types_fst_1(x, _ctx); /*486*/
  kk_box_t _x10747 = kk_std_core_types_snd_1(x, _ctx); /*530*/
  kk_box_t _x10748;
  kk_box_t _borrowApp_10495 = kk_std_core_types_thd(x, _ctx); /*574*/;
  kk_std_core_types__tuple3__drop(x, _ctx);
  _x10748 = _borrowApp_10495; /*574*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_context_t*), op, (op, _x10746, _x10747, _x10748, _ctx));
}


// lift anonymous function
struct kk_std_core_hnd_clause_tail_noyield3_fun10749__t {
  struct kk_function_s _base;
  kk_function_t _b_10445_10443;
};
static kk_box_t kk_std_core_hnd_clause_tail_noyield3_fun10749(kk_function_t _fself, kk_box_t _b_10444, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_tail_noyield3_fun10749(kk_function_t _b_10445_10443, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail_noyield3_fun10749__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_tail_noyield3_fun10749__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_tail_noyield3_fun10749, kk_context());
  _self->_b_10445_10443 = _b_10445_10443;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_tail_noyield3_fun10749(kk_function_t _fself, kk_box_t _b_10444, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail_noyield3_fun10749__t* _self = kk_function_as(struct kk_std_core_hnd_clause_tail_noyield3_fun10749__t*, _fself);
  kk_function_t _b_10445_10443 = _self->_b_10445_10443; /* (x : (8623, 8624, 8625)) -> 8627 8626 */
  kk_drop_match(_self, {kk_function_dup(_b_10445_10443);}, {}, _ctx)
  kk_std_core_types__tuple3_ _x10750 = kk_std_core_types__tuple3__unbox(_b_10444, _ctx); /*(8623, 8624, 8625)*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_types__tuple3_, kk_context_t*), _b_10445_10443, (_b_10445_10443, _x10750, _ctx));
}

kk_std_core_hnd__clause1 kk_std_core_hnd_clause_tail_noyield3(kk_function_t op, kk_context_t* _ctx) { /* forall<a,b,c,d,e,a1,b1> (op : (a, b, c) -> e d) -> clause1<(a, b, c),d,a1,e,b1> */ 
  kk_function_t _b_10445_10443 = kk_std_core_hnd_new_clause_tail_noyield3_fun10745(op, _ctx); /*(x : (8623, 8624, 8625)) -> 8627 8626*/;
  return kk_std_core_hnd_clause_tail_noyield1(kk_std_core_hnd_new_clause_tail_noyield3_fun10749(_b_10445_10443, _ctx), _ctx);
}
 
// extra under1x to make under1 inlineable


// lift anonymous function
struct kk_std_core_hnd_under1x_fun10752__t {
  struct kk_function_s _base;
  kk_std_core_hnd__ev ev;
};
static kk_box_t kk_std_core_hnd_under1x_fun10752(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_under1x_fun10752(kk_std_core_hnd__ev ev, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under1x_fun10752__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_under1x_fun10752__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_under1x_fun10752, kk_context());
  _self->ev = ev;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_under1x_fun10752(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under1x_fun10752__t* _self = kk_function_as(struct kk_std_core_hnd_under1x_fun10752__t*, _fself);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<8690> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev);}, {}, _ctx)
  return kk_std_core_hnd_under1x(ev, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd_under1x(kk_std_core_hnd__ev ev, kk_function_t op, kk_box_t x, kk_context_t* _ctx) { /* forall<a,b,e,c> (ev : ev<c>, op : (a) -> e b, x : a) -> e b */ 
  kk_evv_t w0;
  kk_std_core_hnd__ev _x10751 = kk_std_core_hnd__ev_dup(ev); /*std/core/hnd/ev<8690>*/
  w0 = kk_std_core_hnd_evv_swap_with(_x10751, _ctx); /*std/core/hnd/evv<_8635>*/
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), op, (op, x, _ctx)); /*8688*/;
  if (kk_yielding(kk_context())) {
    kk_evv_drop(w0, _ctx);
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_under1x_fun10752(ev, _ctx), _ctx);
  }
  kk_std_core_hnd__ev_dropn(ev, ((int32_t)3), _ctx);
  kk_unit_t __0 = kk_Unit;
  kk_evv_set(w0,kk_context());
  return y;
}
extern kk_box_t kk_std_core_hnd_under1_fun10754(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under1_fun10754__t* _self = kk_function_as(struct kk_std_core_hnd_under1_fun10754__t*, _fself);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<8751> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev);}, {}, _ctx)
  return kk_std_core_hnd_under1x(ev, cont, res, _ctx);
}
extern kk_box_t kk_std_core_hnd_under0_fun10758(kk_function_t _fself, kk_function_t cont0, kk_box_t res0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under0_fun10758__t* _self = kk_function_as(struct kk_std_core_hnd_under0_fun10758__t*, _fself);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<8804> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev);}, {}, _ctx)
  return kk_std_core_hnd_under1x(ev, cont0, res0, _ctx);
}
extern kk_box_t kk_std_core_hnd_under0_fun10756(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under0_fun10756__t* _self = kk_function_as(struct kk_std_core_hnd_under0_fun10756__t*, _fself);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<8804> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev);}, {}, _ctx)
  kk_evv_t w00;
  kk_std_core_hnd__ev _x10757 = kk_std_core_hnd__ev_dup(ev); /*std/core/hnd/ev<8804>*/
  w00 = kk_std_core_hnd_evv_swap_with(_x10757, _ctx); /*std/core/hnd/evv<_8696>*/
  kk_box_t y0 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), cont, (cont, res, _ctx)); /*8802*/;
  if (kk_yielding(kk_context())) {
    kk_evv_drop(w00, _ctx);
    kk_box_drop(y0, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_under0_fun10758(ev, _ctx), _ctx);
  }
  kk_std_core_hnd__ev_dropn(ev, ((int32_t)3), _ctx);
  kk_unit_t __0 = kk_Unit;
  kk_evv_set(w00,kk_context());
  return y0;
}


// lift anonymous function
struct kk_std_core_hnd_clause_tail0_fun10759__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_tail0_fun10759(kk_function_t _fself, kk_std_core_hnd__marker ___wildcard__629__14, kk_std_core_hnd__ev ev, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_tail0_fun10759(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail0_fun10759__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_tail0_fun10759__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_tail0_fun10759, kk_context());
  _self->op = op;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_core_hnd_clause_tail0_fun10761__t {
  struct kk_function_s _base;
  kk_std_core_hnd__ev ev;
};
static kk_box_t kk_std_core_hnd_clause_tail0_fun10761(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_tail0_fun10761(kk_std_core_hnd__ev ev, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail0_fun10761__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_tail0_fun10761__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_tail0_fun10761, kk_context());
  _self->ev = ev;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_core_hnd_clause_tail0_fun10763__t {
  struct kk_function_s _base;
  kk_std_core_hnd__ev ev;
};
static kk_box_t kk_std_core_hnd_clause_tail0_fun10763(kk_function_t _fself, kk_function_t cont0, kk_box_t res0, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_tail0_fun10763(kk_std_core_hnd__ev ev, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail0_fun10763__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_tail0_fun10763__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_tail0_fun10763, kk_context());
  _self->ev = ev;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_tail0_fun10763(kk_function_t _fself, kk_function_t cont0, kk_box_t res0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail0_fun10763__t* _self = kk_function_as(struct kk_std_core_hnd_clause_tail0_fun10763__t*, _fself);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<8835> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev);}, {}, _ctx)
  return kk_std_core_hnd_under1x(ev, cont0, res0, _ctx);
}
static kk_box_t kk_std_core_hnd_clause_tail0_fun10761(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail0_fun10761__t* _self = kk_function_as(struct kk_std_core_hnd_clause_tail0_fun10761__t*, _fself);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<8835> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev);}, {}, _ctx)
  kk_evv_t w00;
  kk_std_core_hnd__ev _x10762 = kk_std_core_hnd__ev_dup(ev); /*std/core/hnd/ev<8835>*/
  w00 = kk_std_core_hnd_evv_swap_with(_x10762, _ctx); /*std/core/hnd/evv<_8696>*/
  kk_box_t y0 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), cont, (cont, res, _ctx)); /*8834*/;
  if (kk_yielding(kk_context())) {
    kk_evv_drop(w00, _ctx);
    kk_box_drop(y0, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_clause_tail0_fun10763(ev, _ctx), _ctx);
  }
  kk_std_core_hnd__ev_dropn(ev, ((int32_t)3), _ctx);
  kk_unit_t __0 = kk_Unit;
  kk_evv_set(w00,kk_context());
  return y0;
}
static kk_box_t kk_std_core_hnd_clause_tail0_fun10759(kk_function_t _fself, kk_std_core_hnd__marker ___wildcard__629__14, kk_std_core_hnd__ev ev, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail0_fun10759__t* _self = kk_function_as(struct kk_std_core_hnd_clause_tail0_fun10759__t*, _fself);
  kk_function_t op = _self->op; /* () -> 8832 8834 */
  kk_drop_match(_self, {kk_function_dup(op);}, {}, _ctx)
  kk_evv_t w0;
  kk_std_core_hnd__ev _x10760 = kk_std_core_hnd__ev_dup(ev); /*std/core/hnd/ev<8835>*/
  w0 = kk_std_core_hnd_evv_swap_with(_x10760, _ctx); /*std/core/hnd/evv<_8756>*/
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), op, (op, _ctx)); /*8834*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w0,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_clause_tail0_fun10761(ev, _ctx), _ctx);
  }
  kk_std_core_hnd__ev_dropn(ev, ((int32_t)3), _ctx);
  return y;
}

kk_std_core_hnd__clause0 kk_std_core_hnd_clause_tail0(kk_function_t op, kk_context_t* _ctx) { /* forall<e,a,b,c> (op : () -> e b) -> clause0<b,c,e,a> */ 
  return kk_std_core_hnd__new_Clause0(kk_std_core_hnd_new_clause_tail0_fun10759(op, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_tail1_fun10764__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_tail1_fun10764(kk_function_t _fself, kk_std_core_hnd__marker ___wildcard__577__14, kk_std_core_hnd__ev ev, kk_box_t x, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_tail1_fun10764(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail1_fun10764__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_tail1_fun10764__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_tail1_fun10764, kk_context());
  _self->op = op;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_core_hnd_clause_tail1_fun10766__t {
  struct kk_function_s _base;
  kk_std_core_hnd__ev ev;
};
static kk_box_t kk_std_core_hnd_clause_tail1_fun10766(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_tail1_fun10766(kk_std_core_hnd__ev ev, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail1_fun10766__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_tail1_fun10766__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_tail1_fun10766, kk_context());
  _self->ev = ev;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_tail1_fun10766(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail1_fun10766__t* _self = kk_function_as(struct kk_std_core_hnd_clause_tail1_fun10766__t*, _fself);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<8873> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev);}, {}, _ctx)
  return kk_std_core_hnd_under1x(ev, cont, res, _ctx);
}
static kk_box_t kk_std_core_hnd_clause_tail1_fun10764(kk_function_t _fself, kk_std_core_hnd__marker ___wildcard__577__14, kk_std_core_hnd__ev ev, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail1_fun10764__t* _self = kk_function_as(struct kk_std_core_hnd_clause_tail1_fun10764__t*, _fself);
  kk_function_t op = _self->op; /* (8871) -> 8869 8872 */
  kk_drop_match(_self, {kk_function_dup(op);}, {}, _ctx)
  kk_evv_t w0;
  kk_std_core_hnd__ev _x10765 = kk_std_core_hnd__ev_dup(ev); /*std/core/hnd/ev<8873>*/
  w0 = kk_std_core_hnd_evv_swap_with(_x10765, _ctx); /*std/core/hnd/evv<_8696>*/
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), op, (op, x, _ctx)); /*8872*/;
  if (kk_yielding(kk_context())) {
    kk_evv_drop(w0, _ctx);
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_clause_tail1_fun10766(ev, _ctx), _ctx);
  }
  kk_std_core_hnd__ev_dropn(ev, ((int32_t)3), _ctx);
  kk_unit_t __0 = kk_Unit;
  kk_evv_set(w0,kk_context());
  return y;
}

kk_std_core_hnd__clause1 kk_std_core_hnd_clause_tail1(kk_function_t op, kk_context_t* _ctx) { /* forall<e,a,b,c,d> (op : (b) -> e c) -> clause1<b,c,d,e,a> */ 
  return kk_std_core_hnd__new_Clause1(kk_std_core_hnd_new_clause_tail1_fun10764(op, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_under2_fun10768__t {
  struct kk_function_s _base;
  kk_std_core_hnd__ev ev;
};
static kk_box_t kk_std_core_hnd_under2_fun10768(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_under2_fun10768(kk_std_core_hnd__ev ev, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under2_fun10768__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_under2_fun10768__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_under2_fun10768, kk_context());
  _self->ev = ev;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_core_hnd_under2_fun10770__t {
  struct kk_function_s _base;
  kk_std_core_hnd__ev ev;
};
static kk_box_t kk_std_core_hnd_under2_fun10770(kk_function_t _fself, kk_function_t cont0, kk_box_t res0, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_under2_fun10770(kk_std_core_hnd__ev ev, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under2_fun10770__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_under2_fun10770__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_under2_fun10770, kk_context());
  _self->ev = ev;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_under2_fun10770(kk_function_t _fself, kk_function_t cont0, kk_box_t res0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under2_fun10770__t* _self = kk_function_as(struct kk_std_core_hnd_under2_fun10770__t*, _fself);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<8936> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev);}, {}, _ctx)
  return kk_std_core_hnd_under1x(ev, cont0, res0, _ctx);
}
static kk_box_t kk_std_core_hnd_under2_fun10768(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under2_fun10768__t* _self = kk_function_as(struct kk_std_core_hnd_under2_fun10768__t*, _fself);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<8936> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev);}, {}, _ctx)
  kk_evv_t w00;
  kk_std_core_hnd__ev _x10769 = kk_std_core_hnd__ev_dup(ev); /*std/core/hnd/ev<8936>*/
  w00 = kk_std_core_hnd_evv_swap_with(_x10769, _ctx); /*std/core/hnd/evv<_8696>*/
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), cont, (cont, res, _ctx)); /*8934*/;
  if (kk_yielding(kk_context())) {
    kk_evv_drop(w00, _ctx);
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_under2_fun10770(ev, _ctx), _ctx);
  }
  kk_std_core_hnd__ev_dropn(ev, ((int32_t)3), _ctx);
  kk_unit_t __0 = kk_Unit;
  kk_evv_set(w00,kk_context());
  return y;
}

kk_box_t kk_std_core_hnd_under2(kk_std_core_hnd__ev ev, kk_function_t op, kk_box_t x1, kk_box_t x2, kk_context_t* _ctx) { /* forall<a,b,c,e,d> (ev : ev<d>, op : (a, b) -> e c, x1 : a, x2 : b) -> e c */ 
  kk_evv_t w0;
  kk_std_core_hnd__ev _x10767 = kk_std_core_hnd__ev_dup(ev); /*std/core/hnd/ev<8936>*/
  w0 = kk_std_core_hnd_evv_swap_with(_x10767, _ctx); /*std/core/hnd/evv<_8880>*/
  kk_box_t z = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_context_t*), op, (op, x1, x2, _ctx)); /*8934*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w0,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(z, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_under2_fun10768(ev, _ctx), _ctx);
  }
  kk_std_core_hnd__ev_dropn(ev, ((int32_t)3), _ctx);
  return z;
}


// lift anonymous function
struct kk_std_core_hnd_clause_tail2_fun10771__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_tail2_fun10771(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ev, kk_box_t x1, kk_box_t x2, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_tail2_fun10771(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail2_fun10771__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_tail2_fun10771__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_tail2_fun10771, kk_context());
  _self->op = op;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_tail2_fun10771(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ev, kk_box_t x1, kk_box_t x2, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail2_fun10771__t* _self = kk_function_as(struct kk_std_core_hnd_clause_tail2_fun10771__t*, _fself);
  kk_function_t op = _self->op; /* (8978, 8979) -> 8976 8980 */
  kk_drop_match(_self, {kk_function_dup(op);}, {}, _ctx)
  return kk_std_core_hnd_under2(ev, op, x1, x2, _ctx);
}

kk_std_core_hnd__clause2 kk_std_core_hnd_clause_tail2(kk_function_t op, kk_context_t* _ctx) { /* forall<e,a,b,c,d,a1> (op : (b, c) -> e d) -> clause2<b,c,d,a1,e,a> */ 
  return kk_std_core_hnd__new_Clause2(kk_std_core_hnd_new_clause_tail2_fun10771(op, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_tail3_fun10772__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_tail3_fun10772(kk_function_t _fself, kk_std_core_types__tuple3_ x, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_tail3_fun10772(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail3_fun10772__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_tail3_fun10772__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_tail3_fun10772, kk_context());
  _self->op = op;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_tail3_fun10772(kk_function_t _fself, kk_std_core_types__tuple3_ x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail3_fun10772__t* _self = kk_function_as(struct kk_std_core_hnd_clause_tail3_fun10772__t*, _fself);
  kk_function_t op = _self->op; /* (9211, 9212, 9213) -> 9215 9214 */
  kk_drop_match(_self, {kk_function_dup(op);}, {}, _ctx)
  kk_box_t _x10773 = kk_std_core_types_fst_1(x, _ctx); /*486*/
  kk_box_t _x10774 = kk_std_core_types_snd_1(x, _ctx); /*530*/
  kk_box_t _x10775;
  kk_box_t _borrowApp_10485 = kk_std_core_types_thd(x, _ctx); /*574*/;
  kk_std_core_types__tuple3__drop(x, _ctx);
  _x10775 = _borrowApp_10485; /*574*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_context_t*), op, (op, _x10773, _x10774, _x10775, _ctx));
}


// lift anonymous function
struct kk_std_core_hnd_clause_tail3_fun10776__t {
  struct kk_function_s _base;
  kk_function_t _b_10448_10446;
};
static kk_box_t kk_std_core_hnd_clause_tail3_fun10776(kk_function_t _fself, kk_box_t _b_10447, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_tail3_fun10776(kk_function_t _b_10448_10446, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail3_fun10776__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_tail3_fun10776__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_tail3_fun10776, kk_context());
  _self->_b_10448_10446 = _b_10448_10446;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_tail3_fun10776(kk_function_t _fself, kk_box_t _b_10447, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail3_fun10776__t* _self = kk_function_as(struct kk_std_core_hnd_clause_tail3_fun10776__t*, _fself);
  kk_function_t _b_10448_10446 = _self->_b_10448_10446; /* (x : (9211, 9212, 9213)) -> 9215 9214 */
  kk_drop_match(_self, {kk_function_dup(_b_10448_10446);}, {}, _ctx)
  kk_std_core_types__tuple3_ _x10777 = kk_std_core_types__tuple3__unbox(_b_10447, _ctx); /*(9211, 9212, 9213)*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_types__tuple3_, kk_context_t*), _b_10448_10446, (_b_10448_10446, _x10777, _ctx));
}

kk_std_core_hnd__clause1 kk_std_core_hnd_clause_tail3(kk_function_t op, kk_context_t* _ctx) { /* forall<a,b,c,d,e,a1,b1> (op : (a, b, c) -> e d) -> clause1<(a, b, c),d,a1,e,b1> */ 
  kk_function_t _b_10448_10446 = kk_std_core_hnd_new_clause_tail3_fun10772(op, _ctx); /*(x : (9211, 9212, 9213)) -> 9215 9214*/;
  return kk_std_core_hnd_clause_tail_noyield1(kk_std_core_hnd_new_clause_tail3_fun10776(_b_10448_10446, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_tail4_fun10778__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_tail4_fun10778(kk_function_t _fself, kk_std_core_types__tuple4_ x, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_tail4_fun10778(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail4_fun10778__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_tail4_fun10778__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_tail4_fun10778, kk_context());
  _self->op = op;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_tail4_fun10778(kk_function_t _fself, kk_std_core_types__tuple4_ x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail4_fun10778__t* _self = kk_function_as(struct kk_std_core_hnd_clause_tail4_fun10778__t*, _fself);
  kk_function_t op = _self->op; /* (9517, 9518, 9519, 9520) -> 9522 9521 */
  kk_drop_match(_self, {kk_function_dup(op);}, {}, _ctx)
  kk_box_t _x10779 = kk_std_core_types_fst_2(x, _ctx); /*731*/
  kk_box_t _x10780 = kk_std_core_types_snd_2(x, _ctx); /*800*/
  kk_box_t _x10781 = kk_std_core_types_thd_1(x, _ctx); /*869*/
  kk_box_t _x10782;
  kk_box_t _borrowApp_10484 = kk_std_core_types_field4(x, _ctx); /*925*/;
  kk_std_core_types__tuple4__dropn(x, ((int32_t)4), _ctx);
  _x10782 = _borrowApp_10484; /*925*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_box_t, kk_context_t*), op, (op, _x10779, _x10780, _x10781, _x10782, _ctx));
}


// lift anonymous function
struct kk_std_core_hnd_clause_tail4_fun10783__t {
  struct kk_function_s _base;
  kk_function_t _b_10451_10449;
};
static kk_box_t kk_std_core_hnd_clause_tail4_fun10783(kk_function_t _fself, kk_box_t _b_10450, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_tail4_fun10783(kk_function_t _b_10451_10449, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail4_fun10783__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_tail4_fun10783__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_clause_tail4_fun10783, kk_context());
  _self->_b_10451_10449 = _b_10451_10449;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_clause_tail4_fun10783(kk_function_t _fself, kk_box_t _b_10450, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail4_fun10783__t* _self = kk_function_as(struct kk_std_core_hnd_clause_tail4_fun10783__t*, _fself);
  kk_function_t _b_10451_10449 = _self->_b_10451_10449; /* (x : (9517, 9518, 9519, 9520)) -> 9522 9521 */
  kk_drop_match(_self, {kk_function_dup(_b_10451_10449);}, {}, _ctx)
  kk_std_core_types__tuple4_ _x10784 = kk_std_core_types__tuple4__unbox(_b_10450, _ctx); /*(9517, 9518, 9519, 9520)*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_types__tuple4_, kk_context_t*), _b_10451_10449, (_b_10451_10449, _x10784, _ctx));
}

kk_std_core_hnd__clause1 kk_std_core_hnd_clause_tail4(kk_function_t op, kk_context_t* _ctx) { /* forall<a,b,c,d,a1,e,b1,c1> (op : (a, b, c, d) -> e a1) -> clause1<(a, b, c, d),a1,b1,e,c1> */ 
  kk_function_t _b_10451_10449 = kk_std_core_hnd_new_clause_tail4_fun10778(op, _ctx); /*(x : (9517, 9518, 9519, 9520)) -> 9522 9521*/;
  return kk_std_core_hnd_clause_tail_noyield1(kk_std_core_hnd_new_clause_tail4_fun10783(_b_10451_10449, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_finally_prompt_fun10785__t {
  struct kk_function_s _base;
  kk_function_t fin;
};
static kk_box_t kk_std_core_hnd_finally_prompt_fun10785(kk_function_t _fself, kk_function_t cont, kk_box_t x, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_finally_prompt_fun10785(kk_function_t fin, kk_context_t* _ctx) {
  struct kk_std_core_hnd_finally_prompt_fun10785__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_finally_prompt_fun10785__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_finally_prompt_fun10785, kk_context());
  _self->fin = fin;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_finally_prompt_fun10785(kk_function_t _fself, kk_function_t cont, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_finally_prompt_fun10785__t* _self = kk_function_as(struct kk_std_core_hnd_finally_prompt_fun10785__t*, _fself);
  kk_function_t fin = _self->fin; /* () -> 9614 () */
  kk_drop_match(_self, {kk_function_dup(fin);}, {}, _ctx)
  kk_box_t _x10786 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), cont, (cont, x, _ctx)); /*9613*/
  return kk_std_core_hnd_finally_prompt(fin, _x10786, _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_finally_prompt_fun10787__t {
  struct kk_function_s _base;
  kk_std_core_hnd__yield_info yld;
};
static kk_box_t kk_std_core_hnd_finally_prompt_fun10787(kk_function_t _fself, kk_box_t ___wildcard__420__43, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_finally_prompt_fun10787(kk_std_core_hnd__yield_info yld, kk_context_t* _ctx) {
  struct kk_std_core_hnd_finally_prompt_fun10787__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_finally_prompt_fun10787__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_finally_prompt_fun10787, kk_context());
  _self->yld = yld;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_finally_prompt_fun10787(kk_function_t _fself, kk_box_t ___wildcard__420__43, kk_context_t* _ctx) {
  struct kk_std_core_hnd_finally_prompt_fun10787__t* _self = kk_function_as(struct kk_std_core_hnd_finally_prompt_fun10787__t*, _fself);
  kk_std_core_hnd__yield_info yld = _self->yld; /* std/core/hnd/yield-info */
  kk_drop_match(_self, {kk_std_core_hnd__yield_info_dup(yld);}, {}, _ctx)
  kk_box_drop(___wildcard__420__43, _ctx);
  return kk_std_core_hnd_unsafe_reyield(yld, _ctx);
}

kk_box_t kk_std_core_hnd_finally_prompt(kk_function_t fin, kk_box_t res, kk_context_t* _ctx) { /* forall<a,e> (fin : () -> e (), res : a) -> e a */ 
  if (kk_yielding(kk_context())) {
    kk_box_drop(res, _ctx);
    bool _match_10482 = kk_yielding_non_final(kk_context()); /*bool*/;
    if (_match_10482) {
      return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_finally_prompt_fun10785(fin, _ctx), _ctx);
    }
    kk_std_core_hnd__yield_info yld = kk_std_core_hnd_yield_capture(_ctx); /*std/core/hnd/yield-info*/;
    kk_unit_t __0 = kk_Unit;
    kk_function_call(kk_unit_t, (kk_function_t, kk_context_t*), fin, (fin, _ctx));
    if (kk_yielding(kk_context())) {
      return kk_std_core_hnd_yield_extend(kk_std_core_hnd_new_finally_prompt_fun10787(yld, _ctx), _ctx);
    }
    return kk_std_core_hnd_unsafe_reyield(yld, _ctx);
  }
  kk_unit_t __ = kk_Unit;
  kk_function_call(kk_unit_t, (kk_function_t, kk_context_t*), fin, (fin, _ctx));
  return res;
}


// lift anonymous function
struct kk_std_core_hnd_initially_prompt_fun10789__t {
  struct kk_function_s _base;
  kk_ref_t count;
  kk_function_t init;
};
static kk_box_t kk_std_core_hnd_initially_prompt_fun10789(kk_function_t _fself, kk_function_t cont, kk_box_t x, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_initially_prompt_fun10789(kk_ref_t count, kk_function_t init, kk_context_t* _ctx) {
  struct kk_std_core_hnd_initially_prompt_fun10789__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_initially_prompt_fun10789__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_initially_prompt_fun10789, kk_context());
  _self->count = count;
  _self->init = init;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_core_hnd_initially_prompt_fun10795__t {
  struct kk_function_s _base;
  kk_function_t cont;
  kk_function_t init;
  kk_box_t x;
};
static kk_box_t kk_std_core_hnd_initially_prompt_fun10795(kk_function_t _fself, kk_box_t ___wildcard__462__49, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_initially_prompt_fun10795(kk_function_t cont, kk_function_t init, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_initially_prompt_fun10795__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_initially_prompt_fun10795__t, 4, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_initially_prompt_fun10795, kk_context());
  _self->cont = cont;
  _self->init = init;
  _self->x = x;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_initially_prompt_fun10795(kk_function_t _fself, kk_box_t ___wildcard__462__49, kk_context_t* _ctx) {
  struct kk_std_core_hnd_initially_prompt_fun10795__t* _self = kk_function_as(struct kk_std_core_hnd_initially_prompt_fun10795__t*, _fself);
  kk_function_t cont = _self->cont; /* (9758) -> 9768 9767 */
  kk_function_t init = _self->init; /* (int) -> 9768 () */
  kk_box_t x = _self->x; /* 9758 */
  kk_drop_match(_self, {kk_function_dup(cont);kk_function_dup(init);kk_box_dup(x);}, {}, _ctx)
  kk_box_drop(___wildcard__462__49, _ctx);
  kk_box_t _x10796 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), cont, (cont, x, _ctx)); /*9767*/
  return kk_std_core_hnd_initially_prompt(init, _x10796, _ctx);
}
static kk_box_t kk_std_core_hnd_initially_prompt_fun10789(kk_function_t _fself, kk_function_t cont, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_initially_prompt_fun10789__t* _self = kk_function_as(struct kk_std_core_hnd_initially_prompt_fun10789__t*, _fself);
  kk_ref_t count = _self->count; /* ref<global,int> */
  kk_function_t init = _self->init; /* (int) -> 9768 () */
  kk_drop_match(_self, {kk_ref_dup(count);kk_function_dup(init);}, {}, _ctx)
  kk_integer_t cnt;
  kk_box_t _x10790;
  kk_ref_t _x10791 = kk_ref_dup(count); /*ref<global,int>*/
  _x10790 = kk_ref_get(_x10791,kk_context()); /*182*/
  cnt = kk_integer_unbox(_x10790); /*int*/
  kk_integer_t _b_10459_10457;
  kk_integer_t _x10792 = kk_integer_dup(cnt); /*int*/
  _b_10459_10457 = kk_integer_add(_x10792,(kk_integer_from_small(1)),kk_context()); /*int*/
  kk_unit_t __ = kk_Unit;
  kk_unit_t _borrowApp_10481 = kk_Unit;
  kk_ref_set_borrow(count,(kk_integer_box(_b_10459_10457)),kk_context());
  kk_ref_drop(count, _ctx);
  _borrowApp_10481;
  bool _match_10477;
  kk_integer_t _borrowedArg_10479 = kk_integer_from_small(0); /*int*/;
  bool _borrowApp_10480 = kk_integer_eq_borrow(cnt,_borrowedArg_10479,kk_context()); /*bool*/;
  kk_integer_drop(_borrowedArg_10479, _ctx);
  _match_10477 = _borrowApp_10480; /*bool*/
  if (_match_10477) {
    kk_integer_drop(cnt, _ctx);
    kk_box_t _x10793 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), cont, (cont, x, _ctx)); /*9767*/
    return kk_std_core_hnd_initially_prompt(init, _x10793, _ctx);
  }
  kk_unit_t r = kk_Unit;
  kk_function_t _x10794 = kk_function_dup(init); /*(int) -> 9768 ()*/
  kk_function_call(kk_unit_t, (kk_function_t, kk_integer_t, kk_context_t*), _x10794, (_x10794, cnt, _ctx));
  if (kk_yielding(kk_context())) {
    return kk_std_core_hnd_yield_extend(kk_std_core_hnd_new_initially_prompt_fun10795(cont, init, x, _ctx), _ctx);
  }
  kk_box_t _x10797 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), cont, (cont, x, _ctx)); /*9767*/
  return kk_std_core_hnd_initially_prompt(init, _x10797, _ctx);
}

kk_box_t kk_std_core_hnd_initially_prompt(kk_function_t init, kk_box_t res, kk_context_t* _ctx) { /* forall<a,e> (init : (int) -> e (), res : a) -> e a */ 
  bool _match_10476 = kk_yielding_non_final(kk_context()); /*bool*/;
  if (_match_10476) {
    kk_box_drop(res, _ctx);
    kk_ref_t count = kk_ref_alloc((kk_integer_box(kk_integer_from_small(0))),kk_context()); /*ref<global,int>*/;
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_initially_prompt_fun10789(count, init, _ctx), _ctx);
  }
  kk_function_drop(init, _ctx);
  return res;
}


// lift anonymous function
struct kk_std_core_hnd_initially_fun10799__t {
  struct kk_function_s _base;
  kk_function_t action;
  kk_function_t init;
};
static kk_box_t kk_std_core_hnd_initially_fun10799(kk_function_t _fself, kk_unit_t ___wildcard__450__42, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_initially_fun10799(kk_function_t action, kk_function_t init, kk_context_t* _ctx) {
  struct kk_std_core_hnd_initially_fun10799__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_initially_fun10799__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_initially_fun10799, kk_context());
  _self->action = action;
  _self->init = init;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_initially_fun10799(kk_function_t _fself, kk_unit_t ___wildcard__450__42, kk_context_t* _ctx) {
  struct kk_std_core_hnd_initially_fun10799__t* _self = kk_function_as(struct kk_std_core_hnd_initially_fun10799__t*, _fself);
  kk_function_t action = _self->action; /* () -> 9804 9803 */
  kk_function_t init = _self->init; /* (int) -> 9804 () */
  kk_drop_match(_self, {kk_function_dup(action);kk_function_dup(init);}, {}, _ctx)
  kk_box_t _x10800 = kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), action, (action, _ctx)); /*9803*/
  return kk_std_core_hnd_initially_prompt(init, _x10800, _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_initially_fun10801__t {
  struct kk_function_s _base;
  kk_function_t _b_10462_10460;
};
static kk_box_t kk_std_core_hnd_initially_fun10801(kk_function_t _fself, kk_box_t _b_10461, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_initially_fun10801(kk_function_t _b_10462_10460, kk_context_t* _ctx) {
  struct kk_std_core_hnd_initially_fun10801__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_initially_fun10801__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_initially_fun10801, kk_context());
  _self->_b_10462_10460 = _b_10462_10460;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_initially_fun10801(kk_function_t _fself, kk_box_t _b_10461, kk_context_t* _ctx) {
  struct kk_std_core_hnd_initially_fun10801__t* _self = kk_function_as(struct kk_std_core_hnd_initially_fun10801__t*, _fself);
  kk_function_t _b_10462_10460 = _self->_b_10462_10460; /* (()) -> 9804 9803 */
  kk_drop_match(_self, {kk_function_dup(_b_10462_10460);}, {}, _ctx)
  kk_unit_t _x10802 = kk_Unit;
  kk_unit_unbox(_b_10461);
  return kk_function_call(kk_box_t, (kk_function_t, kk_unit_t, kk_context_t*), _b_10462_10460, (_b_10462_10460, _x10802, _ctx));
}

kk_box_t kk_std_core_hnd_initially(kk_function_t init, kk_function_t action, kk_context_t* _ctx) { /* forall<a,e> (init : (int) -> e (), action : () -> e a) -> e a */ 
  kk_unit_t __ = kk_Unit;
  kk_function_t _x10798 = kk_function_dup(init); /*(int) -> 9804 ()*/
  kk_function_call(kk_unit_t, (kk_function_t, kk_integer_t, kk_context_t*), _x10798, (_x10798, kk_integer_from_small(0), _ctx));
  if (kk_yielding(kk_context())) {
    kk_function_t _b_10462_10460 = kk_std_core_hnd_new_initially_fun10799(action, init, _ctx); /*(()) -> 9804 9803*/;
    return kk_std_core_hnd_yield_extend(kk_std_core_hnd_new_initially_fun10801(_b_10462_10460, _ctx), _ctx);
  }
  kk_box_t _x10803 = kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), action, (action, _ctx)); /*9803*/
  return kk_std_core_hnd_initially_prompt(init, _x10803, _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_prompt_local_var_fun10805__t {
  struct kk_function_s _base;
  kk_ref_t loc;
  kk_box_t v;
};
static kk_box_t kk_std_core_hnd_prompt_local_var_fun10805(kk_function_t _fself, kk_function_t cont, kk_box_t x, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_prompt_local_var_fun10805(kk_ref_t loc, kk_box_t v, kk_context_t* _ctx) {
  struct kk_std_core_hnd_prompt_local_var_fun10805__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_prompt_local_var_fun10805__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_prompt_local_var_fun10805, kk_context());
  _self->loc = loc;
  _self->v = v;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_prompt_local_var_fun10805(kk_function_t _fself, kk_function_t cont, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_prompt_local_var_fun10805__t* _self = kk_function_as(struct kk_std_core_hnd_prompt_local_var_fun10805__t*, _fself);
  kk_ref_t loc = _self->loc; /* local-var<9897,9894> */
  kk_box_t v = _self->v; /* 9894 */
  kk_drop_match(_self, {kk_ref_dup(loc);kk_box_dup(v);}, {}, _ctx)
  kk_unit_t __0 = kk_Unit;
  (kk_ref_set_borrow(loc,v,kk_context()));
  kk_box_t _x10806 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), cont, (cont, x, _ctx)); /*9895*/
  return kk_std_core_hnd_prompt_local_var(loc, _x10806, _ctx);
}

kk_box_t kk_std_core_hnd_prompt_local_var(kk_ref_t loc, kk_box_t res, kk_context_t* _ctx) { /* forall<a,b,h> (loc : local-var<h,a>, res : b) -> <div,local<h>> b */ 
  if (kk_yielding(kk_context())) {
    kk_box_drop(res, _ctx);
    kk_box_t v;
    kk_ref_t _x10804 = kk_ref_dup(loc); /*local-var<9897,9894>*/
    v = (kk_ref_get(_x10804,kk_context())); /*9894*/
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_prompt_local_var_fun10805(loc, v, _ctx), _ctx);
  }
  kk_ref_drop(loc, _ctx);
  return res;
}


// lift anonymous function
struct kk_std_core_hnd_try_finalize_prompt_fun10808__t {
  struct kk_function_s _base;
};
static kk_std_core_types__either kk_std_core_hnd_try_finalize_prompt_fun10808(kk_function_t _fself, kk_function_t cont, kk_box_t x, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_try_finalize_prompt_fun10808(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_hnd_try_finalize_prompt_fun10808, _ctx)
  return kk_function_dup(_fself);
}

static kk_std_core_types__either kk_std_core_hnd_try_finalize_prompt_fun10808(kk_function_t _fself, kk_function_t cont, kk_box_t x, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_box_t _x10809 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), cont, (cont, x, _ctx)); /*10070*/
  return kk_std_core_hnd_try_finalize_prompt(_x10809, _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_try_finalize_prompt_fun10811__t {
  struct kk_function_s _base;
  kk_function_t _b_10467_10463;
};
static kk_box_t kk_std_core_hnd_try_finalize_prompt_fun10811(kk_function_t _fself, kk_function_t _b_10464, kk_box_t _b_10465, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_try_finalize_prompt_fun10811(kk_function_t _b_10467_10463, kk_context_t* _ctx) {
  struct kk_std_core_hnd_try_finalize_prompt_fun10811__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_try_finalize_prompt_fun10811__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_try_finalize_prompt_fun10811, kk_context());
  _self->_b_10467_10463 = _b_10467_10463;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_try_finalize_prompt_fun10811(kk_function_t _fself, kk_function_t _b_10464, kk_box_t _b_10465, kk_context_t* _ctx) {
  struct kk_std_core_hnd_try_finalize_prompt_fun10811__t* _self = kk_function_as(struct kk_std_core_hnd_try_finalize_prompt_fun10811__t*, _fself);
  kk_function_t _b_10467_10463 = _self->_b_10467_10463; /* (cont : (10020) -> 10071 10070, x : 10020) -> 10071 either<std/core/hnd/yield-info,10070> */
  kk_drop_match(_self, {kk_function_dup(_b_10467_10463);}, {}, _ctx)
  kk_std_core_types__either _x10812 = kk_function_call(kk_std_core_types__either, (kk_function_t, kk_function_t, kk_box_t, kk_context_t*), _b_10467_10463, (_b_10467_10463, _b_10464, _b_10465, _ctx)); /*either<std/core/hnd/yield-info,10070>*/
  return kk_std_core_types__either_box(_x10812, _ctx);
}

kk_std_core_types__either kk_std_core_hnd_try_finalize_prompt(kk_box_t res, kk_context_t* _ctx) { /* forall<a,e> (res : a) -> e either<yield-info,a> */ 
  bool _match_10474 = kk_yielding_non_final(kk_context()); /*bool*/;
  if (_match_10474) {
    kk_box_drop(res, _ctx);
    kk_function_t _b_10467_10463 = kk_std_core_hnd_new_try_finalize_prompt_fun10808(_ctx); /*(cont : (10020) -> 10071 10070, x : 10020) -> 10071 either<std/core/hnd/yield-info,10070>*/;
    kk_box_t _x10810 = kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_try_finalize_prompt_fun10811(_b_10467_10463, _ctx), _ctx); /*3881*/
    return kk_std_core_types__either_unbox(_x10810, _ctx);
  }
  if (kk_yielding(kk_context())) {
    kk_box_drop(res, _ctx);
    kk_std_core_hnd__yield_info _b_10468_10466 = kk_std_core_hnd_yield_capture(_ctx); /*std/core/hnd/yield-info*/;
    return kk_std_core_types__new_Left(kk_std_core_hnd__yield_info_box(_b_10468_10466, _ctx), _ctx);
  }
  return kk_std_core_types__new_Right(res, _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_under3_fun10814__t {
  struct kk_function_s _base;
  kk_std_core_hnd__ev ev;
};
static kk_box_t kk_std_core_hnd_under3_fun10814(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_under3_fun10814(kk_std_core_hnd__ev ev, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under3_fun10814__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_under3_fun10814__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_under3_fun10814, kk_context());
  _self->ev = ev;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_core_hnd_under3_fun10816__t {
  struct kk_function_s _base;
  kk_std_core_hnd__ev ev;
};
static kk_box_t kk_std_core_hnd_under3_fun10816(kk_function_t _fself, kk_function_t cont0, kk_box_t res0, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_under3_fun10816(kk_std_core_hnd__ev ev, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under3_fun10816__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_under3_fun10816__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_under3_fun10816, kk_context());
  _self->ev = ev;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_under3_fun10816(kk_function_t _fself, kk_function_t cont0, kk_box_t res0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under3_fun10816__t* _self = kk_function_as(struct kk_std_core_hnd_under3_fun10816__t*, _fself);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<10139> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev);}, {}, _ctx)
  return kk_std_core_hnd_under1x(ev, cont0, res0, _ctx);
}
static kk_box_t kk_std_core_hnd_under3_fun10814(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under3_fun10814__t* _self = kk_function_as(struct kk_std_core_hnd_under3_fun10814__t*, _fself);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<10139> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev);}, {}, _ctx)
  kk_evv_t w00;
  kk_std_core_hnd__ev _x10815 = kk_std_core_hnd__ev_dup(ev); /*std/core/hnd/ev<10139>*/
  w00 = kk_std_core_hnd_evv_swap_with(_x10815, _ctx); /*std/core/hnd/evv<_8696>*/
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), cont, (cont, res, _ctx)); /*10137*/;
  if (kk_yielding(kk_context())) {
    kk_evv_drop(w00, _ctx);
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_under3_fun10816(ev, _ctx), _ctx);
  }
  kk_std_core_hnd__ev_dropn(ev, ((int32_t)3), _ctx);
  kk_unit_t __0 = kk_Unit;
  kk_evv_set(w00,kk_context());
  return y;
}

kk_box_t kk_std_core_hnd_under3(kk_std_core_hnd__ev ev, kk_function_t op, kk_box_t x1, kk_box_t x2, kk_box_t x3, kk_context_t* _ctx) { /* forall<a,b,c,d,e,a1> (ev : ev<a1>, op : (a, b, c) -> e d, x1 : a, x2 : b, x3 : c) -> e d */ 
  kk_evv_t w0;
  kk_std_core_hnd__ev _x10813 = kk_std_core_hnd__ev_dup(ev); /*std/core/hnd/ev<10139>*/
  w0 = kk_std_core_hnd_evv_swap_with(_x10813, _ctx); /*std/core/hnd/evv<_10079>*/
  kk_box_t z = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_context_t*), op, (op, x1, x2, x3, _ctx)); /*10137*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w0,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(z, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_under3_fun10814(ev, _ctx), _ctx);
  }
  kk_std_core_hnd__ev_dropn(ev, ((int32_t)3), _ctx);
  return z;
}


// lift anonymous function
struct kk_std_core_hnd_under4_fun10818__t {
  struct kk_function_s _base;
  kk_std_core_hnd__ev ev;
};
static kk_box_t kk_std_core_hnd_under4_fun10818(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_under4_fun10818(kk_std_core_hnd__ev ev, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under4_fun10818__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_under4_fun10818__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_under4_fun10818, kk_context());
  _self->ev = ev;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_core_hnd_under4_fun10820__t {
  struct kk_function_s _base;
  kk_std_core_hnd__ev ev;
};
static kk_box_t kk_std_core_hnd_under4_fun10820(kk_function_t _fself, kk_function_t cont0, kk_box_t res0, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_under4_fun10820(kk_std_core_hnd__ev ev, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under4_fun10820__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_under4_fun10820__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_core_hnd_under4_fun10820, kk_context());
  _self->ev = ev;
  return &_self->_base;
}

static kk_box_t kk_std_core_hnd_under4_fun10820(kk_function_t _fself, kk_function_t cont0, kk_box_t res0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under4_fun10820__t* _self = kk_function_as(struct kk_std_core_hnd_under4_fun10820__t*, _fself);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<10212> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev);}, {}, _ctx)
  return kk_std_core_hnd_under1x(ev, cont0, res0, _ctx);
}
static kk_box_t kk_std_core_hnd_under4_fun10818(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under4_fun10818__t* _self = kk_function_as(struct kk_std_core_hnd_under4_fun10818__t*, _fself);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<10212> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev);}, {}, _ctx)
  kk_evv_t w00;
  kk_std_core_hnd__ev _x10819 = kk_std_core_hnd__ev_dup(ev); /*std/core/hnd/ev<10212>*/
  w00 = kk_std_core_hnd_evv_swap_with(_x10819, _ctx); /*std/core/hnd/evv<_8696>*/
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), cont, (cont, res, _ctx)); /*10210*/;
  if (kk_yielding(kk_context())) {
    kk_evv_drop(w00, _ctx);
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_under4_fun10820(ev, _ctx), _ctx);
  }
  kk_std_core_hnd__ev_dropn(ev, ((int32_t)3), _ctx);
  kk_unit_t __0 = kk_Unit;
  kk_evv_set(w00,kk_context());
  return y;
}

kk_box_t kk_std_core_hnd_under4(kk_std_core_hnd__ev ev, kk_function_t op, kk_box_t x1, kk_box_t x2, kk_box_t x3, kk_box_t x4, kk_context_t* _ctx) { /* forall<a,b,c,d,a1,e,b1> (ev : ev<b1>, op : (a, b, c, d) -> e a1, x1 : a, x2 : b, x3 : c, x4 : d) -> e a1 */ 
  kk_evv_t w0;
  kk_std_core_hnd__ev _x10817 = kk_std_core_hnd__ev_dup(ev); /*std/core/hnd/ev<10212>*/
  w0 = kk_std_core_hnd_evv_swap_with(_x10817, _ctx); /*std/core/hnd/evv<_10148>*/
  kk_box_t z = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_box_t, kk_context_t*), op, (op, x1, x2, x3, x4, _ctx)); /*10210*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w0,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(z, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_under4_fun10818(ev, _ctx), _ctx);
  }
  kk_std_core_hnd__ev_dropn(ev, ((int32_t)3), _ctx);
  return z;
}

// initialization
void kk_std_core_hnd__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
}

// termination
void kk_std_core_hnd__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_core_types__done(_ctx);
}
