// Koka generated module: "std/num/double", koka version: 2.2.1
#include "std_num_double.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/

static inline kk_std_core_types__tuple2_ kk_double_to_bits( double d, kk_context_t* ctx ) {
  uint64_t u;
  memcpy(&u,&d,sizeof(u));  // safe for C aliasing: see <https://gist.github.com/shafik/848ae25ee209f698763cffee272a58f8#how-do-we-type-pun-correctly>
  return kk_std_core_types__new_dash__lp__comma__rp_( kk_int32_box((int32_t)u, ctx), kk_int32_box((int32_t)(u >> 32), ctx), ctx );
}

static inline double kk_double_from_bits( int32_t lo, int32_t hi, kk_context_t* ctx ) {
  KK_UNUSED(ctx);
  double d;
  uint64_t u = (((uint64_t)((uint32_t)hi)) << 32) | (uint32_t)lo;  // note: careful about sign extension
  memcpy(&d,&u,sizeof(d));
  return d;
}

static inline double kk_prim_parse_double( kk_string_t str, kk_context_t* ctx) {
  const char* s = kk_string_cbuf_borrow(str,NULL);
  char* end;
  double d = strtod(s,&end);
  kk_string_drop(str,ctx);  
  return d;
}

 
// lifted
// specialized std/core/foldl to parameters [f]

double kk_std_num_double__lift3878_abs_max_1(kk_std_core__list xs0, double z, kk_context_t* _ctx) { /* (xs0 : list<double>, z : double) -> double */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs0)) {
    struct kk_std_core_Cons* _con4783 = kk_std_core__as_Cons(xs0);
    kk_box_t _box_x4140 = _con4783->head;
    kk_std_core__list xx = _con4783->tail;
    double x0 = kk_double_unbox(_box_x4140, NULL);
    if (kk_likely(kk_std_core__list_is_unique(xs0))) {
      kk_box_drop(_box_x4140, _ctx);
      kk_Unit;
      kk_Unit;
      kk_std_core__list_free(xs0);
    }
    else {
      kk_std_core__list_dup(xx);
      kk_Unit;
      kk_std_core__list_decref(xs0, _ctx);
      kk_Unit;
    }
    { // tailcall
      double _x4785;
      double x0_3818 = kk_double_abs(x0); /*double*/;
      bool _match_4765 = (x0_3818 >= z); /*bool*/;
      if (_match_4765) {
        _x4785 = x0_3818; /*double*/
      }
      else {
        _x4785 = z; /*double*/
      }
      xs0 = xx;
      z = _x4785;
      goto kk__tailcall;
    }
  }
  return z;
}
 
// The area hyperbolic cosine of `d`

double kk_std_num_double_acosh(double d, kk_context_t* _ctx) { /* (d : double) -> double */ 
  return acosh(d);
}
 
// The area hyperbolic sine of `d`

double kk_std_num_double_asinh(double d, kk_context_t* _ctx) { /* (d : double) -> double */ 
  return asinh(d);
}
 
// The area hyperbolic tangent of `d`

double kk_std_num_double_atanh(double d, kk_context_t* _ctx) { /* (d : double) -> double */ 
  return atanh(d);
}

kk_integer_t kk_std_num_double_dbl_max_prec;
 
// Low-level: return the `(lo,hi)` bits of a 64-bit double.

kk_std_core_types__tuple2_ kk_std_num_double_double_to_bits(double d, kk_context_t* _ctx) { /* (d : double) -> (int32, int32) */ 
  return kk_double_to_bits(d,kk_context());
}
 
// Low-level: create a `:double` from the given `lo` and `hi` 32-bits.

double kk_std_num_double_double_from_bits(int32_t lo, int32_t hi, kk_context_t* _ctx) { /* (lo : int32, hi : int32) -> double */ 
  return kk_double_from_bits(lo,hi,kk_context());
}

double kk_std_num_double_make_neginf(kk_context_t* _ctx) { /* () -> double */ 
  return -HUGE_VAL;
}

double kk_std_num_double_make_posinf(kk_context_t* _ctx) { /* () -> double */ 
  return HUGE_VAL;
}
 
// fused multiply-add. Computes `(x*y)+z` as if to infinite precision
// with only the final result rounded back to a `:double`.

double kk_std_num_double_fmadd(double x, double y, double z, kk_context_t* _ctx) { /* (x : double, y : double, z : double) -> double */ 
  return fma(x,y,z);
}
 
// lifted
// specialized std/core/foreach to parameters [action]

kk_unit_t kk_std_num_double__lift3879_sum(kk_ref_t comp, kk_ref_t total, kk_std_core__list xs0, kk_context_t* _ctx) { /* forall<h> (comp : local-var<h,double>, total : local-var<h,double>, xs0 : list<double>) -> (local<h>) () */ 
  kk__tailcall: ;
  if (kk_std_core__is_Nil(xs0)) {
    kk_ref_drop(comp, _ctx);
    kk_ref_drop(total, _ctx);
    kk_Unit; return kk_Unit;
  }
  struct kk_std_core_Cons* _con4788 = kk_std_core__as_Cons(xs0);
  kk_box_t _box_x4141 = _con4788->head;
  kk_std_core__list xx = _con4788->tail;
  double x0 = kk_double_unbox(_box_x4141, NULL);
  if (kk_likely(kk_std_core__list_is_unique(xs0))) {
    kk_box_drop(_box_x4141, _ctx);
    kk_Unit;
    kk_Unit;
    kk_std_core__list_free(xs0);
  }
  else {
    kk_std_core__list_dup(xx);
    kk_Unit;
    kk_std_core__list_decref(xs0, _ctx);
    kk_Unit;
  }
  double t;
  double _x4790;
  kk_box_t _x4791;
  kk_ref_t _x4792 = kk_ref_dup(total); /*local-var<666,double>*/
  _x4791 = (kk_ref_get(_x4792,kk_context())); /*256*/
  _x4790 = kk_double_unbox(_x4791, _ctx); /*double*/
  t = (_x4790 + x0); /*double*/
  double c;
  bool _match_4762;
  double _x4793;
  double _x4794;
  kk_box_t _x4795;
  kk_ref_t _x4796 = kk_ref_dup(total); /*local-var<666,double>*/
  _x4795 = (kk_ref_get(_x4796,kk_context())); /*256*/
  _x4794 = kk_double_unbox(_x4795, _ctx); /*double*/
  _x4793 = kk_double_abs(_x4794); /*double*/
  double _x4797 = kk_double_abs(x0); /*double*/
  _match_4762 = (_x4793 >= _x4797); /*bool*/
  if (_match_4762) {
    double _x4798;
    double _x4799;
    kk_box_t _x4800;
    kk_ref_t _x4801 = kk_ref_dup(total); /*local-var<666,double>*/
    _x4800 = (kk_ref_get(_x4801,kk_context())); /*256*/
    _x4799 = kk_double_unbox(_x4800, _ctx); /*double*/
    _x4798 = (_x4799 - t); /*double*/
    c = (_x4798 + x0); /*double*/
  }
  else {
    double _x4802 = (x0 - t); /*double*/
    double _x4803;
    kk_box_t _x4804;
    kk_ref_t _x4805 = kk_ref_dup(total); /*local-var<666,double>*/
    _x4804 = (kk_ref_get(_x4805,kk_context())); /*256*/
    _x4803 = kk_double_unbox(_x4804, _ctx); /*double*/
    c = (_x4802 + _x4803); /*double*/
  }
  double _b_4154_4152;
  double _x4806;
  kk_box_t _x4807;
  kk_ref_t _x4808 = kk_ref_dup(comp); /*local-var<666,double>*/
  _x4807 = (kk_ref_get(_x4808,kk_context())); /*256*/
  _x4806 = kk_double_unbox(_x4807, _ctx); /*double*/
  _b_4154_4152 = (_x4806 + c); /*double*/
  kk_unit_t __ = kk_Unit;
  (kk_ref_set_borrow(comp,(kk_double_box(_b_4154_4152, _ctx)),kk_context()));
  kk_unit_t __0 = kk_Unit;
  (kk_ref_set_borrow(total,(kk_double_box(t, _ctx)),kk_context()));
  { // tailcall
    xs0 = xx;
    goto kk__tailcall;
  }
}
 
// Return the sum of a list of doubles.
// Uses [Kahan-Babu&scaron;kan-Neumaier summation](https://en.wikipedia.org/wiki/Kahan_summation_algorithm#Further_enhancements)
// to minimize rounding errors. This
// is more precise as Kahan summation and about as fast.
// `[1.0e3,1.0e97,1.0e3,-1.0e97].sum == 2000.0`
// A. Neumaier, _Rundungsfehleranalyse einiger Verfahren zur Summation endlicher Summen_.
// Math. Mechanik, 54:39--51, 1974.

double kk_std_num_double_sum(kk_std_core__list xs, kk_context_t* _ctx) { /* (xs : list<double>) -> double */ 
  kk_ref_t loc = kk_ref_alloc((kk_double_box(0.0, _ctx)),kk_context()); /*local-var<global,double>*/;
  kk_ref_t loc0 = kk_ref_alloc((kk_double_box(0.0, _ctx)),kk_context()); /*local-var<global,double>*/;
  kk_unit_t __00 = kk_Unit;
  kk_ref_t _x4809 = kk_ref_dup(loc0); /*local-var<global,double>*/
  kk_ref_t _x4810 = kk_ref_dup(loc); /*local-var<global,double>*/
  kk_std_num_double__lift3879_sum(_x4809, _x4810, xs, _ctx);
  double res0;
  double _x4811;
  kk_box_t _x4812;
  kk_ref_t _x4813 = kk_ref_dup(loc); /*local-var<global,double>*/
  _x4812 = (kk_ref_get(_x4813,kk_context())); /*256*/
  _x4811 = kk_double_unbox(_x4812, _ctx); /*double*/
  double _x4814;
  kk_box_t _x4815;
  kk_ref_t _x4816 = kk_ref_dup(loc0); /*local-var<global,double>*/
  _x4815 = (kk_ref_get(_x4816,kk_context())); /*256*/
  _x4814 = kk_double_unbox(_x4815, _ctx); /*double*/
  res0 = (_x4811 + _x4814); /*double*/
  double res;
  kk_box_t _x4817 = kk_std_core_hnd_prompt_local_var(loc0, kk_double_box(res0, _ctx), _ctx); /*9895*/
  res = kk_double_unbox(_x4817, _ctx); /*double*/
  kk_ref_t _b_4174_4172 = loc; /*local-var<global,double>*/;
  double _b_4175_4173 = res; /*double*/;
  kk_box_t _x4818 = kk_std_core_hnd_prompt_local_var(_b_4174_4172, kk_double_box(_b_4175_4173, _ctx), _ctx); /*9895*/
  return kk_double_unbox(_x4818, _ctx);
}
 
// Is this value equal to negative or positive infinity ?

bool kk_std_num_double_is_inf(double d, kk_context_t* _ctx) { /* (d : double) -> bool */ 
  return isinf(d);
}

double kk_std_num_double_make_nan(kk_context_t* _ctx) { /* () -> double */ 
  return (double)NAN;
}
 
// Return `nan` on failure

double kk_std_num_double_prim_parse_double(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> double */ 
  return kk_prim_parse_double(s,kk_context());
}
 
// decode a normalized double (i.e. not subnormal)

kk_std_core_types__tuple2_ kk_std_num_double_decode_normalized(double d, kk_std_core_types__optional e_adjust, kk_context_t* _ctx) { /* (d : double, e-adjust : optional<int>) -> (int, int) */ 
  kk_std_core_types__tuple2_ _match_4759 = kk_std_num_double_double_to_bits(d, _ctx); /*(int32, int32)*/;
  kk_box_t _box_x4176 = _match_4759.fst;
  kk_box_t _box_x4177 = _match_4759.snd;
  int32_t lo = kk_int32_unbox(_box_x4176, NULL);
  int32_t hi = kk_int32_unbox(_box_x4177, NULL);
  kk_std_core_types__tuple2__drop(_match_4759, _ctx);
  kk_Unit;
  kk_integer_t sign;
  bool _match_4760 = (hi)<0; /*bool*/;
  if (_match_4760) {
    sign = kk_integer_from_small(-1); /*int*/
  }
  else {
    sign = kk_integer_from_small(1); /*int*/
  }
  kk_integer_t exp;
  kk_integer_t _x4822;
  int32_t _x4823;
  int32_t _x4824 = ((int32_t)((uint32_t)hi >> (((int32_t)20)))); /*int32*/
  _x4823 = (_x4824 & (((int32_t)2047))); /*int32*/
  _x4822 = kk_integer_from_int(_x4823,kk_context()); /*int*/
  exp = kk_integer_sub(_x4822,(kk_integer_from_small(1043)),kk_context()); /*int*/
  kk_integer_t man;
  kk_integer_t _x4825;
  int32_t _x4826 = (hi & (((int32_t)1048575))); /*int32*/
  _x4825 = kk_integer_from_int(_x4826,kk_context()); /*int*/
  man = kk_integer_add(_x4825,(kk_integer_from_int(1048576, _ctx)),kk_context()); /*int*/
  kk_integer_t _b_4181_4179;
  kk_integer_t _x4827;
  kk_integer_t _x4828 = kk_integer_mul(man,(kk_integer_from_str("4294967296", _ctx)),kk_context()); /*int*/
  kk_integer_t _x4829 = kk_std_num_int32_uint(lo, _ctx); /*int*/
  _x4827 = kk_integer_add(_x4828,_x4829,kk_context()); /*int*/
  _b_4181_4179 = kk_integer_mul(sign,_x4827,kk_context()); /*int*/
  kk_integer_t _b_4182_4180;
  kk_integer_t _x4830 = kk_integer_sub(exp,(kk_integer_from_small(32)),kk_context()); /*int*/
  kk_integer_t _x4831;
  if (kk_std_core_types__is_Optional(e_adjust)) {
    kk_box_t _box_x4178 = e_adjust._cons.Optional.value;
    kk_integer_t _e_adjust_736 = kk_integer_unbox(_box_x4178);
    kk_integer_dup(_e_adjust_736);
    kk_std_core_types__optional_drop(e_adjust, _ctx);
    kk_Unit;
    _x4831 = _e_adjust_736; /*int*/
    goto _match4832;
  }
  _x4831 = kk_integer_from_small(0); /*int*/
  _match4832: ;
  _b_4182_4180 = kk_integer_add(_x4830,_x4831,kk_context()); /*int*/
  return kk_std_core_types__new_dash__lp__comma__rp_(kk_integer_box(_b_4181_4179), kk_integer_box(_b_4182_4180), _ctx);
}
 
// Decode a double `d` into a tuple `(m,e)` of a mantissa `m` and exponent `e`
// such that `m`&middot;2^`e`^ =  `d` exactly. The mantissa `m` is
// always either 0 or in the range [2^52^, 2^53^). See also `frexp`.

kk_std_core_types__tuple2_ kk_std_num_double_decode(double d, kk_context_t* _ctx) { /* (d : double) -> (int, int) */ 
  bool _match_4749 = (d == (0.0)); /*bool*/;
  if (_match_4749) {
    kk_integer_t _b_4197_4183 = kk_integer_from_small(0); /*int*/;
    kk_integer_t _b_4198_4184 = kk_integer_from_small(0); /*int*/;
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_integer_box(_b_4197_4183), kk_integer_box(_b_4198_4184), _ctx);
  }
  bool _match_4750 = (d != (0.0)); /*bool*/;
  if (_match_4750) {
    bool _match_4753;
    double _x4835 = kk_double_abs(d); /*double*/
    _match_4753 = (_x4835 < (2.2250738585072014e-308)); /*bool*/
    if (_match_4753) {
      double d1_3822 = (d * (1.8014398509481984e16)); /*double*/;
      kk_std_core_types__tuple2_ _match_4756 = kk_std_num_double_double_to_bits(d1_3822, _ctx); /*(int32, int32)*/;
      kk_box_t _box_x4185 = _match_4756.fst;
      kk_box_t _box_x4186 = _match_4756.snd;
      int32_t lo = kk_int32_unbox(_box_x4185, NULL);
      int32_t hi = kk_int32_unbox(_box_x4186, NULL);
      kk_std_core_types__tuple2__drop(_match_4756, _ctx);
      kk_Unit;
      kk_integer_t sign;
      bool _match_4757 = (hi)<0; /*bool*/;
      if (_match_4757) {
        sign = kk_integer_from_small(-1); /*int*/
      }
      else {
        sign = kk_integer_from_small(1); /*int*/
      }
      kk_integer_t exp;
      kk_integer_t _x4838;
      int32_t _x4839;
      int32_t _x4840 = ((int32_t)((uint32_t)hi >> (((int32_t)20)))); /*int32*/
      _x4839 = (_x4840 & (((int32_t)2047))); /*int32*/
      _x4838 = kk_integer_from_int(_x4839,kk_context()); /*int*/
      exp = kk_integer_sub(_x4838,(kk_integer_from_small(1043)),kk_context()); /*int*/
      kk_integer_t man;
      kk_integer_t _x4841;
      int32_t _x4842 = (hi & (((int32_t)1048575))); /*int32*/
      _x4841 = kk_integer_from_int(_x4842,kk_context()); /*int*/
      man = kk_integer_add(_x4841,(kk_integer_from_int(1048576, _ctx)),kk_context()); /*int*/
      kk_integer_t _b_4199_4187;
      kk_integer_t _x4843;
      kk_integer_t _x4844 = kk_integer_mul(man,(kk_integer_from_str("4294967296", _ctx)),kk_context()); /*int*/
      kk_integer_t _x4845 = kk_std_num_int32_uint(lo, _ctx); /*int*/
      _x4843 = kk_integer_add(_x4844,_x4845,kk_context()); /*int*/
      _b_4199_4187 = kk_integer_mul(sign,_x4843,kk_context()); /*int*/
      kk_integer_t _b_4200_4188;
      kk_integer_t _x4846 = kk_integer_sub(exp,(kk_integer_from_small(32)),kk_context()); /*int*/
      _b_4200_4188 = kk_integer_add(_x4846,(kk_integer_from_small(-54)),kk_context()); /*int*/
      return kk_std_core_types__new_dash__lp__comma__rp_(kk_integer_box(_b_4199_4187), kk_integer_box(_b_4200_4188), _ctx);
    }
    kk_std_core_types__tuple2_ _match_4754 = kk_std_num_double_double_to_bits(d, _ctx); /*(int32, int32)*/;
    kk_box_t _box_x4189 = _match_4754.fst;
    kk_box_t _box_x4190 = _match_4754.snd;
    int32_t lo0 = kk_int32_unbox(_box_x4189, NULL);
    int32_t hi0 = kk_int32_unbox(_box_x4190, NULL);
    kk_std_core_types__tuple2__drop(_match_4754, _ctx);
    kk_Unit;
    kk_integer_t sign0;
    bool _match_4755 = (hi0)<0; /*bool*/;
    if (_match_4755) {
      sign0 = kk_integer_from_small(-1); /*int*/
    }
    else {
      sign0 = kk_integer_from_small(1); /*int*/
    }
    kk_integer_t exp0;
    kk_integer_t _x4849;
    int32_t _x4850;
    int32_t _x4851 = ((int32_t)((uint32_t)hi0 >> (((int32_t)20)))); /*int32*/
    _x4850 = (_x4851 & (((int32_t)2047))); /*int32*/
    _x4849 = kk_integer_from_int(_x4850,kk_context()); /*int*/
    exp0 = kk_integer_sub(_x4849,(kk_integer_from_small(1043)),kk_context()); /*int*/
    kk_integer_t man0;
    kk_integer_t _x4852;
    int32_t _x4853 = (hi0 & (((int32_t)1048575))); /*int32*/
    _x4852 = kk_integer_from_int(_x4853,kk_context()); /*int*/
    man0 = kk_integer_add(_x4852,(kk_integer_from_int(1048576, _ctx)),kk_context()); /*int*/
    kk_integer_t _b_4201_4191;
    kk_integer_t _x4854;
    kk_integer_t _x4855 = kk_integer_mul(man0,(kk_integer_from_str("4294967296", _ctx)),kk_context()); /*int*/
    kk_integer_t _x4856 = kk_std_num_int32_uint(lo0, _ctx); /*int*/
    _x4854 = kk_integer_add(_x4855,_x4856,kk_context()); /*int*/
    _b_4201_4191 = kk_integer_mul(sign0,_x4854,kk_context()); /*int*/
    kk_integer_t _b_4202_4192;
    kk_integer_t _x4857 = kk_integer_sub(exp0,(kk_integer_from_small(32)),kk_context()); /*int*/
    _b_4202_4192 = kk_integer_add(_x4857,(kk_integer_from_small(0)),kk_context()); /*int*/
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_integer_box(_b_4201_4191), kk_integer_box(_b_4202_4192), _ctx);
  }
  kk_std_core_types__tuple2_ _match_4751 = kk_std_num_double_double_to_bits(d, _ctx); /*(int32, int32)*/;
  kk_box_t _box_x4193 = _match_4751.fst;
  kk_box_t _box_x4194 = _match_4751.snd;
  int32_t lo00 = kk_int32_unbox(_box_x4193, NULL);
  int32_t hi00 = kk_int32_unbox(_box_x4194, NULL);
  kk_std_core_types__tuple2__drop(_match_4751, _ctx);
  kk_Unit;
  kk_integer_t sign00;
  bool _match_4752 = (hi00)<0; /*bool*/;
  if (_match_4752) {
    sign00 = kk_integer_from_small(-1); /*int*/
  }
  else {
    sign00 = kk_integer_from_small(1); /*int*/
  }
  kk_integer_t exp00;
  kk_integer_t _x4860;
  int32_t _x4861;
  int32_t _x4862 = ((int32_t)((uint32_t)hi00 >> (((int32_t)20)))); /*int32*/
  _x4861 = (_x4862 & (((int32_t)2047))); /*int32*/
  _x4860 = kk_integer_from_int(_x4861,kk_context()); /*int*/
  exp00 = kk_integer_sub(_x4860,(kk_integer_from_small(1043)),kk_context()); /*int*/
  kk_integer_t man00;
  kk_integer_t _x4863;
  int32_t _x4864 = (hi00 & (((int32_t)1048575))); /*int32*/
  _x4863 = kk_integer_from_int(_x4864,kk_context()); /*int*/
  man00 = kk_integer_add(_x4863,(kk_integer_from_int(1048576, _ctx)),kk_context()); /*int*/
  kk_integer_t _b_4203_4195;
  kk_integer_t _x4865;
  kk_integer_t _x4866 = kk_integer_mul(man00,(kk_integer_from_str("4294967296", _ctx)),kk_context()); /*int*/
  kk_integer_t _x4867 = kk_std_num_int32_uint(lo00, _ctx); /*int*/
  _x4865 = kk_integer_add(_x4866,_x4867,kk_context()); /*int*/
  _b_4203_4195 = kk_integer_mul(sign00,_x4865,kk_context()); /*int*/
  kk_integer_t _b_4204_4196;
  kk_integer_t _x4868 = kk_integer_sub(exp00,(kk_integer_from_small(32)),kk_context()); /*int*/
  _b_4204_4196 = kk_integer_add(_x4868,(kk_integer_from_small(0)),kk_context()); /*int*/
  return kk_std_core_types__new_dash__lp__comma__rp_(kk_integer_box(_b_4203_4195), kk_integer_box(_b_4204_4196), _ctx);
}

double kk_std_num_double_rad2deg;

double kk_std_num_double_deg2rad;
 
// Calculate 2&middot;^`e`^ for an integer `e`.
// Uses efficient bit conversion for exponents between  -1022 and 1023 and
// otherwise falls back to the regular `exp2` function converting `e` to a double.

double kk_std_num_double_exp2_1(kk_integer_t e, kk_context_t* _ctx) { /* (e : int) -> double */ 
  bool _match_4741;
  kk_integer_t _borrowedArg_4747 = kk_integer_from_small(-1022); /*int*/;
  bool _borrowApp_4748 = kk_integer_gte_borrow(e,_borrowedArg_4747,kk_context()); /*bool*/;
  kk_integer_drop(_borrowedArg_4747, _ctx);
  _match_4741 = _borrowApp_4748; /*bool*/
  if (_match_4741) {
    bool _match_4743;
    kk_integer_t _borrowedArg_4745 = kk_integer_from_small(1023); /*int*/;
    bool _borrowApp_4746 = kk_integer_lte_borrow(e,_borrowedArg_4745,kk_context()); /*bool*/;
    kk_integer_drop(_borrowedArg_4745, _ctx);
    _match_4743 = _borrowApp_4746; /*bool*/
    if (_match_4743) {
      int32_t _x4870;
      int32_t _x4871;
      kk_integer_t _x4872 = kk_integer_add((kk_integer_from_small(1023)),e,kk_context()); /*int*/
      _x4871 = kk_std_core_int32(_x4872, _ctx); /*int32*/
      _x4870 = (_x4871 << (((int32_t)20))); /*int32*/
      return kk_std_num_double_double_from_bits(((int32_t)0), _x4870, _ctx);
    }
    double p_3826;
    double _borrowApp_4744 = kk_integer_as_double_borrow(e); /*double*/;
    kk_integer_drop(e, _ctx);
    p_3826 = _borrowApp_4744; /*double*/
    return pow((2.0),p_3826);
  }
  double p0_3827;
  double _borrowApp_4742 = kk_integer_as_double_borrow(e); /*double*/;
  kk_integer_drop(e, _ctx);
  p0_3827 = _borrowApp_4742; /*double*/
  return pow((2.0),p0_3827);
}

double kk_std_num_double_neginf;

double kk_std_num_double_posinf;
 
// 'Load exponent': returns `x`&middot;2^`e`^ for a `is-finite` `x` and
// otherwise `x` itself. See also `encode` which loads an integer mantissa.

double kk_std_num_double_ldexp(double x, kk_integer_t e, kk_context_t* _ctx) { /* (x : double, e : int) -> double */ 
  bool b_3828 = isfinite(x); /*bool*/;
  if (b_3828) {
    bool _match_4721;
    kk_integer_t _borrowedArg_4739 = kk_integer_from_small(-1022); /*int*/;
    bool _borrowApp_4740 = kk_integer_gte_borrow(e,_borrowedArg_4739,kk_context()); /*bool*/;
    kk_integer_drop(_borrowedArg_4739, _ctx);
    _match_4721 = _borrowApp_4740; /*bool*/
    if (_match_4721) {
      bool _match_4729;
      kk_integer_t _borrowedArg_4737 = kk_integer_from_small(1023); /*int*/;
      bool _borrowApp_4738 = kk_integer_lte_borrow(e,_borrowedArg_4737,kk_context()); /*bool*/;
      kk_integer_drop(_borrowedArg_4737, _ctx);
      _match_4729 = _borrowApp_4738; /*bool*/
      if (_match_4729) {
        double _x4874 = kk_std_num_double_exp2_1(e, _ctx); /*double*/
        return (x * _x4874);
      }
      bool _match_4730;
      kk_integer_t _borrowedArg_4735 = kk_integer_from_small(2046); /*int*/;
      bool _borrowApp_4736 = kk_integer_lte_borrow(e,_borrowedArg_4735,kk_context()); /*bool*/;
      kk_integer_drop(_borrowedArg_4735, _ctx);
      _match_4730 = _borrowApp_4736; /*bool*/
      if (_match_4730) {
        double x1_3831 = (x * (8.98846567431158e307)); /*double*/;
        kk_integer_t e1_3832 = kk_integer_sub(e,(kk_integer_from_small(1023)),kk_context()); /*int*/;
        double _x4875 = kk_std_num_double_exp2_1(e1_3832, _ctx); /*double*/
        return (x1_3831 * _x4875);
      }
      bool _match_4731;
      kk_integer_t _borrowedArg_4733 = kk_integer_from_int(3069, _ctx); /*int*/;
      bool _borrowApp_4734 = kk_integer_lte_borrow(e,_borrowedArg_4733,kk_context()); /*bool*/;
      kk_integer_drop(_borrowedArg_4733, _ctx);
      _match_4731 = _borrowApp_4734; /*bool*/
      if (_match_4731) {
        double x2_3833;
        double _x4876 = (x * (8.98846567431158e307)); /*double*/
        x2_3833 = (_x4876 * (8.98846567431158e307)); /*double*/
        kk_integer_t e2_3834 = kk_integer_sub(e,(kk_integer_from_small(2046)),kk_context()); /*int*/;
        double _x4877 = kk_std_num_double_exp2_1(e2_3834, _ctx); /*double*/
        return (x2_3833 * _x4877);
      }
      kk_integer_drop(e, _ctx);
      bool _match_4732 = (x < (0.0)); /*bool*/;
      if (_match_4732) {
        return kk_std_num_double_make_neginf(_ctx);
      }
      return kk_std_num_double_make_posinf(_ctx);
    }
    bool _match_4722;
    kk_integer_t _borrowedArg_4727 = kk_integer_from_small(-2044); /*int*/;
    bool _borrowApp_4728 = kk_integer_gte_borrow(e,_borrowedArg_4727,kk_context()); /*bool*/;
    kk_integer_drop(_borrowedArg_4727, _ctx);
    _match_4722 = _borrowApp_4728; /*bool*/
    if (_match_4722) {
      double x3_3835 = (x * (2.2250738585072014e-308)); /*double*/;
      kk_integer_t e3_3836 = kk_integer_add(e,(kk_integer_from_small(1022)),kk_context()); /*int*/;
      double _x4878 = kk_std_num_double_exp2_1(e3_3836, _ctx); /*double*/
      return (x3_3835 * _x4878);
    }
    bool _match_4723;
    kk_integer_t _borrowedArg_4725 = kk_integer_from_int(-3066, _ctx); /*int*/;
    bool _borrowApp_4726 = kk_integer_gte_borrow(e,_borrowedArg_4725,kk_context()); /*bool*/;
    kk_integer_drop(_borrowedArg_4725, _ctx);
    _match_4723 = _borrowApp_4726; /*bool*/
    if (_match_4723) {
      double x4_3837;
      double _x4879 = (x * (2.2250738585072014e-308)); /*double*/
      x4_3837 = (_x4879 * (2.2250738585072014e-308)); /*double*/
      kk_integer_t e4_3838 = kk_integer_add(e,(kk_integer_from_small(2044)),kk_context()); /*int*/;
      double _x4880 = kk_std_num_double_exp2_1(e4_3838, _ctx); /*double*/
      return (x4_3837 * _x4880);
    }
    kk_integer_drop(e, _ctx);
    bool _match_4724 = (x < (0.0)); /*bool*/;
    if (_match_4724) {
      return -0.0;
    }
    return 0.0;
  }
  kk_integer_drop(e, _ctx);
  return x;
}
 
// 'Fraction/exponent': return the normalized fraction `f` and exponent `exp`
// for a number `x` such that `x == f`&middot;2^`exp`^.
// The absolute value of the fraction `f` is always in the range [0.5, 1.0), or
// one of `0.0`, `-0.0`, `neginf`, `posinf`, or `nan`.
// See also `decode` which  decodes to an integer mantissa.

kk_std_core_types__tuple2_ kk_std_num_double_frexp(double x, kk_context_t* _ctx) { /* (x : double) -> (double, int) */ 
  bool b_3840 = isfinite(x); /*bool*/;
  if (b_3840) {
    bool _match_4713 = (x == (0.0)); /*bool*/;
    if (_match_4713) {
      bool _match_4716;
      double _x4884 = ((1.0) / x); /*double*/
      _match_4716 = (isinf(_x4884) && signbit(_x4884)); /*bool*/
      if (_match_4716) {
        double _b_4217_4205 = x; /*double*/;
        kk_integer_t _b_4218_4206 = kk_integer_from_small(0); /*int*/;
        return kk_std_core_types__new_dash__lp__comma__rp_(kk_double_box(_b_4217_4205, _ctx), kk_integer_box(_b_4218_4206), _ctx);
      }
      kk_std_core_types__tuple2_ _match_4717 = kk_std_num_double_decode(x, _ctx); /*(int, int)*/;
      kk_box_t _box_x4207 = _match_4717.fst;
      kk_box_t _box_x4208 = _match_4717.snd;
      kk_integer_t m = kk_integer_unbox(_box_x4207);
      kk_integer_t e = kk_integer_unbox(_box_x4208);
      kk_integer_dup(e);
      kk_integer_dup(m);
      kk_std_core_types__tuple2__drop(_match_4717, _ctx);
      kk_Unit;
      double _b_4219_4209;
      double _x4887;
      double _borrowApp_4718 = kk_integer_as_double_borrow(m); /*double*/;
      kk_integer_drop(m, _ctx);
      _x4887 = _borrowApp_4718; /*double*/
      _b_4219_4209 = (_x4887 * (1.1102230246251565e-16)); /*double*/
      kk_integer_t _b_4220_4210 = kk_integer_add(e,(kk_integer_from_small(53)),kk_context()); /*int*/;
      return kk_std_core_types__new_dash__lp__comma__rp_(kk_double_box(_b_4219_4209, _ctx), kk_integer_box(_b_4220_4210), _ctx);
    }
    kk_std_core_types__tuple2_ _match_4714 = kk_std_num_double_decode(x, _ctx); /*(int, int)*/;
    kk_box_t _box_x4211 = _match_4714.fst;
    kk_box_t _box_x4212 = _match_4714.snd;
    kk_integer_t m0 = kk_integer_unbox(_box_x4211);
    kk_integer_t e0 = kk_integer_unbox(_box_x4212);
    kk_integer_dup(e0);
    kk_integer_dup(m0);
    kk_std_core_types__tuple2__drop(_match_4714, _ctx);
    kk_Unit;
    double _b_4221_4213;
    double _x4890;
    double _borrowApp_4715 = kk_integer_as_double_borrow(m0); /*double*/;
    kk_integer_drop(m0, _ctx);
    _x4890 = _borrowApp_4715; /*double*/
    _b_4221_4213 = (_x4890 * (1.1102230246251565e-16)); /*double*/
    kk_integer_t _b_4222_4214 = kk_integer_add(e0,(kk_integer_from_small(53)),kk_context()); /*int*/;
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_double_box(_b_4221_4213, _ctx), kk_integer_box(_b_4222_4214), _ctx);
  }
  double _b_4223_4215 = x; /*double*/;
  kk_integer_t _b_4224_4216 = kk_integer_from_small(0); /*int*/;
  return kk_std_core_types__new_dash__lp__comma__rp_(kk_double_box(_b_4223_4215, _ctx), kk_integer_box(_b_4224_4216), _ctx);
}
 
// The hypotenuse of `x` and `y`: `sqrt(x*x + y*y)`.
// Prevents overflow for large numbers.

double kk_std_num_double_hypot(double x, double y, kk_context_t* _ctx) { /* (x : double, y : double) -> double */ 
  double xx = kk_double_abs(x); /*double*/;
  double yy = kk_double_abs(y); /*double*/;
  double lo;
  bool _match_4712 = (xx <= yy); /*bool*/;
  if (_match_4712) {
    lo = xx; /*double*/
  }
  else {
    lo = yy; /*double*/
  }
  double hi;
  bool _match_4711 = (xx >= yy); /*bool*/;
  if (_match_4711) {
    hi = xx; /*double*/
  }
  else {
    hi = yy; /*double*/
  }
  bool _match_4710 = (hi == (0.0)); /*bool*/;
  if (_match_4710) {
    return 0.0;
  }
  double z = (lo / hi); /*double*/;
  double _x4891;
  double _x4892;
  double _x4893 = (z * z); /*double*/
  _x4892 = ((1.0) + _x4893); /*double*/
  _x4891 = sqrt(_x4892); /*double*/
  return (hi * _x4891);
}
 
// The square root of the sum of the squares of three doubles.
// Prevents overflow for large numbers.

double kk_std_num_double_hypot_1(double x, double y, double z, kk_context_t* _ctx) { /* (x : double, y : double, z : double) -> double */ 
  double xx = kk_double_abs(x); /*double*/;
  double yy = kk_double_abs(y); /*double*/;
  double zz = kk_double_abs(z); /*double*/;
  double x0_3846;
  bool _match_4709 = (xx >= yy); /*bool*/;
  if (_match_4709) {
    x0_3846 = xx; /*double*/
  }
  else {
    x0_3846 = yy; /*double*/
  }
  double hi;
  bool _match_4708 = (x0_3846 >= zz); /*bool*/;
  if (_match_4708) {
    hi = x0_3846; /*double*/
  }
  else {
    hi = zz; /*double*/
  }
  bool _match_4707 = (hi == (0.0)); /*bool*/;
  if (_match_4707) {
    return 0.0;
  }
  double _x4894;
  double _x4895;
  double _x4896;
  double _x4897;
  double x2_3850 = (xx / hi); /*double*/;
  _x4897 = (x2_3850 * x2_3850); /*double*/
  double _x4898;
  double x3_3851 = (yy / hi); /*double*/;
  _x4898 = (x3_3851 * x3_3851); /*double*/
  _x4896 = (_x4897 + _x4898); /*double*/
  double _x4899;
  double x4_3852 = (zz / hi); /*double*/;
  _x4899 = (x4_3852 * x4_3852); /*double*/
  _x4895 = (_x4896 + _x4899); /*double*/
  _x4894 = sqrt(_x4895); /*double*/
  return (hi * _x4894);
}
 
// lifted
// specialized std/core/foldl to parameters [f]

double kk_std_num_double__lift3880_hypot_2(kk_std_core__list xs1, double z, kk_context_t* _ctx) { /* (xs1 : list<double>, z : double) -> double */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs1)) {
    struct kk_std_core_Cons* _con4900 = kk_std_core__as_Cons(xs1);
    kk_box_t _box_x4225 = _con4900->head;
    kk_std_core__list xx = _con4900->tail;
    double x0 = kk_double_unbox(_box_x4225, NULL);
    if (kk_likely(kk_std_core__list_is_unique(xs1))) {
      kk_box_drop(_box_x4225, _ctx);
      kk_Unit;
      kk_Unit;
      kk_std_core__list_free(xs1);
    }
    else {
      kk_std_core__list_dup(xx);
      kk_Unit;
      kk_std_core__list_decref(xs1, _ctx);
      kk_Unit;
    }
    { // tailcall
      double _x4902;
      double x0_3818 = kk_double_abs(x0); /*double*/;
      bool _match_4706 = (x0_3818 >= z); /*bool*/;
      if (_match_4706) {
        _x4902 = x0_3818; /*double*/
      }
      else {
        _x4902 = z; /*double*/
      }
      xs1 = xx;
      z = _x4902;
      goto kk__tailcall;
    }
  }
  return z;
}
 
// lifted
// specialized std/core/map.5 to parameters [f]

kk_std_core__list kk_std_num_double__ctail_lift3881_hypot_2(double hi, kk_std_core__list xs2, kk_std_core_types__ctail _acc, kk_context_t* _ctx) { /* (hi : double, xs2 : list<double>, ctail<list<double>>) -> list<double> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs2)) {
    struct kk_std_core_Cons* _con4903 = kk_std_core__as_Cons(xs2);
    kk_box_t _box_x4226 = _con4903->head;
    kk_std_core__list xx0 = _con4903->tail;
    double x1 = kk_double_unbox(_box_x4226, NULL);
    kk_reuse_t _ru_4770 = kk_reuse_null; /*reuse*/;
    if (kk_likely(kk_std_core__list_is_unique(xs2))) {
      kk_box_drop(_box_x4226, _ctx);
      kk_Unit;
      kk_Unit;
      _ru_4770 = (kk_std_core__list_reuse(xs2));
    }
    else {
      kk_std_core__list_dup(xx0);
      kk_Unit;
      kk_std_core__list_decref(xs2, _ctx);
      kk_Unit;
    }
    double x0_3853 = (x1 / hi); /*double*/;
    double _ctail_3892 = (x0_3853 * x0_3853); /*double*/;
    kk_std_core__list _ctail_3893 = kk_std_core__list_hole(); /*list<double>*/;
    kk_std_core__list _ctail_3894 = kk_std_core__new_Cons(_ru_4770, kk_double_box(_ctail_3892, _ctx), _ctail_3893, _ctx); /*list<double>*/;
    { // tailcall
      kk_std_core_types__ctail _x4905;
      kk_box_t* field_3964 = (kk_box_t*)((&kk_std_core__as_Cons(_ctail_3894)->tail)); /*cfield<list<double>>*/;
      if (kk_std_core_types__is_CTail(_acc)) {
        kk_box_t _box_x4237 = _acc._cons.CTail._field1;
        kk_box_t* last = _acc._cons.CTail._field2;
        kk_std_core__list head = kk_std_core__list_unbox(_box_x4237, NULL);
        kk_std_core__list_dup(head);
        kk_std_core_types__ctail_drop(_acc, _ctx);
        kk_Unit;
        kk_unit_t __ = kk_Unit;
        *(last) = kk_std_core__list_box(_ctail_3894, _ctx);
        kk_std_core__list _b_4251_4242 = head; /*list<double>*/;
        kk_box_t* _b_4252_4243 = field_3964; /*cfield<list<double>>*/;
        _x4905 = kk_std_core_types__new_CTail(kk_std_core__list_box(_b_4251_4242, _ctx), _b_4252_4243, _ctx); /*ctail<58>*/
        goto _match4906;
      }
      kk_std_core__list _b_4253_4244 = _ctail_3894; /*list<double>*/;
      kk_box_t* _b_4254_4245 = field_3964; /*cfield<list<double>>*/;
      _x4905 = kk_std_core_types__new_CTail(kk_std_core__list_box(_b_4253_4244, _ctx), _b_4254_4245, _ctx); /*ctail<58>*/
      _match4906: ;
      xs2 = xx0;
      _acc = _x4905;
      goto kk__tailcall;
    }
  }
  if (kk_std_core_types__is_CTail(_acc)) {
    kk_box_t _box_x4246 = _acc._cons.CTail._field1;
    kk_box_t* last0 = _acc._cons.CTail._field2;
    kk_std_core__list head0 = kk_std_core__list_unbox(_box_x4246, NULL);
    kk_std_core__list_dup(head0);
    kk_std_core_types__ctail_drop(_acc, _ctx);
    kk_Unit;
    kk_unit_t __0 = kk_Unit;
    *(last0) = kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx);
    return head0;
  }
  return kk_std_core__new_Nil(_ctx);
}
 
// lifted
// specialized std/core/map.5 to parameters [f]

kk_std_core__list kk_std_num_double__lift3881_hypot_2(double hi0, kk_std_core__list xs20, kk_context_t* _ctx) { /* (hi : double, xs2 : list<double>) -> list<double> */ 
  return kk_std_num_double__ctail_lift3881_hypot_2(hi0, xs20, kk_std_core_types__new_CTailNil(_ctx), _ctx);
}
 
// The square root of the sum of squares of a list of doubles.
// Prevents overflow for large numbers and uses Kahan-Babu&scaron;kan-Neumaier summation
// for precision.

double kk_std_num_double_hypot_2(kk_std_core__list xs, kk_context_t* _ctx) { /* (xs : list<double>) -> double */ 
  double hi;
  kk_std_core__list _x4909 = kk_std_core__list_dup(xs); /*list<double>*/
  hi = kk_std_num_double__lift3880_hypot_2(_x4909, 0.0, _ctx); /*double*/
  bool _match_4705 = (hi == (0.0)); /*bool*/;
  if (_match_4705) {
    kk_std_core__list_drop(xs, _ctx);
    return 0.0;
  }
  double _x4910;
  double _x4911;
  kk_std_core__list xs0_4115 = kk_std_num_double__lift3881_hypot_2(hi, xs, _ctx); /*list<double>*/;
  kk_ref_t loc = kk_ref_alloc((kk_double_box(0.0, _ctx)),kk_context()); /*local-var<global,double>*/;
  kk_ref_t loc0 = kk_ref_alloc((kk_double_box(0.0, _ctx)),kk_context()); /*local-var<global,double>*/;
  kk_unit_t __00 = kk_Unit;
  kk_ref_t _x4912 = kk_ref_dup(loc0); /*local-var<global,double>*/
  kk_ref_t _x4913 = kk_ref_dup(loc); /*local-var<global,double>*/
  kk_std_num_double__lift3879_sum(_x4912, _x4913, xs0_4115, _ctx);
  double res0;
  double _x4914;
  kk_box_t _x4915;
  kk_ref_t _x4916 = kk_ref_dup(loc); /*local-var<global,double>*/
  _x4915 = (kk_ref_get(_x4916,kk_context())); /*256*/
  _x4914 = kk_double_unbox(_x4915, _ctx); /*double*/
  double _x4917;
  kk_box_t _x4918;
  kk_ref_t _x4919 = kk_ref_dup(loc0); /*local-var<global,double>*/
  _x4918 = (kk_ref_get(_x4919,kk_context())); /*256*/
  _x4917 = kk_double_unbox(_x4918, _ctx); /*double*/
  res0 = (_x4914 + _x4917); /*double*/
  double res;
  kk_box_t _x4920 = kk_std_core_hnd_prompt_local_var(loc0, kk_double_box(res0, _ctx), _ctx); /*9895*/
  res = kk_double_unbox(_x4920, _ctx); /*double*/
  kk_ref_t _b_4269_4267 = loc; /*local-var<global,double>*/;
  double _b_4270_4268 = res; /*double*/;
  kk_box_t _x4921 = kk_std_core_hnd_prompt_local_var(_b_4269_4267, kk_double_box(_b_4270_4268, _ctx), _ctx); /*9895*/
  _x4911 = kk_double_unbox(_x4921, _ctx); /*double*/
  _x4910 = sqrt(_x4911); /*double*/
  return (hi * _x4910);
}
 
// Returns `log(exp(x) + exp(y))`.
// Avoids overlow/underflow errors.

double kk_std_num_double_logaddexp(double x, double y, kk_context_t* _ctx) { /* (x : double, y : double) -> double */ 
  bool _match_4703 = (x == y); /*bool*/;
  if (_match_4703) {
    return (x + (0.6931471805599453));
  }
  double z = (x - y); /*double*/;
  bool _match_4704 = (z > (0.0)); /*bool*/;
  if (_match_4704) {
    double _x4925;
    double _x4926;
    double _x4927 = (-z); /*double*/
    _x4926 = exp(_x4927); /*double*/
    _x4925 = log1p(_x4926); /*double*/
    return (x + _x4925);
  }
  double _x4928;
  double _x4929 = exp(z); /*double*/
  _x4928 = log1p(_x4929); /*double*/
  return (y + _x4928);
}
 
// Returns `log2( exp2(x) + exp2(y) )`.
// Avoids overlow/underflow errors.

double kk_std_num_double_logaddexp2(double x, double y, kk_context_t* _ctx) { /* (x : double, y : double) -> double */ 
  bool _match_4701 = (x == y); /*bool*/;
  if (_match_4701) {
    return (x + (1.0));
  }
  double z = (x - y); /*double*/;
  bool _match_4702 = (z > (0.0)); /*bool*/;
  if (_match_4702) {
    double _x4930;
    double p_3855 = (-z); /*double*/;
    double x0_3854 = pow((2.0),p_3855); /*double*/;
    double _x4931 = log1p(x0_3854); /*double*/
    _x4930 = ((1.4426950408889634) * _x4931); /*double*/
    return (x + _x4930);
  }
  double _x4932;
  double x1_3856 = pow((2.0),z); /*double*/;
  double _x4933 = log1p(x1_3856); /*double*/
  _x4932 = ((1.4426950408889634) * _x4933); /*double*/
  return (y + _x4932);
}

double kk_std_num_double_nan;
 
// Return if two doubles are nearly equal with respect to some `epsilon` (=`8*dbl-epsilon`).
// The epsilon is the nearest difference for numbers around 1.0. The routine automatically
// scales the epsilon for larger and smaller numbers, and for subnormal numbers.

bool kk_std_num_double_nearly_eq(double x, double y, kk_std_core_types__optional epsilon, kk_context_t* _ctx) { /* (x : double, y : double, epsilon : optional<double>) -> bool */ 
  double _epsilon_2587;
  if (kk_std_core_types__is_Optional(epsilon)) {
    kk_box_t _box_x4271 = epsilon._cons.Optional.value;
    double _epsilon_2588 = kk_double_unbox(_box_x4271, NULL);
    kk_std_core_types__optional_drop(epsilon, _ctx);
    kk_Unit;
    _epsilon_2587 = _epsilon_2588; /*double*/
    goto _match4934;
  }
  _epsilon_2587 = ((8.0) * (2.220446049250313e-16)); /*double*/
  _match4934: ;
  bool _match_4696 = (x == y); /*bool*/;
  if (_match_4696) {
    return true;
  }
  double diff;
  double _x4936 = (x - y); /*double*/
  diff = kk_double_abs(_x4936); /*double*/
  bool _match_4697 = (x == (0.0)); /*bool*/;
  if (_match_4697) {
    double _x4937 = ((2.0) * diff); /*double*/
    double _x4938 = (_epsilon_2587 * (2.2250738585072014e-308)); /*double*/
    return (_x4937 < _x4938);
  }
  bool _match_4698 = (y == (0.0)); /*bool*/;
  if (_match_4698) {
    double _x4939 = ((2.0) * diff); /*double*/
    double _x4940 = (_epsilon_2587 * (2.2250738585072014e-308)); /*double*/
    return (_x4939 < _x4940);
  }
  bool _match_4699 = (diff < (2.2250738585072014e-308)); /*bool*/;
  if (_match_4699) {
    double _x4941 = ((2.0) * diff); /*double*/
    double _x4942 = (_epsilon_2587 * (2.2250738585072014e-308)); /*double*/
    return (_x4941 < _x4942);
  }
  double sum0;
  double _x4943 = kk_double_abs(x); /*double*/
  double _x4944 = kk_double_abs(y); /*double*/
  sum0 = (_x4943 + _x4944); /*double*/
  double _x4945;
  double _x4946 = ((2.0) * diff); /*double*/
  double _x4947;
  bool _match_4700 = (sum0 > (1.7976931348623157e308)); /*bool*/;
  if (_match_4700) {
    _x4947 = 1.7976931348623157e308; /*double*/
  }
  else {
    _x4947 = sum0; /*double*/
  }
  _x4945 = (_x4946 / _x4947); /*double*/
  return (_x4945 < _epsilon_2587);
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_double__mlift3933_pdecdouble_fun4949__t {
  struct kk_function_s _base;
};
static double kk_std_num_double__mlift3933_pdecdouble_fun4949(kk_function_t _fself, kk_string_t _x14948, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3933_pdecdouble_fun4949(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3933_pdecdouble_fun4949, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double__mlift3933_pdecdouble_fun4949(kk_function_t _fself, kk_string_t _x14948, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_num_double_prim_parse_double(_x14948, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3933_pdecdouble_fun4951__t {
  struct kk_function_s _base;
  kk_function_t _b_4275_4272;
};
static kk_box_t kk_std_num_double__mlift3933_pdecdouble_fun4951(kk_function_t _fself, kk_box_t _b_4274, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3933_pdecdouble_fun4951(kk_function_t _b_4275_4272, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3933_pdecdouble_fun4951__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3933_pdecdouble_fun4951__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3933_pdecdouble_fun4951, kk_context());
  _self->_b_4275_4272 = _b_4275_4272;
  return &_self->_base;
}

static kk_box_t kk_std_num_double__mlift3933_pdecdouble_fun4951(kk_function_t _fself, kk_box_t _b_4274, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3933_pdecdouble_fun4951__t* _self = kk_function_as(struct kk_std_num_double__mlift3933_pdecdouble_fun4951__t*, _fself);
  kk_function_t _b_4275_4272 = _self->_b_4275_4272; /* (s : string) -> double */
  kk_drop_match(_self, {kk_function_dup(_b_4275_4272);}, {}, _ctx)
  double _x4952;
  kk_string_t _x4953 = kk_string_unbox(_b_4274); /*string*/
  _x4952 = kk_function_call(double, (kk_function_t, kk_string_t, kk_context_t*), _b_4275_4272, (_b_4275_4272, _x4953, _ctx)); /*double*/
  return kk_double_box(_x4952, _ctx);
}

double kk_std_num_double__mlift3933_pdecdouble(kk_std_core__sslice cur, kk_integer_t _c_3904, kk_context_t* _ctx) { /* (cur : sslice, int) -> double */ 
  kk_integer_drop(_c_3904, _ctx);
  kk_string_t _x1 = kk_std_core_string_3(cur, _ctx); /*string*/;
  kk_function_t _b_4275_4272 = kk_std_num_double__new_mlift3933_pdecdouble_fun4949(_ctx); /*(s : string) -> double*/;
  kk_string_t _b_4276_4273 = _x1; /*string*/;
  kk_box_t _x4950 = kk_std_core_hnd__open_none1(kk_std_num_double__new_mlift3933_pdecdouble_fun4951(_b_4275_4272, _ctx), kk_string_box(_b_4276_4273), _ctx); /*3289*/
  return kk_double_unbox(_x4950, _ctx);
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_double__mlift3934_pdecdouble_fun4957__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3934_pdecdouble_fun4957(kk_function_t _fself, kk_box_t _b_4278, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3934_pdecdouble_fun4957(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3934_pdecdouble_fun4957, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double__mlift3934_pdecdouble_fun4957(kk_function_t _fself, kk_box_t _b_4278, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_integer_t _x4958;
  kk_char_t _x4959 = kk_char_unbox(_b_4278, _ctx); /*char*/
  _x4958 = kk_std_num_double__mlift3932_pdecdouble(_x4959, _ctx); /*int*/
  return kk_integer_box(_x4958);
}


// lift anonymous function
struct kk_std_num_double__mlift3934_pdecdouble_fun4960__t {
  struct kk_function_s _base;
  kk_std_core__sslice cur;
};
static double kk_std_num_double__mlift3934_pdecdouble_fun4960(kk_function_t _fself, kk_integer_t _c_3904, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3934_pdecdouble_fun4960(kk_std_core__sslice cur, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3934_pdecdouble_fun4960__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3934_pdecdouble_fun4960__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3934_pdecdouble_fun4960, kk_context());
  _self->cur = cur;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_num_double__mlift3934_pdecdouble_fun4962__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3934_pdecdouble_fun4962(kk_function_t _fself, kk_box_t _b_4282, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3934_pdecdouble_fun4962(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3934_pdecdouble_fun4962, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double__mlift3934_pdecdouble_fun4962(kk_function_t _fself, kk_box_t _b_4282, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x4963;
  kk_string_t _x4964 = kk_string_unbox(_b_4282); /*string*/
  _x4963 = kk_std_num_double_prim_parse_double(_x4964, _ctx); /*double*/
  return kk_double_box(_x4963, _ctx);
}
static double kk_std_num_double__mlift3934_pdecdouble_fun4960(kk_function_t _fself, kk_integer_t _c_3904, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3934_pdecdouble_fun4960__t* _self = kk_function_as(struct kk_std_num_double__mlift3934_pdecdouble_fun4960__t*, _fself);
  kk_std_core__sslice cur = _self->cur; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(cur);}, {}, _ctx)
  kk_integer_drop(_c_3904, _ctx);
  kk_string_t _x1 = kk_std_core_string_3(cur, _ctx); /*string*/;
  kk_box_t _x4961 = kk_std_core_hnd__open_none1(kk_std_num_double__new_mlift3934_pdecdouble_fun4962(_ctx), kk_string_box(_x1), _ctx); /*3289*/
  return kk_double_unbox(_x4961, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3934_pdecdouble_fun4966__t {
  struct kk_function_s _base;
  kk_function_t _b_4287_4285;
};
static kk_box_t kk_std_num_double__mlift3934_pdecdouble_fun4966(kk_function_t _fself, kk_box_t _b_4286, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3934_pdecdouble_fun4966(kk_function_t _b_4287_4285, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3934_pdecdouble_fun4966__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3934_pdecdouble_fun4966__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3934_pdecdouble_fun4966, kk_context());
  _self->_b_4287_4285 = _b_4287_4285;
  return &_self->_base;
}

static kk_box_t kk_std_num_double__mlift3934_pdecdouble_fun4966(kk_function_t _fself, kk_box_t _b_4286, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3934_pdecdouble_fun4966__t* _self = kk_function_as(struct kk_std_num_double__mlift3934_pdecdouble_fun4966__t*, _fself);
  kk_function_t _b_4287_4285 = _self->_b_4287_4285; /* (int) -> double */
  kk_drop_match(_self, {kk_function_dup(_b_4287_4285);}, {}, _ctx)
  double _x4967;
  kk_integer_t _x4968 = kk_integer_unbox(_b_4286); /*int*/
  _x4967 = kk_function_call(double, (kk_function_t, kk_integer_t, kk_context_t*), _b_4287_4285, (_b_4287_4285, _x4968, _ctx)); /*double*/
  return kk_double_box(_x4967, _ctx);
}

double kk_std_num_double__mlift3934_pdecdouble(kk_std_core__sslice cur, bool _y_3901, kk_context_t* _ctx) { /* (cur : sslice, bool) -> std/text/parse/parse double */ 
  kk_integer_t x_3967;
  if (_y_3901) {
    kk_char_t x0_3969;
    kk_string_t _x4954;
    kk_define_string_literal(, _s4955, 2, "eE")
    _x4954 = kk_string_dup(_s4955); /*string*/
    x0_3969 = kk_std_text_parse_one_of(_x4954, _ctx); /*char*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x4956 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3934_pdecdouble_fun4957(_ctx), _ctx); /*3858*/
      x_3967 = kk_integer_unbox(_x4956); /*int*/
    }
    else {
      x_3967 = kk_std_num_double__mlift3932_pdecdouble(x0_3969, _ctx); /*int*/
    }
  }
  else {
    x_3967 = kk_integer_from_small(0); /*int*/
  }
  kk_function_t next_3968 = kk_std_num_double__new_mlift3934_pdecdouble_fun4960(cur, _ctx); /*(int) -> double*/;
  if (kk_yielding(kk_context())) {
    kk_integer_drop(x_3967, _ctx);
    kk_function_t _b_4287_4285 = next_3968; /*(int) -> double*/;
    kk_box_t _x4965 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3934_pdecdouble_fun4966(_b_4287_4285, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x4965, _ctx);
  }
  return kk_function_call(double, (kk_function_t, kk_integer_t, kk_context_t*), next_3968, (next_3968, x_3967, _ctx));
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_double__mlift3936_pdecdouble_fun4975__t {
  struct kk_function_s _base;
  kk_std_core__sslice cur;
};
static double kk_std_num_double__mlift3936_pdecdouble_fun4975(kk_function_t _fself, bool _y_3901, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3936_pdecdouble_fun4975(kk_std_core__sslice cur, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3936_pdecdouble_fun4975__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3936_pdecdouble_fun4975__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3936_pdecdouble_fun4975, kk_context());
  _self->cur = cur;
  return &_self->_base;
}

static double kk_std_num_double__mlift3936_pdecdouble_fun4975(kk_function_t _fself, bool _y_3901, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3936_pdecdouble_fun4975__t* _self = kk_function_as(struct kk_std_num_double__mlift3936_pdecdouble_fun4975__t*, _fself);
  kk_std_core__sslice cur = _self->cur; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(cur);}, {}, _ctx)
  return kk_std_num_double__mlift3934_pdecdouble(cur, _y_3901, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3936_pdecdouble_fun4977__t {
  struct kk_function_s _base;
  kk_function_t _b_4296_4294;
};
static kk_box_t kk_std_num_double__mlift3936_pdecdouble_fun4977(kk_function_t _fself, kk_box_t _b_4295, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3936_pdecdouble_fun4977(kk_function_t _b_4296_4294, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3936_pdecdouble_fun4977__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3936_pdecdouble_fun4977__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3936_pdecdouble_fun4977, kk_context());
  _self->_b_4296_4294 = _b_4296_4294;
  return &_self->_base;
}

static kk_box_t kk_std_num_double__mlift3936_pdecdouble_fun4977(kk_function_t _fself, kk_box_t _b_4295, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3936_pdecdouble_fun4977__t* _self = kk_function_as(struct kk_std_num_double__mlift3936_pdecdouble_fun4977__t*, _fself);
  kk_function_t _b_4296_4294 = _self->_b_4296_4294; /* (bool) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4296_4294);}, {}, _ctx)
  double _x4978;
  bool _x4979 = kk_bool_unbox(_b_4295); /*bool*/
  _x4978 = kk_function_call(double, (kk_function_t, bool, kk_context_t*), _b_4296_4294, (_b_4296_4294, _x4979, _ctx)); /*double*/
  return kk_double_box(_x4978, _ctx);
}

double kk_std_num_double__mlift3936_pdecdouble(kk_std_core__sslice cur, kk_string_t _c_3900, kk_context_t* _ctx) { /* (cur : sslice, string) -> double */ 
  kk_string_t frac;
  kk_string_t _x4969;
  kk_define_string_literal(, _s4970, 1, "0")
  _x4969 = kk_string_dup(_s4970); /*string*/
  frac = kk_std_core_trim_right_1(_c_3900, _x4969, _ctx); /*string*/
  kk_string_drop(frac, _ctx);
  kk_std_core_hnd__ev ev_3975;
  kk_ssize_t _x4971 = ((kk_ssize_t)0); /*ssize_t*/
  ev_3975 = kk_evv_at(_x4971,kk_context()); /*std/core/hnd/ev<std/text/parse/.hnd-parse>*/
  bool x_3973;
  kk_box_t _x4972;
  struct kk_std_core_hnd_Ev* _con4973 = kk_std_core_hnd__as_Ev(ev_3975);
  kk_std_core_hnd__marker m0 = _con4973->marker;
  kk_box_t _box_x4288 = _con4973->hnd;
  kk_std_text_parse__hnd_parse h = kk_std_text_parse__hnd_parse_unbox(_box_x4288, NULL);
  kk_std_text_parse__hnd_parse_dup(h);
  kk_std_core_hnd__clause0 _match_4692;
  kk_std_core_hnd__clause0 _borrowApp_4693 = kk_std_text_parse__select_pick(h, _ctx); /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,417,418>*/;
  kk_std_text_parse__hnd_parse_drop(h, _ctx);
  _match_4692 = _borrowApp_4693; /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,417,418>*/
  kk_function_t _fun_unbox_x4291 = _match_4692.clause;
  _x4972 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_context_t*), _fun_unbox_x4291, (_fun_unbox_x4291, m0, ev_3975, _ctx)); /*37*/
  x_3973 = kk_bool_unbox(_x4972); /*bool*/
  if (kk_yielding(kk_context())) {
    kk_function_t _b_4296_4294 = kk_std_num_double__new_mlift3936_pdecdouble_fun4975(cur, _ctx); /*(bool) -> std/text/parse/parse double*/;
    kk_box_t _x4976 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3936_pdecdouble_fun4977(_b_4296_4294, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x4976, _ctx);
  }
  return kk_std_num_double__mlift3934_pdecdouble(cur, x_3973, _ctx);
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_double__mlift3937_pdecdouble_fun4981__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3937_pdecdouble_fun4981(kk_function_t _fself, kk_box_t _b_4298, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3937_pdecdouble_fun4981(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3937_pdecdouble_fun4981, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double__mlift3937_pdecdouble_fun4981(kk_function_t _fself, kk_box_t _b_4298, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x4982;
  kk_char_t _x4983 = kk_char_unbox(_b_4298, _ctx); /*char*/
  _x4982 = kk_std_num_double__mlift3935_pdecdouble(_x4983, _ctx); /*string*/
  return kk_string_box(_x4982);
}


// lift anonymous function
struct kk_std_num_double__mlift3937_pdecdouble_fun4985__t {
  struct kk_function_s _base;
  kk_std_core__sslice cur;
};
static double kk_std_num_double__mlift3937_pdecdouble_fun4985(kk_function_t _fself, kk_string_t _c_3900, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3937_pdecdouble_fun4985(kk_std_core__sslice cur, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3937_pdecdouble_fun4985__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3937_pdecdouble_fun4985__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3937_pdecdouble_fun4985, kk_context());
  _self->cur = cur;
  return &_self->_base;
}

static double kk_std_num_double__mlift3937_pdecdouble_fun4985(kk_function_t _fself, kk_string_t _c_3900, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3937_pdecdouble_fun4985__t* _self = kk_function_as(struct kk_std_num_double__mlift3937_pdecdouble_fun4985__t*, _fself);
  kk_std_core__sslice cur = _self->cur; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(cur);}, {}, _ctx)
  return kk_std_num_double__mlift3936_pdecdouble(cur, _c_3900, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3937_pdecdouble_fun4987__t {
  struct kk_function_s _base;
  kk_function_t _b_4302_4300;
};
static kk_box_t kk_std_num_double__mlift3937_pdecdouble_fun4987(kk_function_t _fself, kk_box_t _b_4301, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3937_pdecdouble_fun4987(kk_function_t _b_4302_4300, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3937_pdecdouble_fun4987__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3937_pdecdouble_fun4987__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3937_pdecdouble_fun4987, kk_context());
  _self->_b_4302_4300 = _b_4302_4300;
  return &_self->_base;
}

static kk_box_t kk_std_num_double__mlift3937_pdecdouble_fun4987(kk_function_t _fself, kk_box_t _b_4301, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3937_pdecdouble_fun4987__t* _self = kk_function_as(struct kk_std_num_double__mlift3937_pdecdouble_fun4987__t*, _fself);
  kk_function_t _b_4302_4300 = _self->_b_4302_4300; /* (string) -> double */
  kk_drop_match(_self, {kk_function_dup(_b_4302_4300);}, {}, _ctx)
  double _x4988;
  kk_string_t _x4989 = kk_string_unbox(_b_4301); /*string*/
  _x4988 = kk_function_call(double, (kk_function_t, kk_string_t, kk_context_t*), _b_4302_4300, (_b_4302_4300, _x4989, _ctx)); /*double*/
  return kk_double_box(_x4988, _ctx);
}

double kk_std_num_double__mlift3937_pdecdouble(kk_std_core__sslice cur, bool _y_3897, kk_context_t* _ctx) { /* (cur : sslice, bool) -> std/text/parse/parse double */ 
  kk_string_t x_3977;
  if (_y_3897) {
    kk_char_t x0_3979 = kk_std_text_parse_char('.', _ctx); /*char*/;
    if (kk_yielding(kk_context())) {
      kk_box_t _x4980 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3937_pdecdouble_fun4981(_ctx), _ctx); /*3858*/
      x_3977 = kk_string_unbox(_x4980); /*string*/
    }
    else {
      x_3977 = kk_std_num_double__mlift3935_pdecdouble(x0_3979, _ctx); /*string*/
    }
  }
  else {
    x_3977 = kk_string_empty(); /*string*/
  }
  if (kk_yielding(kk_context())) {
    kk_string_drop(x_3977, _ctx);
    kk_function_t _b_4302_4300 = kk_std_num_double__new_mlift3937_pdecdouble_fun4985(cur, _ctx); /*(string) -> double*/;
    kk_box_t _x4986 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3937_pdecdouble_fun4987(_b_4302_4300, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x4986, _ctx);
  }
  return kk_std_num_double__mlift3936_pdecdouble(cur, x_3977, _ctx);
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_double__mlift3938_pdecdouble_fun4994__t {
  struct kk_function_s _base;
  kk_std_core__sslice cur;
};
static double kk_std_num_double__mlift3938_pdecdouble_fun4994(kk_function_t _fself, bool _y_3897, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3938_pdecdouble_fun4994(kk_std_core__sslice cur, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3938_pdecdouble_fun4994__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3938_pdecdouble_fun4994__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3938_pdecdouble_fun4994, kk_context());
  _self->cur = cur;
  return &_self->_base;
}

static double kk_std_num_double__mlift3938_pdecdouble_fun4994(kk_function_t _fself, bool _y_3897, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3938_pdecdouble_fun4994__t* _self = kk_function_as(struct kk_std_num_double__mlift3938_pdecdouble_fun4994__t*, _fself);
  kk_std_core__sslice cur = _self->cur; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(cur);}, {}, _ctx)
  return kk_std_num_double__mlift3937_pdecdouble(cur, _y_3897, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3938_pdecdouble_fun4996__t {
  struct kk_function_s _base;
  kk_function_t _b_4311_4309;
};
static kk_box_t kk_std_num_double__mlift3938_pdecdouble_fun4996(kk_function_t _fself, kk_box_t _b_4310, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3938_pdecdouble_fun4996(kk_function_t _b_4311_4309, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3938_pdecdouble_fun4996__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3938_pdecdouble_fun4996__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3938_pdecdouble_fun4996, kk_context());
  _self->_b_4311_4309 = _b_4311_4309;
  return &_self->_base;
}

static kk_box_t kk_std_num_double__mlift3938_pdecdouble_fun4996(kk_function_t _fself, kk_box_t _b_4310, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3938_pdecdouble_fun4996__t* _self = kk_function_as(struct kk_std_num_double__mlift3938_pdecdouble_fun4996__t*, _fself);
  kk_function_t _b_4311_4309 = _self->_b_4311_4309; /* (bool) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4311_4309);}, {}, _ctx)
  double _x4997;
  bool _x4998 = kk_bool_unbox(_b_4310); /*bool*/
  _x4997 = kk_function_call(double, (kk_function_t, bool, kk_context_t*), _b_4311_4309, (_b_4311_4309, _x4998, _ctx)); /*double*/
  return kk_double_box(_x4997, _ctx);
}

double kk_std_num_double__mlift3938_pdecdouble(kk_std_core__sslice cur, kk_string_t man, kk_context_t* _ctx) { /* (cur : sslice, man : string) -> std/text/parse/parse double */ 
  kk_string_drop(man, _ctx);
  kk_std_core_hnd__ev ev_3983;
  kk_ssize_t _x4990 = ((kk_ssize_t)0); /*ssize_t*/
  ev_3983 = kk_evv_at(_x4990,kk_context()); /*std/core/hnd/ev<std/text/parse/.hnd-parse>*/
  bool x_3981;
  kk_box_t _x4991;
  struct kk_std_core_hnd_Ev* _con4992 = kk_std_core_hnd__as_Ev(ev_3983);
  kk_std_core_hnd__marker m0 = _con4992->marker;
  kk_box_t _box_x4303 = _con4992->hnd;
  kk_std_text_parse__hnd_parse h = kk_std_text_parse__hnd_parse_unbox(_box_x4303, NULL);
  kk_std_text_parse__hnd_parse_dup(h);
  kk_std_core_hnd__clause0 _match_4687;
  kk_std_core_hnd__clause0 _borrowApp_4688 = kk_std_text_parse__select_pick(h, _ctx); /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,417,418>*/;
  kk_std_text_parse__hnd_parse_drop(h, _ctx);
  _match_4687 = _borrowApp_4688; /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,417,418>*/
  kk_function_t _fun_unbox_x4306 = _match_4687.clause;
  _x4991 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_context_t*), _fun_unbox_x4306, (_fun_unbox_x4306, m0, ev_3983, _ctx)); /*37*/
  x_3981 = kk_bool_unbox(_x4991); /*bool*/
  if (kk_yielding(kk_context())) {
    kk_function_t _b_4311_4309 = kk_std_num_double__new_mlift3938_pdecdouble_fun4994(cur, _ctx); /*(bool) -> std/text/parse/parse double*/;
    kk_box_t _x4995 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3938_pdecdouble_fun4996(_b_4311_4309, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x4995, _ctx);
  }
  return kk_std_num_double__mlift3937_pdecdouble(cur, x_3981, _ctx);
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_double__mlift3939_pdecdouble_fun4999__t {
  struct kk_function_s _base;
  kk_std_core__sslice cur;
};
static double kk_std_num_double__mlift3939_pdecdouble_fun4999(kk_function_t _fself, kk_string_t man, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3939_pdecdouble_fun4999(kk_std_core__sslice cur, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3939_pdecdouble_fun4999__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3939_pdecdouble_fun4999__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3939_pdecdouble_fun4999, kk_context());
  _self->cur = cur;
  return &_self->_base;
}

static double kk_std_num_double__mlift3939_pdecdouble_fun4999(kk_function_t _fself, kk_string_t man, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3939_pdecdouble_fun4999__t* _self = kk_function_as(struct kk_std_num_double__mlift3939_pdecdouble_fun4999__t*, _fself);
  kk_std_core__sslice cur = _self->cur; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(cur);}, {}, _ctx)
  return kk_std_num_double__mlift3938_pdecdouble(cur, man, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3939_pdecdouble_fun5001__t {
  struct kk_function_s _base;
  kk_function_t _b_4314_4312;
};
static kk_box_t kk_std_num_double__mlift3939_pdecdouble_fun5001(kk_function_t _fself, kk_box_t _b_4313, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3939_pdecdouble_fun5001(kk_function_t _b_4314_4312, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3939_pdecdouble_fun5001__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3939_pdecdouble_fun5001__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3939_pdecdouble_fun5001, kk_context());
  _self->_b_4314_4312 = _b_4314_4312;
  return &_self->_base;
}

static kk_box_t kk_std_num_double__mlift3939_pdecdouble_fun5001(kk_function_t _fself, kk_box_t _b_4313, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3939_pdecdouble_fun5001__t* _self = kk_function_as(struct kk_std_num_double__mlift3939_pdecdouble_fun5001__t*, _fself);
  kk_function_t _b_4314_4312 = _self->_b_4314_4312; /* (man : string) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4314_4312);}, {}, _ctx)
  double _x5002;
  kk_string_t _x5003 = kk_string_unbox(_b_4313); /*string*/
  _x5002 = kk_function_call(double, (kk_function_t, kk_string_t, kk_context_t*), _b_4314_4312, (_b_4314_4312, _x5003, _ctx)); /*double*/
  return kk_double_box(_x5002, _ctx);
}

double kk_std_num_double__mlift3939_pdecdouble(kk_std_core__sslice cur, kk_context_t* _ctx) { /* (cur : sslice) -> std/text/parse/parse double */ 
  kk_string_t x_3985 = kk_std_text_parse_digits(_ctx); /*string*/;
  if (kk_yielding(kk_context())) {
    kk_string_drop(x_3985, _ctx);
    kk_function_t _b_4314_4312 = kk_std_num_double__new_mlift3939_pdecdouble_fun4999(cur, _ctx); /*(man : string) -> std/text/parse/parse double*/;
    kk_box_t _x5000 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3939_pdecdouble_fun5001(_b_4314_4312, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x5000, _ctx);
  }
  return kk_std_num_double__mlift3938_pdecdouble(cur, x_3985, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun5009__t {
  struct kk_function_s _base;
};
static double kk_std_num_double_pdecdouble_fun5009(kk_function_t _fself, kk_std_core__sslice _x15008, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun5009(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdecdouble_fun5009, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double_pdecdouble_fun5009(kk_function_t _fself, kk_std_core__sslice _x15008, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_num_double__mlift3939_pdecdouble(_x15008, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun5011__t {
  struct kk_function_s _base;
  kk_function_t _b_4357_4321;
};
static kk_box_t kk_std_num_double_pdecdouble_fun5011(kk_function_t _fself, kk_box_t _b_4322, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun5011(kk_function_t _b_4357_4321, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun5011__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdecdouble_fun5011__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdecdouble_fun5011, kk_context());
  _self->_b_4357_4321 = _b_4357_4321;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pdecdouble_fun5011(kk_function_t _fself, kk_box_t _b_4322, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun5011__t* _self = kk_function_as(struct kk_std_num_double_pdecdouble_fun5011__t*, _fself);
  kk_function_t _b_4357_4321 = _self->_b_4357_4321; /* (cur : sslice) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4357_4321);}, {}, _ctx)
  double _x5012;
  kk_std_core__sslice _x5013 = kk_std_core__sslice_unbox(_b_4322, _ctx); /*sslice*/
  _x5012 = kk_function_call(double, (kk_function_t, kk_std_core__sslice, kk_context_t*), _b_4357_4321, (_b_4357_4321, _x5013, _ctx)); /*double*/
  return kk_double_box(_x5012, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun5014__t {
  struct kk_function_s _base;
  kk_std_core__sslice x_3987;
};
static double kk_std_num_double_pdecdouble_fun5014(kk_function_t _fself, kk_string_t man, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun5014(kk_std_core__sslice x_3987, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun5014__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdecdouble_fun5014__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdecdouble_fun5014, kk_context());
  _self->x_3987 = x_3987;
  return &_self->_base;
}

static double kk_std_num_double_pdecdouble_fun5014(kk_function_t _fself, kk_string_t man, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun5014__t* _self = kk_function_as(struct kk_std_num_double_pdecdouble_fun5014__t*, _fself);
  kk_std_core__sslice x_3987 = _self->x_3987; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(x_3987);}, {}, _ctx)
  return kk_std_num_double__mlift3938_pdecdouble(x_3987, man, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun5016__t {
  struct kk_function_s _base;
  kk_function_t _b_4358_4323;
};
static kk_box_t kk_std_num_double_pdecdouble_fun5016(kk_function_t _fself, kk_box_t _b_4324, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun5016(kk_function_t _b_4358_4323, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun5016__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdecdouble_fun5016__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdecdouble_fun5016, kk_context());
  _self->_b_4358_4323 = _b_4358_4323;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pdecdouble_fun5016(kk_function_t _fself, kk_box_t _b_4324, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun5016__t* _self = kk_function_as(struct kk_std_num_double_pdecdouble_fun5016__t*, _fself);
  kk_function_t _b_4358_4323 = _self->_b_4358_4323; /* (man : string) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4358_4323);}, {}, _ctx)
  double _x5017;
  kk_string_t _x5018 = kk_string_unbox(_b_4324); /*string*/
  _x5017 = kk_function_call(double, (kk_function_t, kk_string_t, kk_context_t*), _b_4358_4323, (_b_4358_4323, _x5018, _ctx)); /*double*/
  return kk_double_box(_x5017, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun5023__t {
  struct kk_function_s _base;
  kk_std_core__sslice x_3987;
};
static double kk_std_num_double_pdecdouble_fun5023(kk_function_t _fself, bool _y_3897, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun5023(kk_std_core__sslice x_3987, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun5023__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdecdouble_fun5023__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdecdouble_fun5023, kk_context());
  _self->x_3987 = x_3987;
  return &_self->_base;
}

static double kk_std_num_double_pdecdouble_fun5023(kk_function_t _fself, bool _y_3897, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun5023__t* _self = kk_function_as(struct kk_std_num_double_pdecdouble_fun5023__t*, _fself);
  kk_std_core__sslice x_3987 = _self->x_3987; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(x_3987);}, {}, _ctx)
  return kk_std_num_double__mlift3937_pdecdouble(x_3987, _y_3897, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun5025__t {
  struct kk_function_s _base;
  kk_function_t _b_4359_4331;
};
static kk_box_t kk_std_num_double_pdecdouble_fun5025(kk_function_t _fself, kk_box_t _b_4332, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun5025(kk_function_t _b_4359_4331, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun5025__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdecdouble_fun5025__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdecdouble_fun5025, kk_context());
  _self->_b_4359_4331 = _b_4359_4331;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pdecdouble_fun5025(kk_function_t _fself, kk_box_t _b_4332, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun5025__t* _self = kk_function_as(struct kk_std_num_double_pdecdouble_fun5025__t*, _fself);
  kk_function_t _b_4359_4331 = _self->_b_4359_4331; /* (bool) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4359_4331);}, {}, _ctx)
  double _x5026;
  bool _x5027 = kk_bool_unbox(_b_4332); /*bool*/
  _x5026 = kk_function_call(double, (kk_function_t, bool, kk_context_t*), _b_4359_4331, (_b_4359_4331, _x5027, _ctx)); /*double*/
  return kk_double_box(_x5026, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun5029__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_pdecdouble_fun5029(kk_function_t _fself, kk_box_t _b_4334, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun5029(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdecdouble_fun5029, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double_pdecdouble_fun5029(kk_function_t _fself, kk_box_t _b_4334, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x5030;
  kk_char_t _x5031 = kk_char_unbox(_b_4334, _ctx); /*char*/
  _x5030 = kk_std_num_double__mlift3935_pdecdouble(_x5031, _ctx); /*string*/
  return kk_string_box(_x5030);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun5033__t {
  struct kk_function_s _base;
  kk_std_core__sslice x_3987;
};
static double kk_std_num_double_pdecdouble_fun5033(kk_function_t _fself, kk_string_t _c_3900, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun5033(kk_std_core__sslice x_3987, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun5033__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdecdouble_fun5033__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdecdouble_fun5033, kk_context());
  _self->x_3987 = x_3987;
  return &_self->_base;
}

static double kk_std_num_double_pdecdouble_fun5033(kk_function_t _fself, kk_string_t _c_3900, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun5033__t* _self = kk_function_as(struct kk_std_num_double_pdecdouble_fun5033__t*, _fself);
  kk_std_core__sslice x_3987 = _self->x_3987; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(x_3987);}, {}, _ctx)
  return kk_std_num_double__mlift3936_pdecdouble(x_3987, _c_3900, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun5035__t {
  struct kk_function_s _base;
  kk_function_t _b_4360_4336;
};
static kk_box_t kk_std_num_double_pdecdouble_fun5035(kk_function_t _fself, kk_box_t _b_4337, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun5035(kk_function_t _b_4360_4336, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun5035__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdecdouble_fun5035__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdecdouble_fun5035, kk_context());
  _self->_b_4360_4336 = _b_4360_4336;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pdecdouble_fun5035(kk_function_t _fself, kk_box_t _b_4337, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun5035__t* _self = kk_function_as(struct kk_std_num_double_pdecdouble_fun5035__t*, _fself);
  kk_function_t _b_4360_4336 = _self->_b_4360_4336; /* (string) -> double */
  kk_drop_match(_self, {kk_function_dup(_b_4360_4336);}, {}, _ctx)
  double _x5036;
  kk_string_t _x5037 = kk_string_unbox(_b_4337); /*string*/
  _x5036 = kk_function_call(double, (kk_function_t, kk_string_t, kk_context_t*), _b_4360_4336, (_b_4360_4336, _x5037, _ctx)); /*double*/
  return kk_double_box(_x5036, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun5044__t {
  struct kk_function_s _base;
  kk_std_core__sslice x_3987;
};
static double kk_std_num_double_pdecdouble_fun5044(kk_function_t _fself, bool _y_3901, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun5044(kk_std_core__sslice x_3987, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun5044__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdecdouble_fun5044__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdecdouble_fun5044, kk_context());
  _self->x_3987 = x_3987;
  return &_self->_base;
}

static double kk_std_num_double_pdecdouble_fun5044(kk_function_t _fself, bool _y_3901, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun5044__t* _self = kk_function_as(struct kk_std_num_double_pdecdouble_fun5044__t*, _fself);
  kk_std_core__sslice x_3987 = _self->x_3987; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(x_3987);}, {}, _ctx)
  return kk_std_num_double__mlift3934_pdecdouble(x_3987, _y_3901, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun5046__t {
  struct kk_function_s _base;
  kk_function_t _b_4361_4344;
};
static kk_box_t kk_std_num_double_pdecdouble_fun5046(kk_function_t _fself, kk_box_t _b_4345, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun5046(kk_function_t _b_4361_4344, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun5046__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdecdouble_fun5046__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdecdouble_fun5046, kk_context());
  _self->_b_4361_4344 = _b_4361_4344;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pdecdouble_fun5046(kk_function_t _fself, kk_box_t _b_4345, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun5046__t* _self = kk_function_as(struct kk_std_num_double_pdecdouble_fun5046__t*, _fself);
  kk_function_t _b_4361_4344 = _self->_b_4361_4344; /* (bool) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4361_4344);}, {}, _ctx)
  double _x5047;
  bool _x5048 = kk_bool_unbox(_b_4345); /*bool*/
  _x5047 = kk_function_call(double, (kk_function_t, bool, kk_context_t*), _b_4361_4344, (_b_4361_4344, _x5048, _ctx)); /*double*/
  return kk_double_box(_x5047, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun5052__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_pdecdouble_fun5052(kk_function_t _fself, kk_box_t _b_4347, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun5052(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdecdouble_fun5052, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double_pdecdouble_fun5052(kk_function_t _fself, kk_box_t _b_4347, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_integer_t _x5053;
  kk_char_t _x5054 = kk_char_unbox(_b_4347, _ctx); /*char*/
  _x5053 = kk_std_num_double__mlift3932_pdecdouble(_x5054, _ctx); /*int*/
  return kk_integer_box(_x5053);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun5055__t {
  struct kk_function_s _base;
  kk_std_core__sslice x_3987;
};
static double kk_std_num_double_pdecdouble_fun5055(kk_function_t _fself, kk_integer_t _c_3904, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun5055(kk_std_core__sslice x_3987, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun5055__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdecdouble_fun5055__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdecdouble_fun5055, kk_context());
  _self->x_3987 = x_3987;
  return &_self->_base;
}



// lift anonymous function
struct kk_std_num_double_pdecdouble_fun5057__t {
  struct kk_function_s _base;
};
static double kk_std_num_double_pdecdouble_fun5057(kk_function_t _fself, kk_string_t _x15056, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun5057(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdecdouble_fun5057, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double_pdecdouble_fun5057(kk_function_t _fself, kk_string_t _x15056, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_num_double_prim_parse_double(_x15056, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun5059__t {
  struct kk_function_s _base;
  kk_function_t _b_4363_4349;
};
static kk_box_t kk_std_num_double_pdecdouble_fun5059(kk_function_t _fself, kk_box_t _b_4351, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun5059(kk_function_t _b_4363_4349, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun5059__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdecdouble_fun5059__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdecdouble_fun5059, kk_context());
  _self->_b_4363_4349 = _b_4363_4349;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pdecdouble_fun5059(kk_function_t _fself, kk_box_t _b_4351, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun5059__t* _self = kk_function_as(struct kk_std_num_double_pdecdouble_fun5059__t*, _fself);
  kk_function_t _b_4363_4349 = _self->_b_4363_4349; /* (s : string) -> double */
  kk_drop_match(_self, {kk_function_dup(_b_4363_4349);}, {}, _ctx)
  double _x5060;
  kk_string_t _x5061 = kk_string_unbox(_b_4351); /*string*/
  _x5060 = kk_function_call(double, (kk_function_t, kk_string_t, kk_context_t*), _b_4363_4349, (_b_4363_4349, _x5061, _ctx)); /*double*/
  return kk_double_box(_x5060, _ctx);
}
static double kk_std_num_double_pdecdouble_fun5055(kk_function_t _fself, kk_integer_t _c_3904, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun5055__t* _self = kk_function_as(struct kk_std_num_double_pdecdouble_fun5055__t*, _fself);
  kk_std_core__sslice x_3987 = _self->x_3987; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(x_3987);}, {}, _ctx)
  kk_integer_drop(_c_3904, _ctx);
  kk_string_t _x1 = kk_std_core_string_3(x_3987, _ctx); /*string*/;
  kk_function_t _b_4363_4349 = kk_std_num_double_new_pdecdouble_fun5057(_ctx); /*(s : string) -> double*/;
  kk_string_t _b_4364_4350 = _x1; /*string*/;
  kk_box_t _x5058 = kk_std_core_hnd__open_none1(kk_std_num_double_new_pdecdouble_fun5059(_b_4363_4349, _ctx), kk_string_box(_b_4364_4350), _ctx); /*3289*/
  return kk_double_unbox(_x5058, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun5063__t {
  struct kk_function_s _base;
  kk_function_t _b_4362_4352;
};
static kk_box_t kk_std_num_double_pdecdouble_fun5063(kk_function_t _fself, kk_box_t _b_4353, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun5063(kk_function_t _b_4362_4352, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun5063__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdecdouble_fun5063__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdecdouble_fun5063, kk_context());
  _self->_b_4362_4352 = _b_4362_4352;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pdecdouble_fun5063(kk_function_t _fself, kk_box_t _b_4353, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun5063__t* _self = kk_function_as(struct kk_std_num_double_pdecdouble_fun5063__t*, _fself);
  kk_function_t _b_4362_4352 = _self->_b_4362_4352; /* (int) -> double */
  kk_drop_match(_self, {kk_function_dup(_b_4362_4352);}, {}, _ctx)
  double _x5064;
  kk_integer_t _x5065 = kk_integer_unbox(_b_4353); /*int*/
  _x5064 = kk_function_call(double, (kk_function_t, kk_integer_t, kk_context_t*), _b_4362_4352, (_b_4362_4352, _x5065, _ctx)); /*double*/
  return kk_double_box(_x5064, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun5067__t {
  struct kk_function_s _base;
};
static double kk_std_num_double_pdecdouble_fun5067(kk_function_t _fself, kk_string_t _x15066, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun5067(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdecdouble_fun5067, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double_pdecdouble_fun5067(kk_function_t _fself, kk_string_t _x15066, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_num_double_prim_parse_double(_x15066, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdecdouble_fun5069__t {
  struct kk_function_s _base;
  kk_function_t _b_4365_4354;
};
static kk_box_t kk_std_num_double_pdecdouble_fun5069(kk_function_t _fself, kk_box_t _b_4356, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdecdouble_fun5069(kk_function_t _b_4365_4354, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun5069__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdecdouble_fun5069__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdecdouble_fun5069, kk_context());
  _self->_b_4365_4354 = _b_4365_4354;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pdecdouble_fun5069(kk_function_t _fself, kk_box_t _b_4356, kk_context_t* _ctx) {
  struct kk_std_num_double_pdecdouble_fun5069__t* _self = kk_function_as(struct kk_std_num_double_pdecdouble_fun5069__t*, _fself);
  kk_function_t _b_4365_4354 = _self->_b_4365_4354; /* (s : string) -> double */
  kk_drop_match(_self, {kk_function_dup(_b_4365_4354);}, {}, _ctx)
  double _x5070;
  kk_string_t _x5071 = kk_string_unbox(_b_4356); /*string*/
  _x5070 = kk_function_call(double, (kk_function_t, kk_string_t, kk_context_t*), _b_4365_4354, (_b_4365_4354, _x5071, _ctx)); /*double*/
  return kk_double_box(_x5070, _ctx);
}

double kk_std_num_double_pdecdouble(kk_context_t* _ctx) { /* () -> std/text/parse/parse double */ 
  kk_std_core_hnd__ev ev_3990;
  kk_ssize_t _x5004 = ((kk_ssize_t)0); /*ssize_t*/
  ev_3990 = kk_evv_at(_x5004,kk_context()); /*std/core/hnd/ev<std/text/parse/.hnd-parse>*/
  kk_std_core__sslice x_3987;
  kk_box_t _x5005;
  struct kk_std_core_hnd_Ev* _con5006 = kk_std_core_hnd__as_Ev(ev_3990);
  kk_std_core_hnd__marker m0 = _con5006->marker;
  kk_box_t _box_x4315 = _con5006->hnd;
  kk_std_text_parse__hnd_parse h = kk_std_text_parse__hnd_parse_unbox(_box_x4315, NULL);
  kk_std_text_parse__hnd_parse_dup(h);
  kk_std_core_hnd__clause0 _match_4683;
  kk_std_core_hnd__clause0 _borrowApp_4684 = kk_std_text_parse__select_current_input(h, _ctx); /*std/core/hnd/clause0<sslice,std/text/parse/.hnd-parse,378,379>*/;
  kk_std_text_parse__hnd_parse_drop(h, _ctx);
  _match_4683 = _borrowApp_4684; /*std/core/hnd/clause0<sslice,std/text/parse/.hnd-parse,378,379>*/
  kk_function_t _fun_unbox_x4318 = _match_4683.clause;
  _x5005 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_context_t*), _fun_unbox_x4318, (_fun_unbox_x4318, m0, ev_3990, _ctx)); /*37*/
  x_3987 = kk_std_core__sslice_unbox(_x5005, _ctx); /*sslice*/
  if (kk_yielding(kk_context())) {
    kk_std_core__sslice_drop(x_3987, _ctx);
    kk_function_t _b_4357_4321 = kk_std_num_double_new_pdecdouble_fun5009(_ctx); /*(cur : sslice) -> std/text/parse/parse double*/;
    kk_box_t _x5010 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_pdecdouble_fun5011(_b_4357_4321, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x5010, _ctx);
  }
  kk_string_t x0_3992 = kk_std_text_parse_digits(_ctx); /*string*/;
  kk_string_drop(x0_3992, _ctx);
  if (kk_yielding(kk_context())) {
    kk_function_t _b_4358_4323 = kk_std_num_double_new_pdecdouble_fun5014(x_3987, _ctx); /*(man : string) -> std/text/parse/parse double*/;
    kk_box_t _x5015 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_pdecdouble_fun5016(_b_4358_4323, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x5015, _ctx);
  }
  kk_std_core_hnd__ev ev0_3998;
  kk_ssize_t _x5019 = ((kk_ssize_t)0); /*ssize_t*/
  ev0_3998 = kk_evv_at(_x5019,kk_context()); /*std/core/hnd/ev<std/text/parse/.hnd-parse>*/
  bool x1_3995;
  kk_box_t _x5020;
  struct kk_std_core_hnd_Ev* _con5021 = kk_std_core_hnd__as_Ev(ev0_3998);
  kk_std_core_hnd__marker m00 = _con5021->marker;
  kk_box_t _box_x4325 = _con5021->hnd;
  kk_std_text_parse__hnd_parse h0 = kk_std_text_parse__hnd_parse_unbox(_box_x4325, NULL);
  kk_std_text_parse__hnd_parse_dup(h0);
  kk_std_core_hnd__clause0 _match_4681;
  kk_std_core_hnd__clause0 _borrowApp_4682 = kk_std_text_parse__select_pick(h0, _ctx); /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,417,418>*/;
  kk_std_text_parse__hnd_parse_drop(h0, _ctx);
  _match_4681 = _borrowApp_4682; /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,417,418>*/
  kk_function_t _fun_unbox_x4328 = _match_4681.clause;
  _x5020 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_context_t*), _fun_unbox_x4328, (_fun_unbox_x4328, m00, ev0_3998, _ctx)); /*37*/
  x1_3995 = kk_bool_unbox(_x5020); /*bool*/
  if (kk_yielding(kk_context())) {
    kk_function_t _b_4359_4331 = kk_std_num_double_new_pdecdouble_fun5023(x_3987, _ctx); /*(bool) -> std/text/parse/parse double*/;
    kk_box_t _x5024 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_pdecdouble_fun5025(_b_4359_4331, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x5024, _ctx);
  }
  kk_string_t x2_4000;
  if (x1_3995) {
    kk_char_t x3_4003 = kk_std_text_parse_char('.', _ctx); /*char*/;
    if (kk_yielding(kk_context())) {
      kk_box_t _x5028 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_pdecdouble_fun5029(_ctx), _ctx); /*3858*/
      x2_4000 = kk_string_unbox(_x5028); /*string*/
    }
    else {
      x2_4000 = kk_std_num_double__mlift3935_pdecdouble(x3_4003, _ctx); /*string*/
    }
  }
  else {
    x2_4000 = kk_string_empty(); /*string*/
  }
  if (kk_yielding(kk_context())) {
    kk_string_drop(x2_4000, _ctx);
    kk_function_t _b_4360_4336 = kk_std_num_double_new_pdecdouble_fun5033(x_3987, _ctx); /*(string) -> double*/;
    kk_box_t _x5034 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_pdecdouble_fun5035(_b_4360_4336, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x5034, _ctx);
  }
  kk_string_t frac;
  kk_string_t _x5038;
  kk_define_string_literal(, _s5039, 1, "0")
  _x5038 = kk_string_dup(_s5039); /*string*/
  frac = kk_std_core_trim_right_1(x2_4000, _x5038, _ctx); /*string*/
  kk_string_drop(frac, _ctx);
  kk_std_core_hnd__ev ev1_4008;
  kk_ssize_t _x5040 = ((kk_ssize_t)0); /*ssize_t*/
  ev1_4008 = kk_evv_at(_x5040,kk_context()); /*std/core/hnd/ev<std/text/parse/.hnd-parse>*/
  bool x4_4005;
  kk_box_t _x5041;
  struct kk_std_core_hnd_Ev* _con5042 = kk_std_core_hnd__as_Ev(ev1_4008);
  kk_std_core_hnd__marker m01 = _con5042->marker;
  kk_box_t _box_x4338 = _con5042->hnd;
  kk_std_text_parse__hnd_parse h1 = kk_std_text_parse__hnd_parse_unbox(_box_x4338, NULL);
  kk_std_text_parse__hnd_parse_dup(h1);
  kk_std_core_hnd__clause0 _match_4678;
  kk_std_core_hnd__clause0 _borrowApp_4679 = kk_std_text_parse__select_pick(h1, _ctx); /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,417,418>*/;
  kk_std_text_parse__hnd_parse_drop(h1, _ctx);
  _match_4678 = _borrowApp_4679; /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,417,418>*/
  kk_function_t _fun_unbox_x4341 = _match_4678.clause;
  _x5041 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_context_t*), _fun_unbox_x4341, (_fun_unbox_x4341, m01, ev1_4008, _ctx)); /*37*/
  x4_4005 = kk_bool_unbox(_x5041); /*bool*/
  if (kk_yielding(kk_context())) {
    kk_function_t _b_4361_4344 = kk_std_num_double_new_pdecdouble_fun5044(x_3987, _ctx); /*(bool) -> std/text/parse/parse double*/;
    kk_box_t _x5045 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_pdecdouble_fun5046(_b_4361_4344, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x5045, _ctx);
  }
  kk_integer_t x5_4010;
  if (x4_4005) {
    kk_char_t x6_4013;
    kk_string_t _x5049;
    kk_define_string_literal(, _s5050, 2, "eE")
    _x5049 = kk_string_dup(_s5050); /*string*/
    x6_4013 = kk_std_text_parse_one_of(_x5049, _ctx); /*char*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x5051 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_pdecdouble_fun5052(_ctx), _ctx); /*3858*/
      x5_4010 = kk_integer_unbox(_x5051); /*int*/
    }
    else {
      x5_4010 = kk_std_num_double__mlift3932_pdecdouble(x6_4013, _ctx); /*int*/
    }
  }
  else {
    x5_4010 = kk_integer_from_small(0); /*int*/
  }
  kk_integer_drop(x5_4010, _ctx);
  if (kk_yielding(kk_context())) {
    kk_function_t _b_4362_4352 = kk_std_num_double_new_pdecdouble_fun5055(x_3987, _ctx); /*(int) -> double*/;
    kk_box_t _x5062 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_pdecdouble_fun5063(_b_4362_4352, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x5062, _ctx);
  }
  kk_string_t _x10 = kk_std_core_string_3(x_3987, _ctx); /*string*/;
  kk_function_t _b_4365_4354 = kk_std_num_double_new_pdecdouble_fun5067(_ctx); /*(s : string) -> double*/;
  kk_string_t _b_4366_4355 = _x10; /*string*/;
  kk_box_t _x5068 = kk_std_core_hnd__open_none1(kk_std_num_double_new_pdecdouble_fun5069(_b_4365_4354, _ctx), kk_string_box(_b_4366_4355), _ctx); /*3289*/
  return kk_double_unbox(_x5068, _ctx);
}
 
// monadic lift

double kk_std_num_double__mlift3941_phexdouble(kk_string_t frac, kk_string_t man, kk_integer_t _c_3915, kk_context_t* _ctx) { /* (frac : string, man : string, int) -> double */ 
  kk_string_t _x1;
  kk_string_t _x5072 = kk_string_dup(frac); /*string*/
  _x1 = kk_std_core__lp__plus__plus__1_rp_(man, _x5072, _ctx); /*string*/
  kk_evv_t w = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<(<>)>*/;
  kk_std_core_types__maybe x;
  kk_string_t _x5073;
  kk_string_t _x5074 = kk_string_trim_left(_x1,kk_context()); /*string*/
  _x5073 = kk_string_trim_right(_x5074,kk_context()); /*string*/
  x = kk_std_core_xparse_int(_x5073, true, _ctx); /*maybe<int>*/
  kk_unit_t keep = kk_Unit;
  kk_evv_set(w,kk_context());
  kk_integer_t m;
  kk_box_t _x5075 = kk_std_core_default(x, kk_integer_box(kk_integer_from_small(0)), _ctx); /*2300*/
  m = kk_integer_unbox(_x5075); /*int*/
  kk_integer_t e;
  kk_integer_t _x5076;
  kk_integer_t _x5077 = kk_std_core_count_1(frac, _ctx); /*int*/
  _x5076 = kk_integer_mul((kk_integer_from_small(4)),_x5077,kk_context()); /*int*/
  e = kk_integer_sub(_c_3915,_x5076,kk_context()); /*int*/
  kk_evv_t w0 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<(<>)>*/;
  double x0;
  double _x5078;
  double _borrowApp_4670 = kk_integer_as_double_borrow(m); /*double*/;
  kk_integer_drop(m, _ctx);
  _x5078 = _borrowApp_4670; /*double*/
  x0 = kk_std_num_double_ldexp(_x5078, e, _ctx); /*double*/
  kk_unit_t keep0 = kk_Unit;
  kk_evv_set(w0,kk_context());
  return x0;
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_double__mlift3942_phexdouble_fun5082__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3942_phexdouble_fun5082(kk_function_t _fself, kk_box_t _b_4372, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3942_phexdouble_fun5082(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3942_phexdouble_fun5082, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double__mlift3942_phexdouble_fun5082(kk_function_t _fself, kk_box_t _b_4372, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_integer_t _x5083;
  kk_char_t _x5084 = kk_char_unbox(_b_4372, _ctx); /*char*/
  _x5083 = kk_std_num_double__mlift3940_phexdouble(_x5084, _ctx); /*int*/
  return kk_integer_box(_x5083);
}


// lift anonymous function
struct kk_std_num_double__mlift3942_phexdouble_fun5085__t {
  struct kk_function_s _base;
  kk_string_t frac;
  kk_string_t man;
};
static double kk_std_num_double__mlift3942_phexdouble_fun5085(kk_function_t _fself, kk_integer_t _c_3915, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3942_phexdouble_fun5085(kk_string_t frac, kk_string_t man, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3942_phexdouble_fun5085__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3942_phexdouble_fun5085__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3942_phexdouble_fun5085, kk_context());
  _self->frac = frac;
  _self->man = man;
  return &_self->_base;
}

static double kk_std_num_double__mlift3942_phexdouble_fun5085(kk_function_t _fself, kk_integer_t _c_3915, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3942_phexdouble_fun5085__t* _self = kk_function_as(struct kk_std_num_double__mlift3942_phexdouble_fun5085__t*, _fself);
  kk_string_t frac = _self->frac; /* string */
  kk_string_t man = _self->man; /* string */
  kk_drop_match(_self, {kk_string_dup(frac);kk_string_dup(man);}, {}, _ctx)
  return kk_std_num_double__mlift3941_phexdouble(frac, man, _c_3915, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3942_phexdouble_fun5087__t {
  struct kk_function_s _base;
  kk_function_t _b_4376_4374;
};
static kk_box_t kk_std_num_double__mlift3942_phexdouble_fun5087(kk_function_t _fself, kk_box_t _b_4375, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3942_phexdouble_fun5087(kk_function_t _b_4376_4374, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3942_phexdouble_fun5087__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3942_phexdouble_fun5087__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3942_phexdouble_fun5087, kk_context());
  _self->_b_4376_4374 = _b_4376_4374;
  return &_self->_base;
}

static kk_box_t kk_std_num_double__mlift3942_phexdouble_fun5087(kk_function_t _fself, kk_box_t _b_4375, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3942_phexdouble_fun5087__t* _self = kk_function_as(struct kk_std_num_double__mlift3942_phexdouble_fun5087__t*, _fself);
  kk_function_t _b_4376_4374 = _self->_b_4376_4374; /* (int) -> double */
  kk_drop_match(_self, {kk_function_dup(_b_4376_4374);}, {}, _ctx)
  double _x5088;
  kk_integer_t _x5089 = kk_integer_unbox(_b_4375); /*int*/
  _x5088 = kk_function_call(double, (kk_function_t, kk_integer_t, kk_context_t*), _b_4376_4374, (_b_4376_4374, _x5089, _ctx)); /*double*/
  return kk_double_box(_x5088, _ctx);
}

double kk_std_num_double__mlift3942_phexdouble(kk_string_t frac, kk_string_t man, bool _y_3912, kk_context_t* _ctx) { /* (frac : string, man : string, bool) -> std/text/parse/parse double */ 
  kk_integer_t x_4023;
  if (_y_3912) {
    kk_char_t x0_4025;
    kk_string_t _x5079;
    kk_define_string_literal(, _s5080, 2, "pP")
    _x5079 = kk_string_dup(_s5080); /*string*/
    x0_4025 = kk_std_text_parse_one_of(_x5079, _ctx); /*char*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x5081 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3942_phexdouble_fun5082(_ctx), _ctx); /*3858*/
      x_4023 = kk_integer_unbox(_x5081); /*int*/
    }
    else {
      x_4023 = kk_std_num_double__mlift3940_phexdouble(x0_4025, _ctx); /*int*/
    }
  }
  else {
    x_4023 = kk_integer_from_small(0); /*int*/
  }
  if (kk_yielding(kk_context())) {
    kk_integer_drop(x_4023, _ctx);
    kk_function_t _b_4376_4374 = kk_std_num_double__new_mlift3942_phexdouble_fun5085(frac, man, _ctx); /*(int) -> double*/;
    kk_box_t _x5086 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3942_phexdouble_fun5087(_b_4376_4374, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x5086, _ctx);
  }
  return kk_std_num_double__mlift3941_phexdouble(frac, man, x_4023, _ctx);
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_double__mlift3944_phexdouble_fun5096__t {
  struct kk_function_s _base;
  kk_string_t frac;
  kk_string_t man;
};
static double kk_std_num_double__mlift3944_phexdouble_fun5096(kk_function_t _fself, bool _y_3912, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3944_phexdouble_fun5096(kk_string_t frac, kk_string_t man, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3944_phexdouble_fun5096__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3944_phexdouble_fun5096__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3944_phexdouble_fun5096, kk_context());
  _self->frac = frac;
  _self->man = man;
  return &_self->_base;
}

static double kk_std_num_double__mlift3944_phexdouble_fun5096(kk_function_t _fself, bool _y_3912, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3944_phexdouble_fun5096__t* _self = kk_function_as(struct kk_std_num_double__mlift3944_phexdouble_fun5096__t*, _fself);
  kk_string_t frac = _self->frac; /* string */
  kk_string_t man = _self->man; /* string */
  kk_drop_match(_self, {kk_string_dup(frac);kk_string_dup(man);}, {}, _ctx)
  return kk_std_num_double__mlift3942_phexdouble(frac, man, _y_3912, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3944_phexdouble_fun5098__t {
  struct kk_function_s _base;
  kk_function_t _b_4385_4383;
};
static kk_box_t kk_std_num_double__mlift3944_phexdouble_fun5098(kk_function_t _fself, kk_box_t _b_4384, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3944_phexdouble_fun5098(kk_function_t _b_4385_4383, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3944_phexdouble_fun5098__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3944_phexdouble_fun5098__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3944_phexdouble_fun5098, kk_context());
  _self->_b_4385_4383 = _b_4385_4383;
  return &_self->_base;
}

static kk_box_t kk_std_num_double__mlift3944_phexdouble_fun5098(kk_function_t _fself, kk_box_t _b_4384, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3944_phexdouble_fun5098__t* _self = kk_function_as(struct kk_std_num_double__mlift3944_phexdouble_fun5098__t*, _fself);
  kk_function_t _b_4385_4383 = _self->_b_4385_4383; /* (bool) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4385_4383);}, {}, _ctx)
  double _x5099;
  bool _x5100 = kk_bool_unbox(_b_4384); /*bool*/
  _x5099 = kk_function_call(double, (kk_function_t, bool, kk_context_t*), _b_4385_4383, (_b_4385_4383, _x5100, _ctx)); /*double*/
  return kk_double_box(_x5099, _ctx);
}

double kk_std_num_double__mlift3944_phexdouble(kk_string_t man, kk_string_t _c_3911, kk_context_t* _ctx) { /* (man : string, string) -> double */ 
  kk_string_t frac;
  kk_string_t _x5090;
  kk_define_string_literal(, _s5091, 1, "0")
  _x5090 = kk_string_dup(_s5091); /*string*/
  frac = kk_std_core_trim_right_1(_c_3911, _x5090, _ctx); /*string*/
  kk_std_core_hnd__ev ev_4029;
  kk_ssize_t _x5092 = ((kk_ssize_t)0); /*ssize_t*/
  ev_4029 = kk_evv_at(_x5092,kk_context()); /*std/core/hnd/ev<std/text/parse/.hnd-parse>*/
  bool x_4027;
  kk_box_t _x5093;
  struct kk_std_core_hnd_Ev* _con5094 = kk_std_core_hnd__as_Ev(ev_4029);
  kk_std_core_hnd__marker m0 = _con5094->marker;
  kk_box_t _box_x4377 = _con5094->hnd;
  kk_std_text_parse__hnd_parse h = kk_std_text_parse__hnd_parse_unbox(_box_x4377, NULL);
  kk_std_text_parse__hnd_parse_dup(h);
  kk_std_core_hnd__clause0 _match_4666;
  kk_std_core_hnd__clause0 _borrowApp_4667 = kk_std_text_parse__select_pick(h, _ctx); /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,417,418>*/;
  kk_std_text_parse__hnd_parse_drop(h, _ctx);
  _match_4666 = _borrowApp_4667; /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,417,418>*/
  kk_function_t _fun_unbox_x4380 = _match_4666.clause;
  _x5093 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_context_t*), _fun_unbox_x4380, (_fun_unbox_x4380, m0, ev_4029, _ctx)); /*37*/
  x_4027 = kk_bool_unbox(_x5093); /*bool*/
  if (kk_yielding(kk_context())) {
    kk_function_t _b_4385_4383 = kk_std_num_double__new_mlift3944_phexdouble_fun5096(frac, man, _ctx); /*(bool) -> std/text/parse/parse double*/;
    kk_box_t _x5097 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3944_phexdouble_fun5098(_b_4385_4383, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x5097, _ctx);
  }
  return kk_std_num_double__mlift3942_phexdouble(frac, man, x_4027, _ctx);
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_double__mlift3945_phexdouble_fun5102__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3945_phexdouble_fun5102(kk_function_t _fself, kk_box_t _b_4387, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3945_phexdouble_fun5102(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3945_phexdouble_fun5102, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double__mlift3945_phexdouble_fun5102(kk_function_t _fself, kk_box_t _b_4387, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x5103;
  kk_char_t _x5104 = kk_char_unbox(_b_4387, _ctx); /*char*/
  _x5103 = kk_std_num_double__mlift3943_phexdouble(_x5104, _ctx); /*string*/
  return kk_string_box(_x5103);
}


// lift anonymous function
struct kk_std_num_double__mlift3945_phexdouble_fun5106__t {
  struct kk_function_s _base;
  kk_string_t man;
};
static double kk_std_num_double__mlift3945_phexdouble_fun5106(kk_function_t _fself, kk_string_t _c_3911, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3945_phexdouble_fun5106(kk_string_t man, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3945_phexdouble_fun5106__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3945_phexdouble_fun5106__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3945_phexdouble_fun5106, kk_context());
  _self->man = man;
  return &_self->_base;
}

static double kk_std_num_double__mlift3945_phexdouble_fun5106(kk_function_t _fself, kk_string_t _c_3911, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3945_phexdouble_fun5106__t* _self = kk_function_as(struct kk_std_num_double__mlift3945_phexdouble_fun5106__t*, _fself);
  kk_string_t man = _self->man; /* string */
  kk_drop_match(_self, {kk_string_dup(man);}, {}, _ctx)
  return kk_std_num_double__mlift3944_phexdouble(man, _c_3911, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3945_phexdouble_fun5108__t {
  struct kk_function_s _base;
  kk_function_t _b_4391_4389;
};
static kk_box_t kk_std_num_double__mlift3945_phexdouble_fun5108(kk_function_t _fself, kk_box_t _b_4390, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3945_phexdouble_fun5108(kk_function_t _b_4391_4389, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3945_phexdouble_fun5108__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3945_phexdouble_fun5108__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3945_phexdouble_fun5108, kk_context());
  _self->_b_4391_4389 = _b_4391_4389;
  return &_self->_base;
}

static kk_box_t kk_std_num_double__mlift3945_phexdouble_fun5108(kk_function_t _fself, kk_box_t _b_4390, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3945_phexdouble_fun5108__t* _self = kk_function_as(struct kk_std_num_double__mlift3945_phexdouble_fun5108__t*, _fself);
  kk_function_t _b_4391_4389 = _self->_b_4391_4389; /* (string) -> double */
  kk_drop_match(_self, {kk_function_dup(_b_4391_4389);}, {}, _ctx)
  double _x5109;
  kk_string_t _x5110 = kk_string_unbox(_b_4390); /*string*/
  _x5109 = kk_function_call(double, (kk_function_t, kk_string_t, kk_context_t*), _b_4391_4389, (_b_4391_4389, _x5110, _ctx)); /*double*/
  return kk_double_box(_x5109, _ctx);
}

double kk_std_num_double__mlift3945_phexdouble(kk_string_t man, bool _y_3908, kk_context_t* _ctx) { /* (man : string, bool) -> std/text/parse/parse double */ 
  kk_string_t x_4031;
  if (_y_3908) {
    kk_char_t x0_4033 = kk_std_text_parse_char('.', _ctx); /*char*/;
    if (kk_yielding(kk_context())) {
      kk_box_t _x5101 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3945_phexdouble_fun5102(_ctx), _ctx); /*3858*/
      x_4031 = kk_string_unbox(_x5101); /*string*/
    }
    else {
      x_4031 = kk_std_num_double__mlift3943_phexdouble(x0_4033, _ctx); /*string*/
    }
  }
  else {
    x_4031 = kk_string_empty(); /*string*/
  }
  if (kk_yielding(kk_context())) {
    kk_string_drop(x_4031, _ctx);
    kk_function_t _b_4391_4389 = kk_std_num_double__new_mlift3945_phexdouble_fun5106(man, _ctx); /*(string) -> double*/;
    kk_box_t _x5107 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3945_phexdouble_fun5108(_b_4391_4389, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x5107, _ctx);
  }
  return kk_std_num_double__mlift3944_phexdouble(man, x_4031, _ctx);
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_double__mlift3946_phexdouble_fun5115__t {
  struct kk_function_s _base;
  kk_string_t man;
};
static double kk_std_num_double__mlift3946_phexdouble_fun5115(kk_function_t _fself, bool _y_3908, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3946_phexdouble_fun5115(kk_string_t man, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3946_phexdouble_fun5115__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3946_phexdouble_fun5115__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3946_phexdouble_fun5115, kk_context());
  _self->man = man;
  return &_self->_base;
}

static double kk_std_num_double__mlift3946_phexdouble_fun5115(kk_function_t _fself, bool _y_3908, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3946_phexdouble_fun5115__t* _self = kk_function_as(struct kk_std_num_double__mlift3946_phexdouble_fun5115__t*, _fself);
  kk_string_t man = _self->man; /* string */
  kk_drop_match(_self, {kk_string_dup(man);}, {}, _ctx)
  return kk_std_num_double__mlift3945_phexdouble(man, _y_3908, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3946_phexdouble_fun5117__t {
  struct kk_function_s _base;
  kk_function_t _b_4400_4398;
};
static kk_box_t kk_std_num_double__mlift3946_phexdouble_fun5117(kk_function_t _fself, kk_box_t _b_4399, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3946_phexdouble_fun5117(kk_function_t _b_4400_4398, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3946_phexdouble_fun5117__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3946_phexdouble_fun5117__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3946_phexdouble_fun5117, kk_context());
  _self->_b_4400_4398 = _b_4400_4398;
  return &_self->_base;
}

static kk_box_t kk_std_num_double__mlift3946_phexdouble_fun5117(kk_function_t _fself, kk_box_t _b_4399, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3946_phexdouble_fun5117__t* _self = kk_function_as(struct kk_std_num_double__mlift3946_phexdouble_fun5117__t*, _fself);
  kk_function_t _b_4400_4398 = _self->_b_4400_4398; /* (bool) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4400_4398);}, {}, _ctx)
  double _x5118;
  bool _x5119 = kk_bool_unbox(_b_4399); /*bool*/
  _x5118 = kk_function_call(double, (kk_function_t, bool, kk_context_t*), _b_4400_4398, (_b_4400_4398, _x5119, _ctx)); /*double*/
  return kk_double_box(_x5118, _ctx);
}

double kk_std_num_double__mlift3946_phexdouble(kk_string_t man, kk_context_t* _ctx) { /* (man : string) -> std/text/parse/parse double */ 
  kk_std_core_hnd__ev ev_4037;
  kk_ssize_t _x5111 = ((kk_ssize_t)0); /*ssize_t*/
  ev_4037 = kk_evv_at(_x5111,kk_context()); /*std/core/hnd/ev<std/text/parse/.hnd-parse>*/
  bool x_4035;
  kk_box_t _x5112;
  struct kk_std_core_hnd_Ev* _con5113 = kk_std_core_hnd__as_Ev(ev_4037);
  kk_std_core_hnd__marker m0 = _con5113->marker;
  kk_box_t _box_x4392 = _con5113->hnd;
  kk_std_text_parse__hnd_parse h = kk_std_text_parse__hnd_parse_unbox(_box_x4392, NULL);
  kk_std_text_parse__hnd_parse_dup(h);
  kk_std_core_hnd__clause0 _match_4661;
  kk_std_core_hnd__clause0 _borrowApp_4662 = kk_std_text_parse__select_pick(h, _ctx); /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,417,418>*/;
  kk_std_text_parse__hnd_parse_drop(h, _ctx);
  _match_4661 = _borrowApp_4662; /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,417,418>*/
  kk_function_t _fun_unbox_x4395 = _match_4661.clause;
  _x5112 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_context_t*), _fun_unbox_x4395, (_fun_unbox_x4395, m0, ev_4037, _ctx)); /*37*/
  x_4035 = kk_bool_unbox(_x5112); /*bool*/
  if (kk_yielding(kk_context())) {
    kk_function_t _b_4400_4398 = kk_std_num_double__new_mlift3946_phexdouble_fun5115(man, _ctx); /*(bool) -> std/text/parse/parse double*/;
    kk_box_t _x5116 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3946_phexdouble_fun5117(_b_4400_4398, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x5116, _ctx);
  }
  return kk_std_num_double__mlift3945_phexdouble(man, x_4035, _ctx);
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_double__mlift3947_phexdouble_fun5121__t {
  struct kk_function_s _base;
};
static double kk_std_num_double__mlift3947_phexdouble_fun5121(kk_function_t _fself, kk_string_t _x15120, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3947_phexdouble_fun5121(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3947_phexdouble_fun5121, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double__mlift3947_phexdouble_fun5121(kk_function_t _fself, kk_string_t _x15120, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_num_double__mlift3946_phexdouble(_x15120, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3947_phexdouble_fun5123__t {
  struct kk_function_s _base;
  kk_function_t _b_4403_4401;
};
static kk_box_t kk_std_num_double__mlift3947_phexdouble_fun5123(kk_function_t _fself, kk_box_t _b_4402, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3947_phexdouble_fun5123(kk_function_t _b_4403_4401, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3947_phexdouble_fun5123__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3947_phexdouble_fun5123__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3947_phexdouble_fun5123, kk_context());
  _self->_b_4403_4401 = _b_4403_4401;
  return &_self->_base;
}

static kk_box_t kk_std_num_double__mlift3947_phexdouble_fun5123(kk_function_t _fself, kk_box_t _b_4402, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3947_phexdouble_fun5123__t* _self = kk_function_as(struct kk_std_num_double__mlift3947_phexdouble_fun5123__t*, _fself);
  kk_function_t _b_4403_4401 = _self->_b_4403_4401; /* (man : string) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4403_4401);}, {}, _ctx)
  double _x5124;
  kk_string_t _x5125 = kk_string_unbox(_b_4402); /*string*/
  _x5124 = kk_function_call(double, (kk_function_t, kk_string_t, kk_context_t*), _b_4403_4401, (_b_4403_4401, _x5125, _ctx)); /*double*/
  return kk_double_box(_x5124, _ctx);
}

double kk_std_num_double__mlift3947_phexdouble(kk_char_t wild__0, kk_context_t* _ctx) { /* (wild_0 : char) -> std/text/parse/parse double */ 
  kk_string_t x_4039 = kk_std_text_parse_hex_digits(_ctx); /*string*/;
  if (kk_yielding(kk_context())) {
    kk_string_drop(x_4039, _ctx);
    kk_function_t _b_4403_4401 = kk_std_num_double__new_mlift3947_phexdouble_fun5121(_ctx); /*(man : string) -> std/text/parse/parse double*/;
    kk_box_t _x5122 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3947_phexdouble_fun5123(_b_4403_4401, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x5122, _ctx);
  }
  return kk_std_num_double__mlift3946_phexdouble(x_4039, _ctx);
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_double__mlift3948_phexdouble_fun5129__t {
  struct kk_function_s _base;
};
static double kk_std_num_double__mlift3948_phexdouble_fun5129(kk_function_t _fself, kk_char_t _x15128, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3948_phexdouble_fun5129(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3948_phexdouble_fun5129, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double__mlift3948_phexdouble_fun5129(kk_function_t _fself, kk_char_t _x15128, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_num_double__mlift3947_phexdouble(_x15128, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3948_phexdouble_fun5131__t {
  struct kk_function_s _base;
  kk_function_t _b_4406_4404;
};
static kk_box_t kk_std_num_double__mlift3948_phexdouble_fun5131(kk_function_t _fself, kk_box_t _b_4405, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3948_phexdouble_fun5131(kk_function_t _b_4406_4404, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3948_phexdouble_fun5131__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3948_phexdouble_fun5131__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3948_phexdouble_fun5131, kk_context());
  _self->_b_4406_4404 = _b_4406_4404;
  return &_self->_base;
}

static kk_box_t kk_std_num_double__mlift3948_phexdouble_fun5131(kk_function_t _fself, kk_box_t _b_4405, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3948_phexdouble_fun5131__t* _self = kk_function_as(struct kk_std_num_double__mlift3948_phexdouble_fun5131__t*, _fself);
  kk_function_t _b_4406_4404 = _self->_b_4406_4404; /* (wild_0 : char) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4406_4404);}, {}, _ctx)
  double _x5132;
  kk_char_t _x5133 = kk_char_unbox(_b_4405, _ctx); /*char*/
  _x5132 = kk_function_call(double, (kk_function_t, kk_char_t, kk_context_t*), _b_4406_4404, (_b_4406_4404, _x5133, _ctx)); /*double*/
  return kk_double_box(_x5132, _ctx);
}

double kk_std_num_double__mlift3948_phexdouble(kk_char_t wild__, kk_context_t* _ctx) { /* (wild_ : char) -> std/text/parse/parse double */ 
  kk_char_t x_4041;
  kk_string_t _x5126;
  kk_define_string_literal(, _s5127, 2, "xX")
  _x5126 = kk_string_dup(_s5127); /*string*/
  x_4041 = kk_std_text_parse_one_of(_x5126, _ctx); /*char*/
  if (kk_yielding(kk_context())) {
    kk_function_t _b_4406_4404 = kk_std_num_double__new_mlift3948_phexdouble_fun5129(_ctx); /*(wild_0 : char) -> std/text/parse/parse double*/;
    kk_box_t _x5130 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3948_phexdouble_fun5131(_b_4406_4404, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x5130, _ctx);
  }
  return kk_std_num_double__mlift3947_phexdouble(x_4041, _ctx);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun5135__t {
  struct kk_function_s _base;
};
static double kk_std_num_double_phexdouble_fun5135(kk_function_t _fself, kk_char_t _x15134, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun5135(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_phexdouble_fun5135, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double_phexdouble_fun5135(kk_function_t _fself, kk_char_t _x15134, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_num_double__mlift3948_phexdouble(_x15134, _ctx);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun5137__t {
  struct kk_function_s _base;
  kk_function_t _b_4443_4407;
};
static kk_box_t kk_std_num_double_phexdouble_fun5137(kk_function_t _fself, kk_box_t _b_4408, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun5137(kk_function_t _b_4443_4407, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun5137__t* _self = kk_function_alloc_as(struct kk_std_num_double_phexdouble_fun5137__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_phexdouble_fun5137, kk_context());
  _self->_b_4443_4407 = _b_4443_4407;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_phexdouble_fun5137(kk_function_t _fself, kk_box_t _b_4408, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun5137__t* _self = kk_function_as(struct kk_std_num_double_phexdouble_fun5137__t*, _fself);
  kk_function_t _b_4443_4407 = _self->_b_4443_4407; /* (wild_ : char) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4443_4407);}, {}, _ctx)
  double _x5138;
  kk_char_t _x5139 = kk_char_unbox(_b_4408, _ctx); /*char*/
  _x5138 = kk_function_call(double, (kk_function_t, kk_char_t, kk_context_t*), _b_4443_4407, (_b_4443_4407, _x5139, _ctx)); /*double*/
  return kk_double_box(_x5138, _ctx);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun5143__t {
  struct kk_function_s _base;
};
static double kk_std_num_double_phexdouble_fun5143(kk_function_t _fself, kk_char_t _x15142, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun5143(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_phexdouble_fun5143, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double_phexdouble_fun5143(kk_function_t _fself, kk_char_t _x15142, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_num_double__mlift3947_phexdouble(_x15142, _ctx);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun5145__t {
  struct kk_function_s _base;
  kk_function_t _b_4444_4409;
};
static kk_box_t kk_std_num_double_phexdouble_fun5145(kk_function_t _fself, kk_box_t _b_4410, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun5145(kk_function_t _b_4444_4409, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun5145__t* _self = kk_function_alloc_as(struct kk_std_num_double_phexdouble_fun5145__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_phexdouble_fun5145, kk_context());
  _self->_b_4444_4409 = _b_4444_4409;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_phexdouble_fun5145(kk_function_t _fself, kk_box_t _b_4410, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun5145__t* _self = kk_function_as(struct kk_std_num_double_phexdouble_fun5145__t*, _fself);
  kk_function_t _b_4444_4409 = _self->_b_4444_4409; /* (wild_0 : char) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4444_4409);}, {}, _ctx)
  double _x5146;
  kk_char_t _x5147 = kk_char_unbox(_b_4410, _ctx); /*char*/
  _x5146 = kk_function_call(double, (kk_function_t, kk_char_t, kk_context_t*), _b_4444_4409, (_b_4444_4409, _x5147, _ctx)); /*double*/
  return kk_double_box(_x5146, _ctx);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun5149__t {
  struct kk_function_s _base;
};
static double kk_std_num_double_phexdouble_fun5149(kk_function_t _fself, kk_string_t _x15148, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun5149(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_phexdouble_fun5149, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double_phexdouble_fun5149(kk_function_t _fself, kk_string_t _x15148, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_num_double__mlift3946_phexdouble(_x15148, _ctx);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun5151__t {
  struct kk_function_s _base;
  kk_function_t _b_4445_4411;
};
static kk_box_t kk_std_num_double_phexdouble_fun5151(kk_function_t _fself, kk_box_t _b_4412, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun5151(kk_function_t _b_4445_4411, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun5151__t* _self = kk_function_alloc_as(struct kk_std_num_double_phexdouble_fun5151__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_phexdouble_fun5151, kk_context());
  _self->_b_4445_4411 = _b_4445_4411;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_phexdouble_fun5151(kk_function_t _fself, kk_box_t _b_4412, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun5151__t* _self = kk_function_as(struct kk_std_num_double_phexdouble_fun5151__t*, _fself);
  kk_function_t _b_4445_4411 = _self->_b_4445_4411; /* (man : string) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4445_4411);}, {}, _ctx)
  double _x5152;
  kk_string_t _x5153 = kk_string_unbox(_b_4412); /*string*/
  _x5152 = kk_function_call(double, (kk_function_t, kk_string_t, kk_context_t*), _b_4445_4411, (_b_4445_4411, _x5153, _ctx)); /*double*/
  return kk_double_box(_x5152, _ctx);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun5158__t {
  struct kk_function_s _base;
  kk_string_t x1_4049;
};
static double kk_std_num_double_phexdouble_fun5158(kk_function_t _fself, bool _y_3908, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun5158(kk_string_t x1_4049, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun5158__t* _self = kk_function_alloc_as(struct kk_std_num_double_phexdouble_fun5158__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_phexdouble_fun5158, kk_context());
  _self->x1_4049 = x1_4049;
  return &_self->_base;
}

static double kk_std_num_double_phexdouble_fun5158(kk_function_t _fself, bool _y_3908, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun5158__t* _self = kk_function_as(struct kk_std_num_double_phexdouble_fun5158__t*, _fself);
  kk_string_t x1_4049 = _self->x1_4049; /* string */
  kk_drop_match(_self, {kk_string_dup(x1_4049);}, {}, _ctx)
  return kk_std_num_double__mlift3945_phexdouble(x1_4049, _y_3908, _ctx);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun5160__t {
  struct kk_function_s _base;
  kk_function_t _b_4446_4419;
};
static kk_box_t kk_std_num_double_phexdouble_fun5160(kk_function_t _fself, kk_box_t _b_4420, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun5160(kk_function_t _b_4446_4419, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun5160__t* _self = kk_function_alloc_as(struct kk_std_num_double_phexdouble_fun5160__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_phexdouble_fun5160, kk_context());
  _self->_b_4446_4419 = _b_4446_4419;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_phexdouble_fun5160(kk_function_t _fself, kk_box_t _b_4420, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun5160__t* _self = kk_function_as(struct kk_std_num_double_phexdouble_fun5160__t*, _fself);
  kk_function_t _b_4446_4419 = _self->_b_4446_4419; /* (bool) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4446_4419);}, {}, _ctx)
  double _x5161;
  bool _x5162 = kk_bool_unbox(_b_4420); /*bool*/
  _x5161 = kk_function_call(double, (kk_function_t, bool, kk_context_t*), _b_4446_4419, (_b_4446_4419, _x5162, _ctx)); /*double*/
  return kk_double_box(_x5161, _ctx);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun5164__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_phexdouble_fun5164(kk_function_t _fself, kk_box_t _b_4422, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun5164(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_phexdouble_fun5164, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double_phexdouble_fun5164(kk_function_t _fself, kk_box_t _b_4422, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t _x5165;
  kk_char_t _x5166 = kk_char_unbox(_b_4422, _ctx); /*char*/
  _x5165 = kk_std_num_double__mlift3943_phexdouble(_x5166, _ctx); /*string*/
  return kk_string_box(_x5165);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun5168__t {
  struct kk_function_s _base;
  kk_string_t x1_4049;
};
static double kk_std_num_double_phexdouble_fun5168(kk_function_t _fself, kk_string_t _c_3911, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun5168(kk_string_t x1_4049, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun5168__t* _self = kk_function_alloc_as(struct kk_std_num_double_phexdouble_fun5168__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_phexdouble_fun5168, kk_context());
  _self->x1_4049 = x1_4049;
  return &_self->_base;
}

static double kk_std_num_double_phexdouble_fun5168(kk_function_t _fself, kk_string_t _c_3911, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun5168__t* _self = kk_function_as(struct kk_std_num_double_phexdouble_fun5168__t*, _fself);
  kk_string_t x1_4049 = _self->x1_4049; /* string */
  kk_drop_match(_self, {kk_string_dup(x1_4049);}, {}, _ctx)
  return kk_std_num_double__mlift3944_phexdouble(x1_4049, _c_3911, _ctx);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun5170__t {
  struct kk_function_s _base;
  kk_function_t _b_4447_4424;
};
static kk_box_t kk_std_num_double_phexdouble_fun5170(kk_function_t _fself, kk_box_t _b_4425, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun5170(kk_function_t _b_4447_4424, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun5170__t* _self = kk_function_alloc_as(struct kk_std_num_double_phexdouble_fun5170__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_phexdouble_fun5170, kk_context());
  _self->_b_4447_4424 = _b_4447_4424;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_phexdouble_fun5170(kk_function_t _fself, kk_box_t _b_4425, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun5170__t* _self = kk_function_as(struct kk_std_num_double_phexdouble_fun5170__t*, _fself);
  kk_function_t _b_4447_4424 = _self->_b_4447_4424; /* (string) -> double */
  kk_drop_match(_self, {kk_function_dup(_b_4447_4424);}, {}, _ctx)
  double _x5171;
  kk_string_t _x5172 = kk_string_unbox(_b_4425); /*string*/
  _x5171 = kk_function_call(double, (kk_function_t, kk_string_t, kk_context_t*), _b_4447_4424, (_b_4447_4424, _x5172, _ctx)); /*double*/
  return kk_double_box(_x5171, _ctx);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun5179__t {
  struct kk_function_s _base;
  kk_string_t frac;
  kk_string_t x1_4049;
};
static double kk_std_num_double_phexdouble_fun5179(kk_function_t _fself, bool _y_3912, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun5179(kk_string_t frac, kk_string_t x1_4049, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun5179__t* _self = kk_function_alloc_as(struct kk_std_num_double_phexdouble_fun5179__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_phexdouble_fun5179, kk_context());
  _self->frac = frac;
  _self->x1_4049 = x1_4049;
  return &_self->_base;
}

static double kk_std_num_double_phexdouble_fun5179(kk_function_t _fself, bool _y_3912, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun5179__t* _self = kk_function_as(struct kk_std_num_double_phexdouble_fun5179__t*, _fself);
  kk_string_t frac = _self->frac; /* string */
  kk_string_t x1_4049 = _self->x1_4049; /* string */
  kk_drop_match(_self, {kk_string_dup(frac);kk_string_dup(x1_4049);}, {}, _ctx)
  return kk_std_num_double__mlift3942_phexdouble(frac, x1_4049, _y_3912, _ctx);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun5181__t {
  struct kk_function_s _base;
  kk_function_t _b_4448_4432;
};
static kk_box_t kk_std_num_double_phexdouble_fun5181(kk_function_t _fself, kk_box_t _b_4433, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun5181(kk_function_t _b_4448_4432, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun5181__t* _self = kk_function_alloc_as(struct kk_std_num_double_phexdouble_fun5181__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_phexdouble_fun5181, kk_context());
  _self->_b_4448_4432 = _b_4448_4432;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_phexdouble_fun5181(kk_function_t _fself, kk_box_t _b_4433, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun5181__t* _self = kk_function_as(struct kk_std_num_double_phexdouble_fun5181__t*, _fself);
  kk_function_t _b_4448_4432 = _self->_b_4448_4432; /* (bool) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4448_4432);}, {}, _ctx)
  double _x5182;
  bool _x5183 = kk_bool_unbox(_b_4433); /*bool*/
  _x5182 = kk_function_call(double, (kk_function_t, bool, kk_context_t*), _b_4448_4432, (_b_4448_4432, _x5183, _ctx)); /*double*/
  return kk_double_box(_x5182, _ctx);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun5187__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_phexdouble_fun5187(kk_function_t _fself, kk_box_t _b_4435, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun5187(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_phexdouble_fun5187, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double_phexdouble_fun5187(kk_function_t _fself, kk_box_t _b_4435, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_integer_t _x5188;
  kk_char_t _x5189 = kk_char_unbox(_b_4435, _ctx); /*char*/
  _x5188 = kk_std_num_double__mlift3940_phexdouble(_x5189, _ctx); /*int*/
  return kk_integer_box(_x5188);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun5190__t {
  struct kk_function_s _base;
  kk_string_t frac;
  kk_string_t x1_4049;
};
static double kk_std_num_double_phexdouble_fun5190(kk_function_t _fself, kk_integer_t _c_3915, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun5190(kk_string_t frac, kk_string_t x1_4049, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun5190__t* _self = kk_function_alloc_as(struct kk_std_num_double_phexdouble_fun5190__t, 3, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_phexdouble_fun5190, kk_context());
  _self->frac = frac;
  _self->x1_4049 = x1_4049;
  return &_self->_base;
}

static double kk_std_num_double_phexdouble_fun5190(kk_function_t _fself, kk_integer_t _c_3915, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun5190__t* _self = kk_function_as(struct kk_std_num_double_phexdouble_fun5190__t*, _fself);
  kk_string_t frac = _self->frac; /* string */
  kk_string_t x1_4049 = _self->x1_4049; /* string */
  kk_drop_match(_self, {kk_string_dup(frac);kk_string_dup(x1_4049);}, {}, _ctx)
  return kk_std_num_double__mlift3941_phexdouble(frac, x1_4049, _c_3915, _ctx);
}


// lift anonymous function
struct kk_std_num_double_phexdouble_fun5192__t {
  struct kk_function_s _base;
  kk_function_t _b_4449_4437;
};
static kk_box_t kk_std_num_double_phexdouble_fun5192(kk_function_t _fself, kk_box_t _b_4438, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_phexdouble_fun5192(kk_function_t _b_4449_4437, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun5192__t* _self = kk_function_alloc_as(struct kk_std_num_double_phexdouble_fun5192__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_phexdouble_fun5192, kk_context());
  _self->_b_4449_4437 = _b_4449_4437;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_phexdouble_fun5192(kk_function_t _fself, kk_box_t _b_4438, kk_context_t* _ctx) {
  struct kk_std_num_double_phexdouble_fun5192__t* _self = kk_function_as(struct kk_std_num_double_phexdouble_fun5192__t*, _fself);
  kk_function_t _b_4449_4437 = _self->_b_4449_4437; /* (int) -> double */
  kk_drop_match(_self, {kk_function_dup(_b_4449_4437);}, {}, _ctx)
  double _x5193;
  kk_integer_t _x5194 = kk_integer_unbox(_b_4438); /*int*/
  _x5193 = kk_function_call(double, (kk_function_t, kk_integer_t, kk_context_t*), _b_4449_4437, (_b_4449_4437, _x5194, _ctx)); /*double*/
  return kk_double_box(_x5193, _ctx);
}

double kk_std_num_double_phexdouble(kk_context_t* _ctx) { /* () -> std/text/parse/parse double */ 
  kk_char_t x_4043 = kk_std_text_parse_char('0', _ctx); /*char*/;
  if (kk_yielding(kk_context())) {
    kk_function_t _b_4443_4407 = kk_std_num_double_new_phexdouble_fun5135(_ctx); /*(wild_ : char) -> std/text/parse/parse double*/;
    kk_box_t _x5136 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_phexdouble_fun5137(_b_4443_4407, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x5136, _ctx);
  }
  kk_char_t x0_4046;
  kk_string_t _x5140;
  kk_define_string_literal(, _s5141, 2, "xX")
  _x5140 = kk_string_dup(_s5141); /*string*/
  x0_4046 = kk_std_text_parse_one_of(_x5140, _ctx); /*char*/
  if (kk_yielding(kk_context())) {
    kk_function_t _b_4444_4409 = kk_std_num_double_new_phexdouble_fun5143(_ctx); /*(wild_0 : char) -> std/text/parse/parse double*/;
    kk_box_t _x5144 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_phexdouble_fun5145(_b_4444_4409, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x5144, _ctx);
  }
  kk_string_t x1_4049 = kk_std_text_parse_hex_digits(_ctx); /*string*/;
  if (kk_yielding(kk_context())) {
    kk_string_drop(x1_4049, _ctx);
    kk_function_t _b_4445_4411 = kk_std_num_double_new_phexdouble_fun5149(_ctx); /*(man : string) -> std/text/parse/parse double*/;
    kk_box_t _x5150 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_phexdouble_fun5151(_b_4445_4411, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x5150, _ctx);
  }
  kk_std_core_hnd__ev ev_4055;
  kk_ssize_t _x5154 = ((kk_ssize_t)0); /*ssize_t*/
  ev_4055 = kk_evv_at(_x5154,kk_context()); /*std/core/hnd/ev<std/text/parse/.hnd-parse>*/
  bool x2_4052;
  kk_box_t _x5155;
  struct kk_std_core_hnd_Ev* _con5156 = kk_std_core_hnd__as_Ev(ev_4055);
  kk_std_core_hnd__marker m0 = _con5156->marker;
  kk_box_t _box_x4413 = _con5156->hnd;
  kk_std_text_parse__hnd_parse h = kk_std_text_parse__hnd_parse_unbox(_box_x4413, NULL);
  kk_std_text_parse__hnd_parse_dup(h);
  kk_std_core_hnd__clause0 _match_4656;
  kk_std_core_hnd__clause0 _borrowApp_4657 = kk_std_text_parse__select_pick(h, _ctx); /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,417,418>*/;
  kk_std_text_parse__hnd_parse_drop(h, _ctx);
  _match_4656 = _borrowApp_4657; /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,417,418>*/
  kk_function_t _fun_unbox_x4416 = _match_4656.clause;
  _x5155 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_context_t*), _fun_unbox_x4416, (_fun_unbox_x4416, m0, ev_4055, _ctx)); /*37*/
  x2_4052 = kk_bool_unbox(_x5155); /*bool*/
  if (kk_yielding(kk_context())) {
    kk_function_t _b_4446_4419 = kk_std_num_double_new_phexdouble_fun5158(x1_4049, _ctx); /*(bool) -> std/text/parse/parse double*/;
    kk_box_t _x5159 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_phexdouble_fun5160(_b_4446_4419, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x5159, _ctx);
  }
  kk_string_t x3_4057;
  if (x2_4052) {
    kk_char_t x4_4060 = kk_std_text_parse_char('.', _ctx); /*char*/;
    if (kk_yielding(kk_context())) {
      kk_box_t _x5163 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_phexdouble_fun5164(_ctx), _ctx); /*3858*/
      x3_4057 = kk_string_unbox(_x5163); /*string*/
    }
    else {
      x3_4057 = kk_std_num_double__mlift3943_phexdouble(x4_4060, _ctx); /*string*/
    }
  }
  else {
    x3_4057 = kk_string_empty(); /*string*/
  }
  if (kk_yielding(kk_context())) {
    kk_string_drop(x3_4057, _ctx);
    kk_function_t _b_4447_4424 = kk_std_num_double_new_phexdouble_fun5168(x1_4049, _ctx); /*(string) -> double*/;
    kk_box_t _x5169 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_phexdouble_fun5170(_b_4447_4424, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x5169, _ctx);
  }
  kk_string_t frac;
  kk_string_t _x5173;
  kk_define_string_literal(, _s5174, 1, "0")
  _x5173 = kk_string_dup(_s5174); /*string*/
  frac = kk_std_core_trim_right_1(x3_4057, _x5173, _ctx); /*string*/
  kk_std_core_hnd__ev ev0_4065;
  kk_ssize_t _x5175 = ((kk_ssize_t)0); /*ssize_t*/
  ev0_4065 = kk_evv_at(_x5175,kk_context()); /*std/core/hnd/ev<std/text/parse/.hnd-parse>*/
  bool x5_4062;
  kk_box_t _x5176;
  struct kk_std_core_hnd_Ev* _con5177 = kk_std_core_hnd__as_Ev(ev0_4065);
  kk_std_core_hnd__marker m00 = _con5177->marker;
  kk_box_t _box_x4426 = _con5177->hnd;
  kk_std_text_parse__hnd_parse h0 = kk_std_text_parse__hnd_parse_unbox(_box_x4426, NULL);
  kk_std_text_parse__hnd_parse_dup(h0);
  kk_std_core_hnd__clause0 _match_4653;
  kk_std_core_hnd__clause0 _borrowApp_4654 = kk_std_text_parse__select_pick(h0, _ctx); /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,417,418>*/;
  kk_std_text_parse__hnd_parse_drop(h0, _ctx);
  _match_4653 = _borrowApp_4654; /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,417,418>*/
  kk_function_t _fun_unbox_x4429 = _match_4653.clause;
  _x5176 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_context_t*), _fun_unbox_x4429, (_fun_unbox_x4429, m00, ev0_4065, _ctx)); /*37*/
  x5_4062 = kk_bool_unbox(_x5176); /*bool*/
  if (kk_yielding(kk_context())) {
    kk_function_t _b_4448_4432 = kk_std_num_double_new_phexdouble_fun5179(frac, x1_4049, _ctx); /*(bool) -> std/text/parse/parse double*/;
    kk_box_t _x5180 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_phexdouble_fun5181(_b_4448_4432, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x5180, _ctx);
  }
  kk_integer_t x6_4067;
  if (x5_4062) {
    kk_char_t x7_4070;
    kk_string_t _x5184;
    kk_define_string_literal(, _s5185, 2, "pP")
    _x5184 = kk_string_dup(_s5185); /*string*/
    x7_4070 = kk_std_text_parse_one_of(_x5184, _ctx); /*char*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x5186 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_phexdouble_fun5187(_ctx), _ctx); /*3858*/
      x6_4067 = kk_integer_unbox(_x5186); /*int*/
    }
    else {
      x6_4067 = kk_std_num_double__mlift3940_phexdouble(x7_4070, _ctx); /*int*/
    }
  }
  else {
    x6_4067 = kk_integer_from_small(0); /*int*/
  }
  if (kk_yielding(kk_context())) {
    kk_integer_drop(x6_4067, _ctx);
    kk_function_t _b_4449_4437 = kk_std_num_double_new_phexdouble_fun5190(frac, x1_4049, _ctx); /*(int) -> double*/;
    kk_box_t _x5191 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_phexdouble_fun5192(_b_4449_4437, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x5191, _ctx);
  }
  kk_string_t _x1;
  kk_string_t _x5195 = kk_string_dup(frac); /*string*/
  _x1 = kk_std_core__lp__plus__plus__1_rp_(x1_4049, _x5195, _ctx); /*string*/
  kk_evv_t w = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<(<>)>*/;
  kk_std_core_types__maybe x8;
  kk_string_t _x5196;
  kk_string_t _x5197 = kk_string_trim_left(_x1,kk_context()); /*string*/
  _x5196 = kk_string_trim_right(_x5197,kk_context()); /*string*/
  x8 = kk_std_core_xparse_int(_x5196, true, _ctx); /*maybe<int>*/
  kk_unit_t keep = kk_Unit;
  kk_evv_set(w,kk_context());
  kk_integer_t m;
  kk_box_t _x5198 = kk_std_core_default(x8, kk_integer_box(kk_integer_from_small(0)), _ctx); /*2300*/
  m = kk_integer_unbox(_x5198); /*int*/
  kk_integer_t e;
  kk_integer_t _x5199;
  kk_integer_t _x5200 = kk_std_core_count_1(frac, _ctx); /*int*/
  _x5199 = kk_integer_mul((kk_integer_from_small(4)),_x5200,kk_context()); /*int*/
  e = kk_integer_sub(x6_4067,_x5199,kk_context()); /*int*/
  kk_evv_t w0 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<(<>)>*/;
  double x9;
  double _x5201;
  double _borrowApp_4651 = kk_integer_as_double_borrow(m); /*double*/;
  kk_integer_drop(m, _ctx);
  _x5201 = _borrowApp_4651; /*double*/
  x9 = kk_std_num_double_ldexp(_x5201, e, _ctx); /*double*/
  kk_unit_t keep0 = kk_Unit;
  kk_evv_set(w0,kk_context());
  return x9;
}


// lift anonymous function
struct kk_std_num_double_pspecial_fun5202__t {
  struct kk_function_s _base;
};
static double kk_std_num_double_pspecial_fun5202(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pspecial_fun5202(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pspecial_fun5202, _ctx)
  return kk_function_dup(_fself);
}



// lift anonymous function
struct kk_std_num_double_pspecial_fun5206__t {
  struct kk_function_s _base;
};
static double kk_std_num_double_pspecial_fun5206(kk_function_t _fself, kk_string_t _x15205, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pspecial_fun5206(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pspecial_fun5206, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double_pspecial_fun5206(kk_function_t _fself, kk_string_t _x15205, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_num_double__mlift3949_pspecial(_x15205, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pspecial_fun5208__t {
  struct kk_function_s _base;
  kk_function_t _b_4469_4450;
};
static kk_box_t kk_std_num_double_pspecial_fun5208(kk_function_t _fself, kk_box_t _b_4451, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pspecial_fun5208(kk_function_t _b_4469_4450, kk_context_t* _ctx) {
  struct kk_std_num_double_pspecial_fun5208__t* _self = kk_function_alloc_as(struct kk_std_num_double_pspecial_fun5208__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pspecial_fun5208, kk_context());
  _self->_b_4469_4450 = _b_4469_4450;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pspecial_fun5208(kk_function_t _fself, kk_box_t _b_4451, kk_context_t* _ctx) {
  struct kk_std_num_double_pspecial_fun5208__t* _self = kk_function_as(struct kk_std_num_double_pspecial_fun5208__t*, _fself);
  kk_function_t _b_4469_4450 = _self->_b_4469_4450; /* (wild_ : string) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4469_4450);}, {}, _ctx)
  double _x5209;
  kk_string_t _x5210 = kk_string_unbox(_b_4451); /*string*/
  _x5209 = kk_function_call(double, (kk_function_t, kk_string_t, kk_context_t*), _b_4469_4450, (_b_4469_4450, _x5210, _ctx)); /*double*/
  return kk_double_box(_x5209, _ctx);
}
static double kk_std_num_double_pspecial_fun5202(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t x_4078;
  kk_string_t _x5203;
  kk_define_string_literal(, _s5204, 3, "nan")
  _x5203 = kk_string_dup(_s5204); /*string*/
  x_4078 = kk_std_text_parse_pstring(_x5203, _ctx); /*string*/
  if (kk_yielding(kk_context())) {
    kk_string_drop(x_4078, _ctx);
    kk_function_t _b_4469_4450 = kk_std_num_double_new_pspecial_fun5206(_ctx); /*(wild_ : string) -> std/text/parse/parse double*/;
    kk_box_t _x5207 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_pspecial_fun5208(_b_4469_4450, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x5207, _ctx);
  }
  return kk_std_num_double__mlift3949_pspecial(x_4078, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pspecial_fun5211__t {
  struct kk_function_s _base;
};
static double kk_std_num_double_pspecial_fun5211(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pspecial_fun5211(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pspecial_fun5211, _ctx)
  return kk_function_dup(_fself);
}



// lift anonymous function
struct kk_std_num_double_pspecial_fun5215__t {
  struct kk_function_s _base;
};
static double kk_std_num_double_pspecial_fun5215(kk_function_t _fself, kk_string_t _x15214, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pspecial_fun5215(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pspecial_fun5215, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double_pspecial_fun5215(kk_function_t _fself, kk_string_t _x15214, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_num_double__mlift3950_pspecial(_x15214, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pspecial_fun5217__t {
  struct kk_function_s _base;
  kk_function_t _b_4472_4452;
};
static kk_box_t kk_std_num_double_pspecial_fun5217(kk_function_t _fself, kk_box_t _b_4453, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pspecial_fun5217(kk_function_t _b_4472_4452, kk_context_t* _ctx) {
  struct kk_std_num_double_pspecial_fun5217__t* _self = kk_function_alloc_as(struct kk_std_num_double_pspecial_fun5217__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pspecial_fun5217, kk_context());
  _self->_b_4472_4452 = _b_4472_4452;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pspecial_fun5217(kk_function_t _fself, kk_box_t _b_4453, kk_context_t* _ctx) {
  struct kk_std_num_double_pspecial_fun5217__t* _self = kk_function_as(struct kk_std_num_double_pspecial_fun5217__t*, _fself);
  kk_function_t _b_4472_4452 = _self->_b_4472_4452; /* (wild_0 : string) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4472_4452);}, {}, _ctx)
  double _x5218;
  kk_string_t _x5219 = kk_string_unbox(_b_4453); /*string*/
  _x5218 = kk_function_call(double, (kk_function_t, kk_string_t, kk_context_t*), _b_4472_4452, (_b_4472_4452, _x5219, _ctx)); /*double*/
  return kk_double_box(_x5218, _ctx);
}
static double kk_std_num_double_pspecial_fun5211(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t x0_4080;
  kk_string_t _x5212;
  kk_define_string_literal(, _s5213, 8, "infinity")
  _x5212 = kk_string_dup(_s5213); /*string*/
  x0_4080 = kk_std_text_parse_pstring(_x5212, _ctx); /*string*/
  if (kk_yielding(kk_context())) {
    kk_string_drop(x0_4080, _ctx);
    kk_function_t _b_4472_4452 = kk_std_num_double_new_pspecial_fun5215(_ctx); /*(wild_0 : string) -> std/text/parse/parse double*/;
    kk_box_t _x5216 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_pspecial_fun5217(_b_4472_4452, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x5216, _ctx);
  }
  return kk_std_num_double__mlift3950_pspecial(x0_4080, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pspecial_fun5220__t {
  struct kk_function_s _base;
};
static double kk_std_num_double_pspecial_fun5220(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pspecial_fun5220(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pspecial_fun5220, _ctx)
  return kk_function_dup(_fself);
}



// lift anonymous function
struct kk_std_num_double_pspecial_fun5224__t {
  struct kk_function_s _base;
};
static double kk_std_num_double_pspecial_fun5224(kk_function_t _fself, kk_string_t _x15223, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pspecial_fun5224(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pspecial_fun5224, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double_pspecial_fun5224(kk_function_t _fself, kk_string_t _x15223, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_num_double__mlift3951_pspecial(_x15223, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pspecial_fun5226__t {
  struct kk_function_s _base;
  kk_function_t _b_4475_4454;
};
static kk_box_t kk_std_num_double_pspecial_fun5226(kk_function_t _fself, kk_box_t _b_4455, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pspecial_fun5226(kk_function_t _b_4475_4454, kk_context_t* _ctx) {
  struct kk_std_num_double_pspecial_fun5226__t* _self = kk_function_alloc_as(struct kk_std_num_double_pspecial_fun5226__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pspecial_fun5226, kk_context());
  _self->_b_4475_4454 = _b_4475_4454;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pspecial_fun5226(kk_function_t _fself, kk_box_t _b_4455, kk_context_t* _ctx) {
  struct kk_std_num_double_pspecial_fun5226__t* _self = kk_function_as(struct kk_std_num_double_pspecial_fun5226__t*, _fself);
  kk_function_t _b_4475_4454 = _self->_b_4475_4454; /* (wild_1 : string) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4475_4454);}, {}, _ctx)
  double _x5227;
  kk_string_t _x5228 = kk_string_unbox(_b_4455); /*string*/
  _x5227 = kk_function_call(double, (kk_function_t, kk_string_t, kk_context_t*), _b_4475_4454, (_b_4475_4454, _x5228, _ctx)); /*double*/
  return kk_double_box(_x5227, _ctx);
}
static double kk_std_num_double_pspecial_fun5220(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  kk_string_t x1_4082;
  kk_string_t _x5221;
  kk_define_string_literal(, _s5222, 3, "inf")
  _x5221 = kk_string_dup(_s5222); /*string*/
  x1_4082 = kk_std_text_parse_pstring(_x5221, _ctx); /*string*/
  if (kk_yielding(kk_context())) {
    kk_string_drop(x1_4082, _ctx);
    kk_function_t _b_4475_4454 = kk_std_num_double_new_pspecial_fun5224(_ctx); /*(wild_1 : string) -> std/text/parse/parse double*/;
    kk_box_t _x5225 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_pspecial_fun5226(_b_4475_4454, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x5225, _ctx);
  }
  return kk_std_num_double__mlift3951_pspecial(x1_4082, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pspecial_fun5229__t {
  struct kk_function_s _base;
  kk_function_t _b_4473_4456;
};
static kk_box_t kk_std_num_double_pspecial_fun5229(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pspecial_fun5229(kk_function_t _b_4473_4456, kk_context_t* _ctx) {
  struct kk_std_num_double_pspecial_fun5229__t* _self = kk_function_alloc_as(struct kk_std_num_double_pspecial_fun5229__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pspecial_fun5229, kk_context());
  _self->_b_4473_4456 = _b_4473_4456;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pspecial_fun5229(kk_function_t _fself, kk_context_t* _ctx) {
  struct kk_std_num_double_pspecial_fun5229__t* _self = kk_function_as(struct kk_std_num_double_pspecial_fun5229__t*, _fself);
  kk_function_t _b_4473_4456 = _self->_b_4473_4456; /* () -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4473_4456);}, {}, _ctx)
  double _x5230 = kk_function_call(double, (kk_function_t, kk_context_t*), _b_4473_4456, (_b_4473_4456, _ctx)); /*double*/
  return kk_double_box(_x5230, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pspecial_fun5231__t {
  struct kk_function_s _base;
  kk_function_t _b_4470_4459;
};
static kk_box_t kk_std_num_double_pspecial_fun5231(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pspecial_fun5231(kk_function_t _b_4470_4459, kk_context_t* _ctx) {
  struct kk_std_num_double_pspecial_fun5231__t* _self = kk_function_alloc_as(struct kk_std_num_double_pspecial_fun5231__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pspecial_fun5231, kk_context());
  _self->_b_4470_4459 = _b_4470_4459;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pspecial_fun5231(kk_function_t _fself, kk_context_t* _ctx) {
  struct kk_std_num_double_pspecial_fun5231__t* _self = kk_function_as(struct kk_std_num_double_pspecial_fun5231__t*, _fself);
  kk_function_t _b_4470_4459 = _self->_b_4470_4459; /* () -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4470_4459);}, {}, _ctx)
  double _x5232 = kk_function_call(double, (kk_function_t, kk_context_t*), _b_4470_4459, (_b_4470_4459, _ctx)); /*double*/
  return kk_double_box(_x5232, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pspecial_fun5233__t {
  struct kk_function_s _base;
  kk_function_t _b_4467_4462;
};
static kk_box_t kk_std_num_double_pspecial_fun5233(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pspecial_fun5233(kk_function_t _b_4467_4462, kk_context_t* _ctx) {
  struct kk_std_num_double_pspecial_fun5233__t* _self = kk_function_alloc_as(struct kk_std_num_double_pspecial_fun5233__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pspecial_fun5233, kk_context());
  _self->_b_4467_4462 = _b_4467_4462;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pspecial_fun5233(kk_function_t _fself, kk_context_t* _ctx) {
  struct kk_std_num_double_pspecial_fun5233__t* _self = kk_function_as(struct kk_std_num_double_pspecial_fun5233__t*, _fself);
  kk_function_t _b_4467_4462 = _self->_b_4467_4462; /* () -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4467_4462);}, {}, _ctx)
  double _x5234 = kk_function_call(double, (kk_function_t, kk_context_t*), _b_4467_4462, (_b_4467_4462, _ctx)); /*double*/
  return kk_double_box(_x5234, _ctx);
}

double kk_std_num_double_pspecial(kk_context_t* _ctx) { /* () -> std/text/parse/parse double */ 
  kk_std_core__list _b_4466_4465;
  kk_function_t _b_4467_4462 = kk_std_num_double_new_pspecial_fun5202(_ctx); /*() -> std/text/parse/parse double*/;
  kk_std_core__list _b_4468_4463;
  kk_function_t _b_4470_4459 = kk_std_num_double_new_pspecial_fun5211(_ctx); /*() -> std/text/parse/parse double*/;
  kk_std_core__list _b_4471_4460;
  kk_function_t _b_4473_4456 = kk_std_num_double_new_pspecial_fun5220(_ctx); /*() -> std/text/parse/parse double*/;
  kk_std_core__list _b_4474_4457 = kk_std_core__new_Nil(_ctx); /*list<() -> std/text/parse/parse double>*/;
  _b_4471_4460 = kk_std_core__new_Cons(kk_reuse_null, kk_function_box(kk_std_num_double_new_pspecial_fun5229(_b_4473_4456, _ctx)), _b_4474_4457, _ctx); /*list<() -> std/text/parse/parse double>*/
  _b_4468_4463 = kk_std_core__new_Cons(kk_reuse_null, kk_function_box(kk_std_num_double_new_pspecial_fun5231(_b_4470_4459, _ctx)), _b_4471_4460, _ctx); /*list<() -> std/text/parse/parse double>*/
  _b_4466_4465 = kk_std_core__new_Cons(kk_reuse_null, kk_function_box(kk_std_num_double_new_pspecial_fun5233(_b_4467_4462, _ctx)), _b_4468_4463, _ctx); /*list<() -> std/text/parse/parse double>*/
  kk_box_t _x5235 = kk_std_text_parse_choose(_b_4466_4465, _ctx); /*770*/
  return kk_double_unbox(_x5235, _ctx);
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_double__mlift3956_pdouble_fun5238__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3956_pdouble_fun5238(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3956_pdouble_fun5238(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3956_pdouble_fun5238, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double__mlift3956_pdouble_fun5238(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x5239 = kk_std_num_double_phexdouble(_ctx); /*double*/
  return kk_double_box(_x5239, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3956_pdouble_fun5241__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3956_pdouble_fun5241(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3956_pdouble_fun5241(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3956_pdouble_fun5241, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double__mlift3956_pdouble_fun5241(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x5242 = kk_std_num_double_pdecdouble(_ctx); /*double*/
  return kk_double_box(_x5242, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3956_pdouble_fun5244__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3956_pdouble_fun5244(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3956_pdouble_fun5244(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3956_pdouble_fun5244, _ctx)
  return kk_function_dup(_fself);
}



// lift anonymous function
struct kk_std_num_double__mlift3956_pdouble_fun5246__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3956_pdouble_fun5246(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3956_pdouble_fun5246(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3956_pdouble_fun5246, _ctx)
  return kk_function_dup(_fself);
}



// lift anonymous function
struct kk_std_num_double__mlift3956_pdouble_fun5251__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3956_pdouble_fun5251(kk_function_t _fself, kk_box_t _b_4477, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3956_pdouble_fun5251(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3956_pdouble_fun5251, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double__mlift3956_pdouble_fun5251(kk_function_t _fself, kk_box_t _b_4477, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x5252;
  kk_string_t _x5253 = kk_string_unbox(_b_4477); /*string*/
  _x5252 = kk_std_num_double__mlift3952_pdouble(_x5253, _ctx); /*double*/
  return kk_double_box(_x5252, _ctx);
}
static kk_box_t kk_std_num_double__mlift3956_pdouble_fun5246(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x5247;
  kk_string_t x0_4086;
  kk_string_t _x5248;
  kk_define_string_literal(, _s5249, 3, "nan")
  _x5248 = kk_string_dup(_s5249); /*string*/
  x0_4086 = kk_std_text_parse_pstring(_x5248, _ctx); /*string*/
  if (kk_yielding(kk_context())) {
    kk_string_drop(x0_4086, _ctx);
    kk_box_t _x5250 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3956_pdouble_fun5251(_ctx), _ctx); /*3858*/
    _x5247 = kk_double_unbox(_x5250, _ctx); /*double*/
  }
  else {
    _x5247 = kk_std_num_double__mlift3952_pdouble(x0_4086, _ctx); /*double*/
  }
  return kk_double_box(_x5247, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3956_pdouble_fun5255__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3956_pdouble_fun5255(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3956_pdouble_fun5255(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3956_pdouble_fun5255, _ctx)
  return kk_function_dup(_fself);
}



// lift anonymous function
struct kk_std_num_double__mlift3956_pdouble_fun5260__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3956_pdouble_fun5260(kk_function_t _fself, kk_box_t _b_4479, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3956_pdouble_fun5260(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3956_pdouble_fun5260, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double__mlift3956_pdouble_fun5260(kk_function_t _fself, kk_box_t _b_4479, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x5261;
  kk_string_t _x5262 = kk_string_unbox(_b_4479); /*string*/
  _x5261 = kk_std_num_double__mlift3953_pdouble(_x5262, _ctx); /*double*/
  return kk_double_box(_x5261, _ctx);
}
static kk_box_t kk_std_num_double__mlift3956_pdouble_fun5255(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x5256;
  kk_string_t x1_4088;
  kk_string_t _x5257;
  kk_define_string_literal(, _s5258, 8, "infinity")
  _x5257 = kk_string_dup(_s5258); /*string*/
  x1_4088 = kk_std_text_parse_pstring(_x5257, _ctx); /*string*/
  if (kk_yielding(kk_context())) {
    kk_string_drop(x1_4088, _ctx);
    kk_box_t _x5259 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3956_pdouble_fun5260(_ctx), _ctx); /*3858*/
    _x5256 = kk_double_unbox(_x5259, _ctx); /*double*/
  }
  else {
    _x5256 = kk_std_num_double__mlift3953_pdouble(x1_4088, _ctx); /*double*/
  }
  return kk_double_box(_x5256, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3956_pdouble_fun5264__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3956_pdouble_fun5264(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3956_pdouble_fun5264(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3956_pdouble_fun5264, _ctx)
  return kk_function_dup(_fself);
}



// lift anonymous function
struct kk_std_num_double__mlift3956_pdouble_fun5269__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3956_pdouble_fun5269(kk_function_t _fself, kk_box_t _b_4481, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3956_pdouble_fun5269(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3956_pdouble_fun5269, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double__mlift3956_pdouble_fun5269(kk_function_t _fself, kk_box_t _b_4481, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x5270;
  kk_string_t _x5271 = kk_string_unbox(_b_4481); /*string*/
  _x5270 = kk_std_num_double__mlift3954_pdouble(_x5271, _ctx); /*double*/
  return kk_double_box(_x5270, _ctx);
}
static kk_box_t kk_std_num_double__mlift3956_pdouble_fun5264(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x5265;
  kk_string_t x2_4090;
  kk_string_t _x5266;
  kk_define_string_literal(, _s5267, 3, "inf")
  _x5266 = kk_string_dup(_s5267); /*string*/
  x2_4090 = kk_std_text_parse_pstring(_x5266, _ctx); /*string*/
  if (kk_yielding(kk_context())) {
    kk_string_drop(x2_4090, _ctx);
    kk_box_t _x5268 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3956_pdouble_fun5269(_ctx), _ctx); /*3858*/
    _x5265 = kk_double_unbox(_x5268, _ctx); /*double*/
  }
  else {
    _x5265 = kk_std_num_double__mlift3954_pdouble(x2_4090, _ctx); /*double*/
  }
  return kk_double_box(_x5265, _ctx);
}
static kk_box_t kk_std_num_double__mlift3956_pdouble_fun5244(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x5245;
  kk_std_core__list _b_4512_4491;
  kk_std_core__list _x5254;
  kk_std_core__list _x5263 = kk_std_core__new_Cons(kk_reuse_null, kk_function_box(kk_std_num_double__new_mlift3956_pdouble_fun5264(_ctx)), kk_std_core__new_Nil(_ctx), _ctx); /*list<61>*/
  _x5254 = kk_std_core__new_Cons(kk_reuse_null, kk_function_box(kk_std_num_double__new_mlift3956_pdouble_fun5255(_ctx)), _x5263, _ctx); /*list<61>*/
  _b_4512_4491 = kk_std_core__new_Cons(kk_reuse_null, kk_function_box(kk_std_num_double__new_mlift3956_pdouble_fun5246(_ctx)), _x5254, _ctx); /*list<() -> std/text/parse/parse double>*/
  kk_box_t _x5272 = kk_std_text_parse_choose(_b_4512_4491, _ctx); /*770*/
  _x5245 = kk_double_unbox(_x5272, _ctx); /*double*/
  return kk_double_box(_x5245, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3956_pdouble_fun5274__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double__mlift3956_pdouble_fun5274(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3956_pdouble_fun5274(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3956_pdouble_fun5274, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double__mlift3956_pdouble_fun5274(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_double_box(0.0, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3956_pdouble_fun5275__t {
  struct kk_function_s _base;
  bool neg;
};
static double kk_std_num_double__mlift3956_pdouble_fun5275(kk_function_t _fself, double d, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3956_pdouble_fun5275(bool neg, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3956_pdouble_fun5275__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3956_pdouble_fun5275__t, 1, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3956_pdouble_fun5275, kk_context());
  _self->neg = neg;
  return &_self->_base;
}

static double kk_std_num_double__mlift3956_pdouble_fun5275(kk_function_t _fself, double d, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3956_pdouble_fun5275__t* _self = kk_function_as(struct kk_std_num_double__mlift3956_pdouble_fun5275__t*, _fself);
  bool neg = _self->neg; /* bool */
  kk_drop_match(_self, {;}, {}, _ctx)
  if (neg) {
    return (-d);
  }
  return d;
}


// lift anonymous function
struct kk_std_num_double__mlift3956_pdouble_fun5277__t {
  struct kk_function_s _base;
  kk_function_t _b_4526_4524;
};
static kk_box_t kk_std_num_double__mlift3956_pdouble_fun5277(kk_function_t _fself, kk_box_t _b_4525, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3956_pdouble_fun5277(kk_function_t _b_4526_4524, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3956_pdouble_fun5277__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3956_pdouble_fun5277__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3956_pdouble_fun5277, kk_context());
  _self->_b_4526_4524 = _b_4526_4524;
  return &_self->_base;
}

static kk_box_t kk_std_num_double__mlift3956_pdouble_fun5277(kk_function_t _fself, kk_box_t _b_4525, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3956_pdouble_fun5277__t* _self = kk_function_as(struct kk_std_num_double__mlift3956_pdouble_fun5277__t*, _fself);
  kk_function_t _b_4526_4524 = _self->_b_4526_4524; /* (double) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4526_4524);}, {}, _ctx)
  double _x5278;
  double _x5279 = kk_double_unbox(_b_4525, _ctx); /*double*/
  _x5278 = kk_function_call(double, (kk_function_t, double, kk_context_t*), _b_4526_4524, (_b_4526_4524, _x5279, _ctx)); /*double*/
  return kk_double_box(_x5278, _ctx);
}

double kk_std_num_double__mlift3956_pdouble(kk_char_t _c_3922, kk_context_t* _ctx) { /* (char) -> double */ 
  bool neg = (_c_3922 == ('-')); /*bool*/;
  double x_4084;
  kk_box_t _x5236;
  kk_std_core__list _x5237;
  kk_std_core__list _x5240;
  kk_std_core__list _x5243;
  kk_std_core__list _x5273 = kk_std_core__new_Cons(kk_reuse_null, kk_function_box(kk_std_num_double__new_mlift3956_pdouble_fun5274(_ctx)), kk_std_core__new_Nil(_ctx), _ctx); /*list<61>*/
  _x5243 = kk_std_core__new_Cons(kk_reuse_null, kk_function_box(kk_std_num_double__new_mlift3956_pdouble_fun5244(_ctx)), _x5273, _ctx); /*list<61>*/
  _x5240 = kk_std_core__new_Cons(kk_reuse_null, kk_function_box(kk_std_num_double__new_mlift3956_pdouble_fun5241(_ctx)), _x5243, _ctx); /*list<61>*/
  _x5237 = kk_std_core__new_Cons(kk_reuse_null, kk_function_box(kk_std_num_double__new_mlift3956_pdouble_fun5238(_ctx)), _x5240, _ctx); /*list<61>*/
  _x5236 = kk_std_text_parse_choose(_x5237, _ctx); /*770*/
  x_4084 = kk_double_unbox(_x5236, _ctx); /*double*/
  kk_function_t next_4085 = kk_std_num_double__new_mlift3956_pdouble_fun5275(neg, _ctx); /*(double) -> std/text/parse/parse double*/;
  if (kk_yielding(kk_context())) {
    kk_function_t _b_4526_4524 = next_4085; /*(double) -> std/text/parse/parse double*/;
    kk_box_t _x5276 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3956_pdouble_fun5277(_b_4526_4524, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x5276, _ctx);
  }
  return kk_function_call(double, (kk_function_t, double, kk_context_t*), next_4085, (next_4085, x_4084, _ctx));
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_double__mlift3957_pdouble_fun5283__t {
  struct kk_function_s _base;
};
static double kk_std_num_double__mlift3957_pdouble_fun5283(kk_function_t _fself, kk_char_t _x15282, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3957_pdouble_fun5283(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double__mlift3957_pdouble_fun5283, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double__mlift3957_pdouble_fun5283(kk_function_t _fself, kk_char_t _x15282, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_num_double__mlift3956_pdouble(_x15282, _ctx);
}


// lift anonymous function
struct kk_std_num_double__mlift3957_pdouble_fun5285__t {
  struct kk_function_s _base;
  kk_function_t _b_4529_4527;
};
static kk_box_t kk_std_num_double__mlift3957_pdouble_fun5285(kk_function_t _fself, kk_box_t _b_4528, kk_context_t* _ctx);
static kk_function_t kk_std_num_double__new_mlift3957_pdouble_fun5285(kk_function_t _b_4529_4527, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3957_pdouble_fun5285__t* _self = kk_function_alloc_as(struct kk_std_num_double__mlift3957_pdouble_fun5285__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double__mlift3957_pdouble_fun5285, kk_context());
  _self->_b_4529_4527 = _b_4529_4527;
  return &_self->_base;
}

static kk_box_t kk_std_num_double__mlift3957_pdouble_fun5285(kk_function_t _fself, kk_box_t _b_4528, kk_context_t* _ctx) {
  struct kk_std_num_double__mlift3957_pdouble_fun5285__t* _self = kk_function_as(struct kk_std_num_double__mlift3957_pdouble_fun5285__t*, _fself);
  kk_function_t _b_4529_4527 = _self->_b_4529_4527; /* (char) -> double */
  kk_drop_match(_self, {kk_function_dup(_b_4529_4527);}, {}, _ctx)
  double _x5286;
  kk_char_t _x5287 = kk_char_unbox(_b_4528, _ctx); /*char*/
  _x5286 = kk_function_call(double, (kk_function_t, kk_char_t, kk_context_t*), _b_4529_4527, (_b_4529_4527, _x5287, _ctx)); /*double*/
  return kk_double_box(_x5286, _ctx);
}

double kk_std_num_double__mlift3957_pdouble(bool _y_3920, kk_context_t* _ctx) { /* (bool) -> std/text/parse/parse double */ 
  kk_char_t x_4094;
  if (_y_3920) {
    kk_string_t _x5280;
    kk_define_string_literal(, _s5281, 2, "+-")
    _x5280 = kk_string_dup(_s5281); /*string*/
    x_4094 = kk_std_text_parse_one_of(_x5280, _ctx); /*char*/
  }
  else {
    x_4094 = '+'; /*char*/
  }
  if (kk_yielding(kk_context())) {
    kk_function_t _b_4529_4527 = kk_std_num_double__new_mlift3957_pdouble_fun5283(_ctx); /*(char) -> double*/;
    kk_box_t _x5284 = kk_std_core_hnd_yield_extend(kk_std_num_double__new_mlift3957_pdouble_fun5285(_b_4529_4527, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x5284, _ctx);
  }
  return kk_std_num_double__mlift3956_pdouble(x_4094, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdouble_fun5293__t {
  struct kk_function_s _base;
};
static double kk_std_num_double_pdouble_fun5293(kk_function_t _fself, bool _x15292, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdouble_fun5293(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdouble_fun5293, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double_pdouble_fun5293(kk_function_t _fself, bool _x15292, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_num_double__mlift3957_pdouble(_x15292, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdouble_fun5295__t {
  struct kk_function_s _base;
  kk_function_t _b_4590_4536;
};
static kk_box_t kk_std_num_double_pdouble_fun5295(kk_function_t _fself, kk_box_t _b_4537, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdouble_fun5295(kk_function_t _b_4590_4536, kk_context_t* _ctx) {
  struct kk_std_num_double_pdouble_fun5295__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdouble_fun5295__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdouble_fun5295, kk_context());
  _self->_b_4590_4536 = _b_4590_4536;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pdouble_fun5295(kk_function_t _fself, kk_box_t _b_4537, kk_context_t* _ctx) {
  struct kk_std_num_double_pdouble_fun5295__t* _self = kk_function_as(struct kk_std_num_double_pdouble_fun5295__t*, _fself);
  kk_function_t _b_4590_4536 = _self->_b_4590_4536; /* (bool) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4590_4536);}, {}, _ctx)
  double _x5296;
  bool _x5297 = kk_bool_unbox(_b_4537); /*bool*/
  _x5296 = kk_function_call(double, (kk_function_t, bool, kk_context_t*), _b_4590_4536, (_b_4590_4536, _x5297, _ctx)); /*double*/
  return kk_double_box(_x5296, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdouble_fun5301__t {
  struct kk_function_s _base;
};
static double kk_std_num_double_pdouble_fun5301(kk_function_t _fself, kk_char_t _x15300, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdouble_fun5301(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdouble_fun5301, _ctx)
  return kk_function_dup(_fself);
}

static double kk_std_num_double_pdouble_fun5301(kk_function_t _fself, kk_char_t _x15300, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_std_num_double__mlift3956_pdouble(_x15300, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdouble_fun5303__t {
  struct kk_function_s _base;
  kk_function_t _b_4591_4538;
};
static kk_box_t kk_std_num_double_pdouble_fun5303(kk_function_t _fself, kk_box_t _b_4539, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdouble_fun5303(kk_function_t _b_4591_4538, kk_context_t* _ctx) {
  struct kk_std_num_double_pdouble_fun5303__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdouble_fun5303__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdouble_fun5303, kk_context());
  _self->_b_4591_4538 = _b_4591_4538;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pdouble_fun5303(kk_function_t _fself, kk_box_t _b_4539, kk_context_t* _ctx) {
  struct kk_std_num_double_pdouble_fun5303__t* _self = kk_function_as(struct kk_std_num_double_pdouble_fun5303__t*, _fself);
  kk_function_t _b_4591_4538 = _self->_b_4591_4538; /* (char) -> double */
  kk_drop_match(_self, {kk_function_dup(_b_4591_4538);}, {}, _ctx)
  double _x5304;
  kk_char_t _x5305 = kk_char_unbox(_b_4539, _ctx); /*char*/
  _x5304 = kk_function_call(double, (kk_function_t, kk_char_t, kk_context_t*), _b_4591_4538, (_b_4591_4538, _x5305, _ctx)); /*double*/
  return kk_double_box(_x5304, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdouble_fun5308__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_pdouble_fun5308(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdouble_fun5308(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdouble_fun5308, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double_pdouble_fun5308(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x5309 = kk_std_num_double_phexdouble(_ctx); /*double*/
  return kk_double_box(_x5309, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdouble_fun5311__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_pdouble_fun5311(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdouble_fun5311(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdouble_fun5311, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double_pdouble_fun5311(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x5312 = kk_std_num_double_pdecdouble(_ctx); /*double*/
  return kk_double_box(_x5312, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdouble_fun5314__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_pdouble_fun5314(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdouble_fun5314(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdouble_fun5314, _ctx)
  return kk_function_dup(_fself);
}



// lift anonymous function
struct kk_std_num_double_pdouble_fun5316__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_pdouble_fun5316(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdouble_fun5316(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdouble_fun5316, _ctx)
  return kk_function_dup(_fself);
}



// lift anonymous function
struct kk_std_num_double_pdouble_fun5321__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_pdouble_fun5321(kk_function_t _fself, kk_box_t _b_4541, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdouble_fun5321(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdouble_fun5321, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double_pdouble_fun5321(kk_function_t _fself, kk_box_t _b_4541, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x5322;
  kk_string_t _x5323 = kk_string_unbox(_b_4541); /*string*/
  _x5322 = kk_std_num_double__mlift3952_pdouble(_x5323, _ctx); /*double*/
  return kk_double_box(_x5322, _ctx);
}
static kk_box_t kk_std_num_double_pdouble_fun5316(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x5317;
  kk_string_t x2_4107;
  kk_string_t _x5318;
  kk_define_string_literal(, _s5319, 3, "nan")
  _x5318 = kk_string_dup(_s5319); /*string*/
  x2_4107 = kk_std_text_parse_pstring(_x5318, _ctx); /*string*/
  if (kk_yielding(kk_context())) {
    kk_string_drop(x2_4107, _ctx);
    kk_box_t _x5320 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_pdouble_fun5321(_ctx), _ctx); /*3858*/
    _x5317 = kk_double_unbox(_x5320, _ctx); /*double*/
  }
  else {
    _x5317 = kk_std_num_double__mlift3952_pdouble(x2_4107, _ctx); /*double*/
  }
  return kk_double_box(_x5317, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdouble_fun5325__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_pdouble_fun5325(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdouble_fun5325(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdouble_fun5325, _ctx)
  return kk_function_dup(_fself);
}



// lift anonymous function
struct kk_std_num_double_pdouble_fun5330__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_pdouble_fun5330(kk_function_t _fself, kk_box_t _b_4543, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdouble_fun5330(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdouble_fun5330, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double_pdouble_fun5330(kk_function_t _fself, kk_box_t _b_4543, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x5331;
  kk_string_t _x5332 = kk_string_unbox(_b_4543); /*string*/
  _x5331 = kk_std_num_double__mlift3953_pdouble(_x5332, _ctx); /*double*/
  return kk_double_box(_x5331, _ctx);
}
static kk_box_t kk_std_num_double_pdouble_fun5325(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x5326;
  kk_string_t x3_4109;
  kk_string_t _x5327;
  kk_define_string_literal(, _s5328, 8, "infinity")
  _x5327 = kk_string_dup(_s5328); /*string*/
  x3_4109 = kk_std_text_parse_pstring(_x5327, _ctx); /*string*/
  if (kk_yielding(kk_context())) {
    kk_string_drop(x3_4109, _ctx);
    kk_box_t _x5329 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_pdouble_fun5330(_ctx), _ctx); /*3858*/
    _x5326 = kk_double_unbox(_x5329, _ctx); /*double*/
  }
  else {
    _x5326 = kk_std_num_double__mlift3953_pdouble(x3_4109, _ctx); /*double*/
  }
  return kk_double_box(_x5326, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdouble_fun5334__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_pdouble_fun5334(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdouble_fun5334(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdouble_fun5334, _ctx)
  return kk_function_dup(_fself);
}



// lift anonymous function
struct kk_std_num_double_pdouble_fun5339__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_pdouble_fun5339(kk_function_t _fself, kk_box_t _b_4545, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdouble_fun5339(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdouble_fun5339, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double_pdouble_fun5339(kk_function_t _fself, kk_box_t _b_4545, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x5340;
  kk_string_t _x5341 = kk_string_unbox(_b_4545); /*string*/
  _x5340 = kk_std_num_double__mlift3954_pdouble(_x5341, _ctx); /*double*/
  return kk_double_box(_x5340, _ctx);
}
static kk_box_t kk_std_num_double_pdouble_fun5334(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x5335;
  kk_string_t x4_4111;
  kk_string_t _x5336;
  kk_define_string_literal(, _s5337, 3, "inf")
  _x5336 = kk_string_dup(_s5337); /*string*/
  x4_4111 = kk_std_text_parse_pstring(_x5336, _ctx); /*string*/
  if (kk_yielding(kk_context())) {
    kk_string_drop(x4_4111, _ctx);
    kk_box_t _x5338 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_pdouble_fun5339(_ctx), _ctx); /*3858*/
    _x5335 = kk_double_unbox(_x5338, _ctx); /*double*/
  }
  else {
    _x5335 = kk_std_num_double__mlift3954_pdouble(x4_4111, _ctx); /*double*/
  }
  return kk_double_box(_x5335, _ctx);
}
static kk_box_t kk_std_num_double_pdouble_fun5314(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x5315;
  kk_std_core__list _b_4576_4555;
  kk_std_core__list _x5324;
  kk_std_core__list _x5333 = kk_std_core__new_Cons(kk_reuse_null, kk_function_box(kk_std_num_double_new_pdouble_fun5334(_ctx)), kk_std_core__new_Nil(_ctx), _ctx); /*list<61>*/
  _x5324 = kk_std_core__new_Cons(kk_reuse_null, kk_function_box(kk_std_num_double_new_pdouble_fun5325(_ctx)), _x5333, _ctx); /*list<61>*/
  _b_4576_4555 = kk_std_core__new_Cons(kk_reuse_null, kk_function_box(kk_std_num_double_new_pdouble_fun5316(_ctx)), _x5324, _ctx); /*list<() -> std/text/parse/parse double>*/
  kk_box_t _x5342 = kk_std_text_parse_choose(_b_4576_4555, _ctx); /*770*/
  _x5315 = kk_double_unbox(_x5342, _ctx); /*double*/
  return kk_double_box(_x5315, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdouble_fun5344__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_pdouble_fun5344(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdouble_fun5344(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_pdouble_fun5344, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double_pdouble_fun5344(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  return kk_double_box(0.0, _ctx);
}


// lift anonymous function
struct kk_std_num_double_pdouble_fun5345__t {
  struct kk_function_s _base;
  bool neg;
};
static double kk_std_num_double_pdouble_fun5345(kk_function_t _fself, double d, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdouble_fun5345(bool neg, kk_context_t* _ctx) {
  struct kk_std_num_double_pdouble_fun5345__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdouble_fun5345__t, 1, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdouble_fun5345, kk_context());
  _self->neg = neg;
  return &_self->_base;
}

static double kk_std_num_double_pdouble_fun5345(kk_function_t _fself, double d, kk_context_t* _ctx) {
  struct kk_std_num_double_pdouble_fun5345__t* _self = kk_function_as(struct kk_std_num_double_pdouble_fun5345__t*, _fself);
  bool neg = _self->neg; /* bool */
  kk_drop_match(_self, {;}, {}, _ctx)
  if (neg) {
    return (-d);
  }
  return d;
}


// lift anonymous function
struct kk_std_num_double_pdouble_fun5347__t {
  struct kk_function_s _base;
  kk_function_t _b_4592_4588;
};
static kk_box_t kk_std_num_double_pdouble_fun5347(kk_function_t _fself, kk_box_t _b_4589, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_pdouble_fun5347(kk_function_t _b_4592_4588, kk_context_t* _ctx) {
  struct kk_std_num_double_pdouble_fun5347__t* _self = kk_function_alloc_as(struct kk_std_num_double_pdouble_fun5347__t, 2, _ctx);
  _self->_base.fun = kk_cfun_ptr_box(&kk_std_num_double_pdouble_fun5347, kk_context());
  _self->_b_4592_4588 = _b_4592_4588;
  return &_self->_base;
}

static kk_box_t kk_std_num_double_pdouble_fun5347(kk_function_t _fself, kk_box_t _b_4589, kk_context_t* _ctx) {
  struct kk_std_num_double_pdouble_fun5347__t* _self = kk_function_as(struct kk_std_num_double_pdouble_fun5347__t*, _fself);
  kk_function_t _b_4592_4588 = _self->_b_4592_4588; /* (d : double) -> std/text/parse/parse double */
  kk_drop_match(_self, {kk_function_dup(_b_4592_4588);}, {}, _ctx)
  double _x5348;
  double _x5349 = kk_double_unbox(_b_4589, _ctx); /*double*/
  _x5348 = kk_function_call(double, (kk_function_t, double, kk_context_t*), _b_4592_4588, (_b_4592_4588, _x5349, _ctx)); /*double*/
  return kk_double_box(_x5348, _ctx);
}

double kk_std_num_double_pdouble(kk_context_t* _ctx) { /* () -> std/text/parse/parse double */ 
  kk_std_core_hnd__ev ev_4099;
  kk_ssize_t _x5288 = ((kk_ssize_t)0); /*ssize_t*/
  ev_4099 = kk_evv_at(_x5288,kk_context()); /*std/core/hnd/ev<std/text/parse/.hnd-parse>*/
  bool x_4096;
  kk_box_t _x5289;
  struct kk_std_core_hnd_Ev* _con5290 = kk_std_core_hnd__as_Ev(ev_4099);
  kk_std_core_hnd__marker m0 = _con5290->marker;
  kk_box_t _box_x4530 = _con5290->hnd;
  kk_std_text_parse__hnd_parse h = kk_std_text_parse__hnd_parse_unbox(_box_x4530, NULL);
  kk_std_text_parse__hnd_parse_dup(h);
  kk_std_core_hnd__clause0 _match_4634;
  kk_std_core_hnd__clause0 _borrowApp_4635 = kk_std_text_parse__select_pick(h, _ctx); /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,417,418>*/;
  kk_std_text_parse__hnd_parse_drop(h, _ctx);
  _match_4634 = _borrowApp_4635; /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,417,418>*/
  kk_function_t _fun_unbox_x4533 = _match_4634.clause;
  _x5289 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_context_t*), _fun_unbox_x4533, (_fun_unbox_x4533, m0, ev_4099, _ctx)); /*37*/
  x_4096 = kk_bool_unbox(_x5289); /*bool*/
  if (kk_yielding(kk_context())) {
    kk_function_t _b_4590_4536 = kk_std_num_double_new_pdouble_fun5293(_ctx); /*(bool) -> std/text/parse/parse double*/;
    kk_box_t _x5294 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_pdouble_fun5295(_b_4590_4536, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x5294, _ctx);
  }
  kk_char_t x0_4101;
  if (x_4096) {
    kk_string_t _x5298;
    kk_define_string_literal(, _s5299, 2, "+-")
    _x5298 = kk_string_dup(_s5299); /*string*/
    x0_4101 = kk_std_text_parse_one_of(_x5298, _ctx); /*char*/
  }
  else {
    x0_4101 = '+'; /*char*/
  }
  if (kk_yielding(kk_context())) {
    kk_function_t _b_4591_4538 = kk_std_num_double_new_pdouble_fun5301(_ctx); /*(char) -> double*/;
    kk_box_t _x5302 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_pdouble_fun5303(_b_4591_4538, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x5302, _ctx);
  }
  bool neg = (x0_4101 == ('-')); /*bool*/;
  double x1_4104;
  kk_box_t _x5306;
  kk_std_core__list _x5307;
  kk_std_core__list _x5310;
  kk_std_core__list _x5313;
  kk_std_core__list _x5343 = kk_std_core__new_Cons(kk_reuse_null, kk_function_box(kk_std_num_double_new_pdouble_fun5344(_ctx)), kk_std_core__new_Nil(_ctx), _ctx); /*list<61>*/
  _x5313 = kk_std_core__new_Cons(kk_reuse_null, kk_function_box(kk_std_num_double_new_pdouble_fun5314(_ctx)), _x5343, _ctx); /*list<61>*/
  _x5310 = kk_std_core__new_Cons(kk_reuse_null, kk_function_box(kk_std_num_double_new_pdouble_fun5311(_ctx)), _x5313, _ctx); /*list<61>*/
  _x5307 = kk_std_core__new_Cons(kk_reuse_null, kk_function_box(kk_std_num_double_new_pdouble_fun5308(_ctx)), _x5310, _ctx); /*list<61>*/
  _x5306 = kk_std_text_parse_choose(_x5307, _ctx); /*770*/
  x1_4104 = kk_double_unbox(_x5306, _ctx); /*double*/
  if (kk_yielding(kk_context())) {
    kk_function_t _b_4592_4588 = kk_std_num_double_new_pdouble_fun5345(neg, _ctx); /*(d : double) -> std/text/parse/parse double*/;
    kk_box_t _x5346 = kk_std_core_hnd_yield_extend(kk_std_num_double_new_pdouble_fun5347(_b_4592_4588, _ctx), _ctx); /*3858*/
    return kk_double_unbox(_x5346, _ctx);
  }
  if (neg) {
    return (-x1_4104);
  }
  return x1_4104;
}
 
// Parse a double number. Can be "NaN", "Inf(inity)" (case-insensitive),
// a fix-point number (`1.2`) or in scientific notation (`-2.3e-5`).
// Also allows floats in [hexadecimal notation](https://books.google.com/books?id=FgMsCwAAQBAJ&pg=PA41) (`0xA.Fp-10`) that can
// be represented precisely (and are the preferred _round trip_ format).


// lift anonymous function
struct kk_std_num_double_parse_double_fun5355__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_double_parse_double_fun5355(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_double_new_parse_double_fun5355(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_double_parse_double_fun5355, _ctx)
  return kk_function_dup(_fself);
}

static kk_box_t kk_std_num_double_parse_double_fun5355(kk_function_t _fself, kk_context_t* _ctx) {
  KK_UNUSED(_fself);
  double _x5356 = kk_std_num_double_pdouble(_ctx); /*double*/
  return kk_double_box(_x5356, _ctx);
}

kk_std_core_types__maybe kk_std_num_double_parse_double(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> maybe<double> */ 
  kk_string_t s0_3867;
  kk_string_t _x5350;
  kk_string_t _x5351 = kk_string_trim_left(s,kk_context()); /*string*/
  _x5350 = kk_string_trim_right(_x5351,kk_context()); /*string*/
  s0_3867 = kk_std_core_to_lower(_x5350, _ctx); /*string*/
  kk_std_core__sslice _b_4595_4593;
  kk_string_t _x5352 = kk_string_dup(s0_3867); /*string*/
  kk_ssize_t _x5353 = ((kk_ssize_t)0); /*ssize_t*/
  kk_ssize_t _x5354 = kk_string_len(s0_3867,kk_context()); /*ssize_t*/
  _b_4595_4593 = kk_std_core__new_Sslice(_x5352, _x5353, _x5354, _ctx); /*sslice*/
  kk_std_text_parse__parse_error perr_3866 = kk_std_text_parse_parse_eof(_b_4595_4593, kk_std_num_double_new_parse_double_fun5355(_ctx), _ctx); /*std/text/parse/parse-error<double>*/;
  if (kk_std_text_parse__is_ParseOk(perr_3866)) {
    struct kk_std_text_parse_ParseOk* _con5357 = kk_std_text_parse__as_ParseOk(perr_3866);
    kk_box_t _box_x4597 = _con5357->result;
    kk_std_core__sslice _pat00 = _con5357->rest;
    double x0 = kk_double_unbox(_box_x4597, NULL);
    if (kk_likely(kk_std_text_parse__parse_error_is_unique(perr_3866))) {
      kk_std_core__sslice_drop(_pat00, _ctx);
      kk_box_drop(_box_x4597, _ctx);
      kk_Unit;
      kk_Unit;
      kk_std_text_parse__parse_error_free(perr_3866);
    }
    else {
      kk_std_text_parse__parse_error_decref(perr_3866, _ctx);
      kk_Unit;
    }
    double _b_4599_4598 = x0; /*double*/;
    return kk_std_core_types__new_Just(kk_double_box(_b_4599_4598, _ctx), _ctx);
  }
  struct kk_std_text_parse_ParseError* _con5359 = kk_std_text_parse__as_ParseError(perr_3866);
  kk_std_core__sslice _pat5 = _con5359->rest;
  kk_std_text_parse__parse_error_dropn(perr_3866, ((int32_t)2), _ctx);
  return kk_std_core_types__new_Nothing(_ctx);
}
 
// Round a double to a specified precision. Rounds to the  even number in case of a tie.
// `123.456.round-to-prec(2) == 123.46`
// `123.456.round-to-prec(-1) == 120.0`

double kk_std_num_double_round_to_prec(double d, kk_integer_t prec, kk_context_t* _ctx) { /* (d : double, prec : int) -> double */ 
  bool _match_4624;
  kk_integer_t _borrowedArg_4626 = kk_integer_from_small(0); /*int*/;
  bool _borrowApp_4627 = kk_integer_lte_borrow(prec,_borrowedArg_4626,kk_context()); /*bool*/;
  kk_integer_drop(_borrowedArg_4626, _ctx);
  _match_4624 = _borrowApp_4627; /*bool*/
  if (_match_4624) {
    kk_integer_drop(prec, _ctx);
    return round(d);
  }
  double p_3869;
  double _borrowApp_4625 = kk_integer_as_double_borrow(prec); /*double*/;
  kk_integer_drop(prec, _ctx);
  p_3869 = _borrowApp_4625; /*double*/
  double p0 = pow((10.0),p_3869); /*double*/;
  double _x5361;
  double _x5362 = (d * p0); /*double*/
  _x5361 = round(_x5362); /*double*/
  return (_x5361 / p0);
}
 
/* Show a double in [hexadecimal notation](https://books.google.com/books?id=FgMsCwAAQBAJ&pg=PA41).
An advantage of this format is that it precisely represents the `:double` and can
reliably (and efficiently) be parsed back, i.e. `d.show-hex.parse-double == Just(d)`.
The significant is the _hexadecimal_ fraction while the
exponent after the `p` is the _decimal_ power of 2.
 For example, ``0xA.Fp-10`` = (10 + 15/16)&middot;2^-10^  (not 2^-16^!) = 0.01068115234375.
 Equivalently, ``0xA.Fp-10 == 0x5.78p-9 == 0x2.BCp-8 == 0x1.5Ep-7``.
```
> dbl-min.show-hex
"0x1.0p-1022"
> 0.1.show-hex
"0x1.999999999999Ap-4"
> dbl-max.show-hex
"0x1.FFFFFFFFFFFFFp+1023"
> -0.0.show-hex
"-0x0.0p+0"
> nan.show-hex
"NaN"
> 0.01068115234375.show-hex
"0x1.5Ep-7"
```
.
*/

kk_string_t kk_std_num_double_show_hex(double d, kk_std_core_types__optional width, kk_std_core_types__optional use_capitals, kk_std_core_types__optional pre, kk_context_t* _ctx) { /* (d : double, width : optional<int>, use-capitals : optional<bool>, pre : optional<string>) -> string */ 
  bool b_3870 = isfinite(d); /*bool*/;
  if (b_3870) {
    kk_std_core_types__tuple2_ _match_4612 = kk_std_num_double_decode(d, _ctx); /*(int, int)*/;
    kk_box_t _box_x4600 = _match_4612.fst;
    kk_box_t _box_x4601 = _match_4612.snd;
    kk_integer_t m = kk_integer_unbox(_box_x4600);
    kk_integer_t e = kk_integer_unbox(_box_x4601);
    kk_integer_dup(e);
    kk_integer_dup(m);
    kk_std_core_types__tuple2__drop(_match_4612, _ctx);
    kk_Unit;
    kk_string_t man;
    kk_integer_t _x5365 = kk_integer_abs(m,kk_context()); /*int*/
    kk_std_core_types__optional _x5366 = kk_std_core_types__new_Optional(kk_integer_box(kk_integer_from_small(1)), _ctx); /*optional<106>*/
    kk_std_core_types__optional _x5367;
    kk_box_t _x5368;
    bool _x5369;
    if (kk_std_core_types__is_Optional(use_capitals)) {
      kk_box_t _box_x4603 = use_capitals._cons.Optional.value;
      bool _use_capitals_3410 = kk_bool_unbox(_box_x4603);
      kk_std_core_types__optional_drop(use_capitals, _ctx);
      kk_Unit;
      _x5369 = _use_capitals_3410; /*bool*/
      goto _match5370;
    }
    _x5369 = true; /*bool*/
    _match5370: ;
    _x5368 = kk_bool_box(_x5369); /*106*/
    _x5367 = kk_std_core_types__new_Optional(_x5368, _ctx); /*optional<106>*/
    kk_std_core_types__optional _x5372;
    kk_box_t _x5373;
    kk_string_t _x5374 = kk_string_empty(); /*string*/
    _x5373 = kk_string_box(_x5374); /*106*/
    _x5372 = kk_std_core_types__new_Optional(_x5373, _ctx); /*optional<106>*/
    man = kk_std_core_show_hex(_x5365, _x5366, _x5367, _x5372, _ctx); /*string*/
    kk_integer_t exp0;
    kk_integer_t _x5376;
    kk_integer_t _x5377;
    kk_integer_t _x5378;
    kk_string_t _x5379 = kk_string_dup(man); /*string*/
    _x5378 = kk_std_core_count_1(_x5379, _ctx); /*int*/
    _x5377 = kk_integer_sub(_x5378,(kk_integer_from_small(1)),kk_context()); /*int*/
    _x5376 = kk_integer_mul((kk_integer_from_small(4)),_x5377,kk_context()); /*int*/
    exp0 = kk_integer_add(e,_x5376,kk_context()); /*int*/
    kk_string_t exp;
    kk_string_t _x5380;
    bool _match_4621;
    kk_integer_t _borrowedArg_4622 = kk_integer_from_small(0); /*int*/;
    bool _borrowApp_4623 = kk_integer_gte_borrow(exp0,_borrowedArg_4622,kk_context()); /*bool*/;
    kk_integer_drop(_borrowedArg_4622, _ctx);
    _match_4621 = _borrowApp_4623; /*bool*/
    if (_match_4621) {
      kk_define_string_literal(, _s5381, 1, "+")
      _x5380 = kk_string_dup(_s5381); /*string*/
    }
    else {
      _x5380 = kk_string_empty(); /*string*/
    }
    kk_string_t _x5383 = kk_std_core_show(exp0, _ctx); /*string*/
    exp = kk_std_core__lp__plus__plus__1_rp_(_x5380, _x5383, _ctx); /*string*/
    kk_string_t s_3871;
    kk_string_t _x5384;
    kk_string_t _x5385 = kk_string_dup(man); /*string*/
    _x5384 = kk_std_core_tail_2(_x5385, _ctx); /*string*/
    kk_string_t _x5386;
    kk_define_string_literal(, _s5387, 1, "0")
    _x5386 = kk_string_dup(_s5387); /*string*/
    s_3871 = kk_std_core_trim_right_1(_x5384, _x5386, _ctx); /*string*/
    kk_integer_t width0_3872;
    bool _match_4617;
    kk_integer_t _borrowedArg_4619 = kk_integer_from_small(1); /*int*/;
    kk_integer_t _borrowedArg_4618;
    if (kk_std_core_types__is_Optional(width)) {
      kk_box_t _box_x4609 = width._cons.Optional.value;
      kk_integer_t _width_3406 = kk_integer_unbox(_box_x4609);
      kk_integer_dup(_width_3406);
      _borrowedArg_4618 = _width_3406; /*int*/
      goto _match5388;
    }
    _borrowedArg_4618 = kk_integer_from_small(1); /*int*/
    _match5388: ;
    bool _borrowApp_4620 = kk_integer_gte_borrow(_borrowedArg_4619,_borrowedArg_4618,kk_context()); /*bool*/;
    kk_integer_drop(_borrowedArg_4619, _ctx);
    kk_integer_drop(_borrowedArg_4618, _ctx);
    _match_4617 = _borrowApp_4620; /*bool*/
    if (_match_4617) {
      kk_std_core_types__optional_drop(width, _ctx);
      width0_3872 = kk_integer_from_small(1); /*int*/
    }
    else {
      if (kk_std_core_types__is_Optional(width)) {
        kk_box_t _box_x4610 = width._cons.Optional.value;
        kk_integer_t _width_34060 = kk_integer_unbox(_box_x4610);
        kk_integer_dup(_width_34060);
        kk_std_core_types__optional_drop(width, _ctx);
        kk_Unit;
        width0_3872 = _width_34060; /*int*/
        goto _match5390;
      }
      width0_3872 = kk_integer_from_small(1); /*int*/
      _match5390: ;
    }
    kk_ssize_t w = kk_std_core_ssize__t(width0_3872, _ctx); /*ssize_t*/;
    kk_ssize_t n;
    kk_string_t _x5392 = kk_string_dup(s_3871); /*string*/
    n = kk_string_len(_x5392,kk_context()); /*ssize_t*/
    kk_string_t frac;
    bool _match_4616 = (w <= n); /*bool*/;
    if (_match_4616) {
      frac = s_3871; /*string*/
    }
    else {
      kk_string_t _x5393;
      kk_string_t _x5394 = kk_std_core_string('0', _ctx); /*string*/
      kk_ssize_t _x5395 = (w - n); /*ssize_t*/
      _x5393 = kk_std_core_repeatz(_x5394, _x5395, _ctx); /*string*/
      frac = kk_std_core__lp__plus__plus__1_rp_(s_3871, _x5393, _ctx); /*string*/
    }
    kk_string_t sign;
    bool _match_4613 = (d < (0.0)); /*bool*/;
    if (_match_4613) {
      kk_define_string_literal(, _s5396, 1, "-")
      sign = kk_string_dup(_s5396); /*string*/
    }
    else {
      bool _match_4614 = (d == (0.0)); /*bool*/;
      if (_match_4614) {
        bool _match_4615;
        double _x5397 = ((1.0) / d); /*double*/
        _match_4615 = (isinf(_x5397) && signbit(_x5397)); /*bool*/
        if (_match_4615) {
          kk_define_string_literal(, _s5398, 1, "-")
          sign = kk_string_dup(_s5398); /*string*/
        }
        else {
          sign = kk_string_empty(); /*string*/
        }
      }
      else {
        sign = kk_string_empty(); /*string*/
      }
    }
    kk_string_t _x5401;
    kk_string_t _x5402;
    if (kk_std_core_types__is_Optional(pre)) {
      kk_box_t _box_x4611 = pre._cons.Optional.value;
      kk_string_t _pre_3414 = kk_string_unbox(_box_x4611);
      kk_string_dup(_pre_3414);
      kk_std_core_types__optional_drop(pre, _ctx);
      kk_Unit;
      _x5402 = _pre_3414; /*string*/
      goto _match5403;
    }
    kk_define_string_literal(, _s5405, 2, "0x")
    _x5402 = kk_string_dup(_s5405); /*string*/
    _match5403: ;
    kk_string_t _x5406;
    kk_string_t _x5407 = kk_std_core_head_3(man, _ctx); /*string*/
    kk_string_t _x5408;
    kk_string_t _x5409;
    kk_define_string_literal(, _s5410, 1, ".")
    _x5409 = kk_string_dup(_s5410); /*string*/
    kk_string_t _x5411;
    kk_string_t _x5412;
    kk_string_t _x5413;
    kk_define_string_literal(, _s5414, 1, "p")
    _x5413 = kk_string_dup(_s5414); /*string*/
    _x5412 = kk_std_core__lp__plus__plus__1_rp_(_x5413, exp, _ctx); /*string*/
    _x5411 = kk_std_core__lp__plus__plus__1_rp_(frac, _x5412, _ctx); /*string*/
    _x5408 = kk_std_core__lp__plus__plus__1_rp_(_x5409, _x5411, _ctx); /*string*/
    _x5406 = kk_std_core__lp__plus__plus__1_rp_(_x5407, _x5408, _ctx); /*string*/
    _x5401 = kk_std_core__lp__plus__plus__1_rp_(_x5402, _x5406, _ctx); /*string*/
    return kk_std_core__lp__plus__plus__1_rp_(sign, _x5401, _ctx);
  }
  kk_std_core_types__optional_drop(pre, _ctx);
  kk_std_core_types__optional_drop(use_capitals, _ctx);
  kk_std_core_types__optional_drop(width, _ctx);
  return kk_std_core_show_1(d, kk_std_core_types__new_None(_ctx), _ctx);
}

// initialization
void kk_std_num_double__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core__init(_ctx);
  kk_std_text_parse__init(_ctx);
  kk_std_num_int32__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
  {
    kk_std_num_double_dbl_max_prec = kk_integer_from_small(15); /*int*/
  }
  {
    kk_std_num_double_rad2deg = ((180.0) / (3.141592653589793)); /*double*/
  }
  {
    kk_std_num_double_deg2rad = ((3.141592653589793) / (180.0)); /*double*/
  }
  {
    kk_std_num_double_neginf = kk_std_num_double_make_neginf(_ctx); /*double*/
  }
  {
    kk_std_num_double_posinf = kk_std_num_double_make_posinf(_ctx); /*double*/
  }
  {
    kk_std_num_double_nan = kk_std_num_double_make_nan(_ctx); /*double*/
  }
}

// termination
void kk_std_num_double__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_integer_drop(kk_std_num_double_dbl_max_prec, _ctx);
  kk_std_num_int32__done(_ctx);
  kk_std_text_parse__done(_ctx);
  kk_std_core__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
